--[[
-------------------------------------------------------------------------------
-- LoreBooks, by Ayantir
-------------------------------------------------------------------------------
This software is under : CreativeCommons CC BY-NC-SA 4.0
Attribution-NonCommercial-ShareAlike 4.0 International (CC BY-NC-SA 4.0)

You are free to:

	Share — copy and redistribute the material in any medium or format
	Adapt — remix, transform, and build upon the material
	The licensor cannot revoke these freedoms as long as you follow the license terms.


Under the following terms:

	Attribution — You must give appropriate credit, provide a link to the license, and indicate if changes were made. You may do so in any reasonable manner, but not in any way that suggests the licensor endorses you or your use.
	NonCommercial — You may not use the material for commercial purposes.
	ShareAlike — If you remix, transform, or build upon the material, you must distribute your contributions under the same license as the original.
	No additional restrictions — You may not apply legal terms or technological measures that legally restrict others from doing anything the license permits.


Please read full licence at :
http://creativecommons.org/licenses/by-nc-sa/4.0/legalcode
]]
local internal = _G["LoreBooks_Internal"]

local libraryData = {
  [1] = {
    [1] = {
      ["t"] = 10,
      ["k"] = 3,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Гленумбры.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur la Glénumbrie.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Glenumbra.",
        ["en"] = "A Mages Guild collection of lore books about Glenumbra.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Гленумбры",
        ["fr"] = "Connaissance de Glénumbrie",
        ["de"] = "Über Glenumbra",
        ["en"] = "Glenumbra Lore",
      },
    },
    [2] = {
      ["t"] = 10,
      ["k"] = 5,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Стормхейвена.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Havre-tempête.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Sturmhafen.",
        ["en"] = "A Mages Guild collection of lore books about Stormhaven.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Стормхейвена",
        ["fr"] = "Connaissance de Havre-tempête",
        ["de"] = "Über Sturmhafen",
        ["en"] = "Stormhaven Lore",
      },
    },
    [3] = {
      ["t"] = 10,
      ["k"] = 6,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории Ривенспайра.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Fendretour.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Kluftspitze.",
        ["en"] = "A Mages Guild collection of lore books about Rivenspire.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История Ривенспайра",
        ["fr"] = "Connaissance de Fendretour",
        ["de"] = "Über Kluftspitze",
        ["en"] = "Rivenspire Lore",
      },
    },
    [4] = {
      ["t"] = 10,
      ["k"] = 7,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории Бангкорая.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Bangkoraï.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Bangkorai.",
        ["en"] = "A Mages Guild collection of lore books about Bangkorai.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Бангкорая",
        ["fr"] = "Connaissance de Bangkoraï",
        ["de"] = "Über Bangkorai",
        ["en"] = "Bangkorai Lore",
      },
    },
    [5] = {
      ["t"] = 10,
      ["k"] = 8,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории пустыни Алик'р.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur le désert d'Alik'r.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die Alik'r-Wüste.",
        ["en"] = "A Mages Guild collection of lore books about the Alik'r Desert.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи пустыни Алик'р",
        ["fr"] = "Connaissance du désert d'Alik'r",
        ["de"] = "Über die Alik'r-Wüste",
        ["en"] = "Alik'r Desert Lore",
      },
    },
    [6] = {
      ["t"] = 10,
      ["k"] = 9,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Тенетопи.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Fangeombre.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Schattenfenn.",
        ["en"] = "A Mages Guild collection of lore books about Shadowfen.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Тенетопи",
        ["fr"] = "Connaissance de Fangeombre",
        ["de"] = "Über Schattenfenn",
        ["en"] = "Shadowfen Lore",
      },
    },
    [7] = {
      ["t"] = 4,
      ["k"] = 10,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_magic.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, найденная во время выполнения испытаний Безумного Бога.",
        ["fr"] = "Une collection de livres de la guilde des mages découverts en accomplissant les épreuves du Dieu fou.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern, die man während der Prüfungen des Verrückten Gottes findet.",
        ["en"] = "A Mages Guild collection of books found while completing the Mad God's trials.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Испытание Айвеи",
        ["fr"] = "Les épreuves d'Eyévéa",
        ["de"] = "Die Prüfung von Augvea",
        ["en"] = "The Trial of Eyevea",
      },
    },
    [8] = {
      ["t"] = 10,
      ["k"] = 12,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_daedric.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных князьям даэдра.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur les princes Daedra.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über daedrische Fürsten.",
        ["en"] = "A Mages Guild collection of books regarding the Daedric Princes.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Князья даэдра",
        ["fr"] = "Princes Daedra",
        ["de"] = "Daedrische Fürsten",
        ["en"] = "Daedric Princes",
      },
    },
    [9] = {
      ["t"] = 10,
      ["k"] = 13,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов о жизни выдающихся личностей.",
        ["fr"] = "Une collection de livres de la guilde des mages sur la vie des grands de ce monde.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die Leben der Großen.",
        ["en"] = "A Mages Guild collection of books about the lives of the great.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Биографии",
        ["fr"] = "Biographies",
        ["de"] = "Biographien",
        ["en"] = "Biographies",
      },
    },
    [10] = {
      ["t"] = 10,
      ["k"] = 14,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_divine.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных богам и прочим божествам.",
        ["fr"] = "Une collection de livres de la guilde des mages sur les Divins et autres divinités.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die Göttlichen und andere Gottheiten.",
        ["en"] = "A Mages Guild collection of books regarding the Divines and other Deities.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Боги и божества",
        ["fr"] = "Divins et divinités",
        ["de"] = "Göttliche und Gottheiten",
        ["en"] = "Divines and Deities",
      },
    },
    [11] = {
      ["t"] = 17,
      ["k"] = 15,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_dungeons.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов касательно истории подземелий.",
        ["fr"] = "Une collection de livres de la guilde des mages concernant les donjons.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern mit Wissenswertem über Verliese.",
        ["en"] = "A Mages Guild collection of books regarding dungeon lore.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История подземелий",
        ["fr"] = "Connaissance des donjons",
        ["de"] = "Über Verliese",
        ["en"] = "Dungeon Lore",
      },
    },
    [12] = {
      ["t"] = 16,
      ["k"] = 16,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_dwemer.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных двемерам.",
        ["fr"] = "Une collection de livres de la guilde des mages concernant les Dwemers.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die Dwemer.",
        ["en"] = "A Mages Guild collection of books regarding the Dwemer.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Двемеры",
        ["fr"] = "Dwemer",
        ["de"] = "Die Dwemer",
        ["en"] = "Dwemer",
      },
    },
    [13] = {
      ["t"] = 10,
      ["k"] = 17,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных древним легендам.",
        ["fr"] = "Une collection de livres de la guilde des mages concernant d'anciennes légendes.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die alten Legenden.",
        ["en"] = "A Mages Guild collection of books regarding ancient legends.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Легенды Нирна",
        ["fr"] = "Légendes de Nirn",
        ["de"] = "Legenden von Nirn",
        ["en"] = "Legends of Nirn",
      },
    },
    [14] = {
      ["t"] = 10,
      ["k"] = 18,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, представляющих собой значимые литературные труды.",
        ["fr"] = "Une collection de livres de la guilde des mages recueillant des œuvres majeures de littérature.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern mit bedeutenden literarischen Werken.",
        ["en"] = "A Mages Guild collection of books that are significant works of literature.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Литература",
        ["fr"] = "Littérature",
        ["de"] = "Bekannte Literatur",
        ["en"] = "Literature",
      },
    },
    [15] = {
      ["t"] = 10,
      ["k"] = 19,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_magic.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных магии и тому, что с ней связано.",
        ["fr"] = "Une collection de livres de la guilde des mages parlant de magie.",
        ["de"] = "Eine Büchersammlung der Magiergilde, bestehend aus Werken zu Magie und Magicka.",
        ["en"] = "A Mages Guild books collection of regarding magic and magicka.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Магия и волшебство",
        ["fr"] = "Magie et sortilèges",
        ["de"] = "Magie und Magicka",
        ["en"] = "Magic and Magicka",
      },
    },
    [16] = {
      ["t"] = 10,
      ["k"] = 20,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных древним мифам.",
        ["fr"] = "Une collection de livres de la guilde des mages regroupant les mythes.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über uralte Mythen.",
        ["en"] = "A Mages Guild collection of books regarding ancient myths.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Мифы Мундуса",
        ["fr"] = "Mythes du Mundus",
        ["de"] = "Mythen des Mundus",
        ["en"] = "Myths of the Mundus",
      },
    },
    [17] = {
      ["t"] = 10,
      ["k"] = 21,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_daedric.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных Обливиону.",
        ["fr"] = "Une collection de livres de la guilde des mages concernant Oblivion.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über das Reich des Vergessens.",
        ["en"] = "A Mages Guild collection of books regarding Oblivion.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Обливион",
        ["fr"] = "Connaissance d'Oblivion",
        ["de"] = "Über das Reich des Vergessens",
        ["en"] = "Oblivion Lore",
      },
    },
    [18] = {
      ["t"] = 10,
      ["k"] = 22,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, воздающих дань стихам и песням.",
        ["fr"] = "Une collection de livres de la guilde des mages recueillant des poèmes et des chants.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Feiern und Liedtexte.",
        ["en"] = "A Mages Guild collection of books celebrating lyrics and verse.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Поэзия и песни",
        ["fr"] = "Poésie et chant",
        ["de"] = "Gedichte und Lieder",
        ["en"] = "Poetry and Song",
      },
    },
    [19] = {
      ["t"] = 10,
      ["k"] = 23,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов, посвященных истории Тамриэля.",
        ["fr"] = "Une collection de livres de la guilde des mages traitant de l'histoire de Tamriel.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über die Geschichte Tamriels.",
        ["en"] = "A collection of Mages Guild collection of books pertaining to Tamriel's history.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История Тамриэля",
        ["fr"] = "Histoire de Tamriel",
        ["de"] = "Die Geschichte Tamriels",
        ["en"] = "Tamriel History",
      },
    },
    [20] = {
      ["t"] = 10,
      ["k"] = 24,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Стоунфолза.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur les Éboulis.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Steinfälle.",
        ["en"] = "A Mages Guild collection of books regarding Stonefalls.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Стоунфолза",
        ["fr"] = "Connaissance des Éboulis",
        ["de"] = "Über Steinfälle",
        ["en"] = "Stonefalls Lore",
      },
    },
    [21] = {
      ["t"] = 10,
      ["k"] = 26,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Малабал-Тора.",
        ["fr"] = "Une collection de livres de la guilde des mages découverts à Malabal Tor.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Malabal Tor.",
        ["en"] = "A collection of Mages Guild books found in Malabal Tor.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Малабал-Тора",
        ["fr"] = "Connaissance de Malabal Tor",
        ["de"] = "Über Malabal Tor",
        ["en"] = "Malabal Tor Lore",
      },
    },
    [22] = {
      ["t"] = 10,
      ["k"] = 27,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Истмарка.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur l'Estemarche.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Ostmarsch.",
        ["en"] = "A Mages Guild collection of books regarding Eastmarch.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Истмарка",
        ["fr"] = "Connaissance d'Estemarche",
        ["de"] = "Über Ostmarsch",
        ["en"] = "Eastmarch Lore",
      },
    },
    [23] = {
      ["t"] = 10,
      ["k"] = 28,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Дешаана.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Deshaan.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Deshaan.",
        ["en"] = "A Mages Guild collection of books regarding Deshaan.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Дешаана",
        ["fr"] = "Connaissance de Deshaan",
        ["de"] = "Über Deshaan",
        ["en"] = "Deshaan Lore",
      },
    },
    [24] = {
      ["t"] = 10,
      ["k"] = 29,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Рифта.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur la Brèche.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Rift.",
        ["en"] = "A Mages Guild collection of books regarding the Rift.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Рифта",
        ["fr"] = "Connaissance de la Brèche",
        ["de"] = "Über Rift",
        ["en"] = "The Rift Lore",
      },
    },
    [25] = {
      ["t"] = 10,
      ["k"] = 30,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Ауридона.",
        ["fr"] = "Une collection de livres de la guilde des mages découverts en Auridia.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Auridon.",
        ["en"] = "A collection of Mages Guild books found in Auridon.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Ауридона",
        ["fr"] = "Connaissance d'Auridia",
        ["de"] = "Über Auridon",
        ["en"] = "Auridon Lore",
      },
    },
    [26] = {
      ["t"] = 10,
      ["k"] = 32,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Гратвуда.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur le bois de Graht.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Grahtwald.",
        ["en"] = "A Mages Guild collection of books regarding Grahtwood.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Гратвуда",
        ["fr"] = "Connaissance du bois de Graht",
        ["de"] = "Über Grahtwald",
        ["en"] = "Grahtwood Lore",
      },
    },
    [27] = {
      ["t"] = 10,
      ["k"] = 38,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Гриншейда.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Prasin.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Grünschatten.",
        ["en"] = "A Mages Guild collection of books regarding Greenshade.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Гриншейда",
        ["fr"] = "Connaissance de Prasin",
        ["de"] = "Über Grünschatten",
        ["en"] = "Greenshade Lore",
      },
    },
    [28] = {
      ["t"] = 10,
      ["k"] = 39,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Марки Смерти.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur la marche de la Camarde.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Schnittermark.",
        ["en"] = "A Mages Guild collection of books regarding Reaper's March.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Марки Смерти",
        ["fr"] = "Connaissance de la Camarde",
        ["de"] = "Über Schnittermark",
        ["en"] = "Reaper's March Lore",
      },
    },
    [29] = {
      ["t"] = 10,
      ["k"] = 40,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_daedric.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг Гильдии магов об истории и обычаях Хладной Гавани.",
        ["fr"] = "Une série de livres de connaissances de la guilde des mages sur Havreglace.",
        ["de"] = "Eine Sammlung der Magiergilde mit Büchern über Kalthafen.",
        ["en"] = "A Mages Guild collection of books regarding Coldharbour.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История и обычаи Хладной Гавани",
        ["fr"] = "Connaissance de Havreglace",
        ["de"] = "Über Kalthafen",
        ["en"] = "Coldharbour Lore",
      },
    },
  },
  [2] = {
    [1] = {
      ["t"] = 24,
      ["k"] = 43,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги знаний, относящиеся к различным областям ремесла.",
        ["fr"] = "Livres de savoir autour des différentes disciplines d'artisanat.",
        ["de"] = "Bücher, die sich mit den verschiedenen Handwerken beschäftigen.",
        ["en"] = "Lore books related to the various disciplines of crafting.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Книги о ремеслах",
        ["fr"] = "Livres d'artisanat",
        ["de"] = "Handwerksbücher",
        ["en"] = "Crafting Books",
      },
    },
    [2] = {
      ["t"] = 14,
      ["k"] = 74,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_dwemer.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Двемерский стиль",
        ["fr"] = "Motifs dwemer",
        ["de"] = "Stil der Dwemer",
        ["en"] = "Dwemer Style",
      },
    },
    [3] = {
      ["t"] = 0,
      ["k"] = 0,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = true,
      ["n"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
    },
    [4] = {
      ["t"] = 14,
      ["k"] = 77,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Эти книги позволяют создавать предметы в акавирском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style akavirois.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Akaviri.",
        ["en"] = "These books enable crafting in the Akaviri style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Акавирский стиль",
        ["fr"] = "Style akavirois",
        ["de"] = "Stil der Akaviri",
        ["en"] = "Akaviri Style",
      },
    },
    [5] = {
      ["t"] = 14,
      ["k"] = 78,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Эти книги позволяют создавать предметы в йокуданском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style yokudan.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Yokudaner.",
        ["en"] = "These books enable crafting in the Yokudan style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Йокуданский стиль",
        ["fr"] = "Style yokudan",
        ["de"] = "Stil der Yokudaner",
        ["en"] = "Yokudan Style",
      },
    },
    [6] = {
      ["t"] = 14,
      ["k"] = 79,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стеклянном стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style verrier.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil mit Glasit.",
        ["en"] = "These book fragments enable crafting in the Glass style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стеклянный стиль",
        ["fr"] = "Style du verre",
        ["de"] = "Stil mit Glasit",
        ["en"] = "Glass Style",
      },
    },
    [7] = {
      ["t"] = 14,
      ["k"] = 80,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в подходящем для боя и практичном стиле наемников.",
        ["fr"] = "Permet à l'artisan de créer des objets dans le style mercenaire à la fois guerrier et efficace.",
        ["de"] = "Mit diesem Wissen können Handwerker Gegenstände im kriegerischen und zweckmäßigen Stil berühmter Söldner fertigen.",
        ["en"] = "This style enables the crafter to create items in the martial and utilitarian Mercenary style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль наемников",
        ["fr"] = "Style mercenaire",
        ["de"] = "Stil der Söldner",
        ["en"] = "Mercenary Style",
      },
    },
    [8] = {
      ["t"] = 14,
      ["k"] = 81,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в зивкинском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style Xivkyn.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Xivkyn.",
        ["en"] = "These book fragments enable crafting in the Xivkyn style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Зивкинский стиль",
        ["fr"] = "Style Xivkyn",
        ["de"] = "Stil der Xivkyn",
        ["en"] = "Xivkyn Style",
      },
    },
    [9] = {
      ["t"] = 14,
      ["k"] = 84,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в древнеорочьем стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style orque antique.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Orkahnen.",
        ["en"] = "These book fragments enable crafting in the Ancient Orc style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Древнеорочий стиль",
        ["fr"] = "Style orque antique",
        ["de"] = "Stil der Orkahnen",
        ["en"] = "Ancient Orc Style",
      },
    },
    [10] = {
      ["t"] = 14,
      ["k"] = 88,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле разбойников.",
        ["fr"] = "Ces livres permettent de fabriquer au style hors-la-loi.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Gesetzlosen.",
        ["en"] = "These book fragments enable crafting in the Outlaw style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль разбойников",
        ["fr"] = "Style hors-la-loi",
        ["de"] = "Stil der Gesetzlosen",
        ["en"] = "Outlaw Style",
      },
    },
    [11] = {
      ["t"] = 14,
      ["k"] = 89,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Тринимака.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Trinimac.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Trinimac.",
        ["en"] = "These book fragments enable crafting in the Trinimac style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Тринимака",
        ["fr"] = "Style de Trinimac",
        ["de"] = "Stil des Trinimac",
        ["en"] = "Trinimac Style",
      },
    },
    [12] = {
      ["t"] = 14,
      ["k"] = 90,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Малаката.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Malacath.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Malacath.",
        ["en"] = "These book fragments enable crafting in the Malacath style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Малаката",
        ["fr"] = "Style de Malacath",
        ["de"] = "Stil des Malacath",
        ["en"] = "Malacath Style",
      },
    },
    [13] = {
      ["t"] = 14,
      ["k"] = 91,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Мораг Тонг.",
        ["fr"] = "Ces livres débloquent le style d'artisanat Morag Tong.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Morag Tong.",
        ["en"] = "These books enable crafting in the Morag Tong style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Мораг Тонг",
        ["fr"] = "Style Morag Tong",
        ["de"] = "Stil der Morag Tong",
        ["en"] = "Morag Tong Style",
      },
    },
    [14] = {
      ["t"] = 14,
      ["k"] = 92,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Альдмерского Доминиона.",
        ["fr"] = "Ces extraits de livre permettent de fabriquer au style du Domaine aldmeri.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Aldmeri-Dominions.",
        ["en"] = "These book fragments enable crafting in the Aldmeri Dominion style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Альдмерского Доминиона",
        ["fr"] = "Style du Domaine aldmeri",
        ["de"] = "Stil des Aldmeri-Dominions",
        ["en"] = "Aldmeri Dominion Style",
      },
    },
    [15] = {
      ["t"] = 14,
      ["k"] = 93,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Даггерфолльского Ковенанта.",
        ["fr"] = "Ces extraits de livre permettent de fabriquer au style de l'Alliance de Daguefilante.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Dolchsturz-Bündnisses.",
        ["en"] = "These book fragments enable crafting in the Daggerfall Covenant style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Даггерфолльского Ковенанта",
        ["fr"] = "Style de l'Alliance de Daguefilante",
        ["de"] = "Stil des Dolchsturz-Bündnisses",
        ["en"] = "Daggerfall Covenant Style",
      },
    },
    [16] = {
      ["t"] = 14,
      ["k"] = 94,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Эбонхартского Пакта.",
        ["fr"] = "Ces extraits de livre permettent de fabriquer au style du Pacte de Cœurébène.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Ebenherz-Paktes.",
        ["en"] = "These book fragments enable crafting in the Ebonheart Pact style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Эбонхартского Пакта",
        ["fr"] = "Style du Pacte de Cœurébène",
        ["de"] = "Stil des Ebenherz-Pakts",
        ["en"] = "Ebonheart Pact Style",
      },
    },
    [17] = {
      ["t"] = 14,
      ["k"] = 95,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Ра Гада.",
        ["fr"] = "Ces livres permettent de fabriquer au style Ra Gada.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Ro'Wada.",
        ["en"] = "These book fragments enable crafting in the Ra Gada style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Ра Гада",
        ["fr"] = "Style Ra Gada",
        ["de"] = "Stil der Ro'Wada",
        ["en"] = "Ra Gada Style",
      },
    },
    [18] = {
      ["t"] = 14,
      ["k"] = 96,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле дро-м'Атра.",
        ["fr"] = "Ces livres permettent de fabriquer au style dro-m'Athra.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der dro-m'Athra.",
        ["en"] = "These book fragments enable crafting in the dro-m'Athra style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль дро-м'Атра",
        ["fr"] = "Style dro-m'Athra",
        ["de"] = "Stil der dro-m'Athra",
        ["en"] = "Dro-m'Athra Style",
      },
    },
    [19] = {
      ["t"] = 14,
      ["k"] = 97,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в эбонитовом стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style d'Ébonite.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen aus Ebenerz.",
        ["en"] = "These book fragments enable crafting in the Ebony style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Эбонитовый стиль",
        ["fr"] = "Style d'Ébonite",
        ["de"] = "Stil mit Ebenerz",
        ["en"] = "Ebony Style",
      },
    },
    [20] = {
      ["t"] = 14,
      ["k"] = 99,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле лиги убийц.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la ligue des assassins.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Assassinenbundes.",
        ["en"] = "These book fragments enable crafting in the Assassins League style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль лиги убийц",
        ["fr"] = "Style de la ligue des assassins",
        ["de"] = "Stil des Assassinenbundes",
        ["en"] = "Assassins League Style",
      },
    },
    [21] = {
      ["t"] = 14,
      ["k"] = 100,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Гильдии воров.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la guilde des voleurs.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Diebesgilde.",
        ["en"] = "These book fragments enable crafting in the Thieves Guild style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Гильдии воров",
        ["fr"] = "Style de la guilde des voleurs",
        ["de"] = "Stil der Diebesgilde",
        ["en"] = "Thieves Guild Style",
      },
    },
    [22] = {
      ["t"] = 14,
      ["k"] = 101,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле стражи Причала Абы.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la garde d'Abah.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil von Abahs Wacht.",
        ["en"] = "These book fragments enable crafting in the Abah's Watch style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль стражи Причала Абы",
        ["fr"] = "Style de la garde d'Abah",
        ["de"] = "Stil von Abahs Wacht",
        ["en"] = "Abah's Watch Style",
      },
    },
    [23] = {
      ["t"] = 14,
      ["k"] = 105,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле драугров.",
        ["fr"] = "Ces livres permettent de fabriquer au style Draugr.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Draugr.",
        ["en"] = "These book fragments enable crafting in the Draugr style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль драугров",
        ["fr"] = "Style Draugr",
        ["de"] = "Stil der Draugr",
        ["en"] = "Draugr Style",
      },
    },
    [24] = {
      ["t"] = 14,
      ["k"] = 106,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле минотавров.",
        ["fr"] = "Ces livres permettent de fabriquer au style des minotaures.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Minotauren.",
        ["en"] = "These book fragments enable crafting in the Minotaur style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль минотавров",
        ["fr"] = "Style des minotaures",
        ["de"] = "Stil der Minotauren",
        ["en"] = "Minotaur Style",
      },
    },
    [25] = {
      ["t"] = 14,
      ["k"] = 107,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле ордена Часа.",
        ["fr"] = "Ces livres permettent de fabriquer au style de l'Ordre des Heures.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Ordens der Stunde.",
        ["en"] = "These book fragments enable crafting in the Order of the Hour style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль ордена Часа",
        ["fr"] = "Motif de l'Ordre des Heures",
        ["de"] = "Stil des Ordens der Stunde",
        ["en"] = "Order Hour Style",
      },
    },
    [26] = {
      ["t"] = 14,
      ["k"] = 108,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Небожителей.",
        ["fr"] = "Ces livres permettent de fabriquer au style céleste.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Himmlischen.",
        ["en"] = "These book fragments enable crafting in the Celestial style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Небожителей",
        ["fr"] = "Style céleste",
        ["de"] = "Stil der Himmlischen",
        ["en"] = "Celestial Style",
      },
    },
    [27] = {
      ["t"] = 14,
      ["k"] = 109,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Пустоголового Джека.",
        ["fr"] = "Ces livres permettent de fabriquer au style d'Hallowjack.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil von Kürbisfratze.",
        ["en"] = "These book fragments enable crafting in the Hollowjack style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Пустоголового Джека",
        ["fr"] = "Style d'Hallowjack",
        ["de"] = "Stil von Kürbisfratze",
        ["en"] = "Hollowjack Style",
      },
    },
    [28] = {
      ["t"] = 14,
      ["k"] = 110,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Темного Братства.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Confrérie noire.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Dunklen Bruderschaft.",
        ["en"] = "These book fragments enable crafting in the Dark Brotherhood style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Темного Братства",
        ["fr"] = "Style de la Confrérie noire",
        ["de"] = "Stil der Dunklen Bruderschaft",
        ["en"] = "Dark Brotherhood Style",
      },
    },
    [29] = {
      ["t"] = 0,
      ["k"] = 0,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = true,
      ["n"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
    },
    [30] = {
      ["t"] = 14,
      ["k"] = 112,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле оборотней.",
        ["fr"] = "Ces livres permettent de fabriquer au style changepeau.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Gestaltwandler.",
        ["en"] = "These book fragments enable crafting in the Skinchanger style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль оборотней",
        ["fr"] = "Style changepeau",
        ["de"] = "Stil der Gestaltwandler",
        ["en"] = "Skinchanger Style",
      },
    },
    [31] = {
      ["t"] = 14,
      ["k"] = 113,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Шелкового Круга.",
        ["fr"] = "Ces livres permettent de fabriquer au style de l'Anneau de soie.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Seidenrings.",
        ["en"] = "These book fragments enable crafting in the Silken Ring style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Шелкового Круга",
        ["fr"] = "Style de l'Anneau de soie",
        ["de"] = "Stil des Seidenrings",
        ["en"] = "Silken Ring Style",
      },
    },
    [32] = {
      ["t"] = 14,
      ["k"] = 114,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Маззатуна.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Mazzatun.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil von Mazzatun.",
        ["en"] = "These book fragments enable crafting in the Mazzatun style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Маззатуна",
        ["fr"] = "Style de Mazzatun",
        ["de"] = "Stil von Mazzatun",
        ["en"] = "Mazzatun Style",
      },
    },
    [33] = {
      ["t"] = 14,
      ["k"] = 116,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле дома Телванни.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Maison Telvanni.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil des Hauses Telvanni.",
        ["en"] = "These books enable crafting in the House Telvanni style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль дома Телванни",
        ["fr"] = "Style de la Maison Telvanni",
        ["de"] = "Stil des Hauses Telvanni",
        ["en"] = "House Telvanni Style",
      },
    },
    [34] = {
      ["t"] = 14,
      ["k"] = 117,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле боевых ординаторов.",
        ["fr"] = "Ces livres débloquent le style d'artisanat des Ordonnateurs.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der kriegerischen Ordinatoren.",
        ["en"] = "These books enable crafting in the Militant Ordinator style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль боевых ординаторов",
        ["fr"] = "Style d'Ordonnateur militant",
        ["de"] = "Stil der kriegerischen Ordinatoren",
        ["en"] = "Militant Ordinator Style",
      },
    },
    [35] = {
      ["t"] = 14,
      ["k"] = 118,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Вечной стражи.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Exaltés.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Kriegswappenträger.",
        ["en"] = "These books enable crafting in the Buoyant Armiger style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Вечной стражи",
        ["fr"] = "Style d'Exalté",
        ["de"] = "Stil der Kriegswappenträger",
        ["en"] = "Buoyant Armiger Style",
      },
    },
    [36] = {
      ["t"] = 14,
      ["k"] = 119,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле эшлендеров.",
        ["fr"] = "Ces livres permettent de fabriquer au style cendrais.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Aschländer.",
        ["en"] = "These books enable crafting in the Ashlander style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль эшлендеров",
        ["fr"] = "Le style cendrais",
        ["de"] = "Stil der Aschländer",
        ["en"] = "Ashlander Style",
      },
    },
    [37] = {
      ["t"] = 14,
      ["k"] = 121,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле дома Хлаалу.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Maison Hlaalu.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil des Hauses Hlaalu.",
        ["en"] = "These books enable crafting in the House Hlaalu style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль дома Хлаалу",
        ["fr"] = "Style de la Maison Hlaalu",
        ["de"] = "Stil des Hauses Hlaalu",
        ["en"] = "House Hlaalu Style",
      },
    },
    [38] = {
      ["t"] = 14,
      ["k"] = 122,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле дома Редоран.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Maison Rédoran.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil des Hauses Redoran.",
        ["en"] = "These books enable crafting in the House Redoran style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль дома Редоран",
        ["fr"] = "Style de la Maison Rédoran",
        ["de"] = "Stil des Hauses Redoran",
        ["en"] = "House Redoran Style",
      },
    },
    [39] = {
      ["t"] = 14,
      ["k"] = 124,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в рефабрикационном стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style Refabriqué.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Rekonstruktion.",
        ["en"] = "These books enable crafting in the Refabricated style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Рефабрикационный стиль",
        ["fr"] = "Style refabriqué",
        ["de"] = "Stil der Rekonstruktion",
        ["en"] = "Refabricated Style",
      },
    },
    [40] = {
      ["t"] = 14,
      ["k"] = 125,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Кровавой кузницы.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Forgesang.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Blutquellschmiede.",
        ["en"] = "These book fragments enable crafting in the Bloodforge style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Кровавой кузницы",
        ["fr"] = "Style Forgesang",
        ["de"] = "Stil der Blutquellschmiede",
        ["en"] = "Bloodforge Style",
      },
    },
    [41] = {
      ["t"] = 14,
      ["k"] = 126,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Грозного Рога.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Corneffroi.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Grauenshorn-Klans.",
        ["en"] = "These book fragments enable crafting in the Dreadhorn style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Грозного Рога",
        ["fr"] = "Style Corneffroi",
        ["de"] = "Stil des Grauenshorn-Klans",
        ["en"] = "Dreadhorn Style",
      },
    },
    [42] = {
      ["t"] = 14,
      ["k"] = 127,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле апостолов.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Apôtres.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Apostel.",
        ["en"] = "These book fragments enable crafting in the Apostle style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль апостолов",
        ["fr"] = "Style des Apôtres",
        ["de"] = "Stil der Apostel",
        ["en"] = "Apostle Style",
      },
    },
    [43] = {
      ["t"] = 14,
      ["k"] = 128,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле эбонитовой тени.",
        ["fr"] = "Ces livres permettent de fabriquer au style d'Ombrébène.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Ebenschattens.",
        ["en"] = "These book fragments enable crafting in the Ebonshadow style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль эбонитовой тени",
        ["fr"] = "Style d'Ombrébène",
        ["de"] = "Stil des Ebenschattens",
        ["en"] = "Ebonshadow Style",
      },
    },
    [44] = {
      ["t"] = 14,
      ["k"] = 130,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Ремесленные мотивы для создания предметов в стиле культа Червя.",
        ["fr"] = "Ces livres de style permettent de fabriquer des objets au style du Culte du Ver.",
        ["de"] = "Stilkapitel, die es Euch erlauben, Gegenstände im Stil des Wurmkults herzustellen.",
        ["en"] = "Motif books that enable crafting in the Worm Cult style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль культа Червя",
        ["fr"] = "Le style du Culte du Ver",
        ["de"] = "Stil des Wurmkults",
        ["en"] = "Worm Cult Style",
      },
    },
    [45] = {
      ["t"] = 14,
      ["k"] = 131,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Логова Клыка",
        ["fr"] = "Style du Repaire du croc",
        ["de"] = "Stil des Krallenhorts",
        ["en"] = "Fang Lair Style",
      },
    },
    [46] = {
      ["t"] = 14,
      ["k"] = 132,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Воспевательницы Дракона.",
        ["fr"] = "Ces livres débloquent le style d'artisanat de la Mandécailles.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Schuppenruferin.",
        ["en"] = "These books enable crafting in the Scalecaller style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Воспевательницы Дракона",
        ["fr"] = "Style de la Mandécailles",
        ["de"] = "Stil der Schuppenruferin",
        ["en"] = "Scalecaller Style",
      },
    },
    [47] = {
      ["t"] = 14,
      ["k"] = 133,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Псиджиков",
        ["fr"] = "Le Style psijique",
        ["de"] = "Stil der Psijiker",
        ["en"] = "Psijic Style",
      },
    },
    [48] = {
      ["t"] = 14,
      ["k"] = 134,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "",
        ["fr"] = "",
        ["de"] = "",
        ["en"] = "",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль сапиархов",
        ["fr"] = "Le Style sapiarque",
        ["de"] = "Stil der Sapiarchen",
        ["en"] = "Sapiarch Style",
      },
    },
    [49] = {
      ["t"] = 14,
      ["k"] = 137,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в пиандонейском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style pyandonéen.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Pyandonesier.",
        ["en"] = "These book fragments enable crafting in the Pyandonean style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Пиандонейский стиль",
        ["fr"] = "Style pyandonéen",
        ["de"] = "Stil der Pyandonesier",
        ["en"] = "Pyandonean Style",
      },
    },
    [50] = {
      ["t"] = 14,
      ["k"] = 138,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле дремора.",
        ["fr"] = "Ces livres permettent de fabriquer au style Drémora.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Welkynare.",
        ["en"] = "These book fragments enable crafting in the Dremora style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль дремора",
        ["fr"] = "Motif Drémora",
        ["de"] = "Stil der Dremora",
        ["en"] = "Dremora Style",
      },
    },
    [51] = {
      ["t"] = 14,
      ["k"] = 139,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Охотника.",
        ["fr"] = "Ces fragments de livres permettent de fabriquer des objets au style du Chasseur.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Jägers.",
        ["en"] = "These book fragments enable crafting in the Huntsman style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Охотника",
        ["fr"] = "Style du chasseur",
        ["de"] = "Stil des Jägers",
        ["en"] = "Huntsman Style",
      },
    },
    [52] = {
      ["t"] = 14,
      ["k"] = 140,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Серебряного Рассвета.",
        ["fr"] = "Ces fragments de livres permettent de fabriquer des objets au style de l'Aube d'argent.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Silbermorgens.",
        ["en"] = "These book fragments enable crafting in the Silver Dawn style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Серебряного Рассвета",
        ["fr"] = "Style de l'Aube d'argent",
        ["de"] = "Stil des Silbermorgens",
        ["en"] = "Silver Dawn Style",
      },
    },
    [53] = {
      ["t"] = 14,
      ["k"] = 141,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле велкинаров.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Welkynars.",
        ["de"] = "Diese Bücher ermöglichen die Herstellung von Gegenständen im Stil der Welkynare.",
        ["en"] = "These books enable crafting in the Welkynar style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль велкинаров",
        ["fr"] = "Le style des Welkynars",
        ["de"] = "Stil der Welkynare",
        ["en"] = "Welkynar Style",
      },
    },
    [54] = {
      ["t"] = 14,
      ["k"] = 143,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле почетной стражи.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Garde d'Honneur.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Ehrengarde.",
        ["en"] = "These book fragments enable crafting in the Honor Guard style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль почетной стражи",
        ["fr"] = "Le style de la garde d'honneur",
        ["de"] = "Stil der Ehrengarde",
        ["en"] = "Honor Guard Style",
      },
    },
    [55] = {
      ["t"] = 14,
      ["k"] = 144,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле мертвой-воды.",
        ["fr"] = "Ces livres permettent de fabriquer au style d'Aiguemortes.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Totwasser.",
        ["en"] = "These book fragments enable crafting in the Dead-Water style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль мертвой-воды",
        ["fr"] = "Style d'Aiguemortes",
        ["de"] = "Stil der Totwasser",
        ["en"] = "Dead-Water Style",
      },
    },
    [56] = {
      ["t"] = 14,
      ["k"] = 145,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в древнеаргонианском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Aînés argoniens.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der alten Argonier.",
        ["en"] = "These book fragments enable crafting in the Elder Argonian style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Древнеаргонианский стиль",
        ["fr"] = "Style des Aînés argoniens",
        ["de"] = "Stil der alten Argonier",
        ["en"] = "Elder Argonian Style",
      },
    },
    [57] = {
      ["t"] = 14,
      ["k"] = 146,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле ледохватов.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Glaciation.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Kälteknacker.",
        ["en"] = "These book fragments enable crafting in the Coldsnap style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль ледохватов",
        ["fr"] = "Style de la Glaciation",
        ["de"] = "Stil der Kälteknacker",
        ["en"] = "Coldsnap Style",
      },
    },
    [58] = {
      ["t"] = 14,
      ["k"] = 147,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле служителей Меридии.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Méridia.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil von Meridia.",
        ["en"] = "These book fragments enable crafting in the Meridian style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль служителей Меридии",
        ["fr"] = "Style de Méridia",
        ["de"] = "Stil von Meridia",
        ["en"] = "Meridian Style",
      },
    },
    [59] = {
      ["t"] = 14,
      ["k"] = 148,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Анеквины.",
        ["fr"] = "Ces fragments de livre permettent de fabriquer au style d'Anequina.",
        ["de"] = "Diese Buchfragmente erlauben Handwerk im Stil aus Anequina",
        ["en"] = "These book fragments enable crafting in the Anequina style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Анеквины",
        ["fr"] = "Style d'Anequina",
        ["de"] = "Stil aus Anequina",
        ["en"] = "Anequina Style",
      },
    },
    [60] = {
      ["t"] = 14,
      ["k"] = 149,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Пеллитина.",
        ["fr"] = "Ces fragments de livre permettent de fabriquer au style de Pellitine.",
        ["de"] = "Diese Buchfragmente erlauben Handwerk im Stil aus Pellitine",
        ["en"] = "These book fragments enable crafting in the Pellitine style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Пеллитина",
        ["fr"] = "Style de Pellitine",
        ["de"] = "Stil aus Pellitine",
        ["en"] = "Pellitine Style",
      },
    },
    [61] = {
      ["t"] = 14,
      ["k"] = 150,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Солнечного Шпиля.",
        ["fr"] = "Ces fragments de livres permettent de fabriquer au style de Sollance.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil aus Sonnspitz.",
        ["en"] = "These book fragments enable crafting in the Sunspire style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Солнечного Шпиля",
        ["fr"] = "Style de Sollance",
        ["de"] = "Stil aus Sonnspitz",
        ["en"] = "Sunspire Style",
      },
    },
    [62] = {
      ["t"] = 14,
      ["k"] = 153,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Драконьей стражи.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Garde du dragon.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Drachengarde.",
        ["en"] = "These book fragments enable crafting in the Dragonguard style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Драконьей стражи",
        ["fr"] = "Garde du dragon",
        ["de"] = "Stil der Drachengarde",
        ["en"] = "Dragonguard Style",
      },
    },
    [63] = {
      ["t"] = 14,
      ["k"] = 154,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Оленей З'ена.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Cerfs de Z'en.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Hirsche von Z'en.",
        ["en"] = "These book fragments enable crafting in the Stags of Z'en style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Оленей З'ена",
        ["fr"] = "Style des Cerfs de Z'en",
        ["de"] = "Stil der Hirsche von Z'en",
        ["en"] = "Stags of Z'en Style",
      },
    },
    [64] = {
      ["t"] = 14,
      ["k"] = 155,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле храма Погребенных Лун.",
        ["fr"] = "Ces livres permettent de fabriquer au style du reliquaire des Lunes funèbres.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Mondgrab-Tempelstadt.",
        ["en"] = "These book fragments enable crafting in the Moongrave Fane style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль храма Погребенных Лун",
        ["fr"] = "Style du reliquaire des Lunes funèbres",
        ["de"] = "Stil der Mondgrab-Tempelstadt",
        ["en"] = "Moongrave Fane Style",
      },
    },
    [65] = {
      ["t"] = 14,
      ["k"] = 156,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле жрецов Новой Луны.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Prêtre de la Nouvelle Lune.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen der Priester des Neuen Mondes.",
        ["en"] = "These book fragments enable crafting in the New Moon Priest style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль жрецов Новой Луны",
        ["fr"] = "Style de Prêtre de la Nouvelle Lune",
        ["de"] = "Stil der Priester des Neuen Mondes",
        ["en"] = "New Moon Priest Style",
      },
    },
    [66] = {
      ["t"] = 14,
      ["k"] = 157,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Щитов Сенчала.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Boucliers de Senchal.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Schilde von Senchal.",
        ["en"] = "These book fragments enable crafting in the Shield of Senchal style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Щитов Сенчала",
        ["fr"] = "Style des Boucliers de Senchal",
        ["de"] = "Stil der Schilde von Senchal",
        ["en"] = "Shield of Senchal Style",
      },
    },
    [67] = {
      ["t"] = 14,
      ["k"] = 160,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле ковена Ледяного Предела.",
        ["fr"] = "Ces livres permettent de fabriquer au style des sorcières de Crève-Nève.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil des Eiskap-Zirkels.",
        ["en"] = "These book fragments enable crafting in the Icereach Coven style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль ковена Ледяного Предела",
        ["fr"] = "Style des sorcières de Crève-Nève",
        ["de"] = "Stil des Eiskap-Zirkels",
        ["en"] = "Icereach Coven Style",
      },
    },
    [68] = {
      ["t"] = 14,
      ["k"] = 161,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Погребального Дозора.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Vigie du bûcher.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Schürwacht.",
        ["en"] = "These book fragments enable crafting in the Pyre Watch style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Погребального Дозора",
        ["fr"] = "Style de la Vigie du bûcher",
        ["de"] = "Stil der Schürwacht",
        ["en"] = "Pyre Watch Style",
      },
    },
    [69] = {
      ["t"] = 14,
      ["k"] = 163,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле авангарда Черного Предела.",
        ["fr"] = "Ces livres permettent de fabriquer au style de l'avant-garde de Griffenoire.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Schwarzweite-Vorhut.",
        ["en"] = "These book fragments enable crafting in the Blackreach Vanguard style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль авангарда Черного Предела",
        ["fr"] = "Style de l'avant-garde de Griffenoire",
        ["de"] = "Stil der Schwarzweite-Vorhut",
        ["en"] = "Blackreach Vanguard Style",
      },
    },
    [70] = {
      ["t"] = 14,
      ["k"] = 164,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Греймура.",
        ["fr"] = "Ces livres permettent de fabriquer au style de Griselande.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Welkynare.",
        ["en"] = "These book fragments enable crafting in the Greymoor style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Греймура",
        ["fr"] = "Style de Griselande",
        ["de"] = "Stil von Graumoor",
        ["en"] = "Greymoor Style",
      },
    },
    [71] = {
      ["t"] = 14,
      ["k"] = 165,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле морских великанов.",
        ["fr"] = "Ces fragments de livres permettent de fabriquer des objets au style géant des mers.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Seeriesen.",
        ["en"] = "These book fragments enable crafting in the Sea Giant style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль морских великанов",
        ["fr"] = "Style de Géant des mers",
        ["de"] = "Stil der Seeriesen",
        ["en"] = "Sea Giant Style",
      },
    },
    [72] = {
      ["t"] = 14,
      ["k"] = 166,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в старинном нордском стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style nordique ancestral.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der einstigen Nord.",
        ["en"] = "These book fragments enable crafting in the Ancestral Nord style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Старинный нордский стиль",
        ["fr"] = "Style nordique ancestral",
        ["de"] = "Stil der einstigen Nord",
        ["en"] = "Ancestral Nord Style",
      },
    },
    [73] = {
      ["t"] = 14,
      ["k"] = 167,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в старинном стиле высоких эльфов.",
        ["fr"] = "Ces livres permettent de fabriquer au style haut-elfe ancestral.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der einstigen Hochelfen.",
        ["en"] = "These book fragments enable crafting in the Ancestral High Elf style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Старинный альтмерский стиль",
        ["fr"] = "Style altmer antique",
        ["de"] = "Stil der einstigen Hochelfen",
        ["en"] = "Ancestral High Elf Style",
      },
    },
    [74] = {
      ["t"] = 14,
      ["k"] = 168,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в старинном орочьем стиле.",
        ["fr"] = "Ces livres permettent de fabriquer au style orque ancestral.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der einstigen Orks.",
        ["en"] = "These book fragments enable crafting in the Ancestral Orc style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Старинный орочий стиль",
        ["fr"] = "Style orque ancestral",
        ["de"] = "Stil der einstigen Orks",
        ["en"] = "Ancestral Orc Style",
      },
    },
    [75] = {
      ["t"] = 14,
      ["k"] = 171,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле легиона Шипов.",
        ["fr"] = "Ces livres permettent de fabriquer au style de la Légion de Ronce.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Dornlegion.",
        ["en"] = "These book fragments enable crafting in the Thorn Legion style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль легиона Шипов",
        ["fr"] = "Style de la Légion de Ronce",
        ["de"] = "Stil der Dornlegion",
        ["en"] = "Thorn Legion Style",
      },
    },
    [76] = {
      ["t"] = 14,
      ["k"] = 172,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле гибельной алхимии.",
        ["fr"] = "Ces livres permettent de fabriquer au style de l'Alchimie hasardeuse.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der gefährlichen Alchemie.",
        ["en"] = "These book fragments enable crafting in the Hazardous Alchemy style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль гибельной алхимии",
        ["fr"] = "Style d'Alchimie hasardeuse",
        ["de"] = "Stil der gefährlichen Alchemie",
        ["en"] = "Hazardous Alchemy Style",
      },
    },
    [77] = {
      ["t"] = 14,
      ["k"] = 176,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в старинном стиле предельцев.",
        ["fr"] = "Ces livres permettent de fabriquer au style crevassais ancestral.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der einstigen Reikmannen.",
        ["en"] = "These book fragments enable crafting in the Ancestral Reach style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Старинный стиль предельцев",
        ["fr"] = "La Crevasse ancestrale",
        ["de"] = "Stil der einstige Reikmannen",
        ["en"] = "Ancestral Reach",
      },
    },
    [78] = {
      ["t"] = 14,
      ["k"] = 177,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Ночной Пустоты.",
        ["fr"] = "Ces livres permettent de fabriquer au style du Creux de nuit.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Nachttiefen.",
        ["en"] = "These book fragments enable crafting in the Nighthollow style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Ночной Пустоты",
        ["fr"] = "Style du Creux de nuit",
        ["de"] = "Stil der Nachttiefen",
        ["en"] = "Nighthollow Style",
      },
    },
    [79] = {
      ["t"] = 14,
      ["k"] = 178,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле арсенала Арктзанда.",
        ["fr"] = "Ces livres permettent de fabriquer au style de l'Armurerie d'Arkthzand.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Waffenkammer von Arkthzand.",
        ["en"] = "These book fragments enable crafting in the Arkthzand Armory style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль арсенала Арктзанда",
        ["fr"] = "Style de l'Armurerie d'Arkthzand",
        ["de"] = "Stil der Rüstkammer von Arkthzand",
        ["en"] = "Arkthzand Armory Style",
      },
    },
    [80] = {
      ["t"] = 14,
      ["k"] = 179,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Страницы этой книги позволяют создавать предметы в стиле Непокорных Стражей.",
        ["fr"] = "Ces livres permettent de fabriquer au style des Gardiens égarés.",
        ["de"] = "Diese Buchfragmente ermöglichen die Herstellung von Gegenständen im Stil der Unbezähmbaren Hüter.",
        ["en"] = "These book fragments enable crafting in the Wayward Guardian style.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Стиль Непокорных Стражей",
        ["fr"] = "Style des Gardiens égarés",
        ["de"] = "Stil der Unbezähmbaren Hüter",
        ["en"] = "Wayward Guardian Style",
      },
    },
  },
  [3] = {
    [1] = {
      ["t"] = 117,
      ["k"] = 44,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Тайны и откровения «нейтральной территории» Краглорна.",
        ["fr"] = "Mystères et révélations de la région désolée de Raidelorn.",
        ["de"] = "Mysterien und Enthüllungen der Region Kargstein.",
        ["en"] = "Mysteries and revelations from the no-man's-region of Craglorn.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Тайны Краглорна",
        ["fr"] = "Secrets de Raidelorn",
        ["de"] = "Geheimnisse von Kargstein",
        ["en"] = "Craglorn Secrets",
      },
    },
    [2] = {
      ["t"] = 97,
      ["k"] = 45,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, заметки и журналы, связанные с преступниками и преступными организациями.",
        ["fr"] = "Livres, notes et rapports relatifs au crime et aux organisations criminelles.",
        ["de"] = "Bücher, Notizen und Aufzeichnungen, die sich mit Verbrechen und kriminellen Organisationen beschäftigen.",
        ["en"] = "Books, notes, and ledgers related to crime and criminal organizations.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Переписка преступников",
        ["fr"] = "Correspondance criminelle",
        ["de"] = "Verbrecherischer Schriftverkehr",
        ["en"] = "Criminal Correspondence",
      },
    },
    [3] = {
      ["t"] = 97,
      ["k"] = 46,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_daedric.dds",
      ["d"] = {
        ["ru"] = "Книги, записки и дневники, написанные последователями даэдра или рассказывающие о них.",
        ["fr"] = "Livres, notes et journaux par et à propos des adorateurs de Daedra.",
        ["de"] = "Bücher, Notizen und Tagebücher, von und über Anhänger daedrischer Kulte.",
        ["en"] = "Books, notes, and journals by and about Daedra worshipers.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Даэдрические культы",
        ["fr"] = "Sectes daedriques",
        ["de"] = "Daedrische Kulte",
        ["en"] = "Daedric Cults",
      },
    },
    [4] = {
      ["t"] = 80,
      ["k"] = 47,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Жители Тамриэля считают своим долгом записывать события своей жизни.",
        ["fr"] = "Les habitants de Tamriel estiment qu'il est de leur devoir de tenir un journal de leur vie.",
        ["de"] = "Die Völker Tamriels haben das Gefühl, dass sie die Geschehnisse ihres Lebens aufzeichnen müssen.",
        ["en"] = "Tamrielic peoples feel they have a duty to record the events of their lives.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Дневники и журналы",
        ["fr"] = "Journaux et journaux de bord",
        ["de"] = "Tagebücher und Aufzeichnungen",
        ["en"] = "Diaries and Logs",
      },
    },
    [5] = {
      ["t"] = 121,
      ["k"] = 48,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Объявления о розыске, афиши арены, листовки с объявлениями о вознаграждении, предупреждающие знаки, надгробные эпитафии, официальные объявления, дверные таблички и так далее.",
        ["fr"] = "Avis de recherche, journaux de l'arène, primes, pancartes d'alerte, épitaphes, annonces officielles, inscriptions au-dessus des portes, etc.",
        ["de"] = "Steckbriefe, Arenawerbung, Kopfgeldschreiben, Warnschilder, Grabinschriften, offizielle Ankündigungen, Türbeschriftungen und mehr.",
        ["en"] = "Wanted posters, arena broadsheets, bounty flyers, warning signs, gravestone epitaphs, official announcements, inscriptions over doorways, and so forth.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Листовки, плакаты и указы",
        ["fr"] = "Affichages privés et officiels",
        ["de"] = "Zettel, Aushänge und Erlasse",
        ["en"] = "Handbills, Posters, and Decrees",
      },
    },
    [6] = {
      ["t"] = 79,
      ["k"] = 49,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Любовные и романтические письма, заметки и дневники.",
        ["fr"] = "Lettres, notes et journaux parlant d'amour.",
        ["de"] = "Briefe, Notizen und Tagebücher, die sich mit Liebe und Romanzen beschäftigen.",
        ["en"] = "Letters, notes, and journals about love and romance.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Сердца и цветы",
        ["fr"] = "Cœurs et petites fleurs",
        ["de"] = "Herzen und Blumen",
        ["en"] = "Hearts and Flowers",
      },
    },
    [7] = {
      ["t"] = 86,
      ["k"] = 50,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Рецепты, списки, купчие, контракты, подсказки по ведению домашнего хозяйства, счета, книги учета и так далее.",
        ["fr"] = "Recettes, listes, actes de vente, contrats, conseils domestiques, reçus, livres de compte, etc.",
        ["de"] = "Rezepte, Prüflisten, Rechnungen, Verträge, Haushaltsnotizen, Aufzeichnungen und ähnliches.",
        ["en"] = "Recipes, checklists, bills of sale, contracts, household hints, receipts, ledgers, and so forth.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Дома, магазины и торговля",
        ["fr"] = "Maisons, boutiques et commerce",
        ["de"] = "Häuser, Läden und Handel",
        ["en"] = "Houses, Shops, and Trade",
      },
    },
    [8] = {
      ["t"] = 126,
      ["k"] = 51,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Коллекция писем, которые можно считать в той или иной мере официальными.",
        ["fr"] = "Une collection de lettres relativement officielles.",
        ["de"] = "Eine Sammlung recht förmlicher Briefe.",
        ["en"] = "A collection of relatively formal letters.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Письма и послания",
        ["fr"] = "Lettres et missives",
        ["de"] = "Briefe und Sendschreiben",
        ["en"] = "Letters and Missives",
      },
    },
    [9] = {
      ["t"] = 110,
      ["k"] = 52,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги о тамриэльской культуре и обычаях.",
        ["fr"] = "Livres à propos des cultures et coutumes sociales de Tamriel.",
        ["de"] = "Bücher, die sich mit den Kulturen Tamriels und sozialen Praktiken beschäftigen.",
        ["en"] = "Books about Tamrielic cultures and social practices.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "История, обычаи и культура",
        ["fr"] = "Connaissance et culture",
        ["de"] = "Wissenswertes und Kultur",
        ["en"] = "Lore and Culture",
      },
    },
    [10] = {
      ["t"] = 104,
      ["k"] = 53,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Переписка командиров, солдат и моряков, связанная с военными действиями.",
        ["fr"] = "Correspondance de commandants, soldats et marins à propos de la guerre.",
        ["de"] = "Schriften von Kommandanten, Soldaten und Seeleuten, die sich mit mit dem Krieg beschäftigen.",
        ["en"] = "Correspondence by commanders, soldiers, and sailors relating to warfare.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Военные приказы и отчеты",
        ["fr"] = "Ordres et rapports militaires",
        ["de"] = "Militärische Befehle & Berichte",
        ["en"] = "Military Orders and Reports",
      },
    },
    [11] = {
      ["t"] = 118,
      ["k"] = 54,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги о тайнах и загадках, включающие коды, шифры, книги подсказок, письменные улики и таинственные надписи.",
        ["fr"] = "Livres traitant de mystères et d'énigmes, dont des codes, messages cryptés, livres d'indices, preuves de culpabilité et inscriptions mystérieuses.",
        ["de"] = "Bücher mit Mysterien und Rätseln, welche Codes, Chiffren, Hinweisbücher, Schuldhinweise und mysteriöse Inschriften beinhalten.",
        ["en"] = "Books about mysteries and puzzles, including codes, ciphers, clue books, proofs of guilt, and mysterious inscriptions.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Тайны и подсказки",
        ["fr"] = "Mystères et indices",
        ["de"] = "Geheimnisse und Hinweise",
        ["en"] = "Mysteries and Clues",
      },
    },
    [12] = {
      ["t"] = 123,
      ["k"] = 55,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Неофициальная переписка и заметки на клочках бумаги.",
        ["fr"] = "Communications informelles et notes personnelles sur bouts de papier.",
        ["de"] = "Informelle Schreiben und hastige Notizen für später.",
        ["en"] = "Informal communications and notes-to-self on scraps of paper.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Записки и заметки",
        ["fr"] = "Notes et mémoranda",
        ["de"] = "Notizen und Erinnerungen",
        ["en"] = "Notes and Memos",
      },
    },
    [13] = {
      ["t"] = 107,
      ["k"] = 56,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Деяния, размышления и откровения разных жителей Тамриэля.",
        ["fr"] = "Les activités, pensées et confessions d'individus de Tamriel.",
        ["de"] = "Mehr zu Aktivitäten, Gedanken und Bekenntnissen einzelner Bürger Tamriels.",
        ["en"] = "The activities, thoughts, and confessions of individual Tamrielics.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Личные дневники",
        ["fr"] = "Journaux personnels",
        ["de"] = "Persönliche Aufzeichnungen",
        ["en"] = "Personal Journals",
      },
    },
    [14] = {
      ["t"] = 89,
      ["k"] = 57,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Политические интриги, мятежи, массовые отравления, заговоры с целью вернуть в мир древнее зло и т. д.",
        ["fr"] = "Machinations politiques, rebellions, empoisonnements de masse, complots visant à ramener d'antiques maux dans le monde, etc.",
        ["de"] = "Politische Intrigen, Rebellionen, Massenvergiftungen, Pläne Böses zurück in die Welt zu bringen und vieles mehr.",
        ["en"] = "Political machinations, rebellions, mass poisonings, plots to bring ancient evil back into the world, etc.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Заговоры и интриги",
        ["fr"] = "Complots et manigances",
        ["de"] = "Pläne und Ränke",
        ["en"] = "Plots and Schemes",
      },
    },
    [15] = {
      ["t"] = 107,
      ["k"] = 58,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Заметки и дневники исследователей о магии, двемерских руинах, экспериментах на людях, алхимические трактаты и тому подобное.",
        ["fr"] = "Notes et journaux de chercheurs en magie, explorateurs de ruines dwemers, expérimentateurs sur sujets humains, tracts alchimiques, etc.",
        ["de"] = "Notizen und Tagebücher über die Erforschung der Magie, das Erkunden von Dwemerruinen, das Experimentieren an Menschen, alchemistische Abhandlungen und vieles mehr.",
        ["en"] = "Notes and journals of magical researchers, explorers of Dwarven ruins, experimenters on human subjects, alchemical tracts, and so on.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Исследовательские заметки",
        ["fr"] = "Notes de recherche",
        ["de"] = "Forschungsnotizen",
        ["en"] = "Research Notes",
      },
    },
    [16] = {
      ["t"] = 94,
      ["k"] = 59,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_magic.dds",
      ["d"] = {
        ["ru"] = "Заклинания и ритуалы, инструкции по управлению магическими устройствами, гримуары и книги заклинаний, трактаты по истории магии.",
        ["fr"] = "Sorts et rituels, instructions d'emploi d'appareils infernaux, grimoires, livres de sorts et autres traités sur l'histoire de la magie.",
        ["de"] = "Zauber und Rituale, Anleitungen für infernale Geräte, Grimoire und Zauberbücher, und Berichte über magische Geschichte.",
        ["en"] = "Spells and rituals, instructions for operating infernal devices, grimoires and spellbooks, and treatises on magical history.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Ритуалы и откровения",
        ["fr"] = "Rituels et révélations",
        ["de"] = "Rituale und Offenbarungen",
        ["en"] = "Rituals and Revelations",
      },
    },
    [17] = {
      ["t"] = 118,
      ["k"] = 60,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Истории и легенды древности, ужасающие рассказы о кровопролитиях, а также сказки на ночь для самых маленьких.",
        ["fr"] = "Histoires et légendes anciennes, horribles récits de massacres et histoires pour endormir les petits.",
        ["de"] = "Geschichten von uralten Legenden, entsetzliche Erklärungen von Massakern und Bettgeschichten für die ganz kleinen.",
        ["en"] = "Stories and ancient legends, horrific accounts of massacres, and bedtime tales for the wee ones.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Сказания Тамриэля",
        ["fr"] = "Récits de Tamriel",
        ["de"] = "Erzählungen Tamriels",
        ["en"] = "Tales of Tamriel",
      },
    },
    [18] = {
      ["t"] = 96,
      ["k"] = 61,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Трактаты, заметки, книги и журналы, написанные теми или о тех, кто силен в своей вере и/или заблуждениях.",
        ["fr"] = "Tracts, notes, livres et journaux par ou à propos de ceux pour qui accordent une grande importance à la foi et/ou leurs illusions.",
        ["de"] = "Abhandlungen, Notizen, Bücher und Tagebücher von und über diejenigen, die dem Glauben und/oder dessen Illusionen verfallen sind.",
        ["en"] = "Tracts, notes, books, and journals by and about those who are strong in their faith and/or their delusions.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Верующие и помешанные",
        ["fr"] = "Les dévots et les déments",
        ["de"] = "Die Gesalbten und die Gestörten",
        ["en"] = "The Devoted and the Deranged",
      },
    },
    [19] = {
      ["t"] = 19,
      ["k"] = 62,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, связанные с историей возвращения души героя из когтей Молага Бала.",
        ["fr"] = "Livres à propos de la quête d'un héros pour reprendre son âme à Molag Bal.",
        ["de"] = "Bücher, die von der Reise eines Helden, seine Seele von Molag Bal zurückzuerlangen, handeln.",
        ["en"] = "Books relating to a hero's quest to recover a lost soul from Molag Bal.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Пять соратников",
        ["fr"] = "Les Cinq Compagnons",
        ["de"] = "Die Fünf Gefährten",
        ["en"] = "The Five Companions",
      },
    },
    [20] = {
      ["t"] = 80,
      ["k"] = 63,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги про многочисленные и разнообразные земли Тамриэля, а также про существ, которые там обитают.",
        ["fr"] = "Guides des faunes et flores variées Tamriel.",
        ["de"] = "Bücher, die von den abwechslungsreichen Gegenden Tamriels und deren Bewohnern berichten.",
        ["en"] = "Books about the many and varied environments of Tamriel and the creatures that live in them.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Мир и его обитатели",
        ["fr"] = "Le Monde et ses créatures",
        ["de"] = "Die Welt und ihre Bewohner",
        ["en"] = "The World and Its Creatures",
      },
    },
    [21] = {
      ["t"] = 73,
      ["k"] = 64,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги стихов и песен.",
        ["fr"] = "Recueils de poèmes et de chants.",
        ["de"] = "Bücher mit Poesie und Liedern.",
        ["en"] = "Books of poetry and song.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Слова поэтов",
        ["fr"] = "Paroles des poètes",
        ["de"] = "Die Worte des Propheten",
        ["en"] = "Words of the Poets",
      },
    },
    [22] = {
      ["t"] = 78,
      ["k"] = 65,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, записки и дневники самоубийц и слишком самоуверенных персон.",
        ["fr"] = "Livres, notes et journaux des suicidaires et des intrépides.",
        ["de"] = "Bücher, Notizen und Tagebücher von Selbstmödern und allzu Selbstsicheren.",
        ["en"] = "Books, notes, and journals of the suicidal and the overconfident.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Последние слова",
        ["fr"] = "Dernières paroles",
        ["de"] = "Letzte Worte",
        ["en"] = "Final Words",
      },
    },
    [23] = {
      ["t"] = 89,
      ["k"] = 66,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, которые повышают уровень навыков читателя.",
        ["fr"] = "Livres qui améliorent les compétences de leur lecteur.",
        ["de"] = "Bücher, die das Können des Lesers in Bezug auf verschiedene Dinge verbessern.",
        ["en"] = "Books that endow the reader with skill improvements.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Книги навыков",
        ["fr"] = "Manuels de compétence",
        ["de"] = "Lehrbücher",
        ["en"] = "Skill Books",
      },
    },
    [24] = {
      ["t"] = 127,
      ["k"] = 67,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Истории, легенды и письма из южных регионов Чернотопья.",
        ["fr"] = "Légendes, récits et lettres des royaumes du sud du marais noir.",
        ["de"] = "Geschichten, Legenden und Briefe aus den südlichen Arealen von Schwarzmarsch.",
        ["en"] = "Tales, legends, and letters from the southern realms of Black Marsh.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Литература Мрачных Трясин",
        ["fr"] = "Savoir de Tourbevase",
        ["de"] = "Rund um Trübmoor",
        ["en"] = "Lore of Murkmire",
      },
    },
    [25] = {
      ["t"] = 114,
      ["k"] = 68,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Тексты, как примитивные, так и нетривиальные, из земель дальнего Ротгара.",
        ["fr"] = "Discussions sur les sauvages et les civilisés du royaume frontalier de Wrothgar.",
        ["de"] = "Diskurse wilder sowie anspruchsvoller Natur aus dem Grenzreich Wrothgar.",
        ["en"] = "Discourses savage and sophisticated from the border realm of Wrothgar.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Тексты Ротгара",
        ["fr"] = "Écrits de Wrothgar",
        ["de"] = "Worte aus Wrothgar",
        ["en"] = "Wrothgar Writings",
      },
    },
    [26] = {
      ["t"] = 20,
      ["k"] = 69,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги и переписка из Имперского города.",
        ["fr"] = "Livres et lettres de la cité impériale.",
        ["de"] = "Schriften und Briefe aus der Kaiserstadt.",
        ["en"] = "Tomes and correspondence from the Imperial City.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Имперская библиотека",
        ["fr"] = "Bibliothèque impériale",
        ["de"] = "Kaiserliche Bibliothek",
        ["en"] = "Imperial Library",
      },
    },
    [27] = {
      ["t"] = 54,
      ["k"] = 85,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_craftingstyle.dds",
      ["d"] = {
        ["ru"] = "Книги, свитки и переписка, связанные с великим городом орков и окружающими его землями.",
        ["fr"] = "Livres, parchemins et correspondance relatifs à la grande cité des Orques et sa région.",
        ["de"] = "Bücher, Schriftrollen und Briefwechsel, die mit der imposanten Stadt der Orks und ihrem Umland in Verbindung stehen.",
        ["en"] = "Books, scrolls, and correspondence relating to the great city of the Orcs and its surrounding region.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Архив Орсиниума",
        ["fr"] = "Archives d'Orsinium",
        ["de"] = "Orsinium-Archiv",
        ["en"] = "Orsinium Archive",
      },
    },
    [28] = {
      ["t"] = 78,
      ["k"] = 86,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг, найденных в регионе Хаммерфелла, известном как Проклятие Хью.",
        ["fr"] = "Un ensemble de livres que l'on trouve au Trépas des Cognées, à Martelfell.",
        ["de"] = "Eine Sammlung von Büchern, die in der Hammerfall-Region Hews Fluch gefunden wurden.",
        ["en"] = "A collection of books found in the Hammerfell region of Hew's Bane.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Полка с книгами Проклятия Хью",
        ["fr"] = "Étagère du Trépas des Cognées",
        ["de"] = "Bücherregal: Hews Fluch",
        ["en"] = "Hew's Bane Bookshelf",
      },
    },
    [29] = {
      ["t"] = 103,
      ["k"] = 87,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_places.dds",
      ["d"] = {
        ["ru"] = "Коллекция книг, найденных в западном районе Сиродила, известном как Золотой Берег.",
        ["fr"] = "Une série de livres trouvés sur la Côte d'or, la région occidentale de Cyrodiil.",
        ["de"] = "Eine Sammlung Bücher, die an der Goldküste, der westlichen Region Cyrodiils, gefunden wurde.",
        ["en"] = "A collection of books found in the western Cyrodiil region of the Gold Coast.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Библиотека Золотого Берега",
        ["fr"] = "Volumes de la Côte d'or",
        ["de"] = "Goldküsten-Wälzer",
        ["en"] = "Gold Coast Tomes",
      },
    },
    [30] = {
      ["t"] = 126,
      ["k"] = 102,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, дневники и письма, найденные на огромном вулканическом острове в сердце Морровинда или имеющие к нему отношение.",
        ["fr"] = "Tomes, journaux et lettres relatives à ou trouvées sur la grande île volcanique au cœur de Morrowind.",
        ["de"] = "Folianten, Tagebücher und Briefe von der oder zur großen Vulkaninsel im Herzen von Morrowind.",
        ["en"] = "Tomes, journals, and letters relating to or found in the great volcanic island at the heart of Morrowind.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Литература Вварденфелла",
        ["fr"] = "Volumes de Vvardenfell",
        ["de"] = "Werke aus Vvardenfell",
        ["en"] = "Vvardenfell Volumes",
      },
    },
    [31] = {
      ["t"] = 36,
      ["k"] = 103,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_tutorial_idexicon_morrowind.dds",
      ["d"] = {
        ["ru"] = "Тридцать шесть уроков-проповедей воина-поэта Вивека, живого бога Трибунала Морровинда.",
        ["fr"] = "Les trente-six leçons, ou sermons, du guerrier-poète Vivec, dieu vivant du Tribunal de Morrowind.",
        ["de"] = "Die 36 Lehren oder Lektionen des Kriegerpoeten Vivec, des lebenden Gottes des Tribunals von Morrowind.",
        ["en"] = "The thirty-six lessons, or sermons, of the warrior-poet Vivec, living god of the Tribunal of Morrowind.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "36 уроков Вивека",
        ["fr"] = "Les 36 leçons de Vivec",
        ["de"] = "Vivecs 36 Lehren",
        ["en"] = "Vivec's 36 Lessons",
      },
    },
    [32] = {
      ["t"] = 82,
      ["k"] = 104,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_dungeons.dds",
      ["d"] = {
        ["ru"] = "Различные дневники, книги, письма и свитки, собранные учеными и архивариусами со всего Тамриэля.",
        ["fr"] = "Différents tomes obscurs, journaux, libres, lettres et parchemins rassemblés par les érudits et archivistes de tout Tamriel.",
        ["de"] = "Verschiedene Folianten, Zeitschriften, Bücher, Briefe und Schriftrollen, die von Gelehrten und Archivaren aus allen Reichen Tamriels zusammengetragen wurden.",
        ["en"] = "Various and sundry tomes, journals, books, letters, and scrolls gathered by scholars and archivists across all the realms of Tamriel.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Библиотека редких книг",
        ["fr"] = "Bibliothèque des Incunables",
        ["de"] = "Bücherei der Inkunabeln",
        ["en"] = "Library of Incunabula",
      },
    },
    [33] = {
      ["t"] = 3,
      ["k"] = 115,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Книги, описывающие работу, которая никогда не кончается, — задания, которые искатели приключений могут выполнять хоть каждый день.",
        ["fr"] = "Des livres qui décrivent les tâches sans fin, le genre de quête que les aventuriers peuvent accomplir chaque jour.",
        ["de"] = "Bücher, die nie endende Aufgaben beschreiben, die Art von Aufgaben, die Abenteurer jeden Tag angehen können.",
        ["en"] = "Books that describe tasks without end, the kind of quests that adventurers can complete every day.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Альманах искателя приключений",
        ["fr"] = "Almanach de l'aventurier",
        ["de"] = "Almanach des Abenteurers",
        ["en"] = "Adventurer's Almanac",
      },
    },
    [34] = {
      ["t"] = 82,
      ["k"] = 120,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_dwemer.dds",
      ["d"] = {
        ["ru"] = "Собрание книг и записей, посвященных Сота Силу и его Заводному городу.",
        ["fr"] = "Archive de volumes et de registres relatifs à Sotha Sil et à sa Cité mécanique.",
        ["de"] = "Ein Archiv von Folianten und Aufzeichnungen, die mit Sotha Sil und seiner gleichnamigen Stadt zu tun haben.",
        ["en"] = "An archive of tomes and records relating to Sotha Sil and his city of the same name.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Мнемоника Заводного города",
        ["fr"] = "Mnemonix mécanique",
        ["de"] = "Uhrwerk-Memorabilien",
        ["en"] = "Clockwork Mnemonix",
      },
    },
    [35] = {
      ["t"] = 128,
      ["k"] = 129,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_literature.dds",
      ["d"] = {
        ["ru"] = "Размышления, истории, хроники, байки и рассказы, касающиеся жизни, культуры и общества Саммерсета.",
        ["fr"] = "Réflexions, histoires, chroniques, anecdotes et narrations relatives à la vie, la culture et la société de l'Archipel du Couchant.",
        ["de"] = "Träumereien, Geschichten, Chroniken, Anekdoten und Erzählungen zu Leben, Kultur und Gesellschaft von Sommersend",
        ["en"] = "Musings, histories, chronicles, anecdotes, and narratives pertaining to Summerset life, culture, and society.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Свитки Саммерсета",
        ["fr"] = "Parchemins du Couchant",
        ["de"] = "Sommersend-Schriftrollen",
        ["en"] = "Summerset Scrolls",
      },
    },
    [36] = {
      ["t"] = 21,
      ["k"] = 136,
      ["g"] = "/esoui/art/treeicons/gamepad/gp_lorelibrary_categoryicon_magic.dds",
      ["d"] = {
        ["ru"] = "Описания реликвий, собранных в хранилище Моавиты.",
        ["fr"] = "Descriptions des reliques collectées dans la crypte de moawita",
        ["de"] = "Beschreibungen der gesammelten Relikte des Gewölbes von Moawita.",
        ["en"] = "Descriptions of the collected relics of the Vault of Moawita.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Воспоминания Моавиты",
        ["fr"] = "Souvenirs de Moawita",
        ["de"] = "Moawita-Memoiren",
        ["en"] = "Moawita Memories",
      },
    },
    [37] = {
      ["t"] = 116,
      ["k"] = 142,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "Книги знаний, заметки, дневники и документы, связанные с северным регионом Эльсвейра.",
        ["fr"] = "Livres de savoir, notes, journaux et curiosités associés à la région nord d'Elsweyr.",
        ["de"] = "Bücher, Notizen, Tagebücher und Vermerke aus den nördlichen Teilen von Elsweyr.",
        ["en"] = "Lore books, notes, journals, and memoranda associated with the northern region of Elsweyr.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Архивы Анеквины",
        ["fr"] = "Archives d'Anequina",
        ["de"] = "Archive von Anequina",
        ["en"] = "Anequina Archives",
      },
    },
    [38] = {
      ["t"] = 76,
      ["k"] = 151,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "Книги знаний, заметки, дневники и документы, связанные с южным регионом Эльсвейра.",
        ["fr"] = "Livres de savoir, notes, journaux et curiosités associés à la région sud d'Elsweyr.",
        ["de"] = "Bücher, Notizen, Tagebücher und Vermerke aus den südlichen Teilen von Elsweyr.",
        ["en"] = "Lore books, notes, journals, and memoranda associated with the southern region of Elsweyr.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Публицистика Пеллитина",
        ["fr"] = "Annonces de Pellitine",
        ["de"] = "Pellitine-Aushänge",
        ["en"] = "Pellitine Postings",
      },
    },
    [39] = {
      ["t"] = 118,
      ["k"] = 158,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "Тексты, связанные с владениями и окрестностями Западного Скайрима.",
        ["fr"] = "Des écrits liés aux forteresses et environs du Bordeciel occidental",
        ["de"] = "Schriften, die mit den Jarltümern und Gegenden des westlichen Himmelsrand zu tun haben.",
        ["en"] = "Writings related to the holds and environs of Western Skyrim.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Монологи Солитьюда",
        ["fr"] = "Soliloques de Solitude",
        ["de"] = "Monologe in Einsamkeit",
        ["en"] = "Solitude Soliloquies",
      },
    },
    [40] = {
      ["t"] = 42,
      ["k"] = 169,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "Сообщения и записки из различных уголков Западного Скайрима.",
        ["fr"] = "Nouvelles et notes des châtelleries du Bordeciel occidental",
        ["de"] = "Neuigkeiten und Aufzeichnungen aus den Jarltümern des westlichen Himmelsrand.",
        ["en"] = "News and notes from the holds of Western Skyrim.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Архив Западного Скайрима",
        ["fr"] = "Registre du Bordeciel occidental",
        ["de"] = "Über das westliche Himmelsrand",
        ["en"] = "Western Skyrim Register",
      },
    },
    [41] = {
      ["t"] = 70,
      ["k"] = 170,
      ["g"] = "/esoui/art/icons/icon_missing.dds",
      ["d"] = {
        ["ru"] = "Книги, письма и другие записи, связанные с Пределом и его народом.",
        ["fr"] = "Livres, lettres et autres documents écrits liés à la Crevasse et ses habitants.",
        ["de"] = "Bücher, Briefe und andere schriftlich festgehaltene Werke aus dem Reik und von dessen Bewohnern.",
        ["en"] = "Books, letters, and other written material related to the Reach and its people.",
      },
      ["h"] = false,
      ["n"] = {
        ["ru"] = "Письменные источники Предела",
        ["fr"] = "Lectures sur la Crevasse",
        ["de"] = "Recherche im Reik",
        ["en"] = "The Reach Reader",
      },
    },
  },
}

-- uses mapId for key, ZoneId for z to get texture
local bookshelfData = {
  [1940] = { -- u30_leyawiincity_base
    { ["x"] = 0.402493, ["y"] = 0.456695, ["z"] = 1261 },
    { ["x"] = 0.255003, ["y"] = 0.453110, ["z"] = 1261 },
    { ["x"] = 0.163941, ["y"] = 0.579486, ["z"] = 1261 },
  },
  [1887] = { -- blackwood_base
    { ["x"] = 0.213265, ["y"] = 0.545964, ["z"] = 1261 }, -- Nine Commands of the Eight Divines
  },
  [10] = { -- rivenspire_base
    { ["x"] = 0.715786, ["y"] = 0.488517, ["z"] = 20 },
  },
  [8] = {
    { ["x"] = 0.7958272099, ["y"] = 0.4694717824, ["z"] = 280, },
    { ["x"] = 0.7136975527, ["y"] = 0.2590188980, ["z"] = 280, },
  },
  [1288] = {
    { ["x"] = 0.6968059540, ["y"] = 0.6332955956, ["z"] = 849, },
    { ["x"] = 0.3771406114, ["y"] = 0.2950019538, ["z"] = 849, },
  },
  [605] = {
    { ["x"] = 0.6917211413, ["y"] = 0.8503540158, ["z"] = 537, },
  },
}

--[[ TODO Why was the interaction type ever used
INTERACTION_MAIL = 7
INTERACTION_BOOK = 12
INTERACTION_NONE = 0
]]--
local bookData = {
  [20] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Medium Armor: Tannins and Leather",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 9,
      [258] = 6,
      [227] = 2,
      [1126] = 10,
      [7] = 3,
      [9] = 5,
      [10] = 11,
      [75] = 1,
      [12] = 12,
      [13] = 10,
      [143] = 60,
      [22] = 29,
      [74] = 2,
      [26] = 17,
      [27] = 16,
      [201] = 12,
      [61] = 37,
      [30] = 12,
      [300] = 15,
    },
  },
  [67] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4527500000,
        ["px"] = 0.7691500000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Last Words of a Devotee",
    ["cn"] = "Final Words",
  },
  [68] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Apocrypha, Apocrypha",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [256] = 2,
      [1313] = 1,
      [994] = 5,
      [1060] = 30,
      [1349] = 35,
      [1126] = 10,
      [7] = 6,
      [10] = 17,
      [13] = 5,
      [1006] = 20,
      [143] = 6,
      [16] = 4,
      [660] = 7,
      [1429] = 9,
      [439] = 3,
      [26] = 7,
      [27] = 6,
      [61] = 6,
      [667] = 1,
      [255] = 24,
      [1887] = 1,
    },
  },
  [69] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7142267914, ["py"] = 0.5927915895, ["pm"] = 26, },
    },
    ["n"] = "Ruuvitar's Journal",
    ["cn"] = "Research Notes",
  },
  [70] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6000200000,
        ["px"] = 0.7353500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Lost Communion",
    ["cn"] = "The Devoted and the Deranged",
  },
  [71] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5999100000,
        ["px"] = 0.7354700000,
        ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5985200000,
        ["px"] = 0.7353000000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Fruit and the Stone",
    ["cn"] = "Rituals and Revelations",
  },
  [72] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5998800000,
        ["px"] = 0.7356300000,
        ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5985200000,
        ["px"] = 0.7353000000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The True Balance",
    ["cn"] = "Tales of Tamriel",
  },
  [73] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Charred Notes",
    ["q"] = 3902,
    ["e"] = {
      [1] = {
        ["px"] = 0.7947523787,
        ["py"] = 0.4336324016,
        ["d"] = true,
        ["pm"] = 72,
        ["zx"] = 0.7940827904, ["zy"] = 0.4318587984, ["zm"] = 7
      },
    },
  },
  [75] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6012600000,
        ["px"] = 0.7398200000,
        ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5984700000,
        ["px"] = 0.7353200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Hidden-Hands' Journal",
    ["cn"] = "Criminal Correspondence",
  },
  [77] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0715512006, ["py"] = 0.3814103953, ["pm"] = 237, ["zx"] = 0.0716712014, ["zy"] = 0.3817292068, ["zm"] = 1, ["d"] = true, },
    },
    ["n"] = "Note to Lucien",
    ["cn"] = "Notes and Memos",
  },
  [78] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Doshia's Journal",
    ["q"] = 3856,
    ["e"] = {
      [1] = { ["px"] = 0.2485543979, ["py"] = 0.6979332025, ["pm"] = 193, ["d"] = true, ["zx"] = 0.2474271972, ["zy"] = 0.6963356117, ["zm"] = 143, },
      [2] = { ["px"] = 0.7646716135, ["py"] = 0.5179580145, ["pm"] = 205, ["zm"] = 13, },
      [3] = { ["px"] = 0.2192504027, ["py"] = 0.3319168068, ["pm"] = 33, ["zm"] = 12, },
      [4] = {
        ["px"] = 0.7361200000,
        ["py"] = 0.4263000000,
        ["d"] = true,
        ["pm"] = 241,
        ["zx"] = 0.7361519906, ["zy"] = 0.4321431990, ["zm"] = 7,
      },
      [5] = {
        ["px"] = 0.1029900000,
        ["py"] = 0.3817900000,
        ["d"] = true,
        ["pm"] = 555,
        ["zx"] = 0.1039039984, ["zy"] = 0.3813740034, ["zm"] = 1,
      },
    },
  },
  [80] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4292100000,
        ["px"] = 0.7847300000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4264700000,
        ["px"] = 0.7829600000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Rulantaril's Notes",
    ["cn"] = "Notes and Memos",
  },
  [81] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0725256006, ["py"] = 0.3815003954, ["pm"] = 237, ["zx"] = 0.0716712014, ["zy"] = 0.3817292068, ["zm"] = 1, ["d"] = true, },
    },
    ["n"] = "Red Rook Orders",
    ["cn"] = "Criminal Correspondence",
  },
  [82] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7955391786,
        ["py"] = 0.4327540016,
        ["pm"] = 72,
        ["d"] = true,
        ["zx"] = 0.7940827904, ["zy"] = 0.4318587984, ["zm"] = 7
      },
      [2] = { ["px"] = 0.7946107905, ["py"] = 0.4313920000, ["pm"] = 7, }, -- another copy just outside Crow's Wood
    },
    ["n"] = "Crow's Wood Traveler's Log",
    ["cn"] = "Final Words",
  },
  [83] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0610507998, ["py"] = 0.3760048064, ["pm"] = 111, ["zx"] = 0.0603976003, ["zy"] = 0.3746220064, ["zm"] = 1, },
    },
    ["n"] = "Dominion Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [84] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1234336032, ["py"] = 0.3526960074, ["pm"] = 228, ["zx"] = 0.1236044063, ["zy"] = 0.3526504006, ["zm"] = 1, ["d"] = true, },
    },
    ["n"] = "Bloodthorn Orders",
    ["cn"] = "Daedric Cults",
  },
  [85] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0707908008, ["py"] = 0.3246143980, ["pm"] = 203, ["zx"] = 0.0709111995, ["zy"] = 0.3234156028, ["zm"] = 1, ["d"] = true, },
      [2] = { ["px"] = 0.0709872008, ["py"] = 0.3237703981, ["pm"] = 203, ["d"] = true, },
    },
    ["n"] = "Dominion Orders: Enduum",
    ["cn"] = "Military Orders and Reports",
  },
  [86] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1108603977, ["py"] = 0.3015323932, ["pm"] = 215, ["zx"] = 0.1101304055, ["zy"] = 0.3014540036, ["zm"] = 1, ["d"] = true, },
      [2] = { ["px"] = 0.1117587977, ["py"] = 0.3018547932, ["pm"] = 215, ["d"] = true, },
    },
    ["n"] = "Bloodthorn Orders: Ebon Crypt",
    ["cn"] = "Daedric Cults",
  },
  [87] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1333423959, ["py"] = 0.2952628029, ["pm"] = 235, ["zx"] = 0.1329524044, ["zy"] = 0.2941240037, ["zm"] = 1, ["d"] = true, },
    },
    ["n"] = "Red Rook Orders: Cryptwatch",
    ["cn"] = "Criminal Correspondence",
  },
  [88] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1872320037, ["py"] = 0.2994856044, ["pm"] = 238, ["zx"] = 0.1873600020, ["zy"] = 0.2989472057, ["zm"] = 12, ["d"] = true, },
      [2] = { ["px"] = 0.1871884037, ["py"] = 0.2993848044, ["pm"] = 238, ["d"] = true, }, -- 2nd location
    },
    ["n"] = "Firebrand Watch",
    ["cn"] = "Plots and Schemes",
  },
  [89] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1779352060, ["py"] = 0.3226615952, ["pm"] = 202, ["zx"] = 0.1773340027, ["zy"] = 0.3228328034, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Orders: Steelheart Moorings",
    ["cn"] = "Military Orders and Reports",
  },
  [90] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2083408064, ["py"] = 0.3138943962, ["pm"] = 219, ["zx"] = 0.2082908007, ["zy"] = 0.3138564047, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Warning: Catacombs Infested!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [91] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1996095959, ["py"] = 0.3448415983, ["pm"] = 249, ["zx"] = 0.1986476018, ["zy"] = 0.3451248066, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Orders: Farangel's Delve",
    ["cn"] = "Daedric Cults",
  },
  [92] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2540244036, ["py"] = 0.3144491968, ["pm"] = 223, ["zx"] = 0.2542363994, ["zy"] = 0.3142708042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Orders: Bearclaw Mine",
    ["cn"] = "Daedric Cults",
  },
  [93] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2285439931, ["py"] = 0.3052532005, ["pm"] = 194, ["zx"] = 0.2289327995, ["zy"] = 0.3050692042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Orders: Norvulk Ruins",
    ["cn"] = "Daedric Cults",
  },
  [94] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1623152041, ["py"] = 0.2402856025, ["pm"] = 225, ["zx"] = 0.1617443994, ["zy"] = 0.2410700008, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Letter from Gothurg",
    ["cn"] = "Letters and Missives",
  },
  [95] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1366699951, ["py"] = 0.2536939975, ["pm"] = 216, ["zx"] = 0.1360859985, ["zy"] = 0.2535096019, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Flyleaf Catacombs",
    ["cn"] = "Criminal Correspondence",
  },
  [97] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2166659973, ["py"] = 0.2242556022, ["pm"] = 200, ["zx"] = 0.2167884008, ["zy"] = 0.2241924022, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Dealing with Quitters",
    ["cn"] = "Criminal Correspondence",
  },
  [98] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1669539941, ["py"] = 0.2200231987, ["pm"] = 204, ["zx"] = 0.1670743982, ["zy"] = 0.2193991995, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Erokii Relics",
    ["cn"] = "Military Orders and Reports",
  },
  [99] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2033695982, ["py"] = 0.2038976020, ["pm"] = 10,
      },
    },
    ["n"] = "Hildune's Secret Refuge",
    ["cn"] = "Plots and Schemes",
  },
  [100] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7204300000,
        ["py"] = 0.5781800000,
        ["d"] = true,
        ["pm"] = 138,
        ["zx"] = 0.7213615906, ["zy"] = 0.5794835916, ["zm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5770400000,
        ["px"] = 0.7319200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Keystones of Loriasel",
    ["cn"] = "Rituals and Revelations",
  },
  [102] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1402979943, ["py"] = 0.4118996128, ["pm"] = 246, ["zx"] = 0.1396068030, ["zy"] = 0.4121143921, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 1",
    ["cn"] = "Rituals and Revelations",
  },
  [104] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2068692047, ["py"] = 0.4242712115, ["pm"] = 231, ["zx"] = 0.2067940001, ["zy"] = 0.4240739940, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 7",
    ["cn"] = "Rituals and Revelations",
  },
  [105] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2084888069, ["py"] = 0.3777959964, ["pm"] = 224, ["zx"] = 0.2080355979, ["zy"] = 0.3768635923, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Note on Torn Parchment",
    ["cn"] = "Diaries and Logs",
  },
  [106] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2382524065, ["py"] = 0.4153844135, ["pm"] = 230, ["zx"] = 0.2374351956, ["zy"] = 0.4141811966, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Letter from Mirudda",
    ["cn"] = "Letters and Missives",
  },
  [107] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2483600013, ["py"] = 0.4032595894, ["pm"] = 233, ["zx"] = 0.2486303969, ["zy"] = 0.4045863961, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 15",
    ["cn"] = "Rituals and Revelations",
  },
  [108] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2755144065, ["py"] = 0.3025740004, ["pm"] = 229, ["zx"] = 0.2738100068, ["zy"] = 0.3043063940, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Lorogdu's Journal",
    ["cn"] = "Personal Journals",
  },
  [110] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3138795926, ["py"] = 0.3243843955, ["pm"] = 236, ["zx"] = 0.3143956093, ["zy"] = 0.3240907969, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Bjoulsae Boys Charter",
    ["cn"] = "Criminal Correspondence",
  },
  [111] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Orders from a Knightly Order",
    ["q"] = 4864,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3313500000,
        ["px"] = 0.2991500000,
        ["pm"] = 20,
      },
    },
  },
  [112] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3035400000,
        ["py"] = 0.3669600000,
        ["d"] = true,
        ["pm"] = 232,
        ["zx"] = 0.3029840091, ["zy"] = 0.3669607964, ["zm"] = 20,
      },
    },
    ["n"] = "Urenenya's Lament",
    ["cn"] = "Rituals and Revelations",
  },
  [113] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2620100038, ["py"] = 0.3557823987, ["pm"] = 245, ["zx"] = 0.2626820057, ["zy"] = 0.3549911977, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Lady Edwyge's Notes",
    ["cn"] = "Research Notes",
  },
  [115] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7720300000,
        ["py"] = 0.5280300000,
        ["d"] = true,
        ["pm"] = 126,
        ["zx"] = 0.7657780026, ["zy"] = 0.5322628143, ["zm"] = 13,
      },
    },
    ["n"] = "My Kwama Journal",
    ["cn"] = "Research Notes",
  },
  [118] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6129200000,
        ["px"] = 0.0612100000,
        ["pm"] = 108,
      },
    },
    ["n"] = "Alone",
    ["cn"] = "Hearts and Flowers",
  },
  [120] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Forgotten Tome",
    ["q"] = 3916,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4277100000,
        ["px"] = 0.7830200000,
        ["pm"] = 7,
      },
      [2] = {
        ["px"] = 0.0600044015, ["py"] = 0.3842144056, ["pm"] = 63, ["zm"] = 1,
      },
      [3] = { ["px"] = 0.2263932010, ["py"] = 0.7415052219, ["pm"] = 243, ["zm"] = 143, ["qc"] = true, },
    },
  },
  [121] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Summoning Rituals (Legible)",
    ["q"] = 3916,
    ["e"] = {
      [1] = { ["px"] = 0.2251320008, ["py"] = 0.7417212222, ["pm"] = 243, ["zm"] = 143, },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4264400000,
        ["px"] = 0.7830100000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 2,
        ["py"] = 0.3843200000,
        ["px"] = 0.0597200000,
        ["pm"] = 1,
      },
    },
  },
  [122] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7526900000,
        ["py"] = 0.4654800000,
        ["d"] = true,
        ["pm"] = 112,
        ["zx"] = 0.7526875935, ["zy"] = 0.4649704015, ["zm"] = 7,
      },
    },
    ["n"] = "Cult Screed",
    ["cn"] = "The Devoted and the Deranged",
  },
  [123] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7631800000,
        ["py"] = 0.4372200000,
        ["d"] = true,
        ["pm"] = 90,
      },
    },
    ["n"] = "Tattered Note",
    ["cn"] = "Criminal Correspondence",
  },
  [124] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7440900000,
        ["py"] = 0.4651600000,
        ["d"] = true,
        ["pm"] = 114,
        ["zx"] = 0.7441335890, ["zy"] = 0.4651560003, ["zm"] = 7,
      },
    },
    ["n"] = "Burnt, Mostly Illegible Scrap",
    ["cn"] = "The Devoted and the Deranged",
  },
  [125] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7023200000,
        ["py"] = 0.4604700000,
        ["d"] = true,
        ["pm"] = 110,
        ["zx"] = 0.7024251951, ["zy"] = 0.4601096005, ["zm"] = 7,
      },
    },
    ["n"] = "General Conele's Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [126] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7119500000,
        ["py"] = 0.4445000000,
        ["d"] = true,
        ["pm"] = 97,
        ["zx"] = 0.7116743959, ["zy"] = 0.4444460016, ["zm"] = 7,
      },
    },
    ["n"] = "Note from Jeegren",
    ["cn"] = "Notes and Memos",
  },
  [127] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6911100000,
        ["py"] = 0.4576800000,
        ["d"] = true,
        ["pm"] = 113,
        ["zx"] = 0.6912327949, ["zy"] = 0.4576123997, ["zm"] = 7,
      },
    },
    ["n"] = "Kennixa's List",
    ["cn"] = "The Devoted and the Deranged",
  },
  [128] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Tavo from Nahrina",
    ["q"] = 3970,
    ["e"] = {
      [1] = { ["px"] = 0.1441575926, ["py"] = 0.4011624023, ["pm"] = 83, ["zm"] = 30, },
    },
  },
  [129] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5544500000,
        ["px"] = 0.7590500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Tree-Minder's Journal",
    ["cn"] = "Personal Journals",
  },
  [130] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 26,
        ["px"] = 0.7570800000,
        ["d"] = true,
        ["py"] = 0.5670800000,
        ["mn"] = 9,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5618200000,
        ["px"] = 0.7580500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Dominion Agent's Report",
    ["cn"] = "Military Orders and Reports",
  },
  [139] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2667512133, ["py"] = 0.3798891973, ["pm"] = 71, ["zx"] = 0.2611196047, ["zy"] = 0.3860951949, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Carina's Journal",
    ["cn"] = "Research Notes",
  },
  [140] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 22,
        ["pm"] = 74,
        ["px"] = 0.6826100000,
        ["d"] = true,
        ["py"] = 0.2572500000,
      },
    },
    ["n"] = "My Journal",
    ["cn"] = "Personal Journals",
  },
  [141] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6827580056, ["py"] = 0.2660724009, ["pm"] = 8, ["zm"] = 74, },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3540000000,
        ["px"] = 0.3034100000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Scrawled Note",
    ["cn"] = "Final Words",
  },
  [142] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3549400000,
        ["px"] = 0.2986900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Another Scrawled Note",
    ["cn"] = "Final Words",
  },
  [143] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2636500000,
        ["px"] = 0.6775900000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Contract Scroll",
    ["cn"] = "Military Orders and Reports",
  },
  [144] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Dark Ministrations",
    ["q"] = 3987,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2635000000,
        ["px"] = 0.6790300000,
        ["pm"] = 74,
      },
    },
  },
  [145] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7263700000,
        ["py"] = 0.5349000000,
        ["d"] = true,
        ["pm"] = 149,
        ["zx"] = 0.7262719910, ["zy"] = 0.5341483934, ["zm"] = 26,
      },
    },
    ["n"] = "A Free Argonian's Manifesto",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [146] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2588100000,
        ["px"] = 0.6799300000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Bleakrock Fisherman's Journal",
    ["cn"] = "Personal Journals",
  },
  [148] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7454900000,
        ["py"] = 0.5889100000,
        ["d"] = true,
        ["pm"] = 150,
        ["zx"] = 0.7453391921, ["zy"] = 0.5884107913, ["zm"] = 26,
      },
      [2] = {
        ["px"] = 0.7225356198, ["py"] = 0.6095515877, ["pm"] = 148, ["d"] = true,
        ["zx"] = 0.7219671922, ["zy"] = 0.6093463906, ["zm"] = 26,
      },
    },
    ["n"] = "Argonian Journal Pages",
    ["cn"] = "Personal Journals",
  },
  [149] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7901020158, ["py"] = 0.5590763915, ["pm"] = 155, ["d"] = true,
        ["zx"] = 0.7906443908, ["zy"] = 0.5590855928, ["zm"] = 26,
      },
    },
    ["n"] = "Stonefire Ritual Tome",
    ["cn"] = "Daedric Cults",
  },
  [150] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3031000000,
        ["px"] = 0.3054400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Vantir's Journal",
    ["cn"] = "Daedric Cults",
  },
  [151] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Hymn to Kyne",
    ["q"] = 4030,
    ["e"] = {
      [1] = {
        ["py"] = 0.5353000000,
        ["pm"] = 1006,
        ["px"] = 0.3128600000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 29,
      },
    },
  },
  [152] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7939867805, ["py"] = 0.5855688052, ["pm"] = 146, ["d"] = true,
        ["zx"] = 0.7934847928, ["zy"] = 0.5852967896, ["zm"] = 26,
      },
    },
    ["n"] = "The Holy Wamasu: Care and Feeding",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [194] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6305088265, ["py"] = 0.2890855953, ["pm"] = 61, },
    },
    ["n"] = "Huvar's Journal",
    ["cn"] = "Personal Journals",
  },
  [299] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2184959931, ["py"] = 0.3847279997, ["pm"] = 76, ["zx"] = 0.2171355981, ["zy"] = 0.3833687929, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Vath'ira's Note",
    ["cn"] = "Notes and Memos",
  },
  [300] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2234251925, ["py"] = 0.3849075994, ["pm"] = 76, ["zx"] = 0.2171355981, ["zy"] = 0.3833687929, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "The Na-Totambu of Yokuda",
    ["cn"] = "The World and Its Creatures",
  },
  [301] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1442719929, ["py"] = 0.3946740025, ["pm"] = 83, ["zm"] = 30, },
      [2] = { ["px"] = 0.2216155926, ["py"] = 0.3851383992, ["pm"] = 76, ["zx"] = 0.2171355981, ["zy"] = 0.3833687929, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "KIDNAPPING!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [302] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7723359879, ["py"] = 0.6057352051, ["pm"] = 147, ["d"] = true,
        ["zx"] = 0.7716423923, ["zy"] = 0.6061343917, ["zm"] = 26,
      },
    },
    ["n"] = "Incomplete Letter",
    ["cn"] = "Letters and Missives",
  },
  [303] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7455000000,
        ["py"] = 0.5885700000,
        ["d"] = true,
        ["pm"] = 150,
        ["zx"] = 0.7453391921, ["zy"] = 0.5884107913, ["zm"] = 26,
      },
    },
    ["n"] = "Ayleid Library?",
    ["cn"] = "Final Words",
  },
  [304] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2195271967, ["py"] = 0.3843731952, ["pm"] = 30, },
    },
    ["n"] = "Khajiiti Note",
    ["cn"] = "Criminal Correspondence",
  },
  [307] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6361048251, ["py"] = 0.2871795961, ["pm"] = 61, },
    },
    ["n"] = "Keeper Ormi's Journal",
    ["cn"] = "Personal Journals",
  },
  [308] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "General Serien's Orders",
    ["q"] = 3583,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4785400000,
        ["px"] = 0.7513100000,
        ["pm"] = 7,
      },
    },
  },
  [309] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Serien's Further Orders",
    ["q"] = 3583,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4784500000,
        ["px"] = 0.7512800000,
        ["pm"] = 7,
      },
    },
  },
  [310] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Serien's Additional Orders",
    ["q"] = 3583,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4785100000,
        ["px"] = 0.7512600000,
        ["pm"] = 7,
      },
    },
  },
  [321] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 18,
        ["py"] = 0.4429700000,
        ["px"] = 0.8098500000,
        ["pm"] = 75,
      },
    },
    ["n"] = "Watchtower Ledger",
    ["cn"] = "Mysteries and Clues",
  },
  [322] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6745500000,
        ["py"] = 0.4435800000,
        ["d"] = true,
        ["pm"] = 192,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4438000000,
        ["px"] = 0.6946800000,
        ["pm"] = 7,
      },
      [3] = {
        ["px"] = 0.6739300000,
        ["py"] = 0.4433700000,
        ["d"] = true,
        ["pm"] = 192,
      },
      [4] = {
        ["mn"] = 11,
        ["py"] = 0.4453000000,
        ["px"] = 0.6819000000,
        ["pm"] = 7,
      },
      [5] = {
        ["mn"] = 11,
        ["py"] = 0.4446700000,
        ["px"] = 0.6768400000,
        ["pm"] = 7,
      },
      [6] = {
        ["mn"] = 11,
        ["py"] = 0.4678200000,
        ["px"] = 0.6933100000,
        ["pm"] = 7,
      },
      [7] = {
        ["mn"] = 11,
        ["py"] = 0.4492400000,
        ["px"] = 0.7390700000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Letter from Vila",
    ["cn"] = "The Devoted and the Deranged",
  },
  [324] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4265800000,
        ["px"] = 0.7834400000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4679100000,
        ["px"] = 0.6925300000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 11,
        ["py"] = 0.4510100000,
        ["px"] = 0.7438600000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Interview with a Spider Cultist",
    ["cn"] = "Rituals and Revelations",
  },
  [325] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4492800000,
        ["px"] = 0.7406300000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4280700000,
        ["px"] = 0.7827000000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 11,
        ["py"] = 0.4527800000,
        ["px"] = 0.6765200000,
        ["pm"] = 7,
        [4] = { ["px"] = 0.7406320054, ["py"] = 0.4492492105, ["pm"] = 511, ["fp"] = true, },
      },
    },
    ["n"] = "Notes on the Dreugh",
    ["cn"] = "Research Notes",
  },
  [326] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Truths of the North",
    ["q"] = 4071,
    ["e"] = {
      [1] = { ["px"] = 0.6086072242, ["py"] = 0.2851691983, ["pm"] = 61, },
    },
  },
  [327] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 74,
        ["px"] = 0.6872300000,
        ["d"] = true,
        ["py"] = 0.2629600000,
        ["mn"] = 22,
      },
    },
    ["n"] = "Scroll of Banishment",
    ["cn"] = "Military Orders and Reports",
  },
  [328] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Dry Page",
    ["q"] = 4071,
    ["e"] = {
      [1] = { ["px"] = 0.6031887827, ["py"] = 0.2822936042, ["pm"] = 153, ["zx"] = 0.6031887827, ["zy"] = 0.2822936042, ["zm"] = 153, ["d"] = true, ["qp"] = true, },
    },
  },
  [329] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Damp Page",
    ["q"] = 4071,
    ["e"] = {
      [1] = { ["px"] = 0.6034899827, ["py"] = 0.2815620043, ["pm"] = 153, ["zx"] = 0.6034900225, ["zy"] = 0.2815619968, ["zm"] = 61, ["d"] = true, },
    },
  },
  [330] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Singed Page",
    ["q"] = 4071,
    ["e"] = {
      [1] = { ["px"] = 0.6032115828, ["py"] = 0.2813656042, ["pm"] = 153, ["zx"] = 0.6032116259, ["zy"] = 0.2813655971, ["zm"] = 61, ["d"] = true, },
    },
  },
  [331] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Dusty Page",
    ["q"] = 4071,
    ["e"] = {
      [1] = { ["px"] = 0.6035163827, ["py"] = 0.2819408043, ["pm"] = 153, ["zx"] = 0.6035164250, ["zy"] = 0.2819407962, ["zm"] = 61, ["d"] = true, },
    },
  },
  [332] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4717200000,
        ["px"] = 0.7033100000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4760300000,
        ["px"] = 0.6931000000,
        ["pm"] = 7,
      },
    },
    ["n"] = "To the Captain",
    ["cn"] = "Military Orders and Reports",
  },
  [333] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4752500000,
        ["px"] = 0.6926000000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4711900000,
        ["px"] = 0.7007400000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Tanval's Directive",
    ["cn"] = "Military Orders and Reports",
  },
  [334] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4764600000,
        ["px"] = 0.6925400000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4710500000,
        ["px"] = 0.7042100000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 11,
        ["py"] = 0.4754100000,
        ["px"] = 0.6928700000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Note from Captain Dunveril",
    ["cn"] = "Military Orders and Reports",
  },
  [335] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3129100000,
        ["px"] = 0.1123400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Spindleclutch Expedition",
    ["cn"] = "Research Notes",
  },
  [336] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0549396003, ["py"] = 0.3341996059, ["pm"] = 1,
      },
    },
    ["n"] = "Guild Contract: Spindleclutch",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [337] = {
    ["q"] = 4058,
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6355876270, ["py"] = 0.2669752006, ["pm"] = 160, ["zm"] = 61, },
    },
    ["n"] = "Leimaer the Raven's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [338] = {
    ["c"] = true,
    ["q"] = 4060,
    ["e"] = {
      [1] = { ["px"] = 0.6301764233, ["py"] = 0.2815471957, ["pm"] = 61, ["qp"] = true, },
    },
    ["n"] = "Orders from Fildgor",
    ["cn"] = "Plots and Schemes",
  },
  [339] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6827772055, ["py"] = 0.2660436009, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "Mathor's Journal",
    ["cn"] = "Personal Journals",
  },
  [340] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6824072055, ["py"] = 0.2649236009, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "Supplies and Sundries",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [341] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2660700000,
        ["px"] = 0.6827500000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Letter from Tillrani",
    ["cn"] = "Letters and Missives",
  },
  [342] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6827596057, ["py"] = 0.2662060008, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "Letter to Rana",
    ["cn"] = "Military Orders and Reports",
  },
  [343] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6822572056, ["py"] = 0.2648844010, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "Letter to Seyne",
    ["cn"] = "Letters and Missives",
  },
  [344] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6826920054, ["py"] = 0.2661448009, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "Rana's Log",
    ["cn"] = "Diaries and Logs",
  },
  [345] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6827076057, ["py"] = 0.2662644009, ["pm"] = 8, ["zm"] = 74, },
    },
    ["n"] = "To Grandmaster Sees-All-Colors",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [347] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2661100000,
        ["px"] = 0.6815100000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Eiman's Fishy Secrets",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [348] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2649000000,
        ["px"] = 0.6814600000,
        ["pm"] = 74,
      },
      [2] = {
        ["mn"] = 22,
        ["py"] = 0.2643900000,
        ["px"] = 0.6813300000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Aera's Household Notes",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [349] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5762000000,
        ["py"] = 0.3636300000,
        ["d"] = true,
        ["pm"] = 465,
      },
      [2] = {
        ["mn"] = 22,
        ["py"] = 0.2650700000,
        ["px"] = 0.6814200000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Ode to Oinkers",
    ["cn"] = "Words of the Poets",
  },
  [350] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2649900000,
        ["px"] = 0.6814800000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Tryn's Smithing Notes",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [351] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2649300000,
        ["px"] = 0.6814900000,
        ["pm"] = 74,
      },
      [2] = {
        ["mn"] = 22,
        ["py"] = 0.2647300000,
        ["px"] = 0.6808600000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Against the Snakes",
    ["cn"] = "Lore and Culture",
  },
  [352] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2655900000,
        ["px"] = 0.6811700000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Contracts and Bounties",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [353] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2658200000,
        ["px"] = 0.6809600000,
        ["pm"] = 74,
      },
    },
    ["n"] = "Small Meals, Fast Meals",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [368] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6416276197, ["py"] = 0.2693399979, ["pm"] = 61, },
    },
    ["n"] = "Journal of Skorvild Frostwind",
    ["cn"] = "Personal Journals",
  },
  [369] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6429580239, ["py"] = 0.2680511977, ["pm"] = 61, },
    },
    ["n"] = "From Shad Astula with Love",
    ["cn"] = "Notes and Memos",
  },
  [370] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6455036286, ["py"] = 0.2635859945, ["pm"] = 61, },
    },
    ["n"] = "Howls in the Night",
    ["cn"] = "The World and Its Creatures",
  },
  [372] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2649900000,
        ["px"] = 0.6474700000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Giants: A Discourse",
    ["cn"] = "The World and Its Creatures",
  },
  [373] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6423100213, ["py"] = 0.2764811968, ["pm"] = 61, },
    },
    ["n"] = "You Are What You Eat",
    ["cn"] = "The Devoted and the Deranged",
  },
  [374] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6381200247, ["py"] = 0.2741951966, ["pm"] = 61, },
    },
    ["n"] = "Fishing Camp Checklist",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [376] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6301164229, ["py"] = 0.2888819953, ["pm"] = 61, },
    },
    ["n"] = "Keepers of the Grove",
    ["cn"] = "The World and Its Creatures",
  },
  [377] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6359904223, ["py"] = 0.2874927971, ["pm"] = 61, },
      [2] = { ["px"] = 0.6302288229, ["py"] = 0.2892111942, ["pm"] = 61, },
    },
    ["n"] = "Goddess of Storm, Mother of Nords",
    ["cn"] = "Lore and Culture",
  },
  [378] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6178152261, ["py"] = 0.2655431964, ["pm"] = 61, },
    },
    ["n"] = "Pending Orders",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [380] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2651400000,
        ["px"] = 0.6136800000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Voljar's Meadery Recipes",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [381] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6647871785, ["py"] = 0.3070576059, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Mzulft Researcher's Journal",
    ["cn"] = "Research Notes",
  },
  [382] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6570371783, ["py"] = 0.3027584055, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 3",
    ["cn"] = "Research Notes",
  },
  [383] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6568395782, ["py"] = 0.3049336055, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 7",
    ["cn"] = "Research Notes",
  },
  [384] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6575947782, ["py"] = 0.3060376054, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 12",
    ["cn"] = "Research Notes",
  },
  [385] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6579983783, ["py"] = 0.3059404057, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 14",
    ["cn"] = "Research Notes",
  },
  [386] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6584895783, ["py"] = 0.3053552056, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 19",
    ["cn"] = "Research Notes",
  },
  [387] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6590251783, ["py"] = 0.3036032056, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 22",
    ["cn"] = "Research Notes",
  },
  [388] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6605655782, ["py"] = 0.3054744056, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 24",
    ["cn"] = "Research Notes",
  },
  [389] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6509584262, ["py"] = 0.3039863937, ["pm"] = 61,
      },
    },
    ["n"] = "Legends of the Forest",
    ["cn"] = "Tales of Tamriel",
  },
  [390] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6522159963, ["py"] = 0.2974032062, ["pm"] = 158, ["d"] = true,
        ["zx"] = 0.6508840205, ["zy"] = 0.2997471971, ["zm"] = 61,
      },
    },
    ["n"] = "Calo's Journal",
    ["cn"] = "Personal Journals",
  },
  [391] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6102712237, ["py"] = 0.2779879974, ["pm"] = 61, },
    },
    ["n"] = "Nord Soldier's Journal",
    ["cn"] = "Personal Journals",
  },
  [392] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6116168248, ["py"] = 0.2794827961, ["pm"] = 61,
      },
    },
    ["n"] = "The Fall of Queen Nurnhilde",
    ["cn"] = "Words of the Poets",
  },
  [393] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2833500000,
        ["px"] = 0.6134400000,
        ["pm"] = 61,
      },
    },
    ["n"] = "The Orc Song",
    ["cn"] = "Words of the Poets",
  },
  [394] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6362700000,
        ["px"] = 0.3849200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Journal of a Z'en Priest",
    ["cn"] = "Personal Journals",
  },
  [395] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6362800000,
        ["px"] = 0.3849200000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6382400000,
        ["px"] = 0.3787000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Old Drublog Journal",
    ["cn"] = "Personal Journals",
  },
  [396] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6398600000,
        ["px"] = 0.3796100000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6362900000,
        ["px"] = 0.3848900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Drublog Shaman's Journal",
    ["cn"] = "Personal Journals",
  },
  [397] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6362900000,
        ["px"] = 0.3848900000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6324300000,
        ["px"] = 0.3831700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Founding of Bloodtoil",
    ["cn"] = "The World and Its Creatures",
  },
  [398] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6440624265, ["py"] = 0.3056955974, ["pm"] = 61,
      },
    },
    ["n"] = "Perfumed Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [399] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3058200000,
        ["px"] = 0.6522300000,
        ["pm"] = 61,
      },
    },
    ["n"] = "A New Recipe?",
    ["cn"] = "Skill Books",
  },
  [400] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6205100000,
        ["px"] = 0.3986300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Sunk into Ouze",
    ["cn"] = "Lore and Culture",
  },
  [401] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6191900000,
        ["px"] = 0.4044100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Oathbreakers of Ouze",
    ["cn"] = "The Devoted and the Deranged",
  },
  [402] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6178500000,
        ["px"] = 0.4038600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Altars of Bone",
    ["cn"] = "Lore and Culture",
  },
  [403] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6128100000,
        ["px"] = 0.4035500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Song of the Spirits",
    ["cn"] = "Words of the Poets",
  },
  [404] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 8,
        ["pm"] = 22,
        ["px"] = 0.4032700000,
        ["d"] = true,
        ["py"] = 0.6190900000,
      },
    },
    ["n"] = "The Excavation of Ouze",
    ["cn"] = "Daedric Cults",
  },
  [406] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0629864013, ["py"] = 0.3832704053, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Report: Missing Persons",
    ["cn"] = "Notes and Memos",
  },
  [407] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6133892237, ["py"] = 0.2835011981, ["pm"] = 61, },
    },
    ["n"] = "Dear Johun Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [408] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5944120274, ["py"] = 0.3197515974, ["pm"] = 578, ["zm"] = 61, },
      [2] = { ["px"] = 0.6119560229, ["py"] = 0.2835235951, ["pm"] = 61, },
      [3] = { ["px"] = 0.6060820234, ["py"] = 0.2798911975, ["pm"] = 61, },
    },
    ["n"] = "Orcs: Monsters or Misunderstood?",
    ["cn"] = "Lore and Culture",
  },
  [409] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3020900000,
        ["px"] = 0.6162100000,
        ["pm"] = 61,
      },
      [2] = {
        ["px"] = 0.6152500000,
        ["py"] = 0.3018800000,
        ["d"] = true,
        ["pm"] = 154,
      },
    },
    ["n"] = "Henri's Journal",
    ["cn"] = "Personal Journals",
  },
  [410] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6166200000,
        ["py"] = 0.3020000000,
        ["d"] = true,
        ["pm"] = 154,
      },
      [2] = {
        ["mn"] = 13,
        ["py"] = 0.3021700000,
        ["px"] = 0.6161000000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Ophelia's Journal",
    ["cn"] = "Personal Journals",
  },
  [411] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6403400000,
        ["px"] = 0.3798900000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6397900000,
        ["px"] = 0.3804000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Dalaneth's Journal, Page 1",
    ["cn"] = "Hearts and Flowers",
  },
  [413] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6302300000,
        ["px"] = 0.3784300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Dalaneth's Journal, Page 2",
    ["cn"] = "Hearts and Flowers",
  },
  [414] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6322700000,
        ["px"] = 0.3759100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Dalaneth's Journal, Page 3",
    ["cn"] = "Hearts and Flowers",
  },
  [416] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Ritual of Unbinding",
    ["q"] = 4124,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6494300000,
        ["px"] = 0.3920600000,
        ["pm"] = 22,
      },
    },
  },
  [417] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Slave's Diary",
    ["q"] = 4607,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3919400000,
        ["px"] = 0.0739100000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4328700000,
        ["px"] = 0.7714200000,
        ["pm"] = 7,
      },
      [3] = { ["px"] = 0.2473067985, ["py"] = 0.7429204150, ["pm"] = 143, ["qc"] = true, },
      [4] = { ["px"] = -0.0909216007, ["py"] = 0.0671919996, ["pm"] = 493, ["d"] = true, }, -- on location DURING quest
    },
  },
  [418] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6158700000,
        ["px"] = 0.3273900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Letter to Edhelfin",
    ["cn"] = "Letters and Missives",
  },
  [419] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6131900000,
        ["px"] = 0.3262800000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Provision Requests",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [420] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6138100000,
        ["px"] = 0.3361100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Steel Shrikes Proclamation",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [421] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6092500000,
        ["px"] = 0.3382100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Voyages of Il-Am-Hakim, Vol. 3",
    ["cn"] = "Tales of Tamriel",
  },
  [422] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4872400000,
        ["px"] = 0.4963700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Picnic Note",
    ["cn"] = "Hearts and Flowers",
  },
  [423] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6562391783, ["py"] = 0.3057820055, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 10",
    ["cn"] = "Research Notes",
  },
  [424] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6578363782, ["py"] = 0.3051472056, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 16",
    ["cn"] = "Research Notes",
  },
  [425] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6612483785, ["py"] = 0.3064592052, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 25",
    ["cn"] = "Research Notes",
  },
  [426] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6610011781, ["py"] = 0.3068892052, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 29",
    ["cn"] = "Research Notes",
  },
  [427] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6606575782, ["py"] = 0.3074700058, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 30",
    ["cn"] = "Research Notes",
  },
  [428] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6604547784, ["py"] = 0.3079552054, ["pm"] = 159, ["d"] = true,
        ["zx"] = 0.6580688215, ["zy"] = 0.3021187943, ["zm"] = 61,
      },
    },
    ["n"] = "Kireth's Journal, Page 33",
    ["cn"] = "Research Notes",
  },
  [430] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7277060013, ["py"] = 0.4958479879, ["pm"] = 115, ["d"] = true,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
    },
    ["n"] = "Smuggler's Note",
    ["cn"] = "Criminal Correspondence",
  },
  [431] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7316656012, ["py"] = 0.4941175878, ["pm"] = 115, ["d"] = true,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
    },
    ["n"] = "Journal of Nicolas Douare",
    ["cn"] = "The Devoted and the Deranged",
  },
  [432] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Alchemy Report",
    ["q"] = 4150,
    ["e"] = {
      [1] = { ["py"] = 0.3157300000, ["px"] = 0.5973900000, ["pm"] = 578, ["zm"] = 61, },
    },
  },
  [433] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7265612011, ["py"] = 0.4924603878, ["pm"] = 115, ["d"] = true,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
    },
    ["n"] = "Garil's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [434] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1321707954, ["py"] = 0.3225804028, ["pm"] = 174, ["d"] = true,
        ["zx"] = 0.1260392047, ["zy"] = 0.3238944024, ["zm"] = 1,
      },
    },
    ["n"] = "The Whisperer's Song, Verse 1",
    ["cn"] = "Words of the Poets",
  },
  [435] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1388743955, ["py"] = 0.3217764027, ["pm"] = 174, ["d"] = true,
        ["zx"] = 0.1260392047, ["zy"] = 0.3238944024, ["zm"] = 1,
      },
    },
    ["n"] = "The Whisperer's Song, Verse 2",
    ["cn"] = "Words of the Poets",
  },
  [436] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1402567948, ["py"] = 0.3250880027, ["pm"] = 174, ["d"] = true,
        ["zx"] = 0.1260392047, ["zy"] = 0.3238944024, ["zm"] = 1,
      },
    },
    ["n"] = "The Whisperer's Song, Verse 3",
    ["cn"] = "Words of the Poets",
  },
  [437] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Arkay the Enemy",
    ["q"] = 4160,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3923700000,
        ["px"] = 0.6777800000,
        ["pm"] = 125,
      },
    },
  },
  [438] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Note from Gullveig",
    ["q"] = 4160,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3923800000,
        ["px"] = 0.6778500000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3947000000,
        ["px"] = 0.6764900000,
        ["pm"] = 125,
      },
    },
  },
  [441] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["py"] = 0.3271900000, ["px"] = 0.5969800000, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Note to King Jorunn",
    ["cn"] = "Notes and Memos",
  },
  [442] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5975488272, ["py"] = 0.3279583972, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "The Quiet Room",
    ["cn"] = "Words of the Poets",
  },
  [443] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6318220264, ["py"] = 0.3027415913, ["pm"] = 61, },
    },
    ["n"] = "Valeric's Journal",
    ["cn"] = "Mysteries and Clues",
  },
  [444] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3095500000,
        ["px"] = 0.6202300000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Kerthor's Supply List",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [445] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3013800000,
        ["px"] = 0.6239100000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Letter from Gabbi",
    ["cn"] = "Letters and Missives",
  },
  [446] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2951500000,
        ["px"] = 0.6156100000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Letter to Jakild",
    ["cn"] = "Letters and Missives",
  },
  [447] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6147300000,
        ["py"] = 0.3033800000,
        ["d"] = true,
        ["pm"] = 154,
      },
      [2] = {
        ["mn"] = 13,
        ["py"] = 0.3022300000,
        ["px"] = 0.6160800000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Dark Ritual",
    ["cn"] = "Rituals and Revelations",
  },
  [448] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6213300000,
        ["px"] = 0.3261500000,
        ["pm"] = 22,
      },
      [2] = {
        ["px"] = 0.3260900000,
        ["py"] = 0.6203700000,
        ["d"] = true,
        ["pm"] = 284,
      },
    },
    ["n"] = "Firras' Journal",
    ["cn"] = "Plots and Schemes",
  },
  [449] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3263175984, ["py"] = 0.6230672129, ["pm"] = 22, },
    },
    ["n"] = "Journal of Urodil Sea-Born",
    ["cn"] = "Plots and Schemes",
  },
  [450] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3275400000,
        ["py"] = 0.6234700000,
        ["d"] = true,
        ["pm"] = 284,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6213800000,
        ["px"] = 0.3260500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Watch Log, Volume 245",
    ["cn"] = "Diaries and Logs",
  },
  [451] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Valasha's Journal",
    ["q"] = 3858,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["pm"] = 9,
        ["mn"] = 7,
        ["px"] = 0.4318500000,
        ["d"] = true,
        ["py"] = 0.7336600000,
      },
      [2] = { ["px"] = 0.2182444027, ["py"] = 0.3328784071, ["pm"] = 33, ["zm"] = 12, },
      [3] = {
        ["px"] = 0.2274200000,
        ["d"] = true,
        ["py"] = 0.3340500000,
        ["pm"] = 102,
      },
      [4] = {
        ["mn"] = 10,
        ["py"] = 0.5178400000,
        ["px"] = 0.7665700000,
        ["pm"] = 13,
      },
    },
  },
  [452] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3449200000,
        ["px"] = 0.6148900000,
        ["pm"] = 125,
      },
    },
    ["n"] = "A Diet of Eyes",
    ["cn"] = "The World and Its Creatures",
  },
  [455] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7400396011, ["py"] = 0.5019676187, ["pm"] = 13, },
    },
    ["n"] = "No Quarantine for Us",
    ["cn"] = "Final Words",
  },
  [456] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7295848011, ["py"] = 0.4993079877, ["pm"] = 115, ["d"] = true,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
    },
    ["n"] = "A Plea in Parting",
    ["cn"] = "Hearts and Flowers",
  },
  [457] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7265004010, ["py"] = 0.4954347877, ["pm"] = 115, ["d"] = true,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
    },
    ["n"] = "Redoran Cooking Secrets",
    ["cn"] = "Skill Books",
  },
  [458] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Orders to Halskar",
    ["q"] = 4062,
    ["e"] = {
      [1] = { ["px"] = 0.6085244262, ["py"] = 0.2824731944, ["pm"] = 61, },
      [2] = { ["px"] = 0.6085380256, ["py"] = 0.2818607972, ["pm"] = 61, }, -- 2nd location
    },
  },
  [460] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Delver Notes",
    ["q"] = 4147,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3676600000,
        ["px"] = 0.5524500000,
        ["pm"] = 125,
      },
    },
  },
  [461] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3707000000,
        ["py"] = 0.6604100000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "The Lost Warrior",
    ["cn"] = "Mysteries and Clues",
  },
  [462] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3706900000,
        ["py"] = 0.6602900000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "The Ebon Mage",
    ["cn"] = "Mysteries and Clues",
  },
  [463] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3708600000,
        ["py"] = 0.6603400000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "The Thief's Luck",
    ["cn"] = "Mysteries and Clues",
  },
  [464] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6301200000,
        ["px"] = 0.3983000000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6123000000,
        ["px"] = 0.3901200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Tale Forever Told",
    ["cn"] = "Tales of Tamriel",
  },
  [466] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6244500000,
        ["px"] = 0.3676300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Note from Firuin",
    ["cn"] = "The Devoted and the Deranged",
  },
  [467] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6092000234, ["py"] = 0.3181587948, ["pm"] = 61, },
    },
    ["n"] = "Grida's Note",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [468] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Practical Necromancy",
    ["q"] = 4201,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["pm"] = 125,
        ["py"] = 0.3926100000,
        ["px"] = 0.6623100000,
        ["r"] = true,
      },
    },
  },
  [469] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6562700000,
        ["py"] = 0.2643700000,
        ["d"] = true,
        ["pm"] = 163,
      },
    },
    ["n"] = "Letter from Chill Hollow",
    ["cn"] = "Hearts and Flowers",
  },
  [470] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6557100000,
        ["py"] = 0.2642400000,
        ["d"] = true,
        ["pm"] = 163,
      },
    },
    ["n"] = "Treasure Hunter's Journal",
    ["cn"] = "Final Words",
  },
  [481] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5964100000,
        ["px"] = 0.4058500000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6031300000,
        ["px"] = 0.4053700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Note to Rufinus",
    ["cn"] = "Criminal Correspondence",
  },
  [482] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Gold Coast Missive",
    ["q"] = 4196,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6030800000,
        ["px"] = 0.4053200000,
        ["pm"] = 22,
      },
    },
  },
  [484] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Grida's Note to Dralof",
    ["q"] = 4204,
    ["e"] = {
      [1] = {
        ["px"] = 0.6287072260, ["py"] = 0.3162747922, ["pm"] = 61,
      },
    },
  },
  [485] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2920600000,
        ["px"] = 0.6194800000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Letter to Imwyn",
    ["cn"] = "Final Words",
  },
  [486] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6456600000,
        ["py"] = 0.2894100000,
        ["d"] = true,
        ["pm"] = 164,
      },
    },
    ["n"] = "Legend of Thane Icehammer",
    ["cn"] = "Tales of Tamriel",
  },
  [487] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6356900000,
        ["py"] = 0.3204300000,
        ["d"] = true,
        ["pm"] = 165,
      },
    },
    ["n"] = "Eorim's Tale",
    ["cn"] = "Tales of Tamriel",
  },
  [488] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5829528080, ["py"] = 0.3106863943, ["pm"] = 166, ["d"] = true,
        ["zx"] = 0.5822444242, ["zy"] = 0.3098359934, ["zm"] = 61,
      },
    },
    ["n"] = "Last Will and Testament",
    ["cn"] = "Final Words",
  },
  [489] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6564704055, ["py"] = 0.3254252014, ["pm"] = 168, ["zx"] = 0.6560156275, ["zy"] = 0.3251055968, ["zm"] = 61, ["d"] = true, },
    },
    ["n"] = "The Stormcrag Family Crypt",
    ["cn"] = "Tales of Tamriel",
  },
  [490] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6717487930, ["py"] = 0.3205147955, ["pm"] = 167, ["zx"] = 0.6700232241, ["zy"] = 0.3204872002, ["zm"] = 61, ["d"] = true, }, },
    ["n"] = "Letter from Agnenor",
    ["cn"] = "Letters and Missives",
  },
  [491] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5797200000,
        ["px"] = 0.4062100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Moldy Journal",
    ["cn"] = "Personal Journals",
  },
  [493] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Hadmal's Journal, Page 3",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6582820249, ["py"] = 0.3211611999, ["pm"] = 61, },
    },
  },
  [494] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Hadmal's Journal, Page 7",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6306912276, ["py"] = 0.2661868000, ["pm"] = 160, ["zm"] = 61, ["qp"] = true, },
      [2] = { ["px"] = 0.6603664231, ["py"] = 0.3116267935, ["pm"] = 61, ["qc"] = true, },
    },
  },
  [495] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Hadmal's Journal, Page 12",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6207792267, ["py"] = 0.3042187946, ["pm"] = 61, ["qp"] = true, },
      [2] = { ["px"] = 0.6604000211, ["py"] = 0.3115871969, ["pm"] = 61, ["qc"] = true, },
    },
  },
  [496] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Gilded Letter",
    ["q"] = 4209,
    ["e"] = {
      [1] = { ["px"] = 0.2481808020, ["py"] = 0.7270744193, ["pm"] = 143, },
    },
  },
  [497] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter to Sonya",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6582468248, ["py"] = 0.3210395969, ["pm"] = 61, ["qc"] = true, },
    },
  },
  [498] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Farewell Missive",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6601452279, ["py"] = 0.3115835921, ["pm"] = 61, ["qc"] = true, },
    },
  },
  [499] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Hadmal Lastblood's Journal",
    ["q"] = 4212,
    ["e"] = {
      [1] = { ["px"] = 0.6603544259, ["py"] = 0.3114455954, ["pm"] = 61, ["qc"] = true, },
    },
  },
  [500] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5967636274, ["py"] = 0.3272211971, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Letter to Dhalen",
    ["cn"] = "Criminal Correspondence",
  },
  [502] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Reminder",
    ["q"] = 4210,
    ["e"] = {
      [1] = { ["px"] = 0.2406443959, ["py"] = 0.7205840162, ["pm"] = 143, },
    },
  },
  [503] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7726440136, ["py"] = 0.5133052141, ["pm"] = 205, ["zm"] = 13,
      },
    },
    ["n"] = "Kwama Shipment Manifest",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [504] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7715320130, ["py"] = 0.5158816141, ["pm"] = 205, ["zm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5190400000,
        ["px"] = 0.7630800000,
        ["pm"] = 205,
        ["zm"] = 13,
      },
    },
    ["n"] = "WANTED: Tervur Sadri",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [505] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5173100000,
        ["px"] = 0.8187500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Note to Selias",
    ["cn"] = "Criminal Correspondence",
  },
  [506] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2974900000,
        ["px"] = 0.5975800000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Boethiah and Her Avatars",
    ["cn"] = "Daedric Cults",
  },
  [507] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Aniaste's Journal",
    ["q"] = 4229,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5806100000,
        ["px"] = 0.4030400000,
        ["pm"] = 22,
      },
    },
  },
  [508] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Burnt Note",
    ["e"] = {
      [1] = { ["px"] = 0.2488303958, ["py"] = 0.7284556203, ["pm"] = 143, },
    },
  },
  [509] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Lucius' Note",
    ["q"] = 4238,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4718200000,
        ["px"] = 0.4990800000,
        ["pm"] = 16,
      },
    },
  },
  [510] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Josseline's Letter",
    ["q"] = 4201,
    ["e"] = {
      [1] = {
        ["px"] = 0.6635775966, ["py"] = 0.3917991975, ["pm"] = 125,
      },
    },
  },
  [511] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Scent-of-Graves' Report",
    ["q"] = 4201,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3917700000,
        ["px"] = 0.6636600000,
        ["pm"] = 125,
      },
    },
  },
  [512] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Report on Training",
    ["q"] = 4201,
    ["e"] = {
      [1] = {
        ["px"] = 0.6635607929, ["py"] = 0.3917899946, ["pm"] = 125,
      },
    },
  },
  [513] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1888567940, ["py"] = 0.6115443968, ["pm"] = 279, ["d"] = true,
        ["zx"] = 0.1872111984, ["zy"] = 0.6134112133, ["zm"] = 143,
      },
    },
    ["n"] = "Manifesto of Kinlord Rilis XII",
    ["cn"] = "The Devoted and the Deranged",
  },
  [514] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1929755938, ["py"] = 0.6090915968, ["pm"] = 279, ["d"] = true,
        ["zx"] = 0.1872111984, ["zy"] = 0.6134112133, ["zm"] = 143,
      },
    },
    ["n"] = "2nd Manifesto of Kinlord Rilis XII",
    ["cn"] = "The Devoted and the Deranged",
  },
  [515] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1898711941, ["py"] = 0.6031475965, ["pm"] = 279, ["d"] = true,
        ["zx"] = 0.1872111984, ["zy"] = 0.6134112133, ["zm"] = 143,
      },
    },
    ["n"] = "3rd Manifesto of Kinlord Rilis XII",
    ["cn"] = "The Devoted and the Deranged",
  },
  [516] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1870647941, ["py"] = 0.6011807967, ["pm"] = 279, ["d"] = true,
        ["zx"] = 0.1872111984, ["zy"] = 0.6134112133, ["zm"] = 143,
      },
    },
    ["n"] = "4th Manifesto of Kinlord Rilis XII",
    ["cn"] = "The Devoted and the Deranged",
  },
  [517] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3693800000,
        ["py"] = 0.6592600000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "Mauloch, Orc-Father",
    ["cn"] = "Lore and Culture",
  },
  [518] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3687800000,
        ["py"] = 0.6600600000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "The Fall of Trinimac",
    ["cn"] = "Lore and Culture",
  },
  [519] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6620400000,
        ["px"] = 0.3730700000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6617000000,
        ["px"] = 0.3708300000,
        ["pm"] = 22,
      },
      [3] = {
        ["px"] = 0.3688600000,
        ["py"] = 0.6607300000,
        ["d"] = true,
        ["pm"] = 271,
      },
    },
    ["n"] = "Note from Orlugash",
    ["cn"] = "Notes and Memos",
  },
  [521] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6314000000,
        ["px"] = 0.3993200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "O Blessed Spinners",
    ["cn"] = "Hearts and Flowers",
  },
  [522] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Uricantar's Journal",
    ["q"] = 4220,
    ["e"] = {
      [1] = { ["px"] = 0.2357955979, ["py"] = 0.6602392131, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2369543987, ["py"] = 0.6606728161, ["pm"] = 190, ["d"] = true, ["zx"] = 0.2369483981, ["zy"] = 0.6606780127, ["zm"] = 143, }, -- location accesible only during quest "The Mallari-Mora"
    },
  },
  [523] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Essanyon's Records",
    ["q"] = 2715,
    ["e"] = {
      [1] = { ["px"] = 0.2365351987, ["py"] = 0.6613964162, ["pm"] = 190, ["d"] = true, ["zx"] = 0.2365279958, ["zy"] = 0.6613968138, ["zm"] = 143, },
    },
  },
  [524] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Quaronaldil's Letter",
    ["e"] = {
      [1] = { ["px"] = 0.2372771954, ["py"] = 0.6557680129, ["pm"] = 143, },
    },
  },
  [525] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Instructions for Placement",
    ["e"] = {
      [1] = { ["px"] = 0.2057515982, ["py"] = 0.7178844161, ["pm"] = 143, },
    },
  },
  [526] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "On Activation",
    ["e"] = {
      [1] = { ["px"] = 0.2071531967, ["py"] = 0.7131916159, ["pm"] = 143, },
    },
  },
  [527] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "On the Holy Symbol",
    ["e"] = {
      [1] = { ["px"] = 0.2093111956, ["py"] = 0.7102024133, ["pm"] = 143, },
    },
  },
  [528] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Susceptibility to Corruption",
    ["e"] = {
      [1] = { ["px"] = 0.2132611968, ["py"] = 0.7107880191, ["pm"] = 143, },
    },
  },
  [529] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "In the Event of Your Demise",
    ["e"] = {
      [1] = { ["px"] = 0.2053887973, ["py"] = 0.7069784187, ["pm"] = 143, },
    },
  },
  [530] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Journal of Priestess Aranwen",
    ["e"] = {
      [1] = { ["px"] = 0.2074431993, ["py"] = 0.7176196162, ["pm"] = 143, },
    },
  },
  [531] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Teldur's Journal",
    ["q"] = 4209,
    ["e"] = {
      [1] = { ["px"] = 0.2475132016, ["py"] = 0.7269452197, ["pm"] = 143, },
    },
  },
  [532] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Stormfist Scout Orders",
    ["q"] = 4086,
    ["e"] = {
      [1] = { ["px"] = 0.5931596247, ["py"] = 0.2907863971, ["pm"] = 61, },
    },
  },
  [533] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Dark Elf Dispatch",
    ["q"] = 4086,
    ["e"] = {
      [1] = { ["px"] = 0.5931076256, ["py"] = 0.2908735963, ["pm"] = 61, },
    },
  },
  [534] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Mammoth Duty",
    ["q"] = 4086,
    ["e"] = {
      [1] = { ["px"] = 0.5931636253, ["py"] = 0.2907855960, ["pm"] = 61, },
    },
  },
  [535] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Gate Procedures",
    ["q"] = 4086,
    ["e"] = {
      [1] = { ["px"] = 0.5931636253, ["py"] = 0.2907855960, ["pm"] = 61, },
    },
  },
  [536] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4412500000,
        ["px"] = 0.5088100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Mustn't Forget",
    ["cn"] = "Final Words",
  },
  [538] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Or Else",
    ["q"] = 4135,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3841000000,
        ["px"] = 0.6445900000,
        ["pm"] = 125,
      },
    },
  },
  [539] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7312035800, ["py"] = 0.5028268099, ["pm"] = 119, ["d"] = true,
        ["zx"] = 0.7315296013, ["zy"] = 0.5031324165, ["zm"] = 13,
      },
    },
    ["n"] = "Kwama Egg Omelet",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [540] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "The Chosen People of Aldmeris",
    ["e"] = {
      [1] = { ["px"] = 0.2138347967, ["py"] = 0.7346936201, ["pm"] = 143, },
      [2] = { ["px"] = 0.2153219995, ["py"] = 0.7268016185, ["pm"] = 143, },
      [3] = { ["px"] = 0.2105147965, ["py"] = 0.7334984154, ["pm"] = 143, },
    },
  },
  [541] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "To The Veiled Queen",
    ["e"] = {
      [1] = { ["px"] = 0.2099451971, ["py"] = 0.7328048169, ["pm"] = 143, },
    },
  },
  [542] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "How To Prepare Slaughterfish",
    ["e"] = {
      [1] = { ["px"] = 0.2158943992, ["py"] = 0.7284756130, ["pm"] = 143, },
      [2] = { ["px"] = 0.2163035957, ["py"] = 0.7251256191, ["pm"] = 143, },
      [3] = { ["px"] = 0.2124907996, ["py"] = 0.7258664132, ["pm"] = 143, },
    },
  },
  [543] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "The Maormer of Pyandonea",
    ["e"] = {
      [1] = { ["px"] = 0.2136887999, ["py"] = 0.7285048114, ["pm"] = 143, },
    },
  },
  [547] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7437200000,
        ["py"] = 0.5190900000,
        ["d"] = true,
        ["pm"] = 121,
      },
    },
    ["n"] = "Dwemer Dreams",
    ["cn"] = "Tales of Tamriel",
  },
  [548] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6405204272, ["py"] = 0.2620299999, ["pm"] = 160, ["zm"] = 61, },
    },
    ["n"] = "Note from Thulvald's Logging Camp",
    ["cn"] = "Mysteries and Clues",
  },
  [549] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7860900000,
        ["py"] = 0.5020900000,
        ["d"] = true,
        ["pm"] = 120,
      },
    },
    ["n"] = "Mine Foreman's Log",
    ["cn"] = "Mysteries and Clues",
  },
  [551] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7934000000,
        ["py"] = 0.5273800000,
        ["d"] = true,
        ["pm"] = 122,
      },
      [2] = {
        ["mn"] = 13,
        ["py"] = 0.2624400000,
        ["px"] = 0.6382900000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Brave Little Scrib",
    ["cn"] = "Tales of Tamriel",
  },
  [552] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3637000000,
        ["px"] = 0.5762700000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Dark Contract",
    ["cn"] = "Daedric Cults",
  },
  [553] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Ballad of Skald Skullsplitter",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3497100000,
        ["pm"] = 1126,
        ["px"] = 0.4002700000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 25,
      },
    },
    ["m"] = {
      [25] = 1,
    },
  },
  [554] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5463207733, ["py"] = 0.4811371993, ["pm"] = 900,
      },
    },
    ["n"] = "Darkest Divinities",
    ["cn"] = "Words of the Poets",
  },
  [555] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3421900000,
        ["py"] = 0.6124200000,
        ["d"] = true,
        ["pm"] = 222,
      },
    },
    ["n"] = "A Sad Day for the Ra Gada",
    ["cn"] = "Diaries and Logs",
  },
  [556] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4491100000,
        ["px"] = 0.4918900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Northern Heartlands Journal",
    ["cn"] = "Personal Journals",
  },
  [557] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "The Benefits of Alliance",
    ["e"] = {
      [1] = { ["px"] = 0.1677063965, ["py"] = 0.6303396044, ["pm"] = 182, ["d"] = true, ["zx"] = 0.1681291974, ["zy"] = 0.6301980138, ["zm"] = 143, },
    },
  },
  [558] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "The Danger of Defiance",
    ["e"] = {
      [1] = { ["px"] = 0.1675063965, ["py"] = 0.6301584044, ["pm"] = 182, ["d"] = true, ["zx"] = 0.1681291974, ["zy"] = 0.6301980138, ["zm"] = 143, },
    },
  },
  [559] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Hendil's Journal",
    ["q"] = 4266,
    ["e"] = {
      [1] = { ["px"] = 0.2349199942, ["py"] = 0.7101000119, ["pm"] = 143, },
    },
  },
  [560] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Our Budding Alliance",
    ["e"] = {
      [1] = { ["px"] = 0.1677659965, ["py"] = 0.6298224044, ["pm"] = 182, ["d"] = true, ["zx"] = 0.1681291974, ["zy"] = 0.6301980138, ["zm"] = 143, },
    },
  },
  [561] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8400200000,
        ["py"] = 0.4989500000,
        ["d"] = true,
        ["pm"] = 123,
      },
    },
    ["n"] = "The Will of Drulshasa",
    ["cn"] = "Daedric Cults",
  },
  [562] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2259583987, ["py"] = 0.3315056032, ["pm"] = 46, ["zx"] = 0.2225104061, ["zy"] = 0.3344248036, ["zm"] = 12, ["d"] = true, },
      [2] = { ["px"] = 0.2225104026, ["py"] = 0.3344248069, ["pm"] = 33, ["fp"] = true, },
      [3] = {
        ["py"] = 0.4803400000,
        ["px"] = 0.5466200000,
        ["pm"] = 657,
      },
    },
    ["n"] = "The Art and the Madness v.1",
    ["cn"] = "Rituals and Revelations",
  },
  [563] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2260927987, ["py"] = 0.3307784033, ["pm"] = 46, ["zx"] = 0.2225104061, ["zy"] = 0.3344248036, ["zm"] = 12, ["d"] = true, },
      [2] = { ["px"] = 0.2225104026, ["py"] = 0.3344248069, ["pm"] = 33, ["fp"] = true, },
    },
    ["n"] = "BEWARE: Undercity Ruffians",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [564] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8105400000,
        ["py"] = 0.4911600000,
        ["d"] = true,
        ["pm"] = 124,
      },
    },
    ["n"] = "Corpse Garden Mission",
    ["cn"] = "Military Orders and Reports",
  },
  [565] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2748200000,
        ["px"] = 0.6332600000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Letter from Ragna",
    ["cn"] = "Letters and Missives",
  },
  [566] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7607727870, ["py"] = 0.5414043945, ["pm"] = 26, },
    },
    ["n"] = "The Sanguine Cult",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [567] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3997900000,
        ["py"] = 0.5974600000,
        ["d"] = true,
        ["pm"] = 199,
      },
    },
    ["n"] = "Black Vine Ruins",
    ["cn"] = "Final Words",
  },
  [568] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7716560268, ["py"] = 0.5374484062, ["pm"] = 144, ["d"] = true,
        ["zx"] = 0.7696607906, ["zy"] = 0.5464663933, ["zm"] = 26,
      },
    },
    ["n"] = "Galmon's Note",
    ["cn"] = "Notes and Memos",
  },
  [569] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3892300000,
        ["py"] = 0.6224700000,
        ["d"] = true,
        ["pm"] = 267,
      },
    },
    ["n"] = "Roots of Silvenar",
    ["cn"] = "Plots and Schemes",
  },
  [580] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3783900000,
        ["py"] = 0.6665700000,
        ["d"] = true,
        ["pm"] = 206,
      },
    },
    ["n"] = "Journal of Arrai",
    ["cn"] = "Personal Journals",
  },
  [581] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Letter with Singed Edges",
    ["q"] = 4261,
    ["e"] = {
      [1] = { ["px"] = -0.2717575969, ["py"] = 0.5800588125, ["pm"] = 276, ["d"] = true, }, -- location only accessible DURING quest *Sever All Ties*
      [2] = { ["px"] = 0.1819711983, ["py"] = 0.6214500127, ["pm"] = 540, ["zm"] = 143, ["qc"] = true, },
    },
  },
  [582] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Ode to Auridon",
    ["e"] = {
      [1] = { ["px"] = 0.1880099978, ["py"] = 0.6271204120, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [583] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Mathiisen Forge Inventory",
    ["e"] = {
      [1] = { ["px"] = 0.1842015990, ["py"] = 0.6333788117, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [584] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2248200000, ["py"] = 0.3295100000, ["pm"] = 46, ["zx"] = 0.2225104061, ["zy"] = 0.3344248036, ["zm"] = 12, ["d"] = true, },
      [2] = { ["px"] = 0.2225104026, ["py"] = 0.3344248069, ["pm"] = 33, ["fp"] = true, },
    },
    ["n"] = "The Piper",
    ["cn"] = "Tales of Tamriel",
  },
  [585] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Merion's Diary",
    ["e"] = {
      [1] = { ["px"] = 0.2059619975, ["py"] = 0.6951735977, ["pm"] = 550, ["d"] = true, ["zx"] = 0.2059619971, ["zy"] = 0.6951736152, ["zm"] = 143, },
    },
  },
  [592] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Faded Note",
    ["e"] = {
      [1] = { ["px"] = 0.2063143969, ["py"] = 0.6944188050, ["pm"] = 551, ["d"] = true, ["zx"] = 0.2063143969, ["zy"] = 0.6944188149, ["zm"] = 143, },
    },
  },
  [593] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Royal Decree",
    ["e"] = {
      [1] = { ["px"] = 0.2066923939, ["py"] = 0.6950255770, ["pm"] = 552, ["d"] = true, ["zx"] = 0.2066923995, ["zy"] = 0.6950256182, ["zm"] = 143, },
    },
  },
  [594] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Experiment",
    ["e"] = {
      [1] = { ["px"] = 0.2066175939, ["py"] = 0.6948291770, ["pm"] = 552, ["d"] = true, ["zx"] = 0.2066175962, ["zy"] = 0.6948292115, ["zm"] = 143, },
    },
  },
  [595] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6210500000,
        ["px"] = 0.3096400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Oathbreakers' Rest",
    ["cn"] = "Lore and Culture",
  },
  [596] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6217300000,
        ["px"] = 0.3086300000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6385500000,
        ["px"] = 0.3625200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Ladies of Green",
    ["cn"] = "Lore and Culture",
  },
  [597] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6233700000,
        ["px"] = 0.3684400000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6147200000,
        ["px"] = 0.3174700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Silvenar Manifest",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [598] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3195708045, ["py"] = 0.6202432139, ["pm"] = 275, ["zm"] = 22, },
    },
    ["n"] = "A Letter to the Mayor",
    ["cn"] = "Criminal Correspondence",
  },
  [599] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3187160048, ["py"] = 0.6196764140, ["pm"] = 275, ["zm"] = 22, },
    },
    ["n"] = "Orders from the Chief",
    ["cn"] = "Criminal Correspondence",
  },
  [600] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3093368045, ["py"] = 0.6276960142, ["pm"] = 275, ["zm"] = 22, },
    },
    ["n"] = "Fists of Thalmor",
    ["cn"] = "Notes and Memos",
  },
  [601] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5990000000,
        ["px"] = 0.7358200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Scout Report: Arx Corinium",
    ["cn"] = "Military Orders and Reports",
  },
  [602] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 13,
        ["px"] = 0.8122100000,
        ["d"] = true,
        ["py"] = 0.4874000000,
        ["mn"] = 10,
      },
    },
    ["n"] = "Exodus from Summerset",
    ["cn"] = "Tales of Tamriel",
  },
  [603] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6711459930, ["py"] = 0.3200763955, ["pm"] = 167, ["zx"] = 0.6700232241, ["zy"] = 0.3204872002, ["zm"] = 61, ["d"] = true, },
    },
    ["n"] = "The Bastard's Tomb",
    ["cn"] = "Tales of Tamriel",
  },
  [604] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7206967908, ["py"] = 0.5880467905, ["pm"] = 26,
      },
    },
    ["n"] = "A Perfect Score",
    ["cn"] = "Criminal Correspondence",
  },
  [605] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5206800000,
        ["px"] = 0.7912900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Ashlander Wise Women",
    ["cn"] = "Lore and Culture",
  },
  [606] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5059200000,
        ["px"] = 0.8180100000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Memo to Captain Doronil",
    ["cn"] = "Notes and Memos",
  },
  [607] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["py"] = 0.3195900000, ["px"] = 0.5954300000, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Ice Elves: Fact or Fiction?",
    ["cn"] = "Tales of Tamriel",
  },
  [608] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5035100000,
        ["px"] = 0.8145600000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5002800000,
        ["px"] = 0.8178500000,
        ["pm"] = 13,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5027500000,
        ["px"] = 0.8178000000,
        ["pm"] = 13,
      },
    },
    ["n"] = "General Redoran's Dispatch",
    ["cn"] = "Military Orders and Reports",
  },
  [609] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5035100000,
        ["px"] = 0.8147500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 21",
    ["cn"] = "Tales of Tamriel",
  },
  [610] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5329100000,
        ["px"] = 0.7636700000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Kwama Egg Quiche",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [611] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8283396063, ["py"] = 0.5152972138, ["pm"] = 13,
      },
    },
    ["n"] = "Wasp Wrangling",
    ["cn"] = "Research Notes",
  },
  [612] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5196400000,
        ["px"] = 0.7124200000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5283600000,
        ["px"] = 0.7116200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "About Mercy",
    ["cn"] = "Daedric Cults",
  },
  [613] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5075800000,
        ["px"] = 0.7614700000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Mabrigash Trial",
    ["cn"] = "Tales of Tamriel",
  },
  [614] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3586600000,
        ["py"] = 0.6309700000,
        ["d"] = true,
        ["pm"] = 262,
      },
    },
    ["n"] = "The Hoarvor Pit",
    ["cn"] = "Final Words",
  },
  [615] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3464900000,
        ["py"] = 0.6404300000,
        ["d"] = true,
        ["pm"] = 221,
      },
    },
    ["n"] = "Why We Farm",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [616] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4983700000,
        ["px"] = 0.7152500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 2",
    ["cn"] = "Tales of Tamriel",
  },
  [617] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5176400000,
        ["px"] = 0.7655000000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5094100000,
        ["px"] = 0.7624500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Breaking the Cycle of Tyranny",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [618] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5129100000,
        ["px"] = 0.7665800000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 7",
    ["cn"] = "Tales of Tamriel",
  },
  [619] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5110700000,
        ["px"] = 0.7657600000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Rigurt's Journal",
    ["cn"] = "Personal Journals",
  },
  [620] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7730244142, ["py"] = 0.5133228157, ["pm"] = 205, ["zm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 10",
    ["cn"] = "Tales of Tamriel",
  },
  [621] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5164800000,
        ["px"] = 0.7628600000,
        ["pm"] = 205,
        ["zm"] = 13,
      },
      [2] = {
        ["py"] = 0.5080820000,
        ["px"] = 0.7614820000,
        ["pm"] = 205,
        ["zm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 6",
    ["cn"] = "Tales of Tamriel",
  },
  [622] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7610764133, ["py"] = 0.5152800152, ["pm"] = 205, ["zm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 9",
    ["cn"] = "Tales of Tamriel",
  },
  [623] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3681355995, ["py"] = 0.6073068138, ["pm"] = 22, },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6072300000,
        ["px"] = 0.3681200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Spinners of Y'ffre",
    ["cn"] = "The Devoted and the Deranged",
  },
  [624] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5058300000,
        ["px"] = 0.7673900000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7878600000,
        ["py"] = 0.4875100000,
        ["d"] = true,
        ["pm"] = 128,
      },
      [3] = { ["px"] = 0.8378779988, ["py"] = 0.3459131932, ["pm"] = 2448, ["d"] = true, },
    },
    ["n"] = "War of the First Council",
    ["cn"] = "Lore and Culture",
  },
  [625] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5028100000,
        ["px"] = 0.7687200000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7837800000,
        ["py"] = 0.4866500000,
        ["d"] = true,
        ["pm"] = 128,
      },
    },
    ["n"] = "The Year 2920, Vol. 12",
    ["cn"] = "Tales of Tamriel",
  },
  [626] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6345600000,
        ["px"] = 0.3301100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Taking of Abamath",
    ["cn"] = "Tales of Tamriel",
  },
  [627] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5017300000,
        ["px"] = 0.7673100000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7854900000,
        ["py"] = 0.4879900000,
        ["d"] = true,
        ["pm"] = 128,
      },
    },
    ["n"] = "The Year 2920, Vol. 13",
    ["cn"] = "Tales of Tamriel",
  },
  [628] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5171700000,
        ["px"] = 0.7487400000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Raynor's Journal: Bthanual",
    ["cn"] = "Research Notes",
  },
  [629] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7250160061, ["py"] = 0.5174451997, ["pm"] = 537, ["zm"] = 13,
      },
      [2] = {
        ["px"] = 0.7223720060, ["py"] = 0.5127575995, ["pm"] = 537, ["zm"] = 13,
      },
    },
    ["n"] = "House Hlaalu Philosophy of Trade",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [630] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 537,
        ["py"] = 0.5173000000,
        ["px"] = 0.7198200000,
        ["zm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 5",
    ["cn"] = "Tales of Tamriel",
  },
  [631] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7226972059, ["py"] = 0.5133519991, ["pm"] = 537, ["zm"] = 13,
      },
    },
    ["n"] = "Netches! Netches! All Around!",
    ["cn"] = "Words of the Poets",
  },
  [632] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4939300000,
        ["px"] = 0.8270500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 16",
    ["cn"] = "Tales of Tamriel",
  },
  [633] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5041400000,
        ["px"] = 0.7964900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Holy Vessel",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [634] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5064100000,
        ["px"] = 0.8070800000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Year 2920, Vol. 17",
    ["cn"] = "Tales of Tamriel",
  },
  [635] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter to Rulassalmo",
    ["e"] = {
      [1] = { ["px"] = 0.1806091987, ["py"] = 0.6306740129, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [636] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Things to Do",
    ["e"] = {
      [1] = { ["px"] = 0.1803435985, ["py"] = 0.6318148125, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [637] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Telenger",
    ["e"] = {
      [1] = { ["px"] = 0.1798687981, ["py"] = 0.6335692121, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [638] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Estre",
    ["e"] = {
      [1] = { ["px"] = 0.1819471985, ["py"] = 0.6203024125, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [639] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Chores",
    ["e"] = {
      [1] = { ["px"] = 0.1789699981, ["py"] = 0.6277832131, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [640] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Faculty Application",
    ["e"] = {
      [1] = { ["px"] = 0.1812575987, ["py"] = 0.6204540128, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [641] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Rothondothrin's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.1869071977, ["py"] = 0.6289020126, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [642] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter to Jazish",
    ["e"] = {
      [1] = { ["px"] = 0.1845191991, ["py"] = 0.6301940132, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [644] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5154000000,
        ["px"] = 0.7864400000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5165900000,
        ["px"] = 0.8021400000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Coiled Path",
    ["cn"] = "The Devoted and the Deranged",
  },
  [645] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7107892091, ["py"] = 0.5024623893, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "Against False Gods",
    ["cn"] = "The Devoted and the Deranged",
  },
  [646] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7103956091, ["py"] = 0.5034091896, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "The Llodos Plague",
    ["cn"] = "Daedric Cults",
  },
  [647] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7746328062, ["py"] = 0.5846756152, ["pm"] = 544, ["zm"] = 26, },
    },
    ["n"] = "A Treatise on the Knot",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [648] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7751948071, ["py"] = 0.5849012147, ["pm"] = 544, ["zm"] = 26, },
    },
    ["n"] = "A Discarded Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [650] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4814700000,
        ["px"] = 0.7885400000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Arch-Mage's Journal",
    ["cn"] = "Personal Journals",
  },
  [651] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4927900000,
        ["px"] = 0.7823900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Academy Supplies",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [652] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4842000000,
        ["px"] = 0.7819800000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Apprentice's Assistant",
    ["cn"] = "Lore and Culture",
  },
  [653] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Shad Astula Curriculum",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [300] = 25,
      [10] = 34,
      [26] = 8,
      [27] = 5,
    },
  },
  [654] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7739300000,
        ["py"] = 0.4884300000,
        ["d"] = true,
        ["pm"] = 127,
      },
    },
    ["n"] = "Ithis Omalor's Orders",
    ["cn"] = "Criminal Correspondence",
  },
  [655] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8294316084, ["py"] = 0.5122024198, ["pm"] = 13,
      },
    },
    ["n"] = "Renrijra Pirates",
    ["cn"] = "Hearts and Flowers",
  },
  [656] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2443700000,
        ["px"] = 0.1895600000,
        ["pm"] = 10,
      },
      [2] = { ["px"] = 0.7446112031, ["py"] = 0.5013040169, ["pm"] = 13, },
    },
    ["n"] = "Kotholl's Contract",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [657] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter to Raerana",
    ["q"] = 4289,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3970400000,
        ["px"] = 0.6350000000,
        ["pm"] = 125,
      }, -- post-quest
      [2] = { ["px"] = 0.6395675970, ["py"] = 0.3910907987, ["pm"] = 125, },
    },
  },
  [658] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6350151946, ["py"] = 0.3969563915, ["pm"] = 125, },
    },
    ["n"] = "Rilyn's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [659] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from Camarino",
    ["q"] = 4266,
    ["e"] = {
      [1] = { ["px"] = 0.2306512014, ["py"] = 0.7088116113, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2295127963, ["py"] = 0.7051591878, ["pm"] = 184, ["d"] = true, ["zx"] = 0.2297375984, ["zy"] = 0.7061004148, ["zm"] = 143, },
    },
  },
  [660] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from Lenwe",
    ["q"] = 4266,
    ["e"] = {
      [1] = { ["px"] = 0.2305423993, ["py"] = 0.7096304184, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2295103963, ["py"] = 0.7050523878, ["pm"] = 184, ["d"] = true, ["zx"] = 0.2297375984, ["zy"] = 0.7061004148, ["zm"] = 143, },
    },
  },
  [661] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from Minique",
    ["q"] = 4266,
    ["e"] = {
      [1] = { ["px"] = 0.2304356020, ["py"] = 0.7093800200, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2293659964, ["py"] = 0.7049831878, ["pm"] = 184, ["d"] = true, ["zx"] = 0.2297375984, ["zy"] = 0.7061004148, ["zm"] = 143, },
    },
  },
  [662] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["pm"] = 544, ["py"] = 0.5875000000, ["px"] = 0.7764600000, ["zm"] = 26, },
    },
    ["n"] = "The Voyages of Il-Am-Hakim, Vol. 7",
    ["cn"] = "Tales of Tamriel",
  },
  [663] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Camandar's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2070663939, ["py"] = 0.6602400199, ["pm"] = 180, ["d"] = true, ["zx"] = 0.2059023955, ["zy"] = 0.6603420146, ["zm"] = 143, },
    },
  },
  [664] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7220803922, ["py"] = 0.5572971924, ["pm"] = 26, },
    },
    ["n"] = "Knahaten Flu Confirmed",
    ["cn"] = "Diaries and Logs",
  },
  [665] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7237987904, ["py"] = 0.5512135921, ["pm"] = 26, },
    },
    ["n"] = "The Treasure of Stillrise Village",
    ["cn"] = "Daedric Cults",
  },
  [666] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7208711916, ["py"] = 0.5559663948, ["pm"] = 26, },
    },
    ["n"] = "A Final Appeal",
    ["cn"] = "Daedric Cults",
  },
  [667] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7170648227, ["py"] = 0.5558416010, ["pm"] = 133, ["d"] = true,
        ["zx"] = 0.7192843914, ["zy"] = 0.5618747933, ["zm"] = 26,
      },
    },
    ["n"] = "Song of Despair",
    ["cn"] = "Words of the Poets",
  },
  [668] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6058800000,
        ["px"] = 0.7134800000,
        ["pm"] = 26,
      },
      [2] = { ["px"] = 0.7125447906, ["py"] = 0.6033631907, ["pm"] = 26, },
    },
    ["n"] = "What Flows Downstream",
    ["cn"] = "Diaries and Logs",
  },
  [669] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7063751915, ["py"] = 0.6076859888, ["pm"] = 26, },
    },
    ["n"] = "Rituals of Contempt",
    ["cn"] = "Daedric Cults",
  },
  [670] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7124399914, ["py"] = 0.6059375891, ["pm"] = 26, },
    },
    ["n"] = "Exploring the Xal Ithix Ruins",
    ["cn"] = "Diaries and Logs",
  },
  [671] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7921323873, ["py"] = 0.6134547909, ["pm"] = 26, },
    },
    ["n"] = "Articles of the Sakkr-al-Behr",
    ["cn"] = "Criminal Correspondence",
  },
  [672] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7874495866, ["py"] = 0.6133563931, ["pm"] = 26, },
    },
    ["n"] = "Log of the Intractable",
    ["cn"] = "Military Orders and Reports",
  },
  [673] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7870500000,
        ["py"] = 0.6184400000,
        ["d"] = true,
        ["pm"] = 136,
      },
      [2] = {
        ["px"] = 0.6301500000,
        ["d"] = true,
        ["py"] = 0.6617900000,
        ["pm"] = 1061,
      },
    },
    ["n"] = "The Dark Husband",
    ["cn"] = "Rituals and Revelations",
  },
  [674] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7819359878, ["py"] = 0.5743835966, ["pm"] = 26, },
    },
    ["n"] = "Pillagers of the Hist",
    ["cn"] = "Notes and Memos",
  },
  [675] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7858711889, ["py"] = 0.5674651927, ["pm"] = 26, },
    },
    ["n"] = "Dominion Troops General Order 719a",
    ["cn"] = "Military Orders and Reports",
  },
  [676] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7838519863, ["py"] = 0.5655687923, ["pm"] = 26, },
    },
    ["n"] = "On Argonians",
    ["cn"] = "Lore and Culture",
  },
  [677] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5635100000,
        ["px"] = 0.7448300000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Free Our Goblin Brothers!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [678] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 26,
        ["px"] = 0.7460900000,
        ["d"] = true,
        ["py"] = 0.5669700000,
        ["mn"] = 9,
      },
    },
    ["n"] = "Quartermaster's Report",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [679] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7465067899, ["py"] = 0.5668511921, ["pm"] = 26,
      },
    },
    ["n"] = "An Easy Assignment",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [680] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3730000000,
        ["px"] = 0.0951700000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3724500000,
        ["px"] = 0.0771900000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Ghosts of Glenumbra",
    ["cn"] = "The World and Its Creatures",
  },
  [682] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3920700000,
        ["px"] = 0.0611900000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Lion Guard Wants You!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [683] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0602496012, ["py"] = 0.3830620056, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "What a Pig Needs",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [684] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0557148017, ["py"] = 0.3898640048, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Knights of the Dragon",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [686] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6596836210, ["py"] = 0.3125839964, ["pm"] = 61, },
    },
    ["n"] = "Guard Duty",
    ["cn"] = "Military Orders and Reports",
  },
  [687] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Digging Orders",
    ["e"] = {
      [1] = { ["px"] = 0.2067071939, ["py"] = 0.6602004199, ["pm"] = 180, ["d"] = true, ["zx"] = 0.2059023955, ["zy"] = 0.6603420146, ["zm"] = 143, },
      [2] = { ["px"] = 0.2067871939, ["py"] = 0.6608508198, ["pm"] = 180, ["d"] = true, },
      [3] = { ["px"] = 0.2071603939, ["py"] = 0.6603604199, ["pm"] = 180, ["d"] = true, },
    },
  },
  [688] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Warning: I Heard You!",
    ["e"] = {
      [1] = { ["px"] = 0.2068259939, ["py"] = 0.6605912198, ["pm"] = 180, ["d"] = true, ["zx"] = 0.2059023955, ["zy"] = 0.6603420146, ["zm"] = 143, },
      [2] = { ["px"] = 0.2070463940, ["py"] = 0.6608416198, ["pm"] = 180, ["d"] = true, },
      [3] = { ["px"] = 0.2071375939, ["py"] = 0.6601056199, ["pm"] = 180, ["d"] = true, },
    },
  },
  [699] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Fistalle's Note",
    ["q"] = 4293,
    ["e"] = {
      [1] = { ["px"] = 0.2275884004, ["py"] = 0.6965452151, ["pm"] = 143, },
    },
  },
  [701] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Book of Excellent Teachings",
    ["q"] = 3903,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4868500000,
        ["px"] = 0.7898500000,
        ["pm"] = 13,
      },
    },
  },
  [702] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Aluvus' Notes",
    ["e"] = {
      [1] = { ["px"] = 0.2231300058, ["py"] = 0.7071800059, ["pm"] = 179, ["d"] = true, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
    },
  },
  [703] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Aluvus' Further Notes",
    ["e"] = {
      [1] = { ["px"] = 0.2232808058, ["py"] = 0.7068956058, ["pm"] = 179, ["d"] = true, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
    },
  },
  [704] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Aluvus' Final Notes",
    ["e"] = {
      [1] = { ["px"] = 0.2234324058, ["py"] = 0.7071884059, ["pm"] = 179, ["d"] = true, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
    },
  },
  [705] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5188300000,
        ["px"] = 0.7214400000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7191436002, ["py"] = 0.4987352163, ["pm"] = 13,
      },
    },
    ["n"] = "To Do What is Needed",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [706] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Thalmor Diplomatic Corps Notice",
    ["e"] = {
      [1] = { ["px"] = 0.2038827972, ["py"] = 0.6180920134, ["pm"] = 143, },
      [2] = { ["px"] = 0.2024935953, ["py"] = 0.6182180151, ["pm"] = 143, },
    },
  },
  [707] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Our Dupes, the Sea Elves",
    ["e"] = {
      [1] = { ["px"] = 0.2289012024, ["py"] = 0.7313915730, ["pm"] = 178, ["d"] = true, ["zx"] = 0.2289847936, ["zy"] = 0.7319340137, ["zm"] = 143, },
      [2] = { ["px"] = 0.2296540023, ["py"] = 0.7308147730, ["pm"] = 178, ["d"] = true, },
    },
  },
  [708] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Del's Claim",
    ["e"] = {
      [1] = { ["px"] = 0.2294680024, ["py"] = 0.7307927730, ["pm"] = 178, ["d"] = true, ["zx"] = 0.2289847936, ["zy"] = 0.7319340137, ["zm"] = 143, },
      [2] = { ["px"] = 0.2290388024, ["py"] = 0.7309987730, ["pm"] = 178, ["d"] = true, },
    },
  },
  [709] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Eagle Hunter: Against the Dominion",
    ["e"] = {
      [1] = { ["px"] = 0.2026299957, ["py"] = 0.6163648145, ["pm"] = 143, },
      [2] = { ["px"] = 0.2015483983, ["py"] = 0.6147440139, ["pm"] = 143, },
    },
  },
  [710] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7069804091, ["py"] = 0.4995019894, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "Nostrum's Notes",
    ["cn"] = "Plots and Schemes",
  },
  [711] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6396275926, ["py"] = 0.3910279897, ["pm"] = 125,
      },
    },
    ["n"] = "Eislef's Journal",
    ["cn"] = "Personal Journals",
  },
  [713] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5430200000,
        ["px"] = 0.7247400000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Sep's Kiss",
    ["cn"] = "Rituals and Revelations",
  },
  [715] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Father's Promise",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 8,
      [61] = 4,
      [22] = 17,
      [27] = 2,
    },
  },
  [716] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Armament Inventory",
    ["q"] = 4293,
    ["e"] = {
      [1] = { ["px"] = 0.2368496017, ["py"] = 0.6943372156, ["pm"] = 143, },
    },
  },
  [717] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Bakhig's Journal, Page 3",
    ["e"] = {
      [1] = { ["px"] = 0.2254907929, ["py"] = 0.6848135971, ["pm"] = 186, ["d"] = true, ["zx"] = 0.2257103936, ["zy"] = 0.6849976154, ["zm"] = 143, },
    },
  },
  [718] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Bakhig's Journal, Page 11",
    ["e"] = {
      [1] = { ["px"] = 0.2255199928, ["py"] = 0.6854055970, ["pm"] = 186, ["d"] = true, ["zx"] = 0.2257103936, ["zy"] = 0.6849976154, ["zm"] = 143, },
    },
  },
  [719] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Bakhig's Journal, Page 18",
    ["e"] = {
      [1] = { ["px"] = 0.2251203929, ["py"] = 0.6847359970, ["pm"] = 186, ["d"] = true, ["zx"] = 0.2257103936, ["zy"] = 0.6849976154, ["zm"] = 143, },
    },
  },
  [720] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Bakhig's Journal, Page 19",
    ["e"] = {
      [1] = { ["px"] = 0.2247779929, ["py"] = 0.6849675970, ["pm"] = 186, ["d"] = true, ["zx"] = 0.2257103936, ["zy"] = 0.6849976154, ["zm"] = 143, },
    },
  },
  [721] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Maormer Memo",
    ["e"] = {
      [1] = { ["px"] = 0.2170367936, ["py"] = 0.7408112119, ["pm"] = 143, },
    },
  },
  [723] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Tancano's Journal",
    ["q"] = 4266,
    ["e"] = {
      [1] = { ["px"] = 0.2309051955, ["py"] = 0.7098752162, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2287727963, ["py"] = 0.7060715878, ["pm"] = 184, ["d"] = true, ["zx"] = 0.2297375984, ["zy"] = 0.7061004148, ["zm"] = 143, },
    },
  },
  [725] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7560127888, ["py"] = 0.5819411960, ["pm"] = 26, },
    },
    ["n"] = "Book of Thoughts",
    ["cn"] = "Diaries and Logs",
  },
  [726] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5736000000,
        ["px"] = 0.7550200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Mark of Egg-Births",
    ["cn"] = "Diaries and Logs",
  },
  [728] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6027800000,
        ["px"] = 0.7789800000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Feyne Vildan's Diary",
    ["cn"] = "Hearts and Flowers",
  },
  [729] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5616500000,
        ["px"] = 0.7685700000,
        ["pm"] = 26,
      },
    },
    ["n"] = "A Fitting Tribute",
    ["cn"] = "Diaries and Logs",
  },
  [730] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5674500000,
        ["px"] = 0.7688700000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Not Long Now",
    ["cn"] = "Diaries and Logs",
  },
  [731] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7368203892, ["py"] = 0.5776467935, ["pm"] = 26, },
    },
    ["n"] = "The Founding of Zuuk",
    ["cn"] = "The World and Its Creatures",
  },
  [732] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Anonymous Journal",
    ["q"] = 3610,
    ["e"] = {
      [1] = {
        ["px"] = 0.7247340053, ["py"] = 0.5178295991, ["pm"] = 537, ["zm"] = 13,
      },
    },
  },
  [733] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Letter to Evis Marys",
    ["q"] = 3610,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5177800000,
        ["px"] = 0.7246700000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5173700000,
        ["px"] = 0.7201100000,
        ["pm"] = 13,
      },
    },
  },
  [734] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6216900000,
        ["px"] = 0.3258100000,
        ["pm"] = 22,
      },
      [2] = {
        ["px"] = 0.3266300000,
        ["py"] = 0.6220700000,
        ["d"] = true,
        ["pm"] = 284,
      },
    },
    ["n"] = "Nirwaen's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [735] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Reminder: Don't Drink the Water",
    ["q"] = 3659,
    ["e"] = {
      [1] = {
        ["px"] = 0.7180404062, ["py"] = 0.5082947997, ["pm"] = 537, ["zm"] = 13,
      },
    },
  },
  [736] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6634800000,
        ["px"] = 0.3890900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Orders are Orders",
    ["cn"] = "Criminal Correspondence",
  },
  [737] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Merdyndril's Orders",
    ["q"] = 3659,
    ["e"] = {
      [1] = {
        ["px"] = 0.7179891994, ["py"] = 0.5083252174, ["pm"] = 13,
      },
    },
  },
  [738] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6546200000,
        ["px"] = 0.3855000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Letter from Berfonas",
    ["cn"] = "Letters and Missives",
  },
  [739] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5208400000,
        ["px"] = 0.7115700000,
        ["pm"] = 13,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5278300000,
        ["px"] = 0.7154700000,
        ["pm"] = 13,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5208600000,
        ["px"] = 0.7142200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Our Ironclad Oath",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [740] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6136200000,
        ["px"] = 0.3822400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Handfast Song List",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [741] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7360227897, ["py"] = 0.5789319936, ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5775900000,
        ["px"] = 0.7368000000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Drillk's Journal",
    ["cn"] = "Personal Journals",
  },
  [742] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6141400000,
        ["px"] = 0.3914900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "History of the Handfast",
    ["cn"] = "Words of the Poets",
  },
  [744] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6132000000,
        ["px"] = 0.3869000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Spinning a Story",
    ["cn"] = "Lore and Culture",
  },
  [746] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6013600000,
        ["px"] = 0.7364500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Lamentations of the Lost",
    ["cn"] = "Words of the Poets",
  },
  [747] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5991200000,
        ["px"] = 0.7368500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Path of the Pilgrim",
    ["cn"] = "Lore and Culture",
  },
  [748] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6004700000,
        ["px"] = 0.7373800000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Trials of Hissmir",
    ["cn"] = "Rituals and Revelations",
  },
  [749] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "King Kurog's Promise",
    ["q"] = 3593,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5256300000,
        ["px"] = 0.7090000000,
        ["pm"] = 13,
      },
    },
  },
  [750] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7232695906, ["py"] = 0.5840827932, ["pm"] = 26, },
    },
    ["n"] = "Albus' Journal",
    ["cn"] = "Personal Journals",
  },
  [751] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7212855911, ["py"] = 0.5800511900, ["pm"] = 26, },
    },
    ["n"] = "Evacuation Order",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [753] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1003052030, ["py"] = 0.3572312049, ["pm"] = 531, ["zm"] = 1, },
    },
    ["n"] = "Nadine's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [754] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3920400000,
        ["px"] = 0.0661300000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3549300000,
        ["px"] = 0.1068400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Glenumbra's Towns and Cities",
    ["cn"] = "The World and Its Creatures",
  },
  [755] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1031756030, ["py"] = 0.3533340052, ["pm"] = 531, ["zm"] = 1, },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3879900000,
        ["px"] = 0.0610800000,
        ["pm"] = 1,
      },
      [3] = {
        ["l"] = true,
        ["mn"] = 2,
        ["pm"] = 1,
        ["px"] = 0.0696300000,
        ["d"] = true,
        ["py"] = 0.3546300000,
      },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3546300000,
        ["px"] = 0.0696400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Glenumbra's People",
    ["cn"] = "The World and Its Creatures",
  },
  [756] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1045420033, ["py"] = 0.3575980051, ["pm"] = 531, ["zm"] = 1, },
    },
    ["n"] = "Attention Moon Walkers",
    ["cn"] = "Rituals and Revelations",
  },
  [757] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Gamwyn's Journal",
    ["q"] = 4178,
    ["e"] = {
      [1] = {
        ["px"] = 0.6460955929, ["py"] = 0.4021979953, ["pm"] = 125,
      },
    },
  },
  [758] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Irgnar's Journal",
    ["q"] = 4178,
    ["e"] = {
      [1] = {
        ["px"] = 0.6189656000, ["py"] = 0.3935363915, ["pm"] = 125,
      },
    },
  },
  [759] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7308891800, ["py"] = 0.5026928099, ["pm"] = 119, ["d"] = true,
        ["zx"] = 0.7315296013, ["zy"] = 0.5031324165, ["zm"] = 13,
      },
    },
    ["n"] = "Lady Llarel's Journal",
    ["cn"] = "Personal Journals",
  },
  [760] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Claudie's Journal",
    ["q"] = 3414,
    ["e"] = {
      [1] = { ["px"] = 0.0691791990, ["py"] = 0.3748264030, ["pm"] = 1, },
    },
  },
  [761] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3424400000,
        ["px"] = 0.1154200000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Blood-Sealed Contract",
    ["cn"] = "Plots and Schemes",
  },
  [762] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Brief Letter to an Aldarch",
    ["q"] = 4300,
    ["e"] = {
      [1] = { ["px"] = 0.2005747976, ["py"] = 0.6419679876, ["pm"] = 519, ["d"] = true, ["zx"] = 0.2005503957, ["zy"] = 0.6420080132, ["zm"] = 143, },
    },
  },
  [763] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Coils of the Father",
    ["e"] = {
      [1] = { ["px"] = 0.2005315977, ["py"] = 0.6425007876, ["pm"] = 519, ["d"] = true, ["zx"] = 0.2005423996, ["zy"] = 0.6425408134, ["zm"] = 143, },
    },
  },
  [764] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 143,
        ["px"] = 0.2058500000,
        ["d"] = true,
        ["py"] = 0.6427200000,
        ["mn"] = 15,
      },
    },
    ["n"] = "The Gifts of Magnus",
    ["cn"] = "The Devoted and the Deranged",
  },
  [765] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Warrior's Blade",
    ["e"] = {
      [1] = { ["px"] = 0.1968080014, ["py"] = 0.6359827881, ["pm"] = 522, ["d"] = true, ["zx"] = 0.1968079978, ["zy"] = 0.6359828148, ["zm"] = 143, },
    },
  },
  [766] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Bones of the Forest",
    ["e"] = {
      [1] = { ["px"] = 0.1981331977, ["py"] = 0.6429839873, ["pm"] = 519, ["d"] = true, ["zx"] = 0.1981331975, ["zy"] = 0.6429840134, ["zm"] = 143, },
    },
  },
  [767] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Everscriven Tome",
    ["e"] = {
      [1] = { ["px"] = 0.1951308016, ["py"] = 0.6364243881, ["pm"] = 522, ["d"] = true, ["zx"] = 0.1951307982, ["zy"] = 0.6364244124, ["zm"] = 143, },
    },
  },
  [768] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Heart of Love",
    ["e"] = {
      [1] = { ["px"] = 0.2092747935, ["py"] = 0.6360439882, ["pm"] = 521, ["d"] = true, ["zx"] = 0.2092747964, ["zy"] = 0.6360440143, ["zm"] = 143, },
    },
  },
  [769] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Sounding Horn",
    ["e"] = {
      [1] = { ["px"] = 0.2066183936, ["py"] = 0.6363231882, ["pm"] = 521, ["d"] = true, ["zx"] = 0.2066183963, ["zy"] = 0.6363232134, ["zm"] = 143, },
    },
  },
  [770] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Apprentices' God",
    ["e"] = {
      [1] = { ["px"] = 0.2036828055, ["py"] = 0.6421379876, ["pm"] = 520, ["d"] = true, ["zx"] = 0.2036831995, ["zy"] = 0.6421472139, ["zm"] = 143, },
    },
  },
  [771] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6249800000,
        ["px"] = 0.3058200000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6153300000,
        ["px"] = 0.3884300000,
        ["pm"] = 22,
      },
      [3] = {
        ["px"] = 0.3899000000,
        ["py"] = 0.6154500000,
        ["d"] = true,
        ["pm"] = 757,
      },
    },
    ["n"] = "An Unusual Alliance",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [772] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6245900000,
        ["px"] = 0.3385600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Farandare's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [773] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6300368114, ["py"] = 0.2662299997, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
    },
    ["n"] = "Notice: Hall of the Dead",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [775] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0692992031, ["py"] = 0.3748044079, ["pm"] = 1, },
    },
    ["n"] = "Claudie's Last Entry",
    ["cn"] = "Final Words",
  },
  [776] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6178300000,
        ["px"] = 0.3503500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Champions of Dra'bul",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [777] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6339200000,
        ["px"] = 0.3341300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Green Ladies' Abode",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [778] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6059300000,
        ["px"] = 0.3775800000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Sea Amri Shipping Manifest",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [779] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Supplementary Orders",
    ["e"] = {
      [1] = { ["px"] = 0.2289848062, ["py"] = 0.6476740117, ["pm"] = 181, ["d"] = true, ["zx"] = 0.2283871959, ["zy"] = 0.6477468164, ["zm"] = 143, },
      [2] = { ["px"] = 0.2289852061, ["py"] = 0.6476836117, ["pm"] = 181, ["d"] = true, },
      [3] = { ["px"] = 0.2286360062, ["py"] = 0.6477640117, ["pm"] = 181, ["d"] = true, },
    },
  },
  [780] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Palith Note",
    ["q"] = 4326, -- given to player at quest start, read in inventory
    ["e"] = {
      [1] = { ["px"] = 0.2293083951, ["py"] = 0.6590828125, ["pm"] = 143, ["qc"] = true, }, -- on location AFTER quest
    },
  },
  [781] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Nolonir's Journal, Page 6",
    ["e"] = {
      [1] = { ["px"] = 0.2283216061, ["py"] = 0.6478336117, ["pm"] = 181, ["d"] = true, ["zx"] = 0.2283871959, ["zy"] = 0.6477468164, ["zm"] = 143, },
    },
  },
  [782] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Nolonir's Journal, Page 17",
    ["e"] = {
      [1] = { ["px"] = 0.2284840061, ["py"] = 0.6482604118, ["pm"] = 181, ["d"] = true, ["zx"] = 0.2283871959, ["zy"] = 0.6477468164, ["zm"] = 143, },
    },
  },
  [783] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Nolonir's Journal, Page 29",
    ["e"] = {
      [1] = { ["px"] = 0.2283156061, ["py"] = 0.6486248118, ["pm"] = 181, ["d"] = true, ["zx"] = 0.2283871959, ["zy"] = 0.6477468164, ["zm"] = 143, },
    },
  },
  [784] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6052600000,
        ["px"] = 0.3727100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Battle of the Ale",
    ["cn"] = "Words of the Poets",
  },
  [786] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6029400000,
        ["px"] = 0.4094800000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Baandari Mutton Stew",
    ["cn"] = "Skill Books",
  },
  [787] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5995300000,
        ["px"] = 0.4077600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Sweet Life",
    ["cn"] = "Hearts and Flowers",
  },
  [789] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5848900000,
        ["px"] = 0.3931000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Secrets of Treehenge",
    ["cn"] = "The World and Its Creatures",
  },
  [790] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5973200000,
        ["px"] = 0.3905900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Prayer to Hircine",
    ["cn"] = "Daedric Cults",
  },
  [791] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Boethiah's Glory",
    ["q"] = 5469,
    ["e"] = {
      [1] = {
        ["pm"] = 667,
        ["px"] = 0.2979200000,
        ["d"] = true,
        ["py"] = 0.2436300000,
        ["mn"] = 27,
      },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2436200000,
        ["px"] = 0.2979000000,
        ["pm"] = 667,
      },
    },
  },
  [792] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Bravil,  Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 19,
      [201] = 5,
      [258] = 8,
      [75] = 2,
      [143] = 43,
      [74] = 59,
      [227] = 2,
      [7] = 35,
    },
  },
  [793] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4957300000,
        ["px"] = 0.5705900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Buying Game",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [794] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Prince Aiden's Report",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 17,
      [201] = 3,
      [258] = 6,
      [227] = 5,
      [143] = 21,
      [74] = 11,
      [7] = 9,
    },
  },
  [795] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Of the Dragonfires (Fragment)",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 32,
      [143] = 72,
      [201] = 5,
      [258] = 32,
      [227] = 14,
      [75] = 5,
      [13] = 1,
      [74] = 14,
      [7] = 26,
    },
  },
  [796] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Father of the Niben, Fragment One",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 41,
      [258] = 19,
      [227] = 9,
      [1060] = 17,
      [1126] = 15,
      [7] = 57,
      [201] = 4,
      [10] = 17,
      [75] = 3,
      [13] = 9,
      [143] = 127,
      [16] = 13,
      [660] = 14,
      [26] = 11,
      [27] = 3,
      [125] = 1,
      [74] = 20,
      [255] = 13,
    },
  },
  [797] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4646700000,
        ["px"] = 0.5250700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Heartland of Cyrodiil",
    ["cn"] = "The World and Its Creatures",
  },
  [798] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4227600000,
        ["px"] = 0.1884200000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3952300000,
        ["px"] = 0.1353300000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.3735200000,
        ["px"] = 0.2352700000,
        ["pm"] = 30,
      },
      [4] = {
        ["mn"] = 5,
        ["py"] = 0.3951800000,
        ["px"] = 0.1426600000,
        ["pm"] = 30,
      },
      [5] = {
        ["py"] = 0.6800010000,
        ["px"] = 0.5980020000,
        ["pm"] = 1940,
        ["zm"] = 1887,
      },
    },
    ["n"] = "The Book of Circles, Loredas Maxims",
    ["cn"] = "Lore and Culture",
  },
  [799] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "The Hanging Gardens",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 44,
      [201] = 5,
      [258] = 19,
      [227] = 19,
      [143] = 83,
      [13] = 4,
      [74] = 8,
      [7] = 26,
    },
  },
  [800] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4776800000,
        ["px"] = 0.6005400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "When I Will Come A-Courtin'",
    ["cn"] = "Words of the Poets",
  },
  [801] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Mysticism—The Unfathomable Voyage",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 11,
      [258] = 14,
      [75] = 6,
      [143] = 24,
      [74] = 3,
      [227] = 10,
      [7] = 14,
    },
  },
  [802] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Nerevar Moon-and-Star",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 7,
      [143] = 14,
      [258] = 27,
      [75] = 2,
      [74] = 3,
      [13] = 2,
      [227] = 11,
      [7] = 14,
    },
  },
  [803] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Ruins of Kemel-Ze, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 38,
      [258] = 7,
      [227] = 4,
      [27] = 2,
      [7] = 63,
      [26] = 11,
      [201] = 3,
      [10] = 10,
      [75] = 14,
      [300] = 17,
      [13] = 6,
      [74] = 17,
      [143] = 72,
    },
  },
  [804] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Ruins of Kemel-Ze, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 29,
      [143] = 44,
      [201] = 4,
      [74] = 15,
      [227] = 2,
      [258] = 13,
      [13] = 1,
      [75] = 8,
      [7] = 23,
    },
  },
  [805] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Ruins of Kemel-Ze, Part 3",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 11,
      [201] = 2,
      [258] = 5,
      [75] = 6,
      [143] = 32,
      [7] = 19,
    },
  },
  [806] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4682800000,
        ["px"] = 0.4921400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 1",
    ["cn"] = "Lore and Culture",
  },
  [807] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4708800000,
        ["px"] = 0.5971700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Spirit of Nirn",
    ["cn"] = "Lore and Culture",
  },
  [808] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Tale of Dro-Zira",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 29,
      [258] = 1,
      [227] = 1,
      [20] = 2,
      [7] = 16,
      [75] = 6,
      [9] = 12,
      [74] = 5,
      [27] = 5,
      [12] = 28,
      [13] = 16,
      [201] = 9,
      [143] = 47,
    },
  },
  [809] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Worthy Ar-Azal, His Deeds",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 24,
      [201] = 5,
      [74] = 6,
      [75] = 2,
      [143] = 26,
      [227] = 1,
      [7] = 8,
    },
  },
  [810] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4762600000,
        ["px"] = 0.5890800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Time of the Ebonheart Pact",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [811] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Bravil, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [9] = 18,
      [27] = 4,
      [20] = 1,
      [13] = 19,
      [12] = 12,
    },
  },
  [812] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Father of the Niben, Fragment Two",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 20,
      [13] = 12,
      [9] = 18,
      [27] = 16,
    },
  },
  [813] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Rite of Boethiah's Gauntlet",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [994] = 15,
      [1060] = 41,
      [1349] = 11,
      [439] = 1,
      [9] = 25,
      [61] = 4,
      [27] = 2,
      [12] = 11,
      [13] = 11,
      [1006] = 7,
      [1429] = 9,
    },
  },
  [814] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4706700000,
        ["px"] = 0.5984800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 2",
    ["cn"] = "Lore and Culture",
  },
  [815] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5066700000,
        ["px"] = 0.5162200000,
        ["pm"] = 16,
      },
      [2] = {
        ["py"] = 0.6799930000,
        ["px"] = 0.5976760000,
        ["pm"] = 1940,
        ["zm"] = 1887,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 3",
    ["cn"] = "Lore and Culture",
  },
  [816] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5193100000,
        ["px"] = 0.5651500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Welcome to New Aldmeri Irregulars",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [817] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Worm Saga",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [61] = 1,
      [9] = 18,
      [10] = 7,
      [27] = 5,
      [300] = 14,
      [13] = 10,
      [26] = 16,
      [12] = 13,
    },
  },
  [818] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Battle of Red Mountain, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 33,
      [13] = 11,
      [9] = 11,
      [27] = 6,
    },
  },
  [819] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Battle of Red Mountain, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 21,
      [13] = 28,
      [9] = 31,
      [27] = 4,
    },
  },
  [820] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Death Blow of Abernanit",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 8,
      [13] = 18,
      [9] = 19,
      [27] = 5,
    },
  },
  [821] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2692900000,
        ["px"] = 0.6140600000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Mead, Mead, Mead!",
    ["cn"] = "Words of the Poets",
  },
  [822] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Locked Room, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [9] = 13,
      [10] = 23,
      [27] = 10,
      [300] = 12,
      [13] = 7,
      [12] = 14,
      [26] = 22,
    },
  },
  [823] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Locked Room, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 18,
      [13] = 34,
      [9] = 17,
      [27] = 13,
    },
  },
  [824] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Ruins of Kemel-Ze, Part 4",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 42,
      [13] = 14,
      [9] = 15,
      [27] = 8,
    },
  },
  [825] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Ithguleoir",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [994] = 4,
      [1060] = 20,
      [1349] = 11,
      [9] = 8,
      [61] = 3,
      [27] = 3,
      [12] = 5,
      [13] = 5,
      [1006] = 10,
      [1429] = 5,
    },
  },
  [826] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3295300000,
        ["px"] = 0.3005000000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Code of the Baandari Pedlars",
    ["cn"] = "Lore and Culture",
  },
  [827] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4942900000,
        ["px"] = 0.8189900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Lives of the Saints",
    ["cn"] = "The Devoted and the Deranged",
  },
  [828] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "A Hypothetical Treachery, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 52,
      [16] = 3,
      [143] = 111,
      [258] = 19,
      [227] = 4,
      [1060] = 25,
      [660] = 3,
      [1126] = 11,
      [7] = 35,
      [75] = 4,
      [201] = 22,
      [74] = 10,
      [27] = 4,
      [26] = 9,
      [13] = 4,
      [10] = 8,
      [255] = 48,
    },
  },
  [829] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "A Hypothetical Treachery, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 8,
      [13] = 13,
      [9] = 21,
      [27] = 3,
    },
  },
  [830] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4963700000,
        ["px"] = 0.5478600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Notes on Racial Phylogeny",
    ["cn"] = "Skill Books",
  },
  [831] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8097159908, ["py"] = 0.4430920064, ["pm"] = 75, },
    },
    ["n"] = "Commendation Letter",
    ["cn"] = "Military Orders and Reports",
  },
  [832] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Delves-Deeply's Note",
    ["q"] = 4327,
    ["e"] = {
      [1] = { ["px"] = 0.2313891999, ["py"] = 0.6509984139, ["pm"] = 143, ["qp"] = true, },
    },
  },
  [833] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Zaban's Letter",
    ["q"] = 4329,
    ["e"] = {
      [1] = { ["px"] = 0.2264848007, ["py"] = 0.6323768149, ["pm"] = 143, },
    },
  },
  [834] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3442100000,
        ["px"] = 0.6123600000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Impressions of Northwind Mine",
    ["cn"] = "Notes and Memos",
  },
  [835] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0840740002, ["py"] = 0.3205460039, ["pm"] = 1,
      },
    },
    ["n"] = "Merien's Incantation",
    ["cn"] = "Rituals and Revelations",
  },
  [836] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0842984012, ["py"] = 0.3205968022, ["pm"] = 1,
      },
    },
    ["n"] = "Merien Sellan's Spellbook",
    ["cn"] = "Rituals and Revelations",
  },
  [837] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5459200000,
        ["py"] = 0.3690600000,
        ["d"] = true,
        ["pm"] = 142,
        ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125,
      },
    },
    ["n"] = "Note from Scout Justal",
    ["cn"] = "Notes and Memos",
  },
  [838] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5444779858, ["py"] = 0.3691079988, ["pm"] = 142, ["d"] = true,
        ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125,
      },
    },
    ["n"] = "Note from Commander Derre",
    ["cn"] = "Notes and Memos",
  },
  [839] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5450803859, ["py"] = 0.3689135988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Memo from Menoit",
    ["cn"] = "Notes and Memos",
  },
  [840] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7157500000,
        ["py"] = 0.5886500000,
        ["d"] = true,
        ["pm"] = 338,
      },
    },
    ["n"] = "The Knighting Ceremony",
    ["cn"] = "Rituals and Revelations",
  },
  [841] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6112400000,
        ["px"] = 0.7614700000,
        ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5452600000,
        ["px"] = 0.7525800000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Argonian Mating Ritual",
    ["cn"] = "Research Notes",
  },
  [842] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7190012161, ["py"] = 0.5878599945, ["pm"] = 139, ["d"] = true,
        ["zx"] = 0.7191959911, ["zy"] = 0.5950455892, ["zm"] = 26,
      },
    },
    ["n"] = "The Lamia Threat",
    ["cn"] = "Military Orders and Reports",
  },
  [843] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Military Deployment Across Auridon",
    ["q"] = 4326,
    ["e"] = {
      [1] = { ["px"] = 0.2436015951, ["py"] = 0.6455880127, ["pm"] = 143, ["qp"] = true, }, -- on location DURING quest
      [2] = { ["px"] = 0.2293003942, ["py"] = 0.6591512150, ["pm"] = 143, ["qc"] = true, }, -- on location AFTER quest
    },
  },
  [844] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6673308095, ["py"] = 0.3935755899, ["pm"] = 703, ["d"] = true,
        ["zx"] = 0.6668963927, ["zy"] = 0.3931739953, ["zm"] = 125,
      },
    },
    ["n"] = "Yngrel's To Do List",
    ["cn"] = "Hearts and Flowers",
  },
  [845] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7266872062, ["py"] = 0.5172719995, ["pm"] = 537, ["zm"] = 13,
      },
    },
    ["n"] = "Vim's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [847] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6283996113, ["py"] = 0.2642195998, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
    },
    ["n"] = "Hjurring's Last Seed Journal",
    ["cn"] = "Personal Journals",
  },
  [848] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5583000000,
        ["px"] = 0.7548300000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Sacred Places",
    ["cn"] = "The Devoted and the Deranged",
  },
  [849] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6341496113, ["py"] = 0.2663895998, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
    },
    ["n"] = "Dragon Skull Parchment",
    ["cn"] = "Mysteries and Clues",
  },
  [850] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6342816114, ["py"] = 0.2794335993, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
    },
    ["n"] = "Hlaki's Journal",
    ["cn"] = "Final Words",
  },
  [851] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6386620109, ["py"] = 0.2768715990, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.4442300000,
        ["px"] = 0.5166800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "An Ancient Scroll",
    ["cn"] = "Mysteries and Clues",
  },
  [852] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6393020106, ["py"] = 0.2749967992, ["pm"] = 140, ["zx"] = 0.6298996273, ["zy"] = 0.2658371998, ["zm"] = 61, ["d"] = true, },
      [2] = { ["px"] = 0.6298996273, ["py"] = 0.2658371998, ["pm"] = 160, ["fp"] = true, },
    },
    ["n"] = "Reynir the Destroyer",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [853] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6323100000,
        ["px"] = 0.3287900000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Child's Play",
    ["cn"] = "Tales of Tamriel",
  },
  [854] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3743800000,
        ["px"] = 0.6142600000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Speech Notes",
    ["cn"] = "Daedric Cults",
  },
  [855] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5857500000,
        ["py"] = 0.3372700000,
        ["d"] = true,
        ["pm"] = 265,
      },
    },
    ["n"] = "Slashed and Blood-Stained Note",
    ["cn"] = "Final Words",
  },
  [856] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3660100000,
        ["px"] = 0.6504800000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3613100000,
        ["px"] = 0.6493900000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3665100000,
        ["px"] = 0.6464000000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Wanted: The Chief",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [857] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5565243978, ["py"] = 0.3464691938, ["pm"] = 125, },
    },
    ["n"] = "Sealed Orders (opened)",
    ["cn"] = "Military Orders and Reports",
  },
  [858] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5964000000,
        ["py"] = 0.3908500000,
        ["d"] = true,
        ["pm"] = 169,
      },
    },
    ["n"] = "Dwarven Ruin Explorer's Journal",
    ["cn"] = "Research Notes",
  },
  [859] = {
    ["c"] = true,
    ["m"] = {
      [1060] = 1,
    },
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6032500000,
        ["px"] = 0.7845100000,
        ["pm"] = 26,
      },
      [2] = {
        ["pm"] = 26,
        ["px"] = 0.7844500000,
        ["d"] = true,
        ["py"] = 0.6033000000,
        ["mn"] = 9,
      },
    },
    ["n"] = "The Strange Case of Ja-Reet",
    ["cn"] = "Research Notes",
  },
  [860] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5409700000,
        ["px"] = 0.7476800000,
        ["pm"] = 26,
      },
    },
    ["n"] = "An Invitation to Wealth",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [861] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6739000000,
        ["py"] = 0.4433700000,
        ["d"] = true,
        ["pm"] = 192,
      },
      [2] = {
        ["px"] = 0.6738300000,
        ["py"] = 0.4434300000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "Prayer of the Resolute",
    ["cn"] = "The Devoted and the Deranged",
  },
  [862] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6795200000,
        ["py"] = 0.4426700000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "Journal, Day 12",
    ["cn"] = "Daedric Cults",
  },
  [863] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6829000000,
        ["py"] = 0.4451700000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "Journal, Day 26",
    ["cn"] = "Daedric Cults",
  },
  [864] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6835000000,
        ["py"] = 0.4439200000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "Journal, Day 32",
    ["cn"] = "Daedric Cults",
  },
  [865] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6826200000,
        ["py"] = 0.4411600000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "Journal, Day 40",
    ["cn"] = "Daedric Cults",
  },
  [866] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6141500000,
        ["px"] = 0.7463100000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Letter Home",
    ["cn"] = "Letters and Missives",
  },
  [867] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6834400000,
        ["py"] = 0.4378400000,
        ["d"] = true,
        ["pm"] = 1151,
      },
      [2] = {
        ["px"] = 0.6686800000,
        ["py"] = 0.4378800000,
        ["d"] = true,
        ["pm"] = 1151,
      },
      [3] = {
        ["px"] = 0.6792900000,
        ["py"] = 0.4350500000,
        ["d"] = true,
        ["pm"] = 1151,
      },
    },
    ["n"] = "The Obsidian Husk",
    ["cn"] = "Rituals and Revelations",
  },
  [868] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Journal of Tsona-Ei, Part Four",
    ["q"] = 4358,
    ["e"] = {
      [1] = { ["px"] = -0.0791988034, ["py"] = 0.2186847989, ["pm"] = 255, },
    },
  },
  [869] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "The Ancient Eye",
    ["e"] = {
      [1] = { ["px"] = 0.1754351979, ["py"] = 0.6472732131, ["pm"] = 143, },
      [2] = { ["px"] = 0.1920079955, ["py"] = 0.6493988133, ["pm"] = 143, },
    },
  },
  [871] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Captain Parondo's Log Entry",
    ["e"] = {
      [1] = { ["px"] = 0.1856995976, ["py"] = 0.6483060147, ["pm"] = 143, },
      [2] = { ["px"] = 0.1856763952, ["py"] = 0.6497832165, ["pm"] = 143, },
    },
  },
  [873] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Urcelmo's Supplemental Orders",
    ["e"] = {
      [1] = { ["px"] = 0.2448056007, ["py"] = 0.7151268147, ["pm"] = 143, },
    },
  },
  [874] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Notes on the Order Skeevera",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [300] = 34,
      [10] = 25,
      [26] = 25,
      [27] = 3,
    },
  },
  [875] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4708600000,
        ["px"] = 0.4976400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Daedra Worship: The Ayleids",
    ["cn"] = "Daedric Cults",
  },
  [876] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4715000000,
        ["px"] = 0.4994200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Persistence of Daedric Veneration",
    ["cn"] = "Daedric Cults",
  },
  [877] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4572400000,
        ["px"] = 0.4955500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Daedra Worship: The Chimer",
    ["cn"] = "Daedric Cults",
  },
  [878] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5135700000,
        ["px"] = 0.5846100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 4",
    ["cn"] = "Lore and Culture",
  },
  [879] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4329400000,
        ["px"] = 0.5456800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 5",
    ["cn"] = "Lore and Culture",
  },
  [880] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5510100000,
        ["px"] = 0.5628200000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4493900000,
        ["px"] = 0.4814900000,
        ["pm"] = 16,
      },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.4329200000,
        ["px"] = 0.6062600000,
        ["pm"] = 16,
      },
      [4] = {
        ["mn"] = 14,
        ["py"] = 0.4368300000,
        ["px"] = 0.6014100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Effects of the Elder Scrolls",
    ["cn"] = "Research Notes",
  },
  [881] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5462491859, ["py"] = 0.3698555988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Missive to Alchemist",
    ["cn"] = "Plots and Schemes",
  },
  [882] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Giant Warning",
    ["e"] = {
      [1] = {
        ["px"] = 0.7296800000,
        ["py"] = 0.4992800000,
        ["d"] = true,
        ["pm"] = 115,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
      [2] = {
        ["px"] = 0.4278300000,
        ["py"] = 0.5659700000,
        ["d"] = true,
        ["pm"] = 764,
      },
      [3] = {
        ["px"] = 0.2259800000,
        ["py"] = 0.3315300000,
        ["d"] = true,
        ["pm"] = 1149,
      },
      [4] = {
        ["px"] = 0.5460200000,
        ["py"] = 0.3699800000,
        ["d"] = true,
        ["pm"] = 142,
        ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125,
      },
      [5] = {
        ["px"] = 0.3452600000,
        ["py"] = 0.6127200000,
        ["d"] = true,
        ["pm"] = 175,
      },
      [6] = {
        ["px"] = 0.7264800000,
        ["py"] = 0.4954200000,
        ["d"] = true,
        ["pm"] = 115,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
      [7] = {
        ["px"] = 0.7316800000,
        ["py"] = 0.4940600000,
        ["d"] = true,
        ["pm"] = 115,
        ["zx"] = 0.7257599992, ["zy"] = 0.5009216178, ["zm"] = 13,
      },
      [8] = { ["px"] = 0.5450691858, ["py"] = 0.3692759988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
  },
  [883] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5458611858, ["py"] = 0.3692835988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "No Admittance—This Means You",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [884] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5450643858, ["py"] = 0.3692679988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "No Passing Through Here",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [885] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Missing Citizens",
    ["q"] = 4355, -- give to player at quest-start, read in inventory
    ["e"] = {
      [1] = { ["px"] = 0.2150111994, ["py"] = 0.6619272138, ["pm"] = 143, ["qc"] = true, }, -- on location AFTER quest
    },
  },
  [886] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5444287858, ["py"] = 0.3691067988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Concerning Garick",
    ["cn"] = "Military Orders and Reports",
  },
  [887] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5445555858, ["py"] = 0.3691507988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Bridge Guard's Complaint",
    ["cn"] = "Military Orders and Reports",
  },
  [888] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5448775859, ["py"] = 0.3689115988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Into the Lion's Den",
    ["cn"] = "The World and Its Creatures",
  },
  [889] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "If You Can Read This, Open It",
    ["q"] = 4352,
    ["e"] = {
      [1] = { ["px"] = -0.1181804020, ["py"] = 0.2659416027, ["pm"] = 350, ["zx"] = -0.1188416016, ["zy"] = 0.2655072004, ["zm"] = 255, ["d"] = true, },
    },
  },
  [890] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5460147858, ["py"] = 0.3699767988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
    ["n"] = "Note to Lt. Stenric",
    ["cn"] = "Military Orders and Reports",
  },
  [891] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Daggerfall Market Shopping List",
    ["q"] = 3000,
    ["e"] = {
      [1] = { ["px"] = 0.0665360004, ["py"] = 0.3880612053, ["pm"] = 63, ["zm"] = 1 },
    },
  },
  [893] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "The Toothmaul Contract",
    ["q"] = 4441, -- book is needed for quest, you can't miss it, since you're forced to read it
    ["e"] = {
      [1] = { ["px"] = 0.2029012061, ["py"] = 0.7066975717, ["pm"] = 268, ["zx"] = 0.2035039992, ["zy"] = 0.7035848155, ["zm"] = 143, ["qp"] = true, },
    },
  },
  [896] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6751623988, ["py"] = 0.3256207985, ["pm"] = 348, ["d"] = true,
        ["zx"] = 0.6717776225, ["zy"] = 0.3333547937, ["zm"] = 61,
      },
    },
    ["n"] = "The Direfrost Flame",
    ["cn"] = "Rituals and Revelations",
  },
  [901] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Grim Jest",
    ["e"] = {
      [1] = { ["px"] = 0.1854615959, ["py"] = 0.6113680137, ["pm"] = 143, },
    },
  },
  [902] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Another Grim Jest",
    ["e"] = {
      [1] = { ["px"] = 0.1824551962, ["py"] = 0.6114636133, ["pm"] = 143, },
    },
  },
  [903] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 15,
        ["py"] = 0.6111100000,
        ["px"] = 0.1839500000,
        ["pm"] = 143,
      },
    },
    ["n"] = "To My Reviewer",
    ["cn"] = "Letters and Missives",
  },
  [904] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "To Colundore",
    ["e"] = {
      [1] = { ["px"] = 0.1840559970, ["py"] = 0.6091060143, ["pm"] = 143, },
    },
  },
  [911] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2247780033, ["py"] = 0.3371164068, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "The Mysteries of Moravagarlis",
    ["cn"] = "Research Notes",
  },
  [912] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5989692275, ["py"] = 0.3197279977, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Confessions of a Bold Alchemist",
    ["cn"] = "Tales of Tamriel",
  },
  [915] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "On the Brewing of Dark Meat Beer",
    ["e"] = {
      [1] = { ["px"] = 0.2404447957, ["py"] = 0.6732471973, ["pm"] = 545, ["zm"] = 143, },
    },
  },
  [916] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Everfull Flagon Handbill",
    ["e"] = {
      [1] = { ["px"] = -0.0823344049, ["py"] = 0.2711436025, ["pm"] = 255, },
    },
  },
  [918] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Journal of Tsona-Ei, Part One",
    ["e"] = {
      [1] = { ["px"] = -0.0852148083, ["py"] = 0.2157236022, ["pm"] = 255, },
    },
  },
  [919] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Journal of Tsona-Ei, Part Two",
    ["e"] = {
      [1] = { ["px"] = -0.0804664028, ["py"] = 0.2143940008, ["pm"] = 255, },
    },
  },
  [920] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Journal of Tsona-Ei, Part Three",
    ["e"] = {
      [1] = { ["px"] = -0.0766204040, ["py"] = 0.2092563989, ["pm"] = 255, },
    },
  },
  [921] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Kyne's Tears",
    ["e"] = {
      [1] = { ["px"] = -0.0568911993, ["py"] = 0.2856604003, ["pm"] = 255, },
    },
  },
  [922] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Hidden Tears",
    ["e"] = {
      [1] = { ["px"] = -0.0549648051, ["py"] = 0.2855000052, ["pm"] = 255, },
    },
  },
  [923] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1703292028, ["py"] = 0.2966740020, ["pm"] = 12,
      },
    },
    ["n"] = "To Dream Beyond Dreams",
    ["cn"] = "Daedric Cults",
  },
  [926] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Fasaran's Diary",
    ["e"] = {
      [1] = { ["px"] = 0.2131119998, ["py"] = 0.6579992149, ["pm"] = 143, },
    },
  },
  [927] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Dawnbreak Decree",
    ["e"] = {
      [1] = { ["px"] = 0.2146419978, ["py"] = 0.6544336169, ["pm"] = 143, },
    },
  },
  [928] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Urgent Message from the Kinlady",
    ["e"] = {
      [1] = { ["px"] = 0.2113951960, ["py"] = 0.6545548157, ["pm"] = 143, },
    },
  },
  [929] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7722832138, ["py"] = 0.5101912152, ["pm"] = 205, ["zm"] = 13,
      },
    },
    ["n"] = "An Affair with Death",
    ["cn"] = "Research Notes",
  },
  [930] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1758844034, ["py"] = 0.3141436025, ["pm"] = 12,
      },
    },
    ["n"] = "The Omen of Deception",
    ["cn"] = "Daedric Cults",
  },
  [932] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Dismissal Letter",
    ["e"] = {
      [1] = { ["px"] = 0.2114887966, ["py"] = 0.6814680165, ["pm"] = 143, },
    },
  },
  [933] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Forbidden Research Notes",
    ["e"] = {
      [1] = { ["px"] = 0.2112131955, ["py"] = 0.6815128118, ["pm"] = 143, },
    },
  },
  [934] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Village Record, Recent Entry",
    ["e"] = {
      [1] = { ["px"] = 0.2219327966, ["py"] = 0.6772812183, ["pm"] = 143, },
    },
  },
  [935] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Captain Alphaury's Journal",
    ["q"] = 4399,
    ["e"] = {
      [1] = { ["px"] = -0.1279548042, ["py"] = 0.2567812014, ["pm"] = 255, },
    },
  },
  [936] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2109367982, ["py"] = 0.2620980039, ["pm"] = 151, ["d"] = true,
        ["zx"] = 0.2057295961, ["zy"] = 0.2703959984, ["zm"] = 10,
      },
    },
    ["n"] = "Love's Eternal Flame",
    ["cn"] = "Words of the Poets",
  },
  [937] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2102379979, ["py"] = 0.2639884042, ["pm"] = 151, ["d"] = true,
        ["zx"] = 0.2057295961, ["zy"] = 0.2703959984, ["zm"] = 10,
      },
    },
    ["n"] = "The Deepest Cut",
    ["cn"] = "Words of the Poets",
  },
  [938] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2160559975, ["py"] = 0.2684796035, ["pm"] = 151, ["d"] = true,
        ["zx"] = 0.2057295961, ["zy"] = 0.2703959984, ["zm"] = 10,
      },
    },
    ["n"] = "The Summoner",
    ["cn"] = "Words of the Poets",
  },
  [939] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3447267978, ["py"] = 0.6124184079, ["pm"] = 990, ["d"] = true,
        ["zx"] = 0.3466539975, ["zy"] = 0.6114556158, ["zm"] = 22,
      },
    },
    ["n"] = "Legionary's Journal",
    ["cn"] = "Military Orders and Reports",
  },
  [940] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3445067978, ["py"] = 0.6124960079, ["pm"] = 175, ["d"] = true,
        ["zx"] = 0.3466539975, ["zy"] = 0.6114556158, ["zm"] = 22,
      },
    },
    ["n"] = "Special Advisors",
    ["cn"] = "Military Orders and Reports",
  },
  [941] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3452955978, ["py"] = 0.6127140079, ["pm"] = 990, ["d"] = true,
        ["zx"] = 0.3466539975, ["zy"] = 0.6114556158, ["zm"] = 22,
      },
    },
    ["n"] = "Memo to Captain Siro",
    ["cn"] = "Military Orders and Reports",
  },
  [942] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7262976055, ["py"] = 0.5154819991, ["pm"] = 537, ["zm"] = 13,
      },
    },
    ["n"] = "Note on Broken Crate",
    ["cn"] = "Criminal Correspondence",
  },
  [943] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7236032060, ["py"] = 0.5151503995, ["pm"] = 537, ["zm"] = 13,
      },
    },
    ["n"] = "Covert Note",
    ["cn"] = "Notes and Memos",
  },
  [944] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Ruurifin's Journal, Entry 1",
    ["q"] = 4339,
    ["e"] = {
      [1] = { ["px"] = 0.4471087874, ["py"] = 0.7447379890, ["pm"] = 9, },
    },
  },
  [945] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Uryaamo's Journal",
    ["q"] = 4339,
    ["e"] = {
      [1] = { ["px"] = 0.4471087874, ["py"] = 0.7447379890, ["pm"] = 9, },
    },
  },
  [946] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Tancano the Elder's Journal",
    ["q"] = 4339,
    ["e"] = {
      [1] = { ["px"] = 0.4470627877, ["py"] = 0.7447903847, ["pm"] = 9, },
    },
  },
  [947] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Note from Khezuli's Contact",
    ["q"] = 4405,
    ["e"] = {
      [1] = { ["px"] = 0.4577500134, ["py"] = 0.7555535863, ["pm"] = 512, ["zm"] = 9, },
    },
  },
  [948] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4494939969, ["py"] = 0.7368547922, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "Sirdor's Journal",
    ["cn"] = "Research Notes",
  },
  [949] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Gjarma's Orders: Yngold",
    ["q"] = 4396,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7569900000,
        ["px"] = 0.4582700000,
        ["pm"] = 9,
      },
    },
  },
  [950] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7588400000,
        ["px"] = 0.4543600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Gjarma's Orders: Supplies",
    ["cn"] = "Letters and Missives",
  },
  [951] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Gjarma's Orders: Wamasu",
    ["q"] = 4396,
    ["e"] = {
      [1] = { ["px"] = 0.4559676132, ["py"] = 0.7714759864, ["pm"] = 512, ["zm"] = 9, },
    },
  },
  [952] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1657240050, ["py"] = 0.2869688013, ["pm"] = 34, ["zm"] = 12, },
    },
    ["n"] = "The Royal Lineage of Sentinel",
    ["cn"] = "Lore and Culture",
  },
  [955] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1668084053, ["py"] = 0.2849716014, ["pm"] = 34, ["zm"] = 12, },
    },
    ["n"] = "Sir Hughes' Journal",
    ["cn"] = "Personal Journals",
  },
  [956] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "The Fires of Truth",
    ["e"] = {
      [1] = { ["px"] = 0.2077275937, ["py"] = 0.6345643883, ["pm"] = 521, ["d"] = true, ["zx"] = 0.2077275966, ["zy"] = 0.6345644146, ["zm"] = 143, },
    },
  },
  [957] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Letter to an Aldarch",
    ["e"] = {
      [1] = { ["px"] = 0.1971236016, ["py"] = 0.6354591882, ["pm"] = 522, ["d"] = true, ["zx"] = 0.1971235984, ["zy"] = 0.6354592132, ["zm"] = 143, },
    },
  },
  [958] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8338504034, ["py"] = 0.5165960217, ["pm"] = 13,
      },
    },
    ["n"] = "Churasu's Alchemy Journal",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [959] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Aranias' Diary",
    ["q"] = 4411,
    ["e"] = {
      [1] = { ["px"] = 0.2276211945, ["py"] = 0.6382556141, ["pm"] = 143, },
    },
  },
  [960] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "List of Names",
    ["q"] = 4411, -- given to player at quest-start, read from inventory
    ["e"] = {
      [1] = { ["px"] = 0.2350815956, ["py"] = 0.6751503980, ["pm"] = 545, ["zm"] = 143, ["qc"] = true, }, -- on location AFTER quest
    },
  },
  [961] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Gift of Arson",
    ["e"] = {
      [1] = { ["px"] = 0.2260679961, ["py"] = 0.6570856197, ["pm"] = 595, ["d"] = true, ["zx"] = 0.2260195936, ["zy"] = 0.6570936127, ["zm"] = 143, },
    },
  },
  [962] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Egranor",
    ["e"] = {
      [1] = { ["px"] = 0.2346511938, ["py"] = 0.6448620155, ["pm"] = 143, },
    },
  },
  [963] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4283400000,
        ["py"] = 0.6855200000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
    ["n"] = "Keeper of Tomes",
    ["cn"] = "Rituals and Revelations",
  },
  [964] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Remnants of Cyrod",
    ["q"] = 4386,
    ["e"] = {
      [1] = {
        ["px"] = 0.4278400000,
        ["py"] = 0.6849200000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
  },
  [965] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "The Black Year",
    ["q"] = 4386,
    ["e"] = {
      [1] = {
        ["px"] = 0.4274000000,
        ["py"] = 0.6857900000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
  },
  [966] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5457100000,
        ["px"] = 0.7398800000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Listens-to-Water's Observations",
    ["cn"] = "Diaries and Logs",
  },
  [967] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1424299930, ["py"] = 0.3097848043, ["pm"] = 253, ["d"] = true,
        ["zx"] = 0.1358675993, ["zy"] = 0.3165424029, ["zm"] = 1,
      },
    },
    ["n"] = "Journal of Magiul Shiana",
    ["cn"] = "Personal Journals",
  },
  [970] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0841852009, ["py"] = 0.3204276057, ["pm"] = 1,
      },
    },
    ["n"] = "Letter From Tamien Sellan",
    ["cn"] = "Letters and Missives",
  },
  [973] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2070143976, ["py"] = 0.2688188041, ["pm"] = 151, ["d"] = true,
        ["zx"] = 0.2057295961, ["zy"] = 0.2703959984, ["zm"] = 10,
      },
    },
    ["n"] = "Betrayal",
    ["cn"] = "Words of the Poets",
  },
  [974] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["pm"] = 544, ["py"] = 0.5842500000, ["px"] = 0.7747000000, ["zm"] = 26, },
      [2] = {
        ["px"] = 0.7707772119, ["py"] = 0.5930588115, ["pm"] = 588, ["d"] = true,
        ["zx"] = 0.7752843886, ["zy"] = 0.5849247923, ["zm"] = 26,
      },
      [3] = { ["px"] = 0.7753676066, ["py"] = 0.5849524144, ["pm"] = 544, ["fp"] = true, },
    },
    ["n"] = "Tsanji's Ship Records",
    ["cn"] = "Criminal Correspondence",
  },
  [975] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2209976029, ["py"] = 0.3280136067, ["pm"] = 33, ["zm"] = 12, ["ld"] = 8 },
    },
    ["n"] = "For Donel from Father",
    ["cn"] = "Notes and Memos",
  },
  [976] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Weapon Activation",
    ["e"] = {
      [1] = { ["px"] = 0.1882247979, ["py"] = 0.6513112143, ["pm"] = 143, },
    },
  },
  [978] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = -0.6268600000,
        ["d"] = true,
        ["py"] = -0.4859800000,
        ["pm"] = 106,
      },
      [2] = { ["px"] = 0.2247644032, ["py"] = 0.3370668072, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "The Folly of Isolation, Part 1",
    ["cn"] = "The Devoted and the Deranged",
  },
  [979] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2247816021, ["py"] = 0.3370860072, ["pm"] = 33, ["zm"] = 12, },
      [2] = { ["px"] = -0.6222167855, ["py"] = -0.4907303829, ["pm"] = 106, ["d"] = true, },
    },
    ["n"] = "The Folly of Isolation, Part 3",
    ["cn"] = "The Devoted and the Deranged",
  },
  [980] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = -0.6224603844, ["py"] = -0.4941875825, ["pm"] = 106, ["d"] = true, },
      [2] = { ["px"] = 0.2247780033, ["py"] = 0.3370880074, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "The Folly of Isolation, Part 6",
    ["cn"] = "The Devoted and the Deranged",
  },
  [981] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2247816021, ["py"] = 0.3370860072, ["pm"] = 33, ["zm"] = 12, },
      [2] = { ["px"] = -0.6303651856, ["py"] = -0.4967183824, ["pm"] = 106, ["d"] = true, },
    },
    ["n"] = "The Folly of Isolation, Part 7",
    ["cn"] = "The Devoted and the Deranged",
  },
  [982] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = -0.6346155856, ["py"] = -0.4933455821, ["pm"] = 106, ["d"] = true, },
      [2] = { ["px"] = 0.2247932019, ["py"] = 0.3370988071, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "The Folly of Isolation, Part 8",
    ["cn"] = "The Devoted and the Deranged",
  },
  [983] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2248452034, ["py"] = 0.3371136073, ["pm"] = 33, ["zm"] = 12, },
      [2] = { ["px"] = -0.6329811857, ["py"] = -0.4878379828, ["pm"] = 106, ["d"] = true, },
    },
    ["n"] = "The Folly of Isolation, Part the Last",
    ["cn"] = "The Devoted and the Deranged",
  },
  [984] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2002600000,
        ["py"] = 0.7218000000,
        ["d"] = true,
        ["pm"] = 268,
        ["zx"] = 0.2034543987, ["zy"] = 0.7035788196, ["zm"] = 143,
      },
    },
    ["n"] = "The Toothmaul Contract",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [985] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "The First of the Letters",
    ["q"] = 4387,
    ["e"] = {
      [1] = {
        ["px"] = 0.4198100000,
        ["py"] = 0.6882000000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
  },
  [986] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "The Second of the Letters",
    ["q"] = 4387,
    ["e"] = {
      [1] = {
        ["px"] = 0.4200900000,
        ["py"] = 0.6856600000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
  },
  [987] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4201100000,
        ["py"] = 0.6890400000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
    ["n"] = "The Last of the Letters",
    ["cn"] = "Hearts and Flowers",
  },
  [988] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Sanctuary: Final Assessment",
    ["q"] = 4436,
    ["e"] = {
      [1] = {
        ["px"] = 0.4404000000,
        ["py"] = 0.7685600000,
        ["d"] = true,
        ["pm"] = 405,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7658400000,
        ["px"] = 0.4409800000,
        ["pm"] = 9,
      },
    },
  },
  [989] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Sanctuary: Weapons Report",
    ["q"] = 4436,
    ["e"] = {
      [1] = {
        ["px"] = 0.4404500000,
        ["py"] = 0.7677600000,
        ["d"] = true,
        ["pm"] = 405,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7658300000,
        ["px"] = 0.4409800000,
        ["pm"] = 9,
      },
    },
  },
  [990] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Torn Note from Jessen",
    ["q"] = 3856,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4315700000,
        ["d"] = true,
        ["py"] = 0.7335400000,
      },
      [2] = { ["px"] = 0.2192384021, ["py"] = 0.3318836067, ["pm"] = 33, ["zm"] = 12, },
      [3] = { ["px"] = 0.7646716135, ["py"] = 0.5179580145, ["pm"] = 205, ["zm"] = 13, },
    },
  },
  [993] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7137264000, ["py"] = 0.5011332182, ["pm"] = 13,
      },
    },
    ["n"] = "A Prayer for My Family",
    ["cn"] = "Hearts and Flowers",
  },
  [994] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7137447991, ["py"] = 0.5009828179, ["pm"] = 13,
      },
    },
    ["n"] = "An Offering",
    ["cn"] = "Hearts and Flowers",
  },
  [995] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5040900000,
        ["px"] = 0.7834100000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Words of the Rodent",
    ["cn"] = "Daedric Cults",
  },
  [996] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Kalodar's Letter",
    ["q"] = 4448,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3413700000,
        ["px"] = 0.5938400000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3449100000,
        ["px"] = 0.5992000000,
        ["pm"] = 125,
      },
    },
  },
  [997] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3151300000,
        ["px"] = 0.1020000000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Gabrielle Benele's Journal",
    ["cn"] = "Personal Journals",
  },
  [998] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "A Scrap of Parchment",
    ["q"] = 4337,
    ["e"] = {
      [1] = {
        ["pm"] = 22,
        ["px"] = 0.3783800000,
        ["d"] = true,
        ["py"] = 0.6496500000,
        ["mn"] = 8,
      },
    },
  },
  [999] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "A Second Scrap of Parchment",
    ["q"] = 4337,
    ["e"] = {
      [1] = {
        ["pm"] = 22,
        ["px"] = 0.3783700000,
        ["d"] = true,
        ["py"] = 0.6496300000,
        ["mn"] = 8,
      },
    },
  },
  [1000] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "A Third Scrap of Parchment",
    ["q"] = 4337,
    ["e"] = {
      [1] = {
        ["pm"] = 22,
        ["px"] = 0.3783800000,
        ["d"] = true,
        ["py"] = 0.6496500000,
        ["mn"] = 8,
      },
    },
  },
  [1001] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "A Fourth Scrap of Parchment",
    ["q"] = 4337,
    ["e"] = {
      [1] = {
        ["pm"] = 22,
        ["px"] = 0.3783700000,
        ["d"] = true,
        ["py"] = 0.6496300000,
        ["mn"] = 8,
      },
    },
  },
  [1002] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7112164108, ["py"] = 0.5146948150, ["pm"] = 546, ["d"] = true,
        ["zx"] = 0.7141416009, ["zy"] = 0.5146548159, ["zm"] = 13,
      },
    },
    ["n"] = "A Tally of Villagers",
    ["cn"] = "Daedric Cults",
  },
  [1003] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7110336109, ["py"] = 0.5166088150, ["pm"] = 546, ["d"] = true,
        ["zx"] = 0.7141416009, ["zy"] = 0.5146548159, ["zm"] = 13,
      },
    },
    ["n"] = "No Praise for False Gods",
    ["cn"] = "Plots and Schemes",
  },
  [1004] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5004200000,
        ["px"] = 0.7180700000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7109000092, ["py"] = 0.5036455893, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "The Maulborn Manifesto",
    ["cn"] = "Plots and Schemes",
  },
  [1005] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 22,
        ["px"] = 0.3784700000,
        ["d"] = true,
        ["py"] = 0.6495800000,
        ["mn"] = 8,
      },
    },
    ["n"] = "Etching on Ancient Sword",
    ["cn"] = "Mysteries and Clues",
  },
  [1006] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3733100000,
        ["px"] = 0.6463200000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3441600000,
        ["px"] = 0.6452600000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3625800000,
        ["px"] = 0.5729900000,
        ["pm"] = 125,
      },
    },
    ["n"] = "A Summons of Heroes!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1007] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3419700000,
        ["px"] = 0.6376500000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Letter to Vigrod",
    ["cn"] = "Letters and Missives",
  },
  [1008] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3477600000,
        ["px"] = 0.6243100000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Borzul's Suicide Note",
    ["cn"] = "Final Words",
  },
  [1009] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6693591767, ["py"] = 0.3727327970, ["pm"] = 81, ["d"] = true,
        ["zx"] = 0.6680067939, ["zy"] = 0.3786211926, ["zm"] = 125,
      },
    },
    ["n"] = "Ascendancy: Pathway to Lichdom",
    ["cn"] = "Rituals and Revelations",
  },
  [1010] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3943600000,
        ["px"] = 0.6764100000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Betnikh Limerikh",
    ["cn"] = "Words of the Poets",
  },
  [1011] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5533500000,
        ["py"] = 0.3428000000,
        ["d"] = true,
        ["pm"] = 218,
      },
    },
    ["n"] = "Aronel's Journal",
    ["cn"] = "Personal Journals",
  },
  [1012] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3542900000,
        ["px"] = 0.6287900000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Official Missive from Holgunn",
    ["cn"] = "Military Orders and Reports",
  },
  [1013] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3551300000,
        ["px"] = 0.6294100000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Warning to Jardirr",
    ["cn"] = "Military Orders and Reports",
  },
  [1014] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3552500000,
        ["px"] = 0.6287200000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Jardirr's Commendation",
    ["cn"] = "Military Orders and Reports",
  },
  [1015] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3685900000,
        ["px"] = 0.5822700000,
        ["pm"] = 125,
      },
    },
    ["n"] = "War Call of the Mammoth Herders",
    ["cn"] = "Tales of Tamriel",
  },
  [1016] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3649800000,
        ["px"] = 0.5554700000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Kireth's Taarengrav Note",
    ["cn"] = "Research Notes",
  },
  [1017] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.4071800000,
        ["px"] = 0.6632200000,
        ["pm"] = 125,
      },
    },
    ["n"] = "The Sharpest Blade",
    ["cn"] = "Letters and Missives",
  },
  [1018] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3480200000,
        ["px"] = 0.5619400000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3521100000,
        ["px"] = 0.5623400000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Geirmund's Oath",
    ["cn"] = "Words of the Poets",
  },
  [1019] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5056800000,
        ["px"] = 0.8072600000,
        ["pm"] = 13,
      },
    },
    ["n"] = "A Request for Your Support",
    ["cn"] = "Plots and Schemes",
  },
  [1020] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5049000000,
        ["px"] = 0.7975100000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Response to Vox, First Draft",
    ["cn"] = "Plots and Schemes",
  },
  [1021] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5071400000,
        ["px"] = 0.8038200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Vox's Final Reply",
    ["cn"] = "Plots and Schemes",
  },
  [1022] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7712156175, ["py"] = 0.5316816080, ["pm"] = 126, ["d"] = true,
        ["zx"] = 0.7657780026, ["zy"] = 0.5322628143, ["zm"] = 13,
      },
    },
    ["n"] = "My Kwama Journal, Page 1",
    ["cn"] = "Personal Journals",
  },
  [1023] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7691332172, ["py"] = 0.5299392078, ["pm"] = 126, ["d"] = true,
        ["zx"] = 0.7657780026, ["zy"] = 0.5322628143, ["zm"] = 13,
      },
    },
    ["n"] = "My Kwama Journal, Page 2",
    ["cn"] = "Personal Journals",
  },
  [1024] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7445548024, ["py"] = 0.5027772170, ["pm"] = 13, },
    },
    ["n"] = "Valyia's Cargo Manifest",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1025] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3460800000,
        ["px"] = 0.6412100000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Angry Love Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [1026] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6393400000,
        ["py"] = 0.3458100000,
        ["d"] = true,
        ["pm"] = 277,
      },
      [2] = {
        ["pm"] = 125,
        ["px"] = 0.6715300000,
        ["d"] = true,
        ["py"] = 0.3778400000,
        ["mn"] = 12,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3411600000,
        ["px"] = 0.6079500000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Mine Safety Regulations",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1027] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7431260022, ["py"] = 0.5014500181, ["pm"] = 13, },
    },
    ["n"] = "House Hlaalu Merchant Camp",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1028] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3691300000,
        ["px"] = 0.6390500000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Furious Letter",
    ["cn"] = "Letters and Missives",
  },
  [1029] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3559800000,
        ["px"] = 0.6000700000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3657000000,
        ["px"] = 0.5640800000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3544200000,
        ["px"] = 0.6205400000,
        ["pm"] = 125,
      },
      [4] = {
        ["mn"] = 12,
        ["py"] = 0.3780300000,
        ["px"] = 0.6410700000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Rilaso's Guide to Tamriel, Ch. 21",
    ["cn"] = "The World and Its Creatures",
  },
  [1030] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3757500000,
        ["px"] = 0.6424600000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3791700000,
        ["px"] = 0.6401200000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3816500000,
        ["px"] = 0.6456200000,
        ["pm"] = 125,
      },
      [4] = {
        ["mn"] = 12,
        ["py"] = 0.3800200000,
        ["px"] = 0.6367100000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Warning—Docks Unsafe",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1031] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3817100000,
        ["px"] = 0.6248600000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3943000000,
        ["px"] = 0.6365500000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 12,
        ["py"] = 0.3887800000,
        ["px"] = 0.6096900000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Poetic Verse Contest!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1032] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5031600000,
        ["px"] = 0.8145600000,
        ["pm"] = 13,
      },
    },
    ["n"] = "General's Order 12008",
    ["cn"] = "Military Orders and Reports",
  },
  [1033] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5031800000,
        ["px"] = 0.8145500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Public Notice of Promotion",
    ["cn"] = "Military Orders and Reports",
  },
  [1034] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5002800000,
        ["px"] = 0.8161200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Private Dispatch (Secret!)",
    ["cn"] = "Letters and Missives",
  },
  [1035] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3507400000,
        ["px"] = 0.5611700000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3778800000,
        ["px"] = 0.6289400000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Stagger and Sway",
    ["cn"] = "Words of the Poets",
  },
  [1036] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5204200000,
        ["px"] = 0.7341100000,
        ["pm"] = 13,
      },
    },
    ["n"] = "End of the Journey",
    ["cn"] = "The World and Its Creatures",
  },
  [1037] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5297100000,
        ["px"] = 0.7429000000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Relics of Saint Veloth",
    ["cn"] = "Lore and Culture",
  },
  [1038] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4488900000,
        ["py"] = 0.7446200000,
        ["d"] = true,
        ["pm"] = 283,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "The Root Sunder Roots",
    ["cn"] = "Research Notes",
  },
  [1039] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4497303970, ["py"] = 0.7420543927, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "The Root Sunder Market",
    ["cn"] = "Research Notes",
  },
  [1040] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4532043971, ["py"] = 0.7408223925, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "A Nagging Question",
    ["cn"] = "Research Notes",
  },
  [1041] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4535211966, ["py"] = 0.7372583923, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "WHERE ARE THE PEOPLE",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1042] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4547535968, ["py"] = 0.7385907922, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "Aberrant Welkynd Stones",
    ["cn"] = "Research Notes",
  },
  [1043] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6199500000,
        ["px"] = 0.3462700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "All Fear Agrakh",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1044] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6207800000,
        ["px"] = 0.3452400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Heed My Words",
    ["cn"] = "Notes and Memos",
  },
  [1045] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6395335985, ["py"] = 0.3917111924, ["pm"] = 125,
      },
    },
    ["n"] = "Frirhild's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1046] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5766900000,
        ["py"] = 0.3636400000,
        ["d"] = true,
        ["pm"] = 465,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3637700000,
        ["px"] = 0.5762500000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Aera's Letter to Tryn",
    ["cn"] = "Letters and Missives",
  },
  [1047] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3636400000,
        ["px"] = 0.5762900000,
        ["pm"] = 125,
      },
      [2] = {
        ["px"] = 0.5766500000,
        ["py"] = 0.3636700000,
        ["d"] = true,
        ["pm"] = 465,
      },
    },
    ["n"] = "Aera's Letter to Denskar",
    ["cn"] = "Letters and Missives",
  },
  [1048] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5759800000,
        ["py"] = 0.3639700000,
        ["d"] = true,
        ["pm"] = 1847,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3637000000,
        ["px"] = 0.5761800000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Half-Burned Note to Borodin",
    ["cn"] = "Notes and Memos",
  },
  [1049] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5766500000,
        ["py"] = 0.3636700000,
        ["d"] = true,
        ["pm"] = 465,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3665800000,
        ["px"] = 0.5756900000,
        ["pm"] = 125,
      },
    },
    ["n"] = "There Are Ways",
    ["cn"] = "Daedric Cults",
  },
  [1050] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Altmeri Overseer's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2035352060, ["py"] = 0.7042055717, ["pm"] = 268, ["zx"] = 0.2035039992, ["zy"] = 0.7035848155, ["zm"] = 143, ["d"] = true, },
    },
  },
  [1051] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Verses of the Illuminated",
    ["e"] = {
      [1] = { ["px"] = 0.2033200061, ["py"] = 0.7041423717, ["pm"] = 268, ["d"] = true, ["zx"] = 0.2035039992, ["zy"] = 0.7035848155, ["zm"] = 143, },
    },
  },
  [1052] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Silver Crawdad Surprise",
    ["e"] = {
      [1] = { ["px"] = 0.2028900060, ["py"] = 0.7066567717, ["pm"] = 268, ["d"] = true, ["zx"] = 0.2035039992, ["zy"] = 0.7035848155, ["zm"] = 143, },
    },
  },
  [1053] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Inventory (Confidential)",
    ["e"] = {
      [1] = { ["px"] = 0.2028712061, ["py"] = 0.7046867716, ["pm"] = 268, ["d"] = true, ["zx"] = 0.2035039992, ["zy"] = 0.7035848155, ["zm"] = 143, },
    },
  },
  [1054] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7494200000,
        ["py"] = 0.5070800000,
        ["d"] = true,
        ["pm"] = 191,
      },
    },
    ["n"] = "Kireth's Prism Notes",
    ["cn"] = "Research Notes",
  },
  [1055] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7481600000,
        ["py"] = 0.5095500000,
        ["d"] = true,
        ["pm"] = 191,
      },
    },
    ["n"] = "Raynor's Bthanual Notes",
    ["cn"] = "Research Notes",
  },
  [1056] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1607548033, ["py"] = 0.5511195864, ["pm"] = 201,
      },
    },
    ["n"] = "Letter to Captain Helane",
    ["cn"] = "Letters and Missives",
  },
  [1057] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "How Long Before the Echoes Fade?",
    ["q"] = 4607,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4329300000,
        ["px"] = 0.7714100000,
        ["pm"] = 7,
      },
      [2] = {
        ["px"] = -0.0969200000,
        ["d"] = true,
        ["py"] = 0.0906600000,
        ["pm"] = 490,
      },
      [3] = {
        ["mn"] = 2,
        ["py"] = 0.3919400000,
        ["px"] = 0.0739500000,
        ["pm"] = 1,
      },
      [4] = {
        ["mn"] = 15,
        ["py"] = 0.7437500000,
        ["px"] = 0.2475700000,
        ["pm"] = 143,
      },
    },
  },
  [1058] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Record of Taxation for Year's End",
    ["q"] = 4607,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4328800000,
        ["px"] = 0.7713100000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 15,
        ["py"] = 0.7429200000,
        ["px"] = 0.2485300000,
        ["pm"] = 143,
      },
      [3] = {
        ["px"] = -0.0960400000,
        ["d"] = true,
        ["py"] = 0.0918100000,
        ["pm"] = 490,
      },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3919400000,
        ["px"] = 0.0740400000,
        ["pm"] = 1,
      },
    },
  },
  [1059] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "The Clues, Damn Your Eyes",
    ["q"] = 4471,
    ["e"] = {
      [1] = {
        ["mn"] = 19,
        ["py"] = 0.5509600000,
        ["px"] = 0.1565000000,
        ["pm"] = 201,
      },
    },
  },
  [1060] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5575300000,
        ["px"] = 0.4665400000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6346500000,
        ["px"] = 0.4373800000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.6134800000,
        ["px"] = 0.4524400000,
        ["pm"] = 256,
      },
      [4] = {
        ["mn"] = 17,
        ["py"] = 0.6368300000,
        ["px"] = 0.4396500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Baan Dar and His Boast",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1061] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6360400000,
        ["px"] = 0.4375000000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6335600000,
        ["px"] = 0.4450100000,
        ["pm"] = 256,
      },
    },
    ["n"] = "First Scroll of Baan Dar (Excerpt)",
    ["cn"] = "Tales of Tamriel",
  },
  [1063] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Risa's Journal",
    ["q"] = 3728,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5062300000,
        ["px"] = 0.8190600000,
        ["pm"] = 13,
      },
    },
  },
  [1064] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6393600000,
        ["px"] = 0.3314500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Ragged Inscription",
    ["cn"] = "Notes and Memos",
  },
  [1065] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4317700000,
        ["d"] = true,
        ["py"] = 0.7337600000,
      },
      [2] = { ["px"] = 0.2181200028, ["py"] = 0.3328700068, ["pm"] = 33, ["zm"] = 12, },
      [3] = {
        ["px"] = 0.2217000000,
        ["d"] = true,
        ["py"] = 0.3322100000,
        ["pm"] = 102,
      },
      [4] = {
        ["mn"] = 10,
        ["py"] = 0.5178100000,
        ["px"] = 0.7664900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Curano's Journal",
    ["cn"] = "Personal Journals",
  },
  [1066] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2178816028, ["py"] = 0.3322212068, ["pm"] = 33, ["zm"] = 12, },
      [2] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4317700000,
        ["d"] = true,
        ["py"] = 0.7337600000,
      },
      [3] = {
        ["px"] = 0.2236000000,
        ["d"] = true,
        ["py"] = 0.3316200000,
        ["pm"] = 102,
      },
      [4] = {
        ["mn"] = 10,
        ["py"] = 0.5178000000,
        ["px"] = 0.7664700000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Lanath's Journal",
    ["cn"] = "Personal Journals",
  },
  [1067] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5177100000,
        ["px"] = 0.7664400000,
        ["pm"] = 13,
      },
      [2] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4317200000,
        ["d"] = true,
        ["py"] = 0.7335000000,
      },
      [3] = {
        ["px"] = 0.2247000000,
        ["d"] = true,
        ["py"] = 0.3360600000,
        ["pm"] = 102,
      },
      [4] = { ["px"] = 0.2179504023, ["py"] = 0.3321276067, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Endarre's Log",
    ["cn"] = "Final Words",
  },
  [1068] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4316400000,
        ["d"] = true,
        ["py"] = 0.7336900000,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5178100000,
        ["px"] = 0.7665600000,
        ["pm"] = 13,
      },
      [3] = {
        ["px"] = 0.2234200000,
        ["d"] = true,
        ["py"] = 0.3340800000,
        ["pm"] = 102,
      },
      [4] = { ["px"] = 0.2179340027, ["py"] = 0.3321344067, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Ostarand's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [1069] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6117500000,
        ["px"] = 0.3768400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "There Is No Going Back",
    ["cn"] = "Daedric Cults",
  },
  [1070] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6138800000,
        ["px"] = 0.3752200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Firuin's Journal",
    ["cn"] = "Personal Journals",
  },
  [1071] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0604032017, ["py"] = 0.3839448054, ["pm"] = 63, ["zm"] = 1,
      },
    },
    ["n"] = "The Reality of Spirits",
    ["cn"] = "Rituals and Revelations",
  },
  [1072] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8105044037, ["py"] = 0.5279024218, ["pm"] = 13,
      },
    },
    ["n"] = "Scroll of Eight",
    ["cn"] = "Rituals and Revelations",
  },
  [1073] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6362900000,
        ["px"] = 0.3621000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Tanglehaven's Fletchers",
    ["cn"] = "The World and Its Creatures",
  },
  [1074] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Captain Izad's Letter",
    ["q"] = 4471,
    ["e"] = {
      [1] = {
        ["mn"] = 19,
        ["py"] = 0.5506100000,
        ["px"] = 0.1563100000,
        ["pm"] = 201,
      },
    },
  },
  [1075] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6020800000,
        ["px"] = 0.4060000000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3913700000,
        ["px"] = 0.2226800000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 8,
        ["py"] = 0.6005500000,
        ["px"] = 0.4091300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Way of the Baandari",
    ["cn"] = "Lore and Culture",
  },
  [1076] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Altered Missive",
    ["q"] = 4196,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6030300000,
        ["px"] = 0.4052600000,
        ["pm"] = 22,
      },
    },
  },
  [1077] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3589300000,
        ["py"] = 0.6316200000,
        ["d"] = true,
        ["pm"] = 262,
      },
    },
    ["n"] = "Horrors of the Strid Basin",
    ["cn"] = "The World and Its Creatures",
  },
  [1082] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4734596006, ["py"] = 0.6187575938, ["pm"] = 559, ["d"] = true, },
      [2] = { ["px"] = 0.4755835792, ["py"] = 0.6208504075, ["pm"] = 256, ["fp"] = true, },
    },
    ["n"] = "Laboratory Warning: Be Careful!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1084] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0817316015, ["py"] = 0.3407604025, ["pm"] = 1,
      },
    },
    ["n"] = "Rosalind's Orders",
    ["cn"] = "Notes and Memos",
  },
  [1085] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0774768003, ["py"] = 0.3338168025, ["pm"] = 1,
      },
    },
    ["n"] = "Letters from Leon and Rosalind",
    ["cn"] = "Hearts and Flowers",
  },
  [1087] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6792295993, ["py"] = 0.3377579992, ["pm"] = 348, ["d"] = true,
        ["zx"] = 0.6717776225, ["zy"] = 0.3333547937, ["zm"] = 61,
      },
    },
    ["n"] = "On the Interrogation of Witches",
    ["cn"] = "Lore and Culture",
  },
  [1088] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6704823985, ["py"] = 0.3253671981, ["pm"] = 348, ["d"] = true,
        ["zx"] = 0.6717776225, ["zy"] = 0.3333547937, ["zm"] = 61,
      },
    },
    ["n"] = "To the Captain of the Guard",
    ["cn"] = "Letters and Missives",
  },
  [1089] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1642212008, ["py"] = 0.5459955912, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "Nicolene's Diary (Private!)",
    ["cn"] = "Diaries and Logs",
  },
  [1090] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 201,
        ["px"] = 0.1564900000,
        ["d"] = true,
        ["py"] = 0.5437200000,
        ["mn"] = 19,
      },
    },
    ["n"] = "Scrap of Adubaer's Journal",
    ["cn"] = "Final Words",
  },
  [1091] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6831200000,
        ["py"] = 0.3126400000,
        ["d"] = true,
        ["pm"] = 348,
        ["zx"] = 0.6717776225, ["zy"] = 0.3333547937, ["zm"] = 61,
      },
    },
    ["n"] = "The Interrogation of Henghild",
    ["cn"] = "Criminal Correspondence",
  },
  [1092] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 201,
        ["px"] = 0.1555200000,
        ["d"] = true,
        ["py"] = 0.5438500000,
        ["mn"] = 19,
      },
    },
    ["n"] = "Second Scrap of Adubaer's Journal",
    ["cn"] = "Personal Journals",
  },
  [1093] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 201,
        ["px"] = 0.1556000000,
        ["d"] = true,
        ["py"] = 0.5456500000,
        ["mn"] = 19,
      },
    },
    ["n"] = "Drivas' Journal (Partial)",
    ["cn"] = "Personal Journals",
  },
  [1094] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 19,
        ["py"] = 0.5478600000,
        ["px"] = 0.1558400000,
        ["pm"] = 201,
      },
    },
    ["n"] = "Note from Morantor",
    ["cn"] = "Notes and Memos",
  },
  [1095] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 201,
        ["px"] = 0.1554500000,
        ["d"] = true,
        ["py"] = 0.5452000000,
        ["mn"] = 19,
      },
    },
    ["n"] = "Dwarven Writings",
    ["cn"] = "Mysteries and Clues",
  },
  [1096] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0629492019, ["py"] = 0.3788512059, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Verrik's Note",
    ["cn"] = "Daedric Cults",
  },
  [1097] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Letter from Rakhad",
    ["q"] = 4484,
    ["e"] = {
      [1] = { ["px"] = 0.4680519858, ["py"] = 0.6183492043, ["pm"] = 256, },
    },
  },
  [1098] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4703339813, ["py"] = 0.6206516018, ["pm"] = 256, },
    },
    ["n"] = "For Mathal",
    ["cn"] = "Criminal Correspondence",
  },
  [1099] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Gold for Teeth!",
    ["q"] = 3039,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3415200000,
        ["px"] = 0.1210300000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3344100000,
        ["px"] = 0.1138300000,
        ["pm"] = 1,
      },
      [3] = {
        ["mn"] = 2,
        ["py"] = 0.3405900000,
        ["px"] = 0.1103600000,
        ["pm"] = 1,
      },
    },
  },
  [1100] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3121800000,
        ["px"] = 0.2067600000,
        ["pm"] = 12,
      },
    },
    ["n"] = "The Five Points of the Star",
    ["cn"] = "Daedric Cults",
  },
  [1101] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3366600000,
        ["px"] = 0.1868700000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Letter to Hosni",
    ["cn"] = "Letters and Missives",
  },
  [1102] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2218780029, ["py"] = 0.3281864068, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "King Farangel's Beer Ballad",
    ["cn"] = "Words of the Poets",
  },
  [1103] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2260848029, ["py"] = 0.3326524069, ["pm"] = 33, ["zm"] = 12, },
      [2] = { ["px"] = 0.2285756034, ["py"] = 0.3445748073, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Factor Luluelle's Report",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1104] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4301000000,
        ["px"] = 0.5334400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Argonian Maid—An Oral Tradition",
    ["cn"] = "Tales of Tamriel",
  },
  [1105] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Jornibret's Last Dance",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 61,
      [258] = 8,
      [227] = 9,
      [1060] = 13,
      [1126] = 45,
      [7] = 53,
      [201] = 2,
      [10] = 20,
      [75] = 1,
      [13] = 3,
      [143] = 109,
      [16] = 9,
      [660] = 5,
      [26] = 6,
      [27] = 4,
      [74] = 12,
      [30] = 3,
      [255] = 13,
    },
  },
  [1106] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8398500000,
        ["py"] = 0.4994100000,
        ["d"] = true,
        ["pm"] = 123,
      },
      [2] = {
        ["px"] = 0.7321384014, ["py"] = 0.5128564181, ["pm"] = 13,
      },
    },
    ["n"] = "A Warning and an Offer",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1107] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760371861, ["py"] = 0.4063984152, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Aleris the Shroud",
    ["cn"] = "Lore and Culture",
  },
  [1108] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760555861, ["py"] = 0.4064388151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Sanarel the Great",
    ["cn"] = "Lore and Culture",
  },
  [1109] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760351861, ["py"] = 0.4064524151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Felhorn",
    ["cn"] = "Lore and Culture",
  },
  [1110] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760595861, ["py"] = 0.4065092152, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Crow Bringer",
    ["cn"] = "Lore and Culture",
  },
  [1111] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6759571861, ["py"] = 0.4064732151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Hagrof the Righteous",
    ["cn"] = "Lore and Culture",
  },
  [1112] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760559861, ["py"] = 0.4064768151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "The Thousand Arrows",
    ["cn"] = "Lore and Culture",
  },
  [1113] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6759763861, ["py"] = 0.4065240151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Lucius the Stalwart",
    ["cn"] = "Lore and Culture",
  },
  [1114] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6759823861, ["py"] = 0.4064060151, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Whitebear",
    ["cn"] = "Lore and Culture",
  },
  [1115] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6759939861, ["py"] = 0.4064540152, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Ferian Darkstorm",
    ["cn"] = "Lore and Culture",
  },
  [1116] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6759719861, ["py"] = 0.4064364152, ["pm"] = 401, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "The Lava Queen",
    ["cn"] = "Lore and Culture",
  },
  [1117] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6771856200, ["py"] = 0.4028187924, ["pm"] = 397, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Clan of the White Bear",
    ["cn"] = "Lore and Culture",
  },
  [1118] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5362100000,
        ["px"] = 0.5510300000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Rislav the Righteous, Part 1",
    ["cn"] = "Skill Books",
  },
  [1119] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Fire and Darkness, Part 1",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3443800000,
        ["py"] = 0.3060840000,
        ["d"] = true,
        ["pm"] = 1871,
        ["zx"] = 0.3529464073, ["zy"] = 0.3030287967, ["zm"] = 1814,
      },
    },
    ["m"] = {
      [26] = 17,
      [1060] = 22,
      [10] = 8,
      [27] = 2,
      [300] = 10,
      [1429] = 7,
      [1006] = 5,
      [1349] = 29,
    },
  },
  [1120] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Advances in Lockpicking",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [143] = 5,
      [1060] = 10,
      [13] = 47,
      [660] = 1,
      [10] = 11,
      [1126] = 14,
      [7] = 15,
      [667] = 2,
      [9] = 70,
      [26] = 6,
      [27] = 20,
      [12] = 33,
      [125] = 1,
      [300] = 1,
      [255] = 31,
    },
  },
  [1121] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Exiled from Exile, Volume 7",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 72,
      [258] = 26,
      [227] = 18,
      [1060] = 5,
      [1126] = 11,
      [7] = 50,
      [201] = 11,
      [10] = 10,
      [75] = 13,
      [13] = 7,
      [143] = 134,
      [16] = 4,
      [660] = 3,
      [26] = 1,
      [27] = 11,
      [667] = 1,
      [125] = 1,
      [74] = 21,
      [255] = 11,
    },
  },
  [1122] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Fire and Darkness, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1060] = 31,
      [1429] = 8,
      [1349] = 29,
      [10] = 16,
      [27] = 1,
      [300] = 26,
      [61] = 2,
      [1006] = 20,
      [26] = 24,
    },
  },
  [1123] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Mace Etiquette",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 74,
      [256] = 2,
      [258] = 6,
      [227] = 32,
      [1060] = 13,
      [1126] = 14,
      [7] = 57,
      [201] = 13,
      [10] = 16,
      [75] = 4,
      [13] = 9,
      [143] = 107,
      [16] = 7,
      [660] = 7,
      [26] = 9,
      [27] = 3,
      [667] = 1,
      [125] = 2,
      [74] = 6,
      [255] = 30,
    },
  },
  [1124] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Wulfmare's Guide to Better Thieving",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 58,
      [16] = 5,
      [255] = 10,
      [258] = 20,
      [227] = 12,
      [660] = 5,
      [74] = 29,
      [1126] = 14,
      [7] = 57,
      [201] = 12,
      [9] = 1,
      [26] = 3,
      [27] = 4,
      [75] = 4,
      [13] = 3,
      [10] = 12,
      [143] = 110,
    },
  },
  [1125] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Heavy Armor Forging",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 40,
      [258] = 8,
      [227] = 8,
      [1060] = 1,
      [1126] = 10,
      [7] = 48,
      [201] = 23,
      [74] = 15,
      [75] = 6,
      [13] = 2,
      [143] = 130,
      [16] = 6,
      [660] = 3,
      [26] = 6,
      [667] = 1,
      [27] = 3,
      [10] = 3,
      [255] = 26,
    },
  },
  [1126] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sacred Witness, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1060] = 15,
      [1429] = 4,
      [1349] = 12,
      [10] = 10,
      [27] = 1,
      [300] = 12,
      [61] = 5,
      [1006] = 4,
      [26] = 6,
    },
  },
  [1127] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sacred Witness, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [26] = 21,
      [1060] = 29,
      [10] = 7,
      [27] = 1,
      [300] = 15,
      [1429] = 7,
      [1006] = 5,
      [1349] = 17,
    },
  },
  [1128] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4667400000,
        ["px"] = 0.4906700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Legendary Sancre Tor, 1st Ed.",
    ["cn"] = "Skill Books",
  },
  [1129] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Horror of Castle Xyr, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 2,
      [143] = 7,
      [1060] = 1,
      [61] = 12,
      [660] = 3,
      [26] = 12,
      [22] = 9,
      [7] = 7,
      [667] = 2,
      [1126] = 5,
      [10] = 27,
      [27] = 2,
      [300] = 18,
      [13] = 3,
      [30] = 25,
      [255] = 15,
    },
  },
  [1130] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Horror of Castle Xyr, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 16,
      [26] = 11,
      [27] = 1,
      [300] = 10,
      [61] = 12,
      [30] = 17,
      [10] = 3,
    },
  },
  [1131] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5197200000,
        ["px"] = 0.5158500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 6",
    ["cn"] = "Lore and Culture",
  },
  [1132] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4870000000,
        ["px"] = 0.4920100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 7",
    ["cn"] = "Lore and Culture",
  },
  [1133] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5335300000,
        ["px"] = 0.5489400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Rislav the Righteous, Part 2",
    ["cn"] = "Lore and Culture",
  },
  [1134] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2874900000,
        ["py"] = 0.2715800000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "The Lusty Argonian Maid, A Song",
    ["cn"] = "Words of the Poets",
  },
  [1135] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Three Thieves, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 20,
      [61] = 27,
      [22] = 21,
      [27] = 3,
    },
  },
  [1136] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Three Thieves, Part Two",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 29,
      [61] = 26,
      [30] = 18,
      [27] = 4,
    },
  },
  -- TODO Check this
  [1137] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "A Kiss, Sweet Mother",
    ["e"] = {
      [1] = { ["px"] = 0.3628452099, ["py"] = 0.5515340005, ["pm"] = 1052, ["d"] = true, ["zm"] = 1006, }, -- inside castle kvatch + world-map pin
      [2] = { ["px"] = 0.3628452049, ["py"] = 0.5515339903, ["pm"] = 1064, ["fp"] = true, }, -- "fake"-pin for kvatch city-map
      [3] = { ["px"] = 0.3400776054, ["py"] = 0.5500211968, ["d"] = true, ["pm"] = 1063, ["zx"] = 0.3400776156, ["zy"] = 0.5500212108, ["zm"] = 1006, },
      [4] = {
        ["mn"] = 14,
        ["py"] = 0.5253600000,
        ["px"] = 0.5358000000,
        ["pm"] = 16,
      },
    },
  },
  [1138] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Beggar Prince",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 17,
      [61] = 8,
      [30] = 17,
      [27] = 2,
    },
  },
  [1139] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Brothers of Darkness (1st ed.)",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 21,
      [61] = 14,
      [30] = 9,
      [27] = 2,
    },
  },
  [1140] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Chance's Folly, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 30,
      [61] = 12,
      [30] = 15,
      [27] = 5,
    },
  },
  [1141] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Children of the Sky",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 16,
      [61] = 25,
      [30] = 13,
      [27] = 1,
    },
  },
  [1142] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Death of a Wanderer",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 2,
      [61] = 4,
      [22] = 14,
      [27] = 2,
    },
  },
  [1143] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1959668012, ["py"] = 0.2321012024, ["pm"] = 647, ["d"] = true,
        ["zx"] = 0.2034936009, ["zy"] = 0.2418960001, ["zm"] = 10,
      },
    },
    ["n"] = "Tome of Daedric Portals",
    ["cn"] = "Daedric Cults",
  },
  [1144] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Immortal Blood, Part 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 18,
      [61] = 23,
      [22] = 21,
      [27] = 4,
    },
  },
  [1145] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Cheeses of Tamriel",
    ["e"] = {
      [1] = { ["px"] = 0.0279927993, ["py"] = -0.0151683975, ["pm"] = 105, ["d"] = true, },
      [2] = {
        ["py"] = 0.6118100000,
        ["px"] = 0.0628400000,
        ["pm"] = 108,
      },
      [3] = { ["px"] = 0.2220696029, ["py"] = 0.3287264069, ["pm"] = 33, ["zm"] = 12, },
      [4] = {
        ["px"] = 0.6911900000,
        ["py"] = 0.4576300000,
        ["d"] = true,
        ["pm"] = 113,
        ["zx"] = 0.6912327949, ["zy"] = 0.4576123997, ["zm"] = 7,
      },
      [5] = {
        ["py"] = 0.6799920000,
        ["px"] = 0.5977140000,
        ["pm"] = 1940,
        ["zm"] = 1887,
      },
    },
  },
  [1146] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Thief of Virtue",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 10,
      [61] = 9,
      [22] = 9,
      [27] = 1,
    },
  },
  [1147] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Sultry Argonian Bard, Vol. 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 2,
      [1313] = 1,
      [994] = 9,
      [1060] = 26,
      [1349] = 13,
      [22] = 20,
      [439] = 1,
      [27] = 1,
      [1006] = 25,
      [61] = 21,
      [30] = 4,
      [1429] = 5,
    },
  },
  [1148] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5038800000,
        ["px"] = 0.5557400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Song of Pelinal, Volume 8",
    ["cn"] = "Lore and Culture",
  },
  [1149] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Horror of Castle Xyr, Part 3",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 16,
      [143] = 7,
      [16] = 5,
      [667] = 1,
      [20] = 10,
      [125] = 8,
      [1126] = 16,
      [7] = 18,
      [1060] = 16,
      [26] = 8,
      [10] = 10,
      [27] = 5,
      [22] = 1,
      [13] = 8,
      [660] = 9,
      [255] = 55,
    },
  },
  [1150] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3847300000,
        ["px"] = 0.2725100000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3279000000,
        ["px"] = 0.3069900000,
        ["pm"] = 20,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.3571600000,
        ["px"] = 0.2664800000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Septima Tharn's Leadership Maxims",
    ["cn"] = "Military Orders and Reports",
  },
  [1151] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Ahzidal's Descent",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 7,
      [143] = 10,
      [16] = 3,
      [20] = 7,
      [660] = 7,
      [1126] = 10,
      [7] = 14,
      [125] = 9,
      [1060] = 13,
      [10] = 9,
      [27] = 4,
      [26] = 4,
      [13] = 9,
      [30] = 7,
      [255] = 13,
    },
  },
  [1152] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Changed Ones",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 12,
      [143] = 4,
      [16] = 5,
      [667] = 1,
      [1060] = 5,
      [125] = 19,
      [1126] = 22,
      [7] = 28,
      [660] = 4,
      [26] = 7,
      [10] = 1,
      [27] = 15,
      [300] = 1,
      [13] = 4,
      [20] = 14,
      [255] = 19,
    },
  },
  [1153] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Wind and Sand",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [143] = 7,
      [1060] = 18,
      [667] = 2,
      [20] = 15,
      [125] = 9,
      [1126] = 12,
      [7] = 11,
      [660] = 13,
      [26] = 9,
      [10] = 22,
      [27] = 17,
      [256] = 11,
      [13] = 8,
      [30] = 1,
      [255] = 46,
    },
  },
  [1154] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Chronicles of Nchuleft",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 14,
      [143] = 5,
      [16] = 21,
      [667] = 2,
      [20] = 17,
      [125] = 8,
      [1126] = 16,
      [7] = 10,
      [660] = 6,
      [26] = 7,
      [10] = 16,
      [27] = 17,
      [300] = 1,
      [13] = 9,
      [1060] = 1,
      [255] = 25,
    },
  },
  [1155] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Confessions of a Khajiiti Fur Trader",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 4,
      [143] = 16,
      [1060] = 9,
      [660] = 4,
      [667] = 1,
      [1126] = 9,
      [7] = 29,
      [125] = 7,
      [256] = 17,
      [10] = 11,
      [27] = 6,
      [26] = 8,
      [13] = 3,
      [20] = 6,
      [255] = 23,
    },
  },
  [1156] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4989200000,
        ["px"] = 0.5043900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Glories and Laments",
    ["cn"] = "Lore and Culture",
  },
  [1157] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Night Mother's Truth",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 26,
      [1313] = 1,
      [1060] = 31,
      [1349] = 5,
      [1126] = 23,
      [7] = 21,
      [10] = 10,
      [300] = 1,
      [13] = 6,
      [1006] = 9,
      [143] = 14,
      [16] = 5,
      [20] = 17,
      [1429] = 5,
      [667] = 2,
      [26] = 8,
      [27] = 15,
      [660] = 6,
      [125] = 17,
      [30] = 2,
      [255] = 33,
    },
  },
  [1158] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Nchunak's Fire and Faith",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 16,
      [143] = 5,
      [16] = 9,
      [667] = 1,
      [1060] = 4,
      [125] = 4,
      [1126] = 9,
      [7] = 11,
      [660] = 16,
      [26] = 7,
      [10] = 10,
      [27] = 5,
      [20] = 17,
      [13] = 2,
      [30] = 1,
      [255] = 36,
    },
  },
  [1159] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "On Apocrypha",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 12,
      [1060] = 11,
      [667] = 1,
      [20] = 13,
      [125] = 4,
      [1126] = 15,
      [7] = 26,
      [660] = 9,
      [26] = 3,
      [10] = 5,
      [27] = 4,
      [256] = 13,
      [13] = 4,
      [30] = 2,
      [255] = 32,
    },
  },
  [1160] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Immortal Blood, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 11,
      [143] = 9,
      [16] = 12,
      [20] = 18,
      [667] = 2,
      [1126] = 39,
      [7] = 10,
      [125] = 9,
      [660] = 7,
      [10] = 18,
      [27] = 15,
      [26] = 8,
      [13] = 9,
      [1060] = 6,
      [255] = 45,
    },
  },
  [1161] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Aetherial Fragments",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 34,
      [994] = 11,
      [1060] = 32,
      [1349] = 34,
      [1126] = 21,
      [7] = 10,
      [10] = 8,
      [13] = 14,
      [1006] = 6,
      [143] = 25,
      [16] = 9,
      [20] = 8,
      [1429] = 12,
      [439] = 1,
      [667] = 1,
      [660] = 7,
      [26] = 11,
      [27] = 9,
      [61] = 1,
      [125] = 8,
      [30] = 3,
      [255] = 58,
    },
  },
  [1162] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Sovngarde, A Reexamination",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 7,
      [143] = 5,
      [1060] = 15,
      [16] = 9,
      [1126] = 18,
      [7] = 8,
      [125] = 8,
      [667] = 1,
      [10] = 12,
      [27] = 17,
      [26] = 7,
      [13] = 7,
      [20] = 9,
      [255] = 32,
    },
  },
  [1163] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4739900000,
        ["px"] = 0.5483800000,
        ["pm"] = 660,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4324500000,
        ["px"] = 0.5457400000,
        ["pm"] = 16,
      },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.5192600000,
        ["px"] = 0.5168100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Goodnight Mundus",
    ["cn"] = "Words of the Poets",
  },
  [1164] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4449100000,
        ["px"] = 0.4976900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Remanada, Chapter One",
    ["cn"] = "Lore and Culture",
  },
  [1165] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4382000000,
        ["px"] = 0.6014500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "When the Dragon Broke",
    ["cn"] = "Rituals and Revelations",
  },
  [1166] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Confessions of a Skooma Eater",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 3,
      [143] = 2,
      [16] = 5,
      [1060] = 1,
      [26] = 5,
      [22] = 5,
      [7] = 10,
      [125] = 3,
      [20] = 7,
      [10] = 7,
      [27] = 7,
      [1126] = 7,
      [13] = 8,
      [660] = 5,
      [255] = 21,
    },
  },
  [1167] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "The Five Tenets",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 2,
      [255] = 20,
      [660] = 3,
      [20] = 12,
      [256] = 17,
      [22] = 3,
      [7] = 11,
      [1126] = 54,
      [9] = 1,
      [10] = 8,
      [27] = 9,
      [26] = 6,
      [13] = 15,
      [125] = 36,
      [143] = 6,
    },
  },
  [1169] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6760575814, ["py"] = 0.4051104129, ["pm"] = 399, ["d"] = true,
        ["zx"] = 0.6771855942, ["zy"] = 0.4028187896, ["zm"] = 125,
      },
    },
    ["n"] = "Wish Me Good Fortune",
    ["cn"] = "Hearts and Flowers",
  },
  [1170] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6151100000,
        ["px"] = 0.3995500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Spectral Beings",
    ["cn"] = "Rituals and Revelations",
  },
  [1171] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0896176005, ["py"] = 0.3466420065, ["pm"] = 1,
      },
    },
    ["n"] = "Glenumbria: Alessian Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [1172] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6179600000,
        ["px"] = 0.3904500000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6125300000,
        ["px"] = 0.3866500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Time Will Come",
    ["cn"] = "Mysteries and Clues",
  },
  [1173] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6143200000,
        ["px"] = 0.3918700000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6125700000,
        ["px"] = 0.3866400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Time Is Past",
    ["cn"] = "Mysteries and Clues",
  },
  [1174] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6133600000,
        ["px"] = 0.3875900000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6125000000,
        ["px"] = 0.3865600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "The Time Is Now",
    ["cn"] = "Mysteries and Clues",
  },
  [1175] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Note in a Dead Man's Hand",
    ["q"] = 1527,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3369600000,
        ["px"] = 0.2044900000,
        ["pm"] = 12,
      },
      [2] = { ["px"] = 0.2152676022, ["py"] = 0.3264868068, ["pm"] = 33, ["zm"] = 12, },
    },
  },
  [1176] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2154372024, ["py"] = 0.3264748068, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Baron Sorick's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1177] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2322044031, ["py"] = 0.3238444045, ["pm"] = 12,
      },
    },
    ["n"] = "Summoning Gar Xuu Gar",
    ["cn"] = "Rituals and Revelations",
  },
  [1178] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3473628080, ["py"] = 0.6975715919, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Ceyran, Warlord of Rulanyil's Fall",
    ["cn"] = "Lore and Culture",
  },
  [1180] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3457676081, ["py"] = 0.6887983920, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Head of Brazzefk",
    ["cn"] = "Lore and Culture",
  },
  [1182] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3480824076, ["py"] = 0.6885611920, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Guestbook: Rulanyil's Fall",
    ["cn"] = "Rituals and Revelations",
  },
  [1184] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Hubert's Notes",
    ["q"] = 1615,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3159100000,
        ["px"] = 0.2339200000,
        ["pm"] = 12,
      },
    },
  },
  [1189] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Vareldur's Journal",
    ["q"] = 4524,
    ["e"] = {
      [1] = { ["px"] = 0.2276320003, ["py"] = 0.6957084108, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2293096024, ["py"] = 0.7311131730, ["pm"] = 178, ["d"] = true, ["zx"] = 0.2289847936, ["zy"] = 0.7319340137, ["zm"] = 143, }, -- book is quest-starter, if NOT read in inventory its found at location [1]
    },
  },
  [1193] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5943300000,
        ["px"] = 0.3821400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Ralion's Journal, Day 132",
    ["cn"] = "Personal Journals",
  },
  [1194] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5954700000,
        ["px"] = 0.3892700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Ralion's Journal, Day 147",
    ["cn"] = "Personal Journals",
  },
  [1195] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5917500000,
        ["px"] = 0.3867800000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Ralion's Journal, Day 151",
    ["cn"] = "Personal Journals",
  },
  [1196] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5955000000,
        ["px"] = 0.3895200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Nilaendril's Notes",
    ["cn"] = "Research Notes",
  },
  [1197] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5909700000,
        ["px"] = 0.3896100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Ralion's Journal, Day 149",
    ["cn"] = "Personal Journals",
  },
  [1198] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5910500000,
        ["px"] = 0.3899400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "One Wilding Night",
    ["cn"] = "Words of the Poets",
  },
  [1200] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Heirloom Vase",
    ["q"] = 4497,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6240900000,
        ["px"] = 0.3672400000,
        ["pm"] = 22,
      },
    },
  },
  [1202] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3748500000,
        ["px"] = 0.0888400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Ilessan Tower",
    ["cn"] = "Criminal Correspondence",
  },
  [1203] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6247600000,
        ["px"] = 0.3688200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Aunt Anela's Cookbook",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1205] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1776028060, ["py"] = 0.3229199953, ["pm"] = 202, ["zx"] = 0.1773340027, ["zy"] = 0.3228328034, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Missive from the Mages Guild",
    ["cn"] = "Letters and Missives",
  },
  [1206] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1782132060, ["py"] = 0.3223339953, ["pm"] = 202, ["zx"] = 0.1773340027, ["zy"] = 0.3228328034, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Further Missive from the Mages",
    ["cn"] = "Letters and Missives",
  },
  [1208] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1778524060, ["py"] = 0.3223383952, ["pm"] = 202, ["zx"] = 0.1773340027, ["zy"] = 0.3228328034, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Foreman's Letter",
    ["cn"] = "Letters and Missives",
  },
  [1209] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1991223959, ["py"] = 0.3448231983, ["pm"] = 249, ["zx"] = 0.1986476018, ["zy"] = 0.3451248066, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Don't Mess This Up",
    ["cn"] = "Criminal Correspondence",
  },
  [1210] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6089300000,
        ["px"] = 0.4368300000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Letter from Altholmir",
    ["cn"] = "Letters and Missives",
  },
  [1211] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1993703959, ["py"] = 0.3446011984, ["pm"] = 249, ["zx"] = 0.1986476018, ["zy"] = 0.3451248066, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Farangel's Delve: Further Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1212] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6088700000,
        ["px"] = 0.4361400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Letter to Firilia",
    ["cn"] = "Hearts and Flowers",
  },
  [1213] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4286400000,
        ["py"] = 0.6198100000,
        ["d"] = true,
        ["pm"] = 303,
      },
    },
    ["n"] = "The Journal of Indring the Patient",
    ["cn"] = "Personal Journals",
  },
  [1214] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1990915959, ["py"] = 0.3444147983, ["pm"] = 249, ["zx"] = 0.1986476018, ["zy"] = 0.3451248066, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Hope and Recriminations",
    ["cn"] = "Criminal Correspondence",
  },
  [1215] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1870424037, ["py"] = 0.2995060044, ["pm"] = 238, ["zx"] = 0.1873600020, ["zy"] = 0.2989472057, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "About the Boss",
    ["cn"] = "Criminal Correspondence",
  },
  [1216] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1874284037, ["py"] = 0.2996232044, ["pm"] = 238, ["zx"] = 0.1873600020, ["zy"] = 0.2989472057, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Watch Your Back",
    ["cn"] = "Criminal Correspondence",
  },
  [1217] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1877252037, ["py"] = 0.2997820044, ["pm"] = 238, ["zx"] = 0.1873600020, ["zy"] = 0.2989472057, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Get Back to Work",
    ["cn"] = "Criminal Correspondence",
  },
  [1218] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2545244037, ["py"] = 0.3150343968, ["pm"] = 223, ["zx"] = 0.2542363994, ["zy"] = 0.3142708042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Unfinished Scroll",
    ["cn"] = "Notes and Memos",
  },
  [1219] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2535228036, ["py"] = 0.3140371968, ["pm"] = 223, ["zx"] = 0.2542363994, ["zy"] = 0.3142708042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "…ine Commands of Eight Divines",
    ["cn"] = "Final Words",
  },
  [1220] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2532916037, ["py"] = 0.3145787967, ["pm"] = 223, ["zx"] = 0.2542363994, ["zy"] = 0.3142708042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "All Alone",
    ["cn"] = "Final Words",
  },
  [1221] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2288807931, ["py"] = 0.3051808005, ["pm"] = 194, ["zx"] = 0.2289327995, ["zy"] = 0.3050692042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "In Dreams We Awaken",
    ["cn"] = "Daedric Cults",
  },
  [1222] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2286911931, ["py"] = 0.3056320004, ["pm"] = 194, ["zx"] = 0.2289327995, ["zy"] = 0.3050692042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Dreamers Our Time Has Come",
    ["cn"] = "Daedric Cults",
  },
  [1223] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2083164064, ["py"] = 0.3138467962, ["pm"] = 219, ["zx"] = 0.2082908007, ["zy"] = 0.3138564047, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Here Lies Arah",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1224] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2092644064, ["py"] = 0.3143723962, ["pm"] = 219, ["zx"] = 0.2082908007, ["zy"] = 0.3138564047, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Look to the Dawn",
    ["cn"] = "Daedric Cults",
  },
  [1225] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2090884064, ["py"] = 0.3135559962, ["pm"] = 219, ["zx"] = 0.2082908007, ["zy"] = 0.3138564047, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "I Know Its Name",
    ["cn"] = "Final Words",
  },
  [1226] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3820200000,
        ["py"] = 0.5891100000,
        ["d"] = true,
        ["pm"] = 272,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.5911700000,
        ["px"] = 0.3899100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Token of My Affection",
    ["cn"] = "Tales of Tamriel",
  },
  [1227] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3833900000,
        ["py"] = 0.5894500000,
        ["d"] = true,
        ["pm"] = 272,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.5912200000,
        ["px"] = 0.3898700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "It Is Insufferable",
    ["cn"] = "Hearts and Flowers",
  },
  [1228] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3829600000,
        ["py"] = 0.5908400000,
        ["d"] = true,
        ["pm"] = 272,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.5912200000,
        ["px"] = 0.3899600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "I Must Not Falter",
    ["cn"] = "Daedric Cults",
  },
  [1229] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2284759931, ["py"] = 0.3052232005, ["pm"] = 194, ["zx"] = 0.2289327995, ["zy"] = 0.3050692042, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Dream of a Thousand Dreamers",
    ["cn"] = "Daedric Cults",
  },
  [1230] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0617800012, ["py"] = 0.3802744059, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Back Home in Orsinium",
    ["cn"] = "Diaries and Logs",
  },
  [1231] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2208292025, ["py"] = 0.3281808069, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Orcs? Could Be Worse",
    ["cn"] = "Lore and Culture",
  },
  [1232] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2298724034, ["py"] = 0.3451164072, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Letter to Agnor",
    ["cn"] = "Criminal Correspondence",
  },
  [1233] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1662900056, ["py"] = 0.3065919966, ["pm"] = 532, ["zm"] = 12, },
    },
    ["n"] = "A Soldier's Letter",
    ["cn"] = "Letters and Missives",
  },
  [1234] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3265300000,
        ["px"] = 0.1320900000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Witches of Hag Fen",
    ["cn"] = "Research Notes",
  },
  [1235] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0505651999, ["py"] = 0.3619604072, ["pm"] = 1,
      },
    },
    ["n"] = "Contract with House Diel",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1236] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6143400000,
        ["px"] = 0.3862700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Orchelor's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [1237] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6194800000,
        ["px"] = 0.3867800000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Diplomacy during the Handfasting",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1238] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6161400000,
        ["px"] = 0.3912300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Reward for Information: Silvenar",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1239] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Chance's Folly, Part 2",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [30] = 4,
      [61] = 13,
      [22] = 19,
      [27] = 1,
    },
  },
  [1240] = {
    ["c"] = true,
    ["q"] = 4058,
    ["e"] = {
      [1] = { ["px"] = 0.6374620273, ["py"] = 0.2681827996, ["pm"] = 160, ["zm"] = 61, ["qp"] = true, },
    },
    ["n"] = "For the Tracker's Competition",
    ["cn"] = "Plots and Schemes",
  },
  [1241] = {
    ["c"] = true,
    ["q"] = 4058,
    ["e"] = {
      [1] = { ["px"] = 0.6260364273, ["py"] = 0.2666151997, ["pm"] = 160, ["zm"] = 61, ["qp"] = true, },
    },
    ["n"] = "For the Archery Competition",
    ["cn"] = "Plots and Schemes",
  },
  [1242] = {
    ["c"] = true,
    ["q"] = 4058,
    ["e"] = {
      [1] = { ["px"] = 0.6269680273, ["py"] = 0.2617220000, ["pm"] = 160, ["zm"] = 61, ["qp"] = true, },
    },
    ["n"] = "For the Drinking Contest",
    ["cn"] = "Plots and Schemes",
  },
  [1243] = {
    ["c"] = true,
    ["q"] = 4058,
    ["e"] = {
      [1] = { ["px"] = 0.6374308271, ["py"] = 0.2682004000, ["pm"] = 160, ["zm"] = 61, ["qp"] = true, },
    },
    ["n"] = "For the Preliminary Duels",
    ["cn"] = "Plots and Schemes",
  },
  [1244] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1657352050, ["py"] = 0.2874820012, ["pm"] = 34, ["zm"] = 12, },
    },
    ["n"] = "Letter from Duke Nathaniel",
    ["cn"] = "Letters and Missives",
  },
  [1245] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3179200000,
        ["px"] = 0.2021000000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Old Handbill",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1246] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3247100000,
        ["px"] = 0.2361700000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Overdreamer Chartrand's Orders",
    ["cn"] = "Daedric Cults",
  },
  [1247] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3350900000,
        ["px"] = 0.1634900000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Telvanni Requirements",
    ["cn"] = "Criminal Correspondence",
  },
  [1248] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3142900000,
        ["px"] = 0.2354700000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Mathias Raiment's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [1249] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1820655933, ["py"] = 0.2881144056, ["pm"] = 297, ["zx"] = 0.1843260040, ["zy"] = 0.2919144054, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "The Three's Petition to the King",
    ["cn"] = "Letters and Missives",
  },
  [1250] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3215900000,
        ["px"] = 0.2481300000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Wait Till Next Time",
    ["cn"] = "Lore and Culture",
  },
  [1251] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3124600000,
        ["px"] = 0.2359400000,
        ["pm"] = 12,
      },
    },
    ["n"] = "To Clarice—Be My Darling!",
    ["cn"] = "Hearts and Flowers",
  },
  [1252] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2206328027, ["py"] = 0.3363024068, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Wayrest Guard Orders",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1253] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3068300000,
        ["px"] = 0.1994600000,
        ["pm"] = 12,
      },
    },
    ["n"] = "A Child's Tamriel Bestiary",
    ["cn"] = "Words of the Poets",
  },
  [1254] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2625700000,
        ["px"] = 0.6180700000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Warning from Fildgor",
    ["cn"] = "Plots and Schemes",
  },
  [1255] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Onus of the Oghma",
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4324600000,
        ["px"] = 0.7839900000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3844000000,
        ["px"] = 0.0610600000,
        ["pm"] = 1,
      },
      [3] = { ["px"] = 0.2374476023, ["py"] = 0.7374108217, ["pm"] = 243, ["zm"] = 143, },
      [4] = {
        ["mn"] = 18,
        ["py"] = 0.4472800000,
        ["px"] = 0.8169400000,
        ["pm"] = 75,
      },
      [5] = {
        ["px"] = 0.1666788006, ["py"] = 0.5441055912, ["pm"] = 530, ["zm"] = 201,
      },
      [6] = {
        ["mn"] = 21,
        ["py"] = 0.8047400000,
        ["px"] = 0.5083900000,
        ["pm"] = 258,
      },
    },
  },
  [1256] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Welcome, Veiled Recruit",
    ["e"] = {
      [1] = { ["px"] = 0.2619811966, ["py"] = 0.6773748189, ["pm"] = 143, },
    },
  },
  [1257] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Aluvus' Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2266336010, ["py"] = 0.7423356223, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [1258] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0872996006, ["py"] = 0.3557871984, ["pm"] = 724, ["zx"] = 0.0824784028, ["zy"] = 0.3531068025, ["zm"] = 1, ["d"] = true, },
      [2] = { ["px"] = 0.0826584022, ["py"] = 0.3530672008, ["pm"] = 1, },
    },
    ["n"] = "Faded and Dusty Scroll",
    ["cn"] = "Research Notes",
  },
  [1260] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Entila's Folly",
    ["e"] = {
      [1] = { ["px"] = 0.2311972010, ["py"] = 0.7379644213, ["pm"] = 243, ["zm"] = 143, },
      [2] = { ["px"] = 0.2279340006, ["py"] = 0.7416696220, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [1261] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Gordag's Journal",
    ["q"] = 4556,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5989100000,
        ["px"] = 0.7370800000,
        ["pm"] = 26,
      },
    },
  },
  [1262] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0840840024, ["py"] = 0.3878912036, ["pm"] = 1,
      },
    },
    ["n"] = "Deleyn's Mill Order Form",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1263] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3239700000,
        ["px"] = 0.0862000000,
        ["pm"] = 1,
      },
      [2] = {
        ["px"] = 0.2875400000,
        ["py"] = 0.2717900000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "Of Men and Mer",
    ["cn"] = "Words of the Poets",
  },
  [1265] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.2995400000,
        ["px"] = 0.1289300000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Scholar Garrique's Journal",
    ["cn"] = "Research Notes",
  },
  [1266] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1389644045, ["py"] = 0.2997656066, ["pm"] = 541, ["zm"] = 1, },
    },
    ["n"] = "Letter to Ando",
    ["cn"] = "Criminal Correspondence",
  },
  [1267] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3792400000,
        ["px"] = 0.0754400000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3651000000,
        ["px"] = 0.0700400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Ivory Lord: A Hero Born, V. 1",
    ["cn"] = "Tales of Tamriel",
  },
  [1268] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3219600000,
        ["px"] = 0.1003600000,
        ["pm"] = 1,
      },
    },
    ["n"] = "A Plea for Vengeance",
    ["cn"] = "Notes and Memos",
  },
  [1269] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0993355996, ["py"] = 0.3228948039, ["pm"] = 1,
      },
    },
    ["n"] = "The Journal of Darien Gautier",
    ["cn"] = "Personal Journals",
  },
  [1270] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3000300000,
        ["px"] = 0.1186100000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Catacombs of Cath Bedraud",
    ["cn"] = "Research Notes",
  },
  [1271] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1058036035, ["py"] = 0.3537128057, ["pm"] = 531, ["zm"] = 1, },
      [2] = { ["px"] = 0.0850239993, ["py"] = 0.3258480035, ["pm"] = 1, },
      [3] = {
        ["pm"] = 1,
        ["px"] = 0.0849100000,
        ["d"] = true,
        ["py"] = 0.3258000000,
        ["mn"] = 2,
      },
    },
    ["n"] = "The Ivory Lord: A Hero Born, V. 2",
    ["cn"] = "Tales of Tamriel",
  },
  [1272] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1419140045, ["py"] = 0.3019420064, ["pm"] = 541, ["zm"] = 1, },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3129800000,
        ["px"] = 0.1121500000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Ivory Lord: A Hero Born, V. 3",
    ["cn"] = "Tales of Tamriel",
  },
  [1273] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1057744031, ["py"] = 0.3529836054, ["pm"] = 531, ["zm"] = 1, },
    },
    ["n"] = "On Our Enemies",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1274] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.5973800000,
        ["px"] = 0.3751000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Stormreeve Neidir's Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [1275] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1657524020, ["py"] = 0.3009176030, ["pm"] = 12,
      },
    },
    ["n"] = "Letter to Sentulus",
    ["cn"] = "Daedric Cults",
  },
  [1276] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2808876053, ["py"] = 0.6041712079, ["pm"] = 596, ["zx"] = 0.3567263988, ["zy"] = 0.6009552146, ["zm"] = 22, ["d"] = true, },
    },
    ["n"] = "Maormer Correspondence, Vol. 1",
    ["cn"] = "The World and Its Creatures",
  },
  [1277] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2808684115, ["py"] = 0.6036296037, ["pm"] = 292, ["zx"] = 0.3567263988, ["zy"] = 0.6009552146, ["zm"] = 22, ["d"] = true, },
    },
    ["n"] = "Maormer Correspondence, Vol. 2",
    ["cn"] = "The World and Its Creatures",
  },
  [1280] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Snowmead's Missive",
    ["q"] = 4126,
    ["e"] = {
      [1] = {
        ["px"] = 0.5880768244, ["py"] = 0.3193711914, ["pm"] = 61,
      },
    },
  },
  [1281] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Jomund's Research Notes",
    ["q"] = 4128,
    ["e"] = {
      [1] = { ["px"] = 0.5998712277, ["py"] = 0.3135583973, ["pm"] = 578, ["zm"] = 61, },
    },
  },
  [1284] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5900408260, ["py"] = 0.3208495964, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Note from Magister Osanne",
    ["cn"] = "Plots and Schemes",
  },
  [1285] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Treatise on Metallurgical Anomalies",
    ["q"] = 4138,
    ["e"] = {
      [1] = { ["px"] = 0.5998668272, ["py"] = 0.3135771974, ["pm"] = 578, ["zm"] = 61, },
    },
  },
  [1286] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1372292044, ["py"] = 0.2919888066, ["pm"] = 541, ["zm"] = 1, },
    },
    ["n"] = "The Miner's Lament",
    ["cn"] = "Words of the Poets",
  },
  [1287] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Spymaster Ramorgol's Orders",
    ["q"] = 4070,
    ["e"] = {
      [1] = { ["px"] = 0.6592224241, ["py"] = 0.3165155950, ["pm"] = 61, },
    },
  },
  [1288] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Shaman Moramat's Orders",
    ["q"] = 4070,
    ["e"] = {
      [1] = { ["px"] = 0.6591756273, ["py"] = 0.3165223947, ["pm"] = 61, },
    },
  },
  [1289] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6168500000,
        ["px"] = 0.3854000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Letter to Thalrinel",
    ["cn"] = "Letters and Missives",
  },
  [1290] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6142600000,
        ["px"] = 0.3914500000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6163800000,
        ["px"] = 0.3845100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Time of Troubles",
    ["cn"] = "Diaries and Logs",
  },
  [1291] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6139100000,
        ["px"] = 0.4526900000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Make the Wilds Safer, Earn Gold",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1292] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3119000000,
        ["px"] = 0.1130300000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Ebon Crypt",
    ["cn"] = "Notes and Memos",
  },
  [1293] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Indal's Letter",
    ["q"] = 4537,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6414300000,
        ["px"] = 0.4262900000,
        ["pm"] = 256,
      },
    },
  },
  [1294] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1068976025, ["py"] = 0.3541808052, ["pm"] = 531, ["zm"] = 1, },
    },
    ["n"] = "Oiarah's Journal",
    ["cn"] = "Personal Journals",
  },
  [1295] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2460840015, ["py"] = 0.3242536011, ["pm"] = 12,
      },
    },
    ["n"] = "Kurlash's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1296] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1649332009, ["py"] = 0.5412999911, ["pm"] = 530, ["zm"] = 201, },
      [2] = { ["px"] = 0.1626040008, ["py"] = 0.5446155907, ["pm"] = 530, ["zm"] = 201, },
      [3] = { ["px"] = 0.1588608029, ["py"] = 0.5443227862, ["pm"] = 201, },
    },
    ["n"] = "Bhosek's Punishments",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1297] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 19,
        ["py"] = 0.5441700000,
        ["px"] = 0.1663300000,
        ["pm"] = 201,
      },
    },
    ["n"] = "An Elegantly Penned Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [1298] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1663016005, ["py"] = 0.5443287908, ["pm"] = 530, ["zm"] = 201,
      },
    },
    ["n"] = "Kurog's Betrayal",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1299] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1665980005, ["py"] = 0.5438231910, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "Meat for Soup",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1300] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1617864009, ["py"] = 0.5446947911, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "The Last Will of Roland Volcy",
    ["cn"] = "Final Words",
  },
  [1301] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1626208008, ["py"] = 0.5446731909, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "We Expect Absolute Discretion",
    ["cn"] = "Criminal Correspondence",
  },
  [1302] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1648992006, ["py"] = 0.5401927913, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "Letter to Headman Bhosek",
    ["cn"] = "Letters and Missives",
  },
  [1303] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1651028008, ["py"] = 0.5422535913, ["pm"] = 530, ["zm"] = 201, },
    },
    ["n"] = "A Call to Action!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1304] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1635664032, ["py"] = 0.5510495864, ["pm"] = 201, },
    },
    ["n"] = "Deregor's Lost Goods",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1305] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1641844007, ["py"] = 0.5460663907, ["pm"] = 530, ["zm"] = 201, },
      [2] = { ["px"] = 0.1635888033, ["py"] = 0.5510359865, ["pm"] = 201, },
    },
    ["n"] = "Letter to Captain Lerisa",
    ["cn"] = "Letters and Missives",
  },
  [1306] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3429696082, ["py"] = 0.6902311918, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Nedic Dueling Swords",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1307] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3421120081, ["py"] = 0.6917871917, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Altmer: Heirs of a Noble Lineage",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1308] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3438340081, ["py"] = 0.6943627918, ["pm"] = 278, ["zx"] = 0.3172944031, ["zy"] = 0.6878735925, ["zm"] = 300, ["d"] = true, },
    },
    ["n"] = "Argonians of Black Marsh",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1310] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5448400000,
        ["px"] = 0.7481600000,
        ["pm"] = 26,
      },
      [2] = {
        ["pm"] = 26,
        ["px"] = 0.7478900000,
        ["d"] = true,
        ["py"] = 0.5480300000,
        ["mn"] = 9,
      },
    },
    ["n"] = "The Green Singing",
    ["cn"] = "The World and Its Creatures",
  },
  [1311] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Notes on Bewan",
    ["e"] = {
      [1] = { ["px"] = 0.2457347959, ["py"] = 0.6728611973, ["pm"] = 545, ["zm"] = 143, },
    },
  },
  [1312] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Del's Claim Report",
    ["e"] = {
      [1] = { ["px"] = 0.2379556013, ["py"] = 0.7404852217, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [1313] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "A Discarded Missive",
    ["e"] = {
      [1] = { ["px"] = 0.2479543966, ["py"] = 0.6747343976, ["pm"] = 545, ["zm"] = 143, },
    },
  },
  [1314] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Wansalen Tunnels",
    ["e"] = {
      [1] = { ["px"] = 0.2386807958, ["py"] = 0.6740631973, ["pm"] = 545, ["zm"] = 143, },
    },
  },
  [1315] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6214800000,
        ["px"] = 0.3080400000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Dead Man's Drop",
    ["cn"] = "Rituals and Revelations",
  },
  [1316] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6339700000,
        ["px"] = 0.3287000000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Rogue Elements",
    ["cn"] = "Notes and Memos",
  },
  [1317] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6216800000,
        ["px"] = 0.3453200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "She Dared Me",
    ["cn"] = "Diaries and Logs",
  },
  [1318] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6188900000,
        ["px"] = 0.3690700000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Arrai's Journal",
    ["cn"] = "Personal Journals",
  },
  [1319] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6143700000,
        ["px"] = 0.3911500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Stay Far from the Roots",
    ["cn"] = "Notes and Memos",
  },
  [1320] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6020100000,
        ["px"] = 0.4062300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Note from Zidal",
    ["cn"] = "Notes and Memos",
  },
  [1321] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7891083862, ["py"] = 0.5722303944, ["pm"] = 26,
      },
    },
    ["n"] = "Ofglog's Journal",
    ["cn"] = "Personal Journals",
  },
  [1322] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2946300000,
        ["py"] = 0.7056100000,
        ["d"] = true,
        ["pm"] = 377,
      },
    },
    ["n"] = "Vicereeve Pelidil's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1323] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7673007900, ["py"] = 0.5951559961, ["pm"] = 26, },
    },
    ["n"] = "Rest Gently",
    ["cn"] = "Final Words",
  },
  [1324] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Shadowscale's Journal",
    ["q"] = 3686,
    ["e"] = {
      [1] = {
        ["pm"] = 26,
        ["px"] = 0.7478900000,
        ["d"] = true,
        ["py"] = 0.5481400000,
        ["mn"] = 9,
      },
    },
  },
  [1325] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5389700000,
        ["px"] = 0.7445900000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Three-of-Claws' Note",
    ["cn"] = "Notes and Memos",
  },
  [1326] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7560111937, ["py"] = 0.5532435951, ["pm"] = 26, },
    },
    ["n"] = "Broken Tusk Ritual Notes",
    ["cn"] = "Rituals and Revelations",
  },
  [1327] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.6014300000,
        ["px"] = 0.7374200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Chid Moska",
    ["cn"] = "Notes and Memos",
  },
  [1331] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 26,
        ["px"] = 0.7463400000,
        ["d"] = true,
        ["py"] = 0.5495000000,
        ["mn"] = 9,
      },
    },
    ["n"] = "Partially Legible Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [1332] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Uggissar's Diary",
    ["q"] = 4583,
    ["e"] = {
      [1] = { ["px"] = 0.5969340274, ["py"] = 0.3140943975, ["pm"] = 578, ["zm"] = 61, },
    },
  },
  [1333] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6449500000,
        ["py"] = 0.2899500000,
        ["d"] = true,
        ["pm"] = 164,
      },
    },
    ["n"] = "Letter to Idirfa",
    ["cn"] = "Letters and Missives",
  },
  [1334] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6447400000,
        ["py"] = 0.2891300000,
        ["d"] = true,
        ["pm"] = 164,
      },
    },
    ["n"] = "Nine Commands of the Eight …",
    ["cn"] = "Final Words",
  },
  [1335] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6452900000,
        ["py"] = 0.2890300000,
        ["d"] = true,
        ["pm"] = 164,
      },
    },
    ["n"] = "Uggissar's Lament",
    ["cn"] = "Diaries and Logs",
  },
  [1336] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5951868272, ["py"] = 0.3196795973, ["pm"] = 578, ["zm"] = 61, },
    },
    ["n"] = "Letter to Betra",
    ["cn"] = "Hearts and Flowers",
  },
  [1338] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2696000000,
        ["px"] = 0.6359400000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Unfinished Letter",
    ["cn"] = "Letters and Missives",
  },
  [1339] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6281964271, ["py"] = 0.2672516004, ["pm"] = 160, ["zm"] = 61,
      },
    },
    ["n"] = "Appointments for the Thane",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1340] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3023100000,
        ["px"] = 0.6579600000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Raynor's Travel Diary",
    ["cn"] = "Diaries and Logs",
  },
  [1341] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6864308185, ["py"] = 0.3001771945, ["pm"] = 61, },
    },
    ["n"] = "Skuldafn Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1342] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0795663984, ["py"] = 0.4419543936, ["pm"] = 257, ["zx"] = 0.0867339999, ["zy"] = 0.4435488121, ["zm"] = 227, ["d"] = true, }, -- 1/1
      [2] = { ["px"] = 0.0834331996, ["py"] = 0.4442424119, ["pm"] = 227, ["fp"] = true, }, -- 1/1
      [3] = { ["px"] = 0.0857643995, ["py"] = 0.4450880121, ["pm"] = 227, ["fp"] = true, },
    },
    ["n"] = "Vardan's Diary",
    ["cn"] = "Research Notes",
  },
  [1343] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0856376022, ["py"] = 0.4382172125, ["pm"] = 649, ["zm"] = 227, },
    },
    ["n"] = "Letter from Peverel",
    ["cn"] = "Letters and Missives",
  },
  [1344] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 20,
        ["py"] = 0.4394700000,
        ["px"] = 0.0875400000,
        ["pm"] = 227,
      },
    },
    ["n"] = "Note to Gilbard",
    ["cn"] = "Criminal Correspondence",
  },
  [1345] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0860300011, ["py"] = 0.4315888097, ["pm"] = 260, ["zx"] = 0.0870563989, ["zy"] = 0.4308868113, ["zm"] = 227, ["d"] = true, },
    },
    ["n"] = "Barjot's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1346] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0832576019, ["py"] = 0.4362064123, ["pm"] = 649, ["zm"] = 227, },
    },
    ["n"] = "Shakra's Letter",
    ["cn"] = "Letters and Missives",
  },
  [1347] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0799799998, ["py"] = 0.4309840115, ["pm"] = 227,
      },
    },
    ["n"] = "Drusilla's Notes",
    ["cn"] = "Daedric Cults",
  },
  [1348] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1342747934, ["py"] = 0.3931300025, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "On Calling the Drowned Dead",
    ["cn"] = "Rituals and Revelations",
  },
  [1349] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7730059915, ["py"] = 0.5590071936, ["pm"] = 26, },
    },
    ["n"] = "Badly Damaged Journal",
    ["cn"] = "Research Notes",
  },
  [1350] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5919100000,
        ["px"] = 0.7714200000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Letter from Oleenla",
    ["cn"] = "Letters and Missives",
  },
  [1352] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7347603919, ["py"] = 0.5798099914, ["pm"] = 26, },
    },
    ["n"] = "Dominion Soldier's Journal: Zuuk",
    ["cn"] = "Military Orders and Reports",
  },
  [1353] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7356627907, ["py"] = 0.5761219899, ["pm"] = 26, },
    },
    ["n"] = "Shul's Letter",
    ["cn"] = "Final Words",
  },
  [1355] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0763087995, ["py"] = 0.4422044110, ["pm"] = 227,
      },
    },
    ["n"] = "Garnikh's Hunting Log",
    ["cn"] = "Diaries and Logs",
  },
  [1356] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0825688020, ["py"] = 0.4382456122, ["pm"] = 649, ["zm"] = 227, },
    },
    ["n"] = "Sayings of the Wise",
    ["cn"] = "Lore and Culture",
  },
  [1357] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0758847995, ["py"] = 0.4335856112, ["pm"] = 227,
      },
    },
    ["n"] = "Tazgol's Vision Quest",
    ["cn"] = "Tales of Tamriel",
  },
  [1358] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0791551997, ["py"] = 0.4400192114, ["pm"] = 227,
      },
    },
    ["n"] = "An Almanac of Betony",
    ["cn"] = "The World and Its Creatures",
  },
  [1359] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4034100000,
        ["px"] = 0.2018700000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Interment of Feremuzh",
    ["cn"] = "Rituals and Revelations",
  },
  [1360] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5708800000,
        ["px"] = 0.7830100000,
        ["pm"] = 26,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5621900000,
        ["px"] = 0.7470900000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Hist's Fire",
    ["cn"] = "Hearts and Flowers",
  },
  [1361] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5731600000,
        ["px"] = 0.7405300000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Assassin of Alik'r",
    ["cn"] = "Tales of Tamriel",
  },
  [1362] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5617900000,
        ["px"] = 0.7565200000,
        ["pm"] = 26,
      },
      [2] = { ["px"] = 0.7518787859, ["py"] = 0.5425316112, ["pm"] = 217, ["zm"] = 26, },
    },
    ["n"] = "Weapon and Armor Care Notes",
    ["cn"] = "Military Orders and Reports",
  },
  [1363] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7351231911, ["py"] = 0.5774899951, ["pm"] = 26, },
    },
    ["n"] = "Seafood Supper",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1364] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7078900000,
        ["px"] = 0.2924800000,
        ["pm"] = 300,
      },
      [2] = {
        ["px"] = 0.2925800000,
        ["py"] = 0.7089300000,
        ["d"] = true,
        ["pm"] = 377,
      },
    },
    ["n"] = "Letter to Laryaril",
    ["cn"] = "Letters and Missives",
  },
  [1365] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Anchorite's Log",
    ["q"] = 4607,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4329400000,
        ["px"] = 0.7713600000,
        ["pm"] = 7,
      },
      [2] = {
        ["px"] = -0.0860400000,
        ["d"] = true,
        ["py"] = 0.0715500000,
        ["pm"] = 490,
      },
      [3] = {
        ["mn"] = 2,
        ["py"] = 0.3919400000,
        ["px"] = 0.0739800000,
        ["pm"] = 1,
      },
      [4] = {
        ["mn"] = 15,
        ["py"] = 0.7422400000,
        ["px"] = 0.2493600000,
        ["pm"] = 143,
      },
    },
  },
  [1366] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5699400000,
        ["px"] = 0.7817700000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Wolf in the Sky",
    ["cn"] = "Tales of Tamriel",
  },
  [1367] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7134879912, ["py"] = 0.5927015960, ["pm"] = 26, },
    },
    ["n"] = "Request Denied",
    ["cn"] = "Military Orders and Reports",
  },
  [1368] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "List of Instructions",
    ["q"] = 3791,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5791900000,
        ["px"] = 0.7551300000,
        ["pm"] = 26,
      },
    },
  },
  [1370] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "The Winds of Change",
    ["q"] = 3916,
    ["e"] = {
      [1] = { ["px"] = 0.2228400000, ["py"] = 0.7071800000, ["d"] = true, ["pm"] = 179, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
      [2] = {
        ["px"] = 0.7635600000,
        ["py"] = 0.4369300000,
        ["d"] = true,
        ["pm"] = 90,
      },
      [3] = {
        ["px"] = 0.0610500000,
        ["py"] = 0.3760000000,
        ["d"] = true,
        ["pm"] = 111,
      },
    },
  },
  [1371] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Untold Legends",
    ["q"] = 3916,
    ["e"] = {
      [1] = {
        ["px"] = 0.0615600000,
        ["py"] = 0.3759000000,
        ["d"] = true,
        ["pm"] = 111,
      },
      [2] = { ["px"] = 0.2229700000, ["py"] = 0.7073500000, ["d"] = true, ["pm"] = 179, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
      [3] = {
        ["px"] = 0.7634400000,
        ["py"] = 0.4373500000,
        ["d"] = true,
        ["pm"] = 90,
      },
    },
  },
  [1372] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "The Hidden Twilight",
    ["q"] = 3916,
    ["e"] = {
      [1] = {
        ["px"] = 0.0600900000,
        ["py"] = 0.3748600000,
        ["d"] = true,
        ["pm"] = 111,
      },
      [2] = { ["px"] = 0.2234000000, ["py"] = 0.7070500000, ["d"] = true, ["pm"] = 179, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
      [3] = {
        ["px"] = 0.7629500000,
        ["py"] = 0.4374500000,
        ["d"] = true,
        ["pm"] = 90,
      },
    },
  },
  [1373] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Summoning Rituals of the Arch-Mage",
    ["q"] = 3916,
    ["e"] = {
      [1] = { ["px"] = 0.2234000000, ["py"] = 0.7069200000, ["d"] = true, ["pm"] = 179, ["zx"] = 0.2230291956, ["zy"] = 0.7072228118, ["zm"] = 143, },
      [2] = {
        ["px"] = 0.7630600000,
        ["py"] = 0.4378400000,
        ["d"] = true,
        ["pm"] = 90,
      },
    },
  },
  [1374] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4485700000,
        ["py"] = 0.5871600000,
        ["d"] = true,
        ["pm"] = 29,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5877100000,
        ["px"] = 0.4481000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "To Anchorite Gaius",
    ["cn"] = "Daedric Cults",
  },
  [1375] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5816600000,
        ["px"] = 0.4473600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The Amplification Crystals",
    ["cn"] = "Daedric Cults",
  },
  [1376] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5831700000,
        ["px"] = 0.4439900000,
        ["pm"] = 256,
      },
    },
    ["n"] = "We Have Control",
    ["cn"] = "Daedric Cults",
  },
  [1377] = {
    ["c"] = true,
    ["q"] = 4468,
    ["e"] = {
      [1] = { ["px"] = 0.0811396021, ["py"] = 0.4277399893, ["pm"] = 792, ["d"] = true, },
      [2] = { ["px"] = 0.0863407991, ["py"] = 0.4309160113, ["pm"] = 227, },
    },
    ["n"] = "Note to Nurese",
    ["cn"] = "Hearts and Flowers",
  },
  [1378] = {
    ["c"] = true,
    ["q"] = 4468,
    ["e"] = {
      [1] = { ["px"] = 0.0825860021, ["py"] = 0.4268559890, ["pm"] = 792, ["d"] = true, },
      [2] = { ["px"] = 0.0863615991, ["py"] = 0.4309148113, ["pm"] = 227, },
    },
    ["n"] = "Drago's Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [1379] = {
    ["c"] = true,
    ["q"] = 4468,
    ["e"] = {
      [1] = { ["px"] = 0.0842768021, ["py"] = 0.4278543892, ["pm"] = 792, ["d"] = true, },
      [2] = { ["px"] = 0.0863711991, ["py"] = 0.4309116113, ["pm"] = 227, },
    },
    ["n"] = "Crumbling Breton Scroll",
    ["cn"] = "Rituals and Revelations",
  },
  [1380] = {
    ["c"] = true,
    ["q"] = 4468,
    ["e"] = {
      [1] = { ["px"] = 0.0860244022, ["py"] = 0.4303447887, ["pm"] = 792, ["d"] = true, },
      [2] = { ["px"] = 0.0863915992, ["py"] = 0.4309136113, ["pm"] = 227, },
    },
    ["n"] = "Breton Bedtime Stories (Loose Page)",
    ["cn"] = "Hearts and Flowers",
  },
  [1381] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Transmutation of Living Creatures",
    ["q"] = 4623,
    ["e"] = {
      [1] = { ["px"] = -0.0822344046, ["py"] = 0.2722044016, ["pm"] = 255, ["qp"] = true, }, -- on location DURING quest
      [2] = { ["px"] = -0.0809824071, ["py"] = 0.2753468027, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
    },
  },
  [1382] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1839100000,
        ["d"] = true,
        ["py"] = -0.0548500000,
        ["pm"] = 347,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "Deckhand's Log",
    ["cn"] = "Criminal Correspondence",
  },
  [1383] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Apothecary's Ledger",
    ["q"] = 4624,
    ["e"] = {
      [1] = { ["px"] = 0.5056723749, ["py"] = 0.7970144046, ["pm"] = 567, ["zm"] = 258, },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7976400000,
        ["px"] = 0.5078600000,
        ["pm"] = 258,
      },
    },
  },
  [1384] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1836600000,
        ["d"] = true,
        ["py"] = -0.0551400000,
        ["pm"] = 347,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "I Count the Nights",
    ["cn"] = "Hearts and Flowers",
  },
  [1385] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Promissory Note",
    ["q"] = 4631,
    ["e"] = {
      [1] = { ["px"] = 0.2259708018, ["py"] = 0.3915199950, ["pm"] = 538, ["zm"] = 30, },
    },
  },
  [1386] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1841500000,
        ["d"] = true,
        ["py"] = -0.0552600000,
        ["pm"] = 347,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "Windhelm Shipping Manifest",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1389] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1685264069, ["py"] = 0.4153196041, ["pm"] = 226, ["zx"] = 0.1681872037, ["zy"] = 0.4146331960, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Vanishing Crew",
    ["cn"] = "Diaries and Logs",
  },
  [1390] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1683776069, ["py"] = 0.4158204041, ["pm"] = 226, ["zx"] = 0.1681872037, ["zy"] = 0.4146331960, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Caught Him!",
    ["cn"] = "Diaries and Logs",
  },
  [1391] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1685812069, ["py"] = 0.4160312042, ["pm"] = 226, ["zx"] = 0.1681872037, ["zy"] = 0.4146331960, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Retreat!",
    ["cn"] = "Final Words",
  },
  [1392] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2093344069, ["py"] = 0.3779227963, ["pm"] = 224, ["zx"] = 0.2080355979, ["zy"] = 0.3768635923, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Note Written in Blood",
    ["cn"] = "Daedric Cults",
  },
  [1393] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2080528070, ["py"] = 0.3786331963, ["pm"] = 224, ["zx"] = 0.2080355979, ["zy"] = 0.3768635923, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "They Should Grovel",
    ["cn"] = "Daedric Cults",
  },
  [1394] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2372204065, ["py"] = 0.4142712134, ["pm"] = 230, ["zx"] = 0.2374351956, ["zy"] = 0.4141811966, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Letter to Mirudda",
    ["cn"] = "Letters and Missives",
  },
  [1395] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Fadeel",
    ["q"] = 4638,
    ["e"] = {
      [1] = { ["px"] = 0.2231800011, ["py"] = 0.3921691952, ["pm"] = 538, ["zm"] = 30, },
    },
  },
  [1396] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1409127944, ["py"] = 0.4110052128, ["pm"] = 246, ["zx"] = 0.1396068030, ["zy"] = 0.4121143921, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 2",
    ["cn"] = "Rituals and Revelations",
  },
  [1397] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1397683943, ["py"] = 0.4110096127, ["pm"] = 246, ["zx"] = 0.1396068030, ["zy"] = 0.4121143921, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Dwemer Maintenance Records",
    ["cn"] = "Research Notes",
  },
  [1398] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2065808047, ["py"] = 0.4249844115, ["pm"] = 231, ["zx"] = 0.2067940001, ["zy"] = 0.4240739940, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Letter from Quintus",
    ["cn"] = "Letters and Missives",
  },
  [1399] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2078700049, ["py"] = 0.4249424115, ["pm"] = 231, ["zx"] = 0.2067940001, ["zy"] = 0.4240739940, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayyas' Journal, Entry 10",
    ["cn"] = "Rituals and Revelations",
  },
  [1400] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2485792012, ["py"] = 0.4038483894, ["pm"] = 233, ["zx"] = 0.2486303969, ["zy"] = 0.4045863961, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 16",
    ["cn"] = "Rituals and Revelations",
  },
  [1401] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2474736013, ["py"] = 0.4038207894, ["pm"] = 233, ["zx"] = 0.2486303969, ["zy"] = 0.4045863961, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Tharayya's Journal, Entry 19",
    ["cn"] = "Rituals and Revelations",
  },
  [1402] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8005600000,
        ["px"] = 0.4972200000,
        ["pm"] = 258,
      },
      [2] = {
        ["pm"] = 258,
        ["px"] = 0.4972400000,
        ["d"] = true,
        ["py"] = 0.8005600000,
        ["mn"] = 21,
      },
    },
    ["n"] = "The Prowler's Log",
    ["cn"] = "Diaries and Logs",
  },
  [1403] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7990900000,
        ["px"] = 0.4936800000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Sky and Storm",
    ["cn"] = "Words of the Poets",
  },
  [1404] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7951100000,
        ["px"] = 0.5064900000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Harrani's Report",
    ["cn"] = "Criminal Correspondence",
  },
  [1405] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "The Notebook of Mage Gadris",
    ["q"] = 4623,
    ["e"] = {
      [1] = { ["px"] = -0.0811291979, ["py"] = 0.2793455955, ["pm"] = 353, ["d"] = true, ["qp"] = true, ["zx"] = -0.0805108051, ["zy"] = 0.2753884011, ["zm"] = 255, }, -- on location DURING quest
      [2] = { ["px"] = -0.0808559997, ["py"] = 0.2753079982, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
    },
  },
  [1406] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Catalyst Notes",
    ["q"] = 4623,
    ["e"] = {
      [1] = { ["px"] = -0.0811179977, ["py"] = 0.2793755955, ["pm"] = 353, ["d"] = true, ["qp"] = true, ["zx"] = -0.0805108051, ["zy"] = 0.2753884011, ["zm"] = 255, }, -- on location DURING quest
      [2] = { ["px"] = -0.0809188078, ["py"] = 0.2753396026, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
    },
  },
  [1407] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5647800000,
        ["px"] = 0.4641300000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5619900000,
        ["px"] = 0.4642400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Await My Emissary",
    ["cn"] = "Notes and Memos",
  },
  [1408] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5667500000,
        ["px"] = 0.4641600000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5563600000,
        ["px"] = 0.4660000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Gavo's Itinerary",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1409] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5668400000,
        ["px"] = 0.4658200000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The Key to Projection",
    ["cn"] = "Rituals and Revelations",
  },
  [1410] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3133012043, ["py"] = 0.7052496304, ["pm"] = 369, ["d"] = true,
        ["zx"] = 0.3151952038, ["zy"] = 0.7073311961, ["zm"] = 300,
      },
    },
    ["n"] = "The Book of Memories",
    ["cn"] = "Mysteries and Clues",
  },
  [1411] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Your Silver Fur",
    ["q"] = 4624,
    ["e"] = {
      [1] = { ["px"] = 0.5056723749, ["py"] = 0.7970144046, ["pm"] = 567, ["zm"] = 258, },
    },
  },
  [1412] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Where I'll Be",
    ["q"] = 4664,
    ["e"] = {
      [1] = { ["px"] = 0.5129416069, ["py"] = 0.7952839978, ["pm"] = 258, },
    },
  },
  [1413] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0880744005, ["py"] = 0.3570779984, ["pm"] = 724, ["zx"] = 0.0824784028, ["zy"] = 0.3531068025, ["zm"] = 1, ["d"] = true, },
    },
    ["n"] = "Journal of Habbert Unsinett",
    ["cn"] = "Personal Journals",
  },
  [1444] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6331800000,
        ["px"] = 0.4568800000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6370500000,
        ["px"] = 0.4571400000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.6416100000,
        ["px"] = 0.4608400000,
        ["pm"] = 256,
      },
      [4] = {
        ["mn"] = 17,
        ["py"] = 0.6321700000,
        ["px"] = 0.4620400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Notice to Authorities",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1445] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6375900000,
        ["px"] = 0.4585300000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6368200000,
        ["px"] = 0.4600100000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.6328500000,
        ["px"] = 0.4590500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Spikeball Handbill",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1446] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6376700000,
        ["px"] = 0.4625900000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Azum's Journal",
    ["cn"] = "Criminal Correspondence",
  },
  [1447] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Journal of Bravam Lythandas",
    ["q"] = 4667,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7988900000,
        ["px"] = 0.5015700000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7980500000,
        ["px"] = 0.5108300000,
        ["pm"] = 258,
      },
    },
  },
  [1448] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Masterwork of the Inducer",
    ["q"] = 4667,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8062400000,
        ["px"] = 0.5084800000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.8020700000,
        ["px"] = 0.5078300000,
        ["pm"] = 258,
      },
    },
  },
  [1449] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Ritual of Resonance",
    ["q"] = 4667,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8072700000,
        ["px"] = 0.5024900000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.8009300000,
        ["px"] = 0.5066500000,
        ["pm"] = 258,
      },
      [3] = {
        ["mn"] = 21,
        ["py"] = 0.7971900000,
        ["px"] = 0.5080100000,
        ["pm"] = 258,
      },
    },
  },
  [1450] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5056723749, ["py"] = 0.7970144046, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Forged Letter From \"Zali\"",
    ["cn"] = "Hearts and Flowers",
  },
  [1451] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6198100000,
        ["px"] = 0.4708500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Moon-Sugar in the March",
    ["cn"] = "The World and Its Creatures",
  },
  [1452] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6199600000,
        ["px"] = 0.4708800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Tales of the Two Moons Path Vol. 3",
    ["cn"] = "Tales of Tamriel",
  },
  [1453] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4702567810, ["py"] = 0.6204892081, ["pm"] = 256, },
    },
    ["n"] = "Enak-do's Ledger",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1454] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4702171797, ["py"] = 0.6197736075, ["pm"] = 256, },
    },
    ["n"] = "Pay Up, Enak",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1455] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Unwelcome Visitors",
    ["q"] = 4624,
    ["e"] = {
      [1] = { ["px"] = 0.5056723749, ["py"] = 0.7970144046, ["pm"] = 567, ["zm"] = 258, },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7963600000,
        ["px"] = 0.5074900000,
        ["pm"] = 258,
      },
    },
  },
  [1456] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4704247857, ["py"] = 0.6204972012, ["pm"] = 256, },
    },
    ["n"] = "Distribution Notes",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1457] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4702747852, ["py"] = 0.6201388034, ["pm"] = 256, },
    },
    ["n"] = "Cub Tales",
    ["cn"] = "Tales of Tamriel",
  },
  [1458] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4678355796, ["py"] = 0.6183964029, ["pm"] = 256, },
    },
    ["n"] = "Simple Illusion Magic",
    ["cn"] = "Rituals and Revelations",
  },
  [1459] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4940771823, ["py"] = 0.5673700063, ["pm"] = 256, },
    },
    ["n"] = "An Unexpected Defense",
    ["cn"] = "Tales of Tamriel",
  },
  [1461] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8008300000,
        ["px"] = 0.4973700000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Oblan's Letter",
    ["cn"] = "Letters and Missives",
  },
  [1462] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8087500000,
        ["px"] = 0.5006500000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Order of Battle (partial)",
    ["cn"] = "Military Orders and Reports",
  },
  [1463] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Transmutation Potion Recipe",
    ["q"] = 4623,
    ["e"] = {
      [1] = { ["px"] = -0.0833768082, ["py"] = 0.2741951961, ["pm"] = 255, ["qp"] = true, }, -- on location DURING quest
      [2] = { ["px"] = -0.0810092047, ["py"] = 0.2753556051, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
    },
  },
  [1464] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4954000141, ["py"] = 0.5671663994, ["pm"] = 116, ["zx"] = 0.4946131844, ["zy"] = 0.5674796062, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Cardia's Letter to Father",
    ["cn"] = "Hearts and Flowers",
  },
  [1475] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4940960140, ["py"] = 0.5688699992, ["pm"] = 116, ["zx"] = 0.4946131844, ["zy"] = 0.5674796062, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Sphinxmoth Bandit Leader's Notes",
    ["cn"] = "Criminal Correspondence",
  },
  [1476] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "The Fickle Nature of Mudcrabs",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 18,
      [201] = 12,
      [258] = 18,
      [75] = 9,
      [143] = 41,
      [74] = 1,
      [227] = 3,
      [7] = 6,
    },
  },
  [1477] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Witch Cults of Northern High Rock",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 19,
      [201] = 12,
      [258] = 1,
      [75] = 1,
      [143] = 38,
      [227] = 1,
      [7] = 19,
    },
  },
  [1478] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Necromancy in Modern Tamriel",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 20,
      [16] = 6,
      [255] = 18,
      [258] = 7,
      [74] = 18,
      [1060] = 2,
      [660] = 5,
      [1126] = 11,
      [7] = 18,
      [667] = 1,
      [75] = 2,
      [26] = 4,
      [27] = 8,
      [125] = 1,
      [13] = 13,
      [10] = 8,
      [143] = 49,
    },
  },
  [1479] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Revolting Life Cycle of the Dreugh",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 12,
      [13] = 10,
      [9] = 6,
      [27] = 2,
    },
  },
  [1480] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4299000000,
        ["px"] = 0.5330600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Dealing with Werewolves",
    ["cn"] = "The World and Its Creatures",
  },
  [1481] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Veloth the Pilgrim",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 6,
      [13] = 6,
      [9] = 11,
      [27] = 6,
    },
  },
  [1482] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Khajiiti Arms and Armor",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 7,
      [143] = 6,
      [1060] = 8,
      [660] = 7,
      [125] = 3,
      [1126] = 3,
      [7] = 7,
      [667] = 1,
      [9] = 6,
      [10] = 6,
      [27] = 11,
      [12] = 4,
      [13] = 17,
      [26] = 4,
      [255] = 26,
    },
  },
  [1483] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Notes on Elven Architecture",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [994] = 20,
      [1060] = 26,
      [1349] = 88,
      [439] = 1,
      [9] = 18,
      [61] = 2,
      [27] = 4,
      [12] = 6,
      [13] = 9,
      [1006] = 4,
      [1429] = 24,
    },
  },
  [1484] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "The Wood Elves of Valenwood",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 8,
      [143] = 4,
      [1060] = 3,
      [660] = 6,
      [125] = 1,
      [1126] = 1,
      [7] = 10,
      [667] = 2,
      [9] = 6,
      [26] = 4,
      [27] = 4,
      [12] = 14,
      [13] = 19,
      [10] = 13,
      [255] = 8,
    },
  },
  [1485] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Fury of King Ranser",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [300] = 22,
      [10] = 6,
      [26] = 14,
      [27] = 2,
    },
  },
  [1486] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Wergital the Wolf-Boy",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [300] = 14,
      [10] = 13,
      [26] = 14,
      [27] = 3,
    },
  },
  [1487] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Reverence for the Dead",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 4,
      [30] = 10,
      [61] = 3,
      [22] = 11,
      [27] = 1,
    },
  },
  [1488] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Nord Armorers and Armsmen",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [143] = 4,
      [61] = 20,
      [1060] = 10,
      [125] = 3,
      [1126] = 15,
      [7] = 8,
      [27] = 4,
      [26] = 4,
      [10] = 13,
      [667] = 2,
      [22] = 40,
      [13] = 4,
      [30] = 12,
      [255] = 6,
    },
  },
  [1489] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2875000000,
        ["py"] = 0.2716300000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "Wet Wilds of Black Marsh",
    ["cn"] = "The World and Its Creatures",
  },
  [1490] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Arboreal Architecture",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [22] = 13,
      [61] = 3,
      [30] = 9,
      [27] = 1,
    },
  },
  [1491] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Temples of the Dragon Cult",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1429] = 3,
      [1349] = 5,
    },
  },
  [1492] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Moon Worship among the Cat-Men",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 8,
      [27] = 5,
      [20] = 3,
      [125] = 9,
      [30] = 5,
    },
  },
  [1493] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Great Siege of Orsinium",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 6,
      [143] = 17,
      [20] = 7,
      [1060] = 1,
      [1126] = 4,
      [7] = 20,
      [660] = 2,
      [125] = 26,
      [10] = 7,
      [27] = 6,
      [256] = 4,
      [13] = 5,
      [26] = 4,
      [255] = 30,
    },
  },
  [1494] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Stormhold, City of Shadowfen",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 10,
      [125] = 5,
      [20] = 50,
      [27] = 4,
    },
  },
  [1495] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5426800000,
        ["px"] = 0.5749700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Myths and Legends of the Hist",
    ["cn"] = "Lore and Culture",
  },
  [1496] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Beware the Shadowscales",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 15,
      [125] = 20,
      [20] = 11,
      [27] = 4,
    },
  },
  [1497] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4915500000,
        ["px"] = 0.4999100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Ogres: A Summary",
    ["cn"] = "The World and Its Creatures",
  },
  [1498] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "The Origins of Conjuration",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 7,
      [143] = 3,
      [1060] = 2,
      [13] = 3,
      [20] = 10,
      [256] = 10,
      [1126] = 11,
      [7] = 8,
      [660] = 9,
      [9] = 1,
      [10] = 7,
      [27] = 5,
      [667] = 1,
      [125] = 4,
      [26] = 8,
      [255] = 17,
    },
  },
  [1499] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "How We Came to Coldharbour",
    ["e"] = {
      [1] = { ["px"] = -0.1293668012, ["py"] = 0.2856943980, ["pm"] = 255, },
    },
  },
  [1500] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "The Values of Haj Uxith",
    ["e"] = {
      [1] = { ["px"] = -0.1291708011, ["py"] = 0.2838127968, ["pm"] = 255, },
    },
  },
  [1501] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 255,
        ["px"] = -0.1285600000,
        ["d"] = true,
        ["py"] = 0.2759000000,
        ["mn"] = 23,
      },
    },
    ["n"] = "Warning to Citizens of Haj Uxith",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1502] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4711500000,
        ["px"] = 0.4975400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Chim-el Adabal: A Ballad",
    ["cn"] = "Words of the Poets",
  },
  [1503] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Coldharbour Compact",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 6,
      [1313] = 1,
      [994] = 5,
      [1060] = 19,
      [1349] = 31,
      [1126] = 40,
      [7] = 3,
      [10] = 12,
      [13] = 8,
      [1006] = 8,
      [143] = 8,
      [16] = 7,
      [20] = 10,
      [1429] = 8,
      [22] = 2,
      [439] = 1,
      [26] = 5,
      [27] = 8,
      [660] = 14,
      [125] = 3,
      [61] = 2,
      [255] = 11,
    },
  },
  [1511] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8052300000,
        ["px"] = 0.5067000000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.8006800000,
        ["px"] = 0.5001900000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Tale of Two Moons",
    ["cn"] = "Words of the Poets",
  },
  [1513] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3997600000,
        ["px"] = 0.2006200000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3925200000,
        ["px"] = 0.1468400000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.4022000000,
        ["px"] = 0.2026800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Memory Stone of Makela Leki, Pt. 1",
    ["cn"] = "Lore and Culture",
  },
  [1514] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3998500000,
        ["px"] = 0.1969100000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Memory Stone of Makela Leki, Pt. 2",
    ["cn"] = "Lore and Culture",
  },
  [1515] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8035300000,
        ["px"] = 0.5093400000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Zaban-ma's Journal",
    ["cn"] = "Personal Journals",
  },
  [1516] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8060400000,
        ["px"] = 0.5113300000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Last Warning, Cat",
    ["cn"] = "Criminal Correspondence",
  },
  [1517] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8052400000,
        ["px"] = 0.5125000000,
        ["pm"] = 258,
      },
    },
    ["n"] = "The Perfect Batch",
    ["cn"] = "Criminal Correspondence",
  },
  [1519] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3970700000,
        ["px"] = 0.1451500000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4174800000,
        ["px"] = 0.1490900000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Alik'r (Second Era)",
    ["cn"] = "Tales of Tamriel",
  },
  [1520] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3944400000,
        ["px"] = 0.1480400000,
        ["pm"] = 30,
      },
      [2] = { ["px"] = 0.1420283929, ["py"] = 0.3977868022, ["pm"] = 83, ["zm"] = 30, },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.4021000000,
        ["px"] = 0.2027100000,
        ["pm"] = 30,
      },
    },
    ["n"] = "On the Immortality of Dust",
    ["cn"] = "Words of the Poets",
  },
  [1521] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4019400000,
        ["px"] = 0.1735100000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4026900000,
        ["px"] = 0.1711400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Note to Throne Keeper Farvad",
    ["cn"] = "Notes and Memos",
  },
  [1522] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3650400000,
        ["px"] = 0.2018500000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3692200000,
        ["px"] = 0.1936800000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.3766000000,
        ["px"] = 0.1930200000,
        ["pm"] = 30,
      },
      [4] = {
        ["mn"] = 5,
        ["py"] = 0.3741800000,
        ["px"] = 0.1920100000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Shipyard Workers, Take Warning!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1523] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5663400000,
        ["px"] = 0.4923600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The Fort Sphinxmoth Ruins",
    ["cn"] = "The World and Its Creatures",
  },
  [1524] = {
    ["c"] = true,
    ["r"] = true,
    ["m"] = {
      [1060] = 1,
      [30] = 4,
    },
    ["e"] = {
    },
    ["n"] = "The Book of Circles, Sundas Maxims",
    ["cn"] = "Lore and Culture",
  },
  [1525] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4230600000,
        ["px"] = 0.1871900000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3955600000,
        ["px"] = 0.1407100000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.3804900000,
        ["px"] = 0.2383500000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Book of Circles, Tirdas Maxims",
    ["cn"] = "Lore and Culture",
  },
  [1526] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1918248034, ["py"] = 0.4265956108, ["pm"] = 539, ["zm"] = 30, },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4265600000,
        ["px"] = 0.1943100000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.4214800000,
        ["px"] = 0.1889700000,
        ["pm"] = 30,
      },
    },
    ["n"] = "A Betrayal of Our Heritage",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1527] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "The Ballad of Navid the Singer",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [994] = 11,
      [1060] = 23,
      [1429] = 4,
      [439] = 3,
      [1349] = 15,
      [26] = 5,
      [27] = 1,
      [300] = 17,
      [61] = 7,
      [1006] = 10,
      [10] = 5,
    },
  },
  [1528] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3730600000,
        ["px"] = 0.2404200000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3758400000,
        ["px"] = 0.2330200000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Blessed, Blessed Satakalaam",
    ["cn"] = "The World and Its Creatures",
  },
  [1529] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6252900000,
        ["px"] = 0.4689100000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Lauron's Journal",
    ["cn"] = "Research Notes",
  },
  [1530] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4986184138, ["py"] = 0.5703483990, ["pm"] = 116, ["zx"] = 0.4946131844, ["zy"] = 0.5674796062, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Note to Pellus",
    ["cn"] = "Criminal Correspondence",
  },
  [1531] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4982600000,
        ["py"] = 0.5697500000,
        ["d"] = true,
        ["pm"] = 116,
      },
    },
    ["n"] = "Note to Cardia",
    ["cn"] = "Hearts and Flowers",
  },
  [1532] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4956600000,
        ["py"] = 0.5655000000,
        ["d"] = true,
        ["pm"] = 116,
      },
    },
    ["n"] = "Note to Darius",
    ["cn"] = "Criminal Correspondence",
  },
  [1533] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4959324139, ["py"] = 0.5714387993, ["pm"] = 116, ["zx"] = 0.4946131844, ["zy"] = 0.5674796062, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Note from Captain Accalia",
    ["cn"] = "Criminal Correspondence",
  },
  [1534] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4954460141, ["py"] = 0.5671583992, ["pm"] = 116, ["zx"] = 0.4946131844, ["zy"] = 0.5674796062, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Letter to a Scoundrel",
    ["cn"] = "Final Words",
  },
  [1535] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "On Summoning Skeletons",
    ["e"] = {
      [1] = { ["px"] = -0.1137840016, ["py"] = 0.2350640015, ["pm"] = 266, ["d"] = true, ["zx"] = -0.1141548025, ["zy"] = 0.2351692038, ["zm"] = 255, },
    },
  },
  [1536] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Necromancy: The Great Debate",
    ["e"] = {
      [1] = { ["px"] = -0.1142388016, ["py"] = 0.2354336015, ["pm"] = 266, ["d"] = true, ["zx"] = -0.1141548025, ["zy"] = 0.2351692038, ["zm"] = 255, },
    },
  },
  [1537] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Party Theme",
    ["e"] = {
      [1] = { ["px"] = -0.1112900022, ["py"] = 0.2765292073, ["pm"] = 261, ["d"] = true, ["zx"] = -0.1123148047, ["zy"] = 0.2775968011, ["zm"] = 255, },
      [2] = { ["px"] = -0.1111016021, ["py"] = 0.2766520072, ["pm"] = 261, ["d"] = true, },
    },
  },
  [1538] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Perfect Host",
    ["e"] = {
      [1] = { ["px"] = -0.1104592022, ["py"] = 0.2767192074, ["pm"] = 261, ["d"] = true, ["zx"] = -0.1123148047, ["zy"] = 0.2775968011, ["zm"] = 255, },
    },
  },
  [1540] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5894800000,
        ["px"] = 0.4744200000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5898200000,
        ["px"] = 0.4724300000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5818300000,
        ["px"] = 0.4757400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Resources for Lukiul",
    ["cn"] = "Criminal Correspondence",
  },
  [1541] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5899600000,
        ["px"] = 0.4745100000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5901600000,
        ["px"] = 0.4723700000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5818500000,
        ["px"] = 0.4757700000,
        ["pm"] = 256,
      },
    },
    ["n"] = "New Opportunities",
    ["cn"] = "Notes and Memos",
  },
  [1542] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5897500000,
        ["px"] = 0.4743500000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5818800000,
        ["px"] = 0.4757400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Desperate Time",
    ["cn"] = "Notes and Memos",
  },
  [1543] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5883200000,
        ["px"] = 0.4714900000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5874700000,
        ["px"] = 0.4725900000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5819200000,
        ["px"] = 0.4757400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Crumpled Note in the Desk",
    ["cn"] = "Notes and Memos",
  },
  [1544] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5882900000,
        ["px"] = 0.4713200000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5876700000,
        ["px"] = 0.4727800000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5818900000,
        ["px"] = 0.4757000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Lerineaux's Concerns",
    ["cn"] = "Plots and Schemes",
  },
  [1545] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5883300000,
        ["px"] = 0.4710700000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5818200000,
        ["px"] = 0.4757400000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5873400000,
        ["px"] = 0.4727100000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Wounded Lion",
    ["cn"] = "Notes and Memos",
  },
  [1546] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Note from Alasan",
    ["q"] = 2251,
    ["e"] = {
      [1] = { ["px"] = 0.1894395939, ["py"] = 0.4276664132, ["pm"] = 728, ["zm"] = 30, ["d"] = true, },
      [2] = { ["px"] = 0.1874744035, ["py"] = 0.4277376110, ["pm"] = 539, ["fp"] = true, },
    },
  },
  [1547] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Letter of Understanding",
    ["q"] = 4687,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5897800000,
        ["px"] = 0.4744800000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5897100000,
        ["px"] = 0.4726300000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 17,
        ["py"] = 0.5819500000,
        ["px"] = 0.4756800000,
        ["pm"] = 256,
      },
    },
  },
  [1548] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "To Captain Marck",
    ["q"] = 4687,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5882200000,
        ["px"] = 0.4712100000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5818900000,
        ["px"] = 0.4757200000,
        ["pm"] = 256,
      },
    },
  },
  [1550] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1840092034, ["py"] = 0.4241652113, ["pm"] = 539, ["zm"] = 30, },
    },
    ["n"] = "Fakimal's Letter",
    ["cn"] = "Final Words",
  },
  [1552] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Everfull Flagon Journal, Page 1",
    ["e"] = {
      [1] = { ["px"] = -0.0651831991, ["py"] = 0.2788292011, ["pm"] = 255, },
    },
  },
  [1553] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Everfull Flagon Journal, Page 2",
    ["e"] = {
      [1] = { ["px"] = -0.0644351991, ["py"] = 0.2783423977, ["pm"] = 255, },
    },
  },
  [1554] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Everfull Flagon Journal, Page 3",
    ["e"] = {
      [1] = { ["px"] = -0.0652948058, ["py"] = 0.2789596041, ["pm"] = 255, },
    },
  },
  [1555] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5821900000,
        ["px"] = 0.4760600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Zurka's Orders",
    ["cn"] = "Notes and Memos",
  },
  [1556] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5826100000,
        ["px"] = 0.4762800000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5818900000,
        ["px"] = 0.4757200000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Recruiting a Ranger",
    ["cn"] = "Criminal Correspondence",
  },
  [1558] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5825100000,
        ["px"] = 0.4763800000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5819000000,
        ["px"] = 0.4756600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Notable Transactions",
    ["cn"] = "Criminal Correspondence",
  },
  [1559] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8066500000,
        ["px"] = 0.5028600000,
        ["pm"] = 258,
      },
    },
    ["n"] = "The Falconer's Log",
    ["cn"] = "Final Words",
  },
  [1560] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8047300000,
        ["px"] = 0.4995800000,
        ["pm"] = 258,
      },
    },
    ["n"] = "The Little Alkosh's Log",
    ["cn"] = "Final Words",
  },
  [1561] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7940400000,
        ["px"] = 0.4980300000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Care of Kwama",
    ["cn"] = "The World and Its Creatures",
  },
  [1562] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Guild Mage's Journal",
    ["e"] = {
      [1] = { ["px"] = -0.0702379969, ["py"] = 0.2422944026, ["pm"] = 593, ["d"] = true, ["zx"] = -0.0704004027, ["zy"] = 0.2419179973, ["zm"] = 255, },
    },
  },
  [1563] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5151076074, ["py"] = 0.8018019968, ["pm"] = 258, },
    },
    ["n"] = "What Eats Birds?",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1564] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8025400000,
        ["px"] = 0.5121100000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Khenarthi's Roost: Interim Orders",
    ["cn"] = "Notes and Memos",
  },
  [1565] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8003600000,
        ["px"] = 0.5113100000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Wind-Ripped Page",
    ["cn"] = "Diaries and Logs",
  },
  [1566] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["zy"] = 0.6289127801,
        ["x"] = 0.5045100000,
        ["zx"] = 0.4596879900,
        ["y"] = 0.8029700000,
        ["z"] = 537,
      },
    },
    ["k"] = 1566,
  },
  [1567] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8038300000,
        ["px"] = 0.5043900000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Letter from Karpu-sa",
    ["cn"] = "Letters and Missives",
  },
  [1568] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8047900000,
        ["px"] = 0.5083100000,
        ["pm"] = 258,
      },
    },
    ["n"] = "A Word to the Wise",
    ["cn"] = "Criminal Correspondence",
  },
  [1569] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5139720206, ["py"] = 0.7975716134, ["pm"] = 605, ["zx"] = 0.5122412075, ["zy"] = 0.7956667969, ["zm"] = 258, ["d"] = true, },
    },
    ["n"] = "No Reason to Worry",
    ["cn"] = "Criminal Correspondence",
  },
  [1570] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8024600000,
        ["px"] = 0.5043800000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.8059600000,
        ["px"] = 0.5024400000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Sugarbelly",
    ["cn"] = "The World and Its Creatures",
  },
  [1572] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8025200000,
        ["px"] = 0.4992800000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Rakamud's Letter",
    ["cn"] = "Letters and Missives",
  },
  [1573] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6324500000,
        ["px"] = 0.4500300000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6495500000,
        ["px"] = 0.4402300000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Battle of Thormar",
    ["cn"] = "Mysteries and Clues",
  },
  [1574] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6524700000,
        ["px"] = 0.4372600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "A Midnight Ambush",
    ["cn"] = "Rituals and Revelations",
  },
  [1575] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6084600000,
        ["px"] = 0.4219700000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Battle of Falinesti",
    ["cn"] = "Mysteries and Clues",
  },
  [1576] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7976300000,
        ["px"] = 0.5018100000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Thank You for Your Patience",
    ["cn"] = "Notes and Memos",
  },
  [1577] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5065451748, ["py"] = 0.7951532046, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Increased Bandit Activity",
    ["cn"] = "Notes and Memos",
  },
  [1578] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5065663748, ["py"] = 0.7951540045, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Rats in the Crops",
    ["cn"] = "Letters and Missives",
  },
  [1579] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7981500000,
        ["px"] = 0.4997700000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Unavoidable Delays",
    ["cn"] = "Notes and Memos",
  },
  [1580] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7927300000,
        ["px"] = 0.5146000000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Salvager's Torn Journal",
    ["cn"] = "Personal Journals",
  },
  [1581] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 258,
        ["px"] = 0.5145400000,
        ["d"] = true,
        ["py"] = 0.8008600000,
        ["mn"] = 21,
      },
    },
    ["n"] = "Rurelion's Observation #1",
    ["cn"] = "Research Notes",
  },
  [1582] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8083500000,
        ["px"] = 0.5069200000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7957500000,
        ["px"] = 0.4992900000,
        ["pm"] = 258,
      },
      [3] = {
        ["mn"] = 21,
        ["py"] = 0.7937200000,
        ["px"] = 0.5009500000,
        ["pm"] = 258,
      },
      [4] = {
        ["mn"] = 21,
        ["py"] = 0.8049800000,
        ["px"] = 0.5083000000,
        ["pm"] = 258,
      },
      [5] = {
        ["mn"] = 21,
        ["py"] = 0.7976400000,
        ["px"] = 0.5017600000,
        ["pm"] = 258,
      },
      [6] = {
        ["mn"] = 21,
        ["py"] = 0.8003900000,
        ["px"] = 0.5111200000,
        ["pm"] = 258,
      },
      [7] = {
        ["mn"] = 21,
        ["py"] = 0.7953600000,
        ["px"] = 0.5066900000,
        ["pm"] = 258,
      },
      [8] = {
        ["pm"] = 258,
        ["px"] = 0.5133700000,
        ["d"] = true,
        ["py"] = 0.7972500000,
        ["mn"] = 21,
      },
      [9] = { ["px"] = 0.5073455748, ["py"] = 0.7959540044, ["pm"] = 567, ["zm"] = 258, },
      [10] = {
        ["pm"] = 258,
        ["px"] = 0.5005500000,
        ["d"] = true,
        ["py"] = 0.8011700000,
        ["mn"] = 21,
      },
      [11] = {
        ["mn"] = 21,
        ["py"] = 0.8023200000,
        ["px"] = 0.5121200000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Bolga's Guide to Island Beasts",
    ["cn"] = "The World and Its Creatures",
  },
  [1583] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5147280060, ["py"] = 0.8006296040, ["pm"] = 329, ["zx"] = 0.5140580067, ["zy"] = 0.8007595983, ["zm"] = 258, ["d"] = true, },
    },
    ["n"] = "Mourning Springs Burial Rites",
    ["cn"] = "Lore and Culture",
  },
  [1584] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5159240060, ["py"] = 0.8007108041, ["pm"] = 329, ["zx"] = 0.5140580067, ["zy"] = 0.8007595983, ["zm"] = 258, ["d"] = true, },
    },
    ["n"] = "Rurelion's Observation #3",
    ["cn"] = "Research Notes",
  },
  [1585] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5144552064, ["py"] = 0.8009639974, ["pm"] = 258, },
    },
    ["n"] = "Rurelion's Observation #2",
    ["cn"] = "Research Notes",
  },
  [1586] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5143624081, ["py"] = 0.8009719968, ["pm"] = 258, },
    },
    ["n"] = "Ealcil's Journal",
    ["cn"] = "Research Notes",
  },
  [1587] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5171004058, ["py"] = 0.8008180040, ["pm"] = 329, ["zx"] = 0.5140580067, ["zy"] = 0.8007595983, ["zm"] = 258, ["d"] = true, },
    },
    ["n"] = "Lost and Dusty Journal",
    ["cn"] = "Final Words",
  },
  [1588] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3721300000,
        ["px"] = 0.0924500000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Red Rook's Journal",
    ["cn"] = "Criminal Correspondence",
  },
  [1589] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3953500000,
        ["px"] = 0.2116600000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Notice of Honorable Discharge",
    ["cn"] = "Military Orders and Reports",
  },
  [1591] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Legend of Haman Forgefire",
    ["e"] = {
      [1] = { ["px"] = -0.0683048002, ["py"] = 0.2667428074, ["pm"] = 352, ["d"] = true, ["zx"] = -0.0684584066, ["zy"] = 0.2669223970, ["zm"] = 255, },
    },
  },
  -- TODO What does this mean
  [1592] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "A Moment of Your Time?",
    ["q"] = 4748,
    ["e"] = {
      [1] = { ["px"] = -0.1188796049, ["py"] = 0.2387415985, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
      [2] = { ["px"] = -0.1264632053, ["py"] = 0.2388635997, ["pm"] = 255, }, -- on location ONLY at quest-start
      [3] = { ["px"] = -0.1209504018, ["py"] = 0.2366403989, ["pm"] = 255, }, -- on location ONLY at quest-start
      [4] = { ["px"] = -0.1235028047, ["py"] = 0.2357559975, ["pm"] = 255, }, -- on location ONLY at quest-start
      [5] = { ["px"] = -0.1269984016, ["py"] = 0.2359748046, ["pm"] = 255, }, -- on location ONLY at quest-start
    },
  },
  -- TODO What does this mean
  [1593] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "If I May Beseech You",
    ["q"] = 4748,
    ["e"] = {
      [1] = { ["px"] = -0.1188524017, ["py"] = 0.2387856002, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
      [2] = { ["px"] = -0.1248508019, ["py"] = 0.2377668001, ["pm"] = 255, }, -- on location ONLY during quest
      [3] = { ["px"] = -0.1222916045, ["py"] = 0.2370908012, ["pm"] = 255, }, -- on location ONLY during quest
      [4] = { ["px"] = -0.1272012013, ["py"] = 0.2359680051, ["pm"] = 255, }, -- on location ONLY during quest
      [5] = { ["px"] = -0.1276208053, ["py"] = 0.2340016048, ["pm"] = 255, }, -- on location ONLY during quest
    },
  },
  -- TODO What does this mean
  [1594] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Situation Becoming Urgent",
    ["q"] = 4748,
    ["e"] = {
      [1] = { ["px"] = -0.1188352026, ["py"] = 0.2387788007, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
      [2] = { ["px"] = -0.1248936020, ["py"] = 0.2349427959, ["pm"] = 255, }, -- on location ONLY during quest
      [3] = { ["px"] = -0.1274224018, ["py"] = 0.2342012049, ["pm"] = 255, }, -- on location ONLY during quest
    },
  },
  -- TODO What does this mean
  [1595] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Prompt Rescue is Imperative",
    ["q"] = 4748,
    ["e"] = {
      [1] = { ["px"] = -0.1188412010, ["py"] = 0.2388020033, ["pm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
      [2] = { ["px"] = -0.1289724026, ["py"] = 0.2319243989, ["pm"] = 255, }, -- on location ONLY during quest
      [3] = { ["px"] = -0.1285708039, ["py"] = 0.2312020048, ["pm"] = 255, }, -- on location ONLY during quest
    },
  },
  [1596] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "On Pircalmo's Emergency Reversal",
    ["q"] = 4740,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6518700000,
        ["px"] = 0.4461300000,
        ["pm"] = 256,
      },
    },
  },
  [1597] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7229127925, ["py"] = 0.5497703920, ["pm"] = 26, },
    },
    ["n"] = "Need More Animus Geodes",
    ["cn"] = "Research Notes",
  },
  [1598] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7181100184, ["py"] = 0.5807859908, ["pm"] = 138, ["d"] = true,
        ["zx"] = 0.7213615906, ["zy"] = 0.5794835916, ["zm"] = 26,
      },
    },
    ["n"] = "Angry Angry",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1599] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7253063922, ["py"] = 0.5850003948, ["pm"] = 26, },
    },
    ["n"] = "White Rose Guard's Journal",
    ["cn"] = "Personal Journals",
  },
  [1600] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4375183974, ["py"] = 0.7232872004, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = {
        ["px"] = 0.4375700000,
        ["py"] = 0.7233400000,
        ["d"] = true,
        ["pm"] = 1143,
      },
      [3] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "The Realm of Shadows",
    ["cn"] = "Rituals and Revelations",
  },
  [1601] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4628800000,
        ["py"] = 0.5840800000,
        ["d"] = true,
        ["pm"] = 343,
      },
    },
    ["n"] = "Notice: New Working Conditions",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1602] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4632200000,
        ["py"] = 0.5838200000,
        ["d"] = true,
        ["pm"] = 343,
      },
    },
    ["n"] = "Anyone, Please",
    ["cn"] = "Final Words",
  },
  [1603] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4631300000,
        ["py"] = 0.5835000000,
        ["d"] = true,
        ["pm"] = 343,
      },
    },
    ["n"] = "The Arena!",
    ["cn"] = "Notes and Memos",
  },
  [1604] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5647200000,
        ["px"] = 0.4654700000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5590500000,
        ["px"] = 0.4656800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Funny Stuff, Sil",
    ["cn"] = "Notes and Memos",
  },
  [1605] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "On the Matter of the Prisoners",
    ["e"] = {
      [1] = { ["px"] = -0.0793828017, ["py"] = 0.2466168032, ["pm"] = 255, },
    },
  },
  [1606] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "A Reminder from the Judge",
    ["e"] = {
      [1] = { ["px"] = -0.0784488006, ["py"] = 0.2500640022, ["pm"] = 255, },
    },
  },
  [1607] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5047007747, ["py"] = 0.7978052047, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Hinaamo's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1608] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7273600000,
        ["px"] = 0.3073800000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Blasphemous Revenants",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1609] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4273927871, ["py"] = 0.5669463986, ["pm"] = 317, ["zx"] = 0.4282907834, ["zy"] = 0.5656224064, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Experiment Journal",
    ["cn"] = "Research Notes",
  },
  [1610] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4278355872, ["py"] = 0.5659704110, ["pm"] = 763, ["zx"] = 0.4282907834, ["zy"] = 0.5656224064, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Missive from Cyrodiil",
    ["cn"] = "Military Orders and Reports",
  },
  [1611] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4278023872, ["py"] = 0.5658960110, ["pm"] = 764, ["zx"] = 0.4282907834, ["zy"] = 0.5656224064, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Graccus' Journal, Volume I",
    ["cn"] = "Daedric Cults",
  },
  [1612] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4394500000,
        ["py"] = 0.5989500000,
        ["d"] = true,
        ["pm"] = 323,
      },
    },
    ["n"] = "Captain Fanimanwe's Journal",
    ["cn"] = "Final Words",
  },
  [1613] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1846800051, ["py"] = -0.0583992038, ["pm"] = 344, ["d"] = true,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "Captain Blackheart's Log",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1614] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1840100000,
        ["d"] = true,
        ["py"] = -0.0553400000,
        ["pm"] = 347,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "Martha's Journal",
    ["cn"] = "Personal Journals",
  },
  [1617] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2287100000,
        ["py"] = 0.3056100000,
        ["d"] = true,
        ["pm"] = 194,
      },
      [2] = {
        ["px"] = 0.3817000000,
        ["py"] = 0.6827400000,
        ["d"] = true,
        ["pm"] = 414,
      },
      [3] = {
        ["mn"] = 15,
        ["py"] = 0.7413900000,
        ["px"] = 0.2459600000,
        ["pm"] = 143,
      },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3922100000,
        ["px"] = 0.0765900000,
        ["pm"] = 1,
      },
      [5] = {
        ["mn"] = 11,
        ["py"] = 0.4361100000,
        ["px"] = 0.7703600000,
        ["pm"] = 7,
      },
      [6] = {
        ["px"] = 0.8399500000,
        ["py"] = 0.4990000000,
        ["d"] = true,
        ["pm"] = 123,
      },
    },
    ["n"] = "The Duchess of Anguish",
    ["cn"] = "The Five Companions",
  },
  [1618] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3817400000,
        ["py"] = 0.6824000000,
        ["d"] = true,
        ["pm"] = 414,
      },
      [2] = {
        ["px"] = 0.2284800000,
        ["py"] = 0.3051100000,
        ["d"] = true,
        ["pm"] = 194,
      },
      [3] = {
        ["mn"] = 15,
        ["py"] = 0.7414600000,
        ["px"] = 0.2459700000,
        ["pm"] = 143,
      },
      [4] = {
        ["px"] = 0.8401900000,
        ["py"] = 0.4991200000,
        ["d"] = true,
        ["pm"] = 123,
      },
      [5] = {
        ["mn"] = 11,
        ["py"] = 0.4361100000,
        ["px"] = 0.7703500000,
        ["pm"] = 7,
      },
      [6] = {
        ["mn"] = 2,
        ["py"] = 0.3921800000,
        ["px"] = 0.0763600000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Unbreakable Redguard",
    ["cn"] = "The Five Companions",
  },
  [1619] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 15,
        ["py"] = 0.7413500000,
        ["px"] = 0.2458900000,
        ["pm"] = 143,
      },
      [2] = {
        ["px"] = 0.3815500000,
        ["py"] = 0.6829000000,
        ["d"] = true,
        ["pm"] = 414,
      },
      [3] = {
        ["px"] = 0.2282300000,
        ["py"] = 0.3052700000,
        ["d"] = true,
        ["pm"] = 194,
      },
      [4] = {
        ["mn"] = 11,
        ["py"] = 0.4361600000,
        ["px"] = 0.7703300000,
        ["pm"] = 7,
      },
      [5] = {
        ["px"] = 0.8400500000,
        ["py"] = 0.4990600000,
        ["d"] = true,
        ["pm"] = 123,
      },
      [6] = {
        ["mn"] = 2,
        ["py"] = 0.3921800000,
        ["px"] = 0.0763000000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Chim-el Adabal",
    ["cn"] = "The Five Companions",
  },
  [1620] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7952511787,
        ["py"] = 0.4331460016,
        ["pm"] = 72,
        ["d"] = true,
        ["zx"] = 0.7940827904, ["zy"] = 0.4318587984, ["zm"] = 7
      },
      [2] = {
        ["px"] = 0.7952867795,
        ["py"] = 0.4327892067,
        ["pm"] = 719,
        ["d"] = true,
        ["zx"] = 0.7940827904, ["zy"] = 0.4318587984, ["zm"] = 7
      },
      [3] = {
        ["px"] = 0.7957003785,
        ["py"] = 0.4326320016,
        ["pm"] = 72,
        ["fp"] = true, -- Tower Undercroft entrance
      },
      [4] = {
        ["px"] = 0.7958767785,
        ["py"] = 0.4331340016,
        ["d"] = true,
        ["pm"] = 72,
        ["zx"] = 0.7940827904, ["zy"] = 0.4318587984, ["zm"] = 7
      },
    },
    ["n"] = "Crow's Spell of Binding",
    ["cn"] = "Rituals and Revelations",
  },
  [1621] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8207600000,
        ["py"] = 0.5231800000,
        ["d"] = true,
        ["pm"] = 1153,
      },
    },
    ["n"] = "Ithisa's Journal",
    ["cn"] = "Personal Journals",
  },
  [1622] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1863387932, ["py"] = -0.0553035967, ["pm"] = 346, ["d"] = true,
        ["zx"] = 0.2790136075, ["zy"] = 0.3050587966, ["zm"] = 20,
      },
    },
    ["n"] = "Quartermaster's Log",
    ["cn"] = "Diaries and Logs",
  },
  [1623] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3447167977, ["py"] = 0.6132304079, ["pm"] = 175, ["d"] = true,
        ["zx"] = 0.3466539975, ["zy"] = 0.6114556158, ["zm"] = 22,
      },
    },
    ["n"] = "Letter to Kathner",
    ["cn"] = "Letters and Missives",
  },
  [1625] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Mal Sorra's Curse",
    ["e"] = {
      [1] = { ["px"] = -0.1067244013, ["py"] = 0.2311179988, ["pm"] = 322, ["d"] = true, ["zx"] = -0.1072056027, ["zy"] = 0.2305796012, ["zm"] = 255, },
    },
  },
  [1626] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Ealcil's Notes, Page 1",
    ["q"] = 4621,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7924800000,
        ["px"] = 0.5097300000,
        ["pm"] = 258,
      },
    },
  },
  [1627] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Ealcil's Notes, Page 2",
    ["q"] = 4621,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7924700000,
        ["px"] = 0.5097600000,
        ["pm"] = 258,
      },
    },
  },
  [1628] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Ealcil's Notes, Page 3",
    ["q"] = 4621,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7924600000,
        ["px"] = 0.5097400000,
        ["pm"] = 258,
      },
    },
  },
  [1629] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3999600000,
        ["px"] = 0.2020600000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4034500000,
        ["px"] = 0.2004900000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Words of the Masters",
    ["cn"] = "Lore and Culture",
  },
  [1630] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3992000000,
        ["px"] = 0.2049800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Blessed Dagger",
    ["cn"] = "Tales of Tamriel",
  },
  [1631] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4169400000,
        ["py"] = 0.6493500000,
        ["d"] = true,
        ["pm"] = 335,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5905800000,
        ["px"] = 0.4948100000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Journal of Elias",
    ["cn"] = "Final Words",
  },
  [1632] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4027300000,
        ["px"] = 0.2033100000,
        ["pm"] = 30,
      },
      [2] = { ["px"] = 0.1537427926, ["py"] = 0.4000332035, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "A Forebear Warrior's Song",
    ["cn"] = "Words of the Poets",
  },
  [1634] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5650900000,
        ["px"] = 0.4658900000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5579600000,
        ["px"] = 0.4620200000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Big Damn Bugs",
    ["cn"] = "Diaries and Logs",
  },
  [1635] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5649800000,
        ["px"] = 0.4655100000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5632500000,
        ["px"] = 0.4633900000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Why the Projections?",
    ["cn"] = "Diaries and Logs",
  },
  [1636] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5668300000,
        ["px"] = 0.4643400000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5550500000,
        ["px"] = 0.4623300000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Who Asked Them Here?",
    ["cn"] = "Final Words",
  },
  [1637] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5559300000,
        ["px"] = 0.4670700000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5650700000,
        ["px"] = 0.4641500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "How Much Longer?",
    ["cn"] = "Diaries and Logs",
  },
  [1638] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5650100000,
        ["px"] = 0.4643100000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5585300000,
        ["px"] = 0.4617000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Rotten Bread and Spoiled Meat",
    ["cn"] = "Diaries and Logs",
  },
  [1639] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5668300000,
        ["px"] = 0.4643400000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5556300000,
        ["px"] = 0.4660200000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Admission Denied",
    ["cn"] = "Notes and Memos",
  },
  [1640] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6519400000,
        ["px"] = 0.4461000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Unfinished Letter to Summerset",
    ["cn"] = "Letters and Missives",
  },
  [1641] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6518700000,
        ["px"] = 0.4461300000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Tamrielic Calligraphy, Chapter VII",
    ["cn"] = "Lore and Culture",
  },
  [1642] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6519400000,
        ["px"] = 0.4461000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Pircalmo's Shopping List",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1644] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5667500000,
        ["px"] = 0.4658100000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5615500000,
        ["px"] = 0.4661800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Not That Bad",
    ["cn"] = "Diaries and Logs",
  },
  [1645] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5668200000,
        ["px"] = 0.4655700000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5586100000,
        ["px"] = 0.4633800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "These Damned Cats",
    ["cn"] = "Military Orders and Reports",
  },
  [1646] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Note to Menthery",
    ["e"] = {
      [1] = { ["px"] = -0.0929536015, ["py"] = 0.2098180023, ["pm"] = 255, },
    },
  },
  [1647] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1865620032, ["py"] = 0.4230572114, ["pm"] = 539, ["zm"] = 30, },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3917600000,
        ["px"] = 0.1508500000,
        ["pm"] = 30,
      },
      [3] = {
        ["pm"] = 30,
        ["px"] = 0.1508500000,
        ["d"] = true,
        ["py"] = 0.3917300000,
        ["mn"] = 5,
      },
      [4] = {
        ["mn"] = 5,
        ["py"] = 0.3936600000,
        ["px"] = 0.1468400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Epode of the Ansei Wards",
    ["cn"] = "Words of the Poets",
  },
  [1648] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1471111923, ["py"] = 0.3928392027, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "Receipt for Arcane Tomes",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1649] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1530279928, ["py"] = 0.3944716031, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "The Book of Circles: Forging Maxims",
    ["cn"] = "Skill Books",
  },
  [1650] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1437267929, ["py"] = 0.3938260025, ["pm"] = 83, ["zm"] = 30, },
      [2] = { ["px"] = 0.1454127924, ["py"] = 0.3946004025, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "The 26th of First Seed is Upon Us!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1651] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3806800000,
        ["px"] = 0.2393800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Nahirah's Journal",
    ["cn"] = "Personal Journals",
  },
  [1652] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Deathbringer Orders",
    ["e"] = {
      [1] = { ["px"] = -0.0719499972, ["py"] = 0.2089776008, ["pm"] = 263, ["d"] = true, ["zx"] = -0.0723779987, ["zy"] = 0.2083536016, ["zm"] = 255, },
    },
  },
  [1653] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Note to Arida",
    ["e"] = {
      [1] = { ["px"] = -0.0986624052, ["py"] = 0.2083632001, ["pm"] = 255, },
    },
  },
  [1654] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6329208273, ["py"] = 0.2663999997, ["pm"] = 160, ["zm"] = 61, },
    },
    ["n"] = "Clans of Eastmarch: The Direfrost",
    ["cn"] = "Lore and Culture",
  },
  [1655] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6710600000,
        ["px"] = 0.3219000000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Elphirion's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1656] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3209000000,
        ["py"] = 0.6816800000,
        ["d"] = true,
        ["pm"] = 367,
      },
    },
    ["n"] = "General Malgoth's Journal",
    ["cn"] = "Final Words",
  },
  [1657] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6736500000,
        ["px"] = 0.3227300000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Glonnir's Letter",
    ["cn"] = "Final Words",
  },
  [1658] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6786200000,
        ["px"] = 0.3227300000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Veiled Heritant's Letter",
    ["cn"] = "Plots and Schemes",
  },
  [1660] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4133800000,
        ["px"] = 0.2242400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Shrine to Makela Leki",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1661] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4121700000,
        ["px"] = 0.2263500000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Shrine to Derik Hallin",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1662] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4109900000,
        ["px"] = 0.2242100000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Shrine to Divad Hunding",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1663] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4121800000,
        ["px"] = 0.2209200000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Shrine to Frandar Hunding",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  -- TODO check this
  [1664] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Powering the Dark Anchors",
    ["e"] = {
      [1] = { ["px"] = -0.1175260048, ["py"] = 0.2672375995, ["pm"] = 255, }, -- on location AFTER completing quests inside the "The Black Forge" ... zone-map
      [2] = { ["px"] = -0.0526507987, ["py"] = 0.2622507972, ["pm"] = 372, ["d"] = true, ["zx"] = -0.0578040006, ["zy"] = 0.2595256038, ["zm"] = 255, }, -- primary location, area-map
      [3] = { ["pnx"] = 0.7716826797, ["pny"] = 0.5270192027, ["pm"] = 371, ["fp"] = true, }, -- location shown on part of "The Black Forge" map
      [4] = { ["pnx"] = 0.7716826797, ["pny"] = 0.5270192027, ["pm"] = 373, ["fp"] = true, }, -- location shown on another part of "The Black Forge" map
      -- as far as I can tell, this is not needed ... [5] = { ["px"] = -0.0471552008, ["py"] = 0.2645443983, ["pm"] = 585, ["fp"] = true, }, -- 1/4 shackle map
    },
  },
  [1665] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "The Source of Power",
    ["e"] = {
      [1] = { ["px"] = -0.1175832051, ["py"] = 0.2672056046, ["pm"] = 255, }, -- on location AFTER completing quests inside the "The Great Shackle"
      [2] = { ["px"] = -0.0287176015, ["py"] = 0.2562771991, ["pm"] = 586, ["d"] = true, ["zx"] = -0.0410123996, ["zy"] = 0.2629627988, ["zm"] = 255, }, -- primary location, area-map
      [3] = { ["px"] = -0.0315176015, ["py"] = 0.2569071991, ["pm"] = 585, ["fp"] = true, }, -- location shown on entry part of "The Great Shackle" map
    },
  },
  [1666] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "The Great Mooring",
    ["e"] = {
      [1] = { ["px"] = -0.1175880019, ["py"] = 0.2672143969, ["pm"] = 255, }, -- on location AFTER completing quests inside the "The Great Shackle"
      [2] = { ["px"] = -0.0314992006, ["py"] = 0.2574447986, ["pm"] = 586, ["d"] = true, ["zx"] = -0.0410123996, ["zy"] = 0.2629627988, ["zm"] = 255, }, -- primary location, area-map
      [3] = { ["px"] = -0.0343176015, ["py"] = 0.2580171991, ["pm"] = 585, ["fp"] = true, }, -- location shown on entry part of "The Great Shackle" map
    },
  },
  [1667] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Fjar's Interrogation Transcript",
    ["q"] = 4332,
    ["e"] = {
      [1] = { ["px"] = 0.5460303859, ["py"] = 0.3699523988, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
  },
  [1725] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 1",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7298800000,
        ["px"] = 0.3382500000,
        ["pm"] = 300,
      },
    },
  },
  [1726] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 2",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7298600000,
        ["px"] = 0.3382500000,
        ["pm"] = 300,
      },
    },
  },
  [1727] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 3",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7298500000,
        ["px"] = 0.3382500000,
        ["pm"] = 300,
      },
    },
  },
  [1728] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 4",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7297900000,
        ["px"] = 0.3382600000,
        ["pm"] = 300,
      },
    },
  },
  [1729] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 5",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7297500000,
        ["px"] = 0.3383000000,
        ["pm"] = 300,
      },
    },
  },
  [1730] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Sumiril's Book, Passage 6",
    ["q"] = 4792,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7297500000,
        ["px"] = 0.3383900000,
        ["pm"] = 300,
      },
    },
  },
  [1731] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4483900000,
        ["px"] = 0.4816100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Plea for the Elder Scrolls",
    ["cn"] = "Notes and Memos",
  },
  [1732] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4319200000,
        ["px"] = 0.6061700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Plea for the Elder Scrolls",
    ["cn"] = "Notes and Memos",
  },
  [1733] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5507100000,
        ["px"] = 0.5618200000,
        ["pm"] = 16,
      },
    },
    ["l"] = true,
    ["n"] = "A Plea for the Elder Scrolls",
    ["cn"] = "Notes and Memos",
  },
  [1734] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Hald's Interrogation Transcript",
    ["q"] = 4332,
    ["e"] = {
      [1] = { ["px"] = 0.5460579858, ["py"] = 0.3698439989, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
  },
  [1735] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Hilka's Interrogation Transcript",
    ["q"] = 4332,
    ["e"] = {
      [1] = { ["px"] = 0.5461347859, ["py"] = 0.3696595989, ["pm"] = 142, ["zx"] = 0.5439643983, ["zy"] = 0.3674635943, ["zm"] = 125, ["d"] = true, },
    },
  },
  [1737] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8246000000,
        ["py"] = 0.5276100000,
        ["d"] = true,
        ["pm"] = 1153,
      },
    },
    ["n"] = "Adainaz's Journal",
    ["cn"] = "Research Notes",
  },
  [1738] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Cinnar's Notes",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7002000000,
        ["px"] = 0.3554200000,
        ["pm"] = 300,
      },
    },
  },
  [1739] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 258,
        ["px"] = 0.5050400000,
        ["d"] = true,
        ["py"] = 0.7933500000,
        ["mn"] = 21,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7925400000,
        ["px"] = 0.5097400000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Roost Smuggler's Ledger",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1740] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7927300000,
        ["px"] = 0.5098100000,
        ["pm"] = 258,
      },
    },
    ["n"] = "The Hind-Quarters Registry",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1741] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7936300000,
        ["px"] = 0.5088500000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Unlabeled Notes",
    ["cn"] = "Criminal Correspondence",
  },
  [1742] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7937700000,
        ["px"] = 0.5094800000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Dockmaster's Lament",
    ["cn"] = "Diaries and Logs",
  },
  [1743] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Your Final Chance",
    ["q"] = 4629,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4311600000,
        ["px"] = 0.5446700000,
        ["pm"] = 16,
      },
    },
  },
  [1745] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "The Artisan's Letters",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7000900000,
        ["px"] = 0.3554200000,
        ["pm"] = 300,
      },
    },
  },
  [1746] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "How the Locks Work",
    ["e"] = {
      [1] = { ["px"] = -0.0959316019, ["py"] = 0.1848796002, ["pm"] = 255, },
    },
  },
  [1747] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "The Daedric Flame",
    ["q"] = 4758,
    ["e"] = {
      [1] = { ["px"] = -0.0959316019, ["py"] = 0.1848796002, ["pm"] = 255, },
    },
  },
  [1748] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1836620035, ["py"] = 0.4030172135, ["pm"] = 553, ["zx"] = 0.1838519991, ["zy"] = 0.4025275982, ["zm"] = 30, ["d"] = true, },
    },
    ["n"] = "Shagora's Journal",
    ["cn"] = "Personal Journals",
  },
  [1749] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Yenadar's Journal",
    ["q"] = 4808,
    ["e"] = {
      [1] = { ["px"] = 0.4708623860, ["py"] = 0.6152148081, ["pm"] = 256, },
    },
  },
  [1750] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Nellor's Bandit Connection",
    ["q"] = 4786,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6918000000,
        ["px"] = 0.4045700000,
        ["pm"] = 9,
      },
    },
  },
  [1751] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Gamirth's Final Message",
    ["q"] = 4347, -- need to be read at quest-start, can't be missed
    ["e"] = {
      [1] = { ["px"] = -0.0653860038, ["py"] = 0.2773591976, ["pm"] = 255, },
    },
  },
  [1752] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5904028270, ["py"] = 0.3172939977, ["pm"] = 578, ["zm"] = 61, },
      [2] = { ["px"] = 0.7647884133, ["py"] = 0.5176772159, ["pm"] = 205, ["zm"] = 13, },
    },
    ["n"] = "Jofnir's Journal",
    ["cn"] = "Personal Journals",
  },
  [1753] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3690100000,
        ["px"] = 0.1978900000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Ansei Shrine",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1754] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Spotted a Cave",
    ["e"] = {
      [1] = { ["px"] = -0.0891835994, ["py"] = 0.2117124015, ["pm"] = 255, },
    },
  },
  [1755] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Message to Jena",
    ["q"] = 4674,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4706000000,
        ["px"] = 0.5982800000,
        ["pm"] = 16,
      },
    },
  },
  [1756] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Belya",
    ["q"] = 4691,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4714400000,
        ["px"] = 0.6020200000,
        ["pm"] = 16,
      },
    },
  },
  [1757] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Final Words",
    ["q"] = 4630,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5153300000,
        ["px"] = 0.5812900000,
        ["pm"] = 16,
      },
    },
  },
  [1758] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Nettira's Journal",
    ["q"] = 4814, -- given to player at quest-start, can be read from inventory
    ["e"] = {
      [1] = { ["px"] = -0.0976196019, ["py"] = 0.2634652025, ["pm"] = 422, ["zm"] = 255, ["qc"] = true, }, -- on location AFTER completing quest
      [2] = { ["px"] = -0.1062436013, ["py"] = 0.2309503988, ["pm"] = 322, ["d"] = true, ["zx"] = -0.1072056027, ["zy"] = 0.2305796012, ["zm"] = 255, }, -- on location at quest-start
    },
  },
  [1759] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Azara's Note",
    ["q"] = 4707,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5189100000,
        ["px"] = 0.5144000000,
        ["pm"] = 16,
      },
    },
  },
  [1760] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Message from Geneura",
    ["q"] = 4714,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5186000000,
        ["px"] = 0.5150400000,
        ["pm"] = 16,
      },
    },
  },
  [1761] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4296000000,
        ["d"] = true,
        ["py"] = 0.7315500000,
      },
      [2] = { ["px"] = 0.1511771926, ["py"] = 0.4026868017, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "An Ode to the Red Bird",
    ["cn"] = "Words of the Poets",
  },
  [1762] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7959100000,
        ["px"] = 0.5073900000,
        ["pm"] = 258,
      },
      [2] = { ["px"] = 0.5046495748, ["py"] = 0.7977608048, ["pm"] = 567, ["zm"] = 258, },
      [3] = { ["px"] = 0.5067579750, ["py"] = 0.7951800046, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Wardens of the Green",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1763] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Khajiiti Merchant's Invoice",
    ["q"] = 4815,
    ["e"] = {
      [1] = {
        ["pm"] = 9,
        ["px"] = 0.4550500000,
        ["d"] = true,
        ["py"] = 0.7055700000,
        ["mn"] = 7,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7031700000,
        ["px"] = 0.4430500000,
        ["pm"] = 9,
      },
    },
  },
  [1764] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "A Prisoner's Journal",
    ["e"] = {
      [1] = { ["px"] = -0.1196244054, ["py"] = 0.2497043974, ["pm"] = 255, },
    },
  },
  [1765] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3750700000,
        ["px"] = 0.2330600000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Knowing Satakal",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1766] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3683900000,
        ["px"] = 0.2340000000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Eight Steps of Mummification",
    ["cn"] = "Lore and Culture",
  },
  [1767] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3804500000,
        ["px"] = 0.2392200000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3979400000,
        ["px"] = 0.2015300000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Beginning Bladecraft: 7 Precepts",
    ["cn"] = "Lore and Culture",
  },
  [1768] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3869000000,
        ["px"] = 0.1840300000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3847800000,
        ["px"] = 0.1842500000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.3865800000,
        ["px"] = 0.1814000000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Legend of the Yokudan Chargers",
    ["cn"] = "The World and Its Creatures",
  },
  [1769] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4080400000,
        ["px"] = 0.2398200000,
        ["pm"] = 30,
      },
      [2] = {
        ["px"] = 0.2875100000,
        ["py"] = 0.2716200000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "Hags, Harpies, and Hagravens",
    ["cn"] = "Lore and Culture",
  },
  [1770] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2266264008, ["py"] = 0.3886835951, ["pm"] = 538, ["zm"] = 30, },
      [2] = { ["px"] = 0.2284768011, ["py"] = 0.3909655954, ["pm"] = 538, ["zm"] = 30, },
      [3] = { ["px"] = 0.2282904016, ["py"] = 0.3918195954, ["pm"] = 538, ["zm"] = 30, },
      [4] = { ["px"] = 0.2371063982, ["py"] = 0.3735147931, ["pm"] = 30, },
    },
    ["n"] = "Threat of the Baandari Pedlars",
    ["cn"] = "Lore and Culture",
  },
  [1771] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3760200000,
        ["px"] = 0.1931600000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Strakes and Futtocks",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1772] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4028100000,
        ["px"] = 0.1880100000,
        ["pm"] = 30,
      },
      [2] = { ["px"] = 0.1436659927, ["py"] = 0.3997020027, ["pm"] = 83, ["zm"] = 30, },
    },
    ["n"] = "Amethyst Mining in the Alik'r",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1773] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3933500000,
        ["px"] = 0.2278800000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4277400000,
        ["px"] = 0.1938800000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.4019400000,
        ["px"] = 0.1516400000,
        ["pm"] = 30,
      },
      [4] = {
        ["mn"] = 5,
        ["py"] = 0.4228200000,
        ["px"] = 0.1887400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Lost Islands of Old Yokuda",
    ["cn"] = "The World and Its Creatures",
  },
  [1774] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4134700000,
        ["px"] = 0.1663800000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3759000000,
        ["px"] = 0.2331100000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.3922400000,
        ["px"] = 0.1491700000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Tu'whacca, Arkay, Xarxes",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1775] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4332100000,
        ["px"] = 0.1409700000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4260700000,
        ["px"] = 0.1401400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Protocols of Propriety, Order Seven",
    ["cn"] = "Military Orders and Reports",
  },
  [1776] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4270100000,
        ["px"] = 0.1518400000,
        ["pm"] = 30,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.4254800000,
        ["px"] = 0.1541700000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 5,
        ["py"] = 0.4100300000,
        ["px"] = 0.1700600000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Correct Ways of Slaying Ra-Netu: 12",
    ["cn"] = "Lore and Culture",
  },
  [1777] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4157300000,
        ["px"] = 0.1453500000,
        ["pm"] = 30,
      },
    },
    ["n"] = "The Hunger of Sep",
    ["cn"] = "The World and Its Creatures",
  },
  [1778] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Gathiel's Diary",
    ["q"] = 4815,
    ["e"] = {
      [1] = {
        ["pm"] = 9,
        ["px"] = 0.4550500000,
        ["d"] = true,
        ["py"] = 0.7055700000,
        ["mn"] = 7,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7060600000,
        ["px"] = 0.4457900000,
        ["pm"] = 9,
      },
    },
  },
  [1779] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Gathiel's Astrology Chart",
    ["q"] = 4815,
    ["e"] = {
      [1] = { ["px"] = 0.4438579890, ["py"] = 0.7057687857, ["pm"] = 9, },
      [2] = {
        ["pm"] = 9,
        ["px"] = 0.4550100000,
        ["d"] = true,
        ["py"] = 0.7055900000,
        ["mn"] = 7,
      },
    },
  },
  [1780] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4373427968, ["py"] = 0.7262831999, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Letter to Akash",
    ["cn"] = "Letters and Missives",
  },
  [1781] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4362723978, ["py"] = 0.7237916003, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Savior of the Altmer, Part 1",
    ["cn"] = "Diaries and Logs",
  },
  [1782] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4366699973, ["py"] = 0.7233860005, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Savior of the Altmer, Part 2",
    ["cn"] = "Diaries and Logs",
  },
  [1783] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4361603969, ["py"] = 0.7220020005, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Savior of the Altmer, Part 3",
    ["cn"] = "Diaries and Logs",
  },
  [1784] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4314671972, ["py"] = 0.7244779998, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Note from Akash",
    ["cn"] = "Notes and Memos",
  },
  [1785] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4257027979, ["py"] = 0.7249780001, ["pm"] = 28, ["d"] = true,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Time is of the Essence",
    ["cn"] = "Military Orders and Reports",
  },
  [1786] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Treaty of Khenarthi's Roost",
    ["q"] = 4624,
    ["e"] = {
      [1] = { ["px"] = 0.5065835748, ["py"] = 0.7951528044, ["pm"] = 567, ["zm"] = 258, },
    },
  },
  [1787] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4297400000,
        ["py"] = 0.7251600000,
        ["d"] = true,
        ["pm"] = 1143,
        ["zx"] = 0.4290380089, ["zy"] = 0.7289168240, ["zm"] = 9,
      },
      [2] = { ["px"] = 0.4290380089, ["py"] = 0.7289168240, ["pm"] = 445, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Mages Guild Authorization",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1788] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2025700000,
        ["px"] = 0.2053300000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Nadafa's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [1789] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1673711941, ["py"] = 0.2202811987, ["pm"] = 204, ["zx"] = 0.1670743982, ["zy"] = 0.2193991995, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Miruin's Journal",
    ["cn"] = "Personal Journals",
  },
  [1791] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7575400000,
        ["px"] = 0.4243100000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7480200000,
        ["px"] = 0.4179600000,
        ["pm"] = 9,
      },
      [3] = {
        ["mn"] = 7,
        ["py"] = 0.7572300000,
        ["px"] = 0.4187800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Last of the Old Bones",
    ["cn"] = "Rituals and Revelations",
  },
  [1794] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7582400000,
        ["px"] = 0.4179000000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Bone Orchard Research Log 1",
    ["cn"] = "Research Notes",
  },
  [1795] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7576900000,
        ["px"] = 0.4236800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Bone Orchard Research Log 2",
    ["cn"] = "Research Notes",
  },
  [1796] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7573100000,
        ["px"] = 0.4188800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Bone Orchard Research Log 3",
    ["cn"] = "Research Notes",
  },
  [1797] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7582700000,
        ["px"] = 0.4234400000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Bone Orchard Research Log 4",
    ["cn"] = "Research Notes",
  },
  [1799] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7524200000,
        ["px"] = 0.4260000000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Bone Orchard Research Log 5",
    ["cn"] = "Research Notes",
  },
  [1800] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Merethrin's Research Notes",
    ["q"] = 4844,
    ["e"] = {
      [1] = { ["px"] = 0.1668324026, ["py"] = 0.2516572044, ["pm"] = 85, ["zm"] = 10, },
    },
  },
  [1801] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "The Fall of Carac Dena",
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6944300000,
        ["px"] = 0.3544500000,
        ["pm"] = 300,
      },
      [2] = { ["px"] = 0.2266440011, ["py"] = 0.7422636222, ["pm"] = 243, ["zm"] = 143, },
      [3] = {
        ["mn"] = 16,
        ["py"] = 0.7236200000,
        ["px"] = 0.3433000000,
        ["pm"] = 300,
      },
    },
  },
  [1802] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 300,
        ["px"] = 0.3657400000,
        ["d"] = true,
        ["py"] = 0.7158200000,
        ["mn"] = 16,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.7100700000,
        ["px"] = 0.3588500000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Stay Away from Gurzag's Mine",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1803] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7053900000,
        ["px"] = 0.2888200000,
        ["pm"] = 300,
      },
    },
    ["n"] = "A Complaint to the Thalmor",
    ["cn"] = "Letters and Missives",
  },
  [1804] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6721100000,
        ["px"] = 0.3011300000,
        ["pm"] = 300,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.6705400000,
        ["px"] = 0.2989400000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Culmination and Success",
    ["cn"] = "Plots and Schemes",
  },
  [1805] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3436588058, ["py"] = 0.6763635926, ["pm"] = 300, },
    },
    ["n"] = "Barrow Trench Scout's Report",
    ["cn"] = "Military Orders and Reports",
  },
  [1806] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7113200000,
        ["px"] = 0.2936100000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Letter from Bashshi-ra",
    ["cn"] = "Letters and Missives",
  },
  [1807] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Vastarie's Journal",
    ["q"] = 4842,
    ["e"] = {
      [1] = {
        ["px"] = 0.4535300000,
        ["py"] = 0.7286300000,
        ["d"] = true,
        ["pm"] = 410,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7258600000,
        ["px"] = 0.4557700000,
        ["pm"] = 9,
      },
    },
  },
  [1808] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Mercano's Journal",
    ["q"] = 4846,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7051200000,
        ["px"] = 0.2893100000,
        ["pm"] = 300,
      },
    },
  },
  [1809] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7121100000,
        ["px"] = 0.2873000000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Bashshi-ra Inquiry (partial)",
    ["cn"] = "Criminal Correspondence",
  },
  [1810] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6943500000,
        ["px"] = 0.3543600000,
        ["pm"] = 300,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.7153200000,
        ["px"] = 0.2939600000,
        ["pm"] = 300,
      },
    },
    ["n"] = "The Amronal's Spell",
    ["cn"] = "Words of the Poets",
  },
  [1811] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3127100000,
        ["py"] = 0.7301400000,
        ["d"] = true,
        ["pm"] = 359,
      },
      [2] = {
        ["px"] = 0.6623535751, ["py"] = 1.5132680402, ["pm"] = 1839, ["d"] = true,
        ["zx"] = 0.6616824197, ["zy"] = 1.5113048374, ["zm"] = 1747,
      },
    },
    ["n"] = "Vampires and their Hunters",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1812] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3037800000,
        ["py"] = 0.6848800000,
        ["d"] = true,
        ["pm"] = 374,
      },
    },
    ["n"] = "Sealing the Great Serpent",
    ["cn"] = "Rituals and Revelations",
  },
  [1813] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6720200000,
        ["px"] = 0.3032300000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Heroes of the Sanctuary",
    ["cn"] = "Tales of Tamriel",
  },
  [1814] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6939500000,
        ["px"] = 0.3498900000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Marbruk Builder's Log",
    ["cn"] = "Diaries and Logs",
  },
  [1815] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3523108007, ["py"] = 0.7315291972, ["pm"] = 300, },
    },
    ["n"] = "Greenshade Explorer's Log",
    ["cn"] = "Diaries and Logs",
  },
  [1816] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 9,
        ["px"] = 0.4228300000,
        ["d"] = true,
        ["py"] = 0.7516600000,
        ["mn"] = 7,
      },
    },
    ["n"] = "Destroyer's Rest",
    ["cn"] = "Words of the Poets",
  },
  [1817] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4031700000,
        ["px"] = 0.2407800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "No Significant Danger",
    ["cn"] = "Notes and Memos",
  },
  [1818] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3202000000,
        ["px"] = 0.2978900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Troll Slaying",
    ["cn"] = "The World and Its Creatures",
  },
  [1819] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3190600000,
        ["px"] = 0.2975900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Harvest's End",
    ["cn"] = "Lore and Culture",
  },
  [1820] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Barkbite Stronghold Shaman's List",
    ["q"] = 4395,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7014000000,
        ["px"] = 0.3851800000,
        ["pm"] = 9,
      },
    },
  },
  [1821] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3305812053, ["py"] = 0.6682987940, ["pm"] = 300, },
    },
    ["n"] = "Heart of Valenwood",
    ["cn"] = "The World and Its Creatures",
  },
  [1822] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7158600000,
        ["px"] = 0.2905300000,
        ["pm"] = 300,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.7117400000,
        ["px"] = 0.3340400000,
        ["pm"] = 300,
      },
      [3] = {
        ["mn"] = 16,
        ["py"] = 0.6708600000,
        ["px"] = 0.3379500000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Tales of the Spinners",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1823] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3066000000,
        ["py"] = 0.6608600000,
        ["d"] = true,
        ["pm"] = 385,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.6599600000,
        ["px"] = 0.3062400000,
        ["pm"] = 300,
      },
    },
    ["n"] = "The Swallowed City",
    ["cn"] = "Rituals and Revelations",
  },
  [1824] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6676500000,
        ["px"] = 0.3378400000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Green Pact Bosmer: Observations",
    ["cn"] = "Lore and Culture",
  },
  [1825] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6631200000,
        ["px"] = 0.3187600000,
        ["pm"] = 300,
      },
      [2] = {
        ["mn"] = 16,
        ["py"] = 0.7112500000,
        ["px"] = 0.3505000000,
        ["pm"] = 300,
      },
      [3] = {
        ["mn"] = 16,
        ["py"] = 0.6942800000,
        ["px"] = 0.3506400000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Valenwood Hounds",
    ["cn"] = "Lore and Culture",
  },
  [1826] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6993500000,
        ["px"] = 0.3497900000,
        ["pm"] = 300,
      },
    },
    ["n"] = "The Dominion's Duty: Marbruk",
    ["cn"] = "The World and Its Creatures",
  },
  [1827] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7304000000,
        ["px"] = 0.3110400000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Letter from Dannic",
    ["cn"] = "Letters and Missives",
  },
  [1828] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Thorzhul's Letter",
    ["q"] = 4852,
    ["e"] = {
      [1] = { ["px"] = 0.2753128064, ["py"] = 0.3020920004, ["pm"] = 229, ["zx"] = 0.2738100068, ["zy"] = 0.3043063940, ["zm"] = 20, ["d"] = true, },
    },
  },
  [1829] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Borzugh's Letter",
    ["q"] = 4852,
    ["e"] = {
      [1] = { ["px"] = 0.2748028064, ["py"] = 0.3015020004, ["pm"] = 229, ["zx"] = 0.2738100068, ["zy"] = 0.3043063940, ["zm"] = 20, ["d"] = true, },
    },
  },
  [1830] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.7969000000,
        ["px"] = 0.5008600000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7926900000,
        ["px"] = 0.5098700000,
        ["pm"] = 258,
      },
      [3] = { ["px"] = 0.5066747746, ["py"] = 0.7953628045, ["pm"] = 567, ["zm"] = 258, },
      [4] = {
        ["mn"] = 21,
        ["py"] = 0.8035700000,
        ["px"] = 0.5092100000,
        ["pm"] = 258,
      },
      [5] = {
        ["mn"] = 21,
        ["py"] = 0.7953500000,
        ["px"] = 0.5066900000,
        ["pm"] = 258,
      },
      [6] = { ["px"] = 0.5058867748, ["py"] = 0.7959064046, ["pm"] = 567, ["zm"] = 258, },
      [7] = {
        ["mn"] = 21,
        ["py"] = 0.7980100000,
        ["px"] = 0.5088700000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Outdated Dominion Broadsheet",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1831] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5089291748, ["py"] = 0.7963748044, ["pm"] = 567, ["zm"] = 258, },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.7962100000,
        ["px"] = 0.5051900000,
        ["pm"] = 258,
      },
      [3] = {
        ["mn"] = 21,
        ["py"] = 0.7971700000,
        ["px"] = 0.5083800000,
        ["pm"] = 258,
      },
      [4] = { ["px"] = 0.5049023749, ["py"] = 0.7969216045, ["pm"] = 567, ["zm"] = 258, },
      [5] = {
        ["mn"] = 21,
        ["py"] = 0.8062000000,
        ["px"] = 0.5078600000,
        ["pm"] = 258,
      },
      [6] = { ["px"] = 0.5069211747, ["py"] = 0.7985044045, ["pm"] = 567, ["zm"] = 258, },
      [7] = { ["px"] = 0.5052523748, ["py"] = 0.7978744046, ["pm"] = 567, ["zm"] = 258, },
    },
    ["n"] = "Hurricane Assistance and Salvage",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1832] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2259700000,
        ["py"] = 0.3315300000,
        ["d"] = true,
        ["pm"] = 1149,
      },
    },
    ["n"] = "Journal of Garron",
    ["cn"] = "Criminal Correspondence",
  },
  [1833] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2248500000,
        ["py"] = 0.3295400000,
        ["d"] = true,
        ["pm"] = 1149,
      },
    },
    ["n"] = "Zombies: Further Experiments",
    ["cn"] = "Research Notes",
  },
  [1834] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2274300000,
        ["py"] = 0.3331100000,
        ["d"] = true,
        ["pm"] = 1149,
      },
    },
    ["n"] = "Journal of Master Pellingare",
    ["cn"] = "Personal Journals",
  },
  [1835] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3396400000,
        ["px"] = 0.3149000000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3284400000,
        ["px"] = 0.2727800000,
        ["pm"] = 20,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.2967500000,
        ["px"] = 0.2875500000,
        ["pm"] = 20,
      },
      [4] = {
        ["mn"] = 6,
        ["py"] = 0.3074500000,
        ["px"] = 0.3181400000,
        ["pm"] = 20,
      },
      [5] = {
        ["mn"] = 6,
        ["py"] = 0.2858700000,
        ["px"] = 0.3167800000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Invocation of Hircine",
    ["cn"] = "Daedric Cults",
  },
  [1836] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3064600000,
        ["py"] = 0.6524500000,
        ["d"] = true,
        ["pm"] = 380,
      },
    },
    ["n"] = "Note from Jahla",
    ["cn"] = "Notes and Memos",
  },
  [1837] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Loriasel Tablet, Entry 1",
    ["q"] = 4854,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7092500000,
        ["px"] = 0.4324300000,
        ["pm"] = 9,
      },
    },
  },
  [1839] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Proper Torture Techniques, Vol. 13",
    ["q"] = 4836,
    ["e"] = {
      [1] = {
        ["px"] = -0.0592400000,
        ["d"] = true,
        ["py"] = 0.0670800000,
        ["pm"] = 507,
      },
      [2] = {
        ["mn"] = 15,
        ["py"] = 0.7433500000,
        ["px"] = 0.2475200000,
        ["pm"] = 143,
      },
      [3] = {
        ["mn"] = 15,
        ["py"] = 0.7455700000,
        ["px"] = 0.2472400000,
        ["pm"] = 143,
      },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3919200000,
        ["px"] = 0.0729000000,
        ["pm"] = 1,
      },
      [5] = {
        ["mn"] = 11,
        ["py"] = 0.4325500000,
        ["px"] = 0.7710700000,
        ["pm"] = 7,
      },
    },
  },
  [1840] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7091300000,
        ["px"] = 0.4322700000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Chronicles of Ehtelar, Vol. 1",
    ["cn"] = "Skill Books",
  },
  [1841] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Cipius' Orders",
    ["q"] = 1799,
    ["e"] = {
      [1] = { ["px"] = 0.2800787990, ["py"] = 0.3093548046, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [1842] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2874879995, ["py"] = 0.3196916054, ["pm"] = 84, ["zm"] = 20, },
      [2] = { ["px"] = 0.2875331997, ["py"] = 0.3195912042, ["pm"] = 84, ["zm"] = 20, },
      [3] = { ["px"] = 0.2877323997, ["py"] = 0.3145448048, ["pm"] = 84, ["zm"] = 20, },
    },
    ["n"] = "The Royal House of King Eamond",
    ["cn"] = "Lore and Culture",
  },
  [1843] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2861771987, ["py"] = 0.3235992045, ["pm"] = 84, ["zm"] = 20, },
    },
    ["n"] = "Orders from Duke Renchant",
    ["cn"] = "Plots and Schemes",
  },
  [1844] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "It's the Hunt that Counts",
    ["q"] = 4777,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4585400000,
        ["px"] = 0.5605300000,
        ["pm"] = 16,
      },
    },
  },
  [1845] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3137687925, ["py"] = 0.3253887954, ["pm"] = 236, ["zx"] = 0.3143956093, ["zy"] = 0.3240907969, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Delivery Schedule and Manifests",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1846] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3151875925, ["py"] = 0.3247851955, ["pm"] = 236, ["zx"] = 0.3143956093, ["zy"] = 0.3240907969, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Curnard's Journal",
    ["cn"] = "Criminal Correspondence",
  },
  [1847] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4330000000,
        ["py"] = 0.6178500000,
        ["d"] = true,
        ["pm"] = 303,
      },
    },
    ["n"] = "Fascinating Relics",
    ["cn"] = "Notes and Memos",
  },
  [1848] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3146000000,
        ["px"] = 0.2826800000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3270100000,
        ["px"] = 0.2845900000,
        ["pm"] = 20,
      },
      [3] = { ["px"] = 0.2870971999, ["py"] = 0.3199264046, ["pm"] = 84, ["zm"] = 20, },
    },
    ["n"] = "The Martyrdom of Saint Pelin",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1849] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2872700000,
        ["px"] = 0.3185100000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.2823200000,
        ["px"] = 0.3120900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Uela's Song",
    ["cn"] = "Words of the Poets",
  },
  [1850] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2344900000,
        ["px"] = 0.1928500000,
        ["pm"] = 10,
      },
    },
    ["n"] = "The Hidden Key",
    ["cn"] = "Mysteries and Clues",
  },
  [1851] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2948444085, ["py"] = 0.2859564010, ["pm"] = 591, ["zx"] = 0.2981604080, ["zy"] = 0.2911823962, ["zm"] = 20, ["d"] = true, },
      [2] = {
        ["px"] = 0.2967500000,
        ["py"] = 0.2850000000,
        ["d"] = true,
        ["pm"] = 591,
      },
    },
    ["n"] = "The Nereid's Dilemma",
    ["cn"] = "Words of the Poets",
  },
  [1852] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3085500000,
        ["px"] = 0.3199100000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Our Curse and Our Glory",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1853] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4913767944, ["py"] = 0.5613871903, ["pm"] = 210, ["zx"] = 0.4908675801, ["zy"] = 0.5610392064, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Colovian Deserter's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1855] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4576700000,
        ["py"] = 0.6438000000,
        ["d"] = true,
        ["pm"] = 307,
      },
    },
    ["n"] = "Wolfpack Initiate's Notes",
    ["cn"] = "Daedric Cults",
  },
  [1856] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4574300000,
        ["py"] = 0.6435400000,
        ["d"] = true,
        ["pm"] = 307,
      },
    },
    ["n"] = "Initiate's Second Note",
    ["cn"] = "Daedric Cults",
  },
  [1857] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4572500000,
        ["py"] = 0.6437900000,
        ["d"] = true,
        ["pm"] = 307,
      },
    },
    ["n"] = "Initiate's Third Note",
    ["cn"] = "Daedric Cults",
  },
  [1859] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2589300000,
        ["px"] = 0.1761600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Healing Herbs of Northwest Tamriel",
    ["cn"] = "The World and Its Creatures",
  },
  [1860] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2553100000,
        ["px"] = 0.1785400000,
        ["pm"] = 10,
      },
      [2] = {
        ["mn"] = 3,
        ["py"] = 0.2587000000,
        ["px"] = 0.1750800000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Healer Heloise's Notes",
    ["cn"] = "Final Words",
  },
  [1861] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4752664066, ["py"] = 0.5970280154, ["pm"] = 304, ["zx"] = 0.4749579836, ["zy"] = 0.5963580073, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Khajiit's Lost Journal Page",
    ["cn"] = "Personal Journals",
  },
  [1862] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4750044065, ["py"] = 0.5975968154, ["pm"] = 304, ["zx"] = 0.4749579836, ["zy"] = 0.5963580073, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Second Khajiiti Journal Page",
    ["cn"] = "Personal Journals",
  },
  [1863] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4752480066, ["py"] = 0.5974732154, ["pm"] = 304, ["zx"] = 0.4749579836, ["zy"] = 0.5963580073, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Third Khajiiti Journal Page",
    ["cn"] = "Personal Journals",
  },
  [1864] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4228900000,
        ["py"] = 0.6247200000,
        ["d"] = true,
        ["pm"] = 301,
      },
      [2] = {
        ["px"] = 0.4221600000,
        ["py"] = 0.6251800000,
        ["d"] = true,
        ["pm"] = 301,
      },
    },
    ["n"] = "Skooma Runner Logs",
    ["cn"] = "Criminal Correspondence",
  },
  [1866] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3660000000,
        ["px"] = 0.2833400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "The Mystery of Gargoyles—Solved!",
    ["cn"] = "The World and Its Creatures",
  },
  [1867] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1929840060, ["py"] = 0.3220959944, ["pm"] = 189, ["zx"] = 0.1886720021, ["zy"] = 0.3233400038, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Bonesnap Journal",
    ["cn"] = "Final Words",
  },
  [1868] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1848628063, ["py"] = 0.3186587943, ["pm"] = 189, ["zx"] = 0.1886720021, ["zy"] = 0.3233400038, ["zm"] = 12, ["d"] = true, },
    },
    ["n"] = "Gaston's Instructions",
    ["cn"] = "Notes and Memos",
  },
  [1869] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2667648011, ["py"] = 0.3635875974, ["pm"] = 360, ["zm"] = 20, },
      [2] = { ["px"] = 0.2650560020, ["py"] = 0.3686803966, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "Den of Thieves, Part Two",
    ["cn"] = "Tales of Tamriel",
  },
  [1870] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "A Distracted Enemy",
    ["q"] = 4854,
    ["e"] = {
      [1] = { ["px"] = 0.1859008064, ["py"] = 0.3220771940, ["pm"] = 189, ["zx"] = 0.1886720021, ["zy"] = 0.3233400038, ["zm"] = 12, ["d"] = true, },
    },
  },
  [1871] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Crow and Raven: Three Short Fables",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 4,
      [660] = 8,
      [143] = 23,
      [1126] = 2,
      [7] = 5,
      [1060] = 11,
      [26] = 4,
      [10] = 9,
      [27] = 2,
      [125] = 2,
      [13] = 2,
      [667] = 1,
      [255] = 35,
    },
  },
  [1874] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2661828009, ["py"] = 0.3638743974, ["pm"] = 360, ["zm"] = 20, },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3749700000,
        ["px"] = 0.2744300000,
        ["pm"] = 20,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.3453500000,
        ["px"] = 0.2994000000,
        ["pm"] = 20,
      },
      [4] = { ["px"] = 0.2660964021, ["py"] = 0.3698531972, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "The Ring of Daggers",
    ["cn"] = "Lore and Culture",
  },
  [1875] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3016700000,
        ["px"] = 0.2837800000,
        ["pm"] = 20,
      },
      [2] = { ["px"] = 0.2866751994, ["py"] = 0.3234448052, ["pm"] = 84, ["zm"] = 20, },
      [3] = {
        ["px"] = 0.2619600000,
        ["py"] = 0.3460500000,
        ["d"] = true,
        ["pm"] = 418,
      },
      [4] = {
        ["mn"] = 6,
        ["py"] = 0.3239100000,
        ["px"] = 0.3143300000,
        ["pm"] = 20,
      },
      [5] = { ["px"] = 0.2659680008, ["py"] = 0.3633651973, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "A Royal Embarrassment",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1876] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2829679991, ["py"] = 0.3115200046, ["pm"] = 84, ["zm"] = 20, },
      [2] = { ["px"] = 0.2897631998, ["py"] = 0.3085160044, ["pm"] = 84, ["zm"] = 20, },
    },
    ["n"] = "Northglen Farm Opportunities",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1877] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 1",
    ["q"] = 4474,
    ["e"] = {
      [1] = {
        ["px"] = 1.1278700000,
        ["d"] = true,
        ["py"] = 0.0079400000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
      [2] = {
        ["px"] = 1.1272500000,
        ["d"] = true,
        ["py"] = 0.0158400000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [3] = { ["px"] = -0.1197532012, ["py"] = 0.2639799966, ["pm"] = 255, ["qc"] = true, },
      [4] = { ["px"] = 1.1269288104, ["py"] = 0.0013672060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
    },
  },
  [1878] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4094535848, ["py"] = 0.7659631829, ["pm"] = 9, },
    },
    ["n"] = "Note to Barkeep",
    ["cn"] = "Notes and Memos",
  },
  [1879] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2976900000,
        ["px"] = 0.2824400000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.2936800000,
        ["px"] = 0.2815500000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Lady Murcien's Folly",
    ["cn"] = "Words of the Poets",
  },
  [1880] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2947920085, ["py"] = 0.2848908009, ["pm"] = 591, ["zx"] = 0.2981604080, ["zy"] = 0.2911823962, ["zm"] = 20, ["d"] = true, },
      [2] = {
        ["px"] = 0.2967500000,
        ["py"] = 0.2850600000,
        ["d"] = true,
        ["pm"] = 591,
      },
    },
    ["n"] = "Bisnensel: Our Ancient Roots",
    ["cn"] = "Daedric Cults",
  },
  [1881] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3195400000,
        ["px"] = 0.3067700000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.2990400000,
        ["px"] = 0.3179400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Field Guide to Spriggans",
    ["cn"] = "The World and Its Creatures",
  },
  [1882] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2646600000,
        ["px"] = 0.1880300000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Lleraya's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1883] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4294855840, ["py"] = 0.7505775889, ["pm"] = 9, },
    },
    ["n"] = "Recipe for Horker Pie",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1884] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3318100000,
        ["px"] = 0.2760300000,
        ["pm"] = 20,
      },
      [2] = { ["px"] = 0.2882715993, ["py"] = 0.3149428045, ["pm"] = 84, ["zm"] = 20, },
    },
    ["n"] = "Picnic at Pelin (A Horror Story)",
    ["cn"] = "Tales of Tamriel",
  },
  [1885] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "A Request for Relief",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 6,
      [255] = 16,
      [1060] = 1,
      [1126] = 65,
      [660] = 6,
      [26] = 3,
      [22] = 28,
      [7] = 7,
      [61] = 6,
      [9] = 22,
      [10] = 7,
      [27] = 12,
      [12] = 13,
      [13] = 13,
      [30] = 5,
      [143] = 7,
    },
  },
  [1886] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Note from Kamu",
    ["q"] = 4399,
    ["e"] = {
      [1] = { ["px"] = -0.1298228013, ["py"] = 0.2420259989, ["pm"] = 255, },
    },
  },
  [1887] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6840200000,
        ["px"] = 0.3538300000,
        ["pm"] = 300,
      },
    },
    ["n"] = "A Merchant's Guide to Valenwood",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1888] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Ghosts of the Old Tower",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 13,
      [660] = 34,
      [1126] = 3,
      [7] = 17,
      [143] = 31,
      [1060] = 13,
      [26] = 7,
      [27] = 8,
      [667] = 2,
      [13] = 5,
      [10] = 11,
      [255] = 28,
    },
  },
  [1889] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2655391859, ["py"] = 0.3481867936, ["pm"] = 419, ["zx"] = 0.2672164048, ["zy"] = 0.3474167968, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Nilata Search Plan",
    ["cn"] = "Research Notes",
  },
  [1890] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7119000000,
        ["px"] = 0.3342500000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Oath of the Shadows Watch",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1891] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3654300000,
        ["px"] = 0.2831000000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Stibbons' Qharroa Checklist",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1892] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7125400000,
        ["px"] = 0.3474600000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Elders of Bramblebreach",
    ["cn"] = "Words of the Poets",
  },
  [1893] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3562800000,
        ["px"] = 0.3176500000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 5,
        ["py"] = 0.3914500000,
        ["px"] = 0.2218000000,
        ["pm"] = 30,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.3538900000,
        ["px"] = 0.3127400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Lessuns Lerned Garding Caravans",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1894] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Daedra Dossier: Cold-Flame Atronach",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [1060] = 8,
      [143] = 10,
      [1126] = 2,
      [7] = 16,
      [26] = 7,
      [125] = 1,
      [10] = 4,
      [27] = 4,
      [667] = 1,
      [13] = 22,
      [660] = 2,
      [255] = 19,
    },
  },
  [1895] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2636020009, ["py"] = 0.3633183971, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "Vindication for the Dragon Break",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1896] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3083900000,
        ["px"] = 0.3188500000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3074500000,
        ["px"] = 0.3183500000,
        ["pm"] = 20,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.3079400000,
        ["px"] = 0.3198900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "The Book of Reason",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1897] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2466200000,
        ["px"] = 0.1431300000,
        ["pm"] = 10,
      },
    },
    ["n"] = "The Living Flesh",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1898] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2645800000,
        ["px"] = 0.1880600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Constable Maldred's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1899] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1962668008, ["py"] = 0.2148451990, ["pm"] = 479, ["zx"] = 0.1994467967, ["zy"] = 0.2134992010, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Note from Theomund",
    ["cn"] = "Notes and Memos",
  },
  [1900] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2473800000,
        ["px"] = 0.1469500000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Concerns, Petitions, Complaints",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1902] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5588900000,
        ["px"] = 0.5695000000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5558800000,
        ["px"] = 0.5624700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Letter to Grand Warlord Sorcalin",
    ["cn"] = "Letters and Missives",
  },
  [1903] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4488300000,
        ["px"] = 0.4768400000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4523500000,
        ["px"] = 0.4719800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Letter to Grand Warlord Dortene",
    ["cn"] = "Letters and Missives",
  },
  [1904] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4334800000,
        ["px"] = 0.6083900000,
        ["pm"] = 16,
      },
      [2] = { ["px"] = 0.6097359950, ["py"] = 0.4197996109, ["pm"] = 573, ["zm"] = 16, },
    },
    ["n"] = "Letter to Grand Warlord Zimmeron",
    ["cn"] = "Letters and Missives",
  },
  [1907] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3469600000,
        ["py"] = 0.6886300000,
        ["d"] = true,
        ["pm"] = 383,
      },
    },
    ["n"] = "Strange Rambling Notes",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1908] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3160100000,
        ["py"] = 0.7155400000,
        ["d"] = true,
        ["pm"] = 391,
      },
    },
    ["n"] = "Naril Nagaia Journal",
    ["cn"] = "Personal Journals",
  },
  [1909] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3083300000,
        ["py"] = 0.6826700000,
        ["d"] = true,
        ["pm"] = 384,
      },
    },
    ["n"] = "Blood-Spattered Love Note",
    ["cn"] = "Hearts and Flowers",
  },
  [1910] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3583500000,
        ["py"] = 0.7071200000,
        ["d"] = true,
        ["pm"] = 382,
      },
    },
    ["n"] = "Mine Foreman's Orders",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1911] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3397307925, ["py"] = 0.7400700152, ["pm"] = 386, ["d"] = true,
        ["zx"] = 0.3398108021, ["zy"] = 0.7395819933, ["zm"] = 300,
      },
    },
    ["n"] = "On the Beauty of Ogres",
    ["cn"] = "Words of the Poets",
  },
  [1912] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from Gorvyn",
    ["q"] = 4894,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4943300000,
        ["px"] = 0.7182400000,
        ["pm"] = 13,
      },
    },
  },
  [1913] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2957400000,
        ["px"] = 0.2824800000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Vital Records, 2E 541—2E 542",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1914] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Loriasel Tablet, Entry 2",
    ["q"] = 4854,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7078300000,
        ["px"] = 0.4319000000,
        ["pm"] = 9,
      },
    },
  },
  [1917] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Loriasel Tablet, Entry 4",
    ["q"] = 4854,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7076600000,
        ["px"] = 0.4325900000,
        ["pm"] = 9,
      },
    },
  },
  [1918] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Loriasel Tablet Notes",
    ["q"] = 4854,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7086000000,
        ["px"] = 0.4319500000,
        ["pm"] = 9,
      },
    },
  },
  [1919] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5459800000,
        ["px"] = 0.5581500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Imperial Refugee's Journal",
    ["cn"] = "Personal Journals",
  },
  [1920] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2436300000,
        ["px"] = 0.1801100000,
        ["pm"] = 10,
      },
    },
    ["n"] = "The True Fate of King Ranser",
    ["cn"] = "Diaries and Logs",
  },
  [1921] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2605800000,
        ["px"] = 0.1498600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Captain's Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [1922] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1408236005, ["py"] = 0.2730000045, ["pm"] = 476, ["zx"] = 0.1453075988, ["zy"] = 0.2620956006, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Reezal-Jul's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [1924] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Gray Mire Tribal Leadership",
    ["q"] = 4768,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7645800000,
        ["px"] = 0.4323100000,
        ["pm"] = 9,
      },
    },
  },
  [1925] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5113500000,
        ["py"] = 0.4864700000,
        ["d"] = true,
        ["pm"] = 285,
      },
    },
    ["n"] = "Reward for Longfang!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1926] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5161300000,
        ["py"] = 0.4995800000,
        ["d"] = true,
        ["pm"] = 286,
      },
    },
    ["n"] = "Letter to Diabolist Volcatia",
    ["cn"] = "Daedric Cults",
  },
  [1927] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7736700000,
        ["px"] = 0.4226800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Night Mother Watches",
    ["cn"] = "Letters and Missives",
  },
  [1928] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7507200000,
        ["px"] = 0.4300600000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7505300000,
        ["px"] = 0.4293900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Set List",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1929] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7506100000,
        ["px"] = 0.4300100000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7503300000,
        ["px"] = 0.4294700000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Diary of a Romance",
    ["cn"] = "Hearts and Flowers",
  },
  [1930] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5239700000,
        ["py"] = 0.5262900000,
        ["d"] = true,
        ["pm"] = 467,
      },
    },
    ["n"] = "Letter to Volgo",
    ["cn"] = "Daedric Cults",
  },
  [1931] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5428900000,
        ["py"] = 0.5298700000,
        ["d"] = true,
        ["pm"] = 291,
      },
    },
    ["n"] = "Letter to Vethisa",
    ["cn"] = "Daedric Cults",
  },
  [1932] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4970400000,
        ["py"] = 0.4911500000,
        ["d"] = true,
        ["pm"] = 466,
      },
    },
    ["n"] = "Serpent Hollow Observations",
    ["cn"] = "Final Words",
  },
  [1933] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5366200000,
        ["py"] = 0.4260000000,
        ["d"] = true,
        ["pm"] = 470,
      },
    },
    ["n"] = "Hegris' Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1934] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Bordaunt Virelande's Journal",
    ["q"] = 4895,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7126700000,
        ["px"] = 0.4341100000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7221200000,
        ["px"] = 0.4091000000,
        ["pm"] = 9,
      },
    },
  },
  [1935] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4256900000,
        ["px"] = 0.5240600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Will of Otrovor Knifeborn",
    ["cn"] = "Final Words",
  },
  [1936] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4442700000,
        ["px"] = 0.4897100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Final Statement of Leobert Charien",
    ["cn"] = "Final Words",
  },
  [1937] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5655900000,
        ["py"] = 0.4335400000,
        ["d"] = true,
        ["pm"] = 289,
      },
    },
    ["n"] = "Orders from Hegris",
    ["cn"] = "Plots and Schemes",
  },
  [1938] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5518700000,
        ["py"] = 0.4371000000,
        ["d"] = true,
        ["pm"] = 294,
      },
    },
    ["n"] = "Toadstool Hollow Journal",
    ["cn"] = "Personal Journals",
  },
  [1939] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5241500000,
        ["py"] = 0.4382300000,
        ["d"] = true,
        ["pm"] = 288,
      },
    },
    ["n"] = "Letter to Raelynne",
    ["cn"] = "Letters and Missives",
  },
  [1940] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5085800000,
        ["px"] = 0.5786100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Letter to Evrien",
    ["cn"] = "Letters and Missives",
  },
  [1941] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5864000000,
        ["py"] = 0.4884200000,
        ["d"] = true,
        ["pm"] = 287,
      },
    },
    ["n"] = "Academy's Rejection Letter",
    ["cn"] = "Letters and Missives",
  },
  [1942] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5202300000,
        ["px"] = 0.5922200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Captain Izard's Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [1943] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5960500000,
        ["py"] = 0.4645000000,
        ["d"] = true,
        ["pm"] = 471,
      },
    },
    ["n"] = "Orders for Athal",
    ["cn"] = "Plots and Schemes",
  },
  [1944] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4843600000,
        ["px"] = 0.6051400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Faceless",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1945] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7093200000,
        ["px"] = 0.4284900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Chronicles of Ehtelar, Vol. 2",
    ["cn"] = "Tales of Tamriel",
  },
  [1946] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 2",
    ["q"] = 4552,
    ["e"] = {
      [1] = { ["px"] = 1.1270072104, ["py"] = 0.0013468061, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [2] = {
        ["px"] = 1.1272400000,
        ["d"] = true,
        ["py"] = 0.0158100000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [3] = { ["px"] = -0.1197680020, ["py"] = 0.2639420033, ["pm"] = 255, },
      [4] = {
        ["px"] = 1.1278700000,
        ["d"] = true,
        ["py"] = 0.0079800000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [1947] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 3",
    ["q"] = 4607,
    ["e"] = {
      [1] = { ["px"] = 1.1270136106, ["py"] = 0.0013504061, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [2] = {
        ["px"] = 1.1272300000,
        ["d"] = true,
        ["py"] = 0.0159100000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [3] = { ["px"] = -0.1197924013, ["py"] = 0.2639040000, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1278800000,
        ["d"] = true,
        ["py"] = 0.0079800000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [1948] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Letter to Reezal-Jul",
    ["q"] = 4902,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2452400000,
        ["px"] = 0.1662400000,
        ["pm"] = 10,
      },
    },
  },
  [1949] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 4",
    ["q"] = 4764,
    ["e"] = {
      [1] = {
        ["px"] = 1.1272300000,
        ["d"] = true,
        ["py"] = 0.0158000000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [2] = { ["px"] = 1.1270772104, ["py"] = 0.0014176060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [3] = { ["px"] = -0.1198320018, ["py"] = 0.2638751995, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1278700000,
        ["d"] = true,
        ["py"] = 0.0080300000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [1950] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1689436029, ["py"] = 0.2438140045, ["pm"] = 85, ["zm"] = 10, },
    },
    ["n"] = "Reply from Reezal-Jul",
    ["cn"] = "Plots and Schemes",
  },
  [1952] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6188100000,
        ["px"] = 0.4529200000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5564600000,
        ["px"] = 0.4676600000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Supplies for the Delve",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [1953] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5600800000,
        ["px"] = 0.4638900000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5828600000,
        ["px"] = 0.4449800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Thibaut's Cairn and its History",
    ["cn"] = "The World and Its Creatures",
  },
  [1954] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6134400000,
        ["px"] = 0.4542500000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5583900000,
        ["px"] = 0.4615500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Wanted: Nimriian the Longfang",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [1955] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5972700000,
        ["px"] = 0.4231500000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6134000000,
        ["px"] = 0.4538900000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Hizrabi's Report",
    ["cn"] = "Criminal Correspondence",
  },
  [1956] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5956000000,
        ["px"] = 0.4831700000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5880000000,
        ["px"] = 0.4735800000,
        ["pm"] = 256,
      },
    },
    ["n"] = "End of My Patience",
    ["cn"] = "Criminal Correspondence",
  },
  [1957] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6162700000,
        ["px"] = 0.4728500000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5992200000,
        ["px"] = 0.4556000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Call to the Faithful",
    ["cn"] = "The Devoted and the Deranged",
  },
  [1958] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2977400000,
        ["px"] = 0.2820600000,
        ["pm"] = 20,
      },
    },
    ["n"] = "The Reachmen are Coming!",
    ["cn"] = "Notes and Memos",
  },
  [1959] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2955500000,
        ["px"] = 0.2861500000,
        ["pm"] = 20,
      },
    },
    ["n"] = "We Will Be Spared",
    ["cn"] = "Notes and Memos",
  },
  [1962] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6328800000,
        ["px"] = 0.3079500000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 8,
        ["py"] = 0.6277300000,
        ["px"] = 0.3096400000,
        ["pm"] = 22,
      },
      [3] = {
        ["mn"] = 7,
        ["py"] = 0.7610800000,
        ["px"] = 0.4634900000,
        ["pm"] = 9,
      },
      [4] = {
        ["mn"] = 7,
        ["py"] = 0.7365100000,
        ["px"] = 0.4315400000,
        ["pm"] = 9,
      },
      [5] = {
        ["mn"] = 7,
        ["py"] = 0.7392000000,
        ["px"] = 0.4294600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Regarding the \"Fists of Thalmor\"",
    ["cn"] = "Letters and Missives",
  },
  [1963] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7327500000,
        ["px"] = 0.4156100000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Seven Shadows of Rajhin, Pt. 1",
    ["cn"] = "Tales of Tamriel",
  },
  [1964] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6493000000,
        ["px"] = 0.5583400000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Mysterious Akavir",
    ["cn"] = "Anequina Archives",
  },
  [1966] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3035571904, ["py"] = 0.3666339948, ["pm"] = 232, ["zx"] = 0.3029840091, ["zy"] = 0.3669607964, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Notes on Klathzgar's Schematics",
    ["cn"] = "Research Notes",
  },
  [1967] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3034219904, ["py"] = 0.3673815948, ["pm"] = 232, ["zx"] = 0.3029840091, ["zy"] = 0.3669607964, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Princess Urenenya's Letter",
    ["cn"] = "Mysteries and Clues",
  },
  [1968] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2003791931, ["py"] = 0.2545648032, ["pm"] = 220, ["zx"] = 0.2000608002, ["zy"] = 0.2547144015, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "The Legend of Dame Marcelle",
    ["cn"] = "Lore and Culture",
  },
  [1969] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5818500000,
        ["px"] = 0.4757500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Note from a Bottle",
    ["cn"] = "Notes and Memos",
  },
  [1970] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2311800000,
        ["px"] = 0.2052500000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Sagabar's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1973] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2028119984, ["py"] = 0.2035015998, ["pm"] = 244, ["zx"] = 0.2027743996, ["zy"] = 0.2033216012, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "I Saw Him Again Tonight",
    ["cn"] = "Hearts and Flowers",
  },
  [1974] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2032627984, ["py"] = 0.2041139998, ["pm"] = 244, ["zx"] = 0.2027743996, ["zy"] = 0.2033216012, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Tonight Was the Night",
    ["cn"] = "Hearts and Flowers",
  },
  [1975] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2034555984, ["py"] = 0.2037779997, ["pm"] = 244, ["zx"] = 0.2027743996, ["zy"] = 0.2033216012, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Tonight He Confessed",
    ["cn"] = "Hearts and Flowers",
  },
  [1977] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Matthiaume's Journal",
    ["q"] = 4923,
    ["e"] = {
      [1] = { ["px"] = 0.1367311951, ["py"] = 0.2539183975, ["pm"] = 216, ["zx"] = 0.1360859985, ["zy"] = 0.2535096019, ["zm"] = 10, ["d"] = true, },
    },
  },
  [1978] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2496900000,
        ["px"] = 0.1985200000,
        ["pm"] = 10,
      },
    },
    ["n"] = "On Immortality",
    ["cn"] = "Rituals and Revelations",
  },
  [1980] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1667783941, ["py"] = 0.2197951987, ["pm"] = 204, ["zx"] = 0.1670743982, ["zy"] = 0.2193991995, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "The Tale of Princess Anurraame",
    ["cn"] = "Tales of Tamriel",
  },
  [1981] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Iirdel's Journal",
    ["q"] = 4917,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6913500000,
        ["px"] = 0.4358600000,
        ["pm"] = 9,
      },
    },
  },
  [1982] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Edweg's Resignation Note",
    ["q"] = 4923,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2441100000,
        ["px"] = 0.1899900000,
        ["pm"] = 10,
      },
    },
  },
  [1983] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1674100000,
        ["py"] = 0.2198700000,
        ["d"] = true,
        ["pm"] = 204,
      },
    },
    ["n"] = "Tears of Anurraame",
    ["cn"] = "Hearts and Flowers",
  },
  [1987] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Troll Socialization Research Notes",
    ["q"] = 4944,
    ["e"] = {
      [1] = { ["px"] = 0.1756592035, ["py"] = 0.2499200050, ["pm"] = 85, ["zm"] = 10, },
    },
  },
  [1988] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Coded Rutter",
    ["q"] = 4378,
    ["e"] = {
      [1] = {
        ["px"] = 0.3466924001, ["py"] = 0.6114004140, ["pm"] = 22,
      },
    },
  },
  [1989] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1620551991, ["py"] = 0.2492488035, ["pm"] = 10,
      },
    },
    ["n"] = "Montclair Assassin's Orders",
    ["cn"] = "Plots and Schemes",
  },
  [1990] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1552431996, ["py"] = 0.2614204031, ["pm"] = 10,
      },
    },
    ["n"] = "Rasaba's Note",
    ["cn"] = "Notes and Memos",
  },
  [1993] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3545100000,
        ["px"] = 0.2865100000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3653400000,
        ["px"] = 0.2830200000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Hawk\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [1994] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3545200000,
        ["px"] = 0.2865700000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3653500000,
        ["px"] = 0.2830400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Man and Beast\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [1995] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3653500000,
        ["px"] = 0.2830200000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3545300000,
        ["px"] = 0.2865500000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Mother and Son\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [1996] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4496675968, ["py"] = 0.7385319923, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "Valamuur's Notes, Volume I",
    ["cn"] = "Rituals and Revelations",
  },
  [1997] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4496459969, ["py"] = 0.7385091921, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "Valamuur's Notes, Volume II",
    ["cn"] = "Rituals and Revelations",
  },
  [1998] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4496135969, ["py"] = 0.7385027923, ["pm"] = 283, ["d"] = true,
        ["zx"] = 0.4475163890, ["zy"] = 0.7445467864, ["zm"] = 9,
      },
    },
    ["n"] = "Valamuur's Notes, Volume III",
    ["cn"] = "Rituals and Revelations",
  },
  [1999] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4572300000,
        ["py"] = 0.7122600000,
        ["d"] = true,
        ["pm"] = 393,
      },
    },
    ["n"] = "Scrap of Storgh's Journal",
    ["cn"] = "Personal Journals",
  },
  [2000] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Nedras' Journal",
    ["q"] = 4955,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2037200000,
        ["px"] = 0.2070200000,
        ["pm"] = 10,
      },
    },
  },
  [2001] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Klaandor's Journal",
    ["q"] = 4956,
    ["e"] = {
      [1] = { ["px"] = 0.1707872031, ["py"] = 0.2491012046, ["pm"] = 85, ["zm"] = 10, },
    },
  },
  [2003] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Lady Laurent's Qharroa Notes",
    ["q"] = 3317,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3654700000,
        ["px"] = 0.2831100000,
        ["pm"] = 20,
      },
    },
  },
  [2004] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2456000000,
        ["px"] = 0.1831300000,
        ["pm"] = 10,
      },
    },
    ["n"] = "King Ranser's Tirade",
    ["cn"] = "Diaries and Logs",
  },
  [2005] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1983067939, ["py"] = 0.2180228031, ["pm"] = 478, ["zx"] = 0.1994467967, ["zy"] = 0.2134992010, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Malofar's Journal",
    ["cn"] = "Plots and Schemes",
  },
  [2006] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1962100008, ["py"] = 0.2197479989, ["pm"] = 479, ["zx"] = 0.1994467967, ["zy"] = 0.2134992010, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Barrowton's Journal",
    ["cn"] = "Final Words",
  },
  [2007] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6254200000,
        ["px"] = 0.3707800000,
        ["pm"] = 22,
      },
      [2] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4314300000,
        ["d"] = true,
        ["py"] = 0.7317500000,
      },
    },
    ["n"] = "Jofnir's Journal",
    ["cn"] = "Personal Journals",
  },
  [2008] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2189416022, ["py"] = 0.3329580071, ["pm"] = 33, ["zm"] = 12, },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5176400000,
        ["px"] = 0.7648000000,
        ["pm"] = 13,
      },
      [3] = {
        ["px"] = -0.5138400000,
        ["d"] = true,
        ["py"] = -0.3720300000,
        ["pm"] = 104,
      },
      [4] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4314800000,
        ["d"] = true,
        ["py"] = 0.7317700000,
      },
    },
    ["n"] = "The Strange Case of Ragnthar",
    ["cn"] = "The World and Its Creatures",
  },
  [2009] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2136400000,
        ["px"] = 0.2216800000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Message in a Bottle",
    ["cn"] = "Final Words",
  },
  [2010] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 9,
        ["px"] = 0.4000900000,
        ["d"] = true,
        ["py"] = 0.6869000000,
        ["mn"] = 7,
      },
    },
    ["n"] = "A Dance in Moonlight",
    ["cn"] = "Rituals and Revelations",
  },
  [2011] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Mastery of Discipline",
    ["q"] = 4959,
    ["e"] = {
      [1] = { ["px"] = 0.2941044142, ["py"] = 0.3928760078, ["pm"] = 420, ["zx"] = 0.2927644048, ["zy"] = 0.3921875965, ["zm"] = 20, ["d"] = true, },
    },
  },
  [2012] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Mastery of Devotion",
    ["q"] = 4959,
    ["e"] = {
      [1] = { ["px"] = 0.2939968142, ["py"] = 0.3934308078, ["pm"] = 420, ["zx"] = 0.2927644048, ["zy"] = 0.3921875965, ["zm"] = 20, ["d"] = true, },
    },
  },
  [2013] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Mastery of Wisdom",
    ["q"] = 4959,
    ["e"] = {
      [1] = { ["px"] = 0.2942380141, ["py"] = 0.3932348078, ["pm"] = 420, ["zx"] = 0.2927644048, ["zy"] = 0.3921875965, ["zm"] = 20, ["d"] = true, },
    },
  },
  [2014] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Mastery of Sacrifice",
    ["q"] = 4959,
    ["e"] = {
      [1] = { ["px"] = 0.2932656142, ["py"] = 0.3931412079, ["pm"] = 420, ["zx"] = 0.2927644048, ["zy"] = 0.3921875965, ["zm"] = 20, ["d"] = true, },
    },
  },
  [2017] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6865700000,
        ["px"] = 0.3987100000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Research Assistant Wanted",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2018] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1955544008, ["py"] = 0.2131955989, ["pm"] = 479, ["zx"] = 0.1994467967, ["zy"] = 0.2134992010, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Amberic's Note",
    ["cn"] = "Notes and Memos",
  },
  [2019] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Alchemy Practicum",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 23,
      [258] = 15,
      [227] = 1,
      [1126] = 15,
      [7] = 19,
      [9] = 18,
      [10] = 18,
      [75] = 4,
      [12] = 11,
      [13] = 15,
      [143] = 26,
      [22] = 9,
      [74] = 3,
      [26] = 22,
      [27] = 3,
      [201] = 10,
      [61] = 23,
      [30] = 12,
      [300] = 20,
    },
  },
  [2024] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Notes on the Mortuum Vivicus",
    ["e"] = {
      [1] = { ["px"] = 0.2485455979, ["py"] = 0.6979328025, ["pm"] = 193, ["d"] = true, ["zx"] = 0.2474271972, ["zy"] = 0.6963356117, ["zm"] = 143, },
      [2] = { ["px"] = 0.7646396130, ["py"] = 0.5179124150, ["pm"] = 205, ["zm"] = 13, },
      [3] = { ["px"] = 0.2192520021, ["py"] = 0.3319336072, ["pm"] = 33, ["zm"] = 12, },
      [4] = {
        ["px"] = 0.1030000000,
        ["py"] = 0.3817900000,
        ["d"] = true,
        ["pm"] = 555,
        ["zx"] = 0.1039039984, ["zy"] = 0.3813740034, ["zm"] = 1,
      },
      [5] = {
        ["px"] = 0.7360600000,
        ["py"] = 0.4264000000,
        ["d"] = true,
        ["pm"] = 241,
        ["zx"] = 0.7361519906, ["zy"] = 0.4321431990, ["zm"] = 7,
      },
    },
  },
  [2025] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Coded Message on Coin",
    ["q"] = 4945,
    ["e"] = {
      [1] = { ["px"] = 0.1706868034, ["py"] = 0.2459580047, ["pm"] = 85, ["zm"] = 10, },
    },
  },
  [2026] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1177000000,
        ["d"] = true,
        ["py"] = 0.2261900000,
        ["pm"] = 455,
      },
    },
    ["n"] = "Note to Ulguna",
    ["cn"] = "Notes and Memos",
  },
  [2027] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1185500000,
        ["d"] = true,
        ["py"] = 0.2226300000,
        ["pm"] = 455,
      },
    },
    ["n"] = "Diary, Day 13",
    ["cn"] = "Diaries and Logs",
  },
  [2028] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1187500000,
        ["d"] = true,
        ["py"] = 0.2218300000,
        ["pm"] = 455,
      },
    },
    ["n"] = "Diary, Day 36",
    ["cn"] = "Diaries and Logs",
  },
  [2029] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1182000000,
        ["d"] = true,
        ["py"] = 0.2211800000,
        ["pm"] = 455,
      },
    },
    ["n"] = "Diary, Day 61",
    ["cn"] = "Diaries and Logs",
  },
  [2030] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1206900000,
        ["d"] = true,
        ["py"] = 0.2204100000,
        ["pm"] = 455,
      },
    },
    ["n"] = "Diary, Day Unknown",
    ["cn"] = "Diaries and Logs",
  },
  [2031] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7393500000,
        ["px"] = 0.4305200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "To the Veiled Masters",
    ["cn"] = "Plots and Schemes",
  },
  [2033] = {
    ["c"] = true,
    ["q"] = 2017,
    ["e"] = {
      [1] = {
        ["py"] = 0.3619000000,
        ["px"] = 0.2602100000,
        ["pm"] = 360,
        ["zm"] = 20,
      },
    },
    ["n"] = "Note to Sir Quatrius",
    ["cn"] = "Notes and Memos",
  },
  [2034] = {
    ["c"] = true,
    ["q"] = 2070,
    ["e"] = {
      [1] = {
        ["py"] = 0.3617700000,
        ["px"] = 0.2602100000,
        ["pm"] = 360,
        ["zm"] = 20,
      },
    },
    ["n"] = "The Grandeya is in Custody",
    ["cn"] = "Notes and Memos",
  },
  [2035] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2659019913, ["py"] = 0.3439075960, ["pm"] = 418, ["zx"] = 0.2718544065, ["zy"] = 0.3393163955, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Letter to Herminius Sophus",
    ["cn"] = "Letters and Missives",
  },
  [2036] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0097600000,
        ["d"] = true,
        ["py"] = -0.0164100000,
        ["pm"] = 563,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5195100000,
        ["px"] = 0.7652200000,
        ["pm"] = 13,
      },
      [3] = { ["px"] = 0.2194432029, ["py"] = 0.3322860066, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Journal of Bernamot the Great",
    ["cn"] = "Personal Journals",
  },
  [2037] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2906520050, ["py"] = 0.3824095990, ["pm"] = 20, },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3875600000,
        ["px"] = 0.2922600000,
        ["pm"] = 20,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.3860700000,
        ["px"] = 0.2879200000,
        ["pm"] = 20,
      },
    },
    ["n"] = "On the Spirits of the Hel Shira",
    ["cn"] = "Plots and Schemes",
  },
  [2038] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3860900000,
        ["px"] = 0.2879100000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3874800000,
        ["px"] = 0.2922000000,
        ["pm"] = 20,
      },
      [3] = { ["px"] = 0.2906520050, ["py"] = 0.3824095990, ["pm"] = 20, },
    },
    ["n"] = "Directive to Centurion Bodenius",
    ["cn"] = "Military Orders and Reports",
  },
  [2039] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3860400000,
        ["px"] = 0.2879500000,
        ["pm"] = 20,
      },
      [2] = {
        ["mn"] = 6,
        ["py"] = 0.3875200000,
        ["px"] = 0.2920800000,
        ["pm"] = 20,
      },
      [3] = { ["px"] = 0.2907000059, ["py"] = 0.3824652006, ["pm"] = 20, },
    },
    ["n"] = "On the Chamber of Passage",
    ["cn"] = "Plots and Schemes",
  },
  [2040] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0128600000,
        ["d"] = true,
        ["py"] = -0.0125500000,
        ["pm"] = 563,
      },
      [2] = {
        ["mn"] = 10,
        ["py"] = 0.5196000000,
        ["px"] = 0.7651800000,
        ["pm"] = 13,
      },
      [3] = { ["px"] = 0.2193424027, ["py"] = 0.3323136068, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "By the Master's Mace",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2041] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Aminyas' Journal",
    ["q"] = 4979,
    ["e"] = {
      [1] = { ["px"] = 0.2667619915, ["py"] = 0.3451371961, ["pm"] = 418, ["zx"] = 0.2718544065, ["zy"] = 0.3393163955, ["zm"] = 20, ["d"] = true, },
      [2] = {
        ["px"] = 0.2660800000,
        ["py"] = 0.3441000000,
        ["d"] = true,
        ["pm"] = 418,
      },
    },
  },
  [2042] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0109200000,
        ["d"] = true,
        ["py"] = -0.0170800000,
        ["pm"] = 563,
      },
      [2] = { ["px"] = 0.2194432029, ["py"] = 0.3322860066, ["pm"] = 33, ["zm"] = 12, },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5196000000,
        ["px"] = 0.7651900000,
        ["pm"] = 13,
      },
    },
    ["n"] = "The Unholy Temple",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2043] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2685283917, ["py"] = 0.3433187957, ["pm"] = 418, ["zx"] = 0.2718544065, ["zy"] = 0.3393163955, ["zm"] = 20, ["d"] = true, },
      [2] = {
        ["px"] = 0.2660900000,
        ["py"] = 0.3440900000,
        ["d"] = true,
        ["pm"] = 418,
      },
    },
    ["n"] = "Morgaulle Dechery's Journal",
    ["cn"] = "Personal Journals",
  },
  [2044] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "Bandit Thug's Journal",
    ["q"] = 4984,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7010900000,
        ["px"] = 0.3849400000,
        ["pm"] = 9,
      },
    },
  },
  [2045] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2661703862, ["py"] = 0.3473271935, ["pm"] = 419, ["zx"] = 0.2672164048, ["zy"] = 0.3474167968, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Najan's Journal",
    ["cn"] = "Hearts and Flowers",
  },
  [2046] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7666800000,
        ["px"] = 0.4269900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Thunderbug Repellent",
    ["cn"] = "Notes and Memos",
  },
  [2047] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7365400000,
        ["px"] = 0.4318200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Wanted: Sgolag",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2048] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4588232131, ["py"] = 0.7604687864, ["pm"] = 512, ["zm"] = 9, },
    },
    ["n"] = "Ne Salas: Need Reinforcements",
    ["cn"] = "Military Orders and Reports",
  },
  [2049] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4364239847, ["py"] = 0.6882427888, ["pm"] = 9,
      },
    },
    ["n"] = "Garick's Message",
    ["cn"] = "Notes and Memos",
  },
  [2050] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7243700000,
        ["px"] = 0.4387600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Dominion Condolences",
    ["cn"] = "Military Orders and Reports",
  },
  [2051] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2656428015, ["py"] = 0.3658179977, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "Regarding the Hall",
    ["cn"] = "Military Orders and Reports",
  },
  [2052] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2659336016, ["py"] = 0.3658663974, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "\"Death\" of Morphotypical Entities",
    ["cn"] = "Rituals and Revelations",
  },
  [2053] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2653836017, ["py"] = 0.3659471975, ["pm"] = 360, ["zm"] = 20, },
    },
    ["n"] = "When We Pass",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2056] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "The Mage's Cipher",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2843783992, ["py"] = 0.3119076048, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2057] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "First Gravestone",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2875975995, ["py"] = 0.3094468045, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2058] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Second Gravestone",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2866527990, ["py"] = 0.3101468044, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2059] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Third Gravestone",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2863335987, ["py"] = 0.3102836046, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2060] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Fourth Gravestone",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2860807988, ["py"] = 0.3105948046, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2061] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Rite of the Scion",
    ["q"] = 4964,
    ["e"] = {
      [1] = { ["px"] = 0.6502459929, ["py"] = 0.3395695940, ["pm"] = 125, ["qc"] = true, },
      [2] = { ["px"] = 0.2928688050, ["py"] = 0.3249747964, ["pm"] = 20, ["qc"] = true, },
      [3] = { ["px"] = 0.4730187796, ["py"] = 0.5727820058, ["pm"] = 256, ["qc"] = true, },
      [4] = { ["px"] = 0.7622020010, ["py"] = 0.4960840165, ["pm"] = 13, ["qc"] = true, },
      [5] = { ["px"] = 0.0827464001, ["py"] = 0.3922388025, ["pm"] = 1, ["qc"] = true, },
    },
  },
  [2062] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7108600000,
        ["px"] = 0.4059800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Faltonia's Promise",
    ["cn"] = "The World and Its Creatures",
  },
  [2063] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Gravestone Notes",
    ["q"] = 4980,
    ["e"] = {
      [1] = { ["px"] = 0.2859855991, ["py"] = 0.3112272046, ["pm"] = 84, ["zm"] = 20, },
    },
  },
  [2064] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2677308133, ["py"] = 0.3849483969, ["pm"] = 71, ["zx"] = 0.2611196047, ["zy"] = 0.3860951949, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Notes on Razak",
    ["cn"] = "Research Notes",
  },
  [2065] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2774860133, ["py"] = 0.3756255971, ["pm"] = 71, ["zx"] = 0.2611196047, ["zy"] = 0.3860951949, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Notes on the Vault Door",
    ["cn"] = "Research Notes",
  },
  [2066] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7064200000,
        ["px"] = 0.4074200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Sweetness in the Air",
    ["cn"] = "Hearts and Flowers",
  },
  [2067] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7078000000,
        ["px"] = 0.4043500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Leave This Place",
    ["cn"] = "Letters and Missives",
  },
  [2068] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3650500000,
        ["px"] = 0.2830900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Gripe, Gripe, Gripe",
    ["cn"] = "Diaries and Logs",
  },
  [2069] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7528300000,
        ["px"] = 0.4136800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Back to the Land!",
    ["cn"] = "Final Words",
  },
  [2070] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2370400000,
        ["px"] = 0.1528600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Translated Ayleid Texts",
    ["cn"] = "Mysteries and Clues",
  },
  [2071] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4631400132, ["py"] = 0.7571155863, ["pm"] = 512, ["zm"] = 9, },
    },
    ["n"] = "Anirtur's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [2072] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1706956028, ["py"] = 0.2459424045, ["pm"] = 85, ["zm"] = 10, },
    },
    ["n"] = "Decoded Coin Message",
    ["cn"] = "Mysteries and Clues",
  },
  [2073] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4557648026, ["py"] = 0.7673967964, ["pm"] = 408, ["d"] = true, },
      [2] = { ["px"] = 0.4569296129, ["py"] = 0.7593207862, ["pm"] = 512, ["zm"] = 9, },
    },
    ["n"] = "A Smuggler's Plan",
    ["cn"] = "Criminal Correspondence",
  },
  [2074] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4536568129, ["py"] = 0.7596871869, ["pm"] = 512, ["zm"] = 9, },
    },
    ["n"] = "The Sea It Rises",
    ["cn"] = "Words of the Poets",
  },
  [2075] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4559436130, ["py"] = 0.7711483866, ["pm"] = 512, ["zm"] = 9, },
    },
    ["n"] = "Raven-Hair's Recollections",
    ["cn"] = "Diaries and Logs",
  },
  [2076] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7014600000,
        ["px"] = 0.3851800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Wear Them Down",
    ["cn"] = "Notes and Memos",
  },
  [2077] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 5",
    ["q"] = 4836,
    ["e"] = {
      [1] = {
        ["px"] = 1.1272400000,
        ["d"] = true,
        ["py"] = 0.0157900000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [2] = { ["px"] = 1.1270796104, ["py"] = 0.0014396060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [3] = { ["px"] = -0.1198560055, ["py"] = 0.2638484019, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1278800000,
        ["d"] = true,
        ["py"] = 0.0080400000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [2078] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 6",
    ["q"] = 4837,
    ["e"] = {
      [1] = {
        ["px"] = 1.1272100000,
        ["d"] = true,
        ["py"] = 0.0158000000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [2] = { ["px"] = 1.1268968104, ["py"] = 0.0014000060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [3] = { ["px"] = -0.1198644023, ["py"] = 0.2638500042, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1278800000,
        ["d"] = true,
        ["py"] = 0.0080300000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [2079] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 7",
    ["q"] = 4867,
    ["e"] = {
      [1] = {
        ["px"] = 1.1278700000,
        ["d"] = true,
        ["py"] = 0.0079700000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
      [2] = { ["px"] = 1.1269360104, ["py"] = 0.0014040060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [3] = { ["px"] = -0.1199016046, ["py"] = 0.2637864049, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1272200000,
        ["d"] = true,
        ["py"] = 0.0157700000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
    },
  },
  [2080] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 8",
    ["q"] = 4832,
    ["e"] = {
      [1] = { ["px"] = 1.1269808105, ["py"] = 0.0014316061, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [2] = {
        ["px"] = 1.1272000000,
        ["d"] = true,
        ["py"] = 0.0157800000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [3] = { ["px"] = -0.1199440041, ["py"] = 0.2637496032, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1278800000,
        ["d"] = true,
        ["py"] = 0.0080400000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [2081] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Chronicles of the Five Companions 9",
    ["q"] = 4847,
    ["e"] = {
      [1] = { ["px"] = 1.1270472105, ["py"] = 0.0016156060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [2] = {
        ["px"] = 1.1279900000,
        ["d"] = true,
        ["py"] = 0.0074000000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
      [3] = { ["px"] = -0.1199588048, ["py"] = 0.2637043998, ["pm"] = 255, ["qc"] = true, },
      [4] = {
        ["px"] = 1.1267000000,
        ["d"] = true,
        ["py"] = 0.0163100000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
    },
  },
  [2082] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2953460067, ["py"] = 0.3448648010, ["pm"] = 894, ["zx"] = 0.2943068070, ["zy"] = 0.3441903942, ["zm"] = 20, ["d"] = true, },
      [2] = { ["px"] = 0.3010316032, ["py"] = 0.3472163987, ["pm"] = 20, },
    },
    ["n"] = "Orders for Attius",
    ["cn"] = "Daedric Cults",
  },
  [2083] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Aldimion's Journal",
    ["q"] = 4552,
    ["e"] = {
      [1] = {
        ["px"] = 1.1267500000,
        ["d"] = true,
        ["py"] = 0.0163200000,
        ["pm"] = 736,
        ["zx"] = 0.0726720032, ["zy"] = 0.3916680015, ["zm"] = 1,
      },
      [2] = { ["px"] = 1.1272128106, ["py"] = 0.0020236060, ["pm"] = 772, ["d"] = true, ["qc"] = true, ["zx"] = 0.2472128026, ["zy"] = 0.7434960150, ["zm"] = 143, },
      [3] = { ["px"] = -0.3366103892, ["py"] = 0.3096936018, ["pm"] = 482, ["d"] = true, }, -- on location DURING quest
      [4] = {
        ["px"] = 1.1270100000,
        ["d"] = true,
        ["py"] = 0.0077800000,
        ["pm"] = 737,
        ["zx"] = 0.7710879924, ["zy"] = 0.4325783997, ["zm"] = 7,
      },
    },
  },
  [2084] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Second Cohort Orders",
    ["q"] = 3496,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3562800000,
        ["px"] = 0.3212000000,
        ["pm"] = 20,
      },
    },
  },
  [2085] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Forged Second Cohort Orders",
    ["q"] = 3496,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3562400000,
        ["px"] = 0.3212500000,
        ["pm"] = 20,
      },
    },
  },
  [2086] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Ripped and Discarded Page",
    ["e"] = {
      [1] = { ["px"] = -0.1189432020, ["py"] = 0.2659700026, ["pm"] = 350, ["d"] = true, ["zx"] = -0.1188416016, ["zy"] = 0.2655072004, ["zm"] = 255, },
      [2] = { ["px"] = -0.0941608019, ["py"] = 0.2553448028, ["pm"] = 422, ["zm"] = 255, },
    },
  },
  [2087] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Knights of the Gleaming Blade",
    ["e"] = {
      [1] = { ["px"] = -0.1181704019, ["py"] = 0.2661088027, ["pm"] = 350, ["d"] = true, ["zx"] = -0.1188416016, ["zy"] = 0.2655072004, ["zm"] = 255, },
    },
  },
  [2089] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6673844095, ["py"] = 0.3936783899, ["pm"] = 703, ["d"] = true,
        ["zx"] = 0.6668963927, ["zy"] = 0.3931739953, ["zm"] = 125,
      },
    },
    ["n"] = "Broken Helm Notes",
    ["cn"] = "Criminal Correspondence",
  },
  [2090] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5563436019, ["py"] = 0.3460391988, ["pm"] = 211, ["d"] = true,
        ["zx"] = 0.5559443970, ["zy"] = 0.3462135948, ["zm"] = 125,
      },
    },
    ["n"] = "Jakolar's Journal",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2091] = {
    ["c"] = true,
    ["cn"] = "The Five Companions",
    ["n"] = "Proper Torture Techniques, Vol. 8",
    ["q"] = 4836,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4355100000,
        ["px"] = 0.7676800000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3908400000,
        ["px"] = 0.0763800000,
        ["pm"] = 1,
      },
      [3] = { ["px"] = -0.0525715987, ["py"] = 0.0747071989, ["pm"] = 507, ["d"] = true, }, -- only accessible DURING quest
      [4] = { ["px"] = 0.2471972011, ["py"] = 0.7456488228, ["pm"] = 243, ["zx"] = 0.2471971962, ["zy"] = 0.7456488181, ["zm"] = 143, ["qc"] = true, },
    },
  },
  [2092] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4405700000,
        ["py"] = 0.7681400000,
        ["d"] = true,
        ["pm"] = 405,
      },
    },
    ["n"] = "An Ancient Love Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [2093] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7695500000,
        ["px"] = 0.4118200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "A Daughter's Journal",
    ["cn"] = "Personal Journals",
  },
  [2094] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4422900000,
        ["py"] = 0.7675800000,
        ["d"] = true,
        ["pm"] = 405,
      },
    },
    ["n"] = "Diary of Climent Noellaume",
    ["cn"] = "Diaries and Logs",
  },
  [2095] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7283600000,
        ["px"] = 0.4616500000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6365400000,
        ["px"] = 0.5310800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "On Necromancy",
    ["cn"] = "Rituals and Revelations",
  },
  [2096] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Collected Theory Hypothesis",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 1,
      [660] = 2,
      [1126] = 8,
      [7] = 16,
      [143] = 1,
      [10] = 3,
      [27] = 1,
      [1060] = 3,
      [13] = 5,
      [26] = 3,
      [255] = 54,
    },
  },
  [2097] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7707100000,
        ["px"] = 0.4106500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Something's in the Attic",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2098] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7354200000,
        ["px"] = 0.4217700000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Orders from General Endare",
    ["cn"] = "Military Orders and Reports",
  },
  [2099] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7680900000,
        ["px"] = 0.4137600000,
        ["pm"] = 9,
      },
      [2] = { ["px"] = 0.4099175878, ["py"] = 0.7661755845, ["pm"] = 9, },
      [3] = {
        ["mn"] = 7,
        ["py"] = 0.7654700000,
        ["px"] = 0.4049200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Call for Census",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2100] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4105811880, ["py"] = 0.7654811872, ["pm"] = 9, },
    },
    ["n"] = "My Sweet Flower",
    ["cn"] = "Hearts and Flowers",
  },
  [2101] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7699900000,
        ["px"] = 0.4273600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Note from Slim-Jah",
    ["cn"] = "Notes and Memos",
  },
  [2102] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7661800000,
        ["px"] = 0.4277800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Argonian Refugee's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [2103] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7659800000,
        ["px"] = 0.4271900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Note from No-Fingers",
    ["cn"] = "Hearts and Flowers",
  },
  [2104] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6939400000,
        ["px"] = 0.4156600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Fisherman's Journal",
    ["cn"] = "Final Words",
  },
  [2105] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 26,
        ["px"] = 0.7475200000,
        ["d"] = true,
        ["py"] = 0.5480600000,
        ["mn"] = 9,
      },
    },
    ["n"] = "Eyes of the Queen Only",
    ["cn"] = "Notes and Memos",
  },
  [2107] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7660400000,
        ["px"] = 0.4096900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Founding of Southpoint",
    ["cn"] = "The World and Its Creatures",
  },
  [2108] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7214900000,
        ["px"] = 0.4576700000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Rajhin and the Stone Maiden, Pt. 1",
    ["cn"] = "Tales of Tamriel",
  },
  [2110] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7427700000,
        ["px"] = 0.4143700000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Rajhin and the Stone Maiden, Pt. 2",
    ["cn"] = "Tales of Tamriel",
  },
  [2111] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5125100224, ["py"] = 0.6544176024, ["pm"] = 1663, ["zm"] = 1555, },
    },
    ["n"] = "Nobility in Theft",
    ["cn"] = "Criminal Correspondence",
  },
  [2112] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4385815870, ["py"] = 0.6907935874, ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7470700000,
        ["px"] = 0.4633800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Truth of the Hunter, Pt. 1",
    ["cn"] = "Tales of Tamriel",
  },
  [2113] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7458200000,
        ["px"] = 0.4643800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Truth of the Hunter, Pt. 2",
    ["cn"] = "Tales of Tamriel",
  },
  [2114] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7471800000,
        ["px"] = 0.4649200000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Truth of the Hunter, Pt. 3",
    ["cn"] = "Tales of Tamriel",
  },
  [2115] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4340047831, ["py"] = 0.6904431887, ["pm"] = 9,
      },
    },
    ["n"] = "The Massacre at Cormount",
    ["cn"] = "The World and Its Creatures",
  },
  [2116] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4365299876, ["py"] = 0.6925183876, ["pm"] = 9,
      },
    },
    ["n"] = "The Rise of Cormount",
    ["cn"] = "The World and Its Creatures",
  },
  [2117] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4336911838, ["py"] = 0.6901111887, ["pm"] = 9,
      },
    },
    ["n"] = "Increased Dominion Activity",
    ["cn"] = "Notes and Memos",
  },
  [2118] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4391535876, ["py"] = 0.6922751870, ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7676600000,
        ["px"] = 0.4256500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Wood Elf Etiquette: An Imperial Perspective",
    ["cn"] = "Lore and Culture",
  },
  [2119] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 9,
        ["px"] = 0.4526600000,
        ["d"] = true,
        ["py"] = 0.7064900000,
        ["mn"] = 7,
      },
    },
    ["n"] = "Neronnir's Journal",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2120] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7518200000,
        ["px"] = 0.4402500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Introduction to Stagecraft",
    ["cn"] = "Lore and Culture",
  },
  [2121] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7178600000,
        ["px"] = 0.4278500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Enthoras' Journal",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [2122] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4254200000,
        ["py"] = 0.6922000000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
    ["n"] = "Redfur Journal, v. 1",
    ["cn"] = "Plots and Schemes",
  },
  [2123] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4296700000,
        ["py"] = 0.6846200000,
        ["d"] = true,
        ["pm"] = 406,
      },
    },
    ["n"] = "Redfur Journal, v. 2",
    ["cn"] = "Plots and Schemes",
  },
  [2124] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7018900000,
        ["px"] = 0.3850500000,
        ["pm"] = 9,
      },
    },
    ["n"] = "The Fall and Rise of Reman's Bluff",
    ["cn"] = "Lore and Culture",
  },
  [2126] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from Althen",
    ["q"] = 5014,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2592600000,
        ["px"] = 0.1958600000,
        ["pm"] = 10,
      },
    },
  },
  [2127] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4391619864, ["py"] = 0.6922763883, ["pm"] = 9
      },
    },
    ["n"] = "Note about \"Wood Elf Etiquette\"",
    ["cn"] = "Notes and Memos",
  },
  [2128] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4359800000,
        ["py"] = 0.7283600000,
        ["d"] = true,
        ["pm"] = 452,
      },
      [2] = {
        ["px"] = 0.4378600000,
        ["py"] = 0.7279900000,
        ["d"] = true,
        ["pm"] = 452,
      },
      [3] = {
        ["px"] = 0.4363800000,
        ["py"] = 0.7273400000,
        ["d"] = true,
        ["pm"] = 452,
      },
      [4] = {
        ["px"] = 0.4365900000,
        ["py"] = 0.7292500000,
        ["d"] = true,
        ["pm"] = 452,
      },
    },
    ["n"] = "Want More than Middens?",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2129] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7297900000,
        ["px"] = 0.4421800000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7296000000,
        ["px"] = 0.4415000000,
        ["pm"] = 9,
      },
      [3] = {
        ["px"] = 0.4373300000,
        ["py"] = 0.7267800000,
        ["d"] = true,
        ["pm"] = 452,
      },
    },
    ["n"] = "Ode to the Elden Tree",
    ["cn"] = "Words of the Poets",
  },
  [2130] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7472600000,
        ["px"] = 0.4233600000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7484200000,
        ["px"] = 0.4514000000,
        ["pm"] = 9,
      },
    },
    ["n"] = "One Bosmer's Response to the Dominion",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2131] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7316300000,
        ["px"] = 0.4636900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Hunt With Me",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2132] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7265800000,
        ["px"] = 0.4126300000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7087000000,
        ["px"] = 0.4125800000,
        ["pm"] = 9,
      },
    },
    ["n"] = "What Comes Next",
    ["cn"] = "Daedric Cults",
  },
  [2133] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6904100000,
        ["px"] = 0.3830900000,
        ["pm"] = 9,
      },
      [2] = {
        ["pm"] = 9,
        ["px"] = 0.3830400000,
        ["d"] = true,
        ["py"] = 0.6903100000,
        ["mn"] = 7,
      },
    },
    ["n"] = "Letter to Calahawn",
    ["cn"] = "Letters and Missives",
  },
  [2134] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3968496093, ["py"] = 0.6843171776, ["pm"] = 536, ["zm"] = 9, },
    },
    ["n"] = "Redfur Corporal's Log",
    ["cn"] = "Diaries and Logs",
  },
  [2135] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7079600000,
        ["px"] = 0.4325100000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Journal of Culanwe",
    ["cn"] = "Daedric Cults",
  },
  [2136] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2285900000,
        ["px"] = 0.2073300000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Note from Sagabar",
    ["cn"] = "Criminal Correspondence",
  },
  [2145] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter from the Orsinium Orphanage",
    ["q"] = 5014,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2555200000,
        ["px"] = 0.1998800000,
        ["pm"] = 10,
      },
    },
  },
  [2146] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "List of Targets",
    ["q"] = 4927,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2385800000,
        ["px"] = 0.1533800000,
        ["pm"] = 10,
      },
    },
  },
  [2148] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2173600000,
        ["px"] = 0.2107600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Orders from Commander Pyline",
    ["cn"] = "Plots and Schemes",
  },
  [2149] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Morrowind Fauna, Part One",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 15,
      [143] = 29,
      [258] = 8,
      [227] = 2,
      [1060] = 66,
      [13] = 5,
      [74] = 5,
      [7] = 15,
    },
  },
  [2150] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2030211958, ["py"] = 0.2417672002, ["pm"] = 10, },
    },
    ["n"] = "Krisandra Edrald's Journal, Vol. 3",
    ["cn"] = "Personal Journals",
  },
  [2151] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Dulkhi's Diary",
    ["q"] = 5027,
    ["e"] = {
      [1] = {
        ["px"] = 0.2056451946, ["py"] = 0.2405632008, ["pm"] = 10,
      },
    },
  },
  [2152] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Krisandra Edrald's Journal, Vol. 1",
    ["q"] = 5027,
    ["e"] = {
      [1] = {
        ["px"] = 0.2008684000, ["py"] = 0.2382428004, ["pm"] = 10,
      },
    },
  },
  [2155] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1606480049, ["py"] = 0.2266451977, ["pm"] = 477, ["d"] = true,
        ["zx"] = 0.1602243977, ["zy"] = 0.2296156003, ["zm"] = 10,
      },
      [2] = {
        ["px"] = 0.1667967986, ["py"] = 0.2355016019, ["pm"] = 10,
      },
    },
    ["n"] = "Morilatta",
    ["cn"] = "Mysteries and Clues",
  },
  [2156] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1597224053, ["py"] = 0.2267007976, ["pm"] = 477, ["d"] = true,
        ["zx"] = 0.1602243977, ["zy"] = 0.2296156003, ["zm"] = 10,
      },
      [2] = {
        ["px"] = 0.1667783992, ["py"] = 0.2355272025, ["pm"] = 10,
      },
    },
    ["n"] = "Angalayond",
    ["cn"] = "Words of the Poets",
  },
  [2157] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1606620050, ["py"] = 0.2271411977, ["pm"] = 477, ["d"] = true,
        ["zx"] = 0.1602243977, ["zy"] = 0.2296156003, ["zm"] = 10,
      },
      [2] = {
        ["px"] = 0.1668051982, ["py"] = 0.2354771996, ["pm"] = 10,
      },
    },
    ["n"] = "Larelleis",
    ["cn"] = "Mysteries and Clues",
  },
  [2159] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Krisandra Edrald's Journal, Vol. 2",
    ["q"] = 5027,
    ["e"] = {
      [1] = {
        ["px"] = 0.1937564012, ["py"] = 0.2315796024, ["pm"] = 647, ["d"] = true,
        ["zx"] = 0.2036532005, ["zy"] = 0.2425103982, ["zm"] = 10,
      },
    },
  },
  [2161] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1606612051, ["py"] = 0.2262751978, ["pm"] = 477, ["d"] = true,
        ["zx"] = 0.1602243977, ["zy"] = 0.2296156003, ["zm"] = 10,
      },
      [2] = {
        ["px"] = 0.1668051982, ["py"] = 0.2354771996, ["pm"] = 10,
      },
    },
    ["n"] = "Wenayasille",
    ["cn"] = "Mysteries and Clues",
  },
  [2162] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3643200000,
        ["px"] = 0.5638500000,
        ["pm"] = 125,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3637100000,
        ["px"] = 0.5731500000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Note in Bag of Vvardenfell Silk",
    ["cn"] = "Notes and Memos",
  },
  [2163] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2055483964, ["py"] = 0.2408416005, ["pm"] = 10,
      },
    },
    ["n"] = "An Orc's Guide to Tamriel",
    ["cn"] = "The World and Its Creatures",
  },
  [2164] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2043212004, ["py"] = 0.2418328003, ["pm"] = 10,
      },
    },
    ["n"] = "A Light on the Moor",
    ["cn"] = "Tales of Tamriel",
  },
  [2176] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1647004053, ["py"] = 0.2852936010, ["pm"] = 34, ["zm"] = 12, },
    },
    ["n"] = "Statue of Sir Byric",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2177] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Saving Your Hide",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 29,
      [1060] = 11,
      [1126] = 11,
      [7] = 2,
      [9] = 1,
      [10] = 4,
      [13] = 3,
      [143] = 5,
      [16] = 7,
      [660] = 9,
      [22] = 2,
      [26] = 4,
      [27] = 25,
      [20] = 45,
      [125] = 16,
      [667] = 1,
      [255] = 8,
    },
  },
  [2178] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Chopping Block",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 1,
      [143] = 10,
      [1060] = 4,
      [660] = 6,
      [61] = 28,
      [22] = 47,
      [7] = 15,
      [26] = 3,
      [1126] = 9,
      [10] = 6,
      [667] = 1,
      [27] = 8,
      [13] = 3,
      [30] = 18,
      [255] = 43,
    },
  },
  [2179] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Sword-Wisdom of Saikhalar",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [1060] = 11,
      [143] = 24,
      [1126] = 61,
      [7] = 15,
      [61] = 1,
      [660] = 2,
      [10] = 48,
      [27] = 13,
      [300] = 74,
      [13] = 6,
      [26] = 48,
      [255] = 26,
    },
  },
  [2180] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "A Grifter's Apology",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 6,
      [255] = 22,
      [1060] = 8,
      [667] = 1,
      [20] = 1,
      [660] = 18,
      [1126] = 7,
      [7] = 25,
      [10] = 19,
      [9] = 44,
      [26] = 5,
      [27] = 42,
      [12] = 16,
      [13] = 49,
      [125] = 1,
      [143] = 5,
    },
  },
  [2182] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5112800000,
        ["px"] = 0.5816400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Letter to Marina",
    ["cn"] = "Letters and Missives",
  },
  [2183] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4274400000,
        ["px"] = 0.5181100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "All Our Hopes Dashed",
    ["cn"] = "Final Words",
  },
  [2184] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5571900000,
        ["px"] = 0.5448900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Perfect Hiding Spot",
    ["cn"] = "Diaries and Logs",
  },
  [2185] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4478200000,
        ["px"] = 0.5427100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Love Note to Adrienne",
    ["cn"] = "Hearts and Flowers",
  },
  [2186] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4478000000,
        ["px"] = 0.5425900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Love Note to Catina",
    ["cn"] = "Hearts and Flowers",
  },
  [2187] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4479200000,
        ["px"] = 0.5427000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Love Note to Enna",
    ["cn"] = "Hearts and Flowers",
  },
  [2188] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4997600000,
        ["px"] = 0.5456100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Pages from Thiirril's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [2191] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5333400000,
        ["px"] = 0.5267100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Rendarion's Apology",
    ["cn"] = "Notes and Memos",
  },
  [2197] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5392300000,
        ["px"] = 0.5768000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Last Words of Gordianus Fortunatus",
    ["cn"] = "Final Words",
  },
  [2198] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4450100000,
        ["px"] = 0.5483800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Ulf's Torn Journal",
    ["cn"] = "Personal Journals",
  },
  [2199] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4440900000,
        ["px"] = 0.5496900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Rayno's Scorched Journal",
    ["cn"] = "Plots and Schemes",
  },
  [2200] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3798800000,
        ["px"] = 0.4115100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Caecilius' Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2201] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3796200000,
        ["px"] = 0.4119200000,
        ["pm"] = 1126,
      },
      [2] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
    },
    ["n"] = "How the Yokudans Chased the Stars",
    ["cn"] = "Craglorn Secrets",
  },
  [2204] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5287500000,
        ["px"] = 0.5149100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "To Scarius",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2205] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5218200000,
        ["px"] = 0.5673200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Graveyard Research Notes",
    ["cn"] = "Research Notes",
  },
  [2206] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4488100000,
        ["px"] = 0.5253100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Ayleid Ruin Exploration Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [2207] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4240000000,
        ["px"] = 0.5318700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Imperial Recall Orders",
    ["cn"] = "Military Orders and Reports",
  },
  [2208] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4448800000,
        ["px"] = 0.4976000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Death Desired",
    ["cn"] = "Final Words",
  },
  [2209] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4508700000,
        ["px"] = 0.5461500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "To Delay Means Death",
    ["cn"] = "Military Orders and Reports",
  },
  [2210] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4260900000,
        ["px"] = 0.5566000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "From Nirn to the Aether",
    ["cn"] = "Research Notes",
  },
  [2211] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Non-Standard Techniques",
    ["q"] = 5038,
    ["e"] = {
      [1] = {
        ["px"] = 0.7118500000,
        ["py"] = 0.4444300000,
        ["d"] = true,
        ["pm"] = 97,
        ["zx"] = 0.7116743959, ["zy"] = 0.4444460016, ["zm"] = 7,
      },
    },
  },
  [2212] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4358600000,
        ["px"] = 0.5169400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Imperial Mutiny!",
    ["cn"] = "Plots and Schemes",
  },
  [2213] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5203300000,
        ["px"] = 0.5888100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Avenge Us!",
    ["cn"] = "Final Words",
  },
  [2214] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4729400000,
        ["px"] = 0.5719500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Your Final Opportunity",
    ["cn"] = "Military Orders and Reports",
  },
  [2215] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4640100000,
        ["px"] = 0.5622900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Heading to Imperial City",
    ["cn"] = "Military Orders and Reports",
  },
  [2216] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4810700000,
        ["px"] = 0.5693300000,
        ["pm"] = 16,
      },
    },
    ["n"] = "I Suspect Duplicity",
    ["cn"] = "Diaries and Logs",
  },
  [2217] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4915400000,
        ["px"] = 0.6007500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Someday It'll Be Just You",
    ["cn"] = "Notes and Memos",
  },
  [2219] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4842100000,
        ["px"] = 0.5822600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Letter to Alma",
    ["cn"] = "Letters and Missives",
  },
  [2220] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5006100000,
        ["px"] = 0.5901600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Call to Adventure!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2221] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4744600000,
        ["px"] = 0.6161900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Might as Well Die Fighting",
    ["cn"] = "Final Words",
  },
  [2222] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4345500000,
        ["px"] = 0.5826200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Skyshard in Sight!",
    ["cn"] = "Final Words",
  },
  [2223] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "How to Win a Fight",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 24,
      [143] = 7,
      [1060] = 2,
      [16] = 9,
      [1126] = 49,
      [7] = 5,
      [13] = 7,
      [26] = 8,
      [10] = 1,
      [27] = 5,
      [660] = 4,
      [125] = 21,
      [20] = 32,
      [255] = 23,
    },
  },
  [2224] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Ceryolminwe's Translation",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 2,
      [143] = 25,
      [1060] = 3,
      [660] = 3,
      [61] = 29,
      [1126] = 17,
      [7] = 11,
      [27] = 7,
      [26] = 7,
      [10] = 11,
      [667] = 1,
      [22] = 45,
      [13] = 15,
      [30] = 45,
      [255] = 13,
    },
  },
  [2225] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Wuunding and Tumult",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [143] = 5,
      [1060] = 4,
      [61] = 1,
      [1126] = 16,
      [7] = 8,
      [125] = 2,
      [26] = 44,
      [10] = 52,
      [27] = 6,
      [300] = 71,
      [13] = 12,
      [667] = 1,
      [255] = 33,
    },
  },
  [2226] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "A Hero's Weapon",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 5,
      [1060] = 4,
      [26] = 6,
      [1126] = 16,
      [7] = 9,
      [660] = 2,
      [9] = 51,
      [10] = 6,
      [667] = 1,
      [12] = 23,
      [13] = 73,
      [27] = 14,
      [255] = 25,
    },
  },
  [2227] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "An Archer's Archive",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [143] = 11,
      [1060] = 1,
      [667] = 1,
      [20] = 41,
      [125] = 25,
      [1126] = 16,
      [7] = 10,
      [660] = 4,
      [26] = 6,
      [10] = 11,
      [27] = 26,
      [256] = 35,
      [13] = 4,
      [30] = 3,
      [255] = 32,
    },
  },
  [2228] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Sporting Chance",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 2,
      [1060] = 4,
      [667] = 1,
      [1126] = 10,
      [660] = 6,
      [255] = 20,
      [22] = 42,
      [7] = 24,
      [10] = 13,
      [61] = 52,
      [26] = 4,
      [27] = 14,
      [125] = 1,
      [13] = 4,
      [30] = 23,
      [143] = 14,
    },
  },
  [2229] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Source of the Bone",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 1,
      [143] = 37,
      [1060] = 3,
      [660] = 5,
      [61] = 1,
      [1126] = 33,
      [7] = 46,
      [667] = 2,
      [26] = 43,
      [10] = 71,
      [27] = 17,
      [300] = 72,
      [13] = 2,
      [256] = 1,
      [255] = 63,
    },
  },
  [2230] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Bliss",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 8,
      [143] = 10,
      [1060] = 1,
      [26] = 4,
      [1126] = 58,
      [7] = 2,
      [660] = 5,
      [9] = 46,
      [10] = 5,
      [667] = 1,
      [12] = 35,
      [13] = 41,
      [27] = 25,
      [255] = 9,
    },
  },
  [2231] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4540100000,
        ["px"] = 0.6061400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Worship in Fanacas",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2232] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4961600000,
        ["px"] = 0.5752100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Black Dagger Recall Orders",
    ["cn"] = "Criminal Correspondence",
  },
  [2234] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5181300000,
        ["px"] = 0.5867900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Timberscar Frustration",
    ["cn"] = "Diaries and Logs",
  },
  [2235] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4369600000,
        ["px"] = 0.5806500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Tough Audience",
    ["cn"] = "Notes and Memos",
  },
  [2236] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4871700000,
        ["px"] = 0.5920800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Promise Made",
    ["cn"] = "Daedric Cults",
  },
  [2237] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4965500000,
        ["px"] = 0.6003100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "There is No Waterside Curse",
    ["cn"] = "Notes and Memos",
  },
  [2238] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5049000000,
        ["px"] = 0.5898500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Establish Watchposts",
    ["cn"] = "Military Orders and Reports",
  },
  [2239] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4466300000,
        ["px"] = 0.6101900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Cyrodilic Merchant's Lament",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [2240] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4697800000,
        ["px"] = 0.5763400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Blue Road Scout Notes",
    ["cn"] = "Military Orders and Reports",
  },
  [2241] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4266400000,
        ["px"] = 0.5953700000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Bruma Pleads for Aid",
    ["cn"] = "Notes and Memos",
  },
  [2242] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4413700000,
        ["px"] = 0.6178500000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Apologies to Uncle Neldatir",
    ["cn"] = "Notes and Memos",
  },
  [2243] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4492100000,
        ["px"] = 0.6239900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Taking Tolls!",
    ["cn"] = "Criminal Correspondence",
  },
  [2244] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4465800000,
        ["px"] = 0.6199200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Time to Strike!",
    ["cn"] = "Daedric Cults",
  },
  [2245] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4622700000,
        ["px"] = 0.6221400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Guise of Woodcutter",
    ["cn"] = "Diaries and Logs",
  },
  [2246] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2031660047, ["py"] = 0.3360208014, ["pm"] = 12,
      },
    },
    ["n"] = "Saint Stental",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2247] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3124900000,
        ["px"] = 0.1121600000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Lieutenant Jascien's Last Missive",
    ["cn"] = "Final Words",
  },
  [2248] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4858900000,
        ["px"] = 0.4903400000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Aicaano's Journal",
    ["cn"] = "Personal Journals",
  },
  [2249] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4538600000,
        ["px"] = 0.5365100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Waited as Long as We Could",
    ["cn"] = "Notes and Memos",
  },
  [2250] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4533400000,
        ["px"] = 0.5318800000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4536200000,
        ["px"] = 0.5354000000,
        ["pm"] = 16,
      },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.4532900000,
        ["px"] = 0.5327000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Aleswell Eviction Notice",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2251] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Report: Quality of Recruits",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 4,
      [143] = 12,
      [1060] = 1,
      [20] = 49,
      [667] = 1,
      [1126] = 13,
      [7] = 3,
      [125] = 28,
      [660] = 1,
      [10] = 7,
      [27] = 15,
      [256] = 27,
      [13] = 8,
      [26] = 5,
      [255] = 20,
    },
  },
  [2252] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Xil-Go's Spell",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 1,
      [143] = 4,
      [16] = 15,
      [61] = 34,
      [1060] = 3,
      [26] = 11,
      [22] = 40,
      [7] = 12,
      [667] = 1,
      [660] = 23,
      [10] = 16,
      [27] = 6,
      [1126] = 15,
      [13] = 23,
      [30] = 21,
      [255] = 28,
    },
  },
  [2253] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Undeniable Truths of Attire",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 4,
      [1060] = 2,
      [255] = 27,
      [1126] = 6,
      [7] = 7,
      [61] = 1,
      [9] = 2,
      [26] = 47,
      [27] = 10,
      [300] = 74,
      [13] = 2,
      [10] = 36,
      [143] = 11,
    },
  },
  [2254] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Call to the Faithful",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [255] = 30,
      [1060] = 15,
      [667] = 2,
      [660] = 5,
      [300] = 1,
      [1126] = 69,
      [7] = 18,
      [26] = 5,
      [9] = 44,
      [10] = 13,
      [27] = 13,
      [12] = 46,
      [13] = 27,
      [30] = 3,
      [143] = 6,
    },
  },
  [2255] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4725000000,
        ["px"] = 0.5531900000,
        ["pm"] = 660,
      },
    },
    ["n"] = "Discomforts of War",
    ["cn"] = "Skill Books",
  },
  [2256] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Settling the Debate",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 15,
      [255] = 15,
      [1060] = 7,
      [660] = 5,
      [667] = 1,
      [22] = 33,
      [7] = 10,
      [1126] = 13,
      [10] = 8,
      [26] = 2,
      [27] = 7,
      [61] = 28,
      [13] = 6,
      [30] = 28,
      [143] = 1,
    },
  },
  [2257] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Azarrid's Race",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 5,
      [660] = 2,
      [1060] = 4,
      [1126] = 46,
      [7] = 14,
      [61] = 1,
      [26] = 49,
      [10] = 30,
      [667] = 1,
      [300] = 55,
      [13] = 10,
      [27] = 6,
      [255] = 14,
    },
  },
  [2258] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Husks and Bones",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 5,
      [143] = 3,
      [1060] = 6,
      [660] = 3,
      [125] = 2,
      [1126] = 13,
      [7] = 8,
      [26] = 3,
      [9] = 44,
      [10] = 3,
      [667] = 1,
      [12] = 38,
      [13] = 44,
      [27] = 15,
      [255] = 20,
    },
  },
  [2259] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4680900000,
        ["px"] = 0.4920800000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4689000000,
        ["px"] = 0.4905000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "The Chorrol Crier",
    ["cn"] = "Diaries and Logs",
  },
  [2260] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5190500000,
        ["px"] = 0.5147600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Angiente's Book of Prospects",
    ["cn"] = "Hearts and Flowers",
  },
  [2261] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5147800000,
        ["px"] = 0.5851300000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Irrigation Research Journal",
    ["cn"] = "Research Notes",
  },
  [2262] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4306800000,
        ["px"] = 0.5450100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Grigerda's Letter",
    ["cn"] = "Letters and Missives",
  },
  [2263] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5251500000,
        ["px"] = 0.5421600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Four Coins of Yore",
    ["cn"] = "Words of the Poets",
  },
  [2264] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5590300000,
        ["px"] = 0.5695300000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5451900000,
        ["px"] = 0.5301200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Bounty Order from Sorcalin",
    ["cn"] = "Military Orders and Reports",
  },
  [2267] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5591800000,
        ["px"] = 0.5695200000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5452200000,
        ["px"] = 0.5301200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Aldmeri Scouting Efforts",
    ["cn"] = "Military Orders and Reports",
  },
  [2277] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5819300000,
        ["px"] = 0.4756200000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5827700000,
        ["px"] = 0.4760000000,
        ["pm"] = 256,
      },
    },
    ["n"] = "Dominion Intelligence Topsheet",
    ["cn"] = "Military Orders and Reports",
  },
  [2280] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5597100000,
        ["px"] = 0.5689400000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5454100000,
        ["px"] = 0.5287900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "War Reports for Queen and Thalmor",
    ["cn"] = "Military Orders and Reports",
  },
  [2281] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5589300000,
        ["px"] = 0.5693700000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5457300000,
        ["px"] = 0.5280200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Progress Inquiry: Cyrodiil",
    ["cn"] = "Military Orders and Reports",
  },
  [2296] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5591400000,
        ["px"] = 0.5312900000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5451000000,
        ["px"] = 0.5289000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Dominion Military Recruitment",
    ["cn"] = "Military Orders and Reports",
  },
  [2298] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4519400000,
        ["px"] = 0.4720000000,
        ["pm"] = 16,
      },
      [2] = { ["px"] = 0.4753532094, ["py"] = 0.4446615919, ["pm"] = 16, },
    },
    ["n"] = "Information Request from Emeric",
    ["cn"] = "Military Orders and Reports",
  },
  [2314] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4432200000,
        ["px"] = 0.4800100000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4517400000,
        ["px"] = 0.4716100000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Respectful Greetings from Am-Shadal",
    ["cn"] = "Notes and Memos",
  },
  [2315] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4513800000,
        ["px"] = 0.4715000000,
        ["pm"] = 16,
      },
      [2] = { ["px"] = 0.4756388083, ["py"] = 0.4449323931, ["pm"] = 16, },
    },
    ["n"] = "Updated Instructions from Dortene",
    ["cn"] = "Military Orders and Reports",
  },
  [2316] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6097027950, ["py"] = 0.4199392110, ["pm"] = 573, ["zm"] = 16, },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4627000000,
        ["px"] = 0.6169000000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Conquer Cyrodiil for the Pact!",
    ["cn"] = "Military Orders and Reports",
  },
  [2317] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4198700000,
        ["px"] = 0.6111600000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4629200000,
        ["px"] = 0.6166300000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Chastisement from Zimmeron",
    ["cn"] = "Military Orders and Reports",
  },
  [2318] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4201500000,
        ["px"] = 0.6113200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "A Warning from Zimmeron",
    ["cn"] = "Military Orders and Reports",
  },
  [2319] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4542600000,
        ["px"] = 0.6276800000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Pact Recruitment",
    ["cn"] = "Military Orders and Reports",
  },
  [2326] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3860500000,
        ["px"] = 0.1825800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Goodbye Note",
    ["cn"] = "Notes and Memos",
  },
  [2327] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3868900000,
        ["px"] = 0.1866800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Things to do before the baby comes:",
    ["cn"] = "Hearts and Flowers",
  },
  [2328] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3567100000,
        ["px"] = 0.3079700000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Shalan's Note",
    ["cn"] = "Notes and Memos",
  },
  [2329] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4339100000,
        ["px"] = 0.7545300000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Still-Water's Journal",
    ["cn"] = "Personal Journals",
  },
  [2331] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Kuralit's Clue",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7001000000,
        ["px"] = 0.3554200000,
        ["pm"] = 300,
      },
    },
  },
  [2332] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Mendreval's Clue",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7001000000,
        ["px"] = 0.3554100000,
        ["pm"] = 300,
      },
    },
  },
  [2333] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Rilding's Clue",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7001100000,
        ["px"] = 0.3553600000,
        ["pm"] = 300,
      },
    },
  },
  [2334] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Talqua's Clue",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7001100000,
        ["px"] = 0.3553400000,
        ["pm"] = 300,
      },
    },
  },
  [2336] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5177900000,
        ["px"] = 0.7914500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Letter to Bodani",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2339] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Masters' Hall",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 19,
      [143] = 8,
      [1060] = 7,
      [16] = 9,
      [1126] = 11,
      [7] = 15,
      [660] = 5,
      [125] = 23,
      [10] = 5,
      [27] = 15,
      [26] = 6,
      [13] = 9,
      [20] = 22,
      [255] = 16,
    },
  },
  [2340] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Folly in Fixation",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 7,
      [16] = 5,
      [255] = 31,
      [1060] = 7,
      [660] = 3,
      [667] = 1,
      [22] = 39,
      [7] = 17,
      [1126] = 9,
      [10] = 8,
      [26] = 4,
      [27] = 3,
      [61] = 33,
      [13] = 3,
      [30] = 16,
      [143] = 7,
    },
  },
  [2341] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Armor of Myth and Legend",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 1,
      [143] = 3,
      [61] = 1,
      [1060] = 1,
      [667] = 3,
      [1126] = 13,
      [7] = 26,
      [26] = 28,
      [660] = 4,
      [10] = 39,
      [27] = 8,
      [300] = 55,
      [13] = 8,
      [30] = 2,
      [255] = 16,
    },
  },
  [2342] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Rotwood Enigma",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 1,
      [143] = 10,
      [16] = 4,
      [660] = 10,
      [1060] = 5,
      [125] = 1,
      [1126] = 15,
      [7] = 25,
      [667] = 2,
      [9] = 39,
      [26] = 7,
      [27] = 20,
      [12] = 21,
      [13] = 59,
      [10] = 18,
      [255] = 26,
    },
  },
  [2343] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Glinting Talons",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 28,
      [143] = 13,
      [16] = 2,
      [667] = 2,
      [20] = 28,
      [125] = 15,
      [1126] = 46,
      [7] = 15,
      [660] = 4,
      [26] = 4,
      [10] = 13,
      [27] = 7,
      [1060] = 1,
      [13] = 5,
      [30] = 29,
      [255] = 10,
    },
  },
  [2344] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Mazubar-do's Advice",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 4,
      [16] = 7,
      [255] = 37,
      [1060] = 11,
      [660] = 7,
      [667] = 1,
      [22] = 54,
      [7] = 33,
      [1126] = 17,
      [10] = 6,
      [26] = 6,
      [27] = 10,
      [61] = 36,
      [13] = 4,
      [30] = 67,
      [143] = 27,
    },
  },
  [2345] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Crush, Slash, Bash, and Stab",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 15,
      [143] = 6,
      [61] = 2,
      [660] = 4,
      [125] = 1,
      [1126] = 48,
      [7] = 12,
      [667] = 2,
      [26] = 43,
      [10] = 35,
      [27] = 8,
      [300] = 51,
      [13] = 6,
      [1060] = 2,
      [255] = 22,
    },
  },
  [2346] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Quotes from the Greats",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 11,
      [255] = 15,
      [20] = 1,
      [1060] = 3,
      [1126] = 12,
      [7] = 3,
      [660] = 3,
      [9] = 41,
      [26] = 3,
      [27] = 16,
      [12] = 33,
      [13] = 59,
      [10] = 9,
      [143] = 1,
    },
  },
  [2347] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Waters of Oblivion",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [1060] = 3,
      [143] = 15,
      [1126] = 4,
      [7] = 9,
      [667] = 1,
      [125] = 2,
      [10] = 18,
      [27] = 6,
      [660] = 1,
      [13] = 6,
      [26] = 1,
      [255] = 35,
    },
  },
  [2348] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 1",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 9,
      [201] = 6,
      [258] = 2,
      [75] = 1,
      [143] = 33,
      [74] = 8,
      [7] = 7,
    },
  },
  [2349] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 3",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [143] = 16,
      [201] = 6,
      [74] = 19,
      [75] = 2,
      [1] = 8,
      [13] = 4,
      [227] = 2,
      [7] = 9,
    },
  },
  [2350] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 4",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [12] = 12,
      [13] = 15,
      [9] = 25,
      [27] = 6,
    },
  },
  [2351] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 8",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [300] = 18,
      [10] = 23,
      [26] = 10,
      [27] = 2,
    },
  },
  [2352] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4740400000,
        ["px"] = 0.5480100000,
        ["pm"] = 660,
      },
    },
    ["n"] = "The Year 2920, Vol. 11",
    ["cn"] = "Tales of Tamriel",
  },
  [2353] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4768200000,
        ["px"] = 0.5555000000,
        ["pm"] = 660,
      },
    },
    ["n"] = "The Year 2920, Vol. 14",
    ["cn"] = "Tales of Tamriel",
  },
  [2354] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4777500000,
        ["px"] = 0.5430200000,
        ["pm"] = 660,
      },
    },
    ["n"] = "The Year 2920, Vol. 15",
    ["cn"] = "Tales of Tamriel",
  },
  [2355] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 18",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 7,
      [125] = 16,
      [20] = 10,
      [27] = 3,
    },
  },
  [2356] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 19",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 8,
      [125] = 18,
      [20] = 11,
      [27] = 5,
    },
  },
  [2357] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4739400000,
        ["px"] = 0.5447200000,
        ["pm"] = 660,
      },
    },
    ["n"] = "The Year 2920, Vol. 20",
    ["cn"] = "Tales of Tamriel",
  },
  [2358] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4774600000,
        ["px"] = 0.5551100000,
        ["pm"] = 660,
      },
    },
    ["n"] = "The Year 2920, Vol. 22",
    ["cn"] = "Tales of Tamriel",
  },
  [2359] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4989800000,
        ["px"] = 0.7087200000,
        ["pm"] = 13,
      },
      [2] = {
        ["px"] = 0.7125388091, ["py"] = 0.5001943893, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "The Scent's the Thing",
    ["cn"] = "Notes and Memos",
  },
  [2360] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7063792091, ["py"] = 0.5005195894, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "Curative Batch Six",
    ["cn"] = "Research Notes",
  },
  [2361] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7085700091, ["py"] = 0.5025603891, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "Curative Batch Fifteen",
    ["cn"] = "Research Notes",
  },
  [2362] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3854900000,
        ["px"] = 0.3984300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "The Way of the Blade",
    ["cn"] = "Craglorn Secrets",
  },
  [2363] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7861400000,
        ["py"] = 0.4843300000,
        ["d"] = true,
        ["pm"] = 128,
      },
      [2] = {
        ["px"] = 0.7661968129, ["py"] = 0.5051888150, ["pm"] = 205, ["zm"] = 13,
      },
    },
    ["n"] = "Great House Mottos (Annotated)",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2364] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Philosophy of Stealth",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 23,
      [143] = 2,
      [16] = 4,
      [20] = 39,
      [13] = 8,
      [1126] = 15,
      [7] = 15,
      [1060] = 4,
      [660] = 2,
      [26] = 5,
      [27] = 10,
      [300] = 1,
      [125] = 29,
      [10] = 4,
      [255] = 29,
    },
  },
  [2365] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Shadow Draining: A Hypothesis",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 11,
      [1060] = 4,
      [61] = 28,
      [22] = 51,
      [7] = 10,
      [1126] = 43,
      [27] = 2,
      [10] = 3,
      [667] = 2,
      [26] = 6,
      [13] = 2,
      [30] = 15,
      [255] = 23,
    },
  },
  [2366] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Stepping through Shadows",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 1,
      [143] = 9,
      [660] = 1,
      [1060] = 5,
      [1126] = 9,
      [7] = 5,
      [61] = 1,
      [26] = 31,
      [10] = 38,
      [27] = 3,
      [300] = 42,
      [13] = 11,
      [30] = 2,
      [255] = 31,
    },
  },
  [2367] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2112403965, ["py"] = 0.2069219996, ["pm"] = 513, ["zm"] = 10, },
    },
    ["n"] = "Note to Parsifal",
    ["cn"] = "Notes and Memos",
  },
  [2368] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Stendarr's Divine Spear",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 24,
      [1060] = 8,
      [1126] = 8,
      [7] = 14,
      [10] = 11,
      [13] = 19,
      [143] = 12,
      [16] = 11,
      [660] = 14,
      [22] = 1,
      [20] = 34,
      [26] = 7,
      [27] = 17,
      [667] = 2,
      [125] = 13,
      [30] = 1,
      [255] = 21,
    },
  },
  [2369] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Aura of the Righteous",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 3,
      [1060] = 5,
      [667] = 1,
      [1126] = 11,
      [660] = 1,
      [255] = 13,
      [22] = 49,
      [7] = 5,
      [10] = 12,
      [9] = 1,
      [26] = 5,
      [27] = 5,
      [61] = 52,
      [13] = 7,
      [30] = 43,
      [143] = 5,
    },
  },
  [2370] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Rituals of the Harmonious Masters",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 4,
      [143] = 16,
      [660] = 9,
      [1060] = 10,
      [1126] = 6,
      [7] = 11,
      [61] = 1,
      [26] = 38,
      [10] = 44,
      [667] = 3,
      [300] = 45,
      [13] = 4,
      [27] = 9,
      [255] = 23,
    },
  },
  [2371] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Friend of All Mortals",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 15,
      [255] = 19,
      [1060] = 7,
      [20] = 1,
      [660] = 6,
      [1126] = 18,
      [7] = 18,
      [10] = 8,
      [9] = 48,
      [26] = 3,
      [27] = 20,
      [12] = 29,
      [13] = 54,
      [125] = 4,
      [143] = 15,
    },
  },
  [2372] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Four Abominations",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 66,
      [256] = 2,
      [258] = 20,
      [227] = 9,
      [1060] = 8,
      [1126] = 27,
      [7] = 27,
      [201] = 7,
      [10] = 19,
      [75] = 9,
      [12] = 1,
      [13] = 3,
      [143] = 126,
      [16] = 13,
      [660] = 31,
      [26] = 3,
      [27] = 7,
      [667] = 1,
      [74] = 8,
      [255] = 17,
    },
  },
  [2373] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5434700000,
        ["px"] = 0.5759400000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4771900000,
        ["px"] = 0.5634800000,
        ["pm"] = 16,
      },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.5153500000,
        ["px"] = 0.5723700000,
        ["pm"] = 16,
      },
      [4] = {
        ["mn"] = 14,
        ["py"] = 0.4980100000,
        ["px"] = 0.5524200000,
        ["pm"] = 16,
      },
      [5] = {
        ["mn"] = 14,
        ["py"] = 0.4955300000,
        ["px"] = 0.5623600000,
        ["pm"] = 16,
      },
      [6] = {
        ["mn"] = 14,
        ["py"] = 0.5284200000,
        ["px"] = 0.5799000000,
        ["pm"] = 16,
      },
      [7] = {
        ["mn"] = 14,
        ["py"] = 0.5208200000,
        ["px"] = 0.5744400000,
        ["pm"] = 16,
      },
      [8] = {
        ["mn"] = 14,
        ["py"] = 0.5232300000,
        ["px"] = 0.5735600000,
        ["pm"] = 16,
      },
      [9] = {
        ["mn"] = 14,
        ["py"] = 0.4960400000,
        ["px"] = 0.5676400000,
        ["pm"] = 16,
      },
      [10] = {
        ["mn"] = 14,
        ["py"] = 0.4622200000,
        ["px"] = 0.5387600000,
        ["pm"] = 16,
      },
      [11] = {
        ["mn"] = 14,
        ["py"] = 0.4946400000,
        ["px"] = 0.5401000000,
        ["pm"] = 16,
      },
      [12] = {
        ["mn"] = 14,
        ["py"] = 0.4974300000,
        ["px"] = 0.5657300000,
        ["pm"] = 16,
      },
      [13] = {
        ["mn"] = 14,
        ["py"] = 0.4753000000,
        ["px"] = 0.5345200000,
        ["pm"] = 16,
      },
      [14] = {
        ["mn"] = 14,
        ["py"] = 0.5446600000,
        ["px"] = 0.5709500000,
        ["pm"] = 16,
      },
      [15] = {
        ["mn"] = 14,
        ["py"] = 0.4597500000,
        ["px"] = 0.5579600000,
        ["pm"] = 16,
      },
      [16] = {
        ["mn"] = 14,
        ["py"] = 0.5302400000,
        ["px"] = 0.5796900000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Slaughterfish Warning",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2374] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7092248093, ["py"] = 0.5000535894, ["pm"] = 569, ["d"] = true,
        ["zx"] = 0.7070607994, ["zy"] = 0.4990504148, ["zm"] = 13,
      },
    },
    ["n"] = "Curative Batch Nineteen",
    ["cn"] = "Research Notes",
  },
  [2375] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
    },
    ["n"] = "The Trial of Fire",
    ["cn"] = "Craglorn Secrets",
  },
  [2376] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
    },
    ["n"] = "The Trial of Martial Knowledge",
    ["cn"] = "Craglorn Secrets",
  },
  [2377] = {
    ["c"] = true,
    ["cn"] = "Craglorn Secrets",
    ["n"] = "The Trial of the Arena",
    ["q"] = 5751,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3788000000,
        ["px"] = 0.3967600000,
        ["pm"] = 1126,
      },
    },
  },
  [2378] = {
    ["c"] = true,
    ["cn"] = "Craglorn Secrets",
    ["n"] = "The Trial of Air",
    ["q"] = 5751,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3787600000,
        ["px"] = 0.3968900000,
        ["pm"] = 1126,
      },
    },
  },
  [2379] = {
    ["c"] = true,
    ["cn"] = "Craglorn Secrets",
    ["n"] = "The Trial of the True Path",
    ["q"] = 5751,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3787200000,
        ["px"] = 0.3968600000,
        ["pm"] = 1126,
      },
    },
  },
  [2380] = {
    ["c"] = true,
    ["cn"] = "Craglorn Secrets",
    ["n"] = "The Hidden Trials",
    ["q"] = 5751,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3788200000,
        ["px"] = 0.3968800000,
        ["pm"] = 1126,
      },
    },
  },
  [2381] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "On the Utility of Shock Magic",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 25,
      [20] = 38,
      [1060] = 8,
      [1126] = 11,
      [7] = 9,
      [667] = 1,
      [125] = 37,
      [10] = 4,
      [27] = 18,
      [256] = 29,
      [13] = 3,
      [26] = 3,
      [255] = 35,
    },
  },
  [2382] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Dark Magic: Three Pretexts",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [27] = 4,
      [1126] = 34,
      [61] = 45,
      [22] = 44,
      [30] = 15,
    },
  },
  [2383] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3989500000,
        ["py"] = 0.3847700000,
        ["d"] = true,
        ["pm"] = 1082,
      },
    },
    ["n"] = "Dead Sword-Disciple's Note",
    ["cn"] = "Craglorn Secrets",
  },
  [2384] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7167299993, ["py"] = 0.4984420175, ["pm"] = 13,
      },
    },
    ["n"] = "Alchemist Nilyne's Notes",
    ["cn"] = "Research Notes",
  },
  [2386] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Principles of Conjuration",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 2,
      [143] = 5,
      [1060] = 12,
      [660] = 3,
      [61] = 1,
      [1126] = 10,
      [7] = 25,
      [125] = 1,
      [667] = 1,
      [26] = 65,
      [27] = 5,
      [300] = 83,
      [13] = 5,
      [10] = 52,
      [255] = 23,
    },
  },
  [2387] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Sorcery is Not Necromancy!",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 51,
      [258] = 18,
      [227] = 1,
      [1126] = 7,
      [7] = 45,
      [201] = 9,
      [74] = 52,
      [75] = 1,
      [13] = 2,
      [143] = 124,
    },
  },
  [2388] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Mora'at's Theory of Lightning",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [9] = 57,
      [27] = 12,
      [12] = 41,
      [13] = 60,
      [1126] = 27,
      [20] = 1,
    },
  },
  [2389] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Ardent Flame: Draconic or Endemic?",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 31,
      [27] = 5,
      [20] = 50,
      [125] = 13,
      [1126] = 8,
    },
  },
  [2391] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3604300000,
        ["px"] = 0.3983100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Alvada's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2392] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3606200000,
        ["px"] = 0.3982000000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Strange Riddle",
    ["cn"] = "Craglorn Secrets",
  },
  [2393] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3960400000,
        ["py"] = 0.3659600000,
        ["d"] = true,
        ["pm"] = 1103,
      },
    },
    ["n"] = "Ibrula's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2394] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "To Smite with Dragon Claws",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 10,
      [1060] = 8,
      [667] = 1,
      [1126] = 13,
      [660] = 6,
      [255] = 29,
      [22] = 36,
      [7] = 6,
      [10] = 21,
      [61] = 49,
      [26] = 2,
      [27] = 4,
      [125] = 1,
      [13] = 6,
      [30] = 15,
      [143] = 1,
    },
  },
  [2395] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Forged in the Heart of Mundus",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [10] = 44,
      [27] = 9,
      [300] = 45,
      [61] = 3,
      [1126] = 12,
      [26] = 40,
    },
  },
  [2396] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4495600000,
        ["px"] = 0.5642000000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.4165700000,
        ["px"] = 0.4886600000,
        ["pm"] = 16,
      },
      [3] = {
        ["mn"] = 14,
        ["py"] = 0.4513400000,
        ["px"] = 0.4706000000,
        ["pm"] = 16,
      },
      [4] = { ["px"] = 0.6098267951, ["py"] = 0.4200544109, ["pm"] = 573, ["zm"] = 16, },
    },
    ["n"] = "Those Who Stood at Chalman Keep",
    ["cn"] = "Tales of Tamriel",
  },
  [2397] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4774500000,
        ["px"] = 0.5523300000,
        ["pm"] = 660,
      },
    },
    ["n"] = "Mythical Beast, Real Powers",
    ["cn"] = "Skill Books",
  },
  [2398] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4806400000,
        ["px"] = 0.5505900000,
        ["pm"] = 657,
      },
    },
    ["n"] = "Legacy of the Dragonguard",
    ["cn"] = "Skill Books",
  },
  [2402] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Journal of Thracius Mento",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 7,
      [143] = 8,
      [1060] = 16,
      [20] = 34,
      [660] = 6,
      [1126] = 10,
      [7] = 6,
      [125] = 40,
      [256] = 17,
      [10] = 8,
      [27] = 13,
      [26] = 4,
      [13] = 11,
      [30] = 1,
      [255] = 21,
    },
  },
  [2403] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Cantillon's Correspondence",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 12,
      [143] = 1,
      [61] = 39,
      [125] = 2,
      [1060] = 1,
      [660] = 11,
      [22] = 52,
      [7] = 8,
      [1126] = 9,
      [10] = 6,
      [26] = 6,
      [27] = 3,
      [300] = 1,
      [13] = 14,
      [30] = 35,
      [255] = 22,
    },
  },
  [2404] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Precepts of Stendarr",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 10,
      [143] = 2,
      [1060] = 15,
      [660] = 20,
      [61] = 2,
      [1126] = 10,
      [7] = 11,
      [667] = 2,
      [26] = 47,
      [10] = 47,
      [27] = 5,
      [300] = 96,
      [13] = 16,
      [256] = 1,
      [255] = 40,
    },
  },
  [2405] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "Almalexia and the Mudcrab",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 9,
      [143] = 7,
      [660] = 8,
      [1060] = 3,
      [1126] = 16,
      [7] = 20,
      [667] = 2,
      [9] = 38,
      [26] = 8,
      [27] = 15,
      [12] = 35,
      [13] = 59,
      [10] = 12,
      [255] = 15,
    },
  },
  [2406] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Destruction or Distraction",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [256] = 31,
      [143] = 10,
      [1060] = 3,
      [16] = 1,
      [1126] = 24,
      [7] = 6,
      [660] = 3,
      [125] = 20,
      [10] = 6,
      [27] = 27,
      [26] = 2,
      [13] = 5,
      [20] = 27,
      [255] = 22,
    },
  },
  [2407] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Oshgura's Destruction Journal",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 1,
      [16] = 8,
      [255] = 17,
      [1060] = 11,
      [1126] = 36,
      [660] = 4,
      [667] = 2,
      [22] = 37,
      [7] = 12,
      [256] = 6,
      [10] = 4,
      [26] = 7,
      [27] = 8,
      [61] = 44,
      [13] = 2,
      [30] = 11,
      [143] = 9,
    },
  },
  [2408] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "The Vanishing Crux",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [16] = 3,
      [143] = 4,
      [660] = 4,
      [1060] = 2,
      [1126] = 4,
      [7] = 4,
      [61] = 1,
      [26] = 31,
      [10] = 51,
      [27] = 4,
      [300] = 80,
      [13] = 5,
      [667] = 2,
      [255] = 22,
    },
  },
  [2409] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Prudence in Practice",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5075900000,
        ["px"] = 0.7613020000,
        ["pm"] = 205,
        ["zm"] = 13,
      },
    },
    ["m"] = {
      [16] = 7,
      [255] = 9,
      [1060] = 17,
      [20] = 1,
      [667] = 2,
      [1126] = 12,
      [7] = 22,
      [660] = 9,
      [9] = 88,
      [26] = 8,
      [27] = 17,
      [12] = 34,
      [13] = 55,
      [10] = 10,
      [143] = 5,
    },
  },
  [2410] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4677600000,
        ["px"] = 0.5031600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Torchbugs",
    ["cn"] = "Notes and Memos",
  },
  [2411] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4563100000,
        ["px"] = 0.5176600000,
        ["pm"] = 16,
      },
    },
    ["n"] = "Statuary Complications",
    ["cn"] = "Letters and Missives",
  },
  [2412] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4458800000,
        ["px"] = 0.5786200000,
        ["pm"] = 16,
      },
    },
    ["n"] = "An Irate Employer",
    ["cn"] = "Letters and Missives",
  },
  [2413] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3608000000,
        ["px"] = 0.2784600000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Hawk\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [2414] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3591600000,
        ["px"] = 0.2783000000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Man and Beast\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [2415] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3574400000,
        ["px"] = 0.2785800000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Yokudan \"Mother and Son\" Enigma",
    ["cn"] = "Mysteries and Clues",
  },
  [2418] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4761300000,
        ["px"] = 0.7076300000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4875000000,
        ["px"] = 0.7190900000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.4943100000,
        ["px"] = 0.7182000000,
        ["pm"] = 13,
      },
      [4] = {
        ["mn"] = 10,
        ["py"] = 0.4987300000,
        ["px"] = 0.7130600000,
        ["pm"] = 13,
      },
      [5] = {
        ["mn"] = 10,
        ["py"] = 0.4968100000,
        ["px"] = 0.7185600000,
        ["pm"] = 13,
      },
      [6] = {
        ["mn"] = 10,
        ["py"] = 0.4999100000,
        ["px"] = 0.7144300000,
        ["pm"] = 13,
      },
      [7] = {
        ["mn"] = 11,
        ["py"] = 0.4817700000,
        ["px"] = 0.7121400000,
        ["pm"] = 7,
      },
      [8] = {
        ["px"] = 0.7169068007, ["py"] = 0.4983396155, ["pm"] = 13,
      },
      [9] = {
        ["mn"] = 10,
        ["py"] = 0.4932500000,
        ["px"] = 0.7176300000,
        ["pm"] = 13,
      },
      [10] = {
        ["px"] = 0.7138432001, ["py"] = 0.4963552155, ["pm"] = 13,
      },
      [11] = {
        ["mn"] = 10,
        ["py"] = 0.5006100000,
        ["px"] = 0.7167800000,
        ["pm"] = 13,
      },
      [12] = {
        ["mn"] = 10,
        ["py"] = 0.4967800000,
        ["px"] = 0.7128200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Come for the Cure!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2419] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Cooking Mastery, The Easy Way",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 27,
      [256] = 6,
      [258] = 15,
      [227] = 2,
      [1126] = 15,
      [7] = 27,
      [9] = 9,
      [10] = 8,
      [75] = 2,
      [12] = 12,
      [13] = 10,
      [143] = 49,
      [20] = 8,
      [22] = 18,
      [74] = 5,
      [201] = 15,
      [26] = 10,
      [27] = 6,
      [300] = 15,
      [125] = 26,
      [30] = 3,
      [61] = 13,
    },
  },
  [2420] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Alchemy: Discovering Traits",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 17,
      [256] = 16,
      [258] = 3,
      [227] = 2,
      [1126] = 20,
      [7] = 13,
      [9] = 3,
      [10] = 16,
      [75] = 7,
      [12] = 14,
      [13] = 9,
      [143] = 56,
      [20] = 31,
      [22] = 21,
      [74] = 24,
      [201] = 2,
      [26] = 10,
      [27] = 10,
      [300] = 8,
      [125] = 16,
      [30] = 2,
      [61] = 18,
    },
  },
  [2421] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Enigma of the Runestones",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 17,
      [256] = 5,
      [1313] = 1,
      [994] = 4,
      [1060] = 22,
      [1349] = 11,
      [1126] = 30,
      [7] = 18,
      [9] = 24,
      [10] = 15,
      [75] = 1,
      [12] = 14,
      [13] = 17,
      [1006] = 20,
      [143] = 37,
      [20] = 10,
      [1429] = 10,
      [74] = 7,
      [26] = 23,
      [27] = 12,
      [201] = 17,
      [125] = 15,
      [300] = 15,
      [61] = 2,
    },
  },
  [2425] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3622800000,
        ["py"] = 0.3515800000,
        ["d"] = true,
        ["pm"] = 1093,
      },
    },
    ["n"] = "Daggerfall Covenant Missive",
    ["cn"] = "Craglorn Secrets",
  },
  [2426] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3821100000,
        ["py"] = 0.3514200000,
        ["d"] = true,
        ["pm"] = 1102,
      },
    },
    ["n"] = "Tome of the Anka-Ra Guardians",
    ["cn"] = "Craglorn Secrets",
  },
  [2427] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3850500000,
        ["py"] = 0.3813900000,
        ["d"] = true,
        ["pm"] = 1080,
      },
    },
    ["n"] = "A Star-Gazer's Ramblings",
    ["cn"] = "Craglorn Secrets",
  },
  [2428] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4051400000,
        ["py"] = 0.3776100000,
        ["d"] = true,
        ["pm"] = 1076,
      },
    },
    ["n"] = "Lamias of Craglorn",
    ["cn"] = "Craglorn Secrets",
  },
  [2429] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3749311958, ["py"] = 0.3681884004, ["pm"] = 1077, ["d"] = true,
        ["zx"] = 0.3702832148, ["zy"] = 0.3648371968, ["zm"] = 1126,
      },
    },
    ["n"] = "Sanavar's Research Notes",
    ["cn"] = "Craglorn Secrets",
  },
  [2430] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4015600000,
        ["py"] = 0.3522500000,
        ["d"] = true,
        ["pm"] = 1089,
      },
    },
    ["n"] = "A Recipe of Surpassing Danger",
    ["cn"] = "Craglorn Secrets",
  },
  [2431] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3798500000,
        ["px"] = 0.4201500000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Phillip's Note to Yasmine",
    ["cn"] = "Craglorn Secrets",
  },
  [2432] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3803700000,
        ["px"] = 0.4112000000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "The Unearthing of Kardala",
    ["cn"] = "Craglorn Secrets",
  },
  [2433] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3818800000,
        ["px"] = 0.4210300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Blasius' Unfinished Manuscript",
    ["cn"] = "Craglorn Secrets",
  },
  [2434] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4179216011, ["py"] = 0.3808823939, ["pm"] = 1131, ["zm"] = 1126,
      },
    },
    ["n"] = "A Merchant's Orders to His Guards",
    ["cn"] = "Craglorn Secrets",
  },
  [2435] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4190912014, ["py"] = 0.3804639938, ["pm"] = 1131, ["zm"] = 1126,
      },
    },
    ["n"] = "Defaced Mages Guild Reward Notice",
    ["cn"] = "Craglorn Secrets",
  },
  [2436] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4158788018, ["py"] = 0.3794651942, ["pm"] = 1131, ["zm"] = 1126,
      },
    },
    ["n"] = "Smuggler's Note",
    ["cn"] = "Craglorn Secrets",
  },
  [2437] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1737992034, ["py"] = 0.2515392046, ["pm"] = 85, ["zm"] = 10, ["ld"] = 9, },
    },
    ["n"] = "The Manifesto of Make Way",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2438] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1744856036, ["py"] = 0.2521092052, ["pm"] = 85, ["zm"] = 10, ["ld"] = 9, },
    },
    ["n"] = "Notes on Shornhelm's Cisterns",
    ["cn"] = "Plots and Schemes",
  },
  [2439] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Fundaments of Alchemy",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 38,
      [256] = 12,
      [227] = 12,
      [1126] = 11,
      [7] = 4,
      [9] = 19,
      [10] = 17,
      [75] = 12,
      [12] = 25,
      [13] = 24,
      [143] = 29,
      [20] = 19,
      [22] = 16,
      [74] = 3,
      [26] = 14,
      [27] = 8,
      [300] = 9,
      [125] = 10,
      [30] = 7,
      [61] = 11,
    },
  },
  [2440] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Glyphs and Enchantment",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1126] = 8,
      [22] = 20,
      [300] = 43,
      [61] = 12,
      [9] = 22,
      [10] = 21,
      [27] = 5,
      [12] = 11,
      [13] = 27,
      [30] = 7,
      [26] = 25,
    },
  },
  [2441] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Clothier: Light Armor Basics",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 31,
      [256] = 8,
      [258] = 5,
      [227] = 4,
      [1126] = 25,
      [7] = 11,
      [201] = 3,
      [10] = 20,
      [75] = 2,
      [300] = 48,
      [13] = 3,
      [143] = 21,
      [16] = 4,
      [20] = 33,
      [22] = 11,
      [61] = 9,
      [26] = 25,
      [27] = 3,
      [74] = 16,
      [125] = 10,
      [30] = 39,
      [255] = 17,
    },
  },
  [2442] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Bowyer and Fletcher",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 25,
      [256] = 9,
      [258] = 18,
      [227] = 2,
      [1126] = 8,
      [7] = 11,
      [9] = 9,
      [10] = 36,
      [75] = 2,
      [12] = 18,
      [13] = 11,
      [143] = 100,
      [20] = 10,
      [22] = 11,
      [74] = 3,
      [201] = 4,
      [26] = 8,
      [27] = 4,
      [300] = 16,
      [125] = 23,
      [30] = 3,
      [61] = 9,
    },
  },
  [2443] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "One Staff, Many Staves",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 13,
      [256] = 25,
      [227] = 1,
      [1126] = 4,
      [7] = 11,
      [9] = 39,
      [10] = 19,
      [75] = 3,
      [12] = 32,
      [13] = 17,
      [143] = 19,
      [20] = 27,
      [22] = 10,
      [74] = 7,
      [26] = 19,
      [27] = 8,
      [300] = 40,
      [125] = 6,
      [30] = 6,
      [61] = 15,
    },
  },
  [2444] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "The Tava's Bounty Ledger",
    ["q"] = 2556,
    ["e"] = {
      [1] = { ["px"] = 0.1646524057, ["py"] = 0.3109527968, ["pm"] = 532, ["zm"] = 12, },
    },
  },
  [2452] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Heavy Armor: A Forge-Wife's Advice",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1] = 33,
      [256] = 9,
      [227] = 9,
      [1126] = 41,
      [7] = 8,
      [9] = 25,
      [10] = 12,
      [12] = 15,
      [13] = 24,
      [143] = 58,
      [20] = 11,
      [74] = 5,
      [26] = 21,
      [27] = 10,
      [201] = 1,
      [125] = 4,
      [300] = 18,
      [61] = 1,
    },
  },
  [2453] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2875000000,
        ["py"] = 0.2715900000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "Smithing: A Worthy Endeavor",
    ["cn"] = "Skill Books",
  },
  [2454] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Zuzik's Clue",
    ["q"] = 4791,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.7001200000,
        ["px"] = 0.3552700000,
        ["pm"] = 300,
      },
    },
  },
  [2455] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.2917200000,
        ["px"] = 0.1213200000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Fire's Grip",
    ["cn"] = "Notes and Memos",
  },
  [2456] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3325200000,
        ["px"] = 0.1384400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Mesanthano's Tower",
    ["cn"] = "Notes and Memos",
  },
  [2457] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3635300000,
        ["px"] = 0.0736100000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Legend of Chill House",
    ["cn"] = "Notes and Memos",
  },
  [2458] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0659843988, ["py"] = 0.3280524023, ["pm"] = 1,
      },
    },
    ["n"] = "Theyo Bezon's Natural Observations",
    ["cn"] = "Final Words",
  },
  [2459] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0626979996, ["py"] = 0.3744324029, ["pm"] = 1,
      },
    },
    ["n"] = "Ruminations by Guard Kleo",
    ["cn"] = "Final Words",
  },
  [2460] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1073792003, ["py"] = 0.3437168050, ["pm"] = 1,
      },
    },
    ["n"] = "By Order of Faolchu",
    ["cn"] = "Military Orders and Reports",
  },
  [2461] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1383160053, ["py"] = 0.3211908060, ["pm"] = 1,
      },
    },
    ["n"] = "An Egg-citing Discovery!",
    ["cn"] = "Final Words",
  },
  [2462] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0930808006, ["py"] = 0.3134664034, ["pm"] = 1,
      },
    },
    ["n"] = "A Wealth of Raw Material",
    ["cn"] = "Letters and Missives",
  },
  [2463] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3425700000,
        ["px"] = 0.1146100000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Sardok's Bloodthorn Report",
    ["cn"] = "Daedric Cults",
  },
  [2464] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3580200000,
        ["px"] = 0.0932100000,
        ["pm"] = 1,
      },
    },
    ["n"] = "Leeza's Bloodthorn Report",
    ["cn"] = "Daedric Cults",
  },
  [2465] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3186500000,
        ["px"] = 0.1056400000,
        ["pm"] = 1,
      },
    },
    ["n"] = "The Lurching Dead",
    ["cn"] = "Letters and Missives",
  },
  [2466] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1796972011, ["py"] = 0.2143352001, ["pm"] = 10,
      },
    },
    ["n"] = "Ravenwatch Research: Veawend Ede",
    ["cn"] = "Research Notes",
  },
  [2467] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2608300000,
        ["px"] = 0.1399100000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Ravenwatch Research: Aesar Hatespinner",
    ["cn"] = "Research Notes",
  },
  [2468] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1937100003, ["py"] = 0.2445107991, ["pm"] = 10,
      },
    },
    ["n"] = "Louna's Grimoire: Corpse Cough",
    ["cn"] = "Rituals and Revelations",
  },
  [2469] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2194200000,
        ["px"] = 0.1990600000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Letter to Leonce Gavendien",
    ["cn"] = "Letters and Missives",
  },
  [2470] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.1960800000,
        ["px"] = 0.2163800000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Captain Lagra's Ledger",
    ["cn"] = "Criminal Correspondence",
  },
  [2471] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1843723967, ["py"] = 0.2557735982, ["pm"] = 10,
      },
    },
    ["n"] = "Letter from Lady Lleraya",
    ["cn"] = "Letters and Missives",
  },
  [2472] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2330832032, ["py"] = 0.3382284037, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Letter to Danier",
    ["cn"] = "Letters and Missives",
  },
  [2473] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3187300000,
        ["px"] = 0.2657200000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Prayer to My Prince",
    ["cn"] = "Rituals and Revelations",
  },
  [2474] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7986276007, ["py"] = 0.4925548170, ["pm"] = 13,
      },
    },
    ["n"] = "Letter to the Twilight Mage",
    ["cn"] = "Letters and Missives",
  },
  [2475] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4924200000,
        ["px"] = 0.7561400000,
        ["pm"] = 13,
      },
    },
    ["n"] = "By Order of the Tribunal",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2477] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5247500000,
        ["px"] = 0.7300200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Talvini Radus' Last Wish",
    ["cn"] = "Final Words",
  },
  [2478] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3190800000,
        ["px"] = 0.2088300000,
        ["pm"] = 12,
      },
    },
    ["n"] = "A Letter to Maraya",
    ["cn"] = "Hearts and Flowers",
  },
  [2479] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4964700000,
        ["px"] = 0.8108500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Ritual of Daedric Fortitude",
    ["cn"] = "Rituals and Revelations",
  },
  [2480] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3127000000,
        ["px"] = 0.1944300000,
        ["pm"] = 12,
      },
    },
    ["n"] = "Franara's Journal",
    ["cn"] = "Diaries and Logs",
  },
  [2482] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter IV",
    ["e"] = {
      [1] = { ["px"] = 0.2446935982, ["py"] = 0.6963768113, ["pm"] = 143, },
    },
  },
  [2483] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter I",
    ["e"] = {
      [1] = { ["px"] = 0.2380780009, ["py"] = 0.7453364223, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [2484] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter III",
    ["e"] = {
      [1] = { ["px"] = 0.2683464006, ["py"] = 0.6751540133, ["pm"] = 143, },
    },
  },
  [2485] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter XII",
    ["e"] = {
      [1] = { ["px"] = 0.1777255967, ["py"] = 0.6038872135, ["pm"] = 143, },
    },
  },
  [2486] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter V",
    ["e"] = {
      [1] = { ["px"] = 0.2071463960, ["py"] = 0.6492644131, ["pm"] = 143, },
    },
  },
  [2487] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter II",
    ["e"] = {
      [1] = { ["px"] = 0.2224556005, ["py"] = 0.7227444153, ["pm"] = 143, },
    },
  },
  [2488] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Auridon Explored, Chapter VII",
    ["e"] = {
      [1] = { ["px"] = 0.2531603962, ["py"] = 0.6737783980, ["pm"] = 545, ["zm"] = 143, },
    },
  },
  [2489] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5817100000,
        ["px"] = 0.4248500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The March Explored, Chapter I",
    ["cn"] = "The World and Its Creatures",
  },
  [2490] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6625900000,
        ["px"] = 0.4451400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The March Explored, Chapter VI",
    ["cn"] = "The World and Its Creatures",
  },
  [2491] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5735500000,
        ["px"] = 0.4415500000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The March Explored, Chapter III",
    ["cn"] = "The World and Its Creatures",
  },
  [2492] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6261200000,
        ["px"] = 0.4339200000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The March Explored, Chapter IX",
    ["cn"] = "The World and Its Creatures",
  },
  [2493] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5889200000,
        ["px"] = 0.4618400000,
        ["pm"] = 256,
      },
    },
    ["n"] = "The March Explored, Chapter VII",
    ["cn"] = "The World and Its Creatures",
  },
  [2494] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4315200000,
        ["d"] = true,
        ["py"] = 0.7317700000,
      },
      [2] = {
        ["px"] = 0.3325000000,
        ["d"] = true,
        ["py"] = 0.2758600000,
        ["pm"] = 103,
      },
      [3] = { ["px"] = 0.2189264028, ["py"] = 0.3328620067, ["pm"] = 33, ["zm"] = 12, },
      [4] = {
        ["mn"] = 10,
        ["py"] = 0.5179600000,
        ["px"] = 0.7645000000,
        ["pm"] = 13,
      },
    },
    ["n"] = "From Jofnir to Merric",
    ["cn"] = "Letters and Missives",
  },
  [2495] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6101200000,
        ["px"] = 0.0705700000,
        ["pm"] = 108,
      },
    },
    ["n"] = "By Order of Guildmaster Vanus Galerion",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2496] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5246200000,
        ["px"] = 0.7627200000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Letter from Magistrix Vox",
    ["cn"] = "Letters and Missives",
  },
  [2497] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8234636006, ["py"] = 0.5117820215, ["pm"] = 13,
      },
    },
    ["n"] = "House Hlaalu Notice",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2498] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7388952017, ["py"] = 0.5118480209, ["pm"] = 13,
      },
    },
    ["n"] = "Letter to Narsis",
    ["cn"] = "Letters and Missives",
  },
  [2499] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.4979400000,
        ["px"] = 0.8334400000,
        ["pm"] = 13,
      },
    },
    ["n"] = "General Gavryn's Declaration",
    ["cn"] = "Military Orders and Reports",
  },
  [2500] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4315800000,
        ["px"] = 0.7393800000,
        ["pm"] = 7,
      },
    },
    ["n"] = "To My Azeez-Eix",
    ["cn"] = "Hearts and Flowers",
  },
  [2501] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3852200000,
        ["px"] = 0.1892900000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Faithful One",
    ["cn"] = "Notes and Memos",
  },
  [2502] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4477500000,
        ["px"] = 0.7221900000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Get it Done, Conele",
    ["cn"] = "Military Orders and Reports",
  },
  [2503] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4641300000,
        ["px"] = 0.6989300000,
        ["pm"] = 7,
      },
    },
    ["n"] = "We Know, Many-Rocks",
    ["cn"] = "Notes and Memos",
  },
  [2506] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4304700000,
        ["px"] = 0.6861800000,
        ["pm"] = 7,
      },
    },
    ["n"] = "To My Pash-Riha",
    ["cn"] = "Hearts and Flowers",
  },
  [2507] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4683700000,
        ["px"] = 0.7337300000,
        ["pm"] = 7,
      },
    },
    ["n"] = "To Jalal",
    ["cn"] = "Notes and Memos",
  },
  [2508] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6310428221, ["py"] = 0.2980511970, ["pm"] = 61, },
    },
    ["n"] = "Tinkerer Tobin's Big Book of Crafting Recipes",
    ["cn"] = "Personal Journals",
  },
  [2509] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6209964260, ["py"] = 0.2892719957, ["pm"] = 61,
      },
    },
    ["n"] = "The Journal of Vivien Armene",
    ["cn"] = "Personal Journals",
  },
  [2510] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4282600000,
        ["px"] = 0.1774400000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Lizards",
    ["cn"] = "Research Notes",
  },
  [2511] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6704276202, ["py"] = 0.3226363910, ["pm"] = 61,
      },
    },
    ["n"] = "Capturing Ammabani's Pride",
    ["cn"] = "Final Words",
  },
  [2512] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.3273600000,
        ["px"] = 0.6604300000,
        ["pm"] = 61,
      },
    },
    ["n"] = "Greetings from the Orcthane",
    ["cn"] = "Criminal Correspondence",
  },
  [2513] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4125100000,
        ["px"] = 0.1609700000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Sheltered",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2514] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6091324269, ["py"] = 0.3014704007, ["pm"] = 61,
      },
    },
    ["n"] = "Thane Jeggi's Drinking Hole",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2515] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.4065200000,
        ["px"] = 0.1948800000,
        ["pm"] = 30,
      },
    },
    ["n"] = "An Artisan's Oasis",
    ["cn"] = "Notes and Memos",
  },
  [2516] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3819700000,
        ["px"] = 0.1987200000,
        ["pm"] = 30,
      },
    },
    ["n"] = "Beware!",
    ["cn"] = "Words of the Poets",
  },
  [2518] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 23,
        ["py"] = 0.2304800000,
        ["px"] = -0.1231500000,
        ["pm"] = 255,
      },
    },
    ["n"] = "Famous Coldharbourites, Part 14",
    ["cn"] = "Personal Journals",
  },
  [2519] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Famous Coldharbourites, Part 21",
    ["e"] = {
      [1] = { ["px"] = -0.1436952021, ["py"] = 0.2439855997, ["pm"] = 255, },
    },
  },
  [2520] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Zemarek-Thul",
    ["e"] = {
      [1] = { ["px"] = -0.0810088041, ["py"] = 0.2710152023, ["pm"] = 255, },
    },
  },
  [2521] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Famous Coldharbourites, Part 37",
    ["e"] = {
      [1] = { ["px"] = -0.0883768069, ["py"] = 0.2412740033, ["pm"] = 255, },
    },
  },
  [2522] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Letter to Cynhamoth",
    ["e"] = {
      [1] = { ["px"] = -0.1026736009, ["py"] = 0.2342735966, ["pm"] = 255, },
    },
  },
  [2524] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "Cadwell's Journal: Deep Thoughts, Part 412",
    ["e"] = {
      [1] = { ["px"] = -0.1144644021, ["py"] = 0.2401159978, ["pm"] = 255, },
    },
  },
  [2525] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3269272134, ["py"] = 0.3178004035, ["pm"] = 240, ["zx"] = 0.3238640034, ["zy"] = 0.3180191955, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Falling",
    ["cn"] = "Mysteries and Clues",
  },
  [2526] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3494100000,
        ["px"] = 0.3064400000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Letter to Hanza",
    ["cn"] = "Final Words",
  },
  [2527] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3532400000,
        ["px"] = 0.2885200000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Damar's Ledger",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [2528] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3263300000,
        ["px"] = 0.3151100000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Lakewatch Tower",
    ["cn"] = "Tales of Tamriel",
  },
  [2529] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.2796000000,
        ["px"] = 0.3064200000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Fool!",
    ["cn"] = "Criminal Correspondence",
  },
  [2530] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 6,
        ["py"] = 0.3623000000,
        ["px"] = 0.2714500000,
        ["pm"] = 20,
      },
    },
    ["n"] = "A Simple Prayer",
    ["cn"] = "Final Words",
  },
  [2531] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6767600000,
        ["px"] = 0.3286700000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Skeevers",
    ["cn"] = "Final Words",
  },
  [2532] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3463900000,
        ["px"] = 0.6487800000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Letter to Strastnoc",
    ["cn"] = "Letters and Missives",
  },
  [2533] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3602700000,
        ["px"] = 0.6215000000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Treaty of the Three Clans",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2534] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3648100000,
        ["px"] = 0.6124400000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Thallik's Orders",
    ["cn"] = "Letters and Missives",
  },
  [2535] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 12,
        ["py"] = 0.3627300000,
        ["px"] = 0.5668700000,
        ["pm"] = 125,
      },
    },
    ["n"] = "Here Lies Grethel",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2536] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5808079995, ["py"] = 0.3515039933, ["pm"] = 125,
      },
    },
    ["n"] = "Eldbjorg's Needed Ingredients",
    ["cn"] = "Mysteries and Clues",
  },
  [2537] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1900048013, ["py"] = 0.2951448031, ["pm"] = 12,
      },
    },
    ["n"] = "Sir Edmund's Letter",
    ["cn"] = "Letters and Missives",
  },
  [2539] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 21,
        ["py"] = 0.8072400000,
        ["px"] = 0.5075000000,
        ["pm"] = 258,
      },
      [2] = {
        ["mn"] = 21,
        ["py"] = 0.8082100000,
        ["px"] = 0.5077400000,
        ["pm"] = 258,
      },
    },
    ["n"] = "Note from Razum-dar",
    ["cn"] = "Notes and Memos",
  },
  [2540] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6568700000,
        ["px"] = 0.3112600000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Xarxes and Oghma",
    ["cn"] = "Hearts and Flowers",
  },
  [2541] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6966900000,
        ["px"] = 0.2857500000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Blue",
    ["cn"] = "Notes and Memos",
  },
  [2542] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6665700000,
        ["px"] = 0.3196600000,
        ["pm"] = 300,
      },
    },
    ["n"] = "A Folk Tale",
    ["cn"] = "Lore and Culture",
  },
  [2543] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3142280026, ["py"] = 0.6968271936, ["pm"] = 300, },
    },
    ["n"] = "Letter to Laenira",
    ["cn"] = "Letters and Missives",
  },
  [2544] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3755200000,
        ["py"] = 0.3725900000,
        ["d"] = true,
        ["pm"] = 614,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Worn and Torn Page",
    ["cn"] = "Craglorn Secrets",
  },
  [2545] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3755800000,
        ["py"] = 0.3724700000,
        ["d"] = true,
        ["pm"] = 614,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Torn Page",
    ["cn"] = "Craglorn Secrets",
  },
  [2546] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3761100000,
        ["py"] = 0.3732300000,
        ["d"] = true,
        ["pm"] = 614,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Torn Page",
    ["cn"] = "Craglorn Secrets",
  },
  [2547] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3755900000,
        ["py"] = 0.3724700000,
        ["d"] = true,
        ["pm"] = 614,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Castles and Coffers Volume III: Hel Ra Citadel",
    ["cn"] = "Craglorn Secrets",
  },
  [2548] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 10,
        ["py"] = 0.5161500000,
        ["px"] = 0.7721300000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Letter to Artisans Craftworks",
    ["cn"] = "Letters and Missives",
  },
  [2549] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7022200000,
        ["px"] = 0.3873900000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Letter to Ofglog",
    ["cn"] = "Letters and Missives",
  },
  [2550] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6313900000,
        ["px"] = 0.3511600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Thozor's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [2551] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6194300000,
        ["px"] = 0.3302500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Warning: Dugan the Red",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2552] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6150100000,
        ["px"] = 0.3966200000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Cover Every Approach",
    ["cn"] = "Criminal Correspondence",
  },
  [2553] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6137200000,
        ["px"] = 0.3636300000,
        ["pm"] = 22,
      },
    },
    ["n"] = "She Is My Light",
    ["cn"] = "Hearts and Flowers",
  },
  [2554] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6060800000,
        ["px"] = 0.4000100000,
        ["pm"] = 22,
      },
    },
    ["n"] = "A Subtler Brew",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [2555] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6372500000,
        ["px"] = 0.3360600000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Matthild Built This Place",
    ["cn"] = "Words of the Poets",
  },
  [2556] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6152300000,
        ["px"] = 0.3789500000,
        ["pm"] = 22,
      },
    },
    ["n"] = "Closing the Octal Cage",
    ["cn"] = "Research Notes",
  },
  [2557] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 19,
        ["py"] = 0.5467500000,
        ["px"] = 0.1516100000,
        ["pm"] = 201,
      },
    },
    ["n"] = "A Fortune Behind Those Walls",
    ["cn"] = "Final Words",
  },
  [2558] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3699900000,
        ["py"] = 0.3552700000,
        ["d"] = true,
        ["pm"] = 1085,
      },
    },
    ["n"] = "The Fires Guide the Way",
    ["cn"] = "Mysteries and Clues",
  },
  [2559] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3747600000,
        ["py"] = 0.3723500000,
        ["d"] = true,
        ["pm"] = 615,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Elenaire's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2560] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 5,
        ["py"] = 0.3979100000,
        ["px"] = 0.1378700000,
        ["pm"] = 30,
      },
      [2] = { ["px"] = 0.2189196027, ["py"] = 0.3329272074, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Jofnir's Journal",
    ["cn"] = "Personal Journals",
  },
  [2561] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Shrine of Mara",
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4356800000,
        ["d"] = true,
        ["py"] = 0.7274100000,
      },
      [2] = {
        ["mn"] = 11,
        ["py"] = 0.4334200000,
        ["px"] = 0.7831100000,
        ["pm"] = 7,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5140100000,
        ["px"] = 0.7659700000,
        ["pm"] = 13,
      },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3923400000,
        ["px"] = 0.0616200000,
        ["pm"] = 1,
      },
      [5] = { ["px"] = 0.2151144025, ["py"] = 0.3356276068, ["pm"] = 33, ["zm"] = 12, },
      [6] = { ["px"] = 0.2331476010, ["py"] = 0.7401160219, ["pm"] = 243, ["zm"] = 143, },
      [7] = {
        ["mn"] = 36,
        ["py"] = 0.6178700000,
        ["px"] = 0.5703800000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
  },
  [2565] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3687968025, ["py"] = 0.3566639975, ["pm"] = 1084, ["d"] = true, },
    },
    ["n"] = "Defaced Nedic Prayer Book",
    ["cn"] = "Craglorn Secrets",
  },
  [2566] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3685700000,
        ["py"] = 0.3545500000,
        ["d"] = true,
        ["pm"] = 1085,
      },
    },
    ["n"] = "Tishi's Research Notes",
    ["cn"] = "Craglorn Secrets",
  },
  [2567] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3642500000,
        ["px"] = 0.3975400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Targa's Note",
    ["cn"] = "Craglorn Secrets",
  },
  [2583] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3837800000,
        ["px"] = 0.4459000000,
        ["pm"] = 1126,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3787900000,
        ["px"] = 0.4215900000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Merchants, Scoundrels, Thieves",
    ["cn"] = "Craglorn Secrets",
  },
  [2584] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3783900000,
        ["px"] = 0.4206400000,
        ["pm"] = 1126,
      },
      [2] = {
        ["px"] = 0.4477500000,
        ["py"] = 0.3768800000,
        ["d"] = true,
        ["pm"] = 1092,
      },
    },
    ["n"] = "The Flourishing of Elinhir",
    ["cn"] = "Craglorn Secrets",
  },
  [2585] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3996800000,
        ["py"] = 0.3842800000,
        ["d"] = true,
        ["pm"] = 1082,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3852500000,
        ["px"] = 0.4548300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Orcs of Tamriel, Volume 3",
    ["cn"] = "Craglorn Secrets",
  },
  [2586] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3685200000,
        ["py"] = 0.3547000000,
        ["d"] = true,
        ["pm"] = 1085,
      },
      [2] = {
        ["px"] = 0.3960100000,
        ["py"] = 0.3658500000,
        ["d"] = true,
        ["pm"] = 1103,
      },
    },
    ["n"] = "Nedes of the Deathlands",
    ["cn"] = "Craglorn Secrets",
  },
  [2587] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3702800000,
        ["py"] = 0.3563300000,
        ["d"] = true,
        ["pm"] = 1085,
      },
    },
    ["n"] = "Tales of Abba Arl: The Ox's Tale",
    ["cn"] = "Craglorn Secrets",
  },
  [2588] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3675800000,
        ["py"] = 0.3549400000,
        ["d"] = true,
        ["pm"] = 1085,
      },
    },
    ["n"] = "Waterlogged Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2604] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3844000000,
        ["px"] = 0.4471600000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Yamanu-ko's Letter to Her Apprentice",
    ["cn"] = "Craglorn Secrets",
  },
  [2605] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3853100000,
        ["px"] = 0.4592100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Tales of Abba Arl: The Fat Mother",
    ["cn"] = "Craglorn Secrets",
  },
  [2606] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3930600000,
        ["px"] = 0.4538500000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "A Citizen's Petition",
    ["cn"] = "Craglorn Secrets",
  },
  [2607] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4420191989, ["py"] = 0.3805287961, ["pm"] = 1091, ["d"] = true, },
    },
    ["n"] = "Mystic Visions of the Guardians",
    ["cn"] = "Craglorn Secrets",
  },
  [2608] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3866700000,
        ["px"] = 0.4543600000,
        ["pm"] = 1126,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3813200000,
        ["px"] = 0.4521300000,
        ["pm"] = 1126,
      },
      [3] = {
        ["mn"] = 25,
        ["py"] = 0.3821900000,
        ["px"] = 0.4533400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Blackcaster Notice",
    ["cn"] = "Craglorn Secrets",
  },
  [2609] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3812200000,
        ["px"] = 0.4506100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Selene's Letter",
    ["cn"] = "Craglorn Secrets",
  },
  [2610] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3812300000,
        ["px"] = 0.4510000000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Frederick's Letter",
    ["cn"] = "Craglorn Secrets",
  },
  [2611] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3712500000,
        ["px"] = 0.4357400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Grazzar's Threat",
    ["cn"] = "Craglorn Secrets",
  },
  [2612] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3669300000,
        ["px"] = 0.4354200000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "A Werewolf Hunter's Advice",
    ["cn"] = "Craglorn Secrets",
  },
  [2613] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4318236148, ["py"] = 0.3782643994, ["pm"] = 1126,
      },
    },
    ["n"] = "Treasure Hunter's Note",
    ["cn"] = "Craglorn Secrets",
  },
  [2614] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4300355884, ["py"] = 0.3796879971, ["pm"] = 1100, ["d"] = true,
        ["zx"] = 0.4299800182, ["zy"] = 0.3796035967, ["zm"] = 1126,
      },
    },
    ["n"] = "Trumbull's Note",
    ["cn"] = "Craglorn Secrets",
  },
  [2615] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4328100000,
        ["py"] = 0.3697800000,
        ["d"] = true,
        ["pm"] = 1090,
      },
    },
    ["n"] = "Treasure Hunter's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2616] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4510800000,
        ["py"] = 0.3659000000,
        ["d"] = true,
        ["pm"] = 1094,
      },
    },
    ["n"] = "Glorious Balamath",
    ["cn"] = "Craglorn Secrets",
  },
  [2617] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4404300000,
        ["py"] = 0.3857300000,
        ["d"] = true,
        ["pm"] = 1099,
      },
    },
    ["n"] = "Aldmeri Court Transcript",
    ["cn"] = "Craglorn Secrets",
  },
  [2618] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4376300000,
        ["py"] = 0.3488000000,
        ["d"] = true,
        ["pm"] = 1101,
      },
    },
    ["n"] = "Chiselshriek Foreman's Log",
    ["cn"] = "Craglorn Secrets",
  },
  [2619] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4154500000,
        ["py"] = 0.3617600000,
        ["d"] = true,
        ["pm"] = 1081,
      },
    },
    ["n"] = "Waylaid Traveler's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2622] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4694300000,
        ["px"] = 0.6916300000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Opening Performance Notes",
    ["cn"] = "Notes and Memos",
  },
  [2623] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4693300000,
        ["px"] = 0.6915500000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Follow-Up Performance Notes",
    ["cn"] = "Notes and Memos",
  },
  [2624] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4693000000,
        ["px"] = 0.6915200000,
        ["pm"] = 7,
      },
    },
    ["n"] = "Closing Performance Notes",
    ["cn"] = "Notes and Memos",
  },
  [2625] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4593591973, ["py"] = 0.3703420014, ["pm"] = 646, ["d"] = true,
        ["zx"] = 0.4571940179, ["zy"] = 0.3700739931, ["zm"] = 1126,
      },
    },
    ["n"] = "Coming of the Learned One Vol. I",
    ["cn"] = "Lore and Culture",
  },
  [2626] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4593900000,
        ["py"] = 0.3704500000,
        ["d"] = true,
        ["pm"] = 646,
        ["zx"] = 0.4571940179, ["zy"] = 0.3700739931, ["zm"] = 1126,
      },
    },
    ["n"] = "Coming of the Learned One, Vol. II",
    ["cn"] = "Lore and Culture",
  },
  [2627] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 23",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["pm"] = 1126,
        ["py"] = 0.3817800000,
        ["px"] = 0.4121700000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [25] = 1,
    },
  },
  [2628] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 24",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3497000000,
        ["pm"] = 1126,
        ["px"] = 0.4002200000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 25,
      },
    },
    ["m"] = {
      [25] = 1,
    },
  },
  [2629] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 25",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["pm"] = 1126,
        ["py"] = 0.3802800000,
        ["px"] = 0.4109800000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [25] = 1,
    },
  },
  [2630] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4593200000,
        ["py"] = 0.3703800000,
        ["d"] = true,
        ["pm"] = 646,
        ["zx"] = 0.4571940179, ["zy"] = 0.3700739931, ["zm"] = 1126,
      },
    },
    ["n"] = "Coming of the Learned One, Vol. III",
    ["cn"] = "Lore and Culture",
  },
  [2636] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4593900000,
        ["py"] = 0.3701900000,
        ["d"] = true,
        ["pm"] = 646,
        ["zx"] = 0.4571940179, ["zy"] = 0.3700739931, ["zm"] = 1126,
      },
    },
    ["n"] = "Coming of the Learned One, Vol. X",
    ["cn"] = "Lore and Culture",
  },
  [2637] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3960400000,
        ["py"] = 0.3659700000,
        ["d"] = true,
        ["pm"] = 1103,
      },
    },
    ["n"] = "Secrets Overheard in Apocrypha",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2639] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2172700000,
        ["py"] = 0.2605600000,
        ["d"] = true,
        ["pm"] = 1154,
      },
    },
    ["n"] = "Rumors of the Spiral Skein",
    ["cn"] = "Daedric Cults",
  },
  [2643] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3715700000,
        ["px"] = 0.4275300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Closed Until Further Notice",
    ["cn"] = "Craglorn Secrets",
  },
  [2644] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3537500000,
        ["px"] = 0.4441500000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "From the Regent of Fanged Fury",
    ["cn"] = "Craglorn Secrets",
  },
  [2645] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3543000000,
        ["px"] = 0.3879600000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "To Zelguma the Strong",
    ["cn"] = "Craglorn Secrets",
  },
  [2646] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3787200000,
        ["px"] = 0.3920400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Star-Gazer Merith's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2647] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Subtropical Cyrodiil: A Speculation",
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.5588700000,
        ["px"] = 0.5694800000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3840600000,
        ["px"] = 0.0611600000,
        ["pm"] = 1,
      },
      [3] = {
        ["mn"] = 11,
        ["py"] = 0.4287400000,
        ["px"] = 0.7831500000,
        ["pm"] = 7,
      },
      [4] = { ["px"] = 0.6097359950, ["py"] = 0.4197996109, ["pm"] = 573, ["zm"] = 16, },
      [5] = { ["px"] = 0.2271268008, ["py"] = 0.7414728220, ["pm"] = 243, ["zm"] = 143, },
      [6] = {
        ["px"] = 0.3965996053, ["py"] = 0.3142487971, ["pm"] = 706, ["d"] = true,
        ["zx"] = 0.3942672162, ["zy"] = 0.3252951947, ["zm"] = 1126,
      },
      [7] = {
        ["mn"] = 14,
        ["py"] = 0.5601300000,
        ["px"] = 0.5282500000,
        ["pm"] = 16,
      },
      [8] = {
        ["mn"] = 14,
        ["py"] = 0.4536000000,
        ["px"] = 0.6265800000,
        ["pm"] = 16,
      },
      [9] = {
        ["mn"] = 14,
        ["py"] = 0.4523000000,
        ["px"] = 0.4718800000,
        ["pm"] = 16,
      },
      [10] = {
        ["mn"] = 14,
        ["py"] = 0.4168600000,
        ["px"] = 0.4886500000,
        ["pm"] = 16,
      },
    },
  },
  [2650] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3542000000,
        ["px"] = 0.4086200000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Lanista's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2651] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Khajiiti Honorifics",
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.5939400000,
        ["px"] = 0.4946600000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.5584300000,
        ["px"] = 0.4620500000,
        ["pm"] = 256,
      },
      [3] = { ["px"] = 0.2260555974, ["py"] = 0.6363760166, ["pm"] = 143, },
      [4] = { ["px"] = 0.5063503749, ["py"] = 0.7952132044, ["pm"] = 567, ["zm"] = 258, },
    },
  },
  [2652] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3439000000,
        ["px"] = 0.4183100000,
        ["pm"] = 1126,
      },
      [2] = {
        ["px"] = 0.3642684132, ["py"] = 0.3279675937, ["pm"] = 1132, ["zm"] = 1126,
      },
      [3] = {
        ["px"] = 0.4006100000,
        ["py"] = 0.3261600000,
        ["d"] = true,
        ["pm"] = 1111,
      },
    },
    ["n"] = "In Praise of Regent Cassipia",
    ["cn"] = "Craglorn Secrets",
  },
  [2654] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3434600000,
        ["px"] = 0.4131600000,
        ["pm"] = 1126,
      },
      [2] = {
        ["px"] = 0.4009500000,
        ["py"] = 0.3259100000,
        ["d"] = true,
        ["pm"] = 1111,
      },
      [3] = {
        ["px"] = 0.4158276156, ["py"] = 0.3312143949, ["pm"] = 1126,
      },
    },
    ["n"] = "Cassipia's Change of Heart",
    ["cn"] = "Craglorn Secrets",
  },
  [2655] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3664764137, ["py"] = 0.3261235936, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Origin of the Scaled Court",
    ["cn"] = "Craglorn Secrets",
  },
  [2656] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3462900000,
        ["px"] = 0.3821400000,
        ["pm"] = 1126,
      },
      [2] = {
        ["px"] = 0.3683920132, ["py"] = 0.3284075934, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Life In the Scaled Court",
    ["cn"] = "Craglorn Secrets",
  },
  [2657] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3944915991, ["py"] = 0.3321863988, ["pm"] = 1116, ["d"] = true,
        ["zx"] = 0.3959752164, ["zy"] = 0.3320119935, ["zm"] = 1126,
      },
      [2] = {
        ["px"] = 0.3985900000,
        ["py"] = 0.3484700000,
        ["d"] = true,
        ["pm"] = 676,
      },
    },
    ["n"] = "Nirncrux: A Study",
    ["cn"] = "Craglorn Secrets",
  },
  [2658] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3775483935, ["py"] = 0.3270900018, ["pm"] = 1115, ["d"] = true,
        ["zx"] = 0.3808820148, ["zy"] = 0.3261723969, ["zm"] = 1126,
      },
    },
    ["n"] = "It Lives!",
    ["cn"] = "Craglorn Secrets",
  },
  [2660] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3332300000,
        ["px"] = 0.4068700000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Amirmil",
    ["cn"] = "Craglorn Secrets",
  },
  [2661] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4084756153, ["py"] = 0.3356699948, ["pm"] = 1126,
      },
    },
    ["n"] = "The Care and Feeding of Trolls",
    ["cn"] = "Craglorn Secrets",
  },
  [2662] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4089608144, ["py"] = 0.3369871972, ["pm"] = 1126,
      },
    },
    ["n"] = "Tracking the Butcher",
    ["cn"] = "Craglorn Secrets",
  },
  [2663] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2169515955, ["py"] = 0.2613212039, ["pm"] = 653, ["zx"] = 0.2055771940, ["zy"] = 0.2701767978, ["zm"] = 10, ["d"] = true, },
    },
    ["n"] = "Star Teeth, Volume I",
    ["cn"] = "Rituals and Revelations",
  },
  [2664] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4147748108, ["py"] = 0.3226495966, ["pm"] = 1117, ["d"] = true,
        ["zx"] = 0.4150708169, ["zy"] = 0.3244335942, ["zm"] = 1126,
      },
    },
    ["n"] = "Agganor's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2666] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2198900000,
        ["py"] = 0.2606100000,
        ["d"] = true,
        ["pm"] = 1154,
      },
    },
    ["n"] = "Requisition Order",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2670] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.0616064018, ["py"] = 0.3797528058, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Beware the Glenumbra Banks",
    ["cn"] = "The World and Its Creatures",
  },
  [2673] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3822900000,
        ["py"] = 0.3471300000,
        ["d"] = true,
        ["pm"] = 1119,
      },
    },
    ["n"] = "Final Thoughts",
    ["cn"] = "Craglorn Secrets",
  },
  [2674] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3670376133, ["py"] = 0.3264075937, ["pm"] = 1132, ["zm"] = 1126,
      },
      [2] = {
        ["px"] = 0.3681268129, ["py"] = 0.3281915936, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Join Dragonstar Caravan Company!",
    ["cn"] = "Craglorn Secrets",
  },
  [2675] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3862300000,
        ["py"] = 0.3490300000,
        ["d"] = true,
        ["pm"] = 1119,
      },
    },
    ["n"] = "Watcher Shavmar's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2676] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3838216058, ["py"] = 0.3487219995, ["pm"] = 1120, ["d"] = true, },
    },
    ["n"] = "Saradin's Diary",
    ["cn"] = "Craglorn Secrets",
  },
  [2677] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3981800000,
        ["py"] = 0.3395700000,
        ["d"] = true,
        ["pm"] = 676,
      },
    },
    ["n"] = "Skyreach Explorer, Volume One",
    ["cn"] = "Craglorn Secrets",
  },
  [2678] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3831800000,
        ["py"] = 0.3472300000,
        ["d"] = true,
        ["pm"] = 1119,
      },
    },
    ["n"] = "Skyreach Explorer, Volume Four",
    ["cn"] = "Craglorn Secrets",
  },
  [2679] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3830600000,
        ["py"] = 0.3465400000,
        ["d"] = true,
        ["pm"] = 1119,
      },
    },
    ["n"] = "Skyreach Explorer, Volume Three",
    ["cn"] = "Craglorn Secrets",
  },
  [2680] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4009100000,
        ["py"] = 0.3423700000,
        ["d"] = true,
        ["pm"] = 676,
      },
    },
    ["n"] = "Skyreach Explorer, Volume Two",
    ["cn"] = "Craglorn Secrets",
  },
  [2681] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4003960062, ["py"] = 0.3502859960, ["pm"] = 675, ["d"] = true, },
    },
    ["n"] = "From Regent of Serpentine Stratagems",
    ["cn"] = "Craglorn Secrets",
  },
  [2682] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3422900000,
        ["px"] = 0.4251700000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Covenant Intelligence Report 2,502",
    ["cn"] = "Craglorn Secrets",
  },
  [2683] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Unhallowed Legions",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["pm"] = 660,
        ["py"] = 0.4802900000,
        ["px"] = 0.5505700000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2684] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3965684052, ["py"] = 0.3142083971, ["pm"] = 706, ["d"] = true,
        ["zx"] = 0.3942672162, ["zy"] = 0.3252951947, ["zm"] = 1126,
      },
    },
    ["n"] = "Unmarked Pages",
    ["cn"] = "Plots and Schemes",
  },
  [2685] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4006200000,
        ["py"] = 0.3258600000,
        ["d"] = true,
        ["pm"] = 1111,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3798000000,
        ["px"] = 0.4114700000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Dawn of the Exalted Viper",
    ["cn"] = "Craglorn Secrets",
  },
  [2688] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3836800000,
        ["py"] = 0.3488000000,
        ["d"] = true,
        ["pm"] = 1119,
      },
    },
    ["n"] = "Virmaril's Journal",
    ["cn"] = "Craglorn Secrets",
  },
  [2689] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3336900000,
        ["px"] = 0.3759500000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Isrudde",
    ["cn"] = "Craglorn Secrets",
  },
  [2690] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3333700000,
        ["px"] = 0.3757100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "A Star Walks In Craglorn",
    ["cn"] = "Craglorn Secrets",
  },
  [2691] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3479300000,
        ["px"] = 0.3940500000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Dusandar",
    ["cn"] = "Craglorn Secrets",
  },
  [2692] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3559031929, ["py"] = 0.3421296004, ["pm"] = 1107, ["d"] = true,
        ["zx"] = 0.3570700136, ["zy"] = 0.3383915959, ["zm"] = 1126,
      },
    },
    ["n"] = "Wamasu Observations",
    ["cn"] = "Craglorn Secrets",
  },
  [2693] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3785927934, ["py"] = 0.3259976019, ["pm"] = 1115, ["d"] = true,
        ["zx"] = 0.3808820148, ["zy"] = 0.3261723969, ["zm"] = 1126,
      },
    },
    ["n"] = "Orders from Regent Elska",
    ["cn"] = "Craglorn Secrets",
  },
  [2694] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3778455935, ["py"] = 0.3247824019, ["pm"] = 1115, ["d"] = true,
        ["zx"] = 0.3808820148, ["zy"] = 0.3261723969, ["zm"] = 1126,
      },
    },
    ["n"] = "The Serpent's Song",
    ["cn"] = "Craglorn Secrets",
  },
  [2695] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4204200000,
        ["py"] = 0.3456300000,
        ["d"] = true,
        ["pm"] = 1112,
      },
    },
    ["n"] = "Ilthag's Orders",
    ["cn"] = "Craglorn Secrets",
  },
  [2696] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4209000000,
        ["py"] = 0.3447100000,
        ["d"] = true,
        ["pm"] = 1112,
      },
    },
    ["n"] = "Blood for Our Enemies",
    ["cn"] = "Craglorn Secrets",
  },
  [2697] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4189200000,
        ["py"] = 0.3458200000,
        ["d"] = true,
        ["pm"] = 1112,
      },
    },
    ["n"] = "Vosh and Rakh: A History",
    ["cn"] = "Craglorn Secrets",
  },
  [2698] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2187384005, ["py"] = 0.2885084022, ["pm"] = 968, ["d"] = true,
        ["zx"] = 0.2185699974, ["zy"] = 0.2885024004, ["zm"] = 667,
      },
    },
    ["n"] = "King Maxevian's Orders",
    ["cn"] = "Wrothgar Writings",
  },
  [2699] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3950955991, ["py"] = 0.3311859987, ["pm"] = 1116, ["d"] = true,
        ["zx"] = 0.3959752164, ["zy"] = 0.3320119935, ["zm"] = 1126,
      },
    },
    ["n"] = "The Serpent's Blade",
    ["cn"] = "Craglorn Secrets",
  },
  [2700] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2882500000,
        ["px"] = 0.2168900000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2188100000,
        ["py"] = 0.2882100000,
        ["d"] = true,
        ["pm"] = 968,
      },
    },
    ["n"] = "Letter to King Maxevian",
    ["cn"] = "Wrothgar Writings",
  },
  [2701] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Royal Messenger's Fate",
    ["q"] = 5317,
    ["e"] = {
      [1] = { ["px"] = 0.2865575982, ["py"] = 0.2554552018, ["pm"] = 895, ["zm"] = 667, ["qc"] = true, },
      [2] = { ["px"] = 0.2865575982, ["py"] = 0.2554552018, ["pm"] = 2163, ["zm"] = 2114, ["qp"] = true, },
    },
  },
  [2702] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4299975930, ["py"] = 0.3346647952, ["pm"] = 1106, ["d"] = true,
        ["zx"] = 0.4298416158, ["zy"] = 0.3349359970, ["zm"] = 1126,
      },
    },
    ["n"] = "Dragon Priest—Arise!",
    ["cn"] = "Craglorn Secrets",
  },
  [2703] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Offer of Amnesty",
    ["q"] = 5317,
    ["e"] = {
      [1] = { ["px"] = 0.2870315980, ["py"] = 0.2559436013, ["pm"] = 895, ["zm"] = 667, },
    },
  },
  [2704] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2671235953, ["py"] = 0.2523631983, ["pm"] = 958, ["d"] = true,
        ["zx"] = 0.2665711984, ["zy"] = 0.2520740048, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to Purifier Cyrus",
    ["cn"] = "Wrothgar Writings",
  },
  [2706] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2670959954, ["py"] = 0.2524583983, ["pm"] = 958, ["d"] = true,
        ["zx"] = 0.2665711984, ["zy"] = 0.2520740048, ["zm"] = 667,
      },
    },
    ["n"] = "Purifier's Journal",
    ["cn"] = "Wrothgar Writings",
  },
  [2707] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3555856008, ["py"] = 0.3319760022, ["pm"] = 1110, ["d"] = true,
        ["zx"] = 0.3556664133, ["zy"] = 0.3315755938, ["zm"] = 1126,
      },
    },
    ["n"] = "The Perfection of Fearfangs Cavern",
    ["cn"] = "Craglorn Secrets",
  },
  [2708] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3558104008, ["py"] = 0.3316368022, ["pm"] = 1110, ["d"] = true,
        ["zx"] = 0.3556664133, ["zy"] = 0.3315755938, ["zm"] = 1126,
      },
    },
    ["n"] = "A Prayer to the Serpent",
    ["cn"] = "Craglorn Secrets",
  },
  [2709] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3549088008, ["py"] = 0.3319216023, ["pm"] = 1110, ["d"] = true,
        ["zx"] = 0.3556664133, ["zy"] = 0.3315755938, ["zm"] = 1126,
      },
    },
    ["n"] = "Scorpion Observations",
    ["cn"] = "Craglorn Secrets",
  },
  [2710] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4152996108, ["py"] = 0.3211979967, ["pm"] = 1117, ["d"] = true,
        ["zx"] = 0.4150708169, ["zy"] = 0.3244335942, ["zm"] = 1126,
      },
    },
    ["n"] = "Exarch's Orders",
    ["cn"] = "Craglorn Secrets",
  },
  [2711] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4136800000,
        ["py"] = 0.3214800000,
        ["d"] = true,
        ["pm"] = 1117,
        ["zx"] = 0.4150708169, ["zy"] = 0.3244335942, ["zm"] = 1126,
      },
      [2] = {
        ["px"] = 0.4145812108, ["py"] = 0.3208243967, ["pm"] = 1117, ["d"] = true,
        ["zx"] = 0.4150708169, ["zy"] = 0.3244335942, ["zm"] = 1126,
      },
    },
    ["n"] = "Letter to Exarch Braadoth",
    ["cn"] = "Craglorn Secrets",
  },
  [2712] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2767816146, ["py"] = 0.2422748024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "Riekrs of Wrothgar: Observations",
    ["cn"] = "Orsinium Archive",
  },
  [2713] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3499900000,
        ["px"] = 0.3903300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Windhelm",
    ["cn"] = "Craglorn Secrets",
  },
  [2714] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4176572170, ["py"] = 0.3269631935, ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Armorer Uthik",
    ["cn"] = "Craglorn Secrets",
  },
  [2715] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3281600000,
        ["px"] = 0.4095300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Runescriber Kulth",
    ["cn"] = "Craglorn Secrets",
  },
  [2716] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3864500000,
        ["py"] = 0.3353100000,
        ["d"] = true,
        ["pm"] = 1114,
      },
    },
    ["n"] = "Skyreach Explorer, Volume Five",
    ["cn"] = "Craglorn Secrets",
  },
  [2718] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3860900000,
        ["py"] = 0.3353700000,
        ["d"] = true,
        ["pm"] = 1114,
      },
    },
    ["n"] = "Skyreach Explorer, Volume Six",
    ["cn"] = "Craglorn Secrets",
  },
  [2720] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3232100000,
        ["px"] = 0.3680400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Blood-Feathers Battle Slogans",
    ["cn"] = "Craglorn Secrets",
  },
  [2721] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3220500000,
        ["px"] = 0.3662800000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Ballad of Dorzogg the Gutter-King",
    ["cn"] = "Craglorn Secrets",
  },
  [2722] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3202300000,
        ["px"] = 0.3681100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Five Claws Battle Cries",
    ["cn"] = "Craglorn Secrets",
  },
  [2723] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3669684135, ["py"] = 0.3306627937, ["pm"] = 1132, ["zm"] = 1126,
      },
      [2] = {
        ["mn"] = 25,
        ["py"] = 0.3210300000,
        ["px"] = 0.3695400000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Challenge the Arena",
    ["cn"] = "Craglorn Secrets",
  },
  [2725] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3686152136, ["py"] = 0.3308927938, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "A Rumor of Serpents",
    ["cn"] = "Craglorn Secrets",
  },
  [2726] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3529836131, ["py"] = 0.3354383965, ["pm"] = 1126,
      },
    },
    ["n"] = "The Gray Passage",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2727] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3555292008, ["py"] = 0.3317648022, ["pm"] = 1110, ["d"] = true,
        ["zx"] = 0.3556664133, ["zy"] = 0.3315755938, ["zm"] = 1126,
      },
    },
    ["n"] = "The Pledge of Courage",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2728] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3773000000,
        ["py"] = 0.3255100000,
        ["d"] = true,
        ["pm"] = 1115,
        ["zx"] = 0.3808820148, ["zy"] = 0.3261723969, ["zm"] = 1126,
      },
    },
    ["n"] = "The Pledge of Vigilance",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2729] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3945223991, ["py"] = 0.3305359987, ["pm"] = 1116, ["d"] = true,
        ["zx"] = 0.3959752164, ["zy"] = 0.3320119935, ["zm"] = 1126,
      },
    },
    ["n"] = "The Pledge of Obedience",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2730] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4287151929, ["py"] = 0.3349211951, ["pm"] = 1106, ["d"] = true,
        ["zx"] = 0.4298416158, ["zy"] = 0.3349359970, ["zm"] = 1126,
      },
    },
    ["n"] = "The Pledge of Piety",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2731] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4143488108, ["py"] = 0.3222831967, ["pm"] = 1117, ["d"] = true,
        ["zx"] = 0.4150708169, ["zy"] = 0.3244335942, ["zm"] = 1126,
      },
    },
    ["n"] = "The Pledge of Simplicity",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2732] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4195300000,
        ["py"] = 0.3450700000,
        ["d"] = true,
        ["pm"] = 1112,
      },
    },
    ["n"] = "The Pledge of Perfection",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2733] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3694848135, ["py"] = 0.3290507935, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "An Amazing Opportunity",
    ["cn"] = "Craglorn Secrets",
  },
  [2734] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2354300000,
        ["px"] = 0.3048200000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Old Orc Sayings: Shields",
    ["cn"] = "Orsinium Archive",
  },
  [2735] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3332500000,
        ["px"] = 0.3766600000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Intercepted Star-Gazer's Document",
    ["cn"] = "Craglorn Secrets",
  },
  [2736] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3648564134, ["py"] = 0.3305611936, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Letter to Elanwen",
    ["cn"] = "Craglorn Secrets",
  },
  [2737] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2873135863, ["py"] = 0.2232816040, ["pm"] = 945, ["d"] = true,
        ["zx"] = 0.2903111945, ["zy"] = 0.2230275997, ["zm"] = 667,
      },
    },
    ["n"] = "Kireth's Notebook, Page 1",
    ["cn"] = "Wrothgar Writings",
  },
  [2738] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3633000134, ["py"] = 0.3269391938, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Scaled Court Communique",
    ["cn"] = "Craglorn Secrets",
  },
  [2739] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2862295864, ["py"] = 0.2232604040, ["pm"] = 945, ["d"] = true,
        ["zx"] = 0.2903111945, ["zy"] = 0.2230275997, ["zm"] = 667,
      },
    },
    ["n"] = "Kireth's Notebook, Page 5",
    ["cn"] = "Wrothgar Writings",
  },
  [2740] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2869967864, ["py"] = 0.2217620040, ["pm"] = 945, ["d"] = true,
        ["zx"] = 0.2903111945, ["zy"] = 0.2230275997, ["zm"] = 667,
      },
    },
    ["n"] = "Kireth's Notebook, Page 11",
    ["cn"] = "Wrothgar Writings",
  },
  [2741] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2865763864, ["py"] = 0.2225512040, ["pm"] = 945, ["d"] = true,
        ["zx"] = 0.2903111945, ["zy"] = 0.2230275997, ["zm"] = 667,
      },
    },
    ["n"] = "Kireth's Notebook, Page 17",
    ["cn"] = "Wrothgar Writings",
  },
  [2742] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3671376135, ["py"] = 0.3262699937, ["pm"] = 1132, ["zm"] = 1126,
      },
    },
    ["n"] = "Letter to Ariana",
    ["cn"] = "Craglorn Secrets",
  },
  [2743] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0056000000,
        ["d"] = true,
        ["py"] = -0.0543700000,
        ["pm"] = 708,
      },
    },
    ["n"] = "We Who Are About To Die",
    ["cn"] = "Craglorn Secrets",
  },
  [2744] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0056800000,
        ["d"] = true,
        ["py"] = -0.0540000000,
        ["pm"] = 708,
      },
    },
    ["n"] = "The Wonders of Craglorn",
    ["cn"] = "Craglorn Secrets",
  },
  [2745] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0048000000,
        ["d"] = true,
        ["py"] = -0.0541500000,
        ["pm"] = 708,
      },
    },
    ["n"] = "Dragonstar Arena Guest Book",
    ["cn"] = "Craglorn Secrets",
  },
  [2746] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0052700000,
        ["d"] = true,
        ["py"] = -0.0545000000,
        ["pm"] = 708,
      },
    },
    ["n"] = "Tracking the Arena",
    ["cn"] = "Craglorn Secrets",
  },
  [2747] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0404900000,
        ["d"] = true,
        ["py"] = -0.0513700000,
        ["pm"] = 708,
      },
    },
    ["n"] = "Boethiah's Call of Champions",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2749] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3264800000,
        ["px"] = 0.3661100000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "The Raneviad, Volume II",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2750] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3026656011, ["py"] = 0.2551688031, ["pm"] = 956, ["d"] = true,
        ["zx"] = 0.3033407985, ["zy"] = 0.2545720009, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to Mairrna",
    ["cn"] = "Wrothgar Writings",
  },
  [2751] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3029696012, ["py"] = 0.2552856031, ["pm"] = 956, ["d"] = true,
        ["zx"] = 0.3033407985, ["zy"] = 0.2545720009, ["zm"] = 667,
      },
    },
    ["n"] = "Birds of Wrothgar",
    ["cn"] = "Wrothgar Writings",
  },
  [2752] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2324683948, ["py"] = 0.2754079974, ["pm"] = 957, ["d"] = true,
        ["zx"] = 0.2322075947, ["zy"] = 0.2736367981, ["zm"] = 667,
      },
    },
    ["n"] = "Letter from Thukhozod",
    ["cn"] = "Wrothgar Writings",
  },
  [2753] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2685452114, ["py"] = 0.2683736062, ["pm"] = 941, ["d"] = true,
        ["zx"] = 0.2704323933, ["zy"] = 0.2678384010, ["zm"] = 667,
      },
    },
    ["n"] = "The Whistle",
    ["cn"] = "Wrothgar Writings",
  },
  [2754] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3491700000,
        ["py"] = 0.6716400000,
        ["d"] = true,
        ["pm"] = 699,
      },
    },
    ["n"] = "How Long?",
    ["cn"] = "Daedric Cults",
  },
  [2755] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3502400000,
        ["py"] = 0.6713100000,
        ["d"] = true,
        ["pm"] = 699,
      },
    },
    ["n"] = "The New Lord",
    ["cn"] = "Daedric Cults",
  },
  [2756] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3506700000,
        ["py"] = 0.6713900000,
        ["d"] = true,
        ["pm"] = 699,
      },
    },
    ["n"] = "The First Day",
    ["cn"] = "Daedric Cults",
  },
  [2757] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3491700000,
        ["py"] = 0.6716400000,
        ["d"] = true,
        ["pm"] = 699,
      },
    },
    ["n"] = "Here to Stay",
    ["cn"] = "Daedric Cults",
  },
  [2758] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4802700000,
        ["px"] = 0.5469500000,
        ["pm"] = 657,
      },
      [2] = {
        ["mn"] = 26,
        ["py"] = 0.4757400000,
        ["px"] = 0.5532400000,
        ["pm"] = 660,
      },
      [3] = {
        ["mn"] = 26,
        ["py"] = 0.4793800000,
        ["px"] = 0.5512600000,
        ["pm"] = 660,
      },
      [4] = {
        ["px"] = 0.3498200000,
        ["py"] = 0.6708500000,
        ["d"] = true,
        ["pm"] = 699,
      },
      [5] = {
        ["mn"] = 26,
        ["py"] = 0.4828400000,
        ["px"] = 0.5461700000,
        ["pm"] = 660,
      },
      [6] = {
        ["mn"] = 26,
        ["py"] = 0.4776500000,
        ["px"] = 0.5435100000,
        ["pm"] = 660,
      },
      [7] = {
        ["mn"] = 26,
        ["py"] = 0.4749700000,
        ["px"] = 0.5470100000,
        ["pm"] = 660,
      },
      [8] = {
        ["mn"] = 26,
        ["py"] = 0.4718400000,
        ["px"] = 0.5521600000,
        ["pm"] = 660,
      },
    },
    ["n"] = "Daedra Dossier: The Titans",
    ["cn"] = "Daedric Cults",
  },
  [2759] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3507100000,
        ["py"] = 0.6694500000,
        ["d"] = true,
        ["pm"] = 699,
      },
    },
    ["n"] = "To Whom It May Concern",
    ["cn"] = "Daedric Cults",
  },
  [2760] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2695688114, ["py"] = 0.2688292061, ["pm"] = 941, ["d"] = true,
        ["zx"] = 0.2704323933, ["zy"] = 0.2678384010, ["zm"] = 667,
      },
      [2] = {
        ["px"] = 0.2705144113, ["py"] = 0.2686296061, ["pm"] = 941, ["d"] = true,
        ["zx"] = 0.2704323933, ["zy"] = 0.2678384010, ["zm"] = 667,
      },
      [3] = {
        ["px"] = 0.2685744114, ["py"] = 0.2684168061, ["pm"] = 941, ["d"] = true,
        ["zx"] = 0.2704323933, ["zy"] = 0.2678384010, ["zm"] = 667,
      },
    },
    ["n"] = "Rules of Nikolvara's Kennel",
    ["cn"] = "Wrothgar Writings",
  },
  [2761] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2704836113, ["py"] = 0.2670740062, ["pm"] = 941, ["d"] = true,
        ["zx"] = 0.2704323933, ["zy"] = 0.2678384010, ["zm"] = 667,
      },
    },
    ["n"] = "Kennel Tender's Letter",
    ["cn"] = "Wrothgar Writings",
  },
  [2762] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3766700000,
        ["py"] = 0.3749700000,
        ["d"] = true,
        ["pm"] = 616,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "Felgol's Note",
    ["cn"] = "Final Words",
  },
  [2763] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3766700000,
        ["py"] = 0.3749600000,
        ["d"] = true,
        ["pm"] = 616,
        ["zx"] = 0.3746812135, ["zy"] = 0.3724247989, ["zm"] = 1126,
      },
    },
    ["n"] = "This Text Property of Leki's Blade",
    ["cn"] = "Lore and Culture",
  },
  [2764] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2631263906, ["py"] = 0.2770972015, ["pm"] = 951, ["d"] = true,
        ["zx"] = 0.2639347980, ["zy"] = 0.2770843987, ["zm"] = 667,
      },
    },
    ["n"] = "Neramo's Journal, Page 1",
    ["cn"] = "Wrothgar Writings",
  },
  [2769] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4593900000,
        ["py"] = 0.3704400000,
        ["d"] = true,
        ["pm"] = 646,
      },
      [2] = {
        ["px"] = 0.4593100000,
        ["py"] = 0.3734100000,
        ["d"] = true,
        ["pm"] = 646,
      },
    },
    ["n"] = "Hands Off",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2770] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2832595979, ["py"] = 0.2602312012, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Winterborn's Note",
    ["cn"] = "Orsinium Archive",
  },
  [2771] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3172600000,
        ["py"] = 0.2376900000,
        ["d"] = true,
        ["pm"] = 937,
      },
    },
    ["n"] = "Why We Fled",
    ["cn"] = "Orsinium Archive",
  },
  [2772] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3171103986, ["py"] = 0.2372220013, ["pm"] = 938, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
    },
    ["n"] = "Rkindaleft's Council of Chiefs",
    ["cn"] = "Orsinium Archive",
  },
  [2773] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3176227986, ["py"] = 0.2371920014, ["pm"] = 938, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
    },
    ["n"] = "The Great Warmth",
    ["cn"] = "Orsinium Archive",
  },
  [2774] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3176400065, ["py"] = 0.2360744033, ["pm"] = 937, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.3177207986, ["py"] = 0.2371316014, ["pm"] = 938, ["fp"] = true, },
    },
    ["n"] = "For Letter Finder",
    ["cn"] = "Orsinium Archive",
  },
  [2775] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2633447906, ["py"] = 0.2791092014, ["pm"] = 953, ["d"] = true,
        ["zx"] = 0.2639347980, ["zy"] = 0.2770843987, ["zm"] = 667,
      },
    },
    ["n"] = "Neramo's Journal, Page 2",
    ["cn"] = "Wrothgar Writings",
  },
  [2776] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2627087906, ["py"] = 0.2790224015, ["pm"] = 953, ["d"] = true,
        ["zx"] = 0.2639347980, ["zy"] = 0.2770843987, ["zm"] = 667,
      },
    },
    ["n"] = "Neramo's Journal, Page 3",
    ["cn"] = "Wrothgar Writings",
  },
  [2778] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2693400000,
        ["px"] = 0.2646300000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Quarry Work Order",
    ["cn"] = "Wrothgar Writings",
  },
  [2779] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2756900000,
        ["px"] = 0.2628900000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Quarry Overseer's Complaint",
    ["cn"] = "Wrothgar Writings",
  },
  [2780] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2708000000,
        ["px"] = 0.2666600000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Sharfum's Letter",
    ["cn"] = "Wrothgar Writings",
  },
  [2783] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 25,
        ["py"] = 0.3792800000,
        ["px"] = 0.4155300000,
        ["pm"] = 1126,
      },
    },
    ["n"] = "Letter to Geldrion",
    ["cn"] = "Letters and Missives",
  },
  [2787] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4798300000,
        ["px"] = 0.5478100000,
        ["pm"] = 657,
      },
    },
    ["n"] = "Chapter XII: The Graverobber of Imperial City",
    ["cn"] = "Imperial Library",
  },
  [2788] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3957700053, ["py"] = 0.3143535971, ["pm"] = 706, ["d"] = true,
        ["zx"] = 0.3942672162, ["zy"] = 0.3252951947, ["zm"] = 1126,
      },
    },
    ["n"] = "Quartermaster's Note",
    ["cn"] = "Plots and Schemes",
  },
  [2797] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2165500000,
        ["px"] = 0.2685300000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Passenger's Log: Disaster at Sea",
    ["cn"] = "Wrothgar Writings",
  },
  [2800] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7808300000,
        ["px"] = 0.7390900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: From Egg to Adolescence",
    ["cn"] = "Lore of Murkmire",
  },
  [2801] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7825900000,
        ["px"] = 0.7446100000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: The Rites of Maturity, Part 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2802] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7755100000,
        ["px"] = 0.7625400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: The Rites of Maturity, Part 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2803] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7615100000,
        ["px"] = 0.7153000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: The Rites of Maturity, Part 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2804] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7629700000,
        ["px"] = 0.7154900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: Travels Beyond the Village, Part 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2805] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6266576081, ["py"] = 0.7065796043, ["pm"] = 1887, },
      [2] = {
        ["mn"] = 34,
        ["py"] = 0.7912600000,
        ["px"] = 0.7416000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: Travels Beyond the Village, Part 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2806] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7927100000,
        ["px"] = 0.7409400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: Travels Beyond the Village, Part 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2807] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7789200000,
        ["px"] = 0.7439400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Keshu: The Black Fin Goes to War, Part 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2808] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7368400000,
        ["py"] = 0.7563000000,
        ["d"] = true,
        ["pm"] = 1507,
      },
    },
    ["n"] = "Keshu: The Black Fin Goes to War, Part 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2809] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7794700000,
        ["px"] = 0.7607200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A Culinary Adventure, Volume 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2810] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7901600000,
        ["px"] = 0.7400000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A Culinary Adventure, Volume 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2811] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8009500000,
        ["px"] = 0.7691700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A Culinary Adventure, Volume 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2812] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7619100000,
        ["px"] = 0.7315600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A Culinary Adventure, Volume 4",
    ["cn"] = "Lore of Murkmire",
  },
  [2813] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7886800000,
        ["px"] = 0.7400100000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Teeba-Hatsei",
    ["cn"] = "Lore of Murkmire",
  },
  [2814] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7717700000,
        ["px"] = 0.7461000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2815] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "The Blackwater War, Volume 2",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7368100000,
        ["py"] = 0.7572700000,
        ["d"] = true,
        ["r"] = true,
        ["zt"] = 1073,
      },
    },
    ["m"] = {
      [34] = 1,
    },
  },
  [2816] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7929000000,
        ["px"] = 0.7405800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2817] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7988300000,
        ["px"] = 0.7836600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 4",
    ["cn"] = "Lore of Murkmire",
  },
  [2818] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7983700000,
        ["px"] = 0.7692100000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 5",
    ["cn"] = "Lore of Murkmire",
  },
  [2819] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7886600000,
        ["px"] = 0.7602400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 6",
    ["cn"] = "Lore of Murkmire",
  },
  [2820] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7716300000,
        ["px"] = 0.7241700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Blackwater War, Volume 7",
    ["cn"] = "Lore of Murkmire",
  },
  [2821] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7979800000,
        ["px"] = 0.7742200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "On the Ghost People",
    ["cn"] = "Lore of Murkmire",
  },
  [2822] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7751200000,
        ["px"] = 0.7615200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Murky Time",
    ["cn"] = "Lore of Murkmire",
  },
  [2823] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7929100000,
        ["px"] = 0.7706300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "On Playing the Frogs",
    ["cn"] = "Lore of Murkmire",
  },
  [2824] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7686800000,
        ["px"] = 0.7375500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Black Fin: Foreign Adventures, Part 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2825] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2889020041, ["py"] = 0.3342972002, ["pm"] = 212, ["zx"] = 0.2897664063, ["zy"] = 0.3347719950, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "An Exile's Notes",
    ["cn"] = "Personal Journals",
  },
  [2826] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2883028041, ["py"] = 0.3341880002, ["pm"] = 212, ["zx"] = 0.2897664063, ["zy"] = 0.3347719950, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "I'll Get You Ulbazar",
    ["cn"] = "Notes and Memos",
  },
  [2827] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2883164042, ["py"] = 0.3328656002, ["pm"] = 212, ["zx"] = 0.2897664063, ["zy"] = 0.3347719950, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Salamas's Epitaph",
    ["cn"] = "Words of the Poets",
  },
  [2828] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7745700000,
        ["px"] = 0.7304900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Black Fin: Foreign Adventures, Part 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2829] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2620440037, ["py"] = 0.3572083988, ["pm"] = 245, ["zx"] = 0.2626820057, ["zy"] = 0.3549911977, ["zm"] = 20, ["d"] = true, },
    },
    ["n"] = "Bowman's Note",
    ["cn"] = "Notes and Memos",
  },
  [2830] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4228900000,
        ["py"] = 0.6252300000,
        ["d"] = true,
        ["pm"] = 301,
      },
    },
    ["n"] = "Note to Marianas",
    ["cn"] = "Final Words",
  },
  [2831] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5538695764, ["py"] = 0.4689396021, ["pm"] = 767, ["d"] = true,
        ["zx"] = 0.5542132153, ["zy"] = 0.4689975945, ["zm"] = 16,
      },
    },
    ["n"] = "Imperial Prison Discipline Records",
    ["cn"] = "Imperial Library",
  },
  [2832] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5538779790, ["py"] = 0.4696643896, ["pm"] = 769, ["d"] = true, },
    },
    ["n"] = "A Way Out",
    ["cn"] = "Imperial Library",
  },
  [2833] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5542132229, ["py"] = 0.4689976025, ["pm"] = 765, ["d"] = true,
        ["zx"] = 0.5542132153, ["zy"] = 0.4689975945, ["zm"] = 16,
      },
    },
    ["n"] = "The Prison Must Fall",
    ["cn"] = "Imperial Library",
  },
  [2834] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2410800000,
        ["px"] = 0.2988100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "All About Echatere",
    ["cn"] = "Orsinium Archive",
  },
  [2835] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7880700000,
        ["px"] = 0.7557500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Black Fin: Foreign Adventures, Part 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2836] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2432000000,
        ["px"] = 0.2972400000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter to Yazara",
    ["cn"] = "Orsinium Archive",
  },
  [2837] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3075215940, ["py"] = 0.2380728013, ["pm"] = 942, ["d"] = true,
        ["zx"] = 0.3028975974, ["zy"] = 0.2365632024, ["zm"] = 667,
      },
    },
    ["n"] = "The Challenge at Bloody Knoll",
    ["cn"] = "Orsinium Archive",
  },
  [2838] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7591100000,
        ["px"] = 0.7272300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Black Fin: Foreign Adventures, Part 4",
    ["cn"] = "Lore of Murkmire",
  },
  [2839] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7761200000,
        ["px"] = 0.7606900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: Bright-Throats",
    ["cn"] = "Lore of Murkmire",
  },
  [2840] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7362500000,
        ["py"] = 0.7785700000,
        ["d"] = true,
        ["pm"] = 1509,
      },
    },
    ["n"] = "Tribes of Murkmire: Ghost People",
    ["cn"] = "Lore of Murkmire",
  },
  [2841] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8032300000,
        ["px"] = 0.7680700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: Black-Tongues",
    ["cn"] = "Lore of Murkmire",
  },
  [2842] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7721400000,
        ["px"] = 0.7458600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: Root-House People",
    ["cn"] = "Lore of Murkmire",
  },
  [2843] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7753900000,
        ["px"] = 0.7608500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: Miredancers",
    ["cn"] = "Lore of Murkmire",
  },
  [2844] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7713800000,
        ["px"] = 0.7564300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: Tribal Connections",
    ["cn"] = "Lore of Murkmire",
  },
  [2845] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7577300000,
        ["px"] = 0.7573800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Black Fin Comes Home",
    ["cn"] = "Lore of Murkmire",
  },
  [2846] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8048700000,
        ["px"] = 0.7702400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letters from the War: Mead!",
    ["cn"] = "Lore of Murkmire",
  },
  [2847] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7923100000,
        ["px"] = 0.7297700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letters from the War: Mournhold",
    ["cn"] = "Lore of Murkmire",
  },
  [2848] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7832100000,
        ["px"] = 0.7444600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letters from the War: Windhelm",
    ["cn"] = "Lore of Murkmire",
  },
  [2849] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7845000000,
        ["px"] = 0.7368000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letters from the War: Cyrodiil",
    ["cn"] = "Lore of Murkmire",
  },
  [2850] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7994600000,
        ["px"] = 0.7649300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "From Wrothgar to Lilmoth: A Smith's Tale, Vol 1",
    ["cn"] = "Lore of Murkmire",
  },
  [2851] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7651400000,
        ["px"] = 0.7624000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "From Wrothgar to Lilmoth: A Smith's Tale, Vol 2",
    ["cn"] = "Lore of Murkmire",
  },
  [2852] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7644500000,
        ["px"] = 0.7046800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "From Wrothgar to Lilmoth: A Smith's Tale, Vol 3",
    ["cn"] = "Lore of Murkmire",
  },
  [2853] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7111300000,
        ["py"] = 0.7740300000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
    ["n"] = "Imperial Incursions: Why a Swamp?",
    ["cn"] = "Lore of Murkmire",
  },
  [2854] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7115900000,
        ["py"] = 0.7737500000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
    ["n"] = "Imperial Incursions: Officer's Lament",
    ["cn"] = "Lore of Murkmire",
  },
  [2901] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5536855764, ["py"] = 0.4689444021, ["pm"] = 767, ["d"] = true,
        ["zx"] = 0.5542132153, ["zy"] = 0.4689975945, ["zm"] = 16,
      },
    },
    ["n"] = "This is the End",
    ["cn"] = "Imperial Library",
  },
  [2902] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5537691764, ["py"] = 0.4689440021, ["pm"] = 767, ["d"] = true,
        ["zx"] = 0.5542132153, ["zy"] = 0.4689975945, ["zm"] = 16,
      },
    },
    ["n"] = "Frayed Note",
    ["cn"] = "Imperial Library",
  },
  [2903] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["py"] = 0.4691700000,
        ["zt"] = 678,
        ["px"] = 0.5535600000,
      },
    },
    ["n"] = "Necromancer's Journal",
    ["cn"] = "Imperial Library",
  },
  [2904] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5545263907, ["py"] = 0.4697084075, ["pm"] = 770, ["d"] = true, },
    },
    ["n"] = "Battered Note",
    ["cn"] = "Imperial Library",
  },
  [2931] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7361400000,
        ["px"] = 0.4363300000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 4,
        ["py"] = 0.3370800000,
        ["px"] = 0.2126700000,
        ["pm"] = 12,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5173000000,
        ["px"] = 0.7586500000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Tome of the Undaunted (signed)",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2935] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Smuggler's Note",
    ["q"] = 4294,
    ["e"] = {
      [1] = { ["px"] = 0.2361275955, ["py"] = 0.6900144124, ["pm"] = 143, ["qc"] = true, },
      [2] = { ["px"] = 0.2358227929, ["py"] = 0.6966396077, ["pm"] = 800, ["d"] = true, ["zx"] = 0.2358239962, ["zy"] = 0.6966380156, ["zm"] = 143, }, -- location accessible only during quest "The Unveiling"
    },
  },
  [2936] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3544300000,
        ["px"] = 0.0697400000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3533700000,
        ["px"] = 0.0705800000,
        ["pm"] = 1,
      },
      [3] = {
        ["l"] = true,
        ["mn"] = 2,
        ["pm"] = 1,
        ["px"] = 0.0697100000,
        ["d"] = true,
        ["py"] = 0.3544100000,
      },
    },
    ["n"] = "Letter to Wyress Gwen",
    ["cn"] = "Letters and Missives",
  },
  [2937] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Nimriell's Research",
    ["q"] = 4968,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7214300000,
        ["px"] = 0.4209900000,
        ["pm"] = 9,
      },
    },
  },
  [2938] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7116000000,
        ["py"] = 0.4444300000,
        ["d"] = true,
        ["pm"] = 97,
        ["zx"] = 0.7116743959, ["zy"] = 0.4444460016, ["zm"] = 7,
      },
    },
    ["n"] = "Scout Meera's Report",
    ["cn"] = "Military Orders and Reports",
  },
  [2940] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7119900000,
        ["py"] = 0.4444400000,
        ["d"] = true,
        ["pm"] = 97,
        ["zx"] = 0.7116743959, ["zy"] = 0.4444460016, ["zm"] = 7,
      },
    },
    ["n"] = "Oodegu's Journal—Keep Out!",
    ["cn"] = "Personal Journals",
  },
  [2941] = {
    ["c"] = true,
    ["cn"] = "Final Words",
    ["n"] = "Mossy Note",
    ["e"] = {
      [1] = { ["px"] = 0.2259975928, ["py"] = 0.6853991970, ["pm"] = 186, ["d"] = true, ["zx"] = 0.2257103936, ["zy"] = 0.6849976154, ["zm"] = 143, },
    },
  },
  [2943] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 26",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2944] = {
    ["c"] = true,
    ["cn"] = "Tales of Tamriel",
    ["n"] = "The Year 2920, Vol. 27",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4806900000,
        ["r"] = true,
        ["px"] = 0.5466600000,
        ["pm"] = 657,
      },
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2946] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Shezarr and the Divines",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1060] = 21,
      [660] = 5,
      [1429] = 2,
      [1006] = 18,
      [1349] = 1,
    },
  },
  [2947] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Thwarting the Daedra: Dagon's Cult",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["pm"] = 660,
        ["py"] = 0.4825500000,
        ["px"] = 0.5472800000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2948] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Glorious Upheaval",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["pm"] = 660,
        ["py"] = 0.4758000000,
        ["px"] = 0.5468200000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2949] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Introduction to Aedric Studies",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4809800000,
        ["r"] = true,
        ["px"] = 0.5455000000,
        ["pm"] = 657,
      },
    },
    ["m"] = {
      [26] = 1,
      [660] = 6,
    },
  },
  [2950] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 660,
        ["py"] = 0.4821600000,
        ["px"] = 0.5517300000,
        ["mn"] = 26,
        ["r"] = true,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7112100000,
        ["px"] = 0.0384600000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Response to Citizen Inquiries",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2951] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "The Distributed Soul",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.4813100000,
        ["r"] = true,
        ["px"] = 0.5502700000,
        ["pm"] = 657,
      },
    },
    ["m"] = {
      [26] = 1,
    },
  },
  [2952] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Plea for Open Eyes",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [660] = 6,
      [667] = 46,
    },
  },
  [2955] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5459503733, ["py"] = 0.4805759996, ["pm"] = 900,
      },
    },
    ["n"] = "Minutes of the Elder Council",
    ["cn"] = "Imperial Library",
  },
  [2962] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 26,
        ["py"] = 0.4777800000,
        ["px"] = 0.5553400000,
        ["pm"] = 660,
      },
    },
    ["n"] = "Love Letter to Aishah",
    ["cn"] = "Imperial Library",
  },
  [2967] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5466691733, ["py"] = 0.4804679996, ["pm"] = 900,
      },
    },
    ["n"] = "Crumpled Arena Flyer",
    ["cn"] = "Imperial Library",
  },
  [2970] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2337900000,
        ["py"] = 0.7430400000,
        ["d"] = true,
        ["pm"] = 808,
      },
    },
    ["n"] = "The Cannonreeve's Conundrum",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2971] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2340100000,
        ["py"] = 0.7431300000,
        ["d"] = true,
        ["pm"] = 808,
      },
    },
    ["n"] = "Veiled Heritance - Be Warned",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2972] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3542800000,
        ["py"] = 0.6954200000,
        ["d"] = true,
        ["pm"] = 817,
      },
    },
    ["n"] = "Verdant Hand Orientation",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2973] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3543900000,
        ["py"] = 0.6953500000,
        ["d"] = true,
        ["pm"] = 817,
      },
    },
    ["n"] = "Lockpick Sales-Duty",
    ["cn"] = "Criminal Correspondence",
  },
  [2974] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3123400000,
        ["py"] = 0.6267300000,
        ["d"] = true,
        ["pm"] = 820,
      },
    },
    ["n"] = "Who Is REALLY In Charge?",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2975] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4359300000,
        ["py"] = 0.7317200000,
        ["d"] = true,
        ["pm"] = 809,
      },
    },
    ["n"] = "Cracking the Elden Tree Vault",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2976] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4358300000,
        ["py"] = 0.7317300000,
        ["d"] = true,
        ["pm"] = 809,
      },
    },
    ["n"] = "Excuses Don't Buy Mansions",
    ["cn"] = "Criminal Correspondence",
  },
  [2977] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3125400000,
        ["py"] = 0.6266700000,
        ["d"] = true,
        ["pm"] = 820,
      },
    },
    ["n"] = "Problem Solver For Hire!",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [2978] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4504200000,
        ["py"] = 0.6143800000,
        ["d"] = true,
        ["pm"] = 823,
      },
    },
    ["n"] = "Daynila's Corpse-Kabob",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2979] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4500100000,
        ["py"] = 0.6146000000,
        ["d"] = true,
        ["pm"] = 823,
      },
    },
    ["n"] = "The Criminal Mind",
    ["cn"] = "Lore and Culture",
  },
  [2980] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0611500000,
        ["py"] = 0.3870300000,
        ["d"] = true,
        ["pm"] = 807,
      },
    },
    ["n"] = "Memorize and Burn!",
    ["cn"] = "Notes and Memos",
  },
  [2981] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0612600000,
        ["py"] = 0.3872000000,
        ["d"] = true,
        ["pm"] = 807,
      },
    },
    ["n"] = "Atrocious Love Letter",
    ["cn"] = "Hearts and Flowers",
  },
  [2982] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2232200062, ["py"] = 0.3370367975, ["pm"] = 816, ["d"] = true,
        ["zx"] = 0.2163008028, ["zy"] = 0.3372296069, ["zm"] = 12,
      },
      [2] = { ["px"] = 0.2163008028, ["py"] = 0.3372296069, ["pm"] = 33, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Stormhaven Bluster Rejection Notice",
    ["cn"] = "Letters and Missives",
  },
  [2983] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2231344062, ["py"] = 0.3369915975, ["pm"] = 816, ["d"] = true,
        ["zx"] = 0.2163008028, ["zy"] = 0.3372296069, ["zm"] = 12,
      },
      [2] = { ["px"] = 0.2163008028, ["py"] = 0.3372296069, ["pm"] = 33, ["d"] = true, ["fp"] = true, },
    },
    ["n"] = "Vol's Journal",
    ["cn"] = "Personal Journals",
  },
  [2984] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1700631959, ["py"] = 0.2494235974, ["pm"] = 812, ["zx"] = 0.1760099976, ["zy"] = 0.2461672003, ["zm"] = 10, ["d"] = true, },
      [2] = { ["px"] = 0.1733212026, ["py"] = 0.2514208053, ["pm"] = 85, ["fp"] = true, },
    },
    ["n"] = "Letter to Finia Marcott",
    ["cn"] = "Letters and Missives",
  },
  [2985] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1700595959, ["py"] = 0.2492507973, ["pm"] = 812, ["zx"] = 0.1760099976, ["zy"] = 0.2461672003, ["zm"] = 10, ["d"] = true, },
      [2] = { ["px"] = 0.1733212026, ["py"] = 0.2514208053, ["pm"] = 85, ["fp"] = true, },
    },
    ["n"] = "High King Emeric, I Implore You!",
    ["cn"] = "Letters and Missives",
  },
  [2986] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1478043958, ["py"] = 0.3953499942, ["pm"] = 810, ["zx"] = 0.1478044037, ["zy"] = 0.3953499963, ["zm"] = 30, ["d"] = true, },
      [2] = { ["px"] = 0.1448395928, ["py"] = 0.3936036033, ["pm"] = 83, ["fp"] = true, },
    },
    ["n"] = "Scutwork and Drudgery",
    ["cn"] = "Diaries and Logs",
  },
  [2987] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.1478819958, ["py"] = 0.3954375942, ["pm"] = 810, ["zx"] = 0.1478044037, ["zy"] = 0.3953499963, ["zm"] = 30, ["d"] = true, },
      [2] = { ["px"] = 0.1448395928, ["py"] = 0.3936036033, ["pm"] = 83, ["fp"] = true, },
    },
    ["n"] = "The Dose Makes the Poison",
    ["cn"] = "Criminal Correspondence",
  },
  [2988] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2839655897, ["py"] = 0.3156691949, ["pm"] = 813, ["zx"] = 0.2802188070, ["zy"] = 0.3203971976, ["zm"] = 20, ["d"] = true, },
      [2] = { ["px"] = 0.2802187994, ["py"] = 0.3203972044, ["pm"] = 84, ["fp"] = true, },
    },
    ["n"] = "For the Doyen, Sleek Splendid-Paws",
    ["cn"] = "Criminal Correspondence",
  },
  [2989] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2839739897, ["py"] = 0.3154591949, ["pm"] = 813, ["zx"] = 0.2802188070, ["zy"] = 0.3203971976, ["zm"] = 20, ["d"] = true, },
      [2] = { ["px"] = 0.2802187994, ["py"] = 0.3203972044, ["pm"] = 84, ["fp"] = true, },
    },
    ["n"] = "Khorshina's Journal",
    ["cn"] = "Personal Journals",
  },
  [2990] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7849700000,
        ["py"] = 0.4312200000,
        ["d"] = true,
        ["pm"] = 814,
      },
    },
    ["n"] = "Names, Names, Names!",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2991] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7851400000,
        ["py"] = 0.4312700000,
        ["d"] = true,
        ["pm"] = 814,
      },
    },
    ["n"] = "Letter to Stelvene Lothaire",
    ["cn"] = "Letters and Missives",
  },
  [2992] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7667500000,
        ["py"] = 0.5088900000,
        ["d"] = true,
        ["pm"] = 819,
      },
    },
    ["n"] = "Zagrugh's Journal",
    ["cn"] = "Final Words",
  },
  [2993] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7666200000,
        ["py"] = 0.5086300000,
        ["d"] = true,
        ["pm"] = 819,
      },
    },
    ["n"] = "Quit Asking",
    ["cn"] = "Notes and Memos",
  },
  [2994] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7453184198, ["py"] = 0.5459600052, ["pm"] = 811, ["zm"] = 26, ["d"] = true, },
      [2] = { ["px"] = 0.7453183860, ["py"] = 0.5459600108, ["pm"] = 217, ["fp"] = true, },
    },
    ["n"] = "How to Train Your Guar",
    ["cn"] = "The World and Its Creatures",
  },
  [2995] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7452800000,
        ["py"] = 0.5456200000,
        ["d"] = true,
        ["pm"] = 811,
      },
    },
    ["n"] = "Tribunal—Living Lies",
    ["cn"] = "The Devoted and the Deranged",
  },
  [2996] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6337400000,
        ["py"] = 0.2659500000,
        ["d"] = true,
        ["pm"] = 822,
      },
    },
    ["n"] = "People I Hate",
    ["cn"] = "Notes and Memos",
  },
  [2997] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6338500000,
        ["py"] = 0.2660500000,
        ["d"] = true,
        ["pm"] = 822,
      },
    },
    ["n"] = "Enduring Nord Society",
    ["cn"] = "Lore and Culture",
  },
  [2998] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6425500000,
        ["py"] = 0.3770800000,
        ["d"] = true,
        ["pm"] = 815,
      },
    },
    ["n"] = "Letter to Skull-Brother Xandier",
    ["cn"] = "Criminal Correspondence",
  },
  [2999] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6424300000,
        ["py"] = 0.3771600000,
        ["d"] = true,
        ["pm"] = 815,
      },
    },
    ["n"] = "The Ghost is Our Friend",
    ["cn"] = "Criminal Correspondence",
  },
  [3000] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4180300000,
        ["py"] = 0.3817100000,
        ["d"] = true,
        ["pm"] = 818,
      },
    },
    ["n"] = "Letter to Zurga gra-Murtag",
    ["cn"] = "Criminal Correspondence",
  },
  [3001] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4180100000,
        ["py"] = 0.3816800000,
        ["d"] = true,
        ["pm"] = 818,
      },
    },
    ["n"] = "Couplets in Admiration of the Dead",
    ["cn"] = "Words of the Poets",
  },
  [3002] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2768000000,
        ["px"] = 0.2746500000,
        ["pm"] = 667,
      },
      [2] = { ["px"] = 0.2894391983, ["py"] = 0.2646452020, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "The Chronicles of King Kurog, Book I",
    ["cn"] = "Wrothgar Writings",
  },
  [3003] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2500144027, ["py"] = 0.2911095971, ["pm"] = 961, ["d"] = true,
        ["zx"] = 0.2480059954, ["zy"] = 0.2887000017, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.2962684119, ["py"] = 0.2632060018, ["pm"] = 933, ["d"] = true, },
      [3] = { ["px"] = 0.2957775977, ["py"] = 0.2635092017, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
    ["n"] = "The Chronicles of King Kurog, Book II",
    ["cn"] = "Wrothgar Writings",
  },
  [3004] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2884455984, ["py"] = 0.2576420009, ["pm"] = 895, ["zm"] = 667, },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2785900000,
        ["px"] = 0.2445900000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Chronicles of King Kurog, Book III",
    ["cn"] = "Wrothgar Writings",
  },
  [3007] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2669295953, ["py"] = 0.2533331983, ["pm"] = 958, ["d"] = true,
        ["zx"] = 0.2665711984, ["zy"] = 0.2520740048, ["zm"] = 667,
      },
    },
    ["n"] = "The True Nature of Magnar",
    ["cn"] = "Wrothgar Writings",
  },
  [3008] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2039900000,
        ["px"] = 0.2821200000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2951784120, ["py"] = 0.2666976017, ["pm"] = 933, ["d"] = true,
      },
      [3] = { ["px"] = 0.2957775977, ["py"] = 0.2635092017, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
    ["n"] = "The Chronicles of King Kurog, Book IV",
    ["cn"] = "Wrothgar Writings",
  },
  [3009] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2844355986, ["py"] = 0.2655028007, ["pm"] = 895, ["zm"] = 667, },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2694600000,
        ["px"] = 0.2667300000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Chronicles of King Kurog, Book V",
    ["cn"] = "Wrothgar Writings",
  },
  [3010] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4388615828, ["py"] = 0.6924571872, ["pm"] = 9,
      },
    },
    ["n"] = "Letter to Negaelion",
    ["cn"] = "Letters and Missives",
  },
  [3011] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2909171982, ["py"] = 0.2643716013, ["pm"] = 895, ["zm"] = 667, },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2367100000,
        ["px"] = 0.2611500000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Chronicles of King Kurog, Book VI",
    ["cn"] = "Wrothgar Writings",
  },
  [3012] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2323599948, ["py"] = 0.2754659974, ["pm"] = 957, ["d"] = true,
        ["zx"] = 0.2322075947, ["zy"] = 0.2736367981, ["zm"] = 667,
      },
    },
    ["n"] = "The Legend of Thukhozod",
    ["cn"] = "Wrothgar Writings",
  },
  [3013] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3039496012, ["py"] = 0.2564028031, ["pm"] = 956, ["d"] = true,
        ["zx"] = 0.3033407985, ["zy"] = 0.2545720009, ["zm"] = 667,
      },
    },
    ["n"] = "Kraala's Journal",
    ["cn"] = "Wrothgar Writings",
  },
  [3014] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2186852005, ["py"] = 0.2886176021, ["pm"] = 968, ["d"] = true,
        ["zx"] = 0.2185699974, ["zy"] = 0.2885024004, ["zm"] = 667,
      },
    },
    ["n"] = "The Watcher's Pledge",
    ["cn"] = "Wrothgar Writings",
  },
  [3015] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2176008006, ["py"] = 0.2880452021, ["pm"] = 968, ["d"] = true,
        ["zx"] = 0.2185699974, ["zy"] = 0.2885024004, ["zm"] = 667,
      },
    },
    ["n"] = "Watcher's Report",
    ["cn"] = "Wrothgar Writings",
  },
  [3016] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2191164006, ["py"] = 0.2865016022, ["pm"] = 968, ["d"] = true,
        ["zx"] = 0.2185699974, ["zy"] = 0.2885024004, ["zm"] = 667,
      },
    },
    ["n"] = "Ruined Watchmaster's Journal",
    ["cn"] = "Wrothgar Writings",
  },
  [3017] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2328107948, ["py"] = 0.2743463973, ["pm"] = 957, ["d"] = true,
        ["zx"] = 0.2322075947, ["zy"] = 0.2736367981, ["zm"] = 667,
      },
    },
    ["n"] = "Gorlar's Journal, Part One",
    ["cn"] = "Wrothgar Writings",
  },
  [3018] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2323599948, ["py"] = 0.2744967973, ["pm"] = 957, ["d"] = true,
        ["zx"] = 0.2322075947, ["zy"] = 0.2736367981, ["zm"] = 667,
      },
    },
    ["n"] = "Gorlar's Journal, Part Two",
    ["cn"] = "Wrothgar Writings",
  },
  [3019] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2859015985, ["py"] = 0.2607864014, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Ancient Nord Tablet",
    ["cn"] = "Wrothgar Writings",
  },
  [3020] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2126600000,
        ["px"] = 0.2676800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Note to Captain Henrisa",
    ["cn"] = "Wrothgar Writings",
  },
  [3021] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2145000000,
        ["px"] = 0.2697800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter from Baron Materre",
    ["cn"] = "Wrothgar Writings",
  },
  [3022] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2200600000,
        ["px"] = 0.2789200000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Signal Tower Orders",
    ["cn"] = "Wrothgar Writings",
  },
  [3024] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2482163983, ["py"] = 0.2507668002, ["pm"] = 960, ["d"] = true,
        ["zx"] = 0.2515615967, ["zy"] = 0.2567827991, ["zm"] = 667,
      },
    },
    ["n"] = "Narsis Dren and the Lost Notebook",
    ["cn"] = "Wrothgar Writings",
  },
  [3025] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2771480146, ["py"] = 0.2422872024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "Kal-Eeto's Journal",
    ["cn"] = "Wrothgar Writings",
  },
  [3026] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2835655983, ["py"] = 0.2566536018, ["pm"] = 895, ["zm"] = 667, },
      [2] = { ["px"] = 0.2953732119, ["py"] = 0.2654368018, ["pm"] = 933, ["d"] = true, },
      [3] = { ["px"] = 0.2957775977, ["py"] = 0.2635092017, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
    ["n"] = "Vosh Rakh",
    ["cn"] = "Wrothgar Writings",
  },
  [3027] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2442800000,
        ["px"] = 0.2976200000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2876000000,
        ["py"] = 0.2715600000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "101 Uses for Troll Fat",
    ["cn"] = "Wrothgar Writings",
  },
  [3028] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2823927981, ["py"] = 0.2674300021, ["pm"] = 895, ["zm"] = 667, },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2209000000,
        ["px"] = 0.3155600000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Vorgrosh Rot-Tusk's Guide to Dirty Fighting",
    ["cn"] = "Wrothgar Writings",
  },
  [3029] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2872471983, ["py"] = 0.2649768014, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Notes on Orichalcum",
    ["cn"] = "Wrothgar Writings",
  },
  [3030] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2823927981, ["py"] = 0.2674300021, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Your Little Friend, Edu",
    ["cn"] = "Wrothgar Writings",
  },
  [3031] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Fanatic's Orders",
    ["q"] = 5447,
    ["e"] = {
      [1] = { ["px"] = 0.2820199979, ["py"] = 0.2590296017, ["pm"] = 930, ["d"] = true, },
      [2] = { ["px"] = 0.2842463980, ["py"] = 0.2576012014, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
  },
  [3032] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3171335986, ["py"] = 0.2370500014, ["pm"] = 938, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
    },
    ["n"] = "Dorand's Final Notes",
    ["cn"] = "Orsinium Archive",
  },
  [3033] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2078100000,
        ["px"] = 0.3093700000,
        ["pm"] = 667,
      },
      [2] = {
        ["pm"] = 667,
        ["px"] = 0.3131900000,
        ["d"] = true,
        ["py"] = 0.2102600000,
        ["mn"] = 27,
      },
    },
    ["n"] = "Torug ag Krazak",
    ["cn"] = "Wrothgar Writings",
  },
  [3034] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2060200000,
        ["px"] = 0.3031300000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.3126252113, ["py"] = 0.2100699999, ["pm"] = 967, ["d"] = true,
        ["zx"] = 0.3108407950, ["zy"] = 0.2104932006, ["zm"] = 667,
      },
    },
    ["n"] = "Torug at the Summit, Complete Translation",
    ["cn"] = "Wrothgar Writings",
  },
  [3035] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2852452147, ["py"] = 0.2345684028, ["pm"] = 971, ["d"] = true,
        ["zx"] = 0.2840671931, ["zy"] = 0.2332399997, ["zm"] = 667,
      },
    },
    ["n"] = "Mazghar Many-Tongues",
    ["cn"] = "Orsinium Archive",
  },
  [3036] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2851916147, ["py"] = 0.2345704028, ["pm"] = 971, ["d"] = true,
        ["zx"] = 0.2840671931, ["zy"] = 0.2332399997, ["zm"] = 667,
      },
    },
    ["n"] = "Baloth Bloodtusk",
    ["cn"] = "Orsinium Archive",
  },
  [3037] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2852540148, ["py"] = 0.2345080029, ["pm"] = 971, ["d"] = true,
        ["zx"] = 0.2840671931, ["zy"] = 0.2332399997, ["zm"] = 667,
      },
    },
    ["n"] = "Lakora of the Hunt",
    ["cn"] = "Orsinium Archive",
  },
  [3039] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Zayshara's First Note",
    ["q"] = 5453,
    ["e"] = {
      [1] = {
        ["px"] = 0.2771908146, ["py"] = 0.2422732024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
  },
  [3040] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2771908146, ["py"] = 0.2422732024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "Zayshara's Second Note",
    ["cn"] = "Wrothgar Writings",
  },
  [3041] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2772672146, ["py"] = 0.2419876024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "Zayshara's Third Note",
    ["cn"] = "Wrothgar Writings",
  },
  [3042] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2772704146, ["py"] = 0.2420116024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "The Moons Rhyme",
    ["cn"] = "Wrothgar Writings",
  },
  [3045] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2772784146, ["py"] = 0.2422628024, ["pm"] = 889, ["d"] = true,
        ["zx"] = 0.2772447989, ["zy"] = 0.2424492017, ["zm"] = 667,
      },
    },
    ["n"] = "The King's Riddle",
    ["cn"] = "Wrothgar Writings",
  },
  [3046] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7586552133, ["py"] = 0.5166572141, ["pm"] = 205, ["zm"] = 13, },
      [2] = { ["px"] = 0.2125532024, ["py"] = 0.3377060069, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Tome of the Undaunted",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [3047] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Terran's Notes",
    -- Only accessible after defeating Molag Kena and going through the portal at the end, I don't know how to word this.
    ["e"] = {
      [1] = { ["px"] = 0.5477587896, ["py"] = 0.4759068019, ["pm"] = 908, ["d"] = true, },
    },
  },
  [3051] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2826327992, ["py"] = 0.2596352000, ["pm"] = 955, ["d"] = true, },
      [2] = { ["px"] = 0.2827247980, ["py"] = 0.2609756018, ["pm"] = 930, ["fp"] = true, },
      [3] = { ["px"] = 0.2842463980, ["py"] = 0.2576012014, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
      [4] = {
        ["px"] = 0.2875700000,
        ["py"] = 0.2717900000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "On Orcs and the Afterlife",
    ["cn"] = "Wrothgar Writings",
  },
  [3053] = {
    ["c"] = true,
    ["cn"] = "Orsinium Archive",
    ["n"] = "Agolas's Journal",
    ["q"] = 5474,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2648000000,
        ["px"] = 0.2534100000,
        ["pm"] = 667,
      },
    },
  },
  [3054] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "The Wood Elf's Message",
    ["q"] = 5468,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["pm"] = 667,
        ["py"] = 0.2626600000,
        ["px"] = 0.2950700000,
        ["r"] = true,
      },
    },
  },
  [3058] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1997292017, ["py"] = 0.2798308040, ["pm"] = 962, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.1998063953, ["py"] = 0.2808036024, ["pm"] = 950, ["fp"] = true, },
    },
    ["n"] = "The Scroll of Avalian",
    ["cn"] = "Wrothgar Writings",
  },
  [3059] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1996832017, ["py"] = 0.2797716040, ["pm"] = 962, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.1998063953, ["py"] = 0.2808036024, ["pm"] = 950, ["fp"] = true, },
    },
    ["n"] = "The Scroll of Vaia",
    ["cn"] = "Wrothgar Writings",
  },
  [3060] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1997752017, ["py"] = 0.2797772040, ["pm"] = 962, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.1998063953, ["py"] = 0.2808036024, ["pm"] = 950, ["fp"] = true, },
    },
    ["n"] = "The Scroll of Usunok",
    ["cn"] = "Wrothgar Writings",
  },
  [3061] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2199048074, ["py"] = 0.2798119993, ["pm"] = 947, ["d"] = true,
        ["zx"] = 0.2335911961, ["zy"] = 0.2899660020, ["zm"] = 667,
      },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2576400000,
        ["px"] = 0.2886000000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter to Baloth Bloodtusk",
    ["cn"] = "Orsinium Archive",
  },
  [3062] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1991603952, ["py"] = 0.2818472023, ["pm"] = 950, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
    },
    ["n"] = "Conversion Status",
    ["cn"] = "Wrothgar Writings",
  },
  [3064] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2998931993, ["py"] = 0.2600235978, ["pm"] = 932, ["d"] = true,
      },
      [2] = { ["px"] = 0.2957775977, ["py"] = 0.2635092017, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
    ["n"] = "The King's Orders",
    ["cn"] = "Wrothgar Writings",
  },
  [3065] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2004584017, ["py"] = 0.2800688040, ["pm"] = 962, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.1998063953, ["py"] = 0.2808036024, ["pm"] = 950, ["fp"] = true, },
      [3] = { ["px"] = 0.1998107952, ["py"] = 0.2813400024, ["pm"] = 950, ["d"] = true, },
    },
    ["n"] = "Vosh Rakh Orders",
    ["cn"] = "Wrothgar Writings",
  },
  [3066] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2201587991, ["py"] = 0.2800131988, ["pm"] = 943, ["d"] = true,
        ["zx"] = 0.2335911961, ["zy"] = 0.2899660020, ["zm"] = 667,
      },
    },
    ["n"] = "Honor's Rest Monument Stone",
    ["cn"] = "Orsinium Archive",
  },
  [3082] = {
    ["c"] = true,
    ["cn"] = "Imperial Library",
    ["n"] = "The Sublime Brazier",
    ["q"] = 5490,
    ["e"] = {
      [1] = {
        ["py"] = 0.4783100000,
        ["px"] = 0.5484800000,
        ["pm"] = 657,
      },
      [2] = {
        ["px"] = 0.5454443733, ["py"] = 0.4807831994, ["pm"] = 900,
      },
      [3] = {
        ["py"] = 0.4814400000,
        ["px"] = 0.5504500000,
        ["pm"] = 657,
      },
    },
  },
  [3084] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Permit of Trade",
    ["q"] = 5499,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2630200000,
        ["px"] = 0.2775300000,
        ["pm"] = 667,
      },
    },
  },
  [3107] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2055900000,
        ["px"] = 0.3030500000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Stibbons's To-Do List",
    ["cn"] = "Wrothgar Writings",
  },
  [3108] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2056700000,
        ["px"] = 0.3029700000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Lady Laurent's To-Do List",
    ["cn"] = "Wrothgar Writings",
  },
  [3109] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2859075985, ["py"] = 0.2607400011, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Coldwind's Skull",
    ["cn"] = "Wrothgar Writings",
  },
  [3110] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2850947979, ["py"] = 0.2611296009, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "The First Charter",
    ["cn"] = "Wrothgar Writings",
  },
  [3111] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2851483980, ["py"] = 0.2613156019, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Uzdabikh's Helm",
    ["cn"] = "Wrothgar Writings",
  },
  [3112] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2852639979, ["py"] = 0.2614844020, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Agra Crun",
    ["cn"] = "Wrothgar Writings",
  },
  [3113] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2856859982, ["py"] = 0.2602384018, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Frostbreak Chalice",
    ["cn"] = "Wrothgar Writings",
  },
  [3114] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2852827978, ["py"] = 0.2605308016, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Trinimac House Idol",
    ["cn"] = "Wrothgar Writings",
  },
  [3115] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2858067982, ["py"] = 0.2601488009, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Nuzava's Anvil",
    ["cn"] = "Wrothgar Writings",
  },
  [3116] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2851083985, ["py"] = 0.2610460007, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Map of Clans",
    ["cn"] = "Wrothgar Writings",
  },
  [3117] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2863867984, ["py"] = 0.2601184017, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Dwarf Light",
    ["cn"] = "Wrothgar Writings",
  },
  [3118] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2868459985, ["py"] = 0.2606160015, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Heart of Zandadunoz",
    ["cn"] = "Wrothgar Writings",
  },
  [3119] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2860903983, ["py"] = 0.2608468014, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Torc of Baloth Bloodtusk",
    ["cn"] = "Wrothgar Writings",
  },
  [3120] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2852319981, ["py"] = 0.2605772019, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Horn of Beasts",
    ["cn"] = "Wrothgar Writings",
  },
  [3121] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2858847983, ["py"] = 0.2601172018, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Guthrag's Mask",
    ["cn"] = "Wrothgar Writings",
  },
  [3122] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2859139984, ["py"] = 0.2609200014, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Centurion's Signet",
    ["cn"] = "Wrothgar Writings",
  },
  [3123] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2853691984, ["py"] = 0.2615172009, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Thukhozod's Bracer",
    ["cn"] = "Wrothgar Writings",
  },
  [3124] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2855511984, ["py"] = 0.2613700011, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Liquid Silver",
    ["cn"] = "Wrothgar Writings",
  },
  [3125] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2867915985, ["py"] = 0.2604132011, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "The Black Quill",
    ["cn"] = "Wrothgar Writings",
  },
  [3126] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2865867983, ["py"] = 0.2601576013, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Eye of Zthenganaz",
    ["cn"] = "Wrothgar Writings",
  },
  [3127] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2854423983, ["py"] = 0.2614456007, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Hammer of Glass",
    ["cn"] = "Wrothgar Writings",
  },
  [3128] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2868379980, ["py"] = 0.2607004016, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Scepter of the Riekr King-Chief",
    ["cn"] = "Wrothgar Writings",
  },
  [3129] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2865451982, ["py"] = 0.2606656014, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Mad Urkazbur's Ice-Effigy",
    ["cn"] = "Wrothgar Writings",
  },
  [3131] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "The House of Orsimer Glories",
    ["q"] = 5476,
    ["e"] = {
      [1] = { ["px"] = 0.2858131982, ["py"] = 0.2608284023, ["pm"] = 895, ["zm"] = 667, },
    },
  },
  [3132] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Curator's List of Sought-After Relics",
    ["q"] = 5476,
    ["e"] = {
      [1] = { ["px"] = 0.2858131982, ["py"] = 0.2608284023, ["pm"] = 895, ["zm"] = 667, },
    },
  },
  [3133] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3132588130, ["py"] = 0.2104024031, ["pm"] = 966, ["d"] = true,
        ["zx"] = 0.3108407950, ["zy"] = 0.2104932006, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to Hearth-Mother",
    ["cn"] = "Wrothgar Writings",
  },
  [3134] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3168800000,
        ["py"] = 0.2208900000,
        ["d"] = true,
        ["pm"] = 977,
      },
    },
    ["n"] = "A Memory Book, Part 1",
    ["cn"] = "Daedric Cults",
  },
  [3135] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3168900000,
        ["py"] = 0.2208600000,
        ["d"] = true,
        ["pm"] = 977,
      },
    },
    ["n"] = "A Memory Book, Part 2",
    ["cn"] = "Daedric Cults",
  },
  [3136] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3168900000,
        ["py"] = 0.2208600000,
        ["d"] = true,
        ["pm"] = 977,
      },
    },
    ["n"] = "A Memory Book, Part 3",
    ["cn"] = "Daedric Cults",
  },
  [3137] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2199843990, ["py"] = 0.2800599988, ["pm"] = 943, ["d"] = true,
        ["zx"] = 0.2335911961, ["zy"] = 0.2899660020, ["zm"] = 667,
      },
    },
    ["n"] = "Arakaul the Unbroken",
    ["cn"] = "Orsinium Archive",
  },
  [3138] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2203459990, ["py"] = 0.2801875987, ["pm"] = 943, ["d"] = true,
        ["zx"] = 0.2335911961, ["zy"] = 0.2899660020, ["zm"] = 667,
      },
    },
    ["n"] = "Windwalker Tamahl",
    ["cn"] = "Orsinium Archive",
  },
  [3139] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1987395952, ["py"] = 0.2818236024, ["pm"] = 950, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
    },
    ["n"] = "Application of Flame",
    ["cn"] = "Wrothgar Writings",
  },
  [3140] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1987651952, ["py"] = 0.2807096024, ["pm"] = 950, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
    },
    ["n"] = "Ushenat's Notes",
    ["cn"] = "Wrothgar Writings",
  },
  [3141] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1986439952, ["py"] = 0.2807480024, ["pm"] = 950, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
    },
    ["n"] = "Note from Azhnura",
    ["cn"] = "Wrothgar Writings",
  },
  [3142] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1986487952, ["py"] = 0.2818096024, ["pm"] = 950, ["d"] = true,
        ["zx"] = 0.2014011965, ["zy"] = 0.2799051993, ["zm"] = 667,
      },
    },
    ["n"] = "Note to Graguz",
    ["cn"] = "Wrothgar Writings",
  },
  [3143] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5504347733, ["py"] = 0.4809055993, ["pm"] = 897,
      },
    },
    ["n"] = "On the Xivkyn",
    ["cn"] = "Imperial Library",
  },
  [3144] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5498407731, ["py"] = 0.4803451994, ["pm"] = 898,
      },
    },
    ["n"] = "Imperial Architect's Correspondence",
    ["cn"] = "Imperial Library",
  },
  [3145] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3181080042, ["py"] = 0.2355915980, ["pm"] = 939, ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667, ["d"] = true, },
      [2] = { ["px"] = 0.3177468064, ["py"] = 0.2359424034, ["pm"] = 937, ["fp"] = true, },
    },
    ["n"] = "Mercenary's Scorched Journal",
    ["cn"] = "Orsinium Archive",
  },
  [3146] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5490787733, ["py"] = 0.4803243994, ["pm"] = 899,
      },
    },
    ["n"] = "Groundskeeper's Letter",
    ["cn"] = "Imperial Library",
  },
  [3147] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "To Warlord Ice-Heart",
    ["q"] = 5450,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2727800000,
        ["px"] = 0.2772700000,
        ["pm"] = 667,
      },
    },
  },
  [3148] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5481991733, ["py"] = 0.4800023996, ["pm"] = 785, },
    },
    ["n"] = "On the Tel Var Stones: Volume 1",
    ["cn"] = "Imperial Library",
  },
  [3149] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5486619733, ["py"] = 0.4805679994, ["pm"] = 785, },
    },
    ["n"] = "On the Tel Var Stones: Volume 2",
    ["cn"] = "Imperial Library",
  },
  [3150] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5471555732, ["py"] = 0.4803811996, ["pm"] = 901,
      },
    },
    ["n"] = "On the Tel Var Stones: Volume 3",
    ["cn"] = "Imperial Library",
  },
  [3152] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5460991733, ["py"] = 0.4809667996, ["pm"] = 900,
      },
    },
    ["n"] = "On the Tel Var Stones: Volume 4",
    ["cn"] = "Imperial Library",
  },
  [3153] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Path of the Faithful",
    ["q"] = 5340,
    ["e"] = {
      [1] = {
        ["pm"] = 957,
        ["py"] = 0.2742300000,
        ["px"] = 0.2326200000,
        ["d"] = true,
        ["r"] = true,
      },
    },
  },
  [3154] = {
    ["c"] = true,
    ["cn"] = "Wrothgar Writings",
    ["n"] = "Ode to My Jade Princess",
    ["q"] = 5442,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2352900000,
        ["px"] = 0.2586000000,
        ["pm"] = 667,
      },
    },
  },
  [3155] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5466139733, ["py"] = 0.4804491996, ["pm"] = 900,
      },
    },
    ["n"] = "Glyndallagan's Confession",
    ["cn"] = "Imperial Library",
  },
  [3156] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2126800000,
        ["px"] = 0.2936000000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Ogres of Wrothgar: A Continuing Treatise",
    ["cn"] = "Orsinium Archive",
  },
  [3157] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3162200000,
        ["py"] = 0.2358600000,
        ["d"] = true,
        ["pm"] = 937,
      },
      [2] = {
        ["pm"] = 667,
        ["px"] = 0.3162100000,
        ["d"] = true,
        ["py"] = 0.2358600000,
        ["mn"] = 27,
      },
    },
    ["n"] = "Bazorgbeg's Expeditionary Journal",
    ["cn"] = "Orsinium Archive",
  },
  [3158] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2603400000,
        ["px"] = 0.2550200000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Note to Agolas",
    ["cn"] = "Orsinium Archive",
  },
  [3159] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3165704064, ["py"] = 0.2357552034, ["pm"] = 937, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
      [2] = { ["px"] = 0.3177207986, ["py"] = 0.2371316014, ["pm"] = 938, ["fp"] = true, },
    },
    ["n"] = "Jeirmun's Work Log",
    ["cn"] = "Orsinium Archive",
  },
  [3160] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3171859986, ["py"] = 0.2377616015, ["pm"] = 938, ["d"] = true,
        ["zx"] = 0.3166119968, ["zy"] = 0.2353520015, ["zm"] = 667,
      },
    },
    ["n"] = "Auditorial Notes, Declension 81u5",
    ["cn"] = "Orsinium Archive",
  },
  [3161] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2093100000,
        ["py"] = 0.2717700000,
        ["d"] = true,
        ["pm"] = 979,
      },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2644600000,
        ["px"] = 0.2156500000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Grazdar's Notes: Hammer's Bypass",
    ["cn"] = "Orsinium Archive",
  },
  [3165] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2479331983, ["py"] = 0.2509600002, ["pm"] = 960, ["d"] = true,
        ["zx"] = 0.2515615967, ["zy"] = 0.2567827991, ["zm"] = 667,
      },
    },
    ["n"] = "Artisan's Notes",
    ["cn"] = "Wrothgar Writings",
  },
  [3167] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2192760011, ["py"] = 0.2806640061, ["pm"] = 949, ["d"] = true,
        ["zx"] = 0.2330731978, ["zy"] = 0.2939536016, ["zm"] = 667,
      },
      [2] = {
        ["px"] = 0.2194228021, ["py"] = 0.2810272009, ["pm"] = 948, ["d"] = true,
        ["zx"] = 0.2330731978, ["zy"] = 0.2939536016, ["zm"] = 667,
      },
    },
    ["n"] = "King Joile's Orders to General Mercedene",
    ["cn"] = "Orsinium Archive",
  },
  [3168] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2887004151, ["py"] = 0.2035496020, ["pm"] = 929, ["d"] = true,
        ["zx"] = 0.2893407951, ["zy"] = 0.2063236000, ["zm"] = 667,
      },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2577700000,
        ["px"] = 0.2886000000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter from a Prison Guard",
    ["cn"] = "Wrothgar Writings",
  },
  [3170] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "A Less Rude Song",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0304900000,
        ["r"] = true,
        ["px"] = 0.2479600000,
        ["pm"] = 1348,
      },
    },
    ["m"] = {
      [31] = 1,
    },
  },
  [3171] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2578500000,
        ["px"] = 0.2357300000,
        ["pm"] = 667,
      },
    },
    ["n"] = "A Brother's Gifts",
    ["cn"] = "Wrothgar Writings",
  },
  [3173] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2590800000,
        ["px"] = 0.2379900000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Old Snagara Breeding Guide",
    ["cn"] = "Wrothgar Writings",
  },
  [3175] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2472600000,
        ["px"] = 0.2485100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Deep Thoughts of Chief Gloorot",
    ["cn"] = "Wrothgar Writings",
  },
  [3192] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2860000000,
        ["px"] = 0.2363800000,
        ["pm"] = 667,
      },
      [2] = {
        ["mn"] = 27,
        ["py"] = 0.2876300000,
        ["px"] = 0.2381700000,
        ["pm"] = 667,
      },
      [3] = {
        ["mn"] = 27,
        ["py"] = 0.2874000000,
        ["px"] = 0.2371100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Our Continued Labor",
    ["cn"] = "Wrothgar Writings",
  },
  [3193] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2506300000,
        ["px"] = 0.2586800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Rites of the Abomination",
    ["cn"] = "Wrothgar Writings",
  },
  [3194] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2089000000,
        ["px"] = 0.2933000000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Ice Elder of the Ogres",
    ["cn"] = "Wrothgar Writings",
  },
  [3195] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2381800000,
        ["px"] = 0.2979600000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Warning at the Falls",
    ["cn"] = "Wrothgar Writings",
  },
  [3196] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2875563951, ["py"] = 0.2715512006, ["pm"] = 995, ["d"] = true, },
      [2] = { ["px"] = 0.2827247980, ["py"] = 0.2609756018, ["pm"] = 930, ["fp"] = true, },
      [3] = { ["px"] = 0.2842463980, ["py"] = 0.2576012014, ["pm"] = 895, ["zm"] = 667, ["fp"] = true, },
    },
    ["n"] = "Catalog of Tomes and Manuscripts",
    ["cn"] = "Wrothgar Writings",
  },
  [3197] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2692200000,
        ["px"] = 0.2406800000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2874900000,
        ["py"] = 0.2716800000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "The Hidden Tunnels of Orsinium",
    ["cn"] = "Wrothgar Writings",
  },
  [3198] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2194500000,
        ["px"] = 0.2795300000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2876100000,
        ["py"] = 0.2716300000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "The Battle of Orsinium",
    ["cn"] = "Wrothgar Writings",
  },
  [3199] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2077600000,
        ["px"] = 0.2875200000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2875000000,
        ["py"] = 0.2716200000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "Orc Clans and Symbology",
    ["cn"] = "Wrothgar Writings",
  },
  [3203] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2820600000,
        ["py"] = 0.2591600000,
        ["d"] = true,
        ["pm"] = 931,
      },
      [2] = {
        ["px"] = 0.2875200000,
        ["py"] = 0.2715500000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "A Plea for Help",
    ["cn"] = "Wrothgar Writings",
  },
  [3204] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2066900000,
        ["px"] = 0.3047700000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2875100000,
        ["py"] = 0.2715700000,
        ["d"] = true,
        ["pm"] = 959,
      },
    },
    ["n"] = "The Sport of Clans",
    ["cn"] = "Wrothgar Writings",
  },
  [3205] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2861043884, ["py"] = 0.2343588005, ["pm"] = 972, ["d"] = true,
        ["zx"] = 0.2878979967, ["zy"] = 0.2315476003, ["zm"] = 667,
      },
    },
    ["n"] = "Urgdosh's Unsent Letter",
    ["cn"] = "Orsinium Archive",
  },
  [3206] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2859111884, ["py"] = 0.2343680005, ["pm"] = 972, ["d"] = true,
        ["zx"] = 0.2878979967, ["zy"] = 0.2315476003, ["zm"] = 667,
      },
    },
    ["n"] = "Morkuldin's Final Delivery",
    ["cn"] = "Orsinium Archive",
  },
  [3207] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2854555884, ["py"] = 0.2338516006, ["pm"] = 972, ["d"] = true,
        ["zx"] = 0.2878979967, ["zy"] = 0.2315476003, ["zm"] = 667,
      },
    },
    ["n"] = "Skalg's Journal",
    ["cn"] = "Orsinium Archive",
  },
  [3208] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2860595884, ["py"] = 0.2335752005, ["pm"] = 972, ["d"] = true,
        ["zx"] = 0.2878979967, ["zy"] = 0.2315476003, ["zm"] = 667,
      },
    },
    ["n"] = "Morkuldin Visitor's Observations",
    ["cn"] = "Orsinium Archive",
  },
  [3209] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2857007884, ["py"] = 0.2338400005, ["pm"] = 972, ["d"] = true,
        ["zx"] = 0.2878979967, ["zy"] = 0.2315476003, ["zm"] = 667,
      },
    },
    ["n"] = "Gharakul's Journal",
    ["cn"] = "Orsinium Archive",
  },
  [3210] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2883731983, ["py"] = 0.2589492009, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Orcs and Their Tusks",
    ["cn"] = "Orsinium Archive",
  },
  [3211] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2489624027, ["py"] = 0.2917487971, ["pm"] = 961, ["d"] = true,
        ["zx"] = 0.2480059954, ["zy"] = 0.2887000017, ["zm"] = 667,
      },
    },
    ["n"] = "Ice-Heart's Journal",
    ["cn"] = "Orsinium Archive",
  },
  [3212] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2496064027, ["py"] = 0.2907939971, ["pm"] = 961, ["d"] = true,
        ["zx"] = 0.2480059954, ["zy"] = 0.2887000017, ["zm"] = 667,
      },
    },
    ["n"] = "The Care and Feeding of Briarhearts",
    ["cn"] = "Orsinium Archive",
  },
  [3213] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2904483978, ["py"] = 0.2588252013, ["pm"] = 895, ["zm"] = 667, },
      [2] = { ["px"] = 0.0712668028, ["py"] = 0.6033224053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: The Curse of Mandrake Manor",
    ["cn"] = "Orsinium Archive",
  },
  [3214] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2891100000,
        ["px"] = 0.2332700000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Malacath and the Reach",
    ["cn"] = "Orsinium Archive",
  },
  [3215] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2193700000,
        ["py"] = 0.2810800000,
        ["d"] = true,
        ["pm"] = 943,
      },
    },
    ["n"] = "Savage Sons War Chant",
    ["cn"] = "Orsinium Archive",
  },
  [3216] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2916400000,
        ["px"] = 0.2306700000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Unsent Letter From Qumih at-Tamina",
    ["cn"] = "Orsinium Archive",
  },
  [3217] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2935000000,
        ["px"] = 0.2311100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter to Lozruth",
    ["cn"] = "Orsinium Archive",
  },
  [3218] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 667,
        ["px"] = 0.2856800000,
        ["d"] = true,
        ["py"] = 0.1999700000,
        ["mn"] = 27,
      },
      [2] = { ["px"] = 0.0714036027, ["py"] = 0.6034144053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: The Locked Room Murder",
    ["cn"] = "Orsinium Archive",
  },
  [3219] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2718000000,
        ["px"] = 0.2641600000,
        ["pm"] = 667,
      },
      [2] = { ["px"] = 0.0713536026, ["py"] = 0.6034140052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: Fowl Play",
    ["cn"] = "Orsinium Archive",
  },
  [3220] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2266500000,
        ["px"] = 0.2647700000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Mystery of the Chub Loon",
    ["cn"] = "Orsinium Archive",
  },
  [3221] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2486000000,
        ["px"] = 0.2502700000,
        ["pm"] = 667,
      },
      [2] = {
        ["px"] = 0.2821700000,
        ["py"] = 0.2599800000,
        ["d"] = true,
        ["pm"] = 931,
      },
    },
    ["n"] = "Strange Rituals of the Orsimer",
    ["cn"] = "Orsinium Archive",
  },
  [3223] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2304000000,
        ["px"] = 0.2932000000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Letter to Orzorga",
    ["cn"] = "Orsinium Archive",
  },
  [3224] = {
    ["c"] = true,
    ["cn"] = "Orsinium Archive",
    ["n"] = "Invitation to Orsinium",
    ["q"] = 5450,
    ["e"] = {
      [1] = { ["px"] = 0.2898659979, ["py"] = 0.2639752009, ["pm"] = 895, ["zm"] = 667, },
      [2] = { ["px"] = 0.2857919986, ["py"] = 0.2606192011, ["pm"] = 895, ["zm"] = 667, },
    },
  },
  [3225] = {
    ["c"] = true,
    ["cn"] = "Orsinium Archive",
    ["n"] = "Malacath and Trinimac",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2340600000,
        ["pm"] = 667,
        ["px"] = 0.2863500000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 27,
      },
    },
    ["m"] = {
      [27] = 1,
    },
  },
  [3226] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2821635983, ["py"] = 0.2601088013, ["pm"] = 895, ["zm"] = 667, },
    },
    ["n"] = "Confessions of a Reluctant Recruit",
    ["cn"] = "Orsinium Archive",
  },
  [3227] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2472300000,
        ["px"] = 0.3090800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Prayer to the Furious One",
    ["cn"] = "Orsinium Archive",
  },
  [3228] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2801200000,
        ["px"] = 0.2199800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "The Legend of Grudge-Rock Falls",
    ["cn"] = "Orsinium Archive",
  },
  [3229] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2388300000,
        ["px"] = 0.2840100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Ode to a Watchtower",
    ["cn"] = "Orsinium Archive",
  },
  [3230] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2013000000,
        ["px"] = 0.2974800000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Ode to a Horker",
    ["cn"] = "Orsinium Archive",
  },
  [3231] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Captain Evani's Log",
    ["q"] = 5532,
    ["e"] = {
      [1] = {
        ["mn"] = 28,
        ["py"] = 0.4928600000,
        ["px"] = 0.2877600000,
        ["pm"] = 994,
      },
    },
  },
  [3233] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Iron Wheel Precept 15",
    ["e"] = {
      [1] = { ["px"] = 0.2448352073, ["py"] = 0.5255948180, ["pm"] = 994, },
    },
    ["n"] = "Iron Wheel Precept 15",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3234] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Iron Wheel Precept 21",
    ["e"] = {
      [1] = { ["px"] = 0.2428016073, ["py"] = 0.5286404179, ["pm"] = 994, },
    },
  },
  [3235] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Iron Wheel Precept 38",
    ["e"] = {
      [1] = { ["px"] = 0.2461128065, ["py"] = 0.5245616191, ["pm"] = 994, },
    },
  },
  [3236] = {
    ["c"] = true,
    ["cn"] = "Orsinium Archive",
    ["n"] = "Little Echatere",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 957,
        ["py"] = 0.2742600000,
        ["px"] = 0.2318000000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [27] = 1,
    },
  },
  [3237] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4213200000,
        ["py"] = 0.6419600000,
        ["d"] = true,
        ["pm"] = 997,
        ["zx"] = 0.4213403846, ["zy"] = 0.6417611997, ["zm"] = 256,
      },
    },
    ["n"] = "Letter to Paathi",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3238] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "The Elf, the Egg, and the Almost-Dragon",
    ["q"] = 5535,
    ["e"] = {
      [1] = { ["px"] = 0.2442456026, ["py"] = 0.5000963979, ["pm"] = 993, ["qc"] = true, ["zm"] = 994, }, -- on this location AFTER quest
      [2] = { ["px"] = 0.2512000000, ["py"] = 0.4910500000, ["d"] = true, ["pm"] = 1038, }, -- inside Sulima Mansion DURING quest (not verified !!! )
    },
  },
  [3239] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Rhanbiq's Notes",
    ["q"] = 5553,
    ["e"] = {
      [1] = { ["mn"] = 9, ["px"] = 0.7425900000, ["py"] = 0.5417700000, ["pm"] = 26, },
      [2] = { ["px"] = 0.2416107949, ["py"] = 0.4974460152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, }, -- location inside Thieves Den & World-Map pin
      [3] = { ["px"] = 0.2416107949, ["py"] = 0.4974460152, ["pm"] = 993, ["fp"] = true, }, -- "fake"-pin on City-Map
    },
  },
  [3242] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2916600000,
        ["py"] = 0.2598400000,
        ["d"] = true,
        ["pm"] = 927,
      },
    },
    ["n"] = "No More Shipments From Sentinel",
    ["cn"] = "Wrothgar Writings",
  },
  [3243] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2916900000,
        ["py"] = 0.2598500000,
        ["d"] = true,
        ["pm"] = 927,
      },
    },
    ["n"] = "Other Things I Hate",
    ["cn"] = "Wrothgar Writings",
  },
  [3244] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 27,
        ["py"] = 0.2606200000,
        ["px"] = 0.2858100000,
        ["pm"] = 667,
      },
    },
    ["n"] = "Armlet of Torug",
    ["cn"] = "Orsinium Archive",
  },
  [3245] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4219400000,
        ["py"] = 0.6417000000,
        ["d"] = true,
        ["pm"] = 997,
        ["zx"] = 0.4213403846, ["zy"] = 0.6417611997, ["zm"] = 256,
      },
    },
    ["n"] = "Mantra of Expulsion",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3248] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady Balina's Wedding Invitation",
    ["q"] = 5549,
    ["e"] = {
      [1] = { ["px"] = 0.2501356029, ["py"] = 0.4955435980, ["pm"] = 993, ["zx"] = 0.2501400000, ["zy"] = 0.4955400000, ["zm"] = 994, ["qp"] = true, },
    },
  },
  [3249] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Exposing a Terrible Evil",
    ["e"] = {
      [1] = { ["px"] = 0.3224516023, ["py"] = 0.5797944003, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3250] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Worship of the Dragon God",
    ["e"] = {
      [1] = { ["px"] = 0.3633080047, ["py"] = 0.5614243905, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3251] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "A Call for Common Hair",
    ["e"] = {
      [1] = { ["px"] = 0.2483840022, ["py"] = 0.4984575977, ["pm"] = 993, ["zx"] = 0.2484500000, ["zy"] = 0.4984200000, ["zm"] = 994, },
    },
  },
  [3252] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Varen's Wall",
    ["e"] = {
      [1] = { ["px"] = 0.3768640174, ["py"] = 0.5721172132, ["pm"] = 1006, },
    },
  },
  [3253] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Order of the Hour",
    ["e"] = {
      [1] = { ["px"] = 0.3693492127, ["py"] = 0.5786472121, ["pm"] = 1006, },
    },
  },
  [3254] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "On Minotaurs",
    ["e"] = {
      [1] = { ["px"] = 0.3350768019, ["py"] = 0.5725664007, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3255] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Pirate Queen of the Gold Coast",
    ["e"] = {
      [1] = { ["px"] = 0.3341088021, ["py"] = 0.5811752008, ["pm"] = 1074, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3300376016, ["py"] = 0.5707500000, ["pm"] = 1074, ["zm"] = 1006, },
      [3] = { ["px"] = 0.6785908035, ["py"] = 0.6275892134, ["pm"] = 1887, },
    },
  },
  [3256] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Wolf and the Dragon",
    ["e"] = {
      [1] = { ["px"] = 0.3251884025, ["py"] = 0.5696796004, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3257] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Wolf and the Pirate Queen",
    ["e"] = {
      [1] = { ["px"] = 0.3261596025, ["py"] = 0.5715536006, ["pm"] = 1074, ["zm"] = 1006, },
      [2] = { ["px"] = 0.6788804011, ["py"] = 0.6275148124, ["pm"] = 1887, },
    },
  },
  [3258] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Silver-Claw's Forged Wedding Invitation",
    ["e"] = {
      [1] = { ["px"] = 0.2482508031, ["py"] = 0.5022907980, ["pm"] = 993, ["zx"] = 0.2481400000, ["zy"] = 0.5023300000, ["zm"] = 994, },
    },
  },
  [3260] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Iron Wheel Prisoner Transfer: Zeira",
    ["q"] = 5545,
    ["e"] = {
      [1] = { ["px"] = 0.2584600110, ["py"] = 0.5293864156, ["pm"] = 994, },
      [2] = { ["px"] = 0.2508600000, ["py"] = 0.5254500000, ["d"] = true, ["pm"] = 1045, ["zm"] = 994, }, -- on location if you don't help Nicolas
    },
  },
  [3261] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Primate: Before the Light",
    ["e"] = {
      [1] = { ["px"] = 0.3718108048, ["py"] = 0.5647119905, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3262] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Primate: Finding Faith",
    ["e"] = {
      [1] = { ["px"] = 0.3689164044, ["py"] = 0.5558603904, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3278] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Primate: Rise to Glory",
    ["e"] = {
      [1] = { ["px"] = 0.3587292145, ["py"] = 0.5651700116, ["pm"] = 1006, },
    },
  },
  [3279] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Lie We Tell Ourselves",
    ["e"] = {
      [1] = { ["px"] = 0.3405032054, ["py"] = 0.5496087968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3405032166, ["zy"] = 0.5496088122, ["zm"] = 1006, },
    },
  },
  [3280] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Letter to Velsa",
    ["q"] = 5566,
    ["e"] = {
      [1] = { ["px"] = 0.2377600000, ["py"] = 0.5109500000, ["pm"] = 993, ["zm"] = 994 },
    },
  },
  [3281] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Black Dragon",
    ["e"] = {
      [1] = { ["px"] = 0.3334487911, ["py"] = 0.5829732136, ["pm"] = 1047, ["d"] = true, ["zx"] = 0.3334488160, ["zy"] = 0.5829732100, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3334488025, ["py"] = 0.5829732004, ["pm"] = 1074, ["fp"] = true, },
    },
  },
  [3282] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Journal of Ventilias Proximus",
    ["q"] = 5532,
    ["e"] = {
      [1] = { ["px"] = 0.2435376025, ["py"] = 0.5039883976, ["pm"] = 993, ["zx"] = 0.2435500000, ["zy"] = 0.5040200000, ["zm"] = 994, ["qp"] = true, },
    },
  },
  [3283] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Excerpt from al-Danobia Heist Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2191307981, ["py"] = 0.4586300113, ["pm"] = 1021, ["d"] = true, ["zx"] = 0.2258984075, ["zy"] = 0.4987672153, ["zm"] = 994, },
    },
  },
  [3284] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Wake Walkers' Orders",
    ["e"] = {
      [1] = { ["px"] = 0.2127187947, ["py"] = 0.5308976078, ["pm"] = 1030, ["d"] = true, ["zx"] = 0.2188744084, ["zy"] = 0.5338356157, ["zm"] = 994, },
    },
  },
  [3318] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Investigator Vale: A Deadly Toll",
    ["e"] = {
      [1] = { ["px"] = 0.2497228109, ["py"] = 0.5165392146, ["pm"] = 994, },
      [2] = { ["px"] = 0.0713660026, ["py"] = 0.6033448052, ["pm"] = 2163, ["zm"] = 2114, },
    },
  },
  [3320] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 1",
    ["e"] = {
      [1] = { ["px"] = 0.2415795949, ["py"] = 0.4972920152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415795949, ["py"] = 0.4972920152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3324] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Page 71: Erendette's Account",
    ["q"] = 5581,
    ["e"] = {
      [1] = { ["px"] = 0.2416639949, ["py"] = 0.4977400152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416639949, ["py"] = 0.4977400152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3325] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 2",
    ["e"] = {
      [1] = { ["px"] = 0.2501356029, ["py"] = 0.4955435980, ["pm"] = 993, ["zx"] = 0.2501400000, ["zy"] = 0.4955400000, ["zm"] = 994, },
    },
  },
  [3326] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Arrest Writ",
    ["q"] = 5581,
    ["e"] = {
      [1] = { ["px"] = 0.2415703949, ["py"] = 0.4979604152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415703949, ["py"] = 0.4979604152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3328] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4207728067, ["py"] = 0.6427839735, ["pm"] = 1000, ["d"] = true,
        ["zx"] = 0.4213403846, ["zy"] = 0.6417611997, ["zm"] = 256,
      },
    },
    ["n"] = "Letter to Abbot Kulan-dro",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3329] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 3",
    ["e"] = {
      [1] = { ["px"] = 0.2493187967, ["py"] = 0.4927732101, ["pm"] = 1032, ["d"] = true, ["zx"] = 0.2493188114, ["zy"] = 0.4927732158, ["zm"] = 994, },
      [2] = { ["px"] = 0.2493188003, ["py"] = 0.4927732032, ["pm"] = 1038, ["fp"] = true, }, -- inside instance
      [3] = { ["px"] = 0.2493312019, ["py"] = 0.4927831980, ["pm"] = 993, ["fp"] = true, }, -- city-map
    },
  },
  [3331] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4218000000,
        ["py"] = 0.6415500000,
        ["d"] = true,
        ["pm"] = 997,
        ["zx"] = 0.4213403846, ["zy"] = 0.6417611997, ["zm"] = 256,
      },
    },
    ["n"] = "Vazshara's Journal",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3332] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 4",
    ["e"] = {
      [1] = { ["px"] = 0.2527500000, ["py"] = 0.4954800000, ["pm"] = 1039, ["zx"] = 0.2528048078, ["zy"] = 0.4955324150, ["zm"] = 994, },
      [2] = { ["px"] = 0.2528044033, ["py"] = 0.4955451978, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3334] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4219700000,
        ["py"] = 0.6417700000,
        ["d"] = true,
        ["pm"] = 997,
        ["zx"] = 0.4213403846, ["zy"] = 0.6417611997, ["zm"] = 256,
      },
    },
    ["n"] = "Twilight Rites and Hymns",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3335] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 5",
    ["e"] = {
      [1] = { ["px"] = 0.2524268032, ["py"] = 0.4993051979, ["pm"] = 993, ["zx"] = 0.2524100000, ["zy"] = 0.4993400000, ["zm"] = 994, },
    },
  },
  [3336] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Abah's Landing Merchant Lords, V. 6",
    ["e"] = {
      [1] = { ["px"] = 0.2409952030, ["py"] = 0.5015411975, ["pm"] = 993, ["zx"] = 0.2410500000, ["zy"] = 0.5016100000, ["zm"] = 994, },
    },
  },
  [3337] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Travel Itinerary",
    ["q"] = 5570,
    ["e"] = {
      [1] = { ["px"] = 0.2545400000, ["py"] = 0.4961900000, ["pm"] = 1039, ["zx"] = 0.2545804103, ["zy"] = 0.4961536151, ["zm"] = 994, },
      [2] = { ["px"] = 0.2546108016, ["py"] = 0.4962055977, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3338] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Letter to Percy Velmont",
    ["q"] = 5570,
    ["e"] = {
      [1] = { ["px"] = 0.2524000000, ["py"] = 0.4956800000, ["pm"] = 1039, ["zx"] = 0.2524028068, ["zy"] = 0.4956680163, ["zm"] = 994, },
      [2] = { ["px"] = 0.2515668022, ["py"] = 0.4957699976, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3339] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Orders from Lady Anais",
    ["q"] = 5570,
    ["e"] = {
      [1] = { ["px"] = 0.2535800000, ["py"] = 0.4986900000, ["pm"] = 1039, ["zx"] = 0.2535968082, ["zy"] = 0.4986736143, ["zm"] = 994, },
      [2] = { ["px"] = 0.2536036020, ["py"] = 0.4986795973, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3407] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "By Order of Chief Inspector Rhanbiq",
    ["e"] = {
      [1] = { ["px"] = 0.2415607949, ["py"] = 0.4979456151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415607949, ["py"] = 0.4979456151, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3408] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Black Dragon's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3696907861, ["py"] = 0.5825171875, ["pm"] = 1073, ["d"] = true, ["zx"] = 0.3696908129, ["zy"] = 0.5825172106, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3404020054, ["py"] = 0.5495471968, ["pm"] = 1063, ["d"] = true, ["qc"] = true, ["zx"] = 0.3404020139, ["zy"] = 0.5495472108, ["zm"] = 1006, },
    },
  },
  [3409] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Rhanbiq's Orders: Iron Wheel Headquarters",
    ["e"] = {
      [1] = { ["px"] = 0.2528356070, ["py"] = 0.5259532177, ["pm"] = 994, },
      [2] = { ["px"] = 0.2494800000, ["py"] = 0.5273000000, ["d"] = true, ["pm"] = 1045, ["zm"] = 994, }, -- only accessible during quest
    },
  },
  [3410] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Silver-Claw's Ledger",
    ["q"] = 5534,
    ["e"] = {
      [1] = { ["px"] = 0.2482900024, ["py"] = 0.5019711980, ["pm"] = 993, ["zx"] = 0.2483000000, ["zy"] = 0.5019800000, ["zm"] = 994, ["qc"] = true, },
    },
  },
  [3412] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "The Bleak Veil Endures",
    ["e"] = {
      [1] = { ["px"] = 0.2331700000, ["py"] = 0.5007000000, ["d"] = true, ["pm"] = 1003, ["zx"] = 0.2320660089, ["zy"] = 0.5013796147, ["zm"] = 994, },
    },
  },
  [3413] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "An Excerpt from the Book of Seasons",
    ["e"] = {
      [1] = { ["px"] = 0.2592800000, ["py"] = 0.5070100000, ["d"] = true, ["pm"] = 1042, ["zx"] = 0.2592432116, ["zy"] = 0.5070096166, ["zm"] = 994, },
      [2] = { ["px"] = 0.2592432015, ["py"] = 0.5070095982, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3415] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Letter from the Governor",
    ["e"] = {
      [1] = { ["px"] = 0.3111348141, ["py"] = 0.5562704122, ["pm"] = 1006, }, -- inside building, only accessible during a quest
      [2] = { ["px"] = 0.3125352148, ["py"] = 0.5545120125, ["pm"] = 1006, }, -- outside of the building, on a table near by
    },
  },
  [3420] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Urgent Message from Walks-Softly",
    ["e"] = {
      [1] = { ["px"] = 0.2416300000, ["py"] = 0.4978600000, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416300000, ["py"] = 0.4978600000, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3421] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "King Farangel's Ode to Wayrest",
    ["e"] = {
      [1] = { ["px"] = 0.2415287949, ["py"] = 0.4975008152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415287949, ["py"] = 0.4975008152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3423] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Triumph of the Sep Adder",
    ["e"] = {
      [1] = { ["px"] = 0.2439448024, ["py"] = 0.5037791980, ["pm"] = 993, ["zx"] = 0.2439600000, ["zy"] = 0.5037400000, ["zm"] = 994, },
    },
  },
  [3424] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Prince Hew and the Haj Mota Chariot",
    ["e"] = {
      [1] = { ["px"] = 0.2508912032, ["py"] = 0.4975427982, ["pm"] = 993, ["zx"] = 0.2508900000, ["zy"] = 0.4974800000, ["zm"] = 994, }
    },
  },
  [3425] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Prince Hew and the Three-Legged Race",
    ["e"] = {
      [1] = { ["px"] = 0.2464496023, ["py"] = 0.4951375977, ["pm"] = 993, ["zx"] = 0.2463200000, ["zy"] = 0.4951800000, ["zm"] = 994, },
      [2] = { ["px"] = 0.2524536044, ["py"] = 0.5267407909, ["pm"] = 1002, ["zm"] = 994, },
    },
  },
  [3426] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Help Complete Abah's Local History!",
    ["e"] = {
      [1] = { ["px"] = 0.2482524028, ["py"] = 0.4943351976, ["pm"] = 993, ["zx"] = 0.2481400000, ["zy"] = 0.4943500000, ["zm"] = 994, },
    },
  },
  [3427] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Balith's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2562484118, ["py"] = 0.5270212180, ["pm"] = 994, },
    },
  },
  [3428] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Fleg's Note",
    ["e"] = {
      [1] = { ["px"] = 0.2387588081, ["py"] = 0.5349504192, ["pm"] = 994, },
    },
  },
  [3429] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "The Red Curse, Volume 1",
    ["e"] = {
      [1] = { ["px"] = 0.2405308030, ["py"] = 0.5003607972, ["pm"] = 993, ["zx"] = 0.2405600000, ["zy"] = 0.5004000000, ["zm"] = 994, },
    },
  },
  [3430] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "The Red Curse, Volume 2",
    ["e"] = {
      [1] = { ["px"] = 0.2201124086, ["py"] = 0.5351404146, ["pm"] = 994, },
    },
  },
  [3431] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "The Red Curse, Volume 3",
    ["e"] = {
      [1] = { ["px"] = 0.2449672030, ["py"] = 0.5051563982, ["pm"] = 993, ["zx"] = 0.2450200000, ["zy"] = 0.5051600000, ["zm"] = 994, },
    },
  },
  [3432] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "No Shira, No Good!",
    ["e"] = {
      [1] = { ["px"] = 0.2416340106, ["py"] = 0.5251960188, ["pm"] = 994, },
    },
  },
  [3433] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "No Fuss, No Rush",
    ["e"] = {
      [1] = { ["px"] = 0.2416399949, ["py"] = 0.4972968152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416399949, ["py"] = 0.4972968152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3434] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Look at this Guard Dispatch!",
    ["e"] = {
      [1] = { ["px"] = 0.2420951949, ["py"] = 0.4975580152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2420951949, ["py"] = 0.4975580152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3435] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Scouting Report: Deadhollow Halls",
    ["e"] = {
      [1] = { ["px"] = 0.2415539949, ["py"] = 0.4976968151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415539949, ["py"] = 0.4976968151, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3436] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Scouting Report: The Hideaway",
    ["e"] = {
      [1] = { ["px"] = 0.2415315949, ["py"] = 0.4977272152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415315949, ["py"] = 0.4977272152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3437] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Scouting Report: Underground Sepulcher",
    ["e"] = {
      [1] = { ["px"] = 0.2415395949, ["py"] = 0.4976884152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415395949, ["py"] = 0.4976884152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3438] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Missing: Khiruna",
    ["e"] = {
      [1] = { ["px"] = 0.2418775948, ["py"] = 0.4975116152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2418775948, ["py"] = 0.4975116152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3439] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Word of Khiruna",
    ["e"] = {
      [1] = { ["px"] = 0.2416027949, ["py"] = 0.4976300151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416027949, ["py"] = 0.4976300151, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3440] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Missing: Gordonkha the Shark and Lazy Murshez",
    ["e"] = {
      [1] = { ["px"] = 0.2416607949, ["py"] = 0.4974124152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416607949, ["py"] = 0.4974124152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3441] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Murshez Is Dead",
    ["e"] = {
      [1] = { ["px"] = 0.2416311949, ["py"] = 0.4975652152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416311949, ["py"] = 0.4975652152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3442] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Letter to Lady Sulima",
    ["e"] = {
      [1] = { ["px"] = 0.2490951966, ["py"] = 0.4931852099, ["pm"] = 1032, ["d"] = true, ["zx"] = 0.2490136078, ["zy"] = 0.4932244160, ["zm"] = 994, },
      [2] = { ["px"] = 0.2490136009, ["py"] = 0.4932244031, ["pm"] = 1038, ["fp"] = true, }, -- inside instance
      [3] = { ["px"] = 0.2494132021, ["py"] = 0.4930611981, ["pm"] = 993, ["fp"] = true, }, -- city-map
    },
  },
  [3443] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Saroldo's Greatest Treasure",
    ["e"] = {
      [1] = { ["px"] = 0.2415419949, ["py"] = 0.4978776151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415419949, ["py"] = 0.4978776151, ["pm"] = 933, ["fp"] = true, },
    },
  },
  [3444] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Authenticity of the Giovessen Skull",
    ["e"] = {
      [1] = { ["px"] = 0.6621424186, ["py"] = 0.2600443977, ["pm"] = 996, },
      [2] = {
        ["mn"] = 28,
        ["py"] = 0.5288600000,
        ["px"] = 0.2588500000,
        ["pm"] = 994,
      },
      [3] = { ["px"] = 0.2415707949, ["py"] = 0.4975252152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, }, -- location inside Thieves Den + World-Map pin
      [4] = { ["px"] = 0.2415707949, ["py"] = 0.4975252152, ["pm"] = 993, ["fp"] = true, }, -- "fake"-pin location for City-Map
    },
  },
  [3445] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 28,
        ["py"] = 0.5316600000,
        ["px"] = 0.2430400000,
        ["pm"] = 994,
      },
    },
    ["n"] = "Rhanbiq's Orders: Fulstrom Homestead",
    ["cn"] = "Hew's Bane Bookshelf",
  },
  [3446] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Warehouse Under New Ownership",
    ["e"] = {
      [1] = { ["px"] = 0.2429656028, ["py"] = 0.5142267974, ["pm"] = 993, ["zx"] = 0.2429800000, ["zy"] = 0.5142600000, ["zm"] = 994, },
    },
  },
  [3447] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Rhanbiq's Orders: al-Danobia Tomb",
    ["e"] = {
      [1] = { ["px"] = 0.2555384082, ["py"] = 0.5250512149, ["pm"] = 994, },
    },
  },
  [3448] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Rhanbiq's Orders: No Shira Prison",
    ["e"] = {
      [1] = { ["px"] = 0.2529584116, ["py"] = 0.5274808151, ["pm"] = 994, },
    },
  },
  [3449] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Kari's Hit List",
    ["e"] = {
      [1] = { ["px"] = 0.2415519949, ["py"] = 0.4975292152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415519949, ["py"] = 0.4975292152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3484] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3705100000,
        ["px"] = 0.7540300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 1",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3490] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2863500000,
        ["px"] = 0.7167300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 2",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3491] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2740700000,
        ["px"] = 0.7229300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 3",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3492] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3603400000,
        ["px"] = 0.7891900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 4",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3493] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3847200000,
        ["px"] = 0.8210500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 5",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3494] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3603300000,
        ["px"] = 0.7824700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 6",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3495] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Donolon Bakes",
    ["e"] = {
      [1] = { ["px"] = 0.2408600000, ["py"] = 0.7446600000, ["pm"] = 243, ["zm"] = 143, },
      [2] = {
        ["mn"] = 2,
        ["py"] = 0.3806100000,
        ["px"] = 0.0510200000,
        ["pm"] = 1,
      },
      [3] = {
        ["mn"] = 2,
        ["py"] = 0.3811500000,
        ["px"] = 0.0615100000,
        ["pm"] = 1,
      },
      [4] = {
        ["mn"] = 11,
        ["py"] = 0.4236800000,
        ["px"] = 0.7915900000,
        ["pm"] = 7,
      },
      [5] = {
        ["mn"] = 11,
        ["py"] = 0.4296900000,
        ["px"] = 0.7820900000,
        ["pm"] = 7,
      },
      [6] = { ["px"] = 0.2321832013, ["py"] = 0.7465588228, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [3496] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8378740212, ["py"] = 0.3125975997, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 7",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3497] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2739500000,
        ["px"] = 0.8052500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 8",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3498] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8138956209, ["py"] = 0.2894180058, ["pm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 9",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3499] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7660287723, ["py"] = 0.3793955983, ["pm"] = 1287, ["zm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 10",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3500] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3625600000,
        ["px"] = 0.7739600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 11",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3501] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3494100000,
        ["px"] = 0.7388900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 12",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3502] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3124300000,
        ["px"] = 0.7269100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 13",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3503] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3056500000,
        ["px"] = 0.7966000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 14",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3504] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2639800000,
        ["px"] = 0.7463100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 15",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3505] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3179000000,
        ["px"] = 0.7549000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 16",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3506] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2713100000,
        ["px"] = 0.8121100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 17",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3507] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3582000000,
        ["px"] = 0.8239000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 18",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3508] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3068100000,
        ["px"] = 0.8195800000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 19",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3509] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3494500000,
        ["px"] = 0.8308900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 20",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3510] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3516700000,
        ["px"] = 0.7595900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 21",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3511] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3570400000,
        ["px"] = 0.7813000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 22",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3512] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3386500000,
        ["px"] = 0.7732100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 23",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3513] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3682800000,
        ["px"] = 0.7828600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 24",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3514] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Mudcrab Order Request",
    ["e"] = {
      [1] = { ["px"] = 0.2378080090, ["py"] = 0.5073872168, ["pm"] = 994, },
    },
  },
  [3515] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "To My Unknown Benefactor",
    ["e"] = {
      [1] = { ["px"] = 0.2415703949, ["py"] = 0.4975668152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415703949, ["py"] = 0.4975668152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3516] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Litany of Blood",
    ["q"] = 5634,
    ["e"] = {
      [1] = {
        ["px"] = 0.3401600000,
        ["py"] = 0.5498900000,
        ["d"] = true,
        ["pm"] = 1063,
        ["zx"] = 0.3402540155, ["zy"] = 0.5499960129, ["zm"] = 1006,
      },
    },
  },
  [3517] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Litany of Blood Fulfilled",
    ["e"] = {
      [1] = { ["px"] = 0.3401588054, ["py"] = 0.5498911968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3401588150, ["zy"] = 0.5498912131, ["zm"] = 1006, },
    },
  },
  [3518] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7467236166, ["py"] = 0.3331127999, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 25",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3519] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3322800000,
        ["px"] = 0.7996000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 26",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3520] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3254300000,
        ["px"] = 0.8415600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 27",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3521] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3589800000,
        ["px"] = 0.8190500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 28",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3522] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3471900000,
        ["px"] = 0.8366700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 29",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3523] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3195500000,
        ["px"] = 0.7291400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 30",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3524] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2860800000,
        ["px"] = 0.7357200000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 31",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3525] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3537000000,
        ["px"] = 0.7683500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 32",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3526] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3501700000,
        ["px"] = 0.7489800000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 33",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3527] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2965000000,
        ["px"] = 0.8047000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The 36 Lessons: Sermon 34",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3528] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7773036148, ["py"] = 0.3792920074, ["pm"] = 1233, ["zx"] = 0.7773036230, ["zy"] = 0.3792920097, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7773035712, ["py"] = 0.3792919977, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "The 36 Lessons: Sermon 35",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3529] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7533216163, ["py"] = 0.3386444000, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 36",
    ["cn"] = "Vivec's 36 Lessons",
  },
  [3530] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Confessions of a Vampire Devotee",
    ["e"] = {
      [1] = { ["px"] = 0.3255300022, ["py"] = 0.5745124002, ["pm"] = 1074, ["zm"] = 1006, },
      [2] = { ["px"] = 0.6623703751, ["py"] = 1.5132352402, ["pm"] = 1839, ["d"] = true, ["zx"] = 0.6616824197, ["zy"] = 1.5113048374, ["zm"] = 1747, },
    },
  },
  [3531] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Butcher of Bravil",
    ["e"] = {
      [1] = { ["px"] = 0.3253236024, ["py"] = 0.5757728003, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3532] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Investigator Vale: Shadow Fellows",
    ["e"] = {
      [1] = { ["px"] = 0.3290752016, ["py"] = 0.5677020005, ["pm"] = 1074, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3296184029, ["py"] = 0.5768652003, ["pm"] = 1074, ["zm"] = 1006, },
      [3] = { ["px"] = 0.3691296050, ["py"] = 0.5571567902, ["pm"] = 1064, ["zm"] = 1006, },
      [4] = { ["px"] = 0.0713236029, ["py"] = 0.6032548052, ["pm"] = 2163, ["zm"] = 2114, },
    },
  },
  [3533] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Letter from Kireth",
    ["e"] = {
      [1] = { ["px"] = 0.3281144021, ["py"] = 0.5669476003, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3534] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Society of the Dragon",
    ["e"] = {
      [1] = { ["px"] = 0.3660344049, ["py"] = 0.5618119896, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3535] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lord Wallavir's Wedding Invitation",
    ["q"] = 5549,
    ["e"] = {
      [1] = { ["px"] = 0.2415583949, ["py"] = 0.4975132152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415583949, ["py"] = 0.4975132152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3582] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Silver Dawn Contract",
    ["q"] = 5599,
    ["e"] = {
      [1] = { ["px"] = 0.6343700000, ["py"] = 0.4143800000, ["d"] = true, ["pm"] = 1056, },
      [2] = { ["px"] = 0.3406820054, ["py"] = 0.5497859968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3406820126, ["zy"] = 0.5497860109, ["zm"] = 1006, ["qc"] = true, },
    },
  },
  [3583] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Andarri's Theory",
    ["e"] = {
      [1] = { ["px"] = 0.2416475949, ["py"] = 0.4974484152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2416475949, ["py"] = 0.4974484152, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3584] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Thrag's Theory",
    ["q"] = 5532,
    ["e"] = {
      [1] = { ["px"] = 0.2415551949, ["py"] = 0.4977660152, ["d"] = true, ["pm"] = 1013, ["pm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2415551949, ["py"] = 0.4977660152, ["pm"] = 933, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3585] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Quen's Theory",
    ["q"] = 5535,
    ["e"] = {
      [1] = { ["px"] = 0.2416751949, ["py"] = 0.4976140151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2416751949, ["py"] = 0.4976140151, ["pm"] = 993, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3586] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Walks-Softly's Theory",
    ["q"] = 5570,
    ["e"] = {
      [1] = { ["px"] = 0.2417427949, ["py"] = 0.4974980152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2417427949, ["py"] = 0.4974980152, ["pm"] = 993, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3587] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Velsa's Theory",
    ["q"] = 5581,
    ["e"] = {
      [1] = { ["px"] = 0.2417103949, ["py"] = 0.4979568152, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2417103949, ["py"] = 0.4979568152, ["pm"] = 993, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3588] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Silver-Claw's Theory",
    ["q"] = 5545,
    ["e"] = {
      [1] = { ["px"] = 0.2416459949, ["py"] = 0.4977728151, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2416459949, ["py"] = 0.4977728151, ["pm"] = 993, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3589] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Lady in the Cistern: Zeira's Theory",
    ["q"] = 5553,
    ["e"] = {
      [1] = { ["px"] = 0.2416083949, ["py"] = 0.4975764152, ["pm"] = 1013, ["d"] = true, ["zm"] = 994, ["qc"] = true, },
      [2] = { ["px"] = 0.2416083949, ["py"] = 0.4975764152, ["pm"] = 993, ["fp"] = true, ["qc"] = true, },
    },
  },
  [3590] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Excerpt from Cosh's Papers",
    ["e"] = {
      [1] = {
        ["mn"] = 28,
        ["py"] = 0.5208100000,
        ["px"] = 0.2214400000,
        ["pm"] = 994,
      },
    },
  },
  [3591] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Join the Order!",
    ["e"] = {
      [1] = { ["px"] = 0.3674536181, ["py"] = 0.5789000133, ["pm"] = 1006, },
      [2] = { ["px"] = 0.3684036148, ["py"] = 0.5787812153, ["pm"] = 1006, },
      [3] = { ["px"] = 0.3698872161, ["py"] = 0.5793844143, ["pm"] = 1006, },
      [4] = { ["px"] = 0.3690784169, ["py"] = 0.5809260109, ["pm"] = 1006, },
      [5] = { ["px"] = 0.3689443862, ["py"] = 0.5817611875, ["pm"] = 1072, ["d"] = true, ["zm"] = 1006, },
    },
  },
  [3607] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Chewed Note",
    ["e"] = {
      [1] = { ["px"] = 0.3692127862, ["py"] = 0.5822047875, ["pm"] = 1072, ["d"] = true, ["zx"] = 0.3692144168, ["zy"] = 0.5822060148, ["zm"] = 1006, },
    },
  },
  [3608] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "Faradan's Letter",
    ["q"] = 5581,
    ["e"] = {
      [1] = { ["px"] = 0.2415500000, ["py"] = 0.4979600000, ["d"] = true, ["pm"] = 1013, ["zm"] = 994, },
      [2] = { ["px"] = 0.2415500000, ["py"] = 0.4979600000, ["pm"] = 993, ["fp"] = true, },
    },
  },
  [3640] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Contractor's Note",
    ["e"] = {
      [1] = { ["px"] = 0.3114244126, ["py"] = 0.5564431905, ["pm"] = 1015, ["d"] = true, ["zm"] = 1006, },
    },
  },
  [3641] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "A Call to the Worthy", -- only on locations AFTER the quests "5548" & "5569" have been completed
    ["e"] = {
      [1] = { ["px"] = 0.3648064048, ["py"] = 0.5627807898, ["pm"] = 1064, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3685284046, ["py"] = 0.5574415899, ["pm"] = 1064, ["zm"] = 1006, },
      [3] = { ["px"] = 0.3228112025, ["py"] = 0.5717420005, ["pm"] = 1074, ["zm"] = 1006, },
      [4] = { ["px"] = 0.3319104025, ["py"] = 0.5716812005, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3642] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Sweetroll Recipients",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3484088132, ["py"] = 0.5838868121, ["pm"] = 1006, ["qc"] = true, },
    },
  },
  [3643] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Venom's Sanctuary Marginalia",
    ["e"] = {
      [1] = { ["px"] = 0.3403936054, ["py"] = 0.5495527968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3403936156, ["zy"] = 0.5495528107, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3131672024, ["py"] = 0.5357520123, ["pm"] = 1057, ["d"] = true, ["zx"] = 0.3142580156, ["zy"] = 0.5365052122, ["zm"] = 1006, },
    },
  },
  [3644] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Guide to Taming Dire Wolves",
    ["e"] = {
      [1] = { ["px"] = 0.3532328139, ["py"] = 0.5597992128, ["pm"] = 1006, },
    },
  },
  [3645] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Letter to the Withered Rose",
    ["e"] = {
      [1] = { ["px"] = 0.3162004147, ["py"] = 0.5644072122, ["pm"] = 1006, },
    },
  },
  [3646] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Suspicious Message",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3612640049, ["py"] = 0.5587315900, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3647] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0100200000,
        ["d"] = true,
        ["py"] = 0.1522900000,
        ["pm"] = 830,
      },
    },
    ["n"] = "Kindly Contrivers Notes",
    ["cn"] = "Gold Coast Tomes",
  },
  [3648] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0100000000,
        ["d"] = true,
        ["py"] = 0.1522000000,
        ["pm"] = 830,
      },
    },
    ["n"] = "Sanguine's Revelers Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3649] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0100300000,
        ["d"] = true,
        ["py"] = 0.1522800000,
        ["pm"] = 830,
      },
    },
    ["n"] = "Shadowbanish Vintners Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3650] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Gold Coast Guide, Part One",
    ["e"] = {
      [1] = { ["px"] = 0.3499316165, ["py"] = 0.5592292136, ["pm"] = 1006, },
    },
  },
  [3651] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Gold Coast Guide, Part Two",
    ["e"] = {
      [1] = { ["px"] = 0.3415776142, ["py"] = 0.5584512121, ["pm"] = 1006, },
    },
  },
  [3652] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Glories of the Pirate Queen",
    ["e"] = {
      [1] = { ["px"] = 0.3333735911, ["py"] = 0.5834184136, ["pm"] = 1047, ["d"] = true, ["zx"] = 0.3333736158, ["zy"] = 0.5834184150, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3333736022, ["py"] = 0.5834184008, ["pm"] = 1074, ["fp"] = true, },
      [3] = {
        ["mn"] = 32,
        ["py"] = 0.6903700000,
        ["px"] = 0.0781300000,
        ["pm"] = 1349,
      },
    },
  },
  [3653] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Naughty Nereid Players",
    ["e"] = {
      [1] = { ["px"] = 0.3231872021, ["py"] = 0.5710416001, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3654] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "River Trolls Exterminator?",
    ["e"] = {
      [1] = { ["px"] = 0.3332611912, ["py"] = 0.5838424136, ["pm"] = 1047, ["d"] = true, ["zx"] = 0.3332612134, ["zy"] = 0.5838424126, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3332612022, ["py"] = 0.5838423997, ["pm"] = 1074, ["fp"] = true, },
    },
  },
  [3655] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Intriguing Ayleid Ruin",
    ["e"] = {
      [1] = { ["px"] = 0.3388396152, ["py"] = 0.5540464109, ["pm"] = 1006, },
    },
  },
  [3665] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Soggy Note",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3640536049, ["py"] = 0.5597287903, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3666] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Up High Note",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3658984050, ["py"] = 0.5602587906, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3667] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Secret Note",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3676040048, ["py"] = 0.5568999900, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3668] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Arena Note",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3719200045, ["py"] = 0.5555451901, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3669] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Epitaph for Maxivian Faleria",
    ["e"] = {
      [1] = { ["px"] = 0.3505964169, ["py"] = 0.5726772108, ["pm"] = 1006, },
    },
  },
  [3670] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Epitaph for Neransi Faleria",
    ["e"] = {
      [1] = { ["px"] = 0.3506524155, ["py"] = 0.5727092125, ["pm"] = 1006, },
    },
  },
  [3671] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Epitaph for Ianus Faleria",
    ["e"] = {
      [1] = { ["px"] = 0.3513700137, ["py"] = 0.5738296130, ["pm"] = 1006, },
    },
  },
  [3672] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Epitaph for Lucina Faleria",
    ["e"] = {
      [1] = { ["px"] = 0.3512632141, ["py"] = 0.5738076129, ["pm"] = 1006, },
    },
  },
  [3673] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Five Tenets",
    ["e"] = {
      [1] = { ["px"] = 0.3404208054, ["py"] = 0.5499663968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3404208132, ["zy"] = 0.5499664133, ["zm"] = 1006, },
    },
  },
  [3674] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Field Guide to River Trolls",
    ["e"] = {
      [1] = { ["px"] = 0.3293256028, ["py"] = 0.5721620001, ["pm"] = 1074, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3375824161, ["py"] = 0.5656816132, ["pm"] = 1006, },
    },
  },
  [3675] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Dibella's Mysteries and Revelations",
    ["e"] = {
      [1] = { ["px"] = 0.3314388027, ["py"] = 0.5743916006, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3676] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Garlas Agea Construction Log",
    ["e"] = {
      [1] = { ["px"] = 0.3444967938, ["py"] = 0.5614548071, ["pm"] = 1005, ["d"] = true, ["zx"] = 0.3446196147, ["zy"] = 0.5632124133, ["zm"] = 1006, },
    },
  },
  [3677] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Cathedral Hierarchy",
    ["e"] = {
      [1] = { ["px"] = 0.3666424045, ["py"] = 0.5655507904, ["pm"] = 1064, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3719500050, ["py"] = 0.5599523896, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3678] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Knightsgrave: Legend or Legacy",
    ["e"] = {
      [1] = { ["px"] = 0.3136552129, ["py"] = 0.5360884118, ["pm"] = 1006, },
    },
  },
  [3679] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Song of the Prowler",
    ["e"] = {
      [1] = { ["px"] = 0.3280972025, ["py"] = 0.5811452000, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3680] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Anvil Taxes",
    ["e"] = {
      [1] = { ["px"] = 0.3304516025, ["py"] = 0.5770179997, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3681] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Kvatch Arena Reopens!",
    ["e"] = {
      [1] = { ["px"] = 0.3717952051, ["py"] = 0.5566199901, ["pm"] = 1064, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3720136045, ["py"] = 0.5553623901, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3682] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Free Market of the People",
    ["e"] = {
      [1] = { ["px"] = 0.3271248024, ["py"] = 0.5719088004, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3683] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Arena Fight Card",
    ["e"] = {
      [1] = { ["px"] = 0.3734744043, ["py"] = 0.5562579903, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3684] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Deal",
    ["e"] = {
      [1] = { ["px"] = 0.3453800151, ["py"] = 0.5820860127, ["pm"] = 1006, },
    },
  },
  [3685] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Your Package Is Ready",
    ["e"] = {
      [1] = { ["px"] = 0.3336856029, ["py"] = 0.5791504002, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3686] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "To the Traitor of Saintsport",
    ["e"] = {
      [1] = { ["px"] = 0.3291600022, ["py"] = 0.5774624005, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3687] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Regarding Your Contract",
    ["e"] = {
      [1] = { ["px"] = 0.3437152156, ["py"] = 0.5735648134, ["pm"] = 1006, },
    },
  },
  [3688] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Special Instructions",
    ["e"] = {
      [1] = { ["px"] = 0.3120676134, ["py"] = 0.5664956130, ["pm"] = 1006, },
    },
  },
  [3690] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Needful Things",
    ["e"] = {
      [1] = { ["px"] = 0.3161744152, ["py"] = 0.5645904131, ["pm"] = 1006, },
    },
  },
  [3691] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Silver Werewolf",
    ["e"] = {
      [1] = { ["px"] = 0.3407588054, ["py"] = 0.5499111968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3407588132, ["zy"] = 0.5499112134, ["zm"] = 1006, },
    },
  },
  [3692] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Saga of Captain Wereshark, Part 4",
    ["e"] = {
      [1] = { ["px"] = 0.3407556054, ["py"] = 0.5497899968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3407548138, ["zy"] = 0.5497900133, ["zm"] = 1006, },
    },
  },
  [3693] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Saga of Captain Wereshark, Part 5",
    ["e"] = {
      [1] = { ["px"] = 0.3287304023, ["py"] = 0.5719932005, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3694] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Saga of Captain Wereshark, Part 6",
    ["e"] = {
      [1] = { ["px"] = 0.3627044122, ["py"] = 0.5524811919, ["pm"] = 1051, ["d"] = true, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3627044047, ["py"] = 0.5524811903, ["pm"] = 1064, ["fp"] = true, },
    },
  },
  [3695] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Saga of Captain Wereshark, Part 7",
    ["e"] = {
      [1] = { ["px"] = 0.3653472045, ["py"] = 0.5612703897, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3696] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Words of the Grand Sermonizer",
    ["e"] = {
      [1] = { ["px"] = 0.3597716164, ["py"] = 0.5638900138, ["pm"] = 1006, },
      [2] = { ["px"] = 0.3590200000, ["py"] = 0.5640000000, ["d"] = true, ["pm"] = 1068, }, -- location needs to be verified, can only be reached during a quest
    },
  },
  [3697] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Rise of the Red Sails",
    ["e"] = {
      [1] = { ["px"] = 0.3623244098, ["py"] = 0.5514836005, ["pm"] = 1052, ["d"] = true, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3623240047, ["py"] = 0.5514855902, ["pm"] = 1064, ["fp"] = true, },
    },
  },
  [3698] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "A Gold Coast Children's Bestiary",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1052,
        ["py"] = 0.5514300000,
        ["px"] = 0.3623700000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [29] = 1,
    },
  },
  [3699] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Minotaur Song",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5561800000,
        ["pm"] = 1006,
        ["px"] = 0.3109500000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 29,
      },
    },
    ["m"] = {
      [29] = 1,
    },
  },
  [3700] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Bitter Travels Among the Nixad",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5639300000,
        ["pm"] = 1006,
        ["px"] = 0.3589500000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 29,
      },
    },
    ["m"] = {
      [29] = 1,
    },
  },
  [3701] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Glint in the Night",
    ["e"] = {
      [1] = { ["px"] = 0.3400704054, ["py"] = 0.5502439968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3400704153, ["zy"] = 0.5502440130, ["zm"] = 1006, },
    },
  },
  [3702] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Gold Coast Goblin Tribes",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1063,
        ["py"] = 0.5500700000,
        ["px"] = 0.3395300000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [29] = 1,
    },
  },
  [3703] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Mysterious Mermaid of Anvil",
    ["e"] = {
      [1] = { ["px"] = 0.3323616017, ["py"] = 0.5691468002, ["pm"] = 1074, ["zx"] = 0.3323616154, ["zy"] = 0.5691468097, ["zm"] = 1006, },
    },
  },
  [3704] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Letter to Sybilline Elve",
    ["e"] = {
      [1] = { ["px"] = 0.3273303992, ["py"] = 0.5733052024, ["pm"] = 1009, ["d"] = true, ["zx"] = 0.3273304141, ["zy"] = 0.5733052113, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3273304026, ["py"] = 0.5733052000, ["pm"] = 1074, ["fp"] = true, },
    },
  },
  [3705] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Anvil Lighthouse Report",
    ["e"] = {
      [1] = { ["px"] = 0.3270007992, ["py"] = 0.5731628024, ["pm"] = 1009, ["d"] = true, ["zx"] = 0.3270008153, ["zy"] = 0.5731628098, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3270008025, ["py"] = 0.5731628005, ["pm"] = 1074, ["fp"] = true, },
    },
  },
  [3706] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Fantos Epilion's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3085036147, ["py"] = 0.5377052116, ["pm"] = 1006, },
    },
  },
  [3708] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Lost Fort Faleria",
    ["e"] = {
      [1] = { ["px"] = 0.3293412019, ["py"] = 0.5729220003, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3710] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Great Cathedral Closed!",
    ["e"] = {
      [1] = { ["px"] = 0.3681828052, ["py"] = 0.5607871905, ["pm"] = 1064, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3678300048, ["py"] = 0.5603779905, ["pm"] = 1064, ["zm"] = 1006, },
      [3] = { ["px"] = 0.3682556046, ["py"] = 0.5599967900, ["pm"] = 1064, ["zm"] = 1006, },
      [4] = { ["px"] = 0.3656688046, ["py"] = 0.5582655904, ["pm"] = 1064, ["zm"] = 1006, },
      [5] = { ["px"] = 0.3677972050, ["py"] = 0.5570355903, ["pm"] = 1064, ["zm"] = 1006, },
      [6] = { ["px"] = 0.3721024043, ["py"] = 0.5642563901, ["pm"] = 1064, ["zm"] = 1006, },
      [7] = { ["px"] = 0.3704544044, ["py"] = 0.5641659899, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3711] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Reman's Fortune",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3249392020, ["py"] = 0.5696396005, ["pm"] = 1074, ["zm"] = 1006, ["qp"] = true, },
    },
  },
  [3712] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Naryu's Fortune",
    ["q"] = 5664,
    ["e"] = {
      [1] = { ["px"] = 0.3701776043, ["py"] = 0.5643107897, ["pm"] = 1064, ["zm"] = 1006, },
    },
  },
  [3713] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Captive's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.7193495857, ["py"] = 0.5420640076, ["pm"] = 1128, ["d"] = true, ["zx"] = 0.7174887920, ["zy"] = 0.5417071944, ["zm"] = 26, },
    },
  },
  [3715] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Farewell Note",
    ["e"] = {
      [1] = { ["px"] = 0.7197951734, ["py"] = 0.5418136137, ["pm"] = 1129, ["d"] = true, ["zx"] = 0.7174887920, ["zy"] = 0.5417071944, ["zm"] = 26, },
    },
  },
  [3716] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Urgent Letter",
    ["e"] = {
      [1] = { ["px"] = 0.7187164094, ["py"] = 0.5414403948, ["pm"] = 1127, ["d"] = true, ["zx"] = 0.7174887920, ["zy"] = 0.5417071944, ["zm"] = 26, },
    },
  },
  [3717] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Na-Kesh's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.7193464123, ["py"] = 0.5413668141, ["pm"] = 1130, ["d"] = true, ["zx"] = 0.7174887920, ["zy"] = 0.5417071944, ["zm"] = 26, },
    },
  },
  [3719] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Blade of Woe",
    ["e"] = {
      [1] = { ["px"] = 0.3403700054, ["py"] = 0.5495707968, ["d"] = true, ["pm"] = 1063, ["zx"] = 0.3403700121, ["zy"] = 0.5495708113, ["zm"] = 1006, },
    },
  },
  [3720] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0056400000,
        ["d"] = true,
        ["py"] = 0.1507000000,
        ["pm"] = 828,
      },
    },
    ["n"] = "Imperial University Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3721] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0055700000,
        ["d"] = true,
        ["py"] = 0.1506800000,
        ["pm"] = 828,
      },
    },
    ["n"] = "Kwama Miner's Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3722] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0055900000,
        ["d"] = true,
        ["py"] = 0.1506800000,
        ["pm"] = 828,
      },
    },
    ["n"] = "Dragonstar Caravan Company Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3723] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0148100000,
        ["d"] = true,
        ["py"] = 0.1525100000,
        ["pm"] = 833,
      },
    },
    ["n"] = "Resolutes of Stendarr Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3724] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0146900000,
        ["d"] = true,
        ["py"] = 0.1525400000,
        ["pm"] = 833,
      },
    },
    ["n"] = "Baandari Peddler Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3725] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0147800000,
        ["d"] = true,
        ["py"] = 0.1526400000,
        ["pm"] = 833,
      },
    },
    ["n"] = "Gold Coast Trading Company Note",
    ["cn"] = "Gold Coast Tomes",
  },
  [3726] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8184927990, ["py"] = 0.3248048074, ["pm"] = 1286, ["d"] = true,
        ["zx"] = 0.8203436253, ["zy"] = 0.3256828023, ["zm"] = 1060,
      },
    },
    ["n"] = "Tel Fyr, Additional Specifications",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3731] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Gold Coast Notables",
    ["e"] = {
      [1] = { ["px"] = 0.3404068054, ["py"] = 0.5500535968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3404068120, ["zy"] = 0.5500536119, ["zm"] = 1006, },
    },
  },
  [3733] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "A Nixad Made Me Do It",
    ["e"] = {
      [1] = { ["px"] = 0.3497096131, ["py"] = 0.5829112152, ["pm"] = 1006, },
    },
  },
  [3734] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Solus Vertilus's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3111408148, ["py"] = 0.5481260125, ["pm"] = 1006, },
    },
  },
  [3735] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Eyewitness to the Wall",
    ["e"] = {
      [1] = { ["px"] = 0.3746424152, ["py"] = 0.5653064109, ["pm"] = 1006, },
    },
  },
  [3736] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Lord Jarol's Deep Thoughts",
    ["e"] = {
      [1] = { ["px"] = 0.3119628135, ["py"] = 0.5531052118, ["pm"] = 1006, },
    },
  },
  [3737] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Black Dragon's Journal, Part 2",
    ["q"] = 5598,
    ["e"] = {
      [1] = { ["px"] = 0.3403988054, ["py"] = 0.5495503968, ["pm"] = 1063, ["d"] = true, ["qc"] = true, ["zx"] = 0.3403988131, ["zy"] = 0.5495504116, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3138900000, ["py"] = 0.5345600000, ["d"] = true, ["pm"] = 1071, ["zm"] = 1006, },
    },
  },
  [3738] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Grand Sermonizer's Journal",
    ["q"] = 5595,
    ["e"] = {
      [1] = { ["px"] = 0.3701464050, ["py"] = 0.5594911897, ["pm"] = 1064, ["zm"] = 1006, ["qc"] = true, }, -- on this location AFTER quest is completed
      [2] = { ["px"] = 0.3589356040, ["py"] = 0.5639467879, ["d"] = true, ["pm"] = 1066, ["zm"] = 1006, ["qp"] = true, }, -- only accessible during quest
    },
  },
  [3739] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Letter to the Grand Chanter",
    ["e"] = {
      [1] = { ["px"] = 0.3340536019, ["py"] = 0.5746376001, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [3740] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "Count's Correspondence",
    ["e"] = {
      [1] = { ["px"] = 0.3628332098, ["py"] = 0.5514724005, ["pm"] = 1052, ["d"] = true, ["zm"] = 1006, },
      [2] = { ["px"] = 0.3628332047, ["py"] = 0.5514723902, ["pm"] = 1064, ["fp"] = true, },
    },
  },
  [3741] = {
    ["c"] = true,
    ["cn"] = "Gold Coast Tomes",
    ["n"] = "The Black Hand",
    ["e"] = {
      [1] = { ["px"] = 0.3406844054, ["py"] = 0.5498183968, ["pm"] = 1063, ["d"] = true, ["zx"] = 0.3406844147, ["zy"] = 0.5498184119, ["zm"] = 1006, },
    },
  },
  [3955] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3759200000,
        ["px"] = 0.7925500000,
        ["pm"] = 1060,
      },
      [2] = {
        ["l"] = true,
        ["mn"] = 30,
        ["pm"] = 1060,
        ["px"] = 0.7926100000,
        ["d"] = true,
        ["py"] = 0.3759000000,
      },
      [3] = { ["px"] = 0.0714076026, ["py"] = 0.6034028052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale in Vvardenfell",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3956] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Geel-Ma's Diary",
    ["e"] = {
      [1] = { ["px"] = 0.7248960079, ["py"] = 0.5609620149, ["pm"] = 1133, ["d"] = true, ["zx"] = 0.7253195922, ["zy"] = 0.5595879920, ["zm"] = 26, },
    },
  },
  [3957] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Web-Covered Diary",
    ["e"] = {
      [1] = { ["px"] = 0.7250011714, ["py"] = 0.5612079994, ["pm"] = 1134, ["d"] = true, ["zx"] = 0.7253195922, ["zy"] = 0.5595879920, ["zm"] = 26, },
    },
  },
  [3958] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Dranos's Diary",
    ["e"] = {
      [1] = { ["px"] = 0.7255908049, ["py"] = 0.5607140017, ["pm"] = 1135, ["d"] = true, ["zx"] = 0.7253195922, ["zy"] = 0.5595879920, ["zm"] = 26, },
    },
  },
  [3959] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3291400000,
        ["px"] = 0.8251000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Narsis Dren and the Cursed Coffin",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3961] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Letter to Eraven",
    ["q"] = 5799,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3090600000,
        ["px"] = 0.8313100000,
        ["pm"] = 1060,
      },
    },
  },
  [3962] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3813600000,
        ["px"] = 0.8221700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Magister's Writ",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3963] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1374796002, ["py"] = 0.3214932027, ["pm"] = 1,
      },
    },
    ["n"] = "Captain Black Sword's Journal",
    ["cn"] = "Diaries and Logs",
  },
  [3964] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2723100000,
        ["px"] = 0.8010400000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.2730100000,
        ["px"] = 0.8136400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Letter to Savarak",
    ["cn"] = "Mysteries and Clues",
  },
  [3965] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3546200000,
        ["px"] = 0.7687400000,
        ["pm"] = 1060,
      },
      [2] = {
        ["px"] = 0.7911500000,
        ["py"] = 0.3579100000,
        ["d"] = true,
        ["pm"] = 1210,
      },
    },
    ["n"] = "Letter to Marshal Hlaren",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3966] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3633800000,
        ["px"] = 0.7737600000,
        ["pm"] = 1060,
      },
      [2] = {
        ["px"] = 0.7914400000,
        ["py"] = 0.3564900000,
        ["d"] = true,
        ["pm"] = 1210,
      },
    },
    ["n"] = "Letter to Kharekh gra-Bagrat",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3967] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3546300000,
        ["px"] = 0.7865300000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3589600000,
        ["px"] = 0.7870900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Menaldinion's Advert",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3968] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3580700000,
        ["px"] = 0.7854500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Teas and Tisanes for Aches and Pains",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3969] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7924400000,
        ["py"] = 0.3584300000,
        ["d"] = true,
        ["pm"] = 1210,
      },
    },
    ["n"] = "Slave Testimony from Arano Plantation",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3970] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Homes for Sale!",
    ["e"] = {
      [1] = {
        ["mn"] = 11,
        ["py"] = 0.4342400000,
        ["px"] = 0.7835100000,
        ["pm"] = 7,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3725500000,
        ["px"] = 0.7663300000,
        ["pm"] = 1060,
      },
      [3] = { ["px"] = 0.2323000015, ["py"] = 0.7462944222, ["pm"] = 243, ["zm"] = 143, },
      [4] = {
        ["mn"] = 2,
        ["py"] = 0.3909600000,
        ["px"] = 0.0642700000,
        ["pm"] = 1,
      },
    },
  },
  [3977] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7742328247, ["py"] = 0.3827612037, ["pm"] = 1225, ["zx"] = 0.7742328290, ["zy"] = 0.3827612104, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7742327717, ["py"] = 0.3827611978, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "Ritual of Appeasement",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3978] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3666900000,
        ["px"] = 0.8245700000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3561700000,
        ["px"] = 0.8093100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Wise-woman's Journal Page",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3979] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3621600000,
        ["px"] = 0.8127400000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3539300000,
        ["px"] = 0.8246200000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Devotee Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3980] = {
    ["c"] = true,
    ["cn"] = "Words of the Poets",
    ["n"] = "Lord Vivec's Questions",
    ["q"] = 5803,
    ["e"] = {
      [1] = {
        ["px"] = 0.7580800000,
        ["py"] = 0.3638300000,
        ["d"] = true,
        ["pm"] = 1212,
      },
    },
  },
  [3981] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7214000000,
        ["py"] = 0.2853500000,
        ["d"] = true,
        ["pm"] = 1271,
      },
    },
    ["n"] = "A Guide to Dwemer Mega-Structures",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3983] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7454900000,
        ["py"] = 0.3564600000,
        ["d"] = true,
        ["pm"] = 1159,
        ["zx"] = 0.7456536265, ["zy"] = 0.3564428040, ["zm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3694900000,
        ["px"] = 0.7558600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Halinjirr's Notes",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3985] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7720527722, ["py"] = 0.3794183984, ["pm"] = 1287, ["zm"] = 1060, },
    },
    ["n"] = "Ordinator Edict: Mandate Seven",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3986] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7470016166, ["py"] = 0.3331007999, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "Ordinator Edict: Mandate Sixteen",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3987] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3607100000,
        ["px"] = 0.7876500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Ordinator Edict: Mandate Twenty-One",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3988] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3619700000,
        ["px"] = 0.8127300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Ordinator Edict: Mandate Twenty-Seven",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3989] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2870100000,
        ["px"] = 0.7170200000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Ordinator Edict: Mandate Thirty-Four",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3990] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3120400000,
        ["px"] = 0.7255000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Omaren Trial Transcript",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3991] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3558700000,
        ["px"] = 0.7864000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Drunken Aphorisms",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3992] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3133000000,
        ["px"] = 0.8337000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "An \"Invitation\" to Discovery",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3993] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3125700000,
        ["px"] = 0.8343500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 1",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3994] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7468780166, ["py"] = 0.3336203999, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "The Truth in Sequence: Volume 2",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3995] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3608200000,
        ["px"] = 0.7879000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 3",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3996] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3610800000,
        ["px"] = 0.8182100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 4",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3997] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2860000000,
        ["px"] = 0.7170900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 5",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3998] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3311500000,
        ["px"] = 0.7798000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 6",
    ["cn"] = "Vvardenfell Volumes",
  },
  [3999] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2872200000,
        ["px"] = 0.7147000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Cliff Strider Song",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4000] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3129400000,
        ["px"] = 0.8337900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Nix-Hounds: A Manual for New Owners",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4001] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7729607959, ["py"] = 0.3796668031, ["pm"] = 1237, ["zx"] = 0.7724204203, ["zy"] = 0.3801716092, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7726659851, ["py"] = 0.3801527956, ["pm"] = 1235, ["fp"] = true, ["d"] = true, }, -- upper canton
      [3] = { ["px"] = 0.7724203723, ["py"] = 0.3801715976, ["pm"] = 1287, ["fp"] = true, }, -- vivec city
    },
    ["n"] = "A Guide to Liturgical Vestments",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4002] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2753600000,
        ["px"] = 0.8141000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Skin Blights By Any Other Name",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4003] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7742700247, ["py"] = 0.3828668037, ["pm"] = 1225, ["zx"] = 0.7742700221, ["zy"] = 0.3828668036, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7742699721, ["py"] = 0.3828667983, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "Ordinators: A Comprehensive Guide",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4004] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3713100000,
        ["px"] = 0.7560600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Understanding the Living Gods",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4005] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3623700000,
        ["px"] = 0.8130900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Buoyant Armigers: Swords of Vivec",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4007] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7242900000,
        ["py"] = 0.2990700000,
        ["d"] = true,
        ["pm"] = 1207,
      },
    },
    ["n"] = "Honored Ancestors",
    ["cn"] = "Mysteries and Clues",
  },
  [4011] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3373900000,
        ["px"] = 0.7462500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Honorable Writs of Execution",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4012] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2125876021, ["py"] = 0.3370888075, ["pm"] = 33, ["zm"] = 12, },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.7361800000,
        ["px"] = 0.4363300000,
        ["pm"] = 9,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5172500000,
        ["px"] = 0.7585700000,
        ["pm"] = 13,
      },
    },
    ["n"] = "Notice: Pledge Duties",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [4013] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3484700000,
        ["px"] = 0.7403600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Assassin's Orders",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4015] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7530132163, ["py"] = 0.3414652003, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "House Redoran Proclamation",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [4016] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Red Exile Instructions",
    ["q"] = 5880,
    ["e"] = {
      [1] = {
        ["px"] = 0.7434600000,
        ["py"] = 0.3424300000,
        ["d"] = true,
        ["pm"] = 1249,
      },
      [2] = {
        ["pm"] = 1060,
        ["px"] = 0.7740600000,
        ["d"] = true,
        ["py"] = 0.3834700000,
        ["mn"] = 30,
      },
    },
  },
  [4019] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3555900000,
        ["px"] = 0.7855100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Blessed Almalexia's Fables for Morning",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4020] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2718000000,
        ["px"] = 0.8048500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Blessed Almalexia's Fables for Evening",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4021] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7416400000,
        ["py"] = 0.3051000000,
        ["d"] = true,
        ["pm"] = 1209,
      },
    },
    ["n"] = "Ballad of Dranoth Hleran",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4022] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 13,
        ["py"] = 0.2816200000,
        ["px"] = 0.6321300000,
        ["pm"] = 61,
      },
    },
    ["n"] = "From Old Life To New",
    ["cn"] = "Lore and Culture",
  },
  [4023] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Incarnate Ranso's Scroll",
    ["q"] = 5888,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3053200000,
        ["px"] = 0.7531900000,
        ["pm"] = 1060,
      },
    },
  },
  [4024] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Incarnate Aduri's Scroll",
    ["q"] = 5888,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3044300000,
        ["px"] = 0.7529400000,
        ["pm"] = 1060,
      },
    },
  },
  [4025] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Incarnate Danaat's Scroll",
    ["q"] = 5888,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3033800000,
        ["px"] = 0.7510000000,
        ["pm"] = 1060,
      },
    },
  },
  [4026] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3256200000,
        ["px"] = 0.8083100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Mean Old Torchbug",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4027] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7502700000,
        ["py"] = 0.3512400000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Bloody Note",
    ["cn"] = "Mysteries and Clues",
  },
  [4029] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7505900000,
        ["py"] = 0.3525300000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Discarded Journal",
    ["cn"] = "Personal Journals",
  },
  [4030] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7504700000,
        ["py"] = 0.3527700000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Letter to Master Rethan",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4031] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7509000000,
        ["py"] = 0.3526800000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Warning to Miners",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4032] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7497700000,
        ["py"] = 0.3517500000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Gavros's Research Notes",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4033] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7498300000,
        ["py"] = 0.3521400000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "The Source of the Formula",
    ["cn"] = "Research Notes",
  },
  [4034] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7502100000,
        ["py"] = 0.3521500000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Gavros's Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4035] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7508900000,
        ["py"] = 0.3526900000,
        ["d"] = true,
        ["pm"] = 1246,
      },
    },
    ["n"] = "Miner's Scrawled Letter",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4036] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7243300000,
        ["py"] = 0.2990300000,
        ["d"] = true,
        ["pm"] = 1207,
      },
    },
    ["n"] = "Very Old Note",
    ["cn"] = "Mysteries and Clues",
  },
  [4037] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7497600000,
        ["py"] = 0.3517500000,
        ["d"] = true,
        ["pm"] = 1246,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.2911100000,
        ["px"] = 0.7976400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Vile Truth of Barbas",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4038] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1060,
        ["px"] = 0.7768900000,
        ["d"] = true,
        ["py"] = 0.3793800000,
        ["mn"] = 30,
      },
    },
    ["n"] = "Testimonials on Baar Dau",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4039] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2658900000,
        ["px"] = 0.8067700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Dark Elves, Dark Hearts",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4040] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2718500000,
        ["px"] = 0.8062300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Silt Strider Caravaner's Log",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4041] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8115200000,
        ["py"] = 0.2901600000,
        ["d"] = true,
        ["pm"] = 1252,
      },
    },
    ["n"] = "Notice to All Research Assistants",
    ["cn"] = "Notes and Memos",
  },
  [4043] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "How to Use the Tonal Inverter",
    ["q"] = 5893,
    ["e"] = {
      [1] = {
        ["px"] = 0.8314400000,
        ["py"] = 0.3606100000,
        ["d"] = true,
        ["pm"] = 1258,
        ["zx"] = 0.8304508295, ["zy"] = 0.3602984073, ["zm"] = 1060,
      },
    },
  },
  [4044] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2682500000,
        ["px"] = 0.7967600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Seythen's Journal Page",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4045] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2732100000,
        ["px"] = 0.8013000000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3119100000,
        ["px"] = 0.8363400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Letter to Mertis",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4046] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2945900000,
        ["px"] = 0.8166800000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3094100000,
        ["px"] = 0.8320100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Firuth's Writ of Endorsement",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4049] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7682900000,
        ["py"] = 0.2798900000,
        ["d"] = true,
        ["pm"] = 1276,
      },
    },
    ["n"] = "Wakener's Sermon",
    ["cn"] = "Daedric Cults",
  },
  [4052] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Magister Otheri's Research Journal",
    ["q"] = 5914,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3096600000,
        ["px"] = 0.8322200000,
        ["pm"] = 1060,
      },
    },
  },
  [4053] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7919300000,
        ["py"] = 0.3220300000,
        ["d"] = true,
        ["pm"] = 1214,
      },
    },
    ["n"] = "Instructions for Lothnarth",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4055] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "My Golden Child",
    ["q"] = 5920,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3704700000,
        ["px"] = 0.7547400000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3690200000,
        ["px"] = 0.7526400000,
        ["pm"] = 1060,
      },
    },
  },
  [4056] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3412100000,
        ["px"] = 0.7538900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "House Redoran Registry",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4057] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7997300000,
        ["py"] = 0.3134200000,
        ["d"] = true,
        ["pm"] = 1244,
      },
    },
    ["n"] = "The Library of Andule",
    ["cn"] = "Lore and Culture",
  },
  [4058] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3699200000,
        ["px"] = 0.7550700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Unfinished Report",
    ["cn"] = "Mysteries and Clues",
  },
  [4059] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7330200000,
        ["py"] = 0.3684900000,
        ["d"] = true,
        ["pm"] = 1248,
      },
    },
    ["n"] = "Captain's Note",
    ["cn"] = "Mysteries and Clues",
  },
  [4061] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Barilzar's Hirelings",
    ["q"] = 5893,
    ["e"] = {
      [1] = {
        ["px"] = 0.8313800000,
        ["py"] = 0.3607700000,
        ["d"] = true,
        ["pm"] = 1258,
        ["zx"] = 0.8304508295, ["zy"] = 0.3602984073, ["zm"] = 1060,
      },
    },
  },
  [4062] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3198000000,
        ["px"] = 0.7271500000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Hlaalu Letter",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4063] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3090100000,
        ["px"] = 0.7422200000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Meeting with Chodala",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4064] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3199900000,
        ["px"] = 0.7270700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Report From Captain Brivan",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4065] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Rhea's Letter",
    ["q"] = 5935,
    ["e"] = {
      [1] = {
        ["mn"] = 4,
        ["py"] = 0.3108200000,
        ["px"] = 0.2088000000,
        ["pm"] = 12,
      },
      [2] = {
        ["mn"] = 4,
        ["py"] = 0.3113500000,
        ["px"] = 0.2067100000,
        ["pm"] = 12,
      },
    },
  },
  [4098] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5418500000,
        ["px"] = 0.7201300000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Tommy Bones's Journal",
    ["cn"] = "Personal Journals",
  },
  [4099] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3214900000,
        ["px"] = 0.7458600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "House Redoran Orders",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4100] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7263500000,
        ["py"] = 0.3118100000,
        ["d"] = true,
        ["pm"] = 1157,
        ["zx"] = 0.7252892229, ["zy"] = 0.3110492054, ["zm"] = 1060,
      },
    },
    ["n"] = "Blood-Soaked Letter",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4101] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7075800000,
        ["py"] = 0.2738600000,
        ["d"] = true,
        ["pm"] = 1242,
        ["zx"] = 0.7080584241, ["zy"] = 0.2743400069, ["zm"] = 1060,
      },
    },
    ["n"] = "Snorfin's Notes",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4103] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3652900000,
        ["px"] = 0.7412300000,
        ["pm"] = 1060,
      },
      [2] = {
        ["px"] = 0.7380600000,
        ["py"] = 0.3617000000,
        ["d"] = true,
        ["pm"] = 1248,
      },
    },
    ["n"] = "Good Travels!",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4105] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "For Glory!",
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3825500000,
        ["px"] = 0.7666500000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3391800000,
        ["px"] = 0.7535300000,
        ["pm"] = 1060,
      },
      [3] = {
        ["mn"] = 30,
        ["py"] = 0.2731400000,
        ["px"] = 0.8053500000,
        ["pm"] = 1060,
      },
      [4] = {
        ["mn"] = 30,
        ["py"] = 0.3132900000,
        ["px"] = 0.8375300000,
        ["pm"] = 1060,
      },
      [5] = {
        ["mn"] = 30,
        ["py"] = 0.2868900000,
        ["px"] = 0.7147700000,
        ["pm"] = 1060,
      },
      [6] = {
        ["mn"] = 30,
        ["py"] = 0.2646000000,
        ["px"] = 0.7458500000,
        ["pm"] = 1060,
      },
      [7] = {
        ["mn"] = 30,
        ["py"] = 0.3020000000,
        ["px"] = 0.7386700000,
        ["pm"] = 1060,
      },
      [8] = {
        ["mn"] = 30,
        ["py"] = 0.3384200000,
        ["px"] = 0.7676900000,
        ["pm"] = 1060,
      },
      [9] = {
        ["mn"] = 10,
        ["py"] = 0.5153200000,
        ["px"] = 0.7704400000,
        ["pm"] = 13,
      },
      [10] = {
        ["mn"] = 2,
        ["py"] = 0.3810400000,
        ["px"] = 0.0599000000,
        ["pm"] = 1,
      },
      [11] = {
        ["mn"] = 32,
        ["py"] = 0.7629600000,
        ["px"] = 0.0621500000,
        ["pm"] = 1349,
      },
      [12] = { ["px"] = 0.2280240012, ["py"] = 0.7442076225, ["pm"] = 243, ["zm"] = 143, },
      [13] = { ["px"] = 0.2363188006, ["py"] = 0.7426096224, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [4106] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7475412165, ["py"] = 0.3373595998, ["pm"] = 1290, ["zm"] = 1060, },
    },
    ["n"] = "Pierced Note",
    ["cn"] = "Mysteries and Clues",
  },
  [4107] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Ode to Ethrandora",
    ["q"] = 5799,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3094100000,
        ["px"] = 0.8316900000,
        ["pm"] = 1060,
      },
    },
  },
  [4108] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7260500000,
        ["py"] = 0.3120000000,
        ["d"] = true,
        ["pm"] = 1157,
        ["zx"] = 0.7252892229, ["zy"] = 0.3110492054, ["zm"] = 1060,
      },
    },
    ["n"] = "A One-Time Offer",
    ["cn"] = "Notes and Memos",
  },
  [4109] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3183000000,
        ["px"] = 0.7270800000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "House Redoran Advisory",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4110] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3197100000,
        ["px"] = 0.7271700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Council Meeting Summons",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4111] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3183000000,
        ["px"] = 0.7267900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Letter to Councilor Dolvara",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4113] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8314500000,
        ["py"] = 0.3607600000,
        ["d"] = true,
        ["pm"] = 1258,
        ["zx"] = 0.8304508295, ["zy"] = 0.3602984073, ["zm"] = 1060,
      },
    },
    ["n"] = "On Extending Existence",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4114] = {
    ["c"] = true,
    ["q"] = 5893,
    ["e"] = {
      [1] = {
        ["px"] = 0.7918800000,
        ["py"] = 0.3292700000,
        ["d"] = true,
        ["pm"] = 1213,
        ["zx"] = 0.7930392216, ["zy"] = 0.3295808016, ["zm"] = 1060,
      },
    },
    ["n"] = "Volrina's Notes",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4115] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7259700000,
        ["py"] = 0.3111100000,
        ["d"] = true,
        ["pm"] = 1157,
        ["zx"] = 0.7252892229, ["zy"] = 0.3110492054, ["zm"] = 1060,
      },
    },
    ["n"] = "My Dearest Love", -- Letter to Deem-Jei
    ["cn"] = "Hearts and Flowers",
  },
  [4116] = {
    ["c"] = true,
    ["cn"] = "Adventurer's Almanac",
    ["n"] = "Adventurer's Almanac, 1st Edition",
    ["e"] = {
      [1] = { ["px"] = 0.7890383998, ["py"] = 0.4300088094, ["pm"] = 24, ["zm"] = 7, },
      [2] = { ["px"] = 0.2235380006, ["py"] = 0.7445704225, ["pm"] = 243, ["zm"] = 143, },
      [3] = { ["px"] = 0.0629972019, ["py"] = 0.3832172057, ["pm"] = 63, ["zm"] = 1, },
      [4] = { ["px"] = 0.2122236023, ["py"] = 0.3372896070, ["pm"] = 33, ["zm"] = 12, },
    },
  },
  [4117] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8220800000,
        ["py"] = 0.3461500000,
        ["d"] = true,
        ["pm"] = 1160,
        ["zx"] = 0.8247872267, ["zy"] = 0.3454200087, ["zm"] = 1060,
      },
    },
    ["n"] = "Kwama Breeding Research Notes (Flora)",
    ["cn"] = "Research Notes",
  },
  [4118] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7455700000,
        ["py"] = 0.3567700000,
        ["d"] = true,
        ["pm"] = 1159,
        ["zx"] = 0.7456536265, ["zy"] = 0.3564428040, ["zm"] = 1060,
      },
    },
    ["n"] = "Recommended Methods of Moon-Sugar Cultivation",
    ["cn"] = "Research Notes",
  },
  [4119] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7451200000,
        ["py"] = 0.3569900000,
        ["d"] = true,
        ["pm"] = 1159,
        ["zx"] = 0.7456536265, ["zy"] = 0.3564428040, ["zm"] = 1060,
      },
    },
    ["n"] = "Proven Moon-Sugar Fertilization Techniques",
    ["cn"] = "Research Notes",
  },
  [4121] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7226000000,
        ["py"] = 0.2706000000,
        ["d"] = true,
        ["pm"] = 1275,
        ["zx"] = 0.7229400249, ["zy"] = 0.2701004042, ["zm"] = 1060,
      },
    },
    ["n"] = "Ongoing Journal of Galur Rithari",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4419] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2733000000,
        ["px"] = 0.8016700000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.2732800000,
        ["px"] = 0.8135900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Freshly Penned Note",
    ["cn"] = "Mysteries and Clues",
  },
  [4420] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2728000000,
        ["px"] = 0.8021600000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.2732100000,
        ["px"] = 0.8137700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Black Snails Shipping Notice",
    ["cn"] = "Mysteries and Clues",
  },
  [4424] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3679100000,
        ["px"] = 0.7549300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Red Mountain Drinking Song",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4425] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3587800000,
        ["px"] = 0.7860100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Brave Little Scrib Song",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4426] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7453900000,
        ["py"] = 0.3570000000,
        ["d"] = true,
        ["pm"] = 1159,
        ["zx"] = 0.7456536265, ["zy"] = 0.3564428040, ["zm"] = 1060,
      },
    },
    ["n"] = "Bandit's Letter",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4427] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3635600000,
        ["px"] = 0.8325400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "HERE LIES KE'VAL",
    ["cn"] = "Hearts and Flowers",
  },
  [4428] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3693800000,
        ["px"] = 0.8123300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Scribbled Note",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4431] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Anthology of Available Abodes",
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3805200000,
        ["px"] = 0.0610200000,
        ["pm"] = 1,
      },
      [2] = {
        ["pm"] = 1060,
        ["px"] = 0.7753900000,
        ["d"] = true,
        ["py"] = 0.3820500000,
        ["mn"] = 30,
      },
      [3] = {
        ["mn"] = 11,
        ["py"] = 0.4511300000,
        ["px"] = 0.7439800000,
        ["pm"] = 7,
      },
      [4] = { ["px"] = 0.2359440015, ["py"] = 0.7379416219, ["pm"] = 243, ["zm"] = 143, },
      [5] = {
        ["mn"] = 32,
        ["py"] = 0.7549400000,
        ["px"] = 0.0713700000,
        ["pm"] = 1349,
      },
    },
  },
  [4432] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7753124135, ["py"] = 0.3830127974, ["pm"] = 1224, ["zx"] = 0.7753124258, ["zy"] = 0.3830128081, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7753123728, ["py"] = 0.3830127977, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "On Moving Ebonheart",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4433] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Nelfthea's Crumpled Note",
    ["q"] = 6496,
    ["e"] = {
      [1] = {
        ["py"] = 0.1969900000,
        ["px"] = 0.4729200000,
        ["pm"] = 1750,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [4434] = {
    ["c"] = true,
    ["q"] = 6003,
    ["e"] = {
      [1] = { ["px"] = 0.7740816134, ["py"] = 0.3835303974, ["pm"] = 1224, ["zx"] = 0.7740816215, ["zy"] = 0.3835304108, ["zm"] = 1060, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.7740815720, ["py"] = 0.3835303980, ["pm"] = 1287, ["fp"] = true, ["qp"] = true, },
    },
    ["n"] = "Archcanon's Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4435] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8382672206, ["py"] = 0.3157363991, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "Page from Sun-in-Shadow's Journal",
    ["cn"] = "Personal Journals",
  },
  [4437] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3617500000,
        ["px"] = 0.8134300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Songs of Vvardenfell",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4438] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7919000000,
        ["py"] = 0.3216100000,
        ["d"] = true,
        ["pm"] = 1214,
      },
    },
    ["n"] = "Arowende's Diary Page 23",
    ["cn"] = "Diaries and Logs",
  },
  [4439] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7920400000,
        ["py"] = 0.3217700000,
        ["d"] = true,
        ["pm"] = 1214,
      },
    },
    ["n"] = "Arowende's Diary Page 26",
    ["cn"] = "Diaries and Logs",
  },
  [4440] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7758996110, ["py"] = 0.3828356062, ["pm"] = 1222, ["zx"] = 0.7758996301, ["zy"] = 0.3828356073, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7758995719, ["py"] = 0.3828355985, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "Ancestral Tombs of the Thirty Revered Families",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4442] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3096100000,
        ["px"] = 0.8148700000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Bothamul's Orders",
    ["cn"] = "Letters and Missives",
  },
  [4443] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7435900000,
        ["py"] = 0.3428900000,
        ["d"] = true,
        ["pm"] = 1249,
      },
    },
    ["n"] = "Miner's Warning",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4444] = {
    ["c"] = true,
    ["cn"] = "Vvardenfell Volumes",
    ["n"] = "Chodala's Writings",
    ["q"] = 5880,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3095300000,
        ["px"] = 0.7432900000,
        ["pm"] = 1060,
      },
    },
  },
  [4492] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8133800000,
        ["py"] = 0.3696500000,
        ["d"] = true,
        ["pm"] = 1241,
      },
    },
    ["n"] = "Shrine Scavenging Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4493] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7743300000,
        ["py"] = 0.2659000000,
        ["d"] = true,
        ["pm"] = 1276,
      },
      [2] = {
        ["px"] = 0.7639800000,
        ["py"] = 0.2841500000,
        ["d"] = true,
        ["pm"] = 1276,
      },
    },
    ["n"] = "Nevena's Diary",
    ["cn"] = "Diaries and Logs",
  },
  [4494] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "A Loathsome Civilization",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["pm"] = 1349,
        ["py"] = 0.7356100000,
        ["px"] = 0.1005600000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [32] = 1,
    },
  },
  [4496] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7753840246, ["py"] = 0.3896920035, ["pm"] = 1221, ["zx"] = 0.7753840227, ["zy"] = 0.3896920061, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7753839715, ["py"] = 0.3896919976, ["pm"] = 1287, ["fp"] = true, },
      [3] = { ["px"] = 0.8226168226, ["py"] = 0.3820084020, ["pm"] = 1060, },
    },
    ["n"] = "The 36 Lessons: Sermon 37",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4497] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8380056210, ["py"] = 0.3153787993, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "Sun-in-Shadow's To Do List",
    ["cn"] = "Mysteries and Clues",
  },
  [4498] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 14,
        ["py"] = 0.4508100000,
        ["px"] = 0.4716200000,
        ["pm"] = 16,
      },
      [2] = {
        ["mn"] = 14,
        ["py"] = 0.5591600000,
        ["px"] = 0.5677400000,
        ["pm"] = 16,
      },
      [3] = { ["px"] = 0.6114267948, ["py"] = 0.4211436111, ["pm"] = 573, ["zm"] = 16, },
    },
    ["n"] = "The Song of Pelinal, Volume 10",
    ["cn"] = "Lore and Culture",
  },
  [4499] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2937800000,
        ["px"] = 0.7210000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Vvardvark Experiment",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4500] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2731100000,
        ["px"] = 0.8052900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "A Petition for the Mighty Nix-Ox",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4516] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7999300000,
        ["py"] = 0.3132400000,
        ["d"] = true,
        ["pm"] = 1244,
      },
    },
    ["n"] = "Understanding House Indoril",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4517] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7999400000,
        ["py"] = 0.3132500000,
        ["d"] = true,
        ["pm"] = 1244,
      },
    },
    ["n"] = "Understanding House Dres",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4518] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7999600000,
        ["py"] = 0.3132400000,
        ["d"] = true,
        ["pm"] = 1244,
      },
    },
    ["n"] = "Understanding House Redoran",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4519] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7999600000,
        ["py"] = 0.3132500000,
        ["d"] = true,
        ["pm"] = 1244,
      },
    },
    ["n"] = "Understanding House Hlaalu",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4520] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2873800000,
        ["px"] = 0.7162100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Red Mountain's Might",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4521] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7759831718, ["py"] = 0.3823295984, ["pm"] = 1287, ["zm"] = 1060, },
    },
    ["n"] = "A Tale of Baar Dau",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4522] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8382172212, ["py"] = 0.3131179998, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "The Worth of Glass",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4523] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2868500000,
        ["px"] = 0.7145600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Egg Mines and You!",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4525] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1060,
        ["px"] = 0.7733300000,
        ["d"] = true,
        ["py"] = 0.3794000000,
        ["mn"] = 30,
      },
    },
    ["n"] = "Molag Mar\tTax Records",
    ["cn"] = "Houses, Shops, and Trade",
  },
  [4526] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Vos Tax Records",
    ["q"] = 5934,
    ["e"] = {
      [1] = {
        ["pm"] = 1060,
        ["px"] = 0.7733600000,
        ["d"] = true,
        ["py"] = 0.3794100000,
        ["mn"] = 30,
      },
    },
  },
  [4527] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Sadrith Mora Tax Records",
    ["q"] = 5934,
    ["e"] = {
      [1] = {
        ["pm"] = 1060,
        ["px"] = 0.7733800000,
        ["d"] = true,
        ["py"] = 0.3794200000,
        ["mn"] = 30,
      },
    },
  },
  [4528] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7758196110, ["py"] = 0.3827724062, ["pm"] = 1222, ["zx"] = 0.7758196226, ["zy"] = 0.3827724102, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7758195726, ["py"] = 0.3827723987, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "The Waiting Door",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4529] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3699400000,
        ["px"] = 0.7544400000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3375400000,
        ["px"] = 0.7467000000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Hlaalu Letter of Complaint",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4530] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3602800000,
        ["px"] = 0.8151200000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Lure of the Camonna Tong",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4531] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7452300000,
        ["py"] = 0.3570800000,
        ["d"] = true,
        ["pm"] = 1159,
        ["zx"] = 0.7456536265, ["zy"] = 0.3564428040, ["zm"] = 1060,
      },
    },
    ["n"] = "Journal of a Fallen Officer",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4532] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8309972213, ["py"] = 0.3146683992, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "Testimonials on Mushroom Towers",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4533] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8317812208, ["py"] = 0.3090704000, ["pm"] = 1288, ["zm"] = 1060, },
    },
    ["n"] = "Blessed Almalexia's Fables for Afternoon",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4534] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8098000000,
        ["py"] = 0.3562500000,
        ["d"] = true,
        ["pm"] = 1240,
      },
    },
    ["n"] = "Ruddy Man Rhyme",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4535] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8191067990, ["py"] = 0.3246104074, ["pm"] = 1286, ["d"] = true,
        ["zx"] = 0.8203436253, ["zy"] = 0.3256828023, ["zm"] = 1060,
      },
    },
    ["n"] = "Telvanni Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4536] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8189427829, ["py"] = 0.3261875987, ["pm"] = 1294, ["d"] = true,
        ["zx"] = 0.8203436253, ["zy"] = 0.3256828023, ["zm"] = 1060,
      },
    },
    ["n"] = "Cogitation Log 1322331455212478",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4537] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8192571830, ["py"] = 0.3260443987, ["pm"] = 1294, ["d"] = true,
        ["zx"] = 0.8203436253, ["zy"] = 0.3256828023, ["zm"] = 1060,
      },
    },
    ["n"] = "Divayth Fyr's Notes",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4538] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3278600000,
        ["px"] = 0.7465800000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3026400000,
        ["px"] = 0.8376400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Vvardenfell Flora and Fauna",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4539] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8220300000,
        ["py"] = 0.3462700000,
        ["d"] = true,
        ["pm"] = 1160,
        ["zx"] = 0.8247872267, ["zy"] = 0.3454200087, ["zm"] = 1060,
      },
    },
    ["n"] = "Ridena's Letter to Drovos",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4540] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8224000000,
        ["py"] = 0.3463500000,
        ["d"] = true,
        ["pm"] = 1160,
        ["zx"] = 0.8247872267, ["zy"] = 0.3454200087, ["zm"] = 1060,
      },
    },
    ["n"] = "Drovos Research Notes 1",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4541] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8223700000,
        ["py"] = 0.3465800000,
        ["d"] = true,
        ["pm"] = 1160,
        ["zx"] = 0.8247872267, ["zy"] = 0.3454200087, ["zm"] = 1060,
      },
    },
    ["n"] = "Drovos Research Notes 2",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4542] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8221800000,
        ["py"] = 0.3465900000,
        ["d"] = true,
        ["pm"] = 1160,
        ["zx"] = 0.8247872267, ["zy"] = 0.3454200087, ["zm"] = 1060,
      },
    },
    ["n"] = "Drovos Research Notes 3",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4543] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3039900000,
        ["px"] = 0.7506600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Grave of Skar",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4544] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.2728800000,
        ["px"] = 0.8126300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Mistress Dratha's Journal",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4545] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3799000000,
        ["px"] = 0.8127500000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3860300000,
        ["px"] = 0.8224400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Faith in the Shadow of Red Mountain",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4546] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.8046311886, ["py"] = 0.3423491976, ["pm"] = 1318, ["d"] = true, },
    },
    ["n"] = "The Heart of Lorkhan, My Final Prize",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4547] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3373500000,
        ["px"] = 0.7466300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Ashlander Tribes and Customs",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4548] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3222400000,
        ["px"] = 0.7385100000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Nycotic Cult",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4549] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3812200000,
        ["px"] = 0.8169400000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "The Flames of the Fetcherfly",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4550] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3711300000,
        ["px"] = 0.7537900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Pact Pamphlet: Congratulations!",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4551] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3579100000,
        ["px"] = 0.7859900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Oath-Bound: An Outlander's Rise Vol. 1",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4553] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7577400000,
        ["py"] = 0.3196000000,
        ["d"] = true,
        ["pm"] = 1264,
      },
    },
    ["n"] = "Ferhara's Warclaws",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4554] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3099800000,
        ["px"] = 0.8211900000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "On the Clockwork City",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4555] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3365700000,
        ["px"] = 0.7473800000,
        ["pm"] = 1060,
      },
      [2] = {
        ["mn"] = 30,
        ["py"] = 0.3568000000,
        ["px"] = 0.7863800000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Hlaalu Construction Syndic",
    ["cn"] = "Vvardenfell Volumes",
  },
  [4556] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2513400000,
        ["py"] = 1.0192300000,
        ["d"] = true,
        ["pm"] = 1385,
      },
      [2] = { ["px"] = 0.2623263874, ["py"] = 1.0194424081, ["pm"] = 1385, ["zx"] = 0.2623264069, ["zy"] = 1.0194424063, ["zm"] = 1313, ["d"] = true, },
      [3] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Gascone's Memorandum",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4557] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2683251940, ["py"] = 1.0244380101, ["pm"] = 1354, ["zx"] = 0.2681072042, ["zy"] = 1.0262040093, ["zm"] = 1313, ["d"] = true, }, -- 1/1
      [2] = { ["px"] = 0.2681071972, ["py"] = 1.0262039900, ["pm"] = 1348, ["fp"] = true, }, -- 1/1
    },
    ["n"] = "Stuck in the Slag",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4558] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0672800000,
        ["px"] = 0.2928600000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "The Fabricated Fauna of Clockwork",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4559] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0991100000,
        ["px"] = 0.2749300000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "A Brief History of Ald Sotha",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4560] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7767599956, ["py"] = 0.3801999965, ["pm"] = 1231, ["d"] = true, },
    },
    ["n"] = "Archcanon Tarvus Interview",
    ["cn"] = "Letters and Missives",
  },
  [4561] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 3,
        ["py"] = 0.2534000000,
        ["px"] = 0.1674000000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Adeber's Journal",
    ["cn"] = "Rituals and Revelations",
  },
  [4562] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 16,
        ["py"] = 0.6938700000,
        ["px"] = 0.3499300000,
        ["pm"] = 300,
      },
    },
    ["n"] = "Wenridil's Logbook",
    ["cn"] = "Rituals and Revelations",
  },
  [4563] = {
    ["c"] = true,
    ["cn"] = "Rituals and Revelations",
    ["n"] = "Neelo's Notes",
    ["q"] = 6023,
    ["e"] = {
      [1] = { ["px"] = 0.7555527935, ["py"] = 0.5446243953, ["pm"] = 26, },
    },
  },
  [4564] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3697900000,
        ["px"] = 0.7626600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Come to Vvardenfell!",
    ["cn"] = "Letters and Missives",
  },
  [4567] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2854100000,
        ["py"] = 1.0756800000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 7",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4568] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2764000000,
        ["py"] = 1.0760700000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "The Truth in Sequence: Volume 8",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4570] = {
    ["c"] = true,
    ["cn"] = "Letters and Missives",
    ["n"] = "Order of the Eye Dispatch",
    ["e"] = {
      [1] = { ["px"] = 0.7726299959, ["py"] = 0.3791828032, ["pm"] = 1237, ["d"] = true, },
      [2] = { ["px"] = 0.2278004005, ["py"] = 0.7419196212, ["pm"] = 243, ["zm"] = 143, },
      [3] = { ["px"] = 0.2456435954, ["py"] = 0.6728535980, ["pm"] = 545, ["zm"] = 143, },
      [4] = { ["px"] = 0.2250328021, ["py"] = 0.3374844073, ["pm"] = 33, ["zm"] = 12, },
      [5] = { ["py"] = 0.3192500000, ["px"] = 0.6026100000, ["pm"] = 578, ["zm"] = 61, },
      [6] = { ["px"] = 0.4567552132, ["py"] = 0.7542003864, ["pm"] = 512, ["zm"] = 9, },
      [7] = { ["px"] = 0.1801423988, ["py"] = 0.6324280126, ["pm"] = 540, ["zm"] = 143, },
    },
  },
  [4571] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3551600000,
        ["px"] = 0.7847500000,
        ["pm"] = 1060,
      },
      [2] = { ["px"] = 0.7669259725, ["py"] = 0.3731611986, ["pm"] = 1287, ["zm"] = 1060, },
      [3] = {
        ["mn"] = 30,
        ["py"] = 0.2719000000,
        ["px"] = 0.8056800000,
        ["pm"] = 1060,
      },
      [4] = {
        ["mn"] = 30,
        ["py"] = 0.3661500000,
        ["px"] = 0.7570200000,
        ["pm"] = 1060,
      },
      [5] = {
        ["mn"] = 30,
        ["py"] = 0.3416600000,
        ["px"] = 0.7488900000,
        ["pm"] = 1060,
      },
      [6] = {
        ["mn"] = 30,
        ["py"] = 0.2902500000,
        ["px"] = 0.7139300000,
        ["pm"] = 1060,
      },
      [7] = {
        ["mn"] = 30,
        ["py"] = 0.3597600000,
        ["px"] = 0.8096600000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Silt-Strider Station",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [4572] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7758892110, ["py"] = 0.3828020062, ["pm"] = 1222, ["zx"] = 0.7758892242, ["zy"] = 0.3828020080, ["zm"] = 1060, ["d"] = true, },
      [2] = { ["px"] = 0.7758891713, ["py"] = 0.3828019978, ["pm"] = 1287, ["fp"] = true, },
    },
    ["n"] = "Ancestral Tombs of Vvardenfell",
    ["cn"] = "Lore and Culture",
  },
  [4573] = {
    ["c"] = true,
    ["q"] = 6036,
    ["e"] = {
      [1] = { ["px"] = 0.2419843955, ["py"] = 1.0350531891, ["pm"] = 1348, ["zm"] = 1313, ["qp"] = true, },
    },
    ["n"] = "Terari's Notes",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4575] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Morrowind Needs You!",
    ["e"] = {
      [1] = {
        ["mn"] = 22,
        ["py"] = 0.2670300000,
        ["px"] = 0.6808100000,
        ["pm"] = 74,
      },
      [2] = {
        ["mn"] = 17,
        ["py"] = 0.6155500000,
        ["px"] = 0.4528200000,
        ["pm"] = 256,
      },
      [3] = {
        ["mn"] = 19,
        ["py"] = 0.5449300000,
        ["px"] = 0.1622900000,
        ["pm"] = 530,
        ["zm"] = 201,
      },
      [4] = {
        ["mn"] = 8,
        ["py"] = 0.6232600000,
        ["px"] = 0.3687900000,
        ["pm"] = 22,
      },
      [5] = {
        ["mn"] = 13,
        ["py"] = 0.2666600000,
        ["px"] = 0.6405800000,
        ["pm"] = 61,
      },
      [6] = {
        ["mn"] = 9,
        ["py"] = 0.5395200000,
        ["px"] = 0.7445900000,
        ["pm"] = 26,
      },
      [7] = {
        ["mn"] = 10,
        ["py"] = 0.5124100000,
        ["px"] = 0.7577500000,
        ["pm"] = 13,
      },
      [8] = {
        ["mn"] = 6,
        ["py"] = 0.3082400000,
        ["px"] = 0.2824600000,
        ["pm"] = 20,
      },
      [9] = {
        ["mn"] = 2,
        ["py"] = 0.3759800000,
        ["px"] = 0.0524200000,
        ["pm"] = 1,
      },
      [10] = {
        ["mn"] = 12,
        ["py"] = 0.3789300000,
        ["px"] = 0.6358600000,
        ["pm"] = 125,
      },
      [11] = { ["px"] = 0.2369452007, ["py"] = 0.7460480222, ["pm"] = 243, ["zm"] = 143, },
      [12] = {
        ["mn"] = 7,
        ["py"] = 0.7296100000,
        ["px"] = 0.4380900000,
        ["pm"] = 9,
      },
      [13] = {
        ["mn"] = 5,
        ["py"] = 0.3838400000,
        ["px"] = 0.1567200000,
        ["pm"] = 30,
      },
      [14] = {
        ["mn"] = 28,
        ["py"] = 0.5061400000,
        ["px"] = 0.2473000000,
        ["pm"] = 994,
      },
      [15] = { ["px"] = 0.2308444026, ["py"] = 0.3480920070, ["pm"] = 33, ["zm"] = 12, },
      [16] = {
        ["mn"] = 27,
        ["py"] = 0.2555000000,
        ["px"] = 0.2827300000,
        ["pm"] = 667,
      },
      [17] = {
        ["mn"] = 3,
        ["py"] = 0.2514100000,
        ["px"] = 0.1720700000,
        ["pm"] = 10,
      },
      [18] = {
        ["mn"] = 11,
        ["py"] = 0.4237400000,
        ["px"] = 0.7913200000,
        ["pm"] = 7,
      },
      [19] = {
        ["mn"] = 16,
        ["py"] = 0.7136600000,
        ["px"] = 0.2843000000,
        ["pm"] = 300,
      },
      [20] = { ["px"] = 0.3239044022, ["py"] = 0.5751860007, ["pm"] = 1074, ["zm"] = 1006, },
    },
  },
  [4576] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["py"] = 0.3726300000,
        ["px"] = 0.7557300000,
        ["pm"] = 1060,
      },
    },
    ["n"] = "Invitation to Morrowind",
    ["cn"] = "Letters and Missives",
  },
  [4577] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0429700000,
        ["px"] = 0.2720000000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "The Blackfeather Court",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4578] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5079104063, ["py"] = 0.8116407977, ["pm"] = 258, },
    },
    ["n"] = "Soggy Note",
    ["cn"] = "Letters and Missives",
  },
  [4579] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3520600000,
        ["py"] = 1.0705400000,
        ["d"] = true,
        ["pm"] = 1342,
      },
    },
    ["n"] = "Naril's Notes: Origins",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4580] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2626003866, ["py"] = 1.0196168083, ["pm"] = 1385, ["zx"] = 0.2626003973, ["zy"] = 1.0196168066, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Orders of Assassination",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4581] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2100800000,
        ["py"] = 1.0767400000,
        ["d"] = true,
        ["pm"] = 1324,
        ["zx"] = 0.2102732012, ["zy"] = 1.0765236056, ["zm"] = 1313,
      },
    },
    ["n"] = "Acolyte's Chipped Scroll Plate",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4582] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2101500000,
        ["py"] = 1.0763000000,
        ["d"] = true,
        ["pm"] = 1324,
        ["zx"] = 0.2102732012, ["zy"] = 1.0765236056, ["zm"] = 1313,
      },
    },
    ["n"] = "Acolyte's Lost Scroll Plate",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4583] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2105600000,
        ["py"] = 1.0761800000,
        ["d"] = true,
        ["pm"] = 1324,
        ["zx"] = 0.2102732012, ["zy"] = 1.0765236056, ["zm"] = 1313,
      },
    },
    ["n"] = "Acolyte's Scorched Scroll Plate",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4584] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2538355871, ["py"] = 1.0230412083, ["pm"] = 1385, ["zx"] = 0.2538356053, ["zy"] = 1.0230412096, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Steady Hands",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4585] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2097100000,
        ["py"] = 1.0922000000,
        ["d"] = true,
        ["pm"] = 1333,
      },
      [2] = {
        ["px"] = 0.2625900000,
        ["py"] = 1.0198700000,
        ["d"] = true,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Imperfect Operations Manual",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4586] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2622300000,
        ["py"] = 1.0278000000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0304600000,
        ["px"] = 0.2479800000,
        ["pm"] = 1348,
      },
      [3] = {
        ["d"] = true,
        ["py"] = 1.0277900000,
        ["zt"] = 1004,
        ["px"] = 0.2622100000,
      },
    },
    ["n"] = "Factotum Model Registry",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4587] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2622300000,
        ["py"] = 1.0280300000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0315300000,
        ["px"] = 0.2476500000,
        ["pm"] = 1348,
      },
      [3] = {
        ["d"] = true,
        ["py"] = 1.0280300000,
        ["zt"] = 1004,
        ["px"] = 0.2622200000,
      },
    },
    ["n"] = "Residential Logistics Log",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4588] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2621500000,
        ["py"] = 1.0277900000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0304400000,
        ["px"] = 0.2482400000,
        ["pm"] = 1348,
      },
      [3] = {
        ["d"] = true,
        ["py"] = 1.0277900000,
        ["zt"] = 1004,
        ["px"] = 0.2621600000,
      },
    },
    ["n"] = "Security Survey",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4589] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2622300000,
        ["py"] = 1.0279100000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0300700000,
        ["px"] = 0.2481100000,
        ["pm"] = 1348,
      },
      [3] = {
        ["d"] = true,
        ["py"] = 1.0279100000,
        ["zt"] = 1004,
        ["px"] = 0.2622300000,
      },
    },
    ["n"] = "Mechanical Fundament Maintenance Logs",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4592] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Who Are the Wardens?",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 30,
        ["pm"] = 1060,
        ["py"] = 0.3502500000,
        ["px"] = 0.7409700000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [30] = 1,
    },
  },
  [4593] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0730500000,
        ["px"] = 0.2000000000,
        ["pm"] = 1313,
      },
      [2] = {
        ["mn"] = 7,
        ["py"] = 0.6911900000,
        ["px"] = 0.4386600000,
        ["pm"] = 9,
      },
    },
    ["n"] = "Journal of a Stranded Mage",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4594] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0713000000,
        ["px"] = 0.1905700000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "A Study of Fabricants",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4595] = {
    ["c"] = true,
    ["cn"] = "Clockwork Mnemonix",
    ["n"] = "Ironstalk Mushroom Preservation and Sterilization",
    ["q"] = 6059,
    ["e"] = {
      [1] = { ["px"] = 0.2624147978, ["py"] = 1.0366483881, ["pm"] = 1348, ["zm"] = 1313, ["ld"] = 14, },
    },
  },
  [4596] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3227667940, ["py"] = 1.0898523815, ["pm"] = 1332, ["zx"] = 0.3231332021, ["zy"] = 1.0882668088, ["zm"] = 1313, ["d"] = true, },
    },
    ["n"] = "The Water Cycle of Clockwork City",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4597] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0315200000,
        ["px"] = 0.2481300000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "The Ballad of Brisbor Battle-Axe [verse six]",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4598] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0363600000,
        ["px"] = 0.2530100000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Notes on Crow Sightings",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4599] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0306200000,
        ["px"] = 0.2480900000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Ode to a Brass Lily",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4600] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0317600000,
        ["px"] = 0.2483500000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Love Poem LT0782",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4601] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2580700000,
        ["py"] = 1.0383100000,
        ["d"] = true,
        ["pm"] = 1362,
      },
    },
    ["n"] = "Inveigling the Clockwork Apostles",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4602] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3496900000,
        ["py"] = 1.0725100000,
        ["d"] = true,
        ["pm"] = 1342,
      },
    },
    ["n"] = "Naril's Notes: Early Experiments",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4603] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3481400000,
        ["py"] = 1.0758200000,
        ["d"] = true,
        ["pm"] = 1342,
      },
    },
    ["n"] = "Naril's Note: Simulated Sunlight",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4604] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3457600000,
        ["py"] = 1.0750800000,
        ["d"] = true,
        ["pm"] = 1342,
      },
    },
    ["n"] = "Naril's Note: Success Out of Tragedy",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4606] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0304400000,
        ["px"] = 0.2578000000,
        ["pm"] = 1348,
      },
      [2] = {
        ["px"] = 0.2104100000,
        ["py"] = 1.0759900000,
        ["d"] = true,
        ["pm"] = 1324,
        ["zx"] = 0.2102732012, ["zy"] = 1.0765236056, ["zm"] = 1313,
      },
    },
    ["n"] = "Novice Oscard's Notes",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4607] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2747600000,
        ["py"] = 1.0687000000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "The Memories of Sotha Sil",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4610] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0990400000,
        ["px"] = 0.2572700000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "The Unseen Potential of Clockwork",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4611] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2104100000,
        ["py"] = 1.0759700000,
        ["d"] = true,
        ["pm"] = 1324,
        ["zx"] = 0.2102732012, ["zy"] = 1.0765236056, ["zm"] = 1313,
      },
    },
    ["n"] = "Shadows and Whispers",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4612] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0244400000,
        ["px"] = 0.2570100000,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0428700000,
        ["px"] = 0.2386300000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Assistance Needed for Factotum Experiment!",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4613] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0877600000,
        ["px"] = 0.2261500000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Maliah's Journal",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4614] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0362400000,
        ["px"] = 0.2522800000,
        ["pm"] = 1348,
      },
      [2] = {
        ["px"] = 0.0781300000,
        ["py"] = 0.7622500000,
        ["d"] = true,
        ["pm"] = 1446,
      },
    },
    ["n"] = "The Mystery of Artaeum",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4615] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2684179940, ["py"] = 1.0243184102, ["pm"] = 1354, ["zx"] = 0.2681072042, ["zy"] = 1.0262040093, ["zm"] = 1313, ["d"] = true, }, -- 1/1
      [2] = { ["px"] = 0.2681071972, ["py"] = 1.0262039900, ["pm"] = 1348, ["fp"] = true, }, -- 1/1
    },
    ["n"] = "Thoughts of the Honored Assistant",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4616] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Nicolard Lia's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.4347363906, ["py"] = 0.3831496010, ["pm"] = 1307, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4617] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Nicolard's Notes on Ruin Origins",
    ["e"] = {
      [1] = { ["px"] = 0.4347212137, ["py"] = 0.3828956038, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4618] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Nicolard's Notes on the Forge",
    ["e"] = {
      [1] = { ["px"] = 0.4354968136, ["py"] = 0.3825312038, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4619] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4365300000,
        ["py"] = 0.3839400000,
        ["d"] = true,
        ["pm"] = 1309,
      },
    },
    ["n"] = "Nicolard's Note to Self",
    ["cn"] = "Library of Incunabula",
  },
  [4620] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Captive's Crumpled Note",
    ["e"] = {
      [1] = { ["px"] = 0.4353336137, ["py"] = 0.3826908038, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4621] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4352500000,
        ["py"] = 0.3826200000,
        ["d"] = true,
        ["pm"] = 1309,
      },
    },
    ["n"] = "Captive's Discreet Warning",
    ["cn"] = "Library of Incunabula",
  },
  [4622] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4363600000,
        ["py"] = 0.3837600000,
        ["d"] = true,
        ["pm"] = 1309,
      },
    },
    ["n"] = "Plan to Escape",
    ["cn"] = "Library of Incunabula",
  },
  [4623] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Defiant Graffiti",
    ["e"] = {
      [1] = { ["px"] = 0.4351372137, ["py"] = 0.3825028038, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4624] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Scrawled Tally",
    ["e"] = {
      [1] = { ["px"] = 0.4352828137, ["py"] = 0.3827824039, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4625] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Improvised Memorial",
    ["e"] = {
      [1] = { ["px"] = 0.4357232136, ["py"] = 0.3828548038, ["pm"] = 1308, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4626] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Norgorgol's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.4347367905, ["py"] = 0.3843004010, ["pm"] = 1307, ["d"] = true, ["zx"] = 0.4350760168, ["zy"] = 0.3823860003, ["zm"] = 1126, },
    },
  },
  [4627] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4637500000, ["py"] = 0.3753000000, ["pm"] = 1321, ["d"] = true, },
      [2] = { ["px"] = 0.4602472150, ["py"] = 0.3761575941, ["pm"] = 1126, ["fp"] = true, },
    },
    ["n"] = "Urgent Missive",
    ["cn"] = "Library of Incunabula",
  },
  [4628] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4629700000, ["py"] = 0.3756500000, ["pm"] = 1321, ["d"] = true, },
      [2] = { ["px"] = 0.4602472150, ["py"] = 0.3761575941, ["pm"] = 1126, ["fp"] = true, },
    },
    ["n"] = "Unfinished Letter to Marika",
    ["cn"] = "Library of Incunabula",
  },
  [4629] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4630400000, ["py"] = 0.3754900000, ["pm"] = 1321, ["d"] = true, },
      [2] = { ["px"] = 0.4602472150, ["py"] = 0.3761575941, ["pm"] = 1126, ["fp"] = true, },
    },
    ["n"] = "In Reply to Concerning Rumors",
    ["cn"] = "Library of Incunabula",
  },
  [4630] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4621400000, ["py"] = 0.3745300000, ["pm"] = 1322, ["d"] = true, },
      [2] = { ["px"] = 0.4602472150, ["py"] = 0.3761575941, ["pm"] = 1126, ["fp"] = true, },
    },
    ["n"] = "Epitaph of Bjarfrud Skjoralmor",
    ["cn"] = "Library of Incunabula",
  },
  [4680] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0959300000,
        ["px"] = 0.2502700000,
        ["pm"] = 1313,
      },
      [2] = {
        ["mn"] = 3,
        ["py"] = 0.2317000000,
        ["px"] = 0.2055000000,
        ["pm"] = 10,
      },
    },
    ["n"] = "Dulza's Log",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4681] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3364300000,
        ["py"] = 1.0579400000,
        ["d"] = true,
        ["pm"] = 1342,
      },
    },
    ["n"] = "Chirrhari's Notes",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4683] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2710700000,
        ["py"] = 1.0751500000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "The Will of Our Mistress",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4684] = {
    ["c"] = true,
    ["cn"] = "Clockwork Mnemonix",
    ["n"] = "The Truth in Sequence: Volume 9",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1342,
        ["py"] = 1.0649700000,
        ["px"] = 0.3341900000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [31] = 1,
    },
  },
  [4685] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2738200000,
        ["py"] = 1.0711900000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "The Astronomer's Power",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4686] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2768800000,
        ["py"] = 1.0754500000,
        ["d"] = true,
        ["pm"] = 1376,
      },
    },
    ["n"] = "Stealing the Stars",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4689] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0451200000,
        ["px"] = 0.2956600000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Realms of the Clockwork City: The Radius",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4691] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2386735962, ["py"] = 1.0428007889, ["pm"] = 1348, ["zm"] = 1313, ["ld"] = 12, },
    },
    ["n"] = "The Mystery of Factotums",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4692] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "List of Sequestered Guests",
    ["q"] = 6096,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["py"] = 0.7199100000,
        ["zt"] = 1047,
        ["px"] = 0.1611300000,
      },
    },
  },
  [4693] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2620199945, ["py"] = 1.0367367889, ["pm"] = 1348, ["zm"] = 1313, },
    },
    ["n"] = "Excerpts From Fabricated Flora: A Study",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4694] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2598899872, ["py"] = 1.0190204086, ["pm"] = 1386, ["zx"] = 0.2598900060, ["zy"] = 1.0190204088, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Castigation Ritual",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4695] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0501800000,
        ["px"] = 0.2577400000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "The Law of Gears",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4696] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Haladan's Research Journal",
    ["q"] = 6111,
    ["e"] = {
      [1] = {
        ["px"] = 0.0457300000,
        ["py"] = 0.7247700000,
        ["d"] = true,
        ["pm"] = 1390,
      },
    },
  },
  [4697] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Haladan",
    ["q"] = 6111,
    ["e"] = {
      [1] = {
        ["px"] = 0.0458400000,
        ["py"] = 0.7247700000,
        ["d"] = true,
        ["pm"] = 1390,
      },
    },
  },
  [4698] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Norasea",
    ["q"] = 6111,
    ["e"] = {
      [1] = {
        ["px"] = 0.0458400000,
        ["py"] = 0.7247700000,
        ["d"] = true,
        ["pm"] = 1390,
      },
    },
  },
  [4699] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0308300000,
        ["px"] = 0.2567100000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Engine of Expression",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4700] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0460100000,
        ["px"] = 0.2953800000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Barilzar's Journal",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4701] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0365900000,
        ["px"] = 0.2259600000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "The Imperfect Logistics Log",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4702] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0504000000,
        ["px"] = 0.3100500000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Eyes of Nothing",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4703] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3245143921, ["py"] = 1.0562495968, ["pm"] = 1326, ["d"] = true,
        ["zx"] = 0.3238451960, ["zy"] = 1.0536308051, ["zm"] = 1313,
      },
    },
    ["n"] = "A Sky of Dusk",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4704] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3242300000,
        ["py"] = 1.0912900000,
        ["d"] = true,
        ["pm"] = 1371,
      },
    },
    ["n"] = "Maintenance Log 4091",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4705] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3237691940, ["py"] = 1.0886075815, ["pm"] = 1332, ["zx"] = 0.3231332021, ["zy"] = 1.0882668088, ["zm"] = 1313, ["d"] = true, },
    },
    ["n"] = "Maintenance Log 5352",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4706] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3252651940, ["py"] = 1.0897123814, ["pm"] = 1332, ["zx"] = 0.3231332021, ["zy"] = 1.0882668088, ["zm"] = 1313, ["d"] = true, },
    },
    ["n"] = "Maintenance Log 5453",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4707] = {
    ["c"] = true,
    ["cn"] = "Clockwork Mnemonix",
    ["n"] = "The Truth in Sequence: Volume 10",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1376,
        ["py"] = 1.0762000000,
        ["px"] = 0.2793800000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [31] = 1,
    },
  },
  [4708] = {
    ["c"] = true,
    ["cn"] = "Clockwork Mnemonix",
    ["n"] = "The Truth in Sequence: Volume 11",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1429] = 1,
      [1313] = 1,
    },
  },
  [4709] = {
    ["c"] = true,
    ["cn"] = "Clockwork Mnemonix",
    ["n"] = "The Truth in Sequence: Volume 12",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0316900000,
        ["r"] = true,
        ["px"] = 0.2476800000,
        ["pm"] = 1348,
      },
    },
    ["m"] = {
      [31] = 1,
    },
  },
  [4710] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2320783962, ["py"] = 1.0315387909, ["pm"] = 1348, ["zm"] = 1313, },
    },
    ["n"] = "Factotum Classification - Log 233",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4711] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2620667871, ["py"] = 1.0166236085, ["pm"] = 1385, ["zx"] = 0.2620667976, ["zy"] = 1.0166236095, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Worshiping the Illogical",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4712] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2565700000,
        ["py"] = 1.0391200000,
        ["d"] = true,
        ["pm"] = 1362,
      },
    },
    ["n"] = "Outsider Observation Report - Log 1",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4713] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0437900000,
        ["px"] = 0.2245200000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Outsider Observation Report - Log 2",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4714] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2458092003, ["py"] = 1.0607604051, ["pm"] = 1313, },
    },
    ["n"] = "Outsider Observation Report - Log 3",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4715] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2585100000,
        ["py"] = 1.0357800000,
        ["d"] = true,
        ["pm"] = 1362,
      },
    },
    ["n"] = "Clockwork Apostle Poetry Collective",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4716] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7110000000,
        ["px"] = 0.0405500000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Galidor's Scribbled Note",
    ["cn"] = "Summerset Scrolls",
  },
  [4717] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7110800000,
        ["px"] = 0.0407900000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Galidor's Grocery List",
    ["cn"] = "Summerset Scrolls",
  },
  [4718] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7113200000,
        ["px"] = 0.0407000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Galidor's Love Poem",
    ["cn"] = "Summerset Scrolls",
  },
  [4720] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Galidor's Ledger",
    ["q"] = 6111,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7118100000,
        ["px"] = 0.0404400000,
        ["pm"] = 1349,
      },
    },
  },
  [4721] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2299000000,
        ["py"] = 1.0284300000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["px"] = 0.2299000000,
        ["py"] = 1.0284300000,
        ["d"] = true,
        ["pm"] = 1391,
      },
    },
    ["n"] = "Evaluation of Saint Felms",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4722] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2299000000,
        ["py"] = 1.0281700000,
        ["d"] = true,
        ["pm"] = 1348,
      },
      [2] = {
        ["px"] = 0.2299000000,
        ["py"] = 1.0281600000,
        ["d"] = true,
        ["pm"] = 1391,
      },
    },
    ["n"] = "Evaluation of Saint Llothis",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4723] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2297200000,
        ["py"] = 1.0282600000,
        ["d"] = true,
        ["pm"] = 1391,
      },
    },
    ["n"] = "Evaluation of Saint Olms",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4724] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2289100000,
        ["py"] = 1.0283000000,
        ["d"] = true,
        ["pm"] = 1391,
      },
    },
    ["n"] = "Concerning the Saints' Safety and Security",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4725] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2288500000,
        ["py"] = 1.0282500000,
        ["d"] = true,
        ["pm"] = 1391,
      },
    },
    ["n"] = "Catalogue of Afflictions in the City",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4726] = {
    ["c"] = true,
    ["q"] = 6097,
    ["e"] = {
      [1] = {
        ["px"] = 0.1235300000,
        ["py"] = 0.3517700000,
        ["d"] = true,
        ["pm"] = 228,
        ["zx"] = 0.1236044063, ["zy"] = 0.3526504006, ["zm"] = 1,
      },
    },
    ["n"] = "Note to Vanus",
    ["cn"] = "Rituals and Revelations",
  },
  [4788] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Rinyde's Journal",
    ["q"] = 6114,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7326100000,
        ["px"] = 0.0969500000,
        ["pm"] = 1349,
      },
    },
  },
  [4792] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Keeper's Oath",
    ["q"] = 6118,
    ["e"] = {
      [1] = {
        ["px"] = 0.1613000000,
        ["py"] = 0.6914600000,
        ["d"] = true,
        ["pm"] = 1516,
      },
    },
  },
  [4793] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2541611870, ["py"] = 1.0168004085, ["pm"] = 1385, ["zx"] = 0.2541612032, ["zy"] = 1.0168004085, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Proctor Luciana's Journal, Vol 1",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4794] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2559463870, ["py"] = 1.0165076086, ["pm"] = 1385, ["zx"] = 0.2559464023, ["zy"] = 1.0165076085, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Proctor Luciana's Journal, Vol 2",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4795] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2624747871, ["py"] = 1.0205676081, ["pm"] = 1386, ["zx"] = 0.2624748010, ["zy"] = 1.0205676060, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Proctor Luciana's Journal, Vol 4",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4796] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2517995871, ["py"] = 1.0194160086, ["pm"] = 1386, ["zx"] = 0.2517996005, ["zy"] = 1.0194160073, ["zm"] = 1313, ["d"] = true, },
      [2] = { ["px"] = 0.2564751955, ["py"] = 1.0235835893, ["pm"] = 1348, ["fp"] = true, },
    },
    ["n"] = "Proctor Luciana's Journal, Vol 3",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4797] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Insatiable",
    ["q"] = 6117,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7475000000,
        ["px"] = 0.0822100000,
        ["pm"] = 1349,
      },
    },
  },
  [4798] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0965700000,
        ["px"] = 0.2760900000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Vivec, The Warrior-Poet",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4799] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0971600000,
        ["px"] = 0.2762400000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "The Defense of Mournhold",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4800] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0967100000,
        ["px"] = 0.2744100000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Nerevar the Captain",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4801] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 31,
        ["py"] = 1.0975000000,
        ["px"] = 0.2746800000,
        ["pm"] = 1313,
      },
    },
    ["n"] = "Sotha Nall",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4806] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Dear Escort",
    ["q"] = 6119,
    ["e"] = {
      [1] = {
        ["px"] = 0.0994600000,
        ["py"] = 0.6947400000,
        ["d"] = true,
        ["pm"] = 1404,
      },
    },
  },
  [4807] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.2444835965, ["py"] = 1.0229519896, ["pm"] = 1348, ["pm"] = 1313, ["ld"] = 13, },
    },
    ["n"] = "The Factotum's Secret Voice",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4808] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Grand Maestro Forte's Research",
    ["q"] = 6113,
    ["e"] = {
      [1] = {
        ["mn"] = 33,
        ["pm"] = 1429,
        ["px"] = 0.8660100000,
        ["d"] = true,
        ["py"] = -0.0731200000,
      },
    },
  },
  [4810] = {
    ["c"] = true,
    ["cn"] = "Handbills, Posters, and Decrees",
    ["n"] = "Seeking Tenant!",
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3921600000,
        ["px"] = 0.0641900000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 12,
        ["py"] = 0.3784700000,
        ["px"] = 0.6420000000,
        ["pm"] = 125,
      },
      [3] = {
        ["mn"] = 9,
        ["py"] = 0.5414900000,
        ["px"] = 0.7476800000,
        ["pm"] = 26,
      },
      [4] = { ["px"] = 0.7662807724, ["py"] = 0.3725347983, ["pm"] = 1287, ["zm"] = 1060, },
      [5] = {
        ["l"] = true,
        ["mn"] = 7,
        ["pm"] = 9,
        ["px"] = 0.4316900000,
        ["d"] = true,
        ["py"] = 0.7266000000,
      },
      [6] = {
        ["mn"] = 5,
        ["py"] = 0.3970700000,
        ["px"] = 0.1450300000,
        ["pm"] = 30,
      },
      [7] = {
        ["mn"] = 11,
        ["py"] = 0.4293200000,
        ["px"] = 0.7845400000,
        ["pm"] = 7,
      },
      [8] = { ["px"] = 0.2358704005, ["py"] = 0.7378824214, ["pm"] = 243, ["zm"] = 143, },
      [9] = {
        ["mn"] = 2,
        ["py"] = 0.3808800000,
        ["px"] = 0.0611800000,
        ["pm"] = 1,
      },
      [10] = {
        ["mn"] = 16,
        ["py"] = 0.7000100000,
        ["px"] = 0.3548600000,
        ["pm"] = 300,
      },
      [11] = {
        ["mn"] = 3,
        ["py"] = 0.2491600000,
        ["px"] = 0.1733300000,
        ["pm"] = 10,
      },
      [12] = {
        ["mn"] = 6,
        ["py"] = 0.3226700000,
        ["px"] = 0.2853800000,
        ["pm"] = 20,
      },
      [13] = {
        ["mn"] = 11,
        ["py"] = 0.4511600000,
        ["px"] = 0.7438400000,
        ["pm"] = 7,
      },
      [14] = {
        ["pm"] = 1060,
        ["px"] = 0.7743500000,
        ["d"] = true,
        ["py"] = 0.3799400000,
        ["mn"] = 30,
      },
      [15] = {
        ["mn"] = 17,
        ["py"] = 0.6178000000,
        ["px"] = 0.4506600000,
        ["pm"] = 256,
      },
      [16] = {
        ["mn"] = 10,
        ["py"] = 0.5140000000,
        ["px"] = 0.7643400000,
        ["pm"] = 13,
      },
      [17] = {
        ["mn"] = 4,
        ["py"] = 0.3327900000,
        ["px"] = 0.2246600000,
        ["pm"] = 12,
      },
      [18] = {
        ["mn"] = 13,
        ["py"] = 0.2621500000,
        ["px"] = 0.6292300000,
        ["pm"] = 61,
      },
      [19] = {
        ["mn"] = 8,
        ["py"] = 0.6246500000,
        ["px"] = 0.3067000000,
        ["pm"] = 22,
      },
      [20] = {
        ["mn"] = 36,
        ["py"] = 0.6549600000,
        ["px"] = 0.5120300000,
        ["pm"] = 1555,
      },
      [21] = {
        ["mn"] = 36,
        ["py"] = 0.6013000000,
        ["px"] = 0.5296600000,
        ["pm"] = 1555,
      },
      [22] = { ["px"] = 0.9377860150, ["py"] = 0.3865956061, ["pm"] = 2343, ["zm"] = 2274, },
      [23] = { ["px"] = 0.8314488096, ["py"] = 0.4165651877, ["pm"] = 2386, ["zm"] = 2274, },
    },
  },
  [4813] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7066200000,
        ["px"] = 0.0405800000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Sages of the Crystal Tower",
    ["cn"] = "Summerset Scrolls",
  },
  [4814] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7657200000,
        ["px"] = 0.0765700000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Divine Prosecution",
    ["cn"] = "Summerset Scrolls",
  },
  [4815] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8432700000,
        ["d"] = true,
        ["py"] = -0.0272600000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Lantern of Lies",
    ["cn"] = "Moawita Memories",
  },
  [4816] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8433800000,
        ["d"] = true,
        ["py"] = -0.0272600000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Heart of the Indrik",
    ["cn"] = "Moawita Memories",
  },
  [4817] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8433400000,
        ["d"] = true,
        ["py"] = -0.0272900000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Silver-Tongued Quill",
    ["cn"] = "Moawita Memories",
  },
  [4818] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8430100000,
        ["d"] = true,
        ["py"] = -0.0272600000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Unraveling Staff",
    ["cn"] = "Moawita Memories",
  },
  [4819] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8432500000,
        ["d"] = true,
        ["py"] = -0.0274000000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Skull of Minor Cursing",
    ["cn"] = "Moawita Memories",
  },
  [4820] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8430100000,
        ["d"] = true,
        ["py"] = -0.0271600000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Shadowcutter Blade",
    ["cn"] = "Moawita Memories",
  },
  [4821] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8427600000,
        ["d"] = true,
        ["py"] = -0.0271100000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Soulkeeper's Urn",
    ["cn"] = "Moawita Memories",
  },
  [4822] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8428200000,
        ["d"] = true,
        ["py"] = -0.0273200000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Chest of Condemnation",
    ["cn"] = "Moawita Memories",
  },
  [4823] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8431200000,
        ["d"] = true,
        ["py"] = -0.0274300000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Never-Ending Scroll",
    ["cn"] = "Moawita Memories",
  },
  [4824] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8430300000,
        ["d"] = true,
        ["py"] = -0.0274100000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Inescapable Helm",
    ["cn"] = "Moawita Memories",
  },
  [4825] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8430500000,
        ["d"] = true,
        ["py"] = -0.0274200000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Sticky-Fingered Lute",
    ["cn"] = "Moawita Memories",
  },
  [4826] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8429000000,
        ["d"] = true,
        ["py"] = -0.0273800000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Fan of False-Face",
    ["cn"] = "Moawita Memories",
  },
  [4827] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8431400000,
        ["d"] = true,
        ["py"] = -0.0272300000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Pillow of Sweet Dreams",
    ["cn"] = "Moawita Memories",
  },
  [4828] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8427700000,
        ["d"] = true,
        ["py"] = -0.0272800000,
        ["mn"] = 33,
      },
      [2] = {
        ["mn"] = 33,
        ["py"] = -0.0272900000,
        ["px"] = 0.8427800000,
        ["pm"] = 1429,
      },
    },
    ["n"] = "Mirror of Fatal Premonition",
    ["cn"] = "Moawita Memories",
  },
  [4829] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8428400000,
        ["d"] = true,
        ["py"] = -0.0272700000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Monochrome Paintbrush",
    ["cn"] = "Moawita Memories",
  },
  [4830] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8427500000,
        ["d"] = true,
        ["py"] = -0.0271800000,
        ["mn"] = 33,
      },
      [2] = {
        ["mn"] = 33,
        ["py"] = -0.0272000000,
        ["px"] = 0.8427100000,
        ["pm"] = 1429,
      },
    },
    ["n"] = "Hourglass of Perceived Time",
    ["cn"] = "Moawita Memories",
  },
  [4831] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8427400000,
        ["d"] = true,
        ["py"] = -0.0270200000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Jaunt of the Jilted",
    ["cn"] = "Moawita Memories",
  },
  [4832] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8427500000,
        ["d"] = true,
        ["py"] = -0.0270100000,
        ["mn"] = 33,
      },
      [2] = {
        ["mn"] = 33,
        ["py"] = -0.0270000000,
        ["px"] = 0.8427300000,
        ["pm"] = 1429,
      },
    },
    ["n"] = "The Ever-Filling Chalice",
    ["cn"] = "Moawita Memories",
  },
  [4833] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8432800000,
        ["d"] = true,
        ["py"] = -0.0273300000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Chestplate of Desiccation",
    ["cn"] = "Moawita Memories",
  },
  [4834] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8431600000,
        ["d"] = true,
        ["py"] = -0.0271300000,
        ["mn"] = 33,
      },
    },
    ["n"] = "The Shattering Sword",
    ["cn"] = "Moawita Memories",
  },
  [4835] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Tindoria's List of Needed Supplies",
    ["q"] = 6129,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7192500000,
        ["px"] = 0.0360200000,
        ["pm"] = 1349,
      },
    },
  },
  [4836] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Tarnamir",
    ["q"] = 6135,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7270100000,
        ["px"] = 0.1174900000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7267300000,
        ["px"] = 0.1181700000,
        ["pm"] = 1349,
      },
    },
  },
  [4837] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8430800000,
        ["d"] = true,
        ["py"] = -0.0269600000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Psijic Codex: List of Dead Drops",
    ["cn"] = "Summerset Scrolls",
  },
  [4838] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7337700000,
        ["px"] = 0.1341800000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Ghost of the Green",
    ["cn"] = "Summerset Scrolls",
  },
  [4839] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Celan's Journal",
    ["q"] = 6135,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7343500000,
        ["px"] = 0.1344400000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7339400000,
        ["px"] = 0.1327400000,
        ["pm"] = 1349,
      },
    },
  },
  [4840] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "House of Reveries: The History",
    ["q"] = 6114,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7327000000,
        ["px"] = 0.0958600000,
        ["pm"] = 1349,
      },
    },
  },
  [4841] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7329200000,
        ["px"] = 0.0971500000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "House of Reveries: The Audition",
    ["cn"] = "Summerset Scrolls",
  },
  [4842] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7352100000,
        ["px"] = 0.0972600000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "House of Reveries: The Troupe",
    ["cn"] = "Summerset Scrolls",
  },
  [4843] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7368000000,
        ["px"] = 0.0964900000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Peasant Princess, A Play in One Act",
    ["cn"] = "Summerset Scrolls",
  },
  [4845] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7998400000,
        ["px"] = 0.1856000000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.6978300000,
        ["px"] = 0.0800500000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Bright Blade of Captain Castatil: Scene VI",
    ["cn"] = "Summerset Scrolls",
  },
  [4846] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7128500000,
        ["px"] = 0.1544400000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "A Case for Open Borders",
    ["cn"] = "Summerset Scrolls",
  },
  [4847] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7605900000,
        ["px"] = 0.0710000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "To Amberrie",
    ["cn"] = "Summerset Scrolls",
  },
  [4848] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7259200000,
        ["px"] = 0.1618900000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7668200000,
        ["px"] = 0.0724500000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "An End to Isolation",
    ["cn"] = "Summerset Scrolls",
  },
  [4849] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Gorge",
    ["q"] = 6117,
    ["e"] = {
      [1] = {
        ["px"] = 0.0843300000,
        ["py"] = 0.7544100000,
        ["d"] = true,
        ["pm"] = 1420,
      },
    },
  },
  [4850] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7255900000,
        ["px"] = 0.1615200000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "A Rejection of Open Borders",
    ["cn"] = "Summerset Scrolls",
  },
  [4852] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7119800000,
        ["px"] = 0.0376800000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Nursery Rhymes of Summerset",
    ["cn"] = "Summerset Scrolls",
  },
  [4853] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6924800000,
        ["px"] = 0.0807600000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Ubiquitous Sinking Isle",
    ["cn"] = "Summerset Scrolls",
  },
  [4854] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7066600000,
        ["px"] = 0.0414400000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Artaeum Lost",
    ["cn"] = "Summerset Scrolls",
  },
  [4855] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7328500000,
        ["px"] = 0.0772100000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Tips for a Khajiit in Summerset V. 1",
    ["cn"] = "Summerset Scrolls",
  },
  [4856] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["px"] = 0.1735200000,
        ["py"] = 0.8156100000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["px"] = 0.0792500000,
        ["py"] = 0.7462900000,
        ["pm"] = 1349,
      },
      [3] = { ["px"] = 0.0714048026, ["py"] = 0.6032340052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: Retinue of Shambles, Part 1",
    ["cn"] = "Summerset Scrolls",
  },
  [4857] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7288200000,
        ["px"] = 0.0786900000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Letter to Captain Oghul",
    ["cn"] = "Summerset Scrolls",
  },
  [4858] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Note to Arathel",
    ["q"] = 6116,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7211400000,
        ["px"] = 0.1588700000,
        ["pm"] = 1349,
      },
    },
  },
  [4859] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7176300000,
        ["px"] = 0.1257500000,
        ["pm"] = 1349,
      },
      [2] = { ["px"] = 0.0714404028, ["py"] = 0.6033316052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: Retinue of Shambles, Part 2",
    ["cn"] = "Summerset Scrolls",
  },
  [4860] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6950800000,
        ["px"] = 0.0750300000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Five-Fold Felicitations!",
    ["cn"] = "Summerset Scrolls",
  },
  [4862] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6950300000,
        ["px"] = 0.0755900000,
        ["pm"] = 1349,
      },
      [2] = { ["px"] = 0.0714392029, ["py"] = 0.6033424053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "Investigator Vale: Retinue of Shambles, Part 3",
    ["cn"] = "Summerset Scrolls",
  },
  [4863] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6936400000,
        ["px"] = 0.0755500000,
        ["pm"] = 1349,
      },
      [2] = { ["px"] = 0.0712428026, ["py"] = 0.6032996053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["n"] = "The Real Investigator Vale?",
    ["cn"] = "Summerset Scrolls",
  },
  [4864] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Naliara's Notes, Day 2",
    ["q"] = 6138,
    ["e"] = {
      [1] = {
        ["px"] = 0.1065400000,
        ["py"] = 0.6836900000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
  },
  [4865] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Naliara's Notes, Day 8",
    ["q"] = 6138,
    ["e"] = {
      [1] = {
        ["px"] = 0.1062900000,
        ["py"] = 0.6835100000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
  },
  [4866] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1062100000,
        ["py"] = 0.6846000000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "Naliara's Notes, Day 13",
    ["cn"] = "Summerset Scrolls",
  },
  [4867] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Naliara's Notes, Day 18",
    ["q"] = 6138,
    ["e"] = {
      [1] = {
        ["px"] = 0.1062600000,
        ["py"] = 0.6849400000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
  },
  [4869] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Imedril",
    ["q"] = 6142,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6949500000,
        ["px"] = 0.0763000000,
        ["pm"] = 1349,
      },
    },
  },
  [4876] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Journal of Justiciar Avanaire",
    ["q"] = 6144,
    ["e"] = {
      [1] = {
        ["px"] = 0.1268500000,
        ["py"] = 0.7504100000,
        ["d"] = true,
        ["pm"] = 1378,
      },
    },
  },
  [4877] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Words and Power",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["pm"] = 1349,
        ["py"] = 0.7048200000,
        ["px"] = 0.0912500000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [32] = 1,
    },
  },
  [4878] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6929700000,
        ["px"] = 0.0801900000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7717800000,
        ["px"] = 0.0733000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Further Notes on the Sload",
    ["cn"] = "Summerset Scrolls",
  },
  [4879] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Inexplicable Patron: Mephala",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1429] = 16,
      [1349] = 48,
    },
  },
  [4880] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "For Captain Telomure",
    ["q"] = 6144,
    ["e"] = {
      [1] = {
        ["px"] = 0.1270100000,
        ["py"] = 0.7502800000,
        ["d"] = true,
        ["pm"] = 1378,
      },
    },
  },
  [4881] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Pearl Research Notes, Log 3",
    ["q"] = 6144,
    ["e"] = {
      [1] = {
        ["px"] = 0.1271000000,
        ["py"] = 0.7505400000,
        ["d"] = true,
        ["pm"] = 1378,
      },
    },
  },
  [4882] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Lirendel's Family Shrine",
    ["q"] = 6151,
    ["e"] = {
      [1] = {
        ["px"] = 0.1270100000,
        ["py"] = 0.7503900000,
        ["d"] = true,
        ["pm"] = 1378,
      },
    },
  },
  [4883] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Guide to Altmeri Culture (On Dueling)",
    ["q"] = 6151,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7605900000,
        ["px"] = 0.0710000000,
        ["pm"] = 1349,
      },
    },
  },
  [4884] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Research of Nathien Mortieu, Vol. 1",
    ["e"] = {
      [1] = { ["px"] = 0.2382828011, ["py"] = 0.2984556002, ["pm"] = 1432, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4885] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Research of Nathien Mortieu, Vol. 2",
    ["e"] = {
      [1] = { ["px"] = 0.2386999949, ["py"] = 0.2978328064, ["pm"] = 1433, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4886] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Research of Nathien Mortieu, Vol. 3",
    ["e"] = {
      [1] = { ["px"] = 0.2388108042, ["py"] = 0.2962884018, ["pm"] = 1434, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4887] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "A Brother's Plea",
    ["e"] = {
      [1] = { ["px"] = 0.2391699949, ["py"] = 0.2976968064, ["pm"] = 1433, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4888] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "A Sister's Retort",
    ["e"] = {
      [1] = { ["px"] = 0.2393956043, ["py"] = 0.2968760018, ["pm"] = 1434, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4889] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "A Sister's Regret",
    ["e"] = {
      [1] = { ["px"] = 0.2389624061, ["py"] = 0.2956312010, ["pm"] = 1435, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4890] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "The History of Zaan the Scalecaller",
    ["e"] = {
      [1] = { ["px"] = 0.2387104011, ["py"] = 0.2992312002, ["pm"] = 1432, ["d"] = true, ["zx"] = 0.2394964008, ["zy"] = 0.3005428030, ["zm"] = 12, },
    },
  },
  [4891] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7302700000,
        ["px"] = 0.1385600000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Tsoxolza's Letter",
    ["cn"] = "Summerset Scrolls",
  },
  [4892] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.0341100000,
        ["px"] = 0.2667800000,
        ["pm"] = 1348,
      },
      [2] = {
        ["py"] = 1.0364000000,
        ["px"] = 0.2468100000,
        ["pm"] = 1348,
      },
      [3] = {
        ["py"] = 1.0348500000,
        ["px"] = 0.2663900000,
        ["pm"] = 1348,
      },
      [4] = {
        ["py"] = 1.0372100000,
        ["px"] = 0.2468900000,
        ["pm"] = 1348,
      },
    },
    ["n"] = "Warning to All Residents",
    ["cn"] = "Clockwork Mnemonix",
  },
  [4893] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 2,
        ["py"] = 0.3487800000,
        ["px"] = 0.1129200000,
        ["pm"] = 1,
      },
      [2] = {
        ["mn"] = 22,
        ["py"] = 0.2659500000,
        ["px"] = 0.6862700000,
        ["pm"] = 74,
      },
      [3] = {
        ["mn"] = 6,
        ["py"] = 0.2972000000,
        ["px"] = 0.3125900000,
        ["pm"] = 20,
      },
    },
    ["n"] = "Oracle's Vision",
    ["cn"] = "Rituals and Revelations",
  },
  [4894] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Kinlady's Letter",
    ["q"] = 6096,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["py"] = 0.7198400000,
        ["zt"] = 1047,
        ["px"] = 0.1612800000,
      },
    },
  },
  [4895] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1066200000,
        ["py"] = 0.6836500000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "Praise Be (Ancestor Song)",
    ["cn"] = "Summerset Scrolls",
  },
  [4896] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Words of the Fallen",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1446,
        ["py"] = 0.7623700000,
        ["px"] = 0.0782700000,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [32] = 1,
    },
  },
  [4897] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1070900000,
        ["py"] = 0.6846700000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "Restoring the Welwas",
    ["cn"] = "Summerset Scrolls",
  },
  [4898] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Invoice for Comestibles",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7743300000,
        ["px"] = 0.1740000000,
        ["pm"] = 1349,
      },
    },
  },
  [4899] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Disciplinary Action",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7749000000,
        ["px"] = 0.1734000000,
        ["pm"] = 1349,
      },
    },
  },
  [4900] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Serum Infusion Report",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7744300000,
        ["px"] = 0.1727500000,
        ["pm"] = 1349,
      },
    },
  },
  [4901] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6761300000,
        ["px"] = 0.0707700000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Tips for a Khajiit in Summerset V. 2",
    ["cn"] = "Summerset Scrolls",
  },
  [4902] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1062800000,
        ["py"] = 0.6835000000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "The Tale of Syrabane",
    ["cn"] = "Summerset Scrolls",
  },
  [4903] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Scrawled Note to Lorne",
    ["q"] = 6135,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7150200000,
        ["px"] = 0.1183100000,
        ["pm"] = 1349,
      },
    },
  },
  [4904] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Karnhar's Journal",
    ["q"] = 6146,
    ["e"] = {
      [1] = {
        ["px"] = 0.0635600000,
        ["py"] = 0.6797300000,
        ["d"] = true,
        ["pm"] = 1477,
      },
    },
  },
  [4905] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Turn Back!",
    ["q"] = 6146,
    ["e"] = {
      [1] = {
        ["px"] = 0.0647900000,
        ["py"] = 0.6795800000,
        ["d"] = true,
        ["pm"] = 1477,
      },
    },
  },
  [4906] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Farewell Note to Lauriel",
    ["q"] = 6118,
    ["e"] = {
      [1] = {
        ["px"] = 0.1613400000,
        ["py"] = 0.6912700000,
        ["d"] = true,
        ["pm"] = 1516,
      },
    },
  },
  [4907] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Lauriel",
    ["q"] = 6118,
    ["e"] = {
      [1] = {
        ["px"] = 0.1614000000,
        ["py"] = 0.6912600000,
        ["d"] = true,
        ["pm"] = 1516,
      },
    },
  },
  [4908] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Letter to Selenwe",
    ["q"] = 6118,
    ["e"] = {
      [1] = {
        ["px"] = 0.1615100000,
        ["py"] = 0.6914200000,
        ["d"] = true,
        ["pm"] = 1516,
      },
    },
  },
  [4909] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Selenwe's Journal",
    ["q"] = 6118,
    ["e"] = {
      [1] = {
        ["px"] = 0.1620500000,
        ["py"] = 0.6914200000,
        ["d"] = true,
        ["pm"] = 1516,
      },
    },
  },
  [4911] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7891179997, ["py"] = 0.4298380085, ["pm"] = 24, ["zm"] = 7, },
      [2] = { ["px"] = 0.2235960010, ["py"] = 0.7449352218, ["pm"] = 243, ["zm"] = 143, },
      [3] = { ["px"] = 0.0630088017, ["py"] = 0.3829100054, ["pm"] = 63, ["zm"] = 1, },
    },
    ["n"] = "Adventurer's Almanac, 2nd Edition",
    ["cn"] = "Adventurer's Almanac",
  },
  [4912] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7458200000,
        ["px"] = 0.0215100000,
        ["pm"] = 1369,
      },
    },
    ["n"] = "The Star-Eyed Bride of Alinor",
    ["cn"] = "Summerset Scrolls",
  },
  [4913] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3269500000,
        ["py"] = 0.2930800000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Arkngthamz-Phng",
    ["cn"] = "Library of Incunabula",
  },
  [4914] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3297100000,
        ["py"] = 0.2935400000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Journal of Orryn the Black",
    ["cn"] = "Library of Incunabula",
  },
  [4915] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3292800000,
        ["py"] = 0.2921300000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Caluurion's Notes",
    ["cn"] = "Library of Incunabula",
  },
  [4916] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3269900000,
        ["py"] = 0.2915800000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Reanimation Specimen Collection",
    ["cn"] = "Library of Incunabula",
  },
  [4917] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3284300000,
        ["py"] = 0.2909600000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Reanimation Experiment Findings",
    ["cn"] = "Library of Incunabula",
  },
  [4918] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3281300000,
        ["py"] = 0.2914200000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Death is No Laughing Matter",
    ["cn"] = "Library of Incunabula",
  },
  [4919] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3277600000,
        ["py"] = 0.2910300000,
        ["d"] = true,
        ["pm"] = 1436,
      },
    },
    ["n"] = "Cadaver Preparation Findings",
    ["cn"] = "Library of Incunabula",
  },
  [4920] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6832200000,
        ["px"] = 0.0689100000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Price of Praxis",
    ["cn"] = "Summerset Scrolls",
  },
  [4921] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Show Us Your Worth",
    ["q"] = 6117,
    ["e"] = {
      [1] = {
        ["px"] = 0.0812900000,
        ["py"] = 0.7501100000,
        ["d"] = true,
        ["pm"] = 1423,
      },
    },
  },
  [4922] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Night Runner Captain's Journal",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["px"] = 0.0971000000,
        ["py"] = 0.6594000000,
        ["d"] = true,
        ["pm"] = 1397,
      },
    },
  },
  [4923] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7598700000,
        ["px"] = 0.0695400000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7280600000,
        ["px"] = 0.1530700000,
        ["pm"] = 1349,
      },
      [3] = {
        ["mn"] = 32,
        ["py"] = 0.7129300000,
        ["px"] = 0.0397000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Divine Prosecution Notification",
    ["cn"] = "Summerset Scrolls",
  },
  [4925] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Mirulon's Report",
    ["q"] = 6116,
    ["e"] = {
      [1] = {
        ["px"] = 0.1578100000,
        ["py"] = 0.7212700000,
        ["d"] = true,
        ["pm"] = 1482,
      },
    },
  },
  [4926] = {
    ["c"] = true,
    ["cn"] = "Plots and Schemes",
    ["n"] = "To the Villainous Manacar",
    ["q"] = 6140,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7535700000,
        ["px"] = 0.0714500000,
        ["pm"] = 1349,
      },
    },
  },
  [4975] = {
    ["c"] = true,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Nafarion's Note",
    ["q"] = 6176,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6467700000,
        ["px"] = 0.1201400000,
        ["pm"] = 1349,
      },
    },
  },
  [4976] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Rultari's Journal",
    ["q"] = 6146,
    ["e"] = {
      [1] = {
        ["px"] = 0.0632000000,
        ["py"] = 0.6799800000,
        ["d"] = true,
        ["pm"] = 1477,
      },
    },
  },
  [4977] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Corgrad Statue Inscription",
    ["q"] = 6146,
    ["e"] = {
      [1] = {
        ["px"] = 0.0631400000,
        ["py"] = 0.6799900000,
        ["d"] = true,
        ["pm"] = 1477,
      },
    },
  },
  [4979] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Please Respond, Your Beloved Aunt Daiyanni",
    ["q"] = 6146,
    ["e"] = {
      [1] = {
        ["px"] = 0.0632400000,
        ["py"] = 0.6800300000,
        ["d"] = true,
        ["pm"] = 1477,
      },
    },
  },
  [4980] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1067400000,
        ["py"] = 0.6838100000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "King's Haven Scouting Record",
    ["cn"] = "Summerset Scrolls",
  },
  [4981] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1067400000,
        ["py"] = 0.6839300000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "King's Haven Territory Record",
    ["cn"] = "Summerset Scrolls",
  },
  [4982] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1067400000,
        ["py"] = 0.6836900000,
        ["d"] = true,
        ["pm"] = 1366,
      },
    },
    ["n"] = "King's Haven Trade Record",
    ["cn"] = "Summerset Scrolls",
  },
  [4983] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Indirim's Report, Part 1",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7620200000,
        ["px"] = 0.0551300000,
        ["pm"] = 1349,
      },
    },
  },
  [4984] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Indirim's Report, Part 2",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7662300000,
        ["px"] = 0.0521800000,
        ["pm"] = 1349,
      },
    },
  },
  [4985] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Indirim's Report, Part 3",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7693000000,
        ["px"] = 0.0523000000,
        ["pm"] = 1349,
      },
    },
  },
  [4986] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Indirim's Report, Part 4",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7703100000,
        ["px"] = 0.0491400000,
        ["pm"] = 1349,
      },
    },
  },
  [4987] = {
    ["c"] = true,
    ["cn"] = "Military Orders and Reports",
    ["n"] = "Indirim's Report, Part 5",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7723400000,
        ["px"] = 0.0458800000,
        ["pm"] = 1349,
      },
    },
  },
  [4988] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7049800000,
        ["px"] = 0.0912200000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Language of Ebon Stadmont",
    ["cn"] = "Summerset Scrolls",
  },
  [4990] = {
    ["c"] = true,
    ["cn"] = "Hew's Bane Bookshelf",
    ["n"] = "In Defense of Prince Hubalajad",
    ["e"] = {
      [1] = { ["px"] = 0.2436900025, ["py"] = 0.5060271982, ["pm"] = 993, ["zx"] = 0.2436600000, ["zy"] = 0.5060900000, ["zm"] = 994, },
    },
  },
  [4992] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7309000000,
        ["px"] = 0.1473900000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Investigating Our Allies, Part 1",
    ["cn"] = "Summerset Scrolls",
  },
  [4993] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7239100000,
        ["px"] = 0.1620100000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Investigating Our Allies, Part 2",
    ["cn"] = "Summerset Scrolls",
  },
  [4994] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Trapped in Ebon Stadmont",
    ["q"] = 6119,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7048100000,
        ["px"] = 0.0911500000,
        ["pm"] = 1349,
      },
    },
  },
  [4996] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Forest Dark",
    ["q"] = 6115,
    ["e"] = {
      [1] = {
        ["px"] = 0.0808800000,
        ["py"] = 0.6903000000,
        ["d"] = true,
        ["pm"] = 1406,
      },
    },
  },
  [4997] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Cartorrel's Last Words",
    ["q"] = 6149,
    ["e"] = {
      [1] = {
        ["py"] = 0.7460800000,
        ["px"] = 0.0207200000,
        ["pm"] = 1369,
      },
    },
  },
  [4998] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Siege of Ald Marak",
    ["q"] = 6115,
    ["e"] = {
      [1] = {
        ["px"] = 0.0808700000,
        ["py"] = 0.6903900000,
        ["d"] = true,
        ["pm"] = 1406,
      },
    },
  },
  [4999] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Truth of Minotaurs",
    ["q"] = 6115,
    ["e"] = {
      [1] = {
        ["px"] = 0.0806600000,
        ["py"] = 0.6901300000,
        ["d"] = true,
        ["pm"] = 1406,
      },
    },
  },
  [5000] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Illuminus",
    ["q"] = 6115,
    ["e"] = {
      [1] = {
        ["px"] = 0.0806500000,
        ["py"] = 0.6908300000,
        ["d"] = true,
        ["pm"] = 1406,
      },
    },
  },
  [5007] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Indirim's Journal, Assembled",
    ["q"] = 6165,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7668600000,
        ["px"] = 0.0721800000,
        ["pm"] = 1349,
      },
    },
  },
  [5037] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4517900000,
        ["py"] = 0.5506700000,
        ["d"] = true,
        ["pm"] = 1525,
      },
    },
    ["n"] = "By Order of the Silver Dawn",
    ["cn"] = "Library of Incunabula",
  },
  [5038] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4523600000,
        ["py"] = 0.5502100000,
        ["d"] = true,
        ["pm"] = 1525,
      },
    },
    ["n"] = "Rolea's Journal",
    ["cn"] = "Library of Incunabula",
  },
  [5039] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4526695996, ["py"] = 0.5498031924, ["pm"] = 1524, ["zx"] = 0.4517843832, ["zy"] = 0.5507372078, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "The Hedge Maze",
    ["cn"] = "Library of Incunabula",
  },
  [5040] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4527659983, ["py"] = 0.5489196042, ["pm"] = 1525, ["zx"] = 0.4517843832, ["zy"] = 0.5507372078, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Letter to Mylenne",
    ["cn"] = "Library of Incunabula",
  },
  [5041] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4530807983, ["py"] = 0.5487044042, ["pm"] = 1525, ["zx"] = 0.4517843832, ["zy"] = 0.5507372078, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "Log #321: Unexpected Results",
    ["cn"] = "Library of Incunabula",
  },
  [5042] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4529647983, ["py"] = 0.5486816042, ["pm"] = 1525, ["zx"] = 0.4517843832, ["zy"] = 0.5507372078, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "A Cure for Lycanthropy",
    ["cn"] = "Library of Incunabula",
  },
  [5043] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4532395983, ["py"] = 0.5487360042, ["pm"] = 1525, ["zx"] = 0.4517843832, ["zy"] = 0.5507372078, ["zm"] = 256, ["d"] = true, },
    },
    ["n"] = "The Hungry Cat's Curse",
    ["cn"] = "Library of Incunabula",
  },
  [5044] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2969700000,
        ["py"] = 0.6959500000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "The Huntsman Prince",
    ["cn"] = "Library of Incunabula",
  },
  [5045] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2981500000,
        ["py"] = 0.6948300000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "Letter to Balorgh",
    ["cn"] = "Library of Incunabula",
  },
  [5046] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2973000000,
        ["py"] = 0.6956200000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "A Boon for the Tribe",
    ["cn"] = "Library of Incunabula",
  },
  [5047] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2978000000,
        ["py"] = 0.6947900000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "An Unusual Hare",
    ["cn"] = "Library of Incunabula",
  },
  [5048] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2970600000,
        ["py"] = 0.6951900000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "The Glory of the Hunt",
    ["cn"] = "Library of Incunabula",
  },
  [5049] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2982000000,
        ["py"] = 0.6950300000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "Concerning Balorgh",
    ["cn"] = "Library of Incunabula",
  },
  [5050] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2983800000,
        ["py"] = 0.6958600000,
        ["d"] = true,
        ["pm"] = 1519,
      },
    },
    ["n"] = "Balorgh's Plan",
    ["cn"] = "Library of Incunabula",
  },
  [5051] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1130948008, ["py"] = 0.6869872056, ["pm"] = 1502, ["d"] = true,
        ["zx"] = 0.1078844051, ["zy"] = 0.7002756019, ["zm"] = 1349,
      },
    },
    ["n"] = "Wailimo's Personal Account",
    ["cn"] = "Summerset Scrolls",
  },
  [5053] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1214588018, ["py"] = 0.6970608056, ["pm"] = 1502, ["d"] = true,
        ["zx"] = 0.1078844051, ["zy"] = 0.7002756019, ["zm"] = 1349,
      },
    },
    ["n"] = "The Gryphons of the Welkynars",
    ["cn"] = "Summerset Scrolls",
  },
  [5054] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1165460011, ["py"] = 0.6955824063, ["pm"] = 1502, ["d"] = true,
        ["zx"] = 0.1078844051, ["zy"] = 0.7002756019, ["zm"] = 1349,
      },
    },
    ["n"] = "The Welkynars of Eton Nir",
    ["cn"] = "Summerset Scrolls",
  },
  [5055] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1175996000, ["py"] = 0.7019032055, ["pm"] = 1502, ["d"] = true,
        ["zx"] = 0.1078844051, ["zy"] = 0.7002756019, ["zm"] = 1349,
      },
    },
    ["n"] = "Observation Note 154: Z'Maja's Capture",
    ["cn"] = "Summerset Scrolls",
  },
  [5056] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7004600000,
        ["px"] = 0.1079400000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Cloudrest Secret Entrance",
    ["cn"] = "Summerset Scrolls",
  },
  [5065] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0783800000,
        ["py"] = 0.7626000000,
        ["d"] = true,
        ["pm"] = 1446,
      },
    },
    ["n"] = "Writ of Valid Credentials",
    ["cn"] = "Summerset Scrolls",
  },
  [5066] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Sapiarch's Recommendation",
    ["q"] = 6141,
    ["e"] = {
      [1] = {
        ["px"] = 0.0784100000,
        ["py"] = 0.7625800000,
        ["d"] = true,
        ["pm"] = 1446,
      },
    },
  },
  [5067] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Invitation to the Kinlady's Conference",
    ["q"] = 6096,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7224000000,
        ["px"] = 0.1580400000,
        ["pm"] = 1349,
      },
    },
  },
  [5083] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7437300000,
        ["px"] = 0.1393000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "To Chief Justiciar Carawen",
    ["cn"] = "Summerset Scrolls",
  },
  [5084] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8663600000,
        ["d"] = true,
        ["py"] = -0.0733400000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Regarding Thorn Blackstaff",
    ["cn"] = "Summerset Scrolls",
  },
  [5085] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 33,
        ["py"] = -0.0681000000,
        ["px"] = 0.8600200000,
        ["pm"] = 1429,
      },
    },
    ["n"] = "Visit Summerset",
    ["cn"] = "Summerset Scrolls",
  },
  [5086] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Findings on the Elemental Volatility of Imps",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7748100000,
        ["px"] = 0.1746800000,
        ["pm"] = 1349,
      },
    },
  },
  [5087] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Fellrunner Failure?",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7734900000,
        ["px"] = 0.1768000000,
        ["pm"] = 1349,
      },
    },
  },
  [5088] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Report on Wing Rot Curative Trials",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7744000000,
        ["px"] = 0.1739300000,
        ["pm"] = 1349,
      },
    },
  },
  [5089] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6788200000,
        ["px"] = 0.0537300000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.8016300000,
        ["px"] = 0.1898400000,
        ["pm"] = 1349,
      },
      [3] = {
        ["mn"] = 32,
        ["py"] = 0.7860700000,
        ["px"] = 0.1931200000,
        ["pm"] = 1349,
      },
      [4] = {
        ["mn"] = 32,
        ["py"] = 0.6714800000,
        ["px"] = 0.1638200000,
        ["pm"] = 1349,
      },
      [5] = {
        ["mn"] = 32,
        ["py"] = 0.7238000000,
        ["px"] = 0.0878200000,
        ["pm"] = 1349,
      },
      [6] = {
        ["mn"] = 32,
        ["py"] = 0.8167900000,
        ["px"] = 0.1733400000,
        ["pm"] = 1349,
      },
      [7] = {
        ["mn"] = 32,
        ["py"] = 0.7991700000,
        ["px"] = 0.1163300000,
        ["pm"] = 1349,
      },
      [8] = {
        ["mn"] = 32,
        ["py"] = 0.7508800000,
        ["px"] = 0.0617200000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Message in a Bottle",
    ["cn"] = "Mysteries and Clues",
  },
  [5091] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.8167600000,
        ["px"] = 0.1733300000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7859300000,
        ["px"] = 0.1929800000,
        ["pm"] = 1349,
      },
      [3] = {
        ["mn"] = 32,
        ["py"] = 0.7508200000,
        ["px"] = 0.0617100000,
        ["pm"] = 1349,
      },
      [4] = {
        ["mn"] = 32,
        ["py"] = 0.7991700000,
        ["px"] = 0.1163200000,
        ["pm"] = 1349,
      },
      [5] = {
        ["mn"] = 32,
        ["py"] = 0.7121700000,
        ["px"] = 0.0930600000,
        ["pm"] = 1349,
      },
      [6] = {
        ["mn"] = 32,
        ["py"] = 0.7237000000,
        ["px"] = 0.0878100000,
        ["pm"] = 1349,
      },
      [7] = {
        ["mn"] = 32,
        ["py"] = 0.7250700000,
        ["px"] = 0.0444700000,
        ["pm"] = 1349,
      },
      [8] = {
        ["mn"] = 32,
        ["py"] = 0.7191300000,
        ["px"] = 0.0685400000,
        ["pm"] = 1349,
      },
      [9] = {
        ["mn"] = 32,
        ["py"] = 0.7485200000,
        ["px"] = 0.1781300000,
        ["pm"] = 1349,
      },
      [10] = {
        ["mn"] = 32,
        ["py"] = 0.6634200000,
        ["px"] = 0.0702500000,
        ["pm"] = 1349,
      },
      [11] = {
        ["mn"] = 32,
        ["py"] = 0.7391200000,
        ["px"] = 0.0739100000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Message in a Bottle",
    ["cn"] = "Mysteries and Clues",
  },
  [5092] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.8167800000,
        ["px"] = 0.1733200000,
        ["pm"] = 1349,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7391500000,
        ["px"] = 0.0739700000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Message in a Bottle",
    ["cn"] = "Mysteries and Clues",
  },
  [5093] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0558700000,
        ["py"] = 0.7217100000,
        ["d"] = true,
        ["pm"] = 1496,
      },
    },
    ["n"] = "The False Revanchism of the Maormer",
    ["cn"] = "Summerset Scrolls",
  },
  [5095] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1166644005, ["py"] = 0.6931952055, ["pm"] = 1502, ["d"] = true,
        ["zx"] = 0.1078844051, ["zy"] = 0.7002756019, ["zm"] = 1349,
      },
    },
    ["n"] = "Charge of the Welkynar",
    ["cn"] = "Summerset Scrolls",
  },
  [5096] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1303500000,
        ["py"] = 0.7744600000,
        ["d"] = true,
        ["pm"] = 1370,
      },
    },
    ["n"] = "The Pack of Archon's Grove",
    ["cn"] = "Summerset Scrolls",
  },
  [5097] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7109100000,
        ["px"] = 0.1551200000,
        ["pm"] = 1349,
      },
      [2] = {
        ["px"] = 0.8604900000,
        ["py"] = -0.0756400000,
        ["d"] = true,
        ["pm"] = 1403,
      },
    },
    ["n"] = "Veya's Private Thoughts, Part 1",
    ["cn"] = "Summerset Scrolls",
  },
  [5098] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7303100000,
        ["px"] = 0.1094300000,
        ["pm"] = 1349,
      },
      [2] = {
        ["px"] = 0.8618500000,
        ["py"] = -0.0754600000,
        ["d"] = true,
        ["pm"] = 1403,
      },
    },
    ["n"] = "Veya's Private Thoughts, Part 2",
    ["cn"] = "Summerset Scrolls",
  },
  [5099] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1297500000,
        ["py"] = 0.6920700000,
        ["d"] = true,
        ["pm"] = 1373,
      },
      [2] = {
        ["px"] = 0.8600200000,
        ["py"] = -0.0767100000,
        ["d"] = true,
        ["pm"] = 1403,
      },
    },
    ["n"] = "Veya's Private Thoughts, Part 3",
    ["cn"] = "Summerset Scrolls",
  },
  [5100] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8603100000,
        ["py"] = -0.0767300000,
        ["d"] = true,
        ["pm"] = 1403,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.6840400000,
        ["px"] = 0.0493400000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Veya's Private Thoughts, Part 4",
    ["cn"] = "Summerset Scrolls",
  },
  [5101] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.8071700000,
        ["py"] = -0.0359200000,
        ["d"] = true,
        ["pm"] = 1374,
      },
    },
    ["n"] = "Letter to Casolinwe",
    ["cn"] = "Summerset Scrolls",
  },
  [5103] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7010600000,
        ["px"] = 0.0647300000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Pretension of High Elf Jewelry",
    ["cn"] = "Skill Books",
  },
  [5104] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7098300000,
        ["px"] = 0.1546800000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "ART OF SMASHING VOL. 1",
    ["cn"] = "Summerset Scrolls",
  },
  [5105] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Jewels of Yokuda",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [1429] = 30,
      [1349] = 52,
    },
  },
  [5106] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Scaled Elves",
    ["q"] = 6131,
    ["e"] = {
      [1] = {
        ["px"] = 0.0558700000,
        ["py"] = 0.7218000000,
        ["d"] = true,
        ["pm"] = 1496,
      },
    },
  },
  [5107] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Y'frre's Sparkling Steeds",
    ["q"] = 6121,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7733700000,
        ["px"] = 0.1735500000,
        ["pm"] = 1349,
      },
    },
  },
  [5108] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Myth of the Sea Sloads",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0830700000,
        ["py"] = 0.6601700000,
        ["d"] = true,
        ["pm"] = 1397,
      },
    },
    ["m"] = {
      [32] = 1,
    },
  },
  [5109] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "The Crystal of the Tower",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["pm"] = 1349,
        ["py"] = 0.7066200000,
        ["px"] = 0.0405800000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [32] = 1,
    },
  },
  [5110] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7206000000,
        ["px"] = 0.1551900000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Cases of the Divine Prosecution",
    ["cn"] = "Summerset Scrolls",
  },
  [5111] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7113600000,
        ["px"] = 0.0414400000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "On the College of Sapiarchs",
    ["cn"] = "Summerset Scrolls",
  },
  [5112] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7503500000,
        ["px"] = 0.1426200000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "The Psijic Order",
    ["cn"] = "Summerset Scrolls",
  },
  [5113] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7745700000,
        ["px"] = 0.0435000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "A Sailor's Guide to Sea Elves",
    ["cn"] = "Summerset Scrolls",
  },
  [5115] = {
    ["c"] = true,
    ["cn"] = "Summerset Scrolls",
    ["n"] = "Folly of Man",
    ["q"] = 6142,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.6928600000,
        ["px"] = 0.0807200000,
        ["pm"] = 1349,
      },
    },
  },
  [5117] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7596200000,
        ["px"] = 0.0704200000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Our Blessed Isles: A Guide",
    ["cn"] = "Summerset Scrolls",
  },
  [5118] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.0819500000,
        ["py"] = 0.6566400000,
        ["d"] = true,
        ["pm"] = 1397,
      },
      [2] = {
        ["mn"] = 32,
        ["py"] = 0.7206400000,
        ["px"] = 0.1509000000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Summerset Isles: A Visitor's Guide",
    ["cn"] = "Summerset Scrolls",
  },
  [5119] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7261300000,
        ["px"] = 0.1189700000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Corruption of the Blood",
    ["cn"] = "Summerset Scrolls",
  },
  [5120] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.8159100000,
        ["px"] = 0.1735100000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Ertival's Recounting",
    ["cn"] = "Summerset Scrolls",
  },
  [5121] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7875200000,
        ["px"] = 0.0946400000,
        ["pm"] = 1438,
      },
    },
    ["n"] = "The Flight of Gryphons",
    ["cn"] = "Summerset Scrolls",
  },
  [5122] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7861900000,
        ["px"] = 0.0983600000,
        ["pm"] = 1438,
      },
    },
    ["n"] = "The King of Vipers, Canto 17",
    ["cn"] = "Summerset Scrolls",
  },
  [5146] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 32,
        ["py"] = 0.7599800000,
        ["px"] = 0.1642500000,
        ["pm"] = 1349,
      },
    },
    ["n"] = "Thoughts on the Sacred Numbers",
    ["cn"] = "Summerset Scrolls",
  },
  [5147] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Legion Officer's Journal",
    ["q"] = 6240,
    ["e"] = {
      [1] = {
        ["px"] = 0.7111200000,
        ["py"] = 0.7735400000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
  },
  [5148] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Legion Officer's Notebook",
    ["q"] = 6240,
    ["e"] = {
      [1] = {
        ["px"] = 0.7113600000,
        ["py"] = 0.7735000000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
  },
  [5150] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Note from the Last Legionnaire",
    ["q"] = 6240,
    ["e"] = {
      [1] = {
        ["px"] = 0.7111400000,
        ["py"] = 0.7740300000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
  },
  [5157] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7595400000,
        ["px"] = 0.7164000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Tribes of Murkmire: The Dead-Water Tribe",
    ["cn"] = "Lore of Murkmire",
  },
  [5172] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8606400000,
        ["d"] = true,
        ["py"] = -0.0716400000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Sotha Sil and the Scribe",
    ["cn"] = "Tales of Tamriel",
  },
  [5173] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 9,
        ["py"] = 0.5415700000,
        ["px"] = 0.7520700000,
        ["pm"] = 26,
      },
    },
    ["n"] = "List of Argonians",
    ["cn"] = "Mysteries and Clues",
  },
  [5181] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Unearthing Garlas Malatar",
    ["e"] = {
      [1] = { ["px"] = 0.3018083956, ["py"] = 0.5636580075, ["pm"] = 1596, ["d"] = true, ["zx"] = 0.3030780139, ["zy"] = 0.5632388122, ["zm"] = 1006, },
    },
  },
  [5182] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Frostbitten Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3026263867, ["py"] = 0.5645391985, ["pm"] = 1597, ["d"] = true, ["zx"] = 0.3030780139, ["zy"] = 0.5632388122, ["zm"] = 1006, },
    },
  },
  [5183] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Umaril is Undone",
    ["e"] = {
      [1] = { ["px"] = 0.3032484132, ["py"] = 0.5648216026, ["pm"] = 1598, ["d"] = true, ["zx"] = 0.3030780139, ["zy"] = 0.5632388122, ["zm"] = 1006, },
    },
  },
  [5184] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Send Your Forces, Narilmor",
    ["e"] = {
      [1] = { ["px"] = 0.3032996133, ["py"] = 0.5650672025, ["pm"] = 1598, ["d"] = true, ["zx"] = 0.3030780139, ["zy"] = 0.5632388122, ["zm"] = 1006, },
    },
  },
  [5188] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Letter to Bhoki",
    ["q"] = 6254,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7642500000,
        ["px"] = 0.7115100000,
        ["pm"] = 1484,
      },
    },
  },
  [5190] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.7270500000,
        ["px"] = 0.4342300000,
        ["pm"] = 9,
      },
      [2] = { ["px"] = 0.2205448025, ["py"] = 0.3285288070, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Cyrodilic Collections Needs You!",
    ["cn"] = "Lore of Murkmire",
  },
  [5191] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7952200000,
        ["px"] = 0.7473300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Eshraf's Journal",
    ["cn"] = "Lore of Murkmire",
  },
  [5193] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2339100000,
        ["py"] = 0.7430100000,
        ["d"] = true,
        ["pm"] = 808,
      },
      [2] = {
        ["px"] = 0.7850900000,
        ["py"] = 0.4311100000,
        ["d"] = true,
        ["pm"] = 814,
      },
    },
    ["n"] = "Blackguard Note",
    ["cn"] = "Mysteries and Clues",
  },
  [5197] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Ree-Nakal's Orders",
    ["q"] = 6258,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7706400000,
        ["px"] = 0.7490800000,
        ["pm"] = 1484,
      },
    },
  },
  [5198] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Egg-Tender's Journal",
    ["q"] = 6258,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7704900000,
        ["px"] = 0.7490800000,
        ["pm"] = 1484,
      },
    },
  },
  [5199] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Seek Adventure in Murkmire!",
    ["e"] = {
      [1] = { ["px"] = 0.2315300000, ["py"] = 0.7460700000, ["pm"] = 243, ["zm"] = 143, },
      [2] = {
        ["mn"] = 19,
        ["py"] = 0.5439600000,
        ["px"] = 0.1664000000,
        ["pm"] = 530,
        ["zm"] = 201,
      },
      [3] = {
        ["mn"] = 10,
        ["py"] = 0.5136000000,
        ["px"] = 0.7718900000,
        ["pm"] = 13,
      },
    },
  },
  [5200] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "A Guide to Gathering Frogs",
    ["q"] = 6265,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["py"] = 0.8033200000,
        ["px"] = 0.7659600000,
        ["r"] = true,
      },
    },
  },
  [5202] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Bright-Throat Riddle Fragment",
    ["q"] = 6241,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["py"] = 0.7927300000,
        ["px"] = 0.7693100000,
        ["r"] = true,
      },
      [2] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["px"] = 0.7602100000,
        ["i"] = 12,
        ["py"] = 0.7760700000,
      },
    },
  },
  [5203] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Dead-Water Riddle Fragment",
    ["q"] = 6241,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7644600000,
        ["px"] = 0.7143100000,
        ["pm"] = 1484,
      },
    },
  },
  [5265] = {
    ["c"] = true,
    ["cn"] = "Personal Journals",
    ["n"] = "The Journal of Margus Derius",
    ["e"] = {
      [1] = { ["px"] = 0.2195492068, ["py"] = 0.6997272015, ["pm"] = 1513, ["d"] = true, ["zx"] = 0.2198932009, ["zy"] = 0.6989516169, ["zm"] = 143, },
    },
  },
  [5266] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 35,
        ["py"] = 0.8005100000,
        ["px"] = 0.8042000000,
        ["pm"] = 1552,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5418300000,
        ["px"] = 0.7523400000,
        ["pm"] = 26,
      },
    },
    ["n"] = "The Curse of Beela-Kaar",
    ["cn"] = "Rituals and Revelations",
  },
  [5267] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 35,
        ["py"] = 0.7912100000,
        ["px"] = 0.7860400000,
        ["pm"] = 1552,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5414600000,
        ["px"] = 0.7522500000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Blackguard Instructions, One",
    ["cn"] = "Criminal Correspondence",
  },
  [5268] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 35,
        ["py"] = 0.8687400000,
        ["px"] = 0.5431800000,
        ["pm"] = 1552,
      },
      [2] = {
        ["mn"] = 9,
        ["py"] = 0.5414100000,
        ["px"] = 0.7523900000,
        ["pm"] = 26,
      },
    },
    ["n"] = "Blackguard Instructions, Two",
    ["cn"] = "Criminal Correspondence",
  },
  [5269] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 35,
        ["py"] = 0.7956700000,
        ["px"] = 0.8015000000,
        ["pm"] = 1552,
      },
      [2] = {
        ["pm"] = 26,
        ["px"] = 0.7519900000,
        ["i"] = 12,
        ["py"] = 0.5415400000,
        ["mn"] = 9,
      },
    },
    ["n"] = "Blackguard Instructions, Three",
    ["cn"] = "Criminal Correspondence",
  },
  [5270] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7814900000,
        ["px"] = 0.7748800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Broken Xinchei-Konu",
    ["cn"] = "Lore of Murkmire",
  },
  [5271] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7780300000,
        ["mn"] = 34,
        ["px"] = 0.7448400000,
        ["pm"] = 1484,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "For My Beloved Kud-Nakal",
    ["cn"] = "Hearts and Flowers",
  },
  [5272] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7772200000,
        ["px"] = 0.7634300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Egg-Tender's Unfinished Letter",
    ["cn"] = "Lore of Murkmire",
  },
  [5273] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1429,
        ["px"] = 0.8428700000,
        ["d"] = true,
        ["py"] = -0.0270900000,
        ["mn"] = 33,
      },
    },
    ["n"] = "Staff of Towers",
    ["cn"] = "Moawita Memories",
  },
  [5274] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7359600000,
        ["py"] = 0.7784000000,
        ["d"] = true,
        ["pm"] = 1509,
      },
    },
    ["n"] = "So Much Wasted Potential",
    ["cn"] = "Lore of Murkmire",
  },
  [5275] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Development of the Hollow",
    ["q"] = 6258,
    ["e"] = {
      [1] = {
        ["px"] = 0.7359800000,
        ["py"] = 0.7784500000,
        ["d"] = true,
        ["pm"] = 1509,
      },
    },
  },
  [5276] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Letter from Paheiza",
    ["q"] = 6277,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8022100000,
        ["px"] = 0.7700700000,
        ["pm"] = 1484,
      },
    },
  },
  [5277] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Keema-Ru's Grave-Stake",
    ["q"] = 6277,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7986800000,
        ["px"] = 0.7721200000,
        ["pm"] = 1484,
      },
    },
  },
  [5278] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Threatening Letter to Paheiza",
    ["q"] = 6277,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7812600000,
        ["px"] = 0.7402500000,
        ["pm"] = 1484,
      },
    },
  },
  [5279] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1484,
        ["mn"] = 34,
        ["px"] = 0.7660400000,
        ["i"] = 12,
        ["py"] = 0.7624400000,
      },
    },
    ["n"] = "Vanthongar's Letter",
    ["cn"] = "Plots and Schemes",
  },
  [5280] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Journal of Hostia Asellus",
    ["q"] = 6279,
    ["e"] = {
      [1] = {
        ["pm"] = 1484,
        ["px"] = 0.7229700000,
        ["d"] = true,
        ["py"] = 0.7604800000,
        ["mn"] = 34,
      },
    },
  },
  [5281] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Oleen's First Dowry Reminder",
    ["q"] = 6293,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7754500000,
        ["px"] = 0.7632700000,
        ["pm"] = 1484,
      },
    },
  },
  [5282] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Oleen's Second Dowry Reminder",
    ["q"] = 6293,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7783600000,
        ["px"] = 0.7605700000,
        ["pm"] = 1484,
      },
    },
  },
  [5283] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Oleen's Third Dowry Reminder",
    ["q"] = 6293,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7755700000,
        ["px"] = 0.7630900000,
        ["pm"] = 1484,
      },
    },
  },
  [5284] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Oleen's Final Dowry Reminder",
    ["q"] = 6293,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7742300000,
        ["px"] = 0.7660300000,
        ["pm"] = 1484,
      },
    },
  },
  [5287] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7810400000,
        ["px"] = 0.7755900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Ku-Vastei: The Needed Change",
    ["cn"] = "Lore of Murkmire",
  },
  [5288] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7816200000,
        ["px"] = 0.7749500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Seasons of Argonia",
    ["cn"] = "Lore of Murkmire",
  },
  [5290] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7966200000,
        ["px"] = 0.7691300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letter from Ajim-Jaa",
    ["cn"] = "Lore of Murkmire",
  },
  [5291] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Heetzasi's Journal, Page 1",
    ["q"] = 6241,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7830300000,
        ["px"] = 0.7226400000,
        ["pm"] = 1484,
      },
    },
  },
  [5292] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Heetzasi's Journal, Page 2",
    ["q"] = 6241,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7826800000,
        ["px"] = 0.7223500000,
        ["pm"] = 1484,
      },
    },
  },
  [5293] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Heetzasi's Journal, Page 3",
    ["q"] = 6241,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7829000000,
        ["px"] = 0.7226000000,
        ["pm"] = 1484,
      },
    },
  },
  [5294] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Dossier: Varo Hosidias",
    ["q"] = 6266,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7926700000,
        ["px"] = 0.7692900000,
        ["pm"] = 1484,
      },
    },
  },
  [5295] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Dossier: Zadaza",
    ["q"] = 6266,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7926300000,
        ["px"] = 0.7692900000,
        ["pm"] = 1484,
      },
    },
  },
  [5296] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Dossier: The Newcomer",
    ["q"] = 6266,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7926000000,
        ["px"] = 0.7692900000,
        ["pm"] = 1484,
      },
    },
  },
  [5298] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7723400000,
        ["px"] = 0.7114600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Dradeiva's Journal",
    ["cn"] = "Lore of Murkmire",
  },
  [5299] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8002700000,
        ["px"] = 0.7680900000,
        ["pm"] = 1484,
      },
      [2] = {
        ["mn"] = 34,
        ["py"] = 0.8012000000,
        ["px"] = 0.7646200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Death-Hunts Await",
    ["cn"] = "Lore of Murkmire",
  },
  [5300] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7995000000,
        ["px"] = 0.7687800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Black Marsh Awaits!",
    ["cn"] = "Lore of Murkmire",
  },
  [5301] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["i"] = 12,
        ["px"] = 0.7662100000,
        ["py"] = 0.8032200000,
      },
    },
    ["n"] = "The Sharper Tongue: A Jel Primer",
    ["cn"] = "Lore of Murkmire",
  },
  [5302] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7771800000,
        ["px"] = 0.7634700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Rhymes and Chimes",
    ["cn"] = "Lore of Murkmire",
  },
  [5303] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7473500000,
        ["px"] = 0.7633700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Care and Feeding of Swamp Jellies",
    ["cn"] = "Lore of Murkmire",
  },
  [5304] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "On Voriplasms",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7588983796, ["py"] = 0.7606263837, ["pm"] = 1484, },
    },
    ["m"] = {
      [34] = 1,
    },
  },
  [5305] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1484,
        ["px"] = 0.7299000000,
        ["d"] = true,
        ["py"] = 0.7483700000,
        ["mn"] = 34,
      },
    },
    ["n"] = "Miregaunts of the Marsh",
    ["cn"] = "Lore of Murkmire",
  },
  [5306] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Lord Hollowjack's Dread Realm",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["py"] = 0.7926400000,
        ["px"] = 0.7693400000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [34] = 1,
    },
  },
  [5307] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7844700000,
        ["px"] = 0.7758900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Vine-Tongues: Introduction",
    ["cn"] = "Lore of Murkmire",
  },
  [5308] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7522800000,
        ["px"] = 0.7456500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Vine-Tongues: Preparations",
    ["cn"] = "Lore of Murkmire",
  },
  [5309] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7714300000,
        ["px"] = 0.7347000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Vine-Tongues: Happy Plants",
    ["cn"] = "Lore of Murkmire",
  },
  [5310] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7840500000,
        ["px"] = 0.7126800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Vine-Tongues: Nourishment",
    ["cn"] = "Lore of Murkmire",
  },
  [5311] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7114800000,
        ["py"] = 0.7736400000,
        ["d"] = true,
        ["pm"] = 1506,
      },
    },
    ["n"] = "Vine-Tongues: A Happy Home",
    ["cn"] = "Lore of Murkmire",
  },
  [5312] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7370055791, ["py"] = 0.7572056140, ["pm"] = 1522, ["d"] = true, },
    },
    ["n"] = "Vine-Tongues: Common Mistakes",
    ["cn"] = "Lore of Murkmire",
  },
  [5313] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7771800000,
        ["px"] = 0.7633900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Lusty Argonian Footman, Volume 1",
    ["cn"] = "Lore of Murkmire",
  },
  [5359] = {
    ["c"] = true,
    ["cn"] = "Lore of Murkmire",
    ["n"] = "Scaly Steeds of Black Marsh",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7483700000,
        ["pm"] = 1484,
        ["px"] = 0.7303200000,
        ["d"] = true,
        ["r"] = true,
        ["mn"] = 34,
      },
    },
    ["m"] = {
      [34] = 1,
    },
  },
  [5360] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7507700000,
        ["px"] = 0.7641900000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Scales of Shadow",
    ["cn"] = "Lore of Murkmire",
  },
  [5361] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7522000000,
        ["px"] = 0.7299200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lies of the Dread-Father",
    ["cn"] = "Lore of Murkmire",
  },
  [5362] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7934100000,
        ["px"] = 0.7665600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "That of Void",
    ["cn"] = "Lore of Murkmire",
  },
  [5363] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7766100000,
        ["px"] = 0.7651700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Acts of Honoring",
    ["cn"] = "Lore of Murkmire",
  },
  [5364] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7649700000,
        ["px"] = 0.7099800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Speakers of Nothing",
    ["cn"] = "Lore of Murkmire",
  },
  [5365] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7925300000,
        ["px"] = 0.7692300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment I",
    ["cn"] = "Lore of Murkmire",
  },
  [5366] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7954500000,
        ["px"] = 0.7666800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment II",
    ["cn"] = "Lore of Murkmire",
  },
  [5367] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7952200000,
        ["px"] = 0.7644800000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment III",
    ["cn"] = "Lore of Murkmire",
  },
  [5368] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8004700000,
        ["px"] = 0.7626600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment IV",
    ["cn"] = "Lore of Murkmire",
  },
  [5369] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8052700000,
        ["px"] = 0.7733500000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment V",
    ["cn"] = "Lore of Murkmire",
  },
  [5370] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8034600000,
        ["px"] = 0.7667600000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Lost Tales of the Famed Explorer: Fragment VI",
    ["cn"] = "Lore of Murkmire",
  },
  [5371] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7529300000,
        ["py"] = 0.7471100000,
        ["d"] = true,
        ["pm"] = 1559,
      },
    },
    ["n"] = "The Way of Shadow",
    ["cn"] = "Lore of Murkmire",
  },
  [5372] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7625600000,
        ["py"] = 0.7465600000,
        ["d"] = true,
        ["pm"] = 1534,
      },
    },
    ["n"] = "In Accord With Those Sun-Blessed",
    ["cn"] = "Lore of Murkmire",
  },
  [5373] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.8052900000,
        ["px"] = 0.7673300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A Grand Transformation",
    ["cn"] = "Lore of Murkmire",
  },
  [5374] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7492500000,
        ["px"] = 0.7446400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Call Beyond",
    ["cn"] = "Lore of Murkmire",
  },
  [5375] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7626100000,
        ["py"] = 0.7466800000,
        ["d"] = true,
        ["pm"] = 1534,
      },
    },
    ["n"] = "The Last Wish of the Sun-Blessed",
    ["cn"] = "Lore of Murkmire",
  },
  [5376] = {
    ["c"] = true,
    ["cn"] = "Lore and Culture",
    ["n"] = "Reman II: The Limits of Ambition",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["pm"] = 1484,
        ["py"] = 0.7639300000,
        ["px"] = 0.7117100000,
        ["r"] = true,
      },
    },
    ["m"] = {
      [34] = 1,
    },
  },
  [5377] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7536400000,
        ["py"] = 0.7470700000,
        ["d"] = true,
        ["pm"] = 1559,
      },
    },
    ["n"] = "Xul-Thuxis",
    ["cn"] = "Lore of Murkmire",
  },
  [5378] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3816700000,
        ["py"] = 0.6818000000,
        ["d"] = true,
        ["pm"] = 414,
      },
    },
    ["n"] = "Khunzar-ri and the Full Moons",
    ["cn"] = "Mysteries and Clues",
  },
  [5379] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6110900000,
        ["px"] = 0.5507800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Dragonguard Report",
    ["cn"] = "Anequina Archives",
  },
  [5380] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6312300000,
        ["px"] = 0.5323500000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Trail and Tide",
    ["cn"] = "Anequina Archives",
    ["r"] = true,
  },
  [5381] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7518700000,
        ["px"] = 0.7564000000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letter to Septimius",
    ["cn"] = "Lore of Murkmire",
  },
  [5382] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7564800000,
        ["px"] = 0.7647700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Children of the Root",
    ["cn"] = "Lore of Murkmire",
  },
  [5383] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Rahti's Orders",
    ["q"] = 6301,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6304900000,
        ["px"] = 0.5122800000,
        ["pm"] = 1555,
      },
    },
  },
  [5384] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7753100000,
        ["px"] = 0.7152400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Emperor Kastav's Epitaph",
    ["cn"] = "Lore of Murkmire",
  },
  [5385] = {
    ["c"] = true,
    ["q"] = 6302,
    ["e"] = {
      [1] = {
        ["px"] = 0.0099400000,
        ["d"] = true,
        ["py"] = 0.1467700000,
        ["pm"] = 1666,
        ["zx"] = 0.4915911915, ["zy"] = 0.6642792138, ["zm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6605700000,
        ["px"] = 0.4905800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Nikussha's Research Note 1",
    ["cn"] = "Anequina Archives",
  },
  [5387] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7954100000,
        ["px"] = 0.7663700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "A History of Lilmoth",
    ["cn"] = "Lore of Murkmire",
  },
  [5388] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7200200000,
        ["py"] = 0.7760600000,
        ["d"] = true,
        ["pm"] = 1556,
      },
    },
    ["n"] = "A History of Blackrose Prison",
    ["cn"] = "Lore of Murkmire",
  },
  [5389] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["l"] = true,
        ["pm"] = 1556,
        ["px"] = 0.7197300000,
        ["d"] = true,
        ["py"] = 0.7762000000,
      },
    },
    ["n"] = "Drakeeh the Unchained's Journal, Page 3",
    ["cn"] = "Lore of Murkmire",
  },
  [5390] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7195800000,
        ["py"] = 0.7758300000,
        ["d"] = true,
        ["pm"] = 1556,
      },
    },
    ["n"] = "Drakeeh the Unchained's Journal, Page 12",
    ["cn"] = "Lore of Murkmire",
  },
  [5391] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7198800000,
        ["py"] = 0.7756600000,
        ["d"] = true,
        ["pm"] = 1556,
      },
    },
    ["n"] = "Drakeeh the Unchained's Journal, Page 17",
    ["cn"] = "Lore of Murkmire",
  },
  [5393] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6124000000,
        ["px"] = 0.5328000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri: Origin",
    ["cn"] = "Anequina Archives",
  },
  [5394] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7653100000,
        ["px"] = 0.7127100000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "The Strangeness of Dryskins",
    ["cn"] = "Lore of Murkmire",
  },
  [5395] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Tale of the Elements",
    ["q"] = 6307,
    ["e"] = {
      [1] = { ["px"] = 0.5628791959, ["py"] = 0.6487444151, ["pm"] = 1555, },
    },
  },
  [5396] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Letter to Feina-Darak",
    ["q"] = 6307,
    ["e"] = {
      [1] = { ["px"] = 0.5623199971, ["py"] = 0.6485252129, ["pm"] = 1555, },
    },
  },
  [5397] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Tajirri's Note",
    ["q"] = 6311,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6011200000,
        ["px"] = 0.5302200000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6048000000,
        ["px"] = 0.5296400000,
        ["pm"] = 1555,
      },
    },
  },
  [5398] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Note to Tajirri",
    ["q"] = 6311,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6001800000,
        ["px"] = 0.5294200000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6010200000,
        ["px"] = 0.5303000000,
        ["pm"] = 1555,
      },
    },
  },
  [5399] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6200800000,
        ["px"] = 0.5714100000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Tahara's Traveling Menagerie",
    ["cn"] = "Anequina Archives",
  },
  [5400] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4769600000,
        ["py"] = 0.6661400000,
        ["d"] = true,
        ["pm"] = 1608,
      },
      [2] = {
        ["mn"] = 36,
        ["pm"] = 1555,
        ["px"] = 0.4786200000,
        ["i"] = 12,
        ["py"] = 0.6662100000,
      },
    },
    ["n"] = "Hadaz's Final Letter",
    ["cn"] = "Anequina Archives",
  },
  [5401] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7499200000,
        ["px"] = 0.7220200000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Letter to Faral",
    ["cn"] = "Lore of Murkmire",
  },
  [5402] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7632200000,
        ["py"] = 0.7476900000,
        ["d"] = true,
        ["pm"] = 1534,
      },
    },
    ["n"] = "Doomed Explorer's Journal",
    ["cn"] = "Lore of Murkmire",
  },
  [5403] = {
    ["c"] = true,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "Memorandum: Indrik Emergence & Formal Development",
    ["e"] = {
      [1] = { ["px"] = 0.2396108008, ["py"] = 0.7338452216, ["pm"] = 243, ["zm"] = 143, },
      [2] = {
        ["pm"] = 7,
        ["px"] = 0.7920200000,
        ["i"] = 12,
        ["py"] = 0.4378900000,
        ["mn"] = 11,
      },
      [3] = {
        ["pm"] = 1,
        ["px"] = 0.0703100000,
        ["i"] = 12,
        ["py"] = 0.3836800000,
        ["mn"] = 2,
      },
      [4] = { ["px"] = 0.7653328227, ["py"] = 0.3713444067, ["pm"] = 1060, },
      [5] = { ["px"] = 0.0712028056, ["py"] = 0.7484259990, ["pm"] = 1349, },
      [6] = { ["px"] = 0.5648115726, ["py"] = 0.6247287965, ["pm"] = 1576, },
      [7] = { ["px"] = 0.4233532128, ["py"] = 0.2180704009, ["pm"] = 1719, },
      [8] = { ["px"] = 0.6097688049, ["py"] = 0.6774216073, ["pm"] = 1940, },
      [9] = { ["px"] = 0.0709868026, ["py"] = 0.6022732052, ["pm"] = 2163, },
      [10] = { ["px"] = 0.9418575797, ["py"] = 0.3945827967, ["pm"] = 2343, },
    },
  },
  [5404] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4384091849, ["py"] = 0.6833659873, ["pm"] = 9,
      },
    },
    ["n"] = "Sealed Imperial Summons",
    ["cn"] = "Anequina Archives",
  },
  [5405] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 7,
        ["py"] = 0.6872400000,
        ["px"] = 0.4015700000,
        ["pm"] = 9,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri and the Demon: Part One",
    ["cn"] = "Tales of Tamriel",
  },
  [5406] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "M'zum's Journal",
    ["q"] = 6325,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6806400000,
        ["px"] = 0.5149700000,
        ["pm"] = 1555,
      },
    },
  },
  [5407] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7538500000,
        ["py"] = 0.7957300000,
        ["d"] = true,
        ["pm"] = 1539,
      },
      [2] = {
        ["pm"] = 1484,
        ["px"] = 0.7564600000,
        ["i"] = 12,
        ["py"] = 0.7910600000,
        ["mn"] = 34,
      },
    },
    ["n"] = "Ixtaxh Explorer's Journal, Page 1",
    ["cn"] = "Lore of Murkmire",
  },
  [5408] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.7545600000,
        ["py"] = 0.7955600000,
        ["d"] = true,
        ["pm"] = 1539,
      },
      [2] = {
        ["mn"] = 34,
        ["py"] = 0.7910900000,
        ["px"] = 0.7565300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Ixtaxh Explorer's Journal, Page 2",
    ["cn"] = "Lore of Murkmire",
  },
  [5409] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7908000000,
        ["px"] = 0.7560300000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Ixtaxh Explorer's Journal, Page 3",
    ["cn"] = "Lore of Murkmire",
  },
  [5410] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7912600000,
        ["px"] = 0.7560400000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Ixtaxh Explorer's Journal, Page 4",
    ["cn"] = "Lore of Murkmire",
  },
  [5411] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7927600000,
        ["px"] = 0.7690700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Famia Mercius's Journal, Part 1",
    ["cn"] = "Lore of Murkmire",
  },
  [5412] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7707800000,
        ["px"] = 0.7315100000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Famia Mercius's Journal, Part 2",
    ["cn"] = "Lore of Murkmire",
  },
  [5413] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 34,
        ["py"] = 0.7450500000,
        ["px"] = 0.7618700000,
        ["pm"] = 1484,
      },
    },
    ["n"] = "Famia Mercius's Journal, Part 3",
    ["cn"] = "Lore of Murkmire",
  },
  [5414] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5028600000,
        ["d"] = true,
        ["py"] = 0.7705300000,
        ["pm"] = 1602,
      },
      [2] = {
        ["px"] = 0.4383923873, ["py"] = 0.6832071889, ["pm"] = 9,
      },
      [3] = {
        ["px"] = 0.5043676033, ["py"] = 0.7606232122, ["pm"] = 1601, ["d"] = true,
      },
    },
    ["n"] = "Jode's Blessing",
    ["cn"] = "Mysteries and Clues",
  },
  [5415] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4384163886, ["py"] = 0.6831231885, ["pm"] = 9,
      },
      [2] = {
        ["px"] = 0.5029000000,
        ["d"] = true,
        ["py"] = 0.7705300000,
        ["pm"] = 1602,
      },
      [3] = {
        ["px"] = 0.5044176033, ["py"] = 0.7606244121, ["pm"] = 1601, ["d"] = true,
      },
    },
    ["n"] = "Jone's Blessing",
    ["cn"] = "Mysteries and Clues",
  },
  [5416] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5021700000,
        ["d"] = true,
        ["py"] = 0.7706100000,
        ["pm"] = 1602,
      },
      [2] = {
        ["px"] = 0.4384423845, ["py"] = 0.6832467886, ["pm"] = 9,
      },
      [3] = {
        ["px"] = 0.5036864032, ["py"] = 0.7607080122, ["pm"] = 1589, ["d"] = true,
      },
    },
    ["n"] = "Slivers in a Dark Sky",
    ["cn"] = "Mysteries and Clues",
  },
  [5417] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6779800000,
        ["px"] = 0.5092400000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6750500000,
        ["px"] = 0.5176100000,
        ["pm"] = 1555,
      },
      [3] = {
        ["mn"] = 36,
        ["py"] = 0.6659200000,
        ["px"] = 0.5113500000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Help Wanted: Merryvale!",
    ["cn"] = "Anequina Archives",
  },
  [5418] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 8,
        ["py"] = 0.6000000000,
        ["px"] = 0.4083900000,
        ["pm"] = 22,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri and the Demon: Part Two",
    ["cn"] = "Tales of Tamriel",
  },
  [5419] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Beast Acquisitions Log",
    ["q"] = 6301,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6349400000,
        ["px"] = 0.5032400000,
        ["pm"] = 1555,
      },
    },
  },
  [5420] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 17,
        ["py"] = 0.6156400000,
        ["px"] = 0.4533400000,
        ["pm"] = 256,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri and the Demon: Part Three",
    ["cn"] = "Tales of Tamriel",
  },
  [5421] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6150200000,
        ["px"] = 0.5523000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Captain Saulinia's Instructions",
    ["cn"] = "Anequina Archives",
  },
  [5422] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4005500000,
        ["py"] = 0.5967400000,
        ["d"] = true,
        ["pm"] = 199,
      },
    },
    ["n"] = "Khunzar-ri and the Dark Moons",
    ["cn"] = "Mysteries and Clues",
  },
  [5423] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4743200000,
        ["py"] = 0.5974800000,
        ["d"] = true,
        ["pm"] = 304,
      },
    },
    ["n"] = "Khunzar-ri and — — Moons",
    ["cn"] = "Mysteries and Clues",
  },
  [5425] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Malizaz's Journal",
    ["q"] = 6321,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6310800000,
        ["px"] = 0.5326500000,
        ["pm"] = 1555,
      },
    },
  },
  [5426] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6122700000,
        ["px"] = 0.5329000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Ancient Gravestone",
    ["cn"] = "Anequina Archives",
  },
  [5427] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Morgane's Guild Orders",
    ["q"] = 6337,
    ["e"] = {
      [1] = {
        ["px"] = 0.6906916137, ["py"] = 0.6728516024, ["pm"] = 2057,
        ["zx"] = 0.6898331999, ["zy"] = 0.6726372083, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [5428] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Through the Weeping Scar",
    ["q"] = 6316,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6495800000,
        ["px"] = 0.5391500000,
        ["pm"] = 1555,
      },
    },
  },
  [5430] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6033900000,
        ["px"] = 0.5295000000,
        ["pm"] = 1555,
      },
      [2] = {
        ["pm"] = 1618,
        ["i"] = 12,
        ["px"] = 0.5015700000,
        ["d"] = true,
        ["py"] = 0.6116100000,
      },
    },
    ["n"] = "Letter from Abnur Tharn",
    ["cn"] = "Anequina Archives",
  },
  [5431] = {
    ["c"] = true,
    ["q"] = 6304,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6373500000,
        ["px"] = 0.5551800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Aneshi's Note",
    ["cn"] = "Anequina Archives",
  },
  [5434] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5773900000,
        ["py"] = 0.6169400000,
        ["d"] = true,
        ["pm"] = 1571,
      },
      [2] = { ["px"] = 0.5751564291, ["py"] = 0.6158020031, ["pm"] = 1570, ["fp"] = true, },
      [3] = {
        ["px"] = 0.5746867723, ["py"] = 0.6156503957, ["pm"] = 1576, ["zm"] = 1555, ["fp"] = true,
      },
    },
    ["n"] = "King Hemakar's Grave",
    ["cn"] = "Anequina Archives",
  },
  [5435] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6241200000,
        ["px"] = 0.5672000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6201900000,
        ["px"] = 0.5710800000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Elsweyr Needs You!",
    ["cn"] = "Anequina Archives",
  },
  [5436] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4820852143, ["py"] = 0.7123675988, ["pm"] = 1698, ["d"] = true,
        ["zx"] = 0.4813839909, ["zy"] = 0.6878436147, ["zm"] = 1555,
      },
    },
    ["n"] = "Nisaazda's Journal",
    ["cn"] = "Library of Incunabula",
  },
  [5437] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4789219897, ["py"] = 0.7125920193, ["pm"] = 1699, ["d"] = true,
        ["zx"] = 0.4813839909, ["zy"] = 0.6878436147, ["zm"] = 1555,
      },
    },
    ["n"] = "Enough Kitten Play!",
    ["cn"] = "Library of Incunabula",
  },
  [5438] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4783519937, ["py"] = 0.7080648290, ["pm"] = 1697, ["d"] = true,
        ["zx"] = 0.4813839909, ["zy"] = 0.6878436147, ["zm"] = 1555,
      },
    },
    ["n"] = "Burnt Scripture",
    ["cn"] = "Library of Incunabula",
  },
  [5439] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4819216143, ["py"] = 0.7140299988, ["pm"] = 1698, ["d"] = true,
        ["zx"] = 0.4813839909, ["zy"] = 0.6878436147, ["zm"] = 1555,
      },
    },
    ["n"] = "Leave the Dragons Where they Lie",
    ["cn"] = "Library of Incunabula",
  },
  [5443] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Observations on the Changeling",
    ["e"] = {
      [1] = { ["px"] = 0.4641215892, ["py"] = 0.7177508019, ["pm"] = 1720, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5444] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Observations on Tenmar Valley",
    ["e"] = {
      [1] = { ["px"] = 0.4628479968, ["py"] = 0.7181951848, ["pm"] = 1717, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5445] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "No! No! No!",
    ["e"] = {
      [1] = { ["px"] = 0.4628199968, ["py"] = 0.7180915848, ["pm"] = 1717, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5446] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Maarselok Reconnaissance Log One",
    ["e"] = {
      [1] = { ["px"] = 0.4631011968, ["py"] = 0.7183359848, ["pm"] = 1717, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5447] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Maarselok Reconnaissance Log Two",
    ["e"] = {
      [1] = { ["px"] = 0.4639599892, ["py"] = 0.7181180019, ["pm"] = 1720, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5448] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Maarselok Reconnaissance Log Three",
    ["e"] = {
      [1] = { ["px"] = 0.4646212131, ["py"] = 0.7183508000, ["pm"] = 1718, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5449] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Maarselok Reconnaissance Log Four",
    ["e"] = {
      [1] = { ["px"] = 0.4637703969, ["py"] = 0.7191611892, ["pm"] = 1722, ["d"] = true, ["zx"] = 0.4610535870, ["zy"] = 0.7205431876, ["zm"] = 9, },
    },
  },
  [5450] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5083984238, ["py"] = 0.6902691936, ["pm"] = 1655, ["d"] = true,
        ["zx"] = 0.5059035903, ["zy"] = 0.6855072111, ["zm"] = 1555,
      },
    },
    ["n"] = "Letter to Bakul",
    ["cn"] = "Anequina Archives",
  },
  [5451] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["py"] = 0.6887600000,
        ["zt"] = 1121,
        ["px"] = 0.5067000000,
        ["zx"] = 0.5059035903, ["zy"] = 0.6855072111, ["zm"] = 1555,
      },
    },
    ["n"] = "Mojha is a Fool",
    ["cn"] = "Anequina Archives",
  },
  [5452] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5052635970, ["py"] = 0.6904428303, ["pm"] = 1657, ["d"] = true,
        ["zx"] = 0.5059035903, ["zy"] = 0.6855072111, ["zm"] = 1555,
      },
    },
    ["n"] = "A Window for Escape",
    ["cn"] = "Anequina Archives",
  },
  [5453] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5069304028, ["py"] = 0.6878519752, ["pm"] = 1650, ["d"] = true,
        ["zx"] = 0.5059035903, ["zy"] = 0.6855072111, ["zm"] = 1555,
      },
    },
    ["n"] = "The Blessings of Jone and Jode",
    ["cn"] = "Anequina Archives",
  },
  [5454] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5069860028, ["py"] = 0.6876431752, ["pm"] = 1650, ["d"] = true,
        ["zx"] = 0.5059035903, ["zy"] = 0.6855072111, ["zm"] = 1555,
      },
    },
    ["n"] = "Azin-jo's Journal",
    ["cn"] = "Anequina Archives",
  },
  [5457] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6870800000,
        ["px"] = 0.4771200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Visit the House of Histories!",
    ["cn"] = "Anequina Archives",
  },
  [5458] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "The Thief's Riddle",
    ["q"] = 6319,
    ["e"] = {
      [1] = { ["px"] = 0.5268635982, ["py"] = 0.6014028031, ["pm"] = 1591, ["zm"] = 1555, },
    },
  },
  [5459] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Tajirri's Journal",
    ["q"] = 6311,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6000200000,
        ["px"] = 0.5295200000,
        ["pm"] = 1555,
      },
    },
  },
  [5460] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Crumpled Nursery Rhyme",
    ["q"] = 6303,
    ["e"] = {
      [1] = { ["px"] = 0.5684007940, ["py"] = 0.6407548144, ["pm"] = 1555, },
    },
  },
  [5461] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5454200000,
        ["py"] = 0.6111700000,
        ["d"] = true,
        ["pm"] = 1590,
      },
    },
    ["n"] = "On Akaviri Burial Rites",
    ["cn"] = "Anequina Archives",
  },
  [5462] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6485400000,
        ["px"] = 0.5264200000,
        ["pm"] = 1638,
      },
    },
    ["n"] = "Mathoc the Immortal",
    ["cn"] = "Anequina Archives",
  },
  [5463] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6474500000,
        ["px"] = 0.5626200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "The Proving Festival",
    ["cn"] = "Anequina Archives",
  },
  [5464] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5021200000,
        ["d"] = true,
        ["py"] = 0.7703100000,
        ["pm"] = 1602,
      },
      [2] = {
        ["px"] = 0.4386803863, ["py"] = 0.6831999873, ["pm"] = 9,
      },
    },
    ["n"] = "Letter from Queen Euraxia",
    ["cn"] = "Military Orders and Reports",
  },
  [5465] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4368987850, ["py"] = 0.6847023882, ["pm"] = 9,
      },
    },
    ["n"] = "Khunzar-ri and the Demons",
    ["cn"] = "Tales of Tamriel",
  },
  [5466] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6485400000,
        ["px"] = 0.5265100000,
        ["pm"] = 1638,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6492900000,
        ["px"] = 0.5236200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "First Signs of the Flu",
    ["cn"] = "Anequina Archives",
  },
  [5467] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6492300000,
        ["px"] = 0.5236500000,
        ["pm"] = 1555,
      },
      [2] = {
        ["py"] = 0.6487700000,
        ["px"] = 0.5273800000,
        ["pm"] = 1638,
      },
    },
    ["n"] = "Flu Victim's Note",
    ["cn"] = "Anequina Archives",
  },
  [5468] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6485600000,
        ["px"] = 0.5275500000,
        ["pm"] = 1638,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6493400000,
        ["px"] = 0.5236000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Letter to Peryite",
    ["cn"] = "Anequina Archives",
  },
  [5469] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Dragons: A Report for the Queen",
    ["cn"] = "Anequina Archives",
  },
  [5470] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5768027728, ["py"] = 0.6169275961, ["pm"] = 1576, ["zm"] = 1555, },
    },
    ["n"] = "Captain's Letter",
    ["cn"] = "Anequina Archives",
  },
  [5471] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Euraxia's Personal Journal",
    ["cn"] = "Anequina Archives",
  },
  [5472] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Marzula-jo's Notes",
    ["q"] = 6326,
    ["e"] = {
      [1] = {
        ["px"] = 0.5111900000,
        ["py"] = 0.6103400000,
        ["d"] = true,
        ["pm"] = 1595,
        ["zy"] = 0.6105200000, ["zx"] = 0.5155200000, ["zm"] = 1555,
      },
    },
  },
  [5473] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6127900000,
        ["px"] = 0.5501300000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Letter for Vittoria",
    ["cn"] = "Anequina Archives",
  },
  [5474] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Picking up the Pieces",
    ["e"] = {
      [1] = { ["px"] = 0.5978143741, ["py"] = 0.2824296052, ["pm"] = 1607, ["d"] = true, ["zx"] = 0.5992216243, ["zy"] = 0.2840387986, ["zm"] = 61, },
      [2] = { ["px"] = 0.3018119956, ["py"] = 0.5636508075, ["pm"] = 1596, ["d"] = true, ["zx"] = 0.3030780139, ["zy"] = 0.5632388122, ["zm"] = 1006, },
    },
  },
  [5475] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "In Pursuit of Mhuvnak",
    ["e"] = {
      [1] = { ["px"] = 0.5986928287, ["py"] = 0.2824387952, ["pm"] = 1604, ["d"] = true, ["zx"] = 0.5992216243, ["zy"] = 0.2840387986, ["zm"] = 61, },
    },
  },
  [5476] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Skeevaton Modification and Operation",
    ["e"] = {
      [1] = { ["px"] = 0.5986616287, ["py"] = 0.2823831952, ["pm"] = 1604, ["d"] = true, ["zx"] = 0.5992216243, ["zy"] = 0.2840387986, ["zm"] = 61, },
    },
  },
  [5477] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Burr's Writing Practice",
    ["e"] = {
      [1] = { ["px"] = 0.5978043741, ["py"] = 0.2824160052, ["pm"] = 1607, ["d"] = true, ["zx"] = 0.5992216243, ["zy"] = 0.2840387986, ["zm"] = 61, },
    },
  },
  [5478] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6200800000,
        ["px"] = 0.5140000000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6528500000,
        ["px"] = 0.5083800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Melleron's Journal",
    ["cn"] = "Anequina Archives",
  },
  [5479] = {
    ["c"] = true,
    ["q"] = 6365,
    ["e"] = {
      [1] = {
        ["px"] = 0.5753000000,
        ["py"] = 0.6160300000,
        ["d"] = true,
        ["pm"] = 1570,
      },
      [2] = {
        ["px"] = 0.5746867723, ["py"] = 0.6156503957, ["pm"] = 1576, ["zm"] = 1555, ["fp"] = true,
      },
      [3] = {
        ["mn"] = 36,
        ["py"] = 0.6543800000,
        ["px"] = 0.5130900000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Letter to Jakarn",
    ["cn"] = "Anequina Archives",
  },
  [5480] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032400000,
        ["py"] = 0.6608900000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Dread Their Return and Prepare",
    ["cn"] = "Anequina Archives",
  },
  [5481] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032400000,
        ["py"] = 0.6609300000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Fear the Foe, Heed the Teacher",
    ["cn"] = "Anequina Archives",
  },
  [5482] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032400000,
        ["py"] = 0.6609800000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "War, Hunt, Deliverance",
    ["cn"] = "Anequina Archives",
  },
  [5483] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032100000,
        ["py"] = 0.6610200000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Gifts of Death and Fear",
    ["cn"] = "Anequina Archives",
  },
  [5484] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5031800000,
        ["py"] = 0.6609600000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "To Wear Dread Mantle",
    ["cn"] = "Anequina Archives",
  },
  [5485] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5033000000,
        ["py"] = 0.6608600000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "For the Old of Akavir",
    ["cn"] = "Anequina Archives",
  },
  [5487] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032500000,
        ["py"] = 0.6609300000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Gone from Sainted Memory",
    ["cn"] = "Anequina Archives",
  },
  [5488] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032400000,
        ["py"] = 0.6609500000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Devastation is the Scream",
    ["cn"] = "Anequina Archives",
  },
  [5489] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032500000,
        ["py"] = 0.6609600000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Journey to Endings",
    ["cn"] = "Anequina Archives",
  },
  [5490] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032100000,
        ["py"] = 0.6610300000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Faith in Dust and Stone",
    ["cn"] = "Anequina Archives",
  },
  [5491] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5032000000,
        ["py"] = 0.6610100000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Kingdoms Fall People Wander",
    ["cn"] = "Anequina Archives",
  },
  [5492] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5031900000,
        ["py"] = 0.6610200000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "Fight As Prey",
    ["cn"] = "Anequina Archives",
  },
  [5493] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5031900000,
        ["py"] = 0.6609700000,
        ["d"] = true,
        ["pm"] = 1587,
        ["zx"] = 0.5032959910, ["zy"] = 0.6595712117, ["zm"] = 1555,
      },
    },
    ["n"] = "In Death is the Promise",
    ["cn"] = "Anequina Archives",
  },
  [5494] = {
    ["c"] = true,
    ["q"] = 6302,
    ["e"] = {
      [1] = {
        ["px"] = 0.0049900000,
        ["d"] = true,
        ["py"] = 0.1479800000,
        ["pm"] = 1666,
        ["zx"] = 0.4915911915, ["zy"] = 0.6642792138, ["zm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6606400000,
        ["px"] = 0.4905200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Nikussha's Research Note 2",
    ["cn"] = "Anequina Archives",
  },
  [5495] = {
    ["c"] = true,
    ["q"] = 6302,
    ["e"] = {
      [1] = {
        ["px"] = 0.0127176101,
        ["d"] = true,
        ["py"] = 0.1548276107,
        ["pm"] = 1666,
        ["zx"] = 0.4915911915, ["zy"] = 0.6642792138, ["zm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6609700000,
        ["px"] = 0.4906000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Nikussha's Research Note 3",
    ["cn"] = "Anequina Archives",
  },
  [5497] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6403500000,
        ["px"] = 0.4960500000,
        ["pm"] = 1616,
      },
    },
    ["n"] = "Unsent Letter to Zazazrala",
    ["cn"] = "Anequina Archives",
  },
  [5499] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6789400000,
        ["px"] = 0.4804900000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Reward for Stolen Wine",
    ["cn"] = "Anequina Archives",
  },
  [5500] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "The Tale of Three Moons",
    ["q"] = 6322,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6365600000,
        ["px"] = 0.5311100000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6282500000,
        ["px"] = 0.5326000000,
        ["pm"] = 1555,
      },
    },
  },
  [5501] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6290600000,
        ["px"] = 0.5325800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Stone of Commitment",
    ["cn"] = "Anequina Archives",
  },
  [5502] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6286500000,
        ["px"] = 0.5344700000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Stone of Atonement",
    ["cn"] = "Anequina Archives",
  },
  [5503] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6283500000,
        ["px"] = 0.5317000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Stone of Banishment",
    ["cn"] = "Anequina Archives",
  },
  [5505] = {
    ["c"] = true,
    ["cn"] = "Anequina Archives",
    ["n"] = "Discarded Orders",
    ["q"] = 6336,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.5987700000,
        ["px"] = 0.5211600000,
        ["pm"] = 1555,
      },
      [2] = {
        ["mn"] = 36,
        ["py"] = 0.6040000000,
        ["px"] = 0.5292300000,
        ["pm"] = 1555,
      },
    },
  },
  [5506] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5265607982, ["py"] = 0.6011480034, ["pm"] = 1591, ["zm"] = 1555, },
    },
    ["n"] = "The Sixteen Kingdoms",
    ["cn"] = "Anequina Archives",
  },
  [5589] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5480600000,
        ["py"] = 0.6641700000,
        ["d"] = true,
        ["pm"] = 1626,
        ["zx"] = 0.5468095930, ["zy"] = 0.6632748134, ["zm"] = 1555,
      },
    },
    ["n"] = "The Ruddy Fangs",
    ["cn"] = "Anequina Archives",
  },
  [5590] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5129152219, ["py"] = 0.6542368022, ["pm"] = 1663, ["zm"] = 1555, },
    },
    ["n"] = "On Those Who Know Baan Dar",
    ["cn"] = "Anequina Archives",
  },
  [5591] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6486700000,
        ["px"] = 0.5263700000,
        ["pm"] = 1638,
      },
    },
    ["n"] = "Shazah's Diary",
    ["cn"] = "Anequina Archives",
  },
  [5592] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5583896285, ["py"] = 0.6331740012, ["pm"] = 1639, ["zx"] = 0.5584547921, ["zy"] = 0.6335848122, ["zm"] = 1555, },
    },
    ["n"] = "On the Trail of the Forgotten Mane",
    ["cn"] = "Anequina Archives",
  },
  [5593] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5483931951, ["py"] = 0.6307364143, ["pm"] = 1555,
      },
    },
    ["n"] = "Senche-rahts: Not Just Mounts",
    ["cn"] = "Anequina Archives",
  },
  [5594] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6595200000,
        ["px"] = 0.5269400000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "A Sacrament Remains",
    ["cn"] = "Anequina Archives",
  },
  [5595] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6365100000,
        ["px"] = 0.5620800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Anequina and Pellitine: An Introduction",
    ["cn"] = "Anequina Archives",
  },
  [5596] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5167547946, ["py"] = 0.6770832135, ["pm"] = 1555, },
    },
    ["n"] = "Moon-Sugar: A Report",
    ["cn"] = "Anequina Archives",
  },
  [5597] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6171900000,
        ["px"] = 0.5768000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "Necromancers: A Report for the Queen",
    ["cn"] = "Anequina Archives",
  },
  [5598] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6289500000,
        ["px"] = 0.5186200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Terror-Birds: Up Close and Personal",
    ["cn"] = "Anequina Archives",
  },
  [5599] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6704300000,
        ["px"] = 0.5152400000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Sweet Moon-Sugar Cane",
    ["cn"] = "Anequina Archives",
  },
  [5600] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5430463973, ["py"] = 0.6781888114, ["pm"] = 1555, },
    },
    ["n"] = "The Furstock Song",
    ["cn"] = "Anequina Archives",
  },
  [5601] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6008700000,
        ["px"] = 0.5311700000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Dancing Among the Flowers Fine",
    ["cn"] = "Anequina Archives",
  },
  [5602] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6191100000,
        ["px"] = 0.5701700000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "A Cat's Serenade",
    ["cn"] = "Anequina Archives",
  },
  [5603] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6550500000,
        ["px"] = 0.5107000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "What's Yours is Mine (A Little Larceny)",
    ["cn"] = "Anequina Archives",
  },
  [5604] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6624000000,
        ["px"] = 0.4901900000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "The Song of Khunzar-ri",
    ["cn"] = "Anequina Archives",
  },
  [5605] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6502600000,
        ["px"] = 0.5345200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Val Vijah Va Rhook, Baandari",
    ["cn"] = "Anequina Archives",
  },
  [5606] = {
    ["c"] = false,
    ["cn"] = "Anequina Archives",
    ["n"] = "Riddles of the Rithana-di-Renada",
    ["q"] = 6319,
    ["e"] = {
    },
  },
  [5607] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6473600000,
        ["px"] = 0.5644400000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Clever Kail-Perwa and the Great Boast, Volume 1",
    ["cn"] = "Anequina Archives",
  },
  [5608] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6166100000,
        ["px"] = 0.5706000000,
        ["pm"] = 1576,
        ["zm"] = 1555,
      },
    },
    ["n"] = "The Tonenaka Shrine",
    ["cn"] = "Anequina Archives",
  },
  [5609] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5141343912, ["py"] = 0.6753764160, ["pm"] = 1555, },
    },
    ["n"] = "Clever Kail-Perwa and the Great Boast, Volume 2",
    ["cn"] = "Anequina Archives",
  },
  [5610] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6535600000,
        ["px"] = 0.5120300000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Clever Kail-Perwa and the Great Boast, Volume 3",
    ["cn"] = "Anequina Archives",
    ["r"] = true,
  },
  [5611] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4767743922, ["py"] = 0.6861284136, ["pm"] = 1555, },
    },
    ["n"] = "Clever Kail-Perwa and the Great Boast, Volume 4",
    ["cn"] = "Anequina Archives",
  },
  [5612] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6196200000,
        ["px"] = 0.5281900000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "One Dragon Two Dragon",
    ["cn"] = "Anequina Archives",
  },
  [5613] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5491000000,
        ["py"] = 0.6479800000,
        ["d"] = true,
        ["pm"] = 1593,
        ["zx"] = 0.5489683893, ["zy"] = 0.6480624138, ["zm"] = 1555,
      },
    },
    ["n"] = "Chronicles of Juha-ri, Chapter 1",
    ["cn"] = "Anequina Archives",
  },
  [5614] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5492000000,
        ["py"] = 0.6481600000,
        ["d"] = true,
        ["pm"] = 1593,
        ["zx"] = 0.5489683893, ["zy"] = 0.6480624138, ["zm"] = 1555,
      },
    },
    ["n"] = "Chronicles of Juha-ri, Chapter 2",
    ["cn"] = "Anequina Archives",
  },
  [5615] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5492500000,
        ["py"] = 0.6481100000,
        ["d"] = true,
        ["pm"] = 1593,
        ["zx"] = 0.5489683893, ["zy"] = 0.6480624138, ["zm"] = 1555,
      },
    },
    ["n"] = "Chronicles of Juha-ri, Chapter 3",
    ["cn"] = "Anequina Archives",
  },
  [5616] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5489500000,
        ["py"] = 0.6479800000,
        ["d"] = true,
        ["pm"] = 1593,
        ["zx"] = 0.5489683893, ["zy"] = 0.6480624138, ["zm"] = 1555,
      },
    },
    ["n"] = "Anonymous Torn Journal",
    ["cn"] = "Anequina Archives",
  },
  [5617] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5492900000,
        ["py"] = 0.6480400000,
        ["d"] = true,
        ["pm"] = 1593,
        ["zx"] = 0.5489683893, ["zy"] = 0.6480624138, ["zm"] = 1555,
      },
    },
    ["n"] = "To Jun-Jo the Empty Fang",
    ["cn"] = "Anequina Archives",
  },
  [5618] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6022100000,
        ["px"] = 0.5284200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "The Angry Alfiq: A Collection",
    ["cn"] = "Anequina Archives",
  },
  [5619] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6159500000,
        ["px"] = 0.5156200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "A Dragonhorn! Oh, Dragonhorn!",
    ["cn"] = "Anequina Archives",
  },
  [5620] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6377100000,
        ["px"] = 0.5557800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri Sayings, Verse One",
    ["cn"] = "Anequina Archives",
  },
  [5621] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6375900000,
        ["px"] = 0.5557200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khnuzar-ri Sayings, Verse Two",
    ["cn"] = "Anequina Archives",
  },
  [5622] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6377900000,
        ["px"] = 0.5559000000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri Sayings, Verse Three",
    ["cn"] = "Anequina Archives",
  },
  [5623] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6378200000,
        ["px"] = 0.5557800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri Sayings, Verse Four",
    ["cn"] = "Anequina Archives",
  },
  [5624] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6829400000,
        ["px"] = 0.4800800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Origins of the Khajiiti Martial Tradition",
    ["cn"] = "Anequina Archives",
    ["r"] = true,
  },
  [5625] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5679911726, ["py"] = 0.6222967961, ["pm"] = 1576, ["zm"] = 1555, },
      [2] = { ["px"] = 0.2124660022, ["py"] = 0.3371328072, ["pm"] = 33, ["zm"] = 12, },
    },
    ["n"] = "Adventurer's Almanac, 3rd Edition",
    ["cn"] = "Adventurer's Almanac",
  },
  [5626] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6367100000,
        ["px"] = 0.5621100000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Guide to Northern Elsweyr",
    ["cn"] = "Anequina Archives",
  },
  [5627] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6827000000,
        ["px"] = 0.4994200000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri: Tales, One",
    ["cn"] = "Anequina Archives",
  },
  [5628] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6138700000,
        ["px"] = 0.5525500000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Wisdom of the Flying Gods",
    ["cn"] = "Anequina Archives",
  },
  [5630] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6375800000,
        ["px"] = 0.5614500000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Anequina Animal Identification and Tasting",
    ["cn"] = "Anequina Archives",
  },
  [5632] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6264200000,
        ["px"] = 0.5714600000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Khunzar-ri: Tales, Two",
    ["cn"] = "Anequina Archives",
  },
  [5633] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5120700000,
        ["py"] = 0.6096100000,
        ["d"] = true,
        ["pm"] = 1595,
        ["zy"] = 0.6105200000, ["zx"] = 0.5155200000, ["zm"] = 1555,
      },
    },
    ["n"] = "Praise to Mafala!",
    ["cn"] = "Anequina Archives",
  },
  [5634] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Kasura's Notes",
    ["q"] = 6395,
    ["e"] = {
      [1] = { ["px"] = 0.2308700000, ["py"] = 0.7380600000, ["pm"] = 243, ["zm"] = 143, },
      [2] = {
        ["mn"] = 2,
        ["pm"] = 1,
        ["px"] = 0.0615200000,
        ["i"] = 12,
        ["py"] = 0.3810500000,
      },
      [3] = {
        ["px"] = 0.7821459994, ["py"] = 0.4309260085, ["pm"] = 24, ["zm"] = 7,
      },
    },
  },
  [5635] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6402500000,
        ["px"] = 0.5150400000,
        ["pm"] = 1673,
      },
    },
    ["n"] = "Shomae's Journal",
    ["cn"] = "Anequina Archives",
  },
  [5636] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4771500000,
        ["py"] = 0.6656500000,
        ["d"] = true,
        ["pm"] = 1608,
      },
    },
    ["n"] = "Khadabi's Rules",
    ["cn"] = "Anequina Archives",
  },
  [5637] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2247728014, ["py"] = 0.4122728142, ["pm"] = 1703, ["d"] = true,
      },
    },
    ["n"] = "Grandmaster Ghelin-Brol (1E 2703 - 2734)",
    ["cn"] = "Mysteries and Clues",
  },
  [5638] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2250764014, ["py"] = 0.4121424142, ["pm"] = 1703, ["d"] = true,
      },
    },
    ["n"] = "Grandmaster Vashu-Pir (1E 2734 - 2758)",
    ["cn"] = "Mysteries and Clues",
  },
  [5639] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2247704014, ["py"] = 0.4121436142, ["pm"] = 1703, ["d"] = true,
      },
    },
    ["n"] = "Grandmaster Jaiv-Yora (1E 2808 -  2835)",
    ["cn"] = "Mysteries and Clues",
  },
  [5640] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2250800014, ["py"] = 0.4122668142, ["pm"] = 1703, ["d"] = true,
      },
    },
    ["n"] = "Grandmaster Ettiene Volusus (1E 2879 - 2902)",
    ["cn"] = "Mysteries and Clues",
  },
  [5645] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1184400000,
        ["zt"] = 1142,
        ["px"] = -0.1185900000,
      },
      [2] = {
        ["px"] = 0.2245600014, ["py"] = 0.4119720142, ["pm"] = 1703, ["d"] = true,
      },
    },
    ["n"] = "Searching for the Horn of Ja'darri, Part 1",
    ["cn"] = "Mysteries and Clues",
  },
  [5650] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.2423984010, ["py"] = 0.3221732051, ["pm"] = 1704, ["d"] = true,
        ["zx"] = 0.2420740048, ["zy"] = 0.3224412057, ["zm"] = 12,
      },
      [2] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1184700000,
        ["zt"] = 1142,
        ["px"] = -0.1185900000,
      },
    },
    ["n"] = "Searching for the Horn of Ja'darri, Part 2",
    ["cn"] = "Mysteries and Clues",
  },
  [5655] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Letter to Marillan",
    ["q"] = 6395,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1181900000,
        ["zt"] = 1142,
        ["px"] = -0.1186600000,
      },
      [2] = {
        ["pm"] = 1705,
        ["px"] = 0.6408800000,
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.2879500000,
      },
    },
  },
  [5656] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1705,
        ["px"] = 0.6408900000,
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.2889100000,
      },
    },
    ["n"] = "Searching for the Horn of Ja'darri, Part 3",
    ["cn"] = "Mysteries and Clues",
  },
  [5658] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6485300000,
        ["px"] = 0.5270800000,
        ["pm"] = 1638,
      },
    },
    ["n"] = "Noordigloop the Clog",
    ["cn"] = "Anequina Archives",
  },
  [5660] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5106447704, ["py"] = 0.7725771756, ["pm"] = 1676, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "Restored Tablet",
    ["cn"] = "Pellitine Postings",
  },
  [5661] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5175000000,
        ["py"] = 0.7309300000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Colorful Khajiit",
    ["cn"] = "Pellitine Postings",
  },
  [5662] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6017000000,
        ["px"] = 0.5294600000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "The Frostfall Coup",
    ["cn"] = "Anequina Archives",
  },
  [5663] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 36,
        ["py"] = 0.6033200000,
        ["px"] = 0.5294800000,
        ["pm"] = 1555,
      },
    },
    ["n"] = "Euraxian Necromancers",
    ["cn"] = "Anequina Archives",
  },
  [5664] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Mantra of Redemption",
    ["q"] = 6396,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5199300000,
        ["i"] = 12,
        ["py"] = 0.7305500000,
      },
    },
  },
  [5665] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Letter to Shirnama",
    ["q"] = 6399,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5664500000,
        ["py"] = 0.7566900000,
        ["i"] = 12,
      },
    },
  },
  [5666] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5485500000,
        ["py"] = 0.7194100000,
        ["i"] = 12,
      },
    },
    ["n"] = 6403,
    ["cn"] = "Pellitine Postings",
  },
  [5667] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5414000000,
        ["py"] = 0.7198600000,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter from Clan Mother Tadali",
    ["cn"] = "Pellitine Postings",
  },
  [5668] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Final Letter of Sergeant Berarah",
    ["q"] = 6398,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1183800000,
        ["zt"] = 1142,
        ["px"] = -0.1190500000,
      },
      [2] = {
        ["px"] = 0.4752624005, ["py"] = 0.7017471805, ["pm"] = 1708,
      },
    },
  },
  [5670] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5679911726, ["py"] = 0.6222967961, ["pm"] = 1576, ["zm"] = 1555, },
    },
    ["n"] = "Cat Food",
    ["cn"] = "Anequina Archives",
  },
  [5671] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5525400000,
        ["py"] = 0.7368700000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Many Threads",
    ["cn"] = "Pellitine Postings",
  },
  [5672] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5525400000,
        ["py"] = 0.7363700000,
        ["i"] = 12,
      },
    },
    ["n"] = "Nishzo's Journal",
    ["cn"] = "Pellitine Postings",
  },
  [5674] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5654100000,
        ["py"] = 0.7134800000,
        ["i"] = 12,
      },
    },
    ["n"] = "Song of Alkosh's Champion",
    ["cn"] = "Pellitine Postings",
  },
  [5676] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Singed Lady G Note",
    ["q"] = 6408,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5426500000,
        ["py"] = 0.7645300000,
        ["i"] = 12,
      },
    },
  },
  [5678] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Invitation to the Hunt",
    ["q"] = 6408,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5578500000,
        ["py"] = 0.7563000000,
        ["i"] = 12,
      },
    },
  },
  [5680] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = -0.1236183974, ["py"] = 0.1095503990, ["pm"] = 1706, ["d"] = true, },
    },
    ["n"] = "Enzamir's Note",
    ["cn"] = "Mysteries and Clues",
  },
  [5682] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3016552103, ["py"] = 0.1959891990, ["pm"] = 1737, ["d"] = true,
        ["zx"] = 0.3023663937, ["zy"] = 0.1991448016, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to the Icereach Coven",
    ["cn"] = "Library of Incunabula",
  },
  [5683] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3026360010, ["py"] = 0.1963171996, ["pm"] = 1736, ["d"] = true,
        ["zx"] = 0.3023663937, ["zy"] = 0.1991448016, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to Mother Ciannait",
    ["cn"] = "Library of Incunabula",
  },
  [5684] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3022140009, ["py"] = 0.1970883996, ["pm"] = 1736, ["d"] = true,
        ["zx"] = 0.3023663937, ["zy"] = 0.1991448016, ["zm"] = 667,
      },
    },
    ["n"] = "Letter to Haeralf",
    ["cn"] = "Library of Incunabula",
  },
  [5689] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3082935894, ["py"] = 0.3708499949, ["pm"] = 1796, ["d"] = true,
        ["zx"] = 0.3100392088, ["zy"] = 0.3695339964, ["zm"] = 20,
      },
    },
    ["n"] = "Ondagore's Journal",
    ["cn"] = "Library of Incunabula",
  },
  [5690] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3072280089, ["py"] = 0.3702887972, ["pm"] = 1765, ["d"] = true,
        ["zx"] = 0.3100392088, ["zy"] = 0.3695339964, ["zm"] = 20,
      },
    },
    ["n"] = "Pyre Watch Precepts",
    ["cn"] = "Library of Incunabula",
  },
  [5691] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3084411894, ["py"] = 0.3712947949, ["pm"] = 1796, ["d"] = true,
        ["zx"] = 0.3100392088, ["zy"] = 0.3695339964, ["zm"] = 20,
      },
    },
    ["n"] = "Kjalnar's Research Notes",
    ["cn"] = "Library of Incunabula",
  },
  [5692] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3068092031, ["py"] = 0.3697863955, ["pm"] = 1768, ["d"] = true,
        ["zx"] = 0.3100392088, ["zy"] = 0.3695339964, ["zm"] = 20,
      },
    },
    ["n"] = "Letter to Nabor",
    ["cn"] = "Library of Incunabula",
  },
  [5696] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = -0.1185859972, ["py"] = 0.1184895993, ["pm"] = 1706, ["d"] = true, },
      [2] = { ["px"] = 0.7702531889, ["py"] = 0.4695583986, ["pm"] = 7, },
    },
    ["n"] = "Tombstone of Naio-Bhefeo",
    ["cn"] = "Mysteries and Clues",
  },
  [5698] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = -0.1189947971, ["py"] = 0.1185347990, ["pm"] = 1706, ["d"] = true,
      },
      [2] = {
        ["px"] = 0.4769987974, ["py"] = 0.6997947736, ["pm"] = 1709, ["d"] = true,
      },
    },
    ["n"] = "The Illustrious Azashig's Letter",
    ["cn"] = "Mysteries and Clues",
  },
  [5699] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1185800000,
        ["zt"] = 1142,
        ["px"] = -0.1190200000,
      },
      [2] = {
        ["px"] = 0.4764435974, ["py"] = 0.6998063736, ["pm"] = 1709, ["d"] = true,
      },
    },
    ["n"] = "Letter to Halakaku",
    ["cn"] = "Mysteries and Clues",
  },
  [5700] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5172200000,
        ["py"] = 0.7398600000,
        ["i"] = 12,
      },
    },
    ["n"] = "How We Came to Fly",
    ["cn"] = "Pellitine Postings",
  },
  [5701] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "On Plunder Skulls",
    ["e"] = {
      [1] = { ["px"] = 0.1693067979, ["py"] = 0.6351932132, ["pm"] = 143, },
      [2] = {
        ["pm"] = 7,
        ["mn"] = 11,
        ["px"] = 0.7314200000,
        ["py"] = 0.4808800000,
        ["i"] = 12,
      },
      [3] = {
        ["pm"] = 1,
        ["mn"] = 2,
        ["px"] = 0.1257000000,
        ["py"] = 0.2939000000,
        ["i"] = 12,
      },
    },
  },
  [5702] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Vijari is Unwell",
    ["q"] = 6396,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["py"] = 0.7309400000,
        ["px"] = 0.5198200000,
        ["pm"] = 1654,
      },
    },
  },
  [5703] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Children of the Wind",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5226496055, ["py"] = 0.7270652108, ["pm"] = 1654, },
      [2] = {
        ["py"] = 0.7269500000,
        ["px"] = 0.5611600000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [3] = {
        ["py"] = 0.7568700000,
        ["mn"] = 37,
        ["px"] = 0.5614200000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [4] = {
        ["py"] = 0.7883100000,
        ["px"] = 0.6188800000,
        ["pm"] = 1684,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
      [5] = {
        ["py"] = 0.7599600000,
        ["mn"] = 37,
        ["px"] = 0.5628900000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [6] = {
        ["py"] = 0.7592600000,
        ["mn"] = 37,
        ["px"] = 0.5634300000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [7] = {
        ["py"] = 0.7158700000,
        ["px"] = 0.5312000000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [8] = {
        ["py"] = 0.7152600000,
        ["px"] = 0.5310800000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [9] = {
        ["py"] = 0.7606400000,
        ["mn"] = 37,
        ["px"] = 0.5549700000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
      [10] = {
        ["py"] = 0.7265600000,
        ["px"] = 0.5628000000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [11] = {
        ["py"] = 0.7101500000,
        ["mn"] = 37,
        ["px"] = 0.5377700000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
      [12] = {
        ["py"] = 0.7280800000,
        ["px"] = 0.5615400000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [13] = {
        ["py"] = 0.7154900000,
        ["px"] = 0.5298200000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [14] = {
        ["py"] = 0.7565500000,
        ["mn"] = 37,
        ["px"] = 0.5580300000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
    },
    ["m"] = {
      [37] = 18,
    },
  },
  [5704] = {
    ["c"] = true,
    ["n"] = "Sealed Letter",
    ["q"] = 6395,
    ["cn"] = "Mysteries and Clues",
    ["e"] = {
      [1] = { ["px"] = -0.1199727975, ["py"] = 0.1179823985, ["pm"] = 1706, ["d"] = true, },
    },
  },
  [5705] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5801400000,
        ["py"] = 0.7754100000,
        ["i"] = 12,
      },
    },
    ["n"] = "Turo's Cargo Manifest",
    ["cn"] = "Pellitine Postings",
  },
  [5706] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Moon-Sugar Plans",
    ["q"] = 6413,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5315400000,
        ["py"] = 0.7513400000,
        ["i"] = 12,
      },
    },
  },
  [5707] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Lost Cat",
    ["q"] = 6442,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5249700000,
        ["py"] = 0.7702700000,
        ["i"] = 12,
      },
    },
  },
  [5709] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "J'saad's Note",
    ["q"] = 6445,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5483900000,
        ["i"] = 12,
        ["py"] = 0.7304200000,
      },
    },
  },
  [5710] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5446500000,
        ["py"] = 0.7743100000,
        ["i"] = 12,
      },
      [2] = {
        ["mn"] = 37,
        ["px"] = 0.5280000000,
        ["i"] = 12,
        ["py"] = 0.8710800000,
        ["pm"] = 1654,
      },
    },
    ["n"] = "Soul of the Sword",
    ["cn"] = "Pellitine Postings",
  },
  [5711] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Ja'darri the Endless",
    ["q"] = 6403,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5370300000,
        ["py"] = 0.7106500000,
        ["i"] = 12,
      },
    },
  },
  [5713] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Unsent Letter",
    ["q"] = 6418,
    ["e"] = {
      [1] = {
        ["px"] = 0.5615039841, ["py"] = 0.7280967995, ["pm"] = 1694,
        ["zx"] = 0.5576724058, ["zy"] = 0.7295324139, ["zm"] = 1654,
        ["d"] = true,
      },
    },
  },
  [5714] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5647100000,
        ["i"] = 12,
        ["py"] = 0.7522700000,
      },
    },
    ["n"] = "Letter to Selloe",
    ["cn"] = "Pellitine Postings",
  },
  [5715] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5216000000,
        ["py"] = 0.7520900000,
        ["i"] = 12,
      },
    },
    ["n"] = "Terror from the East",
    ["cn"] = "Pellitine Postings",
  },
  [5716] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Moon-Sugar: A Better Plan",
    ["q"] = 6413,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5479700000,
        ["py"] = 0.7690800000,
        ["i"] = 12,
      },
      [2] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5322500000,
        ["py"] = 0.7595900000,
        ["i"] = 12,
      },
    },
  },
  [5718] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Benevolent Necromancy, it Exists",
    ["r"] = true,
    ["e"] = {
    },
    ["m"] = {
      [36] = 1,
      [1555] = 1,
    },
  },
  [5719] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "A World of Corpses",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.6179600000,
        ["px"] = 0.5773900000,
        ["pm"] = 1680,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [2] = {
        ["py"] = 0.6170100000,
        ["mn"] = 36,
        ["px"] = 0.5768400000,
        ["pm"] = 1555,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
    },
    ["m"] = {
      [36] = 2,
    },
  },
  [5722] = {
    ["c"] = true,
    ["n"] = "Battle of the Black Beast",
    ["cn"] = "Pellitine Postings",
    ["e"] = {
      [1] = {
        ["px"] = 0.5705295796, ["py"] = 0.7090216206, ["pm"] = 1712,
        ["zx"] = 0.5734532099, ["zy"] = 0.7112232103, ["zm"] = 1654,
        ["d"] = true,
      },
    },
  },
  [5723] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5803400000,
        ["py"] = 0.7847700000,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter from Turo",
    ["cn"] = "Pellitine Postings",
  },
  [5725] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5178200000,
        ["py"] = 0.7400400000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Sky Spirits",
    ["cn"] = "Pellitine Postings",
  },
  [5726] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5074200000,
        ["i"] = 12,
        ["py"] = 0.7242500000,
      },
    },
    ["n"] = "The Dark Spirits",
    ["cn"] = "Pellitine Postings",
  },
  [5727] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5970800000,
        ["py"] = 0.7809600000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Worldly Spirits",
    ["cn"] = "Pellitine Postings",
  },
  [5728] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "The Wandering Spirits",
    ["q"] = 6403,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5364100000,
        ["py"] = 0.7104000000,
        ["i"] = 12,
      },
    },
  },
  [5729] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5315796065, ["py"] = 0.7639332149, ["pm"] = 1654, },
    },
    ["n"] = "The Adversarial Spirits",
    ["cn"] = "Pellitine Postings",
  },
  [5730] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5181724008, ["py"] = 0.7533300044, ["pm"] = 1701, ["d"] = true,
        ["zx"] = 0.5206104053, ["zy"] = 0.7520704119, ["zm"] = 1654,
      },
    },
    ["n"] = "By Gentle Winds",
    ["cn"] = "Pellitine Postings",
  },
  [5731] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1735,
        ["px"] = 0.5176000000,
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.7533300000,
        ["zx"] = 0.5206104053, ["zy"] = 0.7520704119, ["zm"] = 1654,
      },
    },
    ["n"] = "Through Doom and Darkness",
    ["cn"] = "Pellitine Postings",
  },
  [5732] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5177843925, ["py"] = 0.7527100171, ["pm"] = 1702, ["d"] = true,
        ["zx"] = 0.5206104053, ["zy"] = 0.7520704119, ["zm"] = 1654,
      },
    },
    ["n"] = "Mend the Threads",
    ["cn"] = "Pellitine Postings",
  },
  [5733] = {
    ["c"] = true,
    ["cn"] = "Skill Books",
    ["n"] = "Achieving Harmony with Death",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7155400000,
        ["px"] = 0.5296300000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [2] = {
        ["py"] = 0.7270500000,
        ["px"] = 0.5610700000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [37] = 2,
    },
  },
  [5734] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "To Sai Sahan",
    ["q"] = 6393,
    ["e"] = {
      [1] = { ["px"] = 0.6189159960, ["py"] = 0.7885235713, ["pm"] = 1682, ["zm"] = 1654, },
      [2] = { ["px"] = 0.6189159960, ["py"] = 0.7885235713, ["pm"] = 1684, ["fp"] = true, },
    },
  },
  [5735] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6190927958, ["py"] = 0.7853311711, ["pm"] = 1682, ["zm"] = 1654, },
      [2] = { ["px"] = 0.6190927958, ["py"] = 0.7853311711, ["pm"] = 1684, ["fp"] = true, },
    },
    ["n"] = "The Good Bits",
    ["cn"] = "Pellitine Postings",
  },
  [5736] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6190771960, ["py"] = 0.7887755710, ["pm"] = 1682, ["zm"] = 1654, },
      [2] = { ["px"] = 0.6190771960, ["py"] = 0.7887755710, ["pm"] = 1684, ["fp"] = true, },
      [3] = {
        ["pm"] = 1684,
        ["px"] = 0.6140200000,
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.7921300000,
      },
    },
    ["n"] = "Ra'khajin's Orders",
    ["cn"] = "Pellitine Postings",
  },
  [5738] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2134000000,
        ["px"] = 0.3604600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Brokel (Exhumed)",
    ["cn"] = "Solitude Soliloquies",
  },
  [5739] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2132500000,
        ["px"] = 0.3602200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Isendore Fish-Gutter",
    ["cn"] = "Solitude Soliloquies",
  },
  [5740] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2127200000,
        ["px"] = 0.3595500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Harlock the Bastard (Exhumed)",
    ["cn"] = "Solitude Soliloquies",
  },
  [5741] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2138100000,
        ["px"] = 0.3593000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Unknown (Exhumed)",
    ["cn"] = "Solitude Soliloquies",
  },
  [5742] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2141900000,
        ["px"] = 0.3597700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Shield-Guard Karthi",
    ["cn"] = "Solitude Soliloquies",
  },
  [5743] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2132900000,
        ["px"] = 0.3587600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Nel the Orphan",
    ["cn"] = "Solitude Soliloquies",
  },
  [5744] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Seeks-Birdsong",
    ["e"] = {
      [1] = { ["px"] = 0.3598844114, ["py"] = 0.2143068010, ["pm"] = 1719, },
    },
  },
  [5745] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2136100000,
        ["px"] = 0.3590800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Lekka the Corpulent (Exhumed)",
    ["cn"] = "Solitude Soliloquies",
  },
  [5746] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2133100000,
        ["px"] = 0.3602800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Sedua",
    ["cn"] = "Solitude Soliloquies",
  },
  [5747] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2141000000,
        ["px"] = 0.3596300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Uthbet (Exhumed)",
    ["cn"] = "Solitude Soliloquies",
  },
  [5748] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1503800000,
        ["r"] = false,
        ["px"] = 0.0081300000,
        ["pm"] = 1784,
      },
    },
    ["n"] = "Lucrative Opportunity In Eastmarch",
    ["cn"] = "Handbills, Posters, and Decrees",
  },
  [5751] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5607300000,
        ["i"] = 12,
        ["py"] = 0.7498400000,
      },
    },
    ["n"] = "Elsweyr My Love, Page 1",
    ["cn"] = "Pellitine Postings",
  },
  [5752] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5115235947, ["py"] = 0.7717175956, ["pm"] = 1739, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "Elsweyr My Love, Page 5",
    ["cn"] = "Pellitine Postings",
  },
  [5753] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5202000000,
        ["py"] = 0.7540200000,
        ["i"] = 12,
      },
    },
    ["n"] = "Elsweyr My Love, Page 9",
    ["cn"] = "Pellitine Postings",
  },
  [5754] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5663000000,
        ["py"] = 0.7129400000,
        ["i"] = 12,
      },
    },
    ["n"] = "Elsweyr My Love, Page 16",
    ["cn"] = "Pellitine Postings",
  },
  [5755] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5204000000,
        ["py"] = 0.7288000000,
        ["i"] = 12,
      },
    },
    ["n"] = "Elsweyr My Love, Page 19",
    ["cn"] = "Pellitine Postings",
  },
  [5756] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5924700000,
        ["i"] = 12,
        ["py"] = 0.7892100000,
      },
    },
    ["n"] = "Elsweyr My Love, Page 26",
    ["cn"] = "Pellitine Postings",
  },
  [5757] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5563700000,
        ["i"] = 12,
        ["py"] = 0.7882100000,
      },
    },
    ["n"] = "Elsweyr My Love, Page 36",
    ["cn"] = "Pellitine Postings",
  },
  [5758] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5634024089, ["py"] = 0.7269892244, ["pm"] = 1695,
        ["zx"] = 0.5576724058, ["zy"] = 0.7295324139, ["zm"] = 1654,
        ["d"] = true,
      },
    },
    ["n"] = "Elsweyr My Love, Page 42",
    ["cn"] = "Pellitine Postings",
  },
  [5759] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5316200000,
        ["i"] = 12,
        ["py"] = 0.7831700000,
      },
      [2] = {
        ["px"] = 0.5614300000,
        ["i"] = 12,
        ["py"] = 0.9413200000,
        ["mn"] = 37,
        ["pm"] = 1654,
      },
    },
    ["n"] = "Elsweyr My Love, Page 44",
    ["cn"] = "Pellitine Postings",
  },
  [5760] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5489500000,
        ["i"] = 12,
        ["py"] = 0.7179500000,
      },
    },
    ["n"] = "Elsweyr My Love, Page 52",
    ["cn"] = "Pellitine Postings",
  },
  [5761] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1610000000,
        ["r"] = false,
        ["px"] = 0.0231500000,
        ["pm"] = 1932,
      },
    },
    ["n"] = "Icereach Coven Note",
    ["cn"] = "Rituals and Revelations",
  },
  [5762] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2403600000,
        ["px"] = 0.4628500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Maxten's Research Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [5763] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2190400000,
        ["px"] = 0.4394500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Message from Fennorian",
    ["cn"] = "Solitude Soliloquies",
  },
  [5764] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5346900000,
        ["py"] = 0.7217700000,
        ["i"] = 12,
      },
    },
    ["n"] = "Ra'khajin's Journal, Page 3",
    ["cn"] = "Pellitine Postings",
  },
  [5765] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5750500000,
        ["i"] = 12,
        ["py"] = 0.7648200000,
      },
    },
    ["n"] = "Survivor's Guilt",
    ["cn"] = "Pellitine Postings",
  },
  [5766] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5805700000,
        ["i"] = 12,
        ["py"] = 0.7769200000,
      },
      [2] = {
        ["px"] = 0.3556300000,
        ["i"] = 12,
        ["py"] = 0.7091300000,
        ["mn"] = 37,
        ["pm"] = 1654,
      },
    },
    ["n"] = "The Burning of Senchal",
    ["cn"] = "Pellitine Postings",
  },
  [5767] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5840900000,
        ["py"] = 0.7783200000,
        ["i"] = 12,
      },
    },
    ["n"] = "Fleeing Senchal",
    ["cn"] = "Pellitine Postings",
  },
  [5768] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Today's Instructions",
    ["q"] = 6460,
    ["e"] = {
      [1] = {
        ["py"] = 0.2094400000,
        ["px"] = 0.4567400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [5769] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5552100000,
        ["py"] = 0.7604600000,
        ["i"] = 12,
      },
    },
    ["n"] = "History of Senchal: An Overview",
    ["cn"] = "Pellitine Postings",
  },
  [5770] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5652600000,
        ["px"] = 0.6525900000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Burnt Papers",
    ["cn"] = "Solitude Soliloquies",
  },
  [5772] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6823955873, ["py"] = 1.5425679703, ["pm"] = 1800, ["d"] = true,
      },
    },
    ["n"] = "Netherroot Notes",
    ["cn"] = "Solitude Soliloquies",
  },
  [5773] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6826719873, ["py"] = 1.5424983703, ["pm"] = 1800, ["d"] = true,
      },
    },
    ["n"] = "Lycanthropic Immunity",
    ["cn"] = "Solitude Soliloquies",
  },
  [5774] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5311900000,
        ["py"] = 0.7209700000,
        ["i"] = 12,
      },
    },
    ["n"] = "Ra'khajin's Journal, Page 12",
    ["cn"] = "Pellitine Postings",
  },
  [5775] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5280000000,
        ["py"] = 0.7219800000,
        ["i"] = 12,
      },
    },
    ["n"] = "Ra'khajin's Journal, Page 25",
    ["cn"] = "Pellitine Postings",
  },
  [5776] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5181500000,
        ["py"] = 0.7319900000,
        ["i"] = 12,
      },
    },
    ["n"] = "History of Pellitine: An Overview",
    ["cn"] = "Pellitine Postings",
  },
  [5807] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146300000,
        ["px"] = 0.4351100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Nel's Hidden Loves",
    ["cn"] = "Solitude Soliloquies",
  },
  [5808] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5657400000,
        ["i"] = 12,
        ["py"] = 0.7540500000,
      },
    },
    ["n"] = "J'daththarr's Letter",
    ["cn"] = "Pellitine Postings",
  },
  [5809] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5550000000,
        ["py"] = 0.7601800000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Bounty and the Shields",
    ["cn"] = "Pellitine Postings",
  },
  [5810] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5114235703, ["py"] = 0.7718315755, ["pm"] = 1742, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "Sacred Waters of the Shining Sea",
    ["cn"] = "Pellitine Postings",
  },
  [5811] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5118267703, ["py"] = 0.7704279756, ["pm"] = 1676, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "The Marriage of Moon and Tide",
    ["cn"] = "Pellitine Postings",
  },
  [5812] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5538900000,
        ["py"] = 0.7614000000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Gambler's Art",
    ["cn"] = "Pellitine Postings",
  },
  [5813] = {
    ["c"] = true,
    ["n"] = "Demon from the East",
    ["cn"] = "Pellitine Postings",
    ["e"] = {
      [1] = {
        ["px"] = 0.5613423841, ["py"] = 0.7280199995, ["pm"] = 1694,
        ["zx"] = 0.5576724058, ["zy"] = 0.7295324139, ["zm"] = 1654,
        ["d"] = true,
      },
    },
  },
  [5814] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5171700000,
        ["py"] = 0.7393400000,
        ["i"] = 12,
      },
    },
    ["n"] = "Twilight Cantors: The Exorcists of Azurah",
    ["cn"] = "Pellitine Postings",
  },
  [5815] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5468300000,
        ["py"] = 0.7160300000,
        ["i"] = 12,
      },
    },
    ["n"] = "Pridehome: A Place Outside Time?",
    ["cn"] = "Pellitine Postings",
  },
  [5816] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2464000000,
        ["px"] = 0.4464000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Freiwen's Diary",
    ["cn"] = "Solitude Soliloquies",
  },
  [5817] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Missing Miners",
    ["q"] = 6471,
    ["e"] = {
      [1] = { ["px"] = 0.6545472199, ["py"] = 1.5638032405, ["pm"] = 1747, },
    },
  },
  [5818] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2072200000,
        ["px"] = 0.4218600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter to the Pentarch",
    ["cn"] = "Solitude Soliloquies",
  },
  [5819] = {
    ["c"] = true,
    ["n"] = "Topal Legionary Academy",
    ["cn"] = "Pellitine Postings",
    ["e"] = {
      [1] = {
        ["px"] = 0.5613719841, ["py"] = 0.7271515995, ["pm"] = 1694,
        ["zx"] = 0.5576724058, ["zy"] = 0.7295324139, ["zm"] = 1654,
        ["d"] = true,
      },
    },
  },
  [5850] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5507700000,
        ["py"] = 0.7346200000,
        ["i"] = 12,
      },
    },
    ["n"] = "New Moon Obligations",
    ["cn"] = "Pellitine Postings",
  },
  [5851] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5310200000,
        ["py"] = 0.7518600000,
        ["i"] = 12,
      },
    },
    ["n"] = "Dragons of Southern Elsweyr",
    ["cn"] = "Pellitine Postings",
  },
  [5853] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5760400000,
        ["px"] = 0.6380600000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter to the Overseer",
    ["cn"] = "Solitude Soliloquies",
  },
  [5869] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1679,
        ["px"] = 0.5584600000,
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.7598000000,
      },
    },
    ["n"] = "Black Kiergo: Primed for Peryite?",
    ["cn"] = "Pellitine Postings",
  },
  [5870] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5612100000,
        ["d"] = true,
        ["py"] = 0.7572800000,
        ["i"] = 12,
      },
    },
    ["n"] = "The Shields of Senchal",
    ["cn"] = "Pellitine Postings",
  },
  [5872] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5742200000,
        ["px"] = 0.6503300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "List of Targets",
    ["cn"] = "Solitude Soliloquies",
  },
  [5873] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["pm"] = 1654,
        ["mn"] = 37,
        ["px"] = 0.5210700000,
        ["py"] = 0.7538000000,
        ["i"] = 12,
      },
    },
    ["n"] = "Azurah's Crossing",
    ["cn"] = "Pellitine Postings",
  },
  [5874] = {
    ["c"] = true,
    ["cn"] = "Pellitine Postings",
    ["n"] = "Secrets of the Riddle'Thar",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.8021800000,
        ["px"] = 0.5382400000,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
        ["zt"] = 1151,
      },
      [2] = {
        ["py"] = 0.7594800000,
        ["mn"] = 37,
        ["px"] = 0.5628600000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [3] = {
        ["py"] = 0.7884300000,
        ["px"] = 0.6189100000,
        ["pm"] = 1684,
        ["i"] = 12,
        ["d"] = false,
        ["r"] = true,
      },
      [4] = {
        ["py"] = 0.7593200000,
        ["mn"] = 37,
        ["px"] = 0.5634000000,
        ["pm"] = 1654,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [5] = {
        ["py"] = 0.7159100000,
        ["px"] = 0.5311600000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [6] = {
        ["py"] = 0.7154400000,
        ["px"] = 0.5298300000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [7] = {
        ["py"] = 0.7280900000,
        ["px"] = 0.5614600000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [8] = {
        ["py"] = 0.7269600000,
        ["px"] = 0.5611700000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [9] = {
        ["py"] = 0.7163000000,
        ["px"] = 0.5285600000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [10] = {
        ["py"] = 0.7267900000,
        ["px"] = 0.5627300000,
        ["pm"] = 1696,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
      [11] = {
        ["py"] = 0.8036200000,
        ["px"] = 0.5382900000,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
        ["zt"] = 1151,
      },
      [12] = {
        ["py"] = 0.7160000000,
        ["px"] = 0.5296700000,
        ["pm"] = 1743,
        ["i"] = 12,
        ["d"] = true,
        ["r"] = true,
      },
    },
    ["m"] = {
      [37] = 12,
    },
  },
  [5875] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5600400000,
        ["i"] = 12,
        ["py"] = 0.7615600000,
      },
    },
    ["n"] = "New Cult or Ancient Religion?",
    ["cn"] = "Pellitine Postings",
  },
  [5876] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5630648286, ["py"] = 0.7596607925, ["pm"] = 1690, ["d"] = true, },
      [2] = { ["px"] = 0.5626844036, ["py"] = 0.7600672174, ["pm"] = 1675, ["zm"] = 1654, ["fp"] = true, },
    },
    ["n"] = "Varieties of Dragons: An Initial Exploration",
    ["cn"] = "Pellitine Postings",
  },
  [5877] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5102903703, ["py"] = 0.7712795756, ["pm"] = 1676, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "Khunzar-ri and the Lost Alfiq",
    ["cn"] = "Pellitine Postings",
  },
  [5878] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5117135704, ["py"] = 0.7709003756, ["pm"] = 1676, ["d"] = true,
        ["zx"] = 0.5132656057, ["zy"] = 0.7731904106, ["zm"] = 1654,
      },
    },
    ["n"] = "The Favored Daughter of Fadomai",
    ["cn"] = "Pellitine Postings",
  },
  [5879] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["mn"] = 37,
        ["pm"] = 1654,
        ["px"] = 0.5340400000,
        ["i"] = 12,
        ["py"] = 0.7821900000,
      },
    },
    ["n"] = "Epistle on the Spirits of Amun-dro Vol 1",
    ["cn"] = "Pellitine Postings",
  },
  [5880] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7895100000,
        ["px"] = 0.5589700000,
        ["pm"] = 1654,
        ["mn"] = 37,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Epistle on the Spirits of Amun-dro Vol 2",
    ["cn"] = "Pellitine Postings",
  },
  [5881] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.7869200000,
        ["mn"] = 37,
        ["px"] = 0.5859200000,
        ["pm"] = 1654,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Epistle on the Spirits of Amun-dro Vol 3",
    ["cn"] = "Pellitine Postings",
  },
  [5897] = {
    ["c"] = false,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Bards College Salskap Tonight!",
    ["q"] = 6482,
    ["e"] = {
    },
  },
  [5898] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Brondold's Papers",
    ["q"] = 6467,
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2209600000,
        ["px"] = 0.4233800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 0,
        ["r"] = true,
      },
      [2] = {
        ["py"] = 0.2213600000,
        ["px"] = 0.4288500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 0,
        ["r"] = true,
      },
      [3] = {
        ["py"] = 0.2160600000,
        ["px"] = 0.4261500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 0,
        ["r"] = true,
      },
    },
  },
  [5899] = {
    ["c"] = true,
    ["q"] = 6480,
    ["e"] = {
      [1] = { ["px"] = 0.7014312166, ["py"] = 1.5382663980, ["pm"] = 1809, ["zx"] = 0.7014312222, ["zy"] = 1.5382664378, ["zm"] = 1747, ["d"] = true, ["qp"] = true, },
    },
    ["n"] = "Miner's Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [5901] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3910603930, ["py"] = 0.2718236074, ["pm"] = 1772, ["d"] = true,
        ["zx"] = 0.3934092114, ["zy"] = 0.2642516044, ["zm"] = 1719,
      },
    },
    ["n"] = "Reach Loyalist's Letter",
    ["cn"] = "Solitude Soliloquies",
  },
  [5902] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146800000,
        ["px"] = 0.4351300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Petraloop",
    ["cn"] = "Solitude Soliloquies",
  },
  [5903] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145900000,
        ["px"] = 0.4352000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Lute of Blue Longing",
    ["cn"] = "Solitude Soliloquies",
  },
  [5904] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146700000,
        ["px"] = 0.4352600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Chime of the Endless",
    ["cn"] = "Solitude Soliloquies",
  },
  [5905] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146300000,
        ["px"] = 0.4352100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Tenderclaw",
    ["cn"] = "Solitude Soliloquies",
  },
  [5906] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2848800000,
        ["px"] = 0.5411000000,
        ["pm"] = 1719,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
        ["mn"] = 38,
      },
      [2] = {
        ["py"] = 0.2145500000,
        ["px"] = 0.4353000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Shadow of Rahjin",
    ["cn"] = "Solitude Soliloquies",
  },
  [5907] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Drinks of the Reach",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3445132009, ["py"] = 0.2852079960, ["pm"] = 1858, ["zm"] = 1814, },
    },
    ["m"] = {
      [41] = 1,
    },
  },
  [5908] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146100000,
        ["px"] = 0.4352200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Lilytongue",
    ["cn"] = "Solitude Soliloquies",
  },
  [5909] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "On the Clans of the Reach",
    ["e"] = {
      [1] = { ["px"] = 0.3783480068, ["py"] = 0.2659959968, ["pm"] = 1814, },
    },
  },
  [5910] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146600000,
        ["px"] = 0.4353000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Sky-Talker",
    ["cn"] = "Solitude Soliloquies",
  },
  [5913] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2267700000,
        ["px"] = 0.4284600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Brondold's Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [5914] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145900000,
        ["px"] = 0.4352700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Long Fire",
    ["cn"] = "Solitude Soliloquies",
  },
  [5915] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145500000,
        ["px"] = 0.4352400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2848700000,
        ["px"] = 0.5409000000,
        ["pm"] = 1719,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
        ["mn"] = 38,
      },
    },
    ["n"] = "Highmourn Dizi",
    ["cn"] = "Solitude Soliloquies",
  },
  [5916] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145700000,
        ["px"] = 0.4352800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Jarlsbane",
    ["cn"] = "Solitude Soliloquies",
  },
  [5917] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146500000,
        ["px"] = 0.4352800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "King Thunder",
    ["cn"] = "Solitude Soliloquies",
  },
  [5918] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146200000,
        ["px"] = 0.4353300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Jahar Fuso'ja",
    ["cn"] = "Solitude Soliloquies",
  },
  [5919] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2847700000,
        ["px"] = 0.5410300000,
        ["pm"] = 1719,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
        ["mn"] = 38,
      },
    },
    ["n"] = "Pan Flute of Morachellis Hag-Husband",
    ["cn"] = "Solitude Soliloquies",
  },
  [5920] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145900000,
        ["px"] = 0.4353200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Reman War Drum",
    ["cn"] = "Solitude Soliloquies",
  },
  [5924] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Stonemelt Potion Recipe",
    ["q"] = 6484,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1513500000,
        ["r"] = false,
        ["px"] = 0.0036300000,
        ["pm"] = 1771,
      },
    },
  },
  [5926] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "For My Love",
    ["q"] = 6460,
    ["e"] = {
      [1] = {
        ["px"] = 0.4651688082, ["py"] = 0.2159816024, ["pm"] = 1810, ["d"] = true,
        ["zx"] = 0.4635204089, ["zy"] = 0.2136976030, ["zm"] = 1719,
      },
    },
  },
  [5927] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "New Solution Instructions",
    ["q"] = 6484,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1502400000,
        ["r"] = false,
        ["px"] = 0.0136000000,
        ["pm"] = 1771,
      },
    },
  },
  [5928] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Unnamed Mining Journal, Page 37",
    ["e"] = {
      [1] = { ["px"] = 0.4244151866, ["py"] = 0.2015600003, ["pm"] = 1752, ["zx"] = 0.4192188112, ["zy"] = 0.2002276016, ["zm"] = 1719, ["d"] = true, },
    },
  },
  [5929] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1989000000,
        ["px"] = 0.4242400000,
        ["pm"] = 1752,
        ["zx"] = 0.4192188112, ["zy"] = 0.2002276016, ["zm"] = 1719,
        ["d"] = true,
      },
    },
    ["n"] = "Unnamed Mining Journal, Page 42",
    ["cn"] = "Western Skyrim Register",
  },
  [5930] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Unnamed Mining Journal, Page 45",
    ["e"] = {
      [1] = { ["px"] = 0.4253515867, ["py"] = 0.2001688003, ["pm"] = 1752, ["zx"] = 0.4192188112, ["zy"] = 0.2002276016, ["zm"] = 1719, ["d"] = true, },
    },
  },
  [5932] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4317140010, ["py"] = 0.2147900017, ["pm"] = 1773, ["zm"] = 1719, },
    },
    ["n"] = "Seeking Brave Souls and Able Bodies",
    ["cn"] = "Solitude Soliloquies",
  },
  [5933] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Kal Druun's Notes",
    ["q"] = 6466,
    ["e"] = {
      [1] = {
        ["px"] = 0.6825827872, ["py"] = 1.5430371703, ["pm"] = 1800, ["d"] = true,
      },
      [2] = {
        ["py"] = 0.2188100000,
        ["px"] = 0.4393100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [5934] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Gray Host Communique",
    ["q"] = 6466,
    ["e"] = {
      [1] = {
        ["px"] = 0.6820803872, ["py"] = 1.5427603703, ["pm"] = 1800, ["d"] = true,
      },
    },
  },
  [5935] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6704012041, ["py"] = 1.5500623612, ["pm"] = 1751, ["d"] = true,
        ["zx"] = 0.6649436204, ["zy"] = 1.5540808403, ["zm"] = 1747,
      },
    },
    ["n"] = "Thaddeus's List of Parts",
    ["cn"] = "Solitude Soliloquies",
  },
  [5936] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Rasir's Journal Page",
    ["q"] = 6461,
    ["e"] = {
      [1] = {
        ["py"] = 1.5435100000,
        ["px"] = 0.6421300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [5938] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1969100000,
        ["px"] = 0.4739700000,
        ["pm"] = 1750,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Nelfthea's Warning",
    ["cn"] = "Western Skyrim Register",
  },
  [5940] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5420200000,
        ["px"] = 0.6332700000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Gray Host Orders",
    ["cn"] = "Solitude Soliloquies",
  },
  [5941] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2587800000,
        ["px"] = 0.4571300000,
        ["pm"] = 1774,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Danger of Morokei",
    ["cn"] = "Solitude Soliloquies",
  },
  [5942] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2594500000,
        ["px"] = 0.4602600000,
        ["pm"] = 1774,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Morokei's Power",
    ["cn"] = "Solitude Soliloquies",
  },
  [5943] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2410000000,
        ["px"] = 0.4029000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter from Ena",
    ["cn"] = "Solitude Soliloquies",
  },
  [5944] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Balgvir's Siege Journal",
    ["e"] = {
      [1] = {
        ["px"] = 0.4058675970, ["py"] = 0.1486072005, ["pm"] = 1805, ["d"] = true,
        ["zx"] = 0.4098980125, ["zy"] = 0.1912580016, ["zm"] = 1719,
      },
    },
  },
  [5945] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1486400000,
        ["r"] = false,
        ["px"] = 0.4066300000,
        ["pm"] = 1805,
        ["zx"] = 0.4098980125, ["zy"] = 0.1912580016, ["zm"] = 1719,
      },
    },
    ["n"] = "Letter to Thane Ogvar",
    ["cn"] = "Solitude Soliloquies",
  },
  [5952] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.7012404166, ["py"] = 1.5384299980, ["pm"] = 1809, ["zx"] = 0.7012404198, ["zy"] = 1.5384300365, ["zm"] = 1747, ["d"] = true, },
    },
    ["n"] = "Things My Great-Gran Said",
    ["cn"] = "Solitude Soliloquies",
  },
  [5953] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Stone Husk Dissection Log",
    ["e"] = {
      [1] = {
        ["px"] = 0.6439284031, ["py"] = 1.5183548431, ["pm"] = 1786, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [5954] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Specimen Enhancement Log Four",
    ["e"] = {
      [1] = {
        ["px"] = 0.6458784094, ["py"] = 1.5184547564, ["pm"] = 1787, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [5956] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Regarding Our Guests",
    ["e"] = {
      [1] = {
        ["px"] = 0.6442140031, ["py"] = 1.5176408431, ["pm"] = 1786, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [5960] = {
    ["c"] = true,
    ["cn"] = "Houses, Shops, and Trade",
    ["n"] = "Architectural Survey Summary Report",
    ["e"] = {
      [1] = {
        ["px"] = 0.3588044085, ["py"] = 0.2419455983, ["pm"] = 1823, ["d"] = true,
        ["zx"] = 0.3617232115, ["zy"] = 0.2413048022, ["zm"] = 1719,
      },
    },
  },
  [5961] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "A Daedric Proposal",
    ["e"] = {
      [1] = {
        ["px"] = 0.3595599984, ["py"] = 0.2418508033, ["pm"] = 1825, ["d"] = true,
        ["zx"] = 0.3617232115, ["zy"] = 0.2413048022, ["zm"] = 1719,
      },
    },
  },
  [5962] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Wilderness Survival Tips",
    ["e"] = {
      [1] = { ["px"] = 0.3866540068, ["py"] = 0.2666007961, ["pm"] = 1814, },
    },
  },
  [5963] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Nord Child's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3762812082, ["py"] = 0.2606591972, ["pm"] = 1814, },
    },
  },
  [5964] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2841100000,
        ["px"] = 0.3442100000,
        ["pm"] = 1858,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
        ["zm"] = 1814,
      },
    },
    ["n"] = "History of Markarth: A Story in Stone",
    ["cn"] = "The Reach Reader",
  },
  [5965] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "A Reach Travel Guide",
    ["e"] = {
      [1] = { ["px"] = 0.3897796075, ["py"] = 0.2918379964, ["pm"] = 1814, },
    },
  },
  [5966] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3387359969, ["py"] = 0.2871591962, ["pm"] = 1888, ["d"] = true,
        ["zx"] = 0.3403076011, ["zy"] = 0.2865647960, ["zm"] = 1858,
      },
      [2] = { ["px"] = 0.3403076011, ["py"] = 0.2865647960, ["pm"] = 1858, ["zm"] = 1814, ["fp"] = true, }, -- additional pin on main map
    },
    ["n"] = "Politics of the Reach",
    ["cn"] = "The Reach Reader",
  },
  [5983] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6817847873, ["py"] = 1.5421631704, ["pm"] = 1800, ["d"] = true,
      },
    },
    ["n"] = "Distillation Calibrations and Instructions",
    ["cn"] = "Solitude Soliloquies",
  },
  [5985] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2503100000,
        ["px"] = 0.4542200000,
        ["pm"] = 1754,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter to Warlord Rukar",
    ["cn"] = "Solitude Soliloquies",
  },
  [5986] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2504200000,
        ["px"] = 0.4542500000,
        ["pm"] = 1754,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Sister Elra's Proclamation",
    ["cn"] = "Solitude Soliloquies",
  },
  [5989] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2138500000,
        ["px"] = 0.4286000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Narsis Dren's Skyrim Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [5990] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Incantation of Reversal, First Fragment",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2139800000,
        ["px"] = 0.4275600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [5991] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Incantation of Reversal, Second Fragment",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2170100000,
        ["px"] = 0.4352800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [5992] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Incantation of Reversal, Third Fragment",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2139300000,
        ["px"] = 0.4346300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6008] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Maelmoth's Final Journal",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2177300000,
        ["px"] = 0.4349900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6009] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6623475751, ["py"] = 1.5132600402, ["pm"] = 1839, ["d"] = true,
        ["zx"] = 0.6616824197, ["zy"] = 1.5113048374, ["zm"] = 1747,
      },
    },
    ["n"] = "Research Notes: Chaotica Vampiris",
    ["cn"] = "Solitude Soliloquies",
  },
  [6012] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "The Blossoms of Maelmoth",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2218400000,
        ["px"] = 0.4150900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6013] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Report on the Despot of Markarth",
    ["e"] = {
      [1] = { ["px"] = 0.3495216008, ["py"] = 0.2852235962, ["pm"] = 1858, ["zm"] = 1814, },
    },
  },
  [6014] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "The Mysterium's Threshold",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2545500000,
        ["px"] = 0.3948500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6030] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2897200000,
        ["px"] = 0.3528300000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "The Translated Works of Tosmorn, I",
    ["cn"] = "The Reach Reader",
  },
  [6031] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2255800000,
        ["px"] = 0.4410600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Penultimate Laugh",
    ["cn"] = "Solitude Soliloquies",
  },
  [6032] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5125500000,
        ["px"] = 0.6698600000,
        ["pm"] = 1841,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5430800000,
        ["px"] = 0.6321700000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "My Beloved Siblings, the Exarchs",
    ["cn"] = "Solitude Soliloquies",
  },
  [6033] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "The Sea Giant's Landing",
    ["q"] = 6509,
    ["e"] = {
      [1] = {
        ["py"] = 0.1925100000,
        ["px"] = 0.3955600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6034] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1949600000,
        ["px"] = 0.3949500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Sea Giant's Camp",
    ["cn"] = "Western Skyrim Register",
  },
  [6035] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1944500000,
        ["px"] = 0.3910400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Sea Giant's Actions",
    ["cn"] = "Western Skyrim Register",
  },
  [6036] = {
    ["c"] = true,
    ["q"] = 6514,
    ["e"] = {
      [1] = {
        ["py"] = 0.2329100000,
        ["px"] = 0.4027300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2146100000,
        ["px"] = 0.4328200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 1.5629800000,
        ["px"] = 0.6535500000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [4] = { ["px"] = 0.6037016051, ["py"] = 0.6816448079, ["pm"] = 1940, ["zm"] = 1887, },
      [5] = { ["px"] = 0.9363960162, ["py"] = 0.3834380059, ["pm"] = 2343, ["zm"] = 2274, },
    },
    ["n"] = "Calling All Antiquarians!",
    ["cn"] = "Western Skyrim Register",
  },
  [6037] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1453000000,
        ["r"] = false,
        ["px"] = 0.0128600000,
        ["pm"] = 1783,
      },
      [2] = {
        ["py"] = 0.2403200000,
        ["px"] = 0.4514300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Jhunal the Rune God",
    ["cn"] = "Solitude Soliloquies",
  },
  [6038] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 1.5298600000,
        ["r"] = false,
        ["px"] = 0.6319100000,
        ["pm"] = 1755,
      },
    },
    ["n"] = "Things to Salvage",
    ["cn"] = "Western Skyrim Register",
  },
  [6039] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 1.5297500000,
        ["r"] = false,
        ["px"] = 0.6318400000,
        ["pm"] = 1755,
      },
    },
    ["n"] = "Scrapper's Journal",
    ["cn"] = "Western Skyrim Register",
  },
  [6040] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 1.5296800000,
        ["r"] = false,
        ["px"] = 0.6316200000,
        ["pm"] = 1755,
      },
    },
    ["n"] = "Letter to Roshilde",
    ["cn"] = "Western Skyrim Register",
  },
  [6041] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2216100000,
        ["px"] = 0.3604600000,
        ["pm"] = 1770,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
        ["zx"] = 0.3608928110, ["zy"] = 0.2218551998, ["zm"] = 1719,
      },
    },
    ["n"] = "Heiruna's Journal",
    ["cn"] = "Western Skyrim Register",
  },
  [6042] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2216300000,
        ["px"] = 0.3602700000,
        ["pm"] = 1770,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
        ["zx"] = 0.3608928110, ["zy"] = 0.2218551998, ["zm"] = 1719,
      },
    },
    ["n"] = "About That Doll",
    ["cn"] = "Western Skyrim Register",
  },
  [6043] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2213600000,
        ["px"] = 0.3601500000,
        ["pm"] = 1770,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
        ["zx"] = 0.3608928110, ["zy"] = 0.2218551998, ["zm"] = 1719,
      },
    },
    ["n"] = "Draugr and the Dragon Cult",
    ["cn"] = "Western Skyrim Register",
  },
  [6045] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2804500000,
        ["px"] = 0.3684700000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "The Translated Works of Tosmorn, II",
    ["cn"] = "The Reach Reader",
  },
  [6046] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1476500000,
        ["r"] = false,
        ["px"] = 0.0041000000,
        ["pm"] = 1749,
      },
    },
    ["n"] = "Graverobber's Lament",
    ["cn"] = "Western Skyrim Register",
  },
  [6047] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "The Translated Works of Tosmorn, III",
    ["e"] = {
      [1] = { ["px"] = 0.4006320080, ["py"] = 0.3010723971, ["pm"] = 1814, },
    },
  },
  [6048] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2496900000,
        ["px"] = 0.4001900000,
        ["pm"] = 1756,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Pale Creatures with a Taste for Flesh",
    ["cn"] = "Western Skyrim Register",
  },
  [6049] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2497600000,
        ["px"] = 0.4000600000,
        ["pm"] = 1756,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Chaurus Chant",
    ["cn"] = "Western Skyrim Register",
  },
  [6050] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Scary Tales of the Deep Folk, Book 1",
    ["e"] = {
      [1] = { ["px"] = 0.3778932046, ["py"] = 0.3113951967, ["pm"] = 1814, },
    },
  },
  [6052] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2743800000,
        ["px"] = 0.4104100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Old Nord Drinking Song",
    ["cn"] = "Solitude Soliloquies",
  },
  [6053] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2214500000,
        ["px"] = 0.3822400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2555100000,
        ["px"] = 0.4315400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "A Threnody to Lost Love",
    ["cn"] = "Solitude Soliloquies",
  },
  [6054] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2676200000,
        ["px"] = 0.4084700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2123900000,
        ["px"] = 0.4302900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Solitude: A Charred Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [6055] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2407200000,
        ["px"] = 0.3845000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Monsters of Northern Folklore",
    ["cn"] = "Solitude Soliloquies",
  },
  [6071] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5594100000,
        ["px"] = 0.6472100000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["px"] = 0.3443360000,
        ["py"] = 0.3054010000,
        ["d"] = true,
        ["pm"] = 1871,
        ["zx"] = 0.3529464073, ["zy"] = 0.3030287967, ["zm"] = 1814,
      },
    },
    ["n"] = "How to Pronounce Dwemer Words",
    ["cn"] = "Solitude Soliloquies",
  },
  [6072] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2657000000,
        ["px"] = 0.4110800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Cheeses of Skyrim: Riften, Falkreath",
    ["cn"] = "Solitude Soliloquies",
  },
  [6073] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145600000,
        ["px"] = 0.4277200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5579700000,
        ["px"] = 0.6498300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 0.2387800000,
        ["px"] = 0.3769800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Cheeses of Skyrim: Whiterun, Winterhold, Eastmarch",
    ["cn"] = "Solitude Soliloquies",
  },
  [6074] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1873300000,
        ["px"] = 0.4377700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Cheeses of Skyrim: The Reach, The Pale",
    ["cn"] = "Solitude Soliloquies",
  },
  [6075] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2225700000,
        ["px"] = 0.3807100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Cheeses of Skyrim: Hjaalmarch, Haafingar",
    ["cn"] = "Solitude Soliloquies",
  },
  [6076] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Claudina's Notes",
    ["q"] = 6471,
    ["e"] = {
      [1] = { ["px"] = 0.6579848181, ["py"] = 1.5646712362, ["pm"] = 1747, }, -- post-quest location
    },
  },
  [6077] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5371400000,
        ["px"] = 0.6318300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Frelytte and Pular: A Love Song",
    ["cn"] = "Solitude Soliloquies",
  },
  [6078] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2228400000,
        ["px"] = 0.3844400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["px"] = 0.3606139892, ["py"] = 0.2215715982, ["pm"] = 1770, ["d"] = true,
        ["zx"] = 0.3608928110, ["zy"] = 0.2218551998, ["zm"] = 1719,
      },
    },
    ["n"] = "Nord War Song",
    ["cn"] = "Solitude Soliloquies",
  },
  [6079] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2528500000,
        ["px"] = 0.4297600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Archery Competition",
    ["cn"] = "Western Skyrim Register",
  },
  [6080] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Nord Cuisine: Sweets Edition",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6925596182, ["py"] = 1.5594300398, ["pm"] = 1747, },
    },
    ["m"] = {
      [38] = 1,
    },
  },
  [6081] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2621600000,
        ["px"] = 0.4061500000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Nord Cuisine: Savory Edition",
    ["cn"] = "Solitude Soliloquies",
  },
  [6084] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2601200000,
        ["px"] = 0.4282900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2492600000,
        ["px"] = 0.4579000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 0.2315000000,
        ["px"] = 0.4452900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Pilfered Poison",
    ["cn"] = "Western Skyrim Register",
  },
  [6085] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5170900000,
        ["px"] = 0.6645100000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Dictate of Renewal",
    ["cn"] = "Solitude Soliloquies",
  },
  [6101] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1495500000,
        ["r"] = false,
        ["px"] = 0.0046900000,
        ["pm"] = 1749,
      },
      [2] = {
        ["py"] = 0.2266700000,
        ["px"] = 0.4157200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Song of Gods",
    ["cn"] = "Solitude Soliloquies",
  },
  [6102] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145900000,
        ["px"] = 0.4353700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Ateian Fife",
    ["cn"] = "Solitude Soliloquies",
  },
  [6103] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2146100000,
        ["px"] = 0.4352800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Shriek-of-Silk",
    ["cn"] = "Solitude Soliloquies",
  },
  [6104] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2848000000,
        ["px"] = 0.5413800000,
        ["pm"] = 1719,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
        ["mn"] = 38,
      },
      [2] = {
        ["py"] = 0.2145500000,
        ["px"] = 0.4353800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Kothringi Leviathan Horn",
    ["cn"] = "Solitude Soliloquies",
  },
  [6105] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2145700000,
        ["px"] = 0.4353400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Callisos' Lodestone",
    ["cn"] = "Solitude Soliloquies",
  },
  [6106] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2280600000,
        ["px"] = 0.4291600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Ode to the Founding",
    ["cn"] = "Solitude Soliloquies",
  },
  [6107] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2846900000,
        ["px"] = 0.5412000000,
        ["pm"] = 1719,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
        ["mn"] = 38,
      },
    },
    ["n"] = "Dozzen Talharpa",
    ["cn"] = "Solitude Soliloquies",
  },
  [6108] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3444356009, ["py"] = 0.2879819962, ["pm"] = 1858, ["zm"] = 1814, },
      [2] = { ["px"] = 0.5988772049, ["py"] = 0.6804448071, ["pm"] = 1940, ["zm"] = 1887, },
      [3] = { ["px"] = 0.9441083800, ["py"] = 0.3922503960, ["pm"] = 2343, ["pm"] = 2274, },
    },
    ["n"] = "Which Guild is for You?",
    ["cn"] = "The Reach Reader",
  },
  [6110] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Kelbarn's To-Do List",
    ["q"] = 6533,
    ["e"] = {
      [1] = {
        ["py"] = 1.5574700000,
        ["px"] = 0.6612800000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5658800000,
        ["px"] = 0.6685800000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 1.5545400000,
        ["px"] = 0.6612000000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [4] = {
        ["py"] = 1.5632500000,
        ["px"] = 0.6641100000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6111] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2497300000,
        ["px"] = 0.4001600000,
        ["pm"] = 1756,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Pentarch's Orders",
    ["cn"] = "Solitude Soliloquies",
  },
  [6112] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2497300000,
        ["px"] = 0.4001500000,
        ["pm"] = 1756,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Assassin's Letter",
    ["cn"] = "Solitude Soliloquies",
  },
  [6113] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Letter to Irm",
    ["q"] = 6534,
    ["e"] = {
      [1] = {
        ["py"] = 1.5336700000,
        ["px"] = 0.6309900000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5524100000,
        ["px"] = 0.6366000000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 1.5449900000,
        ["px"] = 0.6485400000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [4] = {
        ["py"] = 1.5350200000,
        ["px"] = 0.6465400000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6114] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "Ingfred's Work Order",
    ["q"] = 6535,
    ["e"] = {
      [1] = {
        ["py"] = 1.5246400000,
        ["px"] = 0.6841800000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5369000000,
        ["px"] = 0.6748200000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["py"] = 1.5248200000,
        ["px"] = 0.6752800000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6115] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5605300000,
        ["px"] = 0.6616100000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5541800000,
        ["px"] = 0.6587900000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Report for Bitterblade",
    ["cn"] = "Solitude Soliloquies",
  },
  [6116] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Scribbled Notes, Stone Garden",
    ["e"] = {
      [1] = {
        ["px"] = 0.6441028032, ["py"] = 1.5179016431, ["pm"] = 1786, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [6117] = {
    ["c"] = true,
    ["cn"] = "Notes and Memos",
    ["n"] = "Confused Correspondence from Fjurig",
    ["e"] = {
      [1] = {
        ["px"] = 0.6461420094, ["py"] = 1.5182051564, ["pm"] = 1787,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
        ["d"] = true,
      },
    },
  },
  [6118] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "Stone Garden Dissection Notes",
    ["e"] = {
      [1] = {
        ["px"] = 0.6463128094, ["py"] = 1.5177127564, ["pm"] = 1787, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [6119] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "To the Kind Stranger Who Finds This",
    ["q"] = 6538,
    ["e"] = {
      [1] = {
        ["py"] = 1.5343400000,
        ["px"] = 0.6941400000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 1.5276700000,
        ["px"] = 0.6973500000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = { ["px"] = 0.6887504218, ["py"] = 1.5362088380, ["pm"] = 1747, },
    },
  },
  [6120] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5595900000,
        ["px"] = 0.6533000000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Exploits of Miss Claudina Ildene",
    ["cn"] = "Western Skyrim Register",
  },
  [6122] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6623599751, ["py"] = 1.5132676402, ["pm"] = 1839, ["d"] = true,
        ["zx"] = 0.6616824197, ["zy"] = 1.5113048374, ["zm"] = 1747,
      },
    },
    ["n"] = "Words of Entry",
    ["cn"] = "Solitude Soliloquies",
  },
  [6123] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5385800000,
        ["px"] = 0.6466000000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Directions to Cure, First Clue",
    ["cn"] = "Western Skyrim Register",
  },
  [6124] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5400500000,
        ["px"] = 0.6497700000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Directions to Cure, Second Clue",
    ["cn"] = "Western Skyrim Register",
  },
  [6125] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5377900000,
        ["px"] = 0.6512300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Directions to Cure, Final Clue",
    ["cn"] = "Western Skyrim Register",
  },
  [6126] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5130900000,
        ["px"] = 0.6624600000,
        ["pm"] = 1839,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Research Notes: The Heir of Verandis",
    ["cn"] = "Solitude Soliloquies",
  },
  [6128] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5425900000,
        ["px"] = 0.6432700000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Rasir's Journal, Page 2",
    ["cn"] = "Western Skyrim Register",
  },
  [6129] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5411100000,
        ["px"] = 0.6420000000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Rasir's Journal, Page 5",
    ["cn"] = "Western Skyrim Register",
  },
  [6130] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5406600000,
        ["px"] = 0.6416400000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Rasir's Journal, Page 8",
    ["cn"] = "Western Skyrim Register",
  },
  [6131] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1980000000,
        ["px"] = 0.3987800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Pale Man",
    ["cn"] = "Solitude Soliloquies",
  },
  [6178] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1886400000,
        ["px"] = 0.4264900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Convergence of Maestros, Volume 1",
    ["cn"] = "Solitude Soliloquies",
  },
  [6179] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1914000000,
        ["px"] = 0.4102400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Convergence of Maestros, Volume 2",
    ["cn"] = "Solitude Soliloquies",
  },
  [6210] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Ecology of the Death Hound",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6798084211, ["py"] = 1.5191088372, ["pm"] = 1747, },
    },
    ["m"] = {
      [13] = 1,
    },
  },
  [6211] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 0.1473700000,
        ["r"] = false,
        ["px"] = 0.0106200000,
        ["pm"] = 1783,
      },
    },
    ["n"] = "The Reach's Progress",
    ["cn"] = "Solitude Soliloquies",
  },
  [6216] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5565900000,
        ["px"] = 0.6495300000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2184800000,
        ["px"] = 0.4391700000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter from the Skald-King's Agent",
    ["cn"] = "Solitude Soliloquies",
  },
  [6217] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2187200000,
        ["px"] = 0.4395000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter from Lyris",
    ["cn"] = "Western Skyrim Register",
  },
  [6218] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2148400000,
        ["px"] = 0.4270000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Letter to Dorbin",
    ["cn"] = "Western Skyrim Register",
  },
  [6219] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Maelmoth's Marvelous Masterpiece",
    ["q"] = 6510,
    ["e"] = {
      [1] = {
        ["py"] = 0.2219600000,
        ["px"] = 0.4414400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
  },
  [6220] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2186500000,
        ["px"] = 0.4272300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Scandals of Solitude's Royalty",
    ["cn"] = "Solitude Soliloquies",
  },
  [6221] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2218500000,
        ["px"] = 0.4383800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Anjuld's Journal",
    ["cn"] = "Solitude Soliloquies",
  },
  [6222] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2521100000,
        ["px"] = 0.4438800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Journal of a Telvanni Emissary",
    ["cn"] = "Solitude Soliloquies",
  },
  [6223] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2645200000,
        ["px"] = 0.3959600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2179500000,
        ["px"] = 0.3883400000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "On Harrowstorms",
    ["cn"] = "Solitude Soliloquies",
  },
  [6224] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2202900000,
        ["px"] = 0.4058100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["px"] = 0.4253983866, ["py"] = 0.1998212003, ["pm"] = 1752, ["d"] = true,
        ["zx"] = 0.4192188112, ["zy"] = 0.2002276016, ["zm"] = 1719,
      },
    },
    ["n"] = "Divines and the Nords",
    ["cn"] = "Solitude Soliloquies",
  },
  [6225] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2503100000,
        ["px"] = 0.4543000000,
        ["pm"] = 1754,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2121200000,
        ["px"] = 0.4287600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "The Tower of the Wolf",
    ["cn"] = "Solitude Soliloquies",
  },
  [6226] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1970100000,
        ["px"] = 0.4728900000,
        ["pm"] = 1750,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2127700000,
        ["px"] = 0.4005900000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Travels Around the Western Holds",
    ["cn"] = "Solitude Soliloquies",
  },
  [6227] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5582700000,
        ["px"] = 0.6571400000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Blackreach: Fictions and Facts",
    ["cn"] = "Solitude Soliloquies",
  },
  [6228] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "The Wolf of Solitude",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4041076097, ["py"] = 0.1941976014, ["pm"] = 1719, },
    },
    ["m"] = {
      [38] = 3,
    },
  },
  [6229] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2412200000,
        ["px"] = 0.4028300000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Guide to Western Skyrim: Haafingar",
    ["cn"] = "Solitude Soliloquies",
  },
  [6230] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2464100000,
        ["px"] = 0.4239000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["px"] = 0.6623499751, ["py"] = 1.5132504402, ["pm"] = 1839, ["d"] = true,
        ["zx"] = 0.6616824197, ["zy"] = 1.5113048374, ["zm"] = 1747,
      },
    },
    ["n"] = "Solitude Bedtime Stories",
    ["cn"] = "Solitude Soliloquies",
  },
  [6231] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2599100000,
        ["px"] = 0.4592800000,
        ["pm"] = 1774,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.1996800000,
        ["px"] = 0.4190800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Hydrik Deep-Delve's Wit and Wisdom",
    ["cn"] = "Solitude Soliloquies",
  },
  [6232] = {
    ["c"] = true,
    ["cn"] = "Solitude Soliloquies",
    ["n"] = "Investigator Vale and the Sober Nord",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["d"] = true,
        ["i"] = INTERACTION_BOOK,
        ["py"] = 1.5297500000,
        ["r"] = true,
        ["px"] = 0.6317900000,
        ["pm"] = 1755,
      },
      [2] = { ["px"] = 0.3446755986, ["py"] = 0.3060951967, ["pm"] = 1871, ["d"] = true, ["zx"] = 0.3529464073, ["zy"] = 0.3030287967, ["zm"] = 1814, ["ld"] = 10, }, -- 1/2 Briar Rock Crypts
      [3] = { ["px"] = 0.3467967998, ["py"] = 0.3064615956, ["pm"] = 1870, ["fp"] = true, }, -- 2/2 Briar Rock Crypts
      [4] = { ["px"] = 0.0713760028, ["py"] = 0.6033084052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["m"] = {
      [24] = 1,
    },
  },
  [6233] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6899052189, ["py"] = 1.5394916388, ["pm"] = 1747, },
    },
    ["n"] = "Scared Little Snow Moth",
    ["cn"] = "Solitude Soliloquies",
  },
  [6234] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5599700000,
        ["px"] = 0.6550100000,
        ["pm"] = 1747,
        ["mn"] = 39,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2145600000,
        ["px"] = 0.4276800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [3] = {
        ["d"] = true,
        ["i"] = 12,
        ["py"] = 1.5299000000,
        ["r"] = false,
        ["px"] = 0.6317500000,
        ["pm"] = 1755,
      },
    },
    ["n"] = "Holy Sweetroll Liturgy",
    ["cn"] = "Solitude Soliloquies",
  },
  [6235] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2521500000,
        ["px"] = 0.3973200000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
      [2] = {
        ["py"] = 0.2720800000,
        ["px"] = 0.3873100000,
        ["pm"] = 1772,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Guide to Western Skyrim: Hjaalmarch",
    ["cn"] = "Solitude Soliloquies",
  },
  [6236] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.6651472047, ["py"] = 1.5359475611, ["pm"] = 1751, ["d"] = true,
        ["zx"] = 0.6649436204, ["zy"] = 1.5540808403, ["zm"] = 1747,
      },
    },
    ["n"] = "Guide to Western Skyrim: Karthald",
    ["cn"] = "Solitude Soliloquies",
  },
  [6237] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.4090087876, ["py"] = 0.3208504072, ["pm"] = 1862, ["d"] = true,
        ["zx"] = 0.4078288071, ["zy"] = 0.3181875992, ["zm"] = 1814,
      },
    },
    ["n"] = "Senan's Note",
    ["cn"] = "The Reach Reader",
  },
  [6238] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3144800000,
        ["px"] = 0.4141000000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter to Pentarch Draljura",
    ["cn"] = "The Reach Reader",
  },
  [6239] = {
    ["c"] = false,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Letter of Welcome",
    ["e"] = {
    },
  },
  [6240] = {
    ["c"] = false,
    ["cn"] = "The Reach Reader",
    ["n"] = "The Library of Arkthzand",
    ["e"] = {
    },
  },
  [6241] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6971900183, ["py"] = 1.5336676372, ["pm"] = 1747, },
    },
    ["n"] = "Pickle's Treats",
    ["cn"] = "Solitude Soliloquies",
  },
  [6242] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2578000000,
        ["px"] = 0.3845600000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Necessities for Successful Negotiations",
    ["cn"] = "Western Skyrim Register",
  },
  [6243] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2608700000,
        ["px"] = 0.3880800000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Food Item List for Travel",
    ["cn"] = "Western Skyrim Register",
  },
  [6244] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "To My Dear Friend",
    ["q"] = 6549,
    ["e"] = {
      [1] = { ["px"] = 0.1530475985, ["py"] = 0.2379744006, ["pm"] = 10, },
    },
  },
  [6245] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2873600000,
        ["px"] = 0.3427500000,
        ["pm"] = 1858,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
        ["zm"] = 1814,
      },
    },
    ["n"] = "Work for Hire in Markarth",
    ["cn"] = "The Reach Reader",
  },
  [6246] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2324100000,
        ["px"] = 0.3657000000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "A History of Mor Khazgur",
    ["cn"] = "Western Skyrim Register",
  },
  [6247] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2909900000,
        ["px"] = 0.3537900000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Scary Tales of the Deep Folk, Book 2",
    ["cn"] = "The Reach Reader",
  },
  [6249] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.1981500000,
        ["px"] = 0.3991100000,
        ["pm"] = 1719,
        ["mn"] = 38,
        ["d"] = false,
        ["i"] = 12,
        ["r"] = false,
      },
    },
    ["n"] = "Sea Giant Predation",
    ["cn"] = "Western Skyrim Register",
  },
  [6250] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Verandis's Journal",
    ["q"] = 6555,
    ["e"] = {
      [1] = { ["px"] = 0.2594268012, ["py"] = 0.1292268009, ["pm"] = 1868, ["d"] = true, },
    },
  },
  [6251] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5739100000,
        ["px"] = 0.6024200000,
        ["pm"] = 1850,
        ["mn"] = 41,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Void Portals",
    ["cn"] = "The Reach Reader",
  },
  [6252] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Undaunted Need You!",
    ["e"] = {
      [1] = { ["px"] = 0.7915899993, ["py"] = 0.4375444085, ["pm"] = 24, },
      [2] = { ["px"] = 0.0706416007, ["py"] = 0.3838684078, ["pm"] = 1, },
      [3] = { ["px"] = 0.2397768018, ["py"] = 0.7334356212, ["pm"] = 243, },
      [4] = { ["px"] = 0.7660343723, ["py"] = 0.3722679981, ["pm"] = 1287, },
      [5] = { ["px"] = 0.0712072039, ["py"] = 0.7486172005, ["pm"] = 1349, },
      [6] = { ["px"] = 0.5648263727, ["py"] = 0.6244903963, ["pm"] = 1576, },
      [7] = { ["px"] = 0.4230880140, ["py"] = 0.2180412007, ["pm"] = 1719, },
      [8] = { ["px"] = 0.6093396052, ["py"] = 0.6771480073, ["pm"] = 1940, },
      [9] = { ["px"] = 0.0709308026, ["py"] = 0.6023104052, ["pm"] = 2163, },
      [10] = { ["px"] = 0.9414088162, ["py"] = 0.3932148050, ["pm"] = 2343, },
    },
  },
  [6253] = {
    ["c"] = true,
    ["cn"] = "Research Notes",
    ["n"] = "The Vitalizer Fluid Must Flow",
    ["e"] = {
      [1] = {
        ["px"] = 0.6438836032, ["py"] = 1.5178692431, ["pm"] = 1786, ["d"] = true,
        ["zx"] = 0.6462408183, ["zy"] = 1.5204704369, ["zm"] = 1747,
      },
    },
  },
  [6254] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Journal of Dionus Trutor",
    ["q"] = 6566,
    ["e"] = {
      [1] = { ["px"] = 0.3387960057, ["py"] = 0.2884968024, ["pm"] = 1856, ["d"] = true, },
      [2] = { ["px"] = 0.3403076011, ["py"] = 0.2865647960, ["pm"] = 1858, ["zm"] = 1814, ["fp"] = true, }, -- additional pin on main map
    },
  },
  [6255] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2848800000,
        ["px"] = 0.3635000000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Gray Host Intelligence Dispatch",
    ["cn"] = "The Reach Reader",
  },
  [6256] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2943300000,
        ["px"] = 0.3673400000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "The Gray Host: A History Part 1",
    ["cn"] = "The Reach Reader",
  },
  [6257] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Master Pythis's Journal",
    ["q"] = 6575,
    ["e"] = {
      [1] = {
        ["px"] = 0.3963591947, ["py"] = 0.3190340024, ["pm"] = 1892,
        ["zx"] = 0.3972876081, ["zy"] = 0.3073783948, ["zm"] = 1814,
        ["d"] = true,
      },
    },
  },
  [6258] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "A Promise and a Warning",
    ["e"] = {
      [1] = { ["px"] = 0.6314679724, ["py"] = 1.5965352058, ["pm"] = 1850, },
    },
  },
  [6259] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Spectral Assassins",
    ["e"] = {
      [1] = { ["px"] = 0.2569755976, ["py"] = 0.1300488003, ["pm"] = 1866, ["d"] = true, },
    },
  },
  [6260] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "High Chancellor's Papers: The Tagh Droiloch",
    ["e"] = {
      [1] = {
        ["px"] = 0.3411507884, ["py"] = 0.5458876126, ["pm"] = 1875, ["d"] = true,
        ["zx"] = 0.3511060128, ["zy"] = 0.5474352126, ["zm"] = 1006,
      },
    },
  },
  [6261] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5459100000,
        ["px"] = 0.3409900000,
        ["pm"] = 1875,
        ["d"] = true,
        ["r"] = false,
        ["i"] = 12,
        ["zx"] = 0.3511060128, ["zy"] = 0.5474352126, ["zm"] = 1006,
      },
    },
    ["n"] = "Imperial Decree Regarding the Elder Council",
    ["cn"] = "Library of Incunabula",
  },
  [6262] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5460000000,
        ["px"] = 0.3408000000,
        ["pm"] = 1875,
        ["d"] = true,
        ["i"] = 12,
        ["r"] = false,
        ["zx"] = 0.3511060128, ["zy"] = 0.5474352126, ["zm"] = 1006,
      },
    },
    ["n"] = "The Crowned Dragon",
    ["cn"] = "Library of Incunabula",
  },
  [6267] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Final Will and Testament of Fovus Rivul",
    ["e"] = {
      [1] = {
        ["px"] = 0.7028816207, ["py"] = 0.5128944120, ["pm"] = 2042, ["d"] = true,
        ["zx"] = 0.7102587997, ["zy"] = 0.5125804198, ["zm"] = 13,
      },
    },
  },
  [6268] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5125000000,
        ["px"] = 0.7077600000,
        ["pm"] = 1966,
        ["d"] = true,
        ["r"] = false,
        ["i"] = 12,
      },
      [2] = { ["px"] = 0.7045100207, ["py"] = 0.5123936120, ["pm"] = 2042, ["zx"] = 0.7102587997, ["zy"] = 0.5125804198, ["zm"] = 13, ["d"] = true, },
    },
    ["n"] = "Hidden Diary",
    ["cn"] = "Library of Incunabula",
  },
  [6269] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.5124400000,
        ["px"] = 0.7059700000,
        ["pm"] = 1962,
        ["d"] = true,
        ["r"] = false,
        ["i"] = 12,
      },
      [2] = {
        ["px"] = 0.7030692208, ["py"] = 0.5125668121, ["pm"] = 2042, ["d"] = true,
        ["zx"] = 0.7102587997, ["zy"] = 0.5125804198, ["zm"] = 13,
      },
    },
    ["n"] = "Operations Report: West Narsis Mining Concern",
    ["cn"] = "Library of Incunabula",
  },
  [6270] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "A Tale of the Dauntless Bananas",
    ["e"] = {
      [1] = { ["px"] = 0.5289760038, ["py"] = 0.5589803885, ["pm"] = 576, ["zm"] = 16, },
      [2] = { ["px"] = 0.5541680147, ["py"] = 0.5244371994, ["pm"] = 16, },
    },
  },
  [6271] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Sonnet of Aetherius Art",
    ["e"] = {
      [1] = { ["px"] = -0.0956420017, ["py"] = 0.2605116033, ["pm"] = 422, ["zm"] = 255, },
    },
  },
  [6272] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "The Nomads of Nirn",
    ["e"] = {
      [1] = { ["px"] = 0.7437780069, ["py"] = 0.4519640104, ["pm"] = 511, ["zm"] = 7, },
    },
  },
  [6273] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Goldleaf Acquisitions, Manager's Notes",
    ["e"] = {
      [1] = { ["px"] = 0.6353128277, ["py"] = 0.2670923994, ["pm"] = 160, ["zm"] = 61, },
    },
  },
  [6275] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "In the Deep Tombs",
    ["e"] = {
      [1] = {
        ["px"] = 0.3749147940, ["py"] = 0.3004303955, ["pm"] = 1926,
        ["zx"] = 0.3745544084, ["zy"] = 0.3007143947, ["zm"] = 1814,
        ["d"] = true,
      },
    },
  },
  [6276] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "House Ravenwatch Contract",
    ["e"] = {
      [1] = { ["px"] = 0.2270076011, ["py"] = 0.7423520219, ["pm"] = 243, ["zm"] = 143, },
      [2] = { ["px"] = 0.0611428009, ["py"] = 0.3845360062, ["pm"] = 63, ["zm"] = 1, },
    },
  },
  [6308] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2854600000,
        ["px"] = 0.3446800000,
        ["pm"] = 1858,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
        ["zm"] = 1814,
      },
    },
    ["n"] = "The Reach Food Letters",
    ["cn"] = "The Reach Reader",
  },
  [6309] = {
    ["c"] = true,
    ["cn"] = "Western Skyrim Register",
    ["n"] = "An Introduction to Circle Correspondence",
    ["e"] = {
      [1] = { ["px"] = 0.4356596007, ["py"] = 0.2155080015, ["pm"] = 1773, ["zm"] = 1719, },
    },
  },
  [6310] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3091800000,
        ["px"] = 0.3733100000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter from Sister Glynolde",
    ["cn"] = "The Reach Reader",
  },
  [6311] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 1.5957000000,
        ["px"] = 0.6162000000,
        ["pm"] = 1850,
        ["mn"] = 41,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "On Dwarven Dynastors",
    ["cn"] = "The Reach Reader",
  },
  [6312] = {
    ["c"] = false,
    ["cn"] = "The Reach Reader",
    ["n"] = "Letter from Lady Belain",
    ["e"] = {
    },
  },
  [6313] = {
    ["c"] = false,
    ["cn"] = "The Reach Reader",
    ["n"] = "Letter from the Intended Couple",
    ["e"] = {
    },
  },
  [6316] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 1",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6179339695, ["py"] = 1.5638668051, ["pm"] = 1850, },
    },
  },
  [6317] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 2",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6093743714, ["py"] = 1.5664876054, ["pm"] = 1850, },
    },
  },
  [6318] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 3",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6070115714, ["py"] = 1.5728932051, ["pm"] = 1850, },
    },
  },
  [6319] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 4",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6049543714, ["py"] = 1.5764692046, ["pm"] = 1850, },
    },
  },
  [6320] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 5",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6088187707, ["py"] = 1.5861820059, ["pm"] = 1850, },
    },
  },
  [6321] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 6",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6127683713, ["py"] = 1.5950628052, ["pm"] = 1850, },
    },
  },
  [6322] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Notes, Page 7",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6227399706, ["py"] = 1.5737376054, ["pm"] = 1850, },
    },
  },
  [6323] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Falkfyr's Complete Report",
    ["q"] = 6591,
    ["e"] = {
      [1] = { ["px"] = 0.6228071722, ["py"] = 1.5737744057, ["pm"] = 1850, },
    },
  },
  [6354] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Scary Tales of the Deep Folk, Book 3",
    ["e"] = {
      [1] = { ["px"] = 0.6186987698, ["py"] = 1.5631800050, ["pm"] = 1850, },
    },
  },
  [6355] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2848400000,
        ["px"] = 0.3633300000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Scary Tales of the Druadach, Book 1",
    ["cn"] = "The Reach Reader",
  },
  [6356] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3007700000,
        ["px"] = 0.3690600000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Scary Tales of the Druadach, Book 2",
    ["cn"] = "The Reach Reader",
  },
  [6357] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3806876082, ["py"] = 0.3080011976, ["pm"] = 1814, },
    },
    ["n"] = "Scary Tales of the Druadach, Book 3",
    ["cn"] = "The Reach Reader",
  },
  [6358] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2843300000,
        ["px"] = 0.3653700000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter to Apprentice Gwerina",
    ["cn"] = "The Reach Reader",
  },
  [6359] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2504900000,
        ["px"] = 0.3591800000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Letter from Ansdurran",
    ["cn"] = "The Reach Reader",
  },
  [6360] = {
    ["c"] = false,
    ["cn"] = "The Reach Reader",
    ["n"] = "Letter to Kitza-Enoo",
    ["e"] = {
    },
  },
  [6361] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Red Eagle's Song",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3772472081, ["py"] = 0.2842383964, ["pm"] = 1814, },
    },
    ["m"] = {
      [42] = 2,
    },
  },
  [6362] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2588300000,
        ["px"] = 0.3581200000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Reach Witch Chant",
    ["cn"] = "The Reach Reader",
  },
  [6363] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Hail to the Ancient Spirits",
    ["e"] = {
      [1] = { ["px"] = 0.3804848069, ["py"] = 0.2666599968, ["pm"] = 1814, },
    },
  },
  [6364] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "We Rise to Fight Again",
    ["e"] = {
      [1] = { ["px"] = 0.3754348021, ["py"] = 0.2863947956, ["pm"] = 1814, },
    },
  },
  [6365] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2767500000,
        ["px"] = 0.3654600000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Reach Hunting Hymn",
    ["cn"] = "The Reach Reader",
  },
  [6366] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5957995775, ["py"] = 1.5733900015, ["pm"] = 1902, ["d"] = true,
      },
    },
    ["n"] = "The Containment Apparatus",
    ["cn"] = "The Reach Reader",
  },
  [6382] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2609900000,
        ["px"] = 0.3798900000,
        ["pm"] = 1854,
        ["d"] = true,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Orders from R",
    ["cn"] = "The Reach Reader",
  },
  [6383] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2968300000,
        ["px"] = 0.3858000000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "A Year Among the Eagleseer Clan",
    ["cn"] = "The Reach Reader",
  },
  [6384] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3098200000,
        ["px"] = 0.3581800000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "The Battle of Karthspire Lea",
    ["cn"] = "The Reach Reader",
  },
  [6385] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.3100700000,
        ["px"] = 0.3737100000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Flora and Fauna of the Druadach Mountains",
    ["cn"] = "The Reach Reader",
  },
  [6386] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Reach Bedtime Stories",
    ["e"] = {
      [1] = { ["px"] = 0.3437904009, ["py"] = 0.2856807960, ["pm"] = 1858, ["zm"] = 1814, },
    },
  },
  [6387] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3972919999, ["py"] = 0.3068404041, ["pm"] = 1892, ["d"] = true, },
      [2] = { ["px"] = 0.3972876081, ["py"] = 0.3073783948, ["pm"] = 1814, ["fp"] = true, },
    },
    ["n"] = "Calis's Journal",
    ["cn"] = "The Reach Reader",
  },
  [6388] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "The Translated Works of Tosmorn, IV",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3812032034, ["py"] = 0.2802763976, ["pm"] = 1814, },
    },
    ["m"] = {
      [41] = 2,
    },
  },
  [6391] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Dread Lady's Letter",
    ["q"] = 6612,
    ["e"] = {
      [1] = {
        ["py"] = 0.3842900000,
        ["px"] = 0.0671100000,
        ["pm"] = 63,
        ["mn"] = 2,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
      [2] = {
        ["py"] = 0.6658500000,
        ["px"] = 0.3785100000,
        ["pm"] = 22,
        ["mn"] = 8,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 7,
      },
    },
  },
  [6392] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Living on the Karth River",
    ["e"] = {
      [1] = { ["px"] = 0.3539592046, ["py"] = 0.2895815958, ["pm"] = 1814, },
    },
  },
  [6393] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Legend of Arkthzand",
    ["r"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3392403968, ["py"] = 0.2875647961, ["pm"] = 1888,
        ["zx"] = 0.3403076011, ["zy"] = 0.2865647960, ["zm"] = 1858,
        ["d"] = true,
      },
      [2] = { ["px"] = 0.3403076011, ["py"] = 0.2865647960, ["pm"] = 1858, ["zm"] = 1814, ["fp"] = true, }, -- additional pin on main map
    },
    ["m"] = {
      [42] = 1,
    },
  },
  [6394] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Werewolves: Long-Suffering Guardians",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.4086552041, ["py"] = 0.3137151955, ["pm"] = 1814, },
    },
    ["m"] = {
      [42] = 1,
    },
  },
  [6395] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.3426200000,
        ["py"] = 0.2874700000,
        ["pm"] = 1858,
        ["zm"] = 1814,
      },
    },
    ["n"] = "An Imperial in Markarth",
    ["cn"] = "The Reach Reader",
  },
  [6396] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Great Spirits of the Reach: Volume 1",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3540864044, ["py"] = 0.2482779976, ["pm"] = 1814, },
    },
    ["m"] = {
      [42] = 1,
    },
  },
  [6397] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Investigator Vale in the Reach",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3793396059, ["py"] = 0.2708223982, ["pm"] = 1814, },
      [2] = { ["px"] = 0.0712772029, ["py"] = 0.6032456053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["m"] = {
      [41] = 1,
    },
  },
  [6399] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Vlindrel Hall Bill of Lading",
    ["e"] = {
      [1] = { ["px"] = 0.3445404014, ["py"] = 0.2830007961, ["pm"] = 1858, ["zm"] = 1814, },
    },
  },
  [6445] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Councilor Jirich's Records",
    ["q"] = 6615,
    ["e"] = {
      [1] = { ["px"] = 0.6045240050, ["py"] = 0.6792100073, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6446] = {
    ["c"] = true,
    ["cn"] = "Mysteries and Clues",
    ["n"] = "Deciphered Imperial Document",
    ["q"] = 6612,
    ["e"] = {
      [1] = {
        ["py"] = 0.7421800000,
        ["px"] = 0.4389100000,
        ["pm"] = 445,
        ["mn"] = 7,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
  },
  [6447] = {
    ["c"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.3814180048, ["py"] = 0.2793443956, ["pm"] = 1814, },
    },
    ["n"] = "Namira's Dance",
    ["cn"] = "The Reach Reader",
  },
  [6449] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tenarei's Contract",
    ["q"] = 6626,
    ["e"] = {
      [1] = { ["px"] = 0.6299668080, ["py"] = 0.7134668115, ["pm"] = 1887, ["qp"] = true, },
    },
  },
  [6450] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tattered Trader's Log",
    ["q"] = 6623,
    ["e"] = {
      [1] = { ["px"] = 0.6420439739, ["py"] = 0.6378875946, ["pm"] = 1985, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6420439739, ["py"] = 0.6378875946, ["pm"] = 1986, ["sm"] = 1985, ["fp"] = true, },
      [3] = { ["px"] = 0.6420439739, ["py"] = 0.6378875946, ["pm"] = 1987, ["sm"] = 1985, ["fp"] = true, },
      [4] = { ["px"] = 0.6420439739, ["py"] = 0.6378875946, ["pm"] = 1988, ["sm"] = 1985, ["fp"] = true, },
      [5] = { ["px"] = 0.6420439739, ["py"] = 0.6378875946, ["pm"] = 1989, ["sm"] = 1985, ["fp"] = true, },
    },
  },
  [6451] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Rebel's Faded Letter",
    ["q"] = 6623,
    ["e"] = {
      [1] = { ["px"] = 0.6420044250, ["py"] = 0.6377708072, ["pm"] = 1986, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6420044250, ["py"] = 0.6377708072, ["pm"] = 1985, ["sm"] = 1986, ["fp"] = true, },
      [3] = { ["px"] = 0.6420044250, ["py"] = 0.6377708072, ["pm"] = 1987, ["sm"] = 1986, ["fp"] = true, },
      [4] = { ["px"] = 0.6420044250, ["py"] = 0.6377708072, ["pm"] = 1988, ["sm"] = 1986, ["fp"] = true, },
      [5] = { ["px"] = 0.6420044250, ["py"] = 0.6377708072, ["pm"] = 1989, ["sm"] = 1986, ["fp"] = true, },
    },
  },
  [6452] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Lovingly Written Note",
    ["q"] = 6623,
    ["e"] = {
      [1] = { ["px"] = 0.6421315999, ["py"] = 0.6379479900, ["pm"] = 1987, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6421315999, ["py"] = 0.6379479900, ["pm"] = 1985, ["sm"] = 1987, ["fp"] = true, },
      [3] = { ["px"] = 0.6421315999, ["py"] = 0.6379479900, ["pm"] = 1986, ["sm"] = 1987, ["fp"] = true, },
      [4] = { ["px"] = 0.6421315999, ["py"] = 0.6379479900, ["pm"] = 1988, ["sm"] = 1987, ["fp"] = true, },
      [5] = { ["px"] = 0.6421315999, ["py"] = 0.6379479900, ["pm"] = 1989, ["sm"] = 1987, ["fp"] = true, },
    },
  },
  [6453] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Bazaar Directory",
    ["e"] = {
      [1] = { ["px"] = 0.6421096200, ["py"] = 0.6378952133, ["pm"] = 1988, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6421096200, ["py"] = 0.6378952133, ["pm"] = 1985, ["sm"] = 1988, ["fp"] = true, },
      [3] = { ["px"] = 0.6421096200, ["py"] = 0.6378952133, ["pm"] = 1986, ["sm"] = 1988, ["fp"] = true, },
      [4] = { ["px"] = 0.6421096200, ["py"] = 0.6378952133, ["pm"] = 1987, ["sm"] = 1988, ["fp"] = true, },
      [5] = { ["px"] = 0.6421096200, ["py"] = 0.6378952133, ["pm"] = 1989, ["sm"] = 1988, ["fp"] = true, },
    },
  },
  [6454] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Ralos's Charred Journal",
    ["e"] = {
      [1] = { ["px"] = 0.6421928027, ["py"] = 0.6378788043, ["pm"] = 1989, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6421928027, ["py"] = 0.6378788043, ["pm"] = 1985, ["sm"] = 1989, ["fp"] = true, },
      [3] = { ["px"] = 0.6421928027, ["py"] = 0.6378788043, ["pm"] = 1986, ["sm"] = 1989, ["fp"] = true, },
      [4] = { ["px"] = 0.6421928027, ["py"] = 0.6378788043, ["pm"] = 1987, ["sm"] = 1989, ["fp"] = true, },
      [5] = { ["px"] = 0.6421928027, ["py"] = 0.6378788043, ["pm"] = 1988, ["sm"] = 1989, ["fp"] = true, },
    },
  },
  [6455] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Quentin's Secret Correspondence",
    ["e"] = {
      [1] = { ["px"] = 0.6422512028, ["py"] = 0.6379572043, ["pm"] = 1989, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6422512028, ["py"] = 0.6379572043, ["pm"] = 1985, ["sm"] = 1989, ["fp"] = true, },
      [3] = { ["px"] = 0.6422512028, ["py"] = 0.6379572043, ["pm"] = 1986, ["sm"] = 1989, ["fp"] = true, },
      [4] = { ["px"] = 0.6422512028, ["py"] = 0.6379572043, ["pm"] = 1987, ["sm"] = 1989, ["fp"] = true, },
      [5] = { ["px"] = 0.6422512028, ["py"] = 0.6379572043, ["pm"] = 1988, ["sm"] = 1989, ["fp"] = true, },
    },
  },
  [6456] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Esdir's Old Journal",
    ["e"] = {
      [1] = { ["px"] = 0.6422708028, ["py"] = 0.6379212044, ["pm"] = 1989, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, },
      [2] = { ["px"] = 0.6422708028, ["py"] = 0.6379212044, ["pm"] = 1985, ["sm"] = 1989, ["fp"] = true, },
      [3] = { ["px"] = 0.6422708028, ["py"] = 0.6379212044, ["pm"] = 1986, ["sm"] = 1989, ["fp"] = true, },
      [4] = { ["px"] = 0.6422708028, ["py"] = 0.6379212044, ["pm"] = 1987, ["sm"] = 1989, ["fp"] = true, },
      [5] = { ["px"] = 0.6422708028, ["py"] = 0.6379212044, ["pm"] = 1988, ["sm"] = 1989, ["fp"] = true, },
    },
  },
  [6457] = {
    ["c"] = true,
    ["q"] = 6623,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Merchant Lords' Compiled Documents",
    ["e"] = {
      [1] = { ["px"] = 0.6422492219, ["py"] = 0.6378591859, ["pm"] = 2022, ["d"] = true, ["zx"] = 0.6411860050, ["zy"] = 0.6379076121, ["zm"] = 1887, ["qc"] = true, }, -- Adytum
      [2] = { ["pnx"] = 0.8494623899, ["pny"] = 0.4562118053, ["pm"] = 1985, ["fp"] = true, ["qc"] = true, }, -- Adytum
      [3] = { ["pnx"] = 0.8494623899, ["pny"] = 0.4562118053, ["pm"] = 1986, ["fp"] = true, ["qc"] = true, }, -- Adytum
      [4] = { ["pnx"] = 0.8494623899, ["pny"] = 0.4562118053, ["pm"] = 1987, ["fp"] = true, ["qc"] = true, }, -- Adytum
      [5] = { ["pnx"] = 0.8494623899, ["pny"] = 0.4562118053, ["pm"] = 1988, ["fp"] = true, ["qc"] = true, }, -- Adytum
      [6] = { ["pnx"] = 0.8494623899, ["pny"] = 0.4562118053, ["pm"] = 1989, ["fp"] = true, ["qc"] = true, }, -- Adytum
    },
  },
  [6473] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["py"] = 0.2871620000,
        ["px"] = 0.3786720000,
        ["pm"] = 1814,
        ["mn"] = 42,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Great Spirits of the Reach: Volume 2",
    ["cn"] = "The Reach Reader",
  },
  [6474] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Great Spirits of the Reach: Volume 3",
    ["e"] = {
      [1] = { ["px"] = 0.4150960074, ["py"] = 0.3167287981, ["pm"] = 1814, },
    },
  },
  [6475] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Great Spirits of the Reach: Volume 4",
    ["e"] = {
      [1] = { ["px"] = 0.3756060077, ["py"] = 0.2708727971, ["pm"] = 1814, },
    },
  },
  [6476] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "Great Spirits of the Reach: Volume 5",
    ["e"] = {
      [1] = { ["px"] = 0.3731948058, ["py"] = 0.2754299972, ["pm"] = 1814, },
    },
  },
  [6477] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Phantasmal Discovery Awaits!",
    ["q"] = 6631,
    ["e"] = {
      [1] = { ["px"] = 0.6200776055, ["py"] = 0.6635000122, ["pm"] = 1887, },
      [2] = { ["px"] = 0.6206064089, ["py"] = 0.6766008143, ["pm"] = 1887, },
      [3] = { ["px"] = 0.6245884063, ["py"] = 0.6537496087, ["pm"] = 1887, },
      [4] = { ["px"] = 0.6290316054, ["py"] = 0.6602548079, ["pm"] = 1887, },
    },
  },
  [6493] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "An Invitation to Elsweyr",
    ["e"] = {
    },
  },
  [6494] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "A Deal is Struck",
    ["q"] = 6627,
    ["e"] = {
      [1] = {
        ["px"] = 0.5507504059, ["py"] = 0.4796448086, ["pm"] = 1931, ["d"] = true,
      },
    },
  },
  [6495] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Journal of Emperor Leovic",
    ["q"] = 6627,
    ["e"] = {
      [1] = {
        ["px"] = 0.5508596061, ["py"] = 0.4805308089, ["pm"] = 1931, ["d"] = true,
      },
    },
  },
  [6496] = {
    ["c"] = true,
    ["cn"] = "The Reach Reader",
    ["n"] = "The Gray Host: A History Part 2",
    ["e"] = {
      [1] = { ["px"] = 0.3869832050, ["py"] = 0.3043371942, ["pm"] = 1814, },
    },
  },
  [6497] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Alizinda's Journal",
    ["q"] = 6634,
    ["e"] = {
      [1] = { ["px"] = 0.6698280062, ["py"] = 0.6697524119, ["pm"] = 1887, },
    },
  },
  [6498] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Scrawled Incantation",
    ["q"] = 6634,
    ["e"] = {
      [1] = { ["px"] = 0.6550552084, ["py"] = 0.6631996120, ["pm"] = 1887, },
    },
  },
  [6499] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Duchess Astella's Notes",
    ["q"] = 6634,
    ["e"] = {
      [1] = { ["px"] = 0.6603320066, ["py"] = 0.6620900091, ["pm"] = 1887, },
    },
  },
  [6501] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Demands of the Painted Eye",
    ["e"] = {
      [1] = { ["px"] = 0.5973120085, ["py"] = 0.6462472129, ["pm"] = 1887, },
    },
  },
  [6502] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tumma-Maxath's Diary",
    ["e"] = {
      [1] = {
        ["px"] = 0.6717748006, ["py"] = 0.6156087993, ["pm"] = 1930,
        ["zx"] = 0.6723552061, ["zy"] = 0.6156212110, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6503] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Prayer for a Shadowscale",
    ["e"] = {
      [1] = {
        ["px"] = 0.6724240005, ["py"] = 0.6147667993, ["pm"] = 1930,
        ["zx"] = 0.6723552061, ["zy"] = 0.6156212110, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6504] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Saga of Captain Wereshark Vol. 3",
    ["q"] = 6636,
    ["e"] = {
      [1] = { ["px"] = 0.6646844047, ["py"] = 0.6295372130, ["pm"] = 1887, }, -- post-quest location
      [2] = { ["px"] = 0.6582480040, ["py"] = 0.6239176115, ["pm"] = 1887, },
      [3] = { ["px"] = 0.6777200040, ["py"] = 0.6325072130, ["pm"] = 1887, },
    },
  },
  [6505] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter from Astara",
    ["q"] = 6615,
    ["e"] = {
      [1] = {
        ["px"] = 0.6564552114, ["py"] = 0.6755631734, ["pm"] = 2014, ["d"] = true,
        ["zx"] = 0.6548716290, ["zy"] = 0.6727764199, ["zm"] = 1887,
      },
      [2] = { ["px"] = 0.6548716290, ["py"] = 0.6727764199, ["pm"] = 2018, ["fp"] = true, ["d"] = true, },
    },
  },
  [6506] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter to Matus Amnis",
    ["q"] = 6619,
    ["e"] = {
      [1] = { ["px"] = 0.6567284287, ["py"] = 0.6777360195, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6507] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Invitation Cover Letter",
    ["q"] = 6619,
    ["e"] = {
      [1] = { ["px"] = 0.6565520290, ["py"] = 0.6777560196, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6508] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "A Quest of Sand, Snow, and Blood",
    ["e"] = {
    },
  },
  [6509] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Order of the Waking Flame",
    ["e"] = {
      [1] = { ["px"] = 0.6270152045, ["py"] = 0.6889392097, ["pm"] = 1887, },
    },
  },
  [6510] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Sweets for Sour Company",
    ["e"] = {
      [1] = { ["px"] = 0.6688744020, ["py"] = 0.6342560137, ["pm"] = 1887, },
    },
  },
  [6511] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Path of the Ironclad",
    ["e"] = {
      [1] = {
        ["px"] = 1.0098651697, ["py"] = 0.7560079792, ["pm"] = 2122,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true, },
    },
  },
  [6512] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Havocrel: Strangers from Oblivion",
    ["e"] = {
      [1] = {
        ["px"] = 0.6910743962, ["py"] = 0.7436999985, ["pm"] = 2012, ["d"] = true,
        ["zx"] = 0.6869360017, ["zy"] = 0.7383796096, ["zm"] = 1887,
      },
    },
  },
  [6515] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "High Priest's Orders",
    ["q"] = 6616,
    ["e"] = {
      [1] = {
        ["px"] = 0.6514507809, ["py"] = 0.6152999976, ["pm"] = 2033, ["d"] = true,
        ["zx"] = 0.6529060032, ["zy"] = 0.6178736115, ["zm"] = 1887,
      },
    },
  },
  [6516] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Preserve the Secret",
    ["q"] = 6616,
    ["e"] = {
      [1] = {
        ["px"] = 0.6505944204, ["py"] = 0.6142875977, ["pm"] = 1937, ["d"] = true,
        ["zx"] = 0.6529060032, ["zy"] = 0.6178736115, ["zm"] = 1887,
      },
      [2] = { ["px"] = 0.6487999801, ["py"] = 0.6138415943, ["pm"] = 2034, ["d"] = true, },
    },
  },
  [6517] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Disastrix Zansora's Journal",
    ["q"] = 6616,
    ["e"] = {
      [1] = {
        ["px"] = 0.6506100203, ["py"] = 0.6143103977, ["pm"] = 1937, ["d"] = true,
        ["zx"] = 0.6529060032, ["zy"] = 0.6178736115, ["zm"] = 1887,
      },
      [2] = { ["px"] = 0.6488863801, ["py"] = 0.6136799944, ["pm"] = 2034, ["d"] = true, },
    },
  },
  [6518] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.1680787984, ["py"] = 0.2200671994, ["pm"] = 10,
      },
      [2] = {
        ["py"] = 0.6658200000,
        ["px"] = 0.3785000000,
        ["pm"] = 22,
        ["mn"] = 8,
        ["d"] = false,
        ["r"] = false,
        ["i"] = 12,
      },
    },
    ["n"] = "Dread Lady's Letter",
    ["cn"] = "Daedric Cults",
  },
  [6519] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Work for Hire in Leyawiin",
    ["q"] = 6643,
    ["e"] = {
      [1] = { ["px"] = 0.5987764048, ["py"] = 0.6787104076, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6520] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Aloysius's Note",
    ["q"] = 6647,
    ["e"] = {
      [1] = { ["px"] = 0.6388832051, ["py"] = 0.6873156093, ["pm"] = 1887, },
    },
  },
  [6522] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Xynaa's Book of Contracts",
    ["q"] = 6617,
    ["e"] = {
      [1] = { ["px"] = 0.6577620288, ["py"] = 0.6754496199, ["pm"] = 2018, ["zm"] = 1887 }, -- post-quest lcoation
    },
  },
  [6523] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Sophus's Sealed Scroll",
    ["q"] = 6615,
    ["e"] = {
      [1] = { ["px"] = 0.5959000063, ["py"] = 0.6688416107, ["pm"] = 1887, },
    },
  },
  [6524] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Last Battle of Phalevon Vero",
    ["e"] = {
      [1] = {
        ["px"] = 0.5984440069, ["py"] = 0.6701704095, ["pm"] = 1935,
        ["zx"] = 0.5981968065, ["zy"] = 0.6701684067, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6525] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Hymn of Zenithar",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6404036077, ["py"] = 0.6327780117, ["pm"] = 1887, },
    },
  },
  [6526] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Adventurers Wanted for Exciting Opportunity!",
    ["q"] = 6648,
    ["e"] = {
      [1] = { ["px"] = 0.6212168048, ["py"] = 0.6078484137, ["pm"] = 1887, },
      [2] = { ["px"] = 0.6216972078, ["py"] = 0.6142784123, ["pm"] = 1887, },
      [3] = { ["px"] = 0.6293320056, ["py"] = 0.6120396131, ["pm"] = 1887, },
      [4] = { ["px"] = 0.6297736038, ["py"] = 0.6031928129, ["pm"] = 1887, },
    },
  },
  [6527] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On Marsh Giants: A Study",
    ["e"] = {
      [1] = { ["px"] = 0.6691424046, ["py"] = 0.6300916095, ["pm"] = 1887, },
    },
  },
  [6528] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Legate Minutes: Concerning Goblins",
    ["e"] = {
      [1] = { ["px"] = 0.5942616077, ["py"] = 0.6632468104, ["pm"] = 1887, },
    },
  },
  [6529] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Wines of Blackwood",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6018304049, ["py"] = 0.6778572077, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6530] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Homesteads in the Black Marsh",
    ["e"] = {
      [1] = { ["px"] = 0.6100724053, ["py"] = 0.6815080076, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6531] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tribes of Blackwood: Gideon and the Border",
    ["e"] = {
      [1] = { ["px"] = 0.6599172291, ["py"] = 0.6750300197, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6532] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tribes of Blackwood: Riverbacks",
    ["e"] = {
      [1] = { ["px"] = 0.5920660088, ["py"] = 0.6654884108, ["pm"] = 1887, },
    },
  },
  [6533] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On Mirrors and Crows",
    ["e"] = {
      [1] = { ["px"] = 0.6273832200, ["py"] = 0.6273936054, ["pm"] = 1939, ["zx"] = 0.6259392064, ["zy"] = 0.6305956092, ["zm"] = 1887, ["d"] = true, },
    },
  },
  [6549] = {
    ["c"] = false,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Courier-Delivered Letter",
    ["e"] = {
    },
  },
  [6572] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Deet-Loh's Notes: Nereid Curses",
    ["e"] = {
      [1] = {
        ["px"] = 0.7082679791, ["py"] = 0.7037296272, ["pm"] = 2062,
        ["zx"] = 0.7062591996, ["zy"] = 0.7032248052, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6573] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Deet-Loh's Notes: Frog Songs",
    ["e"] = {
      [1] = {
        ["px"] = 0.7089879791, ["py"] = 0.7029160272, ["pm"] = 2062,
        ["zx"] = 0.7062591996, ["zy"] = 0.7032248052, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6574] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Deet-Loh's Notes: The Frog Witch",
    ["e"] = {
      [1] = {
        ["px"] = 0.7080615791, ["py"] = 0.7029036272, ["pm"] = 2062,
        ["zx"] = 0.7062591996, ["zy"] = 0.7032248052, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6575] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Dremora Never Die",
    ["e"] = {
      [1] = { ["px"] = 0.8577840077, ["py"] = 1.0160280249, ["pm"] = 2035, },
    },
  },
  [6576] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Stricture and the Grasp",
    ["e"] = {
      [1] = { ["px"] = 0.8631312083, ["py"] = 1.0260812243, ["pm"] = 2035, },
    },
  },
  [6577] = {
    ["c"] = false,
    ["cn"] = "The World and Its Creatures",
    ["n"] = "A Foe Most Porcine",
    ["e"] = {
    },
  },
  [6578] = {
    ["c"] = true,
    ["e"] = {
      [1] = {
        ["px"] = 0.5525804060, ["py"] = 0.4810336087, ["pm"] = 1931, ["d"] = true,
      },
    },
    ["n"] = "Order of the Waking Flame Ritual",
    ["cn"] = "Daedric Cults",
  },
  [6579] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Author's Assistant Wanted!",
    ["q"] = 6634,
    ["e"] = {
      [1] = { ["px"] = 0.6596696286, ["py"] = 0.6740780197, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6580] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Chimes of Silver",
    ["e"] = {
      [1] = { ["px"] = 0.6556032287, ["py"] = 0.6766056195, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6581] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Feast of Saint Coellicia I",
    ["e"] = {
      [1] = { ["px"] = 0.6719608013, ["py"] = 0.7215712046, ["pm"] = 1887, },
    },
  },
  [6582] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Feast of Saint Coellicia II",
    ["e"] = {
      [1] = { ["px"] = 0.6456324078, ["py"] = 0.6668820088, ["pm"] = 1887, },
    },
  },
  [6583] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Feast of Saint Coellicia III",
    ["e"] = {
      [1] = { ["px"] = 0.6836188003, ["py"] = 0.7186192039, ["pm"] = 1887, },
    },
  },
  [6584] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Feast of Saint Coellicia IV",
    ["e"] = {
      [1] = { ["px"] = 0.6553232008, ["py"] = 0.6635532103, ["pm"] = 1887, },
    },
  },
  [6585] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Feast of Saint Coellicia V",
    ["e"] = {
      [1] = { ["px"] = 0.5933440071, ["py"] = 0.6554644125, ["pm"] = 1887, },
    },
  },
  [6586] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "A Supplicant's Song",
    ["e"] = {
      [1] = { ["px"] = 1.1322468259, ["py"] = 0.7081708152, ["pm"] = 2021, },
    },
  },
  [6587] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On Valkynaz Nokvroz",
    ["e"] = {
      [1] = { ["px"] = 0.8525064082, ["py"] = 1.0259608242, ["pm"] = 2035, },
    },
  },
  [6588] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Fool of Fargrave",
    ["e"] = {
      [1] = { ["px"] = 0.9127344078, ["py"] = 0.9711128264, ["pm"] = 2035, },
    },
  },
  [6589] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "When the Spires Fell",
    ["e"] = {
      [1] = { ["px"] = 1.1152064255, ["py"] = 0.7579120214, ["pm"] = 2021, },
    },
  },
  [6590] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Minwileth's Diary",
    ["e"] = {
      [1] = { ["px"] = 1.1281964267, ["py"] = 0.7187084185, ["pm"] = 2021, },
    },
  },
  [6591] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Flora and Fauna of the Burn",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2021] = 1,
    },
  },
  [6592] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Happy Averno Shipping Company Sign",
    ["e"] = {
      [1] = { ["px"] = 0.6017844050, ["py"] = 0.6776528075, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6593] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Adder's Ransom Note",
    ["q"] = 6658,
    ["e"] = {
      [1] = { ["px"] = 0.6016504047, ["py"] = 0.6776640074, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6594] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "A Guide to the Deadlands",
    ["e"] = {
      [1] = { ["px"] = 0.8772128069, ["py"] = 1.0351196246, ["pm"] = 2035, },
    },
  },
  [6595] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Ledger of Souls",
    ["q"] = 6661,
    ["e"] = {
      [1] = { ["px"] = 0.6571256289, ["py"] = 0.6759664201, ["pm"] = 2018, ["zm"] = 1887 },
    },
  },
  [6596] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Cerise's Farewell Note",
    ["q"] = 6661,
    ["e"] = {
      [1] = { ["px"] = 0.6709488090, ["py"] = 0.6826656071, ["pm"] = 1887, },
    },
  },
  [6597] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter from Quistley Silvelle",
    ["q"] = 6662,
    ["e"] = {
      [1] = { ["px"] = 0.0609560011, ["py"] = 0.3803160056, ["pm"] = 63, ["zm"] = 1, },
    },
  },
  [6598] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tales of Black Marsh",
    ["e"] = {
      [1] = { ["px"] = 0.5994964049, ["py"] = 0.6819904076, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6599] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Imperial Deception Song",
    ["e"] = {
      [1] = { ["px"] = 0.5970392082, ["py"] = 0.6459620107, ["pm"] = 1887, },
    },
  },
  [6600] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Countess Caro's Birthday",
    ["e"] = {
      [1] = { ["px"] = 0.6094240049, ["py"] = 0.6819652080, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6601] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Terror of the Death Hopper",
    ["e"] = {
      [1] = {
        ["px"] = 0.6160336142, ["py"] = 0.7011795722, ["pm"] = 1984,
        ["zx"] = 0.6157992060, ["zy"] = 0.7011516103, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6602] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Ardia's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.6276836215, ["py"] = 0.6084547994, ["pm"] = 1992, ["px"] = 0.6276836066, ["py"] = 0.6084548115, ["pm"] = 1887, ["d"] = true, },
    },
  },
  [6603] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Foolish Wings",
    ["e"] = {
      [1] = { ["px"] = 0.6277952201, ["py"] = 0.6279248055, ["pm"] = 1939, ["zx"] = 0.6259392064, ["zy"] = 0.6305956092, ["zm"] = 1887, ["d"] = true, },
    },
  },
  [6619] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "A Perfect Drink",
    ["e"] = {
      [1] = { ["px"] = 0.6713092017, ["py"] = 0.7298352075, ["pm"] = 1887, },
    },
  },
  [6620] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Grenetta's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.0726576005, ["py"] = 0.3806531954, ["pm"] = 237, ["zx"] = 0.0716712014, ["zy"] = 0.3817292068, ["zm"] = 1, ["d"] = true, },
    },
  },
  [6636] = {
    ["c"] = false,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter from Inalieth",
    ["e"] = {
    },
  },
  [6667] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Fang-Furls' Dead Drop",
    ["q"] = 6658,
    ["e"] = {
      [1] = { ["px"] = 0.6082692052, ["py"] = 0.6638452119, ["pm"] = 1887, },
    },
  },
  [6668] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Fang-Furls' Second Dead Drop",
    ["q"] = 6658,
    ["e"] = {
      [1] = { ["px"] = 0.6749620021, ["py"] = 0.7169644129, ["pm"] = 1887, },
    },
  },
  [6669] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Fang-Furls' Third Dead Drop",
    ["q"] = 6658,
    ["e"] = {
      [1] = { ["px"] = 0.6721196063, ["py"] = 0.6461540130, ["pm"] = 1887, },
    },
  },
  [6670] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter from Farrul Lupus",
    ["q"] = 6615,
    ["e"] = {
      [1] = { ["px"] = 0.6087932057, ["py"] = 0.6700972144, ["pm"] = 1887, },
    },
  },
  [6671] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter to Councilor Lovidicus",
    ["q"] = 6615,
    ["e"] = {
      [1] = { ["px"] = 0.6196424044, ["py"] = 0.6829568142, ["pm"] = 1887, },
    },
  },
  [6672] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Vinnus's Note",
    ["q"] = 6663,
    ["e"] = {
      [1] = { ["px"] = -0.0872720027, ["py"] = 0.1488575994, ["pm"] = 2000, ["d"] = true, },
    },
  },
  [6673] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Councilor Abor's Journal",
    ["q"] = 6615,
    ["e"] = {
      [1] = { ["px"] = 0.6286396046, ["py"] = 0.6879652125, ["pm"] = 1887, },
    },
  },
  [6674] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Leyawiin Shipping Schedule",
    ["q"] = 6636,
    ["e"] = {
      [1] = { ["px"] = 0.6785968033, ["py"] = 0.6275088126, ["pm"] = 1887, },
    },
  },
  [6675] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Pirates of Topal Bay",
    ["e"] = {
      [1] = { ["px"] = 0.6031468065, ["py"] = 0.6938120075, ["pm"] = 1887, },
    },
  },
  [6676] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Destron's Journal",
    ["q"] = 6630,
    ["e"] = {
      [1] = { ["px"] = 0.6577120290, ["py"] = 0.6759728195, ["pm"] = 2018, ["zm"] = 1887 }, -- post-quest location
    },
  },
  [6677] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Salvitto's Invitation",
    ["q"] = 6619,
    ["e"] = {
      [1] = { ["px"] = 0.6584808026, ["py"] = 0.6454980128, ["pm"] = 1887, }, -- post-quest location
    },
  },
  [6678] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Unfinished Letter to Pronobius",
    ["e"] = {
      [1] = { ["px"] = 0.6554688043, ["py"] = 0.6622376091, ["pm"] = 1887, },
    },
  },
  [6679] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Sighs of Blackwood",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6722828017, ["py"] = 0.6944624052, ["pm"] = 1887, },
    },
  },
  [6680] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Tribes of Blackwood: Red-Dream People",
    ["e"] = {
      [1] = { ["px"] = 0.5892732077, ["py"] = 0.6498752096, ["pm"] = 1887, },
    },
  },
  [6681] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Leovic's Great Spirits Proclamation",
    ["e"] = {
      [1] = { ["px"] = 0.6606676057, ["py"] = 0.6483588102, ["pm"] = 1887, },
    },
  },
  [6682] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Edvilda's Log Book",
    ["q"] = 6666,
    ["e"] = {
      [1] = { ["px"] = 0.7690711890, ["py"] = 0.4391784009, ["pm"] = 7, },
    },
  },
  [6684] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "May Disaster Turn Away",
    ["e"] = {
      [1] = { ["px"] = 0.6246304046, ["py"] = 0.6609240095, ["pm"] = 1887, },
    },
  },
  [6685] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On Topal Bay",
    ["e"] = {
      [1] = { ["px"] = 0.6638268067, ["py"] = 0.6319076095, ["pm"] = 1887, },
    },
  },
  [6686] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Across the Niben Bar",
    ["e"] = {
      [1] = { ["px"] = 0.6059628051, ["py"] = 0.6849324080, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6687] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Liberation of Leyawiin",
    ["e"] = {
      [1] = { ["px"] = 0.6733896084, ["py"] = 0.6572320121, ["pm"] = 1887, },
    },
  },
  [6688] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Pirate's Treasure Message",
    ["q"] = 6670,
    ["e"] = {
      [1] = { ["px"] = 0.6123044059, ["py"] = 0.6851308130, ["pm"] = 1887, },
    },
  },
  [6690] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Onimiril's Writings",
    ["q"] = 6667,
    ["e"] = {
      [1] = { ["px"] = 0.2151307980, ["py"] = 0.6654596130, ["pm"] = 143, },
    },
  },
  [6691] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Saga of Captain Wereshark Vol. 2",
    ["q"] = 6636,
    ["e"] = {
      [1] = { ["px"] = 0.6646844047, ["py"] = 0.6295372130, ["pm"] = 1887, }, -- post-quest location
      [2] = { ["px"] = 0.6573888068, ["py"] = 0.6246480127, ["pm"] = 1887, },
    },
  },
  [6692] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "To My Love",
    ["e"] = {
      [1] = { ["px"] = 0.6489904054, ["py"] = 0.6120660135, ["pm"] = 1887, },
    },
  },
  [6693] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Fang-Furls' Business Ledger",
    ["q"] = 6658,
    ["e"] = {
      [1] = { ["px"] = 0.6024576052, ["py"] = 0.6767152074, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6694] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Notes of Lovirithel the Sage",
    ["e"] = {
      [1] = { ["px"] = 0.6295436289, ["py"] = 0.7098975861, ["pm"] = 1978, ["zx"] = 0.6295436064, ["zy"] = 0.7098976103, ["zm"] = 1887, ["d"] = true, },
    },
  },
  [6695] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Necromancer's Diary",
    ["e"] = {
      [1] = {
        ["px"] = 0.6717088005, ["py"] = 0.6155035993, ["pm"] = 1930,
        ["zx"] = 0.6723552061, ["zy"] = 0.6156212110, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6696] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter to Darene",
    ["e"] = {
      [1] = { ["px"] = 0.5988888048, ["py"] = 0.6780400074, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6697] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Come One, Come All!",
    ["q"] = 6636,
    ["e"] = {
      [1] = { ["px"] = 0.6595660041, ["py"] = 0.6210148108, ["pm"] = 1887, },
      [2] = { ["px"] = 0.6714788042, ["py"] = 0.6251484114, ["pm"] = 1887, },
      [3] = { ["px"] = 0.6716928090, ["py"] = 0.6377140106, ["pm"] = 1887, },
    },
  },
  [6698] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Letter to Otumi-Ra",
    ["e"] = {
      [1] = { ["px"] = 0.6712376019, ["py"] = 0.7294520076, ["pm"] = 1887, },
    },
  },
  [6700] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "The Making of Wading-Nests",
    ["e"] = {
      [1] = { ["px"] = 0.6710696088, ["py"] = 0.7231576045, ["pm"] = 1887, },
    },
  },
  [6701] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Restoration of Fort Grief",
    ["e"] = {
      [1] = { ["px"] = 1.1062944337, ["py"] = 0.7310612152, ["pm"] = 2021, },
    },
  },
  [6702] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Birds of Gloommire",
    ["e"] = {
      [1] = { ["px"] = 0.6782388044, ["py"] = 0.6557232117, ["pm"] = 1887, },
    },
  },
  [6703] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Gift of the Lilmothiit",
    ["e"] = {
      [1] = { ["px"] = 0.6475692075, ["py"] = 0.6282240107, ["pm"] = 1887, },
    },
  },
  [6704] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On Welkynd Stones",
    ["e"] = {
      [1] = { ["px"] = 0.6777084018, ["py"] = 0.6325880110, ["pm"] = 1887, },
    },
  },
  [6705] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Penitent's Tale",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [6706] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Trans-Niben Delicacies",
    ["e"] = {
      [1] = { ["px"] = 0.6260512052, ["py"] = 0.6878880102, ["pm"] = 1887, },
    },
  },
  [6707] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Before the Gates of Gideon",
    ["e"] = {
      [1] = {
        ["px"] = 0.6160332142, ["py"] = 0.7012351721, ["pm"] = 1984,
        ["zx"] = 0.6157992060, ["zy"] = 0.7011516103, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6708] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "How Hackwing Got Her Tail",
    ["e"] = {
      [1] = {
        ["px"] = 0.6638207960, ["py"] = 0.7263648230, ["pm"] = 2016,
        ["zx"] = 0.6633112048, ["zy"] = 0.7252740098, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6709] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On Dremora Clans",
    ["e"] = {
      [1] = { ["px"] = 0.8782048012, ["py"] = 1.0280571776, ["pm"] = 2136, ["zm"] = 2035, ["d"] = true, },
    },
  },
  [6710] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Artifact Record: Groundsplitters",
    ["e"] = {
      [1] = {
        ["px"] = 0.1431228050, ["py"] = 0.3108656043, ["pm"] = 2045, ["d"] = true,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
      },
    },
  },
  [6711] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Artifact Record: Opal Charm",
    ["e"] = {
      [1] = {
        ["px"] = 0.1429456050, ["py"] = 0.3106748043, ["pm"] = 2045,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
        ["d"] = true,
      },
    },
  },
  [6712] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Artifact Record: Duplici Gladio",
    ["e"] = {
      [1] = {
        ["px"] = 0.1426040050, ["py"] = 0.3107652044, ["pm"] = 2045,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
        ["d"] = true,
      },
    },
  },
  [6713] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Bartholomew's Task",
    ["e"] = {
      [1] = {
        ["px"] = 0.1445672067, ["py"] = 0.3107563940, ["pm"] = 2044, ["d"] = true,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
      },
    },
  },
  [6714] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Bartholomew's Theory",
    ["e"] = {
      [1] = {
        ["px"] = 0.1434244050, ["py"] = 0.3107808043, ["pm"] = 2045, ["d"] = true,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
      },
    },
  },
  [6715] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Bartholomew's Discovery",
    ["e"] = {
      [1] = {
        ["px"] = 0.1434175965, ["py"] = 0.3108767974, ["pm"] = 2097, ["d"] = true,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
      },
    },
  },
  [6716] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "We Can't Leave",
    ["e"] = {
      [1] = {
        ["px"] = 0.1444688067, ["py"] = 0.3108423940, ["pm"] = 2044, ["d"] = true,
        ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1,
      },
    },
  },
  [6717] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Leave the Crimson Oath Alone",
    ["e"] = {
      [1] = {
        ["px"] = 0.6605556244, ["py"] = 0.5978691940, ["pm"] = 2024, ["d"] = true,
        ["zx"] = 0.6456988074, ["zy"] = 0.6086332125, ["zm"] = 1887,
      },
    },
  },
  [6718] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "The Great Stain",
    ["e"] = {
      [1] = {
        ["px"] = 0.6600808244, ["py"] = 0.5981259940, ["pm"] = 2024, ["d"] = true,
        ["zx"] = 0.6456988074, ["zy"] = 0.6086332125, ["zm"] = 1887,
      },
    },
  },
  [6719] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "More Scorions",
    ["e"] = {
      [1] = {
        ["px"] = 0.6603208244, ["py"] = 0.5978787940, ["pm"] = 2024, ["d"] = true,
        ["zx"] = 0.6456988074, ["zy"] = 0.6086332125, ["zm"] = 1887,
      },
    },
  },
  [6720] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Ambitions Realized",
    ["e"] = {
      [1] = {
        ["px"] = 0.6599152244, ["py"] = 0.5988143940, ["pm"] = 2024, ["d"] = true,
        ["zx"] = 0.6456988074, ["zy"] = 0.6086332125, ["zm"] = 1887,
      },
    },
  },
  [6724] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Prayer of Fourfold Wrath",
    ["e"] = {
      [1] = {
        ["px"] = 1.0069816035, ["py"] = 0.7616335838, ["pm"] = 2106,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6725] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Legend of Veyond",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.5984920066, ["py"] = 0.6706520133, ["pm"] = 1887, },
    },
  },
  [6730] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Bounties of Blackwood",
    ["e"] = {
    },
  },
  [6731] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Glenbridge's Argonian Shrine to Sithis",
    ["r"] = true,
    ["e"] = {
      [1] = { ["px"] = 0.6645936037, ["py"] = 0.6994560129, ["pm"] = 1887, },
    },
  },
  [6733] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "An Interview with Countess Caro",
    ["e"] = {
      [1] = { ["px"] = 0.5959180081, ["py"] = 0.6693504081, ["pm"] = 1887, },
    },
  },
  [6734] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Join the Order of the Waking Flame",
    ["e"] = {
      [1] = { ["px"] = 0.6584360031, ["py"] = 0.6455616112, ["pm"] = 1887, },
    },
  },
  [6735] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On the Chamber of Legates",
    ["e"] = {
      [1] = { ["px"] = 0.6072492048, ["py"] = 0.6771008074, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6737] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Fargrave Happenings",
    ["e"] = {
      [1] = { ["px"] = 0.8868632083, ["py"] = 1.0292604248, ["pm"] = 2035, },
    },
  },
  [6738] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Surviving the Shambles",
    ["e"] = {
      [1] = { ["px"] = 0.9034524300, ["py"] = 1.0110575987, ["pm"] = 2082, },
    },
  },
  [6739] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Brigadine's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.6881176067, ["py"] = 0.6511984098, ["pm"] = 1887, },
    },
  },
  [6740] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Sul-Xan Note",
    ["e"] = {
      [1] = {
        ["px"] = 0.6530507999, ["py"] = 0.7120452053, ["pm"] = 1946,
        ["zx"] = 0.6565304041, ["zy"] = 0.7165012095, ["zm"] = 1887,
        ["d"] = true,
      },
    },
  },
  [6741] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Intoxicants of the Shambles",
    ["e"] = {
      [1] = { ["px"] = 0.9050168299, ["py"] = 0.9653647987, ["pm"] = 2082, },
    },
  },
  [6742] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Dagonists Through the Ages",
    ["e"] = {
      [1] = {
        ["px"] = 1.0073104035, ["py"] = 0.7629095838, ["pm"] = 2106,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6743] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Pibiha's Note",
    ["q"] = 6698,
    ["e"] = {
      [1] = {
        ["px"] = 1.0096703695, ["py"] = 0.7567527791, ["pm"] = 2122, ["d"] = true,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
      },
      [2] = { ["px"] = 1.0074940034, ["py"] = 0.7633071838, ["pm"] = 2106, ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021, ["d"] = true, }, },
  },
  [6744] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "A Legionary's History of Fort Redmane",
    ["e"] = {
      [1] = { ["px"] = 0.6122132076, ["py"] = 0.6338856130, ["pm"] = 1887, },
    },
  },
  [6745] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Reformatory Register",
    ["q"] = 6698,
    ["e"] = {
      [1] = {
        ["px"] = 1.0081408035, ["py"] = 0.7626963838, ["pm"] = 2106, ["d"] = true,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
      },
    },
  },
  [6746] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "On the Ivory Brigade",
    ["e"] = {
      [1] = { ["px"] = 0.5972040078, ["py"] = 0.6597084127, ["pm"] = 1887, },
    },
  },
  [6747] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Sul-Xan Ritual Site",
    ["e"] = {
      [1] = { ["px"] = 0.6366928063, ["py"] = 0.6541868114, ["pm"] = 1887, },
    },
  },
  [6748] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Improved Cataclyst Model",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 0.9342440001, ["py"] = 0.7711247790, ["pm"] = 2087, ["d"] = true, },
    },
  },
  [6749] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Audiences with the Longhouse Emperors",
    ["e"] = {
      [1] = { ["px"] = 1.0138368299, ["py"] = 0.7856252128, ["pm"] = 2021, },
    },
  },
  [6750] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Traveler's Guide to Leyawiin",
    ["e"] = {
      [1] = { ["px"] = 0.5999104048, ["py"] = 0.6764092075, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6751] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "An Ode to the Disenfranchised",
    ["e"] = {
      [1] = { ["px"] = 0.5546008160, ["py"] = 0.5158435945, ["pm"] = 16, },
    },
  },
  [6752] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "I Need Your Help!",
    ["e"] = {
      [1] = { ["px"] = 0.6275492080, ["py"] = 0.6762620065, ["pm"] = 1887, },
    },
  },
  [6753] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Traveler's Guide to Gideon",
    ["e"] = {
      [1] = { ["px"] = 0.6558144287, ["py"] = 0.6763692199, ["pm"] = 2018, ["zm"] = 1887, },
    },
  },
  [6754] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Your Assistance Is Appreciated",
    ["e"] = {
      [1] = { ["px"] = 0.6274504056, ["py"] = 0.6762736087, ["pm"] = 1887, }, -- need achievement Lost in the Wilds
    },
  },
  [6755] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Waking Flame Journal",
    ["q"] = 6696,
    ["e"] = {
      [1] = {
        ["px"] = 1.0112403649, ["py"] = 0.7617440123, ["pm"] = 2108, ["d"] = true,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
      },
    },
  },
  [6756] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Kastav's Journal",
    ["q"] = 6705,
    ["e"] = {
      [1] = {
        ["px"] = 1.0591464553, ["py"] = 0.7450116224, ["pm"] = 2083,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
      },
    },
  },
  [6757] = {
    ["c"] = true,
    ["cn"] = "Books of Blackwood",
    ["n"] = "Save My Precious",
    ["e"] = {
      [1] = { ["px"] = -0.0334208007, ["py"] = 0.1836556008, ["pm"] = 2054, ["d"] = true, },
    },
  },
  [6758] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Secrets of Moricar the Inheritor",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 0.9335616001, ["py"] = 0.7724359790, ["pm"] = 2087, ["d"] = true, },
    },
  },
  [6759] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Letter to the High Priest",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 0.9341524001, ["py"] = 0.7718335790, ["pm"] = 2087, ["d"] = true, },
    },
  },
  [6760] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Doombringer Celdina's Testament",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 0.9341456001, ["py"] = 0.7708075791, ["pm"] = 2087, ["d"] = true, },
    },
  },
  [6762] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Partially Hidden Journal",
    ["q"] = 6696,
    ["e"] = {
      [1] = { ["px"] = -0.0888663981, ["py"] = 0.1607664004, ["pm"] = 2101, ["d"] = true, },
    },
  },
  [6764] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "A Constant Hunger",
    ["q"] = 6705,
    ["e"] = {
      [1] = {
        ["px"] = 1.0658895501, ["py"] = 0.7312999739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6766] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Note from Valkynaz Nokvroz",
    ["q"] = 6705,
    ["e"] = {
      [1] = {
        ["px"] = 1.0662003502, ["py"] = 0.7325731739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6767] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Pact with Khajiiti Mortal Zajukki",
    ["e"] = {
      [1] = {
        ["px"] = 1.0657579502, ["py"] = 0.7320967739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6768] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Vow of Consumption",
    ["q"] = 6705,
    ["e"] = {
      [1] = {
        ["px"] = 1.0658419501, ["py"] = 0.7321175739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6769] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Sister Celdina's Orders",
    ["q"] = 6707,
    ["e"] = {
      [1] = { ["px"] = 1.1145688250, ["py"] = 0.7264120166, ["pm"] = 2021, },
    },
  },
  [6770] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Waking Flame Letter",
    ["q"] = 6701,
    ["e"] = {
      [1] = { ["px"] = -0.0977067969, ["py"] = 0.0950964009, ["pm"] = 2050, ["d"] = true, },
    },
  },
  [6771] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Waking Flame Correspondence",
    ["q"] = 6701,
    ["e"] = {
      [1] = { ["px"] = 0.3366519935, ["py"] = 0.7112063809, ["pm"] = 2047, ["d"] = true, },
    },
  },
  [6772] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On Mortal Song",
    ["e"] = {
      [1] = {
        ["px"] = 1.0658959502, ["py"] = 0.7320019739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6773] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Rites of the Hunt",
    ["e"] = {
      [1] = {
        ["px"] = 1.0658551501, ["py"] = 0.7319999739, ["pm"] = 2084,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6775] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Work for Hire in Fargrave",
    ["q"] = 6709,
    ["e"] = {
      [1] = { ["px"] = 0.8655204064, ["py"] = 1.0265052256, ["pm"] = 2035, },
      [2] = { ["px"] = 0.8523120074, ["py"] = 1.0274568256, ["pm"] = 2035, },
    },
  },
  [6776] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Blood Pit Prisoner Roll",
    ["q"] = 6707,
    ["e"] = {
      [1] = { ["px"] = 1.0387300303, ["py"] = 0.7911312179, ["pm"] = 2021, },
    },
  },
  [6777] = {
    ["c"] = true,
    ["cn"] = "The Devoted and the Deranged",
    ["n"] = "Museum Guild Letter",
    ["e"] = {
      [1] = { ["px"] = 0.2386532011, ["py"] = 0.7451140223, ["pm"] = 243, ["zm"] = 143, },
    },
  },
  [6778] = {
    ["c"] = false,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Charred Journal",
    ["e"] = {
    },
  },
  [6781] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Letter to Vibius Sosia",
    ["q"] = 6694,
    ["e"] = {
      [1] = { ["px"] = 1.1057000483, ["py"] = 0.7751336289, ["pm"] = 2118, ["d"] = true, },
    },
  },
  [6803] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Discarded Diary",
    ["q"] = 6696,
    ["e"] = {
      [1] = { ["px"] = 0.6274011794, ["py"] = 0.6085711889, ["pm"] = 2090, ["d"] = true, },
    },
  },
  [6819] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Elegian's Notes",
    ["q"] = 6701,
    ["e"] = {
      [1] = { ["px"] = 0.3365687936, ["py"] = 0.7113667809, ["pm"] = 2047, ["d"] = true, },
    },
  },
  [6820] = {
    ["c"] = false,
    ["cn"] = "Daedric Cults",
    ["n"] = "Lyranth's Letter",
    ["e"] = {
    },
  },
  [6821] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Tamriel's Finest Wines",
    ["e"] = {
      [1] = { ["px"] = 0.7364919943, ["py"] = 0.4638812010, ["pm"] = 7, },
      [2] = { ["px"] = 0.2330268014, ["py"] = 0.7335692213, ["pm"] = 243, },
      [3] = { ["px"] = 0.0667592020, ["py"] = 0.3832892054, ["pm"] = 63, },
    },
  },
  [6838] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Visitor's Guide to Fargrave",
    ["e"] = {
      [1] = { ["px"] = 0.8535960071, ["py"] = 1.0299668249, ["pm"] = 2035, },
    },
  },
  [6839] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Epics of Mehrunes Dagon, Volume 1",
    ["e"] = {
      [1] = { ["px"] = 1.0491608313, ["py"] = 0.7680528204, ["pm"] = 2021, },
    },
  },
  [6840] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Mikget's To-Do List",
    ["q"] = 6728,
    ["e"] = {
      [1] = { ["px"] = 1.0173112279, ["py"] = 0.7844724126, ["pm"] = 2021, },
    },
  },
  [6841] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Summons to Deadlight",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 1.1275760258, ["py"] = 0.7170616185, ["pm"] = 2021, },
    },
  },
  [6842] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Thadriax's Instructions",
    ["q"] = 6699,
    ["e"] = {
      [1] = { ["px"] = 1.1030696325, ["py"] = 0.7157612175, ["pm"] = 2021, },
    },
  },
  [6843] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Telofasa's Diary",
    ["q"] = 6730,
    ["e"] = {
      [1] = { ["px"] = 1.0863508330, ["py"] = 0.7351508174, ["pm"] = 2021, },
    },
  },
  [6844] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Robhir's Letter",
    ["q"] = 6731,
    ["e"] = {
      [1] = { ["px"] = 0.8738508294, ["py"] = 0.9895199990, ["pm"] = 2082, },
    },
  },
  [6848] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Report from Markynaz Oyx",
    ["q"] = 6705,
    ["e"] = {
      [1] = {
        ["px"] = 1.0621484562, ["py"] = 0.7392596228, ["pm"] = 2083,
        ["zx"] = 1.0538860312, ["zy"] = 0.7551728182, ["zm"] = 2021,
      },
    },
  },
  [6849] = {
    ["c"] = false,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Faven's Note",
    ["e"] = {
    },
  },
  [6850] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Devastator Ursana's Letter",
    ["q"] = 6708,
    ["e"] = {
      [1] = { ["px"] = 1.1104176263, ["py"] = 0.6872368159, ["pm"] = 2021, },
    },
  },
  [6851] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Merchandise Retrieval Order",
    ["q"] = 6738,
    ["e"] = {
      [1] = { ["px"] = 0.8528612075, ["py"] = 1.0249784243, ["pm"] = 2035, },
    },
  },
  [6852] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Epics of Mehrunes Dagon, Volume 2",
    ["e"] = {
      [1] = { ["px"] = 1.1537328232, ["py"] = 0.7493716172, ["pm"] = 2021, },
    },
  },
  [6853] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On Proper Whip Procedures",
    ["e"] = {
      [1] = {
        ["px"] = 1.0083824034, ["py"] = 0.7610435837, ["pm"] = 2106,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6854] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Confiscated from the Prisoner",
    ["e"] = {
      [1] = {
        ["px"] = 0.1179979983, ["py"] = 0.6295479913, ["pm"] = 2186,
        ["zx"] = 0.1178388044, ["zy"] = 0.6371344010, ["zm"] = 1349,
        ["d"] = true,
      },
    },
  },
  [6855] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Apply More Pressure",
    ["e"] = {
      [1] = {
        ["px"] = 0.1171487978, ["py"] = 0.6294795976, ["pm"] = 2187, ["d"] = true,
        ["zx"] = 0.1178388044, ["zy"] = 0.6371344010, ["zm"] = 1349,
      },
    },
  },
  [6856] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Gryphon Watching Log",
    ["e"] = {
      [1] = {
        ["px"] = 0.1164219990, ["py"] = 0.6301964082, ["pm"] = 2188, ["d"] = true,
        ["zx"] = 0.1178388044, ["zy"] = 0.6371344010, ["zm"] = 1349,
      },
    },
  },
  [6857] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Ancient Inscription",
    ["e"] = {
      [1] = { ["px"] = 0.1186399994, ["py"] = 0.6287551934, ["pm"] = 2111, ["d"] = true, ["zx"] = 0.1178388044, ["zy"] = 0.6371344010, ["zm"] = 1349, },
    },
  },
  [6861] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Find the Lodestones!",
    ["e"] = {
      [1] = {
        ["px"] = 0.2198516024, ["py"] = 0.2369047997, ["pm"] = 2120, ["d"] = true,
        ["zx"] = 0.2099292006, ["zy"] = 0.2348336019, ["zm"] = 10,
      },
    },
  },
  [6862] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "My Dear Vanessa",
    ["e"] = {
      [1] = {
        ["px"] = 0.2194828023, ["py"] = 0.2361875997, ["pm"] = 2120, ["d"] = true,
        ["zx"] = 0.2099292006, ["zy"] = 0.2348336019, ["zm"] = 10,
      },
    },
  },
  [6863] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Letter of Execution",
    ["e"] = {
      [1] = {
        ["px"] = 0.2187384024, ["py"] = 0.2365995997, ["pm"] = 2120, ["d"] = true,
        ["zx"] = 0.2099292006, ["zy"] = 0.2348336019, ["zm"] = 10,
      },
    },
  },
  [6864] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Report on the Dock Crash",
    ["e"] = {
      [1] = {
        ["px"] = 0.2198084024, ["py"] = 0.2369279997, ["pm"] = 2120, ["d"] = true,
        ["zx"] = 0.2099292006, ["zy"] = 0.2348336019, ["zm"] = 10,
      },
    },
  },
  [6868] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Warden's Orders for the Day",
    ["q"] = 6707,
    ["e"] = {
      [1] = { ["px"] = 1.0385532296, ["py"] = 0.7912216183, ["pm"] = 2021, },
    },
  },
  [6899] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Time to Face Reality",
    ["e"] = {
      [1] = { ["px"] = 0.1445112067, ["py"] = 0.3108227940, ["pm"] = 2044, ["d"] = true, ["zx"] = 0.1392043987, ["zy"] = 0.3088380025, ["zm"] = 1, },
    },
  },
  [6900] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Fargrave's Song",
    ["e"] = {
      [1] = { ["px"] = 0.8623544070, ["py"] = 1.0172360257, ["pm"] = 2035, },
    },
  },
  [6918] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Food of the Deadlands",
    ["e"] = {
      [1] = { ["px"] = 1.0749536282, ["py"] = 0.7307600163, ["pm"] = 2021, },
    },
  },
  [6919] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The First Gleaner",
    ["e"] = {
      [1] = {
        ["px"] = 0.8593828256, ["py"] = 1.0351228037, ["pm"] = 2099,
        ["zx"] = 0.8558236076, ["zy"] = 1.0207332256, ["zm"] = 2035,
        ["d"] = true,
      },
      [2] = { ["px"] = 0.8558236202, ["py"] = 1.0207331897, ["pm"] = 2119, ["fp"] = true, ["d"] = true, },
    },
  },
  [6920] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On the True Nature of Daedra",
    ["e"] = {
      [1] = { ["px"] = 1.1037340285, ["py"] = 0.7179416164, ["pm"] = 2021, },
    },
  },
  [6921] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On Inferniums",
    ["e"] = {
      [1] = { ["px"] = 1.0349000308, ["py"] = 0.7635840152, ["pm"] = 2021, },
    },
  },
  [6922] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Head Overseer's Orders",
    ["q"] = 6698,
    ["e"] = {
      [1] = { ["px"] = 1.0250780293, ["py"] = 0.7777800112, ["pm"] = 2021, },
    },
  },
  [6923] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Torn Journal Page",
    ["q"] = 6706,
    ["e"] = {
      [1] = { ["px"] = 1.1386148315, ["py"] = 0.7149928142, ["pm"] = 2021, },
    },
  },
  [6924] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Note for Khazasha",
    ["q"] = 6705,
    ["e"] = {
      [1] = { ["px"] = 1.0519980276, ["py"] = 0.7615968134, ["pm"] = 2021, },
      [2] = { ["px"] = 1.0633520295, ["py"] = 0.7506052165, ["pm"] = 2021, },
    },
  },
  [6925] = {
    ["c"] = false,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "On the Nature of Oblivion",
    ["e"] = {
    },
  },
  [6926] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Legend of Deadlight",
    ["e"] = {
      [1] = { ["px"] = 1.0387424265, ["py"] = 0.7843836190, ["pm"] = 2021, },
    },
  },
  [6927] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Letter of Complaint",
    ["e"] = {
      [1] = {
        ["px"] = 1.0097051696, ["py"] = 0.7566759792, ["pm"] = 2122,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true, },
    },
  },
  [6928] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Eveli's Speech Ideas",
    ["q"] = 6693,
    ["e"] = {
      [1] = { ["px"] = 0.6088208047, ["py"] = 0.6812880072, ["pm"] = 1940, ["zm"] = 1887, },
    },
  },
  [6929] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Lessons on Lucents",
    ["e"] = {
      [1] = {
        ["px"] = 0.8580000255, ["py"] = 1.0364104038, ["pm"] = 2099,
        ["zx"] = 0.8558236076, ["zy"] = 1.0207332256, ["zm"] = 2035,
        ["d"] = true,
      },
      [2] = { ["px"] = 0.8558236202, ["py"] = 1.0207331897, ["pm"] = 2119, ["fp"] = true, ["d"] = true, },
    },
  },
  [6930] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Brugurikh's Journal",
    ["e"] = {
      [1] = {
        ["px"] = 1.1599292458, ["py"] = 0.7086828259, ["pm"] = 2089,
        ["zx"] = 1.1519280290, ["zy"] = 0.7125928190, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [6931] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Tenets of Destruction",
    ["e"] = {
      [1] = { ["px"] = 1.0560392273, ["py"] = 0.7675944138, ["pm"] = 2021, },
    },
  },
  [6932] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Knight Ondrisse's Orders",
    ["q"] = 6752,
    ["e"] = {
      [1] = { ["px"] = 0.0671288021, ["py"] = 0.5974976016, ["pm"] = 2114, },
    },
  },
  [6933] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Broken Oath",
    ["e"] = {
      [1] = {
        ["px"] = 0.0549451986, ["py"] = 0.5840020149, ["pm"] = 2133, ["d"] = true,
        ["zx"] = 0.0542832023, ["zy"] = 0.5846908027, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [6937] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Visitor's Guide to the Shambles",
    ["e"] = {
      [1] = { ["px"] = 0.8831016074, ["py"] = 1.0125416257, ["pm"] = 2035, },
    },
  },
  [6938] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Ascendant Proclamation",
    ["q"] = 6752,
    ["e"] = {
      [1] = {
        ["px"] = 0.0746695995, ["py"] = 0.6005256042, ["pm"] = 2146, ["d"] = true,
        ["zx"] = 0.0745060030, ["zy"] = 0.6003248017, ["zm"] = 2114,
      },
    },
  },
  [6939] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Prisoner Manifest",
    ["q"] = 6752,
    ["e"] = {
      [1] = {
        ["px"] = 0.0747835995, ["py"] = 0.6005984042, ["pm"] = 2146, ["d"] = true,
        ["zx"] = 0.0745060030, ["zy"] = 0.6003248017, ["zm"] = 2114,
      },
    },
  },
  [6941] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Waterlogged Journal of Vanisande Maul",
    ["e"] = {
      [1] = {
        ["px"] = 0.0847304019, ["py"] = 0.5830395909, ["pm"] = 2211, ["d"] = true,
        ["zx"] = 0.0851008033, ["zy"] = 0.5826904014, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [6942] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Gangs of the Shambles",
    ["e"] = {
      [1] = { ["px"] = 0.8712760068, ["py"] = 1.0211856254, ["pm"] = 2035, },
    },
  },
  [6943] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "A Vision of the Twin Citadels",
    ["e"] = {
      [1] = { ["px"] = 1.0681664303, ["py"] = 0.7942752143, ["pm"] = 2021, },
    },
  },
  [6944] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Dour Lady's Captain Log",
    ["q"] = 6762,
    ["e"] = {
      [1] = {
        ["px"] = 0.0858707993, ["py"] = 0.5829815964, ["pm"] = 2199, ["d"] = true,
        ["zx"] = 0.0851008033, ["zy"] = 0.5826904014, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [6945] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Debonaire's Captain Log",
    ["q"] = 6762,
    ["e"] = {
      [1] = {
        ["px"] = 0.0857791992, ["py"] = 0.5828199964, ["pm"] = 2199, ["d"] = true,
        ["zx"] = 0.0851008033, ["zy"] = 0.5826904014, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [6946] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Commodore's Diary",
    ["q"] = 6762,
    ["e"] = {
      [1] = {
        ["px"] = 0.0858227992, ["py"] = 0.5829087964, ["pm"] = 2199, ["d"] = true,
        ["zx"] = 0.0851008033, ["zy"] = 0.5826904014, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [6947] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Battle of Meadow Fort",
    ["q"] = 6760,
    ["e"] = {
      [1] = {
        ["px"] = 0.0518587997, ["py"] = 0.5991515875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [6948] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter to Dockmaster Arnauld",
    ["q"] = 6753,
    ["e"] = {
      [1] = { ["px"] = 0.0662624024, ["py"] = 0.6054952021, ["pm"] = 2114, },
    },
  },
  [6949] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Note to Cynric",
    ["q"] = 6767,
    ["e"] = {
      [1] = { ["px"] = 0.0598784020, ["py"] = 0.5856520020, ["pm"] = 2114, ["qc"] = true, },
    },
  },
  [6950] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Ode to the Nose of a Woman",
    ["q"] = 6760, -- it is given to you at the begining of the quest
    ["e"] = {
      [1] = { ["px"] = 0.0518611997, ["py"] = 0.5992903875, ["pm"] = 2219, ["d"] = true, ["zm"] = 2114, ["qc"] = true, }, -- can be found here AFTER quest is completed
    },
  },
  [6966] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Courier Grenier's Note",
    ["q"] = 6753,
    ["e"] = {
      [1] = { ["px"] = 0.0595756017, ["py"] = 0.6041560023, ["pm"] = 2114, },
    },
  },
  [6968] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Ascendant Champion's New Orders",
    ["q"] = 6761,
    ["e"] = {
      [1] = { ["px"] = -0.1621868038, ["py"] = 0.3127827974, ["pm"] = 2143, ["d"] = true, },
    },
  },
  [6969] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Knight Richel's Orders",
    ["q"] = 6753,
    ["e"] = {
      [1] = {
        ["px"] = 0.0598784010, ["py"] = 0.6066248070, ["pm"] = 2130, ["d"] = true,
        ["zx"] = 0.0597760025, ["zy"] = 0.6067328012, ["zm"] = 2114,
      },
    },
  },
  [6970] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Rules of the Game",
    ["q"] = 6756,
    ["e"] = {
      [1] = {
        ["px"] = 0.0678452018, ["py"] = 0.5785203862, ["pm"] = 2138, ["d"] = true,
        ["zx"] = 0.0727092014, ["zy"] = 0.5804376024, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7004] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Journal of Scamp Naal",
    ["e"] = {
      [1] = {
        ["px"] = 1.1605104458, ["py"] = 0.7089652258, ["pm"] = 2089,
        ["zx"] = 1.1519280290, ["zy"] = 0.7125928190, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [7005] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Lashum's Report",
    ["e"] = {
      [1] = { ["px"] = 0.0819184010, ["py"] = 0.5830316019, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7006] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Dremora Stories About Mortals",
    ["e"] = {
      [1] = { ["px"] = 1.1119528261, ["py"] = 0.7560600185, ["pm"] = 2021, },
    },
  },
  [7007] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Trial of Perseverance",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0602539985, ["py"] = 0.5861940030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7009] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Voyage of the Seajoy, Day Five",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606703985, ["py"] = 0.5861960030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7010] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Voyage of the Seajoy, Day Seven",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606067985, ["py"] = 0.5861676030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7011] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Voyage of the Seajoy, Day Eight",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606067985, ["py"] = 0.5860948030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7012] = {
    ["c"] = true,
    ["cn"] = "Diaries and Logs",
    ["n"] = "Voyage of the Seajoy, Day Fourteen",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606707985, ["py"] = 0.5861668030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7013] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Duchess Elea's Investigation Notes",
    ["q"] = 6753,
    ["e"] = {
      [1] = { ["px"] = 0.0521708010, ["py"] = 0.5983523993, ["pm"] = 2173, ["d"] = true, },
    },
  },
  [7014] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Mairead's Diary, Entry 3",
    ["q"] = 6696,
    ["e"] = {
      [1] = { ["px"] = 0.8646536079, ["py"] = 1.0271496248, ["pm"] = 2035, }, -- post-quest location
      [2] = { ["px"] = 0.6273983794, ["py"] = 0.6085763889, ["pm"] = 2090, ["d"] = true, },
    },
  },
  [7015] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Mairead's Diary, Entry 346",
    ["q"] = 6696,
    ["e"] = {
      [1] = { ["px"] = 0.8647260084, ["py"] = 1.0271532244, ["pm"] = 2035, }, -- post-quest location
      [2] = { ["px"] = 0.6274091794, ["py"] = 0.6085787889, ["pm"] = 2090, ["d"] = true, },
    },
  },
  [7016] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Mairead's Diary, Entry 712",
    ["e"] = {
      [1] = { ["px"] = 0.8647260084, ["py"] = 1.0271532244, ["pm"] = 2035, }, -- post-quest location
      [2] = { ["px"] = 0.6274019794, ["py"] = 0.6085747889, ["pm"] = 2090, ["d"] = true, },
    },
  },
  [7017] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Transport Plans",
    ["e"] = {
      [1] = {
        ["px"] = 0.0727735987, ["py"] = 0.5949123952, ["pm"] = 2162, ["d"] = true,
        ["zx"] = 0.0727632021, ["zy"] = 0.5948508008, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7018] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Orders for the Recruits",
    ["e"] = {
      [1] = {
        ["px"] = 0.0726015987, ["py"] = 0.5949091951, ["pm"] = 2162, ["d"] = true,
        ["zx"] = 0.0727632021, ["zy"] = 0.5948508008, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7019] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Trial of Wits",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606395985, ["py"] = 0.5860488030, ["pm"] = 2159, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7021] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Banneret Jenine's Orders",
    ["q"] = 6765,
    ["e"] = {
      [1] = { ["px"] = 0.0563008013, ["py"] = 0.5815503940, ["pm"] = 2167, ["d"] = true, ["zx"] = 0.0593876026, ["zy"] = 0.5800732015, ["zm"] = 2114, },
    },
  },
  [7022] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Trial of Constitution",
    ["q"] = 6767,
    ["e"] = {
      [1] = {
        ["px"] = 0.0606392004, ["py"] = 0.5856716088, ["pm"] = 2217, ["d"] = true,
        ["zx"] = 0.0613384014, ["zy"] = 0.5849744015, ["zm"] = 2114,
      },
    },
  },
  [7024] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Sailing Orders",
    ["q"] = 6765,
    ["e"] = {
      [1] = { ["px"] = 0.0543943988, ["py"] = 0.6012120002, ["pm"] = 2168, ["d"] = true, ["zx"] = 0.0541156019, ["zy"] = 0.6012716013, ["zm"] = 2114, },
    },
  },
  [7025] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Mender Roslenn's Journal",
    ["q"] = 6772,
    ["e"] = {
      [1] = { ["px"] = 0.0617468014, ["py"] = 0.5981252032, ["pm"] = 2114, },
    },
  },
  [7026] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Adwig's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.0758404025, ["py"] = 0.5757092017, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7027] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Dreadsails Communique",
    ["q"] = 6773,
    ["e"] = {
      [1] = { ["px"] = 0.0763292025, ["py"] = 0.5753404020, ["pm"] = 2114, },
    },
  },
  [7029] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Master Healer Viralaine's Notes",
    ["q"] = 6772,
    ["e"] = {
      [1] = {
        ["px"] = 0.0600659996, ["py"] = 0.5976196064, ["pm"] = 2221, ["d"] = true,
        ["zx"] = 0.0587364026, ["zy"] = 0.5984180035, ["zm"] = 2114,
      },
    },
  },
  [7030] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Mirrored Way",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0687912018, ["py"] = 0.5970884015, ["pm"] = 2114, ["qp"] = true, },
    },
    ["c"] = true,
  },
  [7031] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Ascendant Magus's Commission",
    ["q"] = 6765,
    ["e"] = {
      [1] = { ["px"] = 0.0461840018, ["py"] = 0.5993824017, ["pm"] = 2114, ["d"] = true, },
    },
  },
  [7032] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Work in Gonfalon Bay",
    ["e"] = {
      [1] = { ["px"] = 0.0695052026, ["py"] = 0.6031628053, ["pm"] = 2163, ["zm"] = 2114, },
    },
  },
  [7033] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Report for the Head Jailer",
    ["e"] = {
      [1] = { ["px"] = 0.0763696033, ["py"] = 0.5852916124, ["pm"] = 2214, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7034] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Head Jailer's Journal",
    ["q"] = 6780,
    ["e"] = {
      [1] = { ["px"] = 0.0764440032, ["py"] = 0.5852044124, ["pm"] = 2214, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7035] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Head Jailer's Ledger",
    ["q"] = 6780,
    ["e"] = {
      [1] = { ["px"] = 0.0764996032, ["py"] = 0.5852024123, ["pm"] = 2214, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7036] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Healer Jenille's Note",
    ["q"] = 6776,
    ["e"] = {
      [1] = { ["px"] = 0.0619752016, ["py"] = 0.5986504025, ["pm"] = 2114, },
    },
  },
  [7038] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Finimi's Domicile",
    ["q"] = 6780,
    ["e"] = {
      [1] = { ["px"] = 0.0776288028, ["py"] = 0.5801572024, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7039] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Fleet Queen's Orders",
    ["e"] = {
      [1] = { ["px"] = 0.0102952004, ["py"] = 0.5787592111, ["pm"] = 2181, ["zx"] = 0.0533936021, ["zy"] = 0.5811676021, ["zm"] = 2114, ["d"] = true, },
    },
  },
  [7040] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Sorti's Shanties in Progress",
    ["e"] = {
      [1] = { ["px"] = 0.0113903999, ["py"] = 0.5834071948, ["pm"] = 2166, ["zx"] = 0.0533936021, ["zy"] = 0.5811676021, ["zm"] = 2114, ["d"] = true, },
    },
  },
  [7041] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Quit Overfeeding the Maw",
    ["e"] = {
      [1] = { ["px"] = 0.0115308003, ["py"] = 0.5784736112, ["pm"] = 2181, ["zx"] = 0.0533936021, ["zy"] = 0.5811676021, ["zm"] = 2114, ["d"] = true, },
    },
  },
  [7042] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Prepare Some Entertainment",
    ["e"] = {
      [1] = { ["px"] = 0.0113395998, ["py"] = 0.5834999948, ["pm"] = 2166, ["zx"] = 0.0533936021, ["zy"] = 0.5811676021, ["zm"] = 2114, ["d"] = true, },
    },
  },
  [7046] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Notes on the Visitor's Guide to the Shambles",
    ["e"] = {
      [1] = { ["px"] = 0.8942744284, ["py"] = 0.9799671997, ["pm"] = 2082, },
    },
  },
  [7047] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Secret History of the Longhouse Emperors",
    ["e"] = {
      [1] = {
        ["px"] = 1.0088875696, ["py"] = 0.7558527792, ["pm"] = 2107,
        ["zx"] = 1.0071172286, ["zy"] = 0.7643976187, ["zm"] = 2021,
        ["d"] = true,
      },
    },
  },
  [7048] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "The Bearers of Fargrave",
    ["e"] = {
      [1] = { ["px"] = 0.8637660080, ["py"] = 1.0398376243, ["pm"] = 2035, },
    },
  },
  [7049] = {
    ["c"] = true,
    ["cn"] = "Dispatches from the Deadlands",
    ["n"] = "Flora and Fauna of the Sever",
    ["e"] = {
      [1] = { ["px"] = 1.1204768284, ["py"] = 0.7508964180, ["pm"] = 2021, },
    },
  },
  [7095] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Silverslip's Journal",
    ["q"] = 6786,
    ["e"] = {
      [1] = { ["px"] = 0.7262711900, ["py"] = 0.5349919961, ["pm"] = 149, ["d"] = true, ["zx"] = 0.7262719910, ["zy"] = 0.5341439946, ["zm"] = 26, ["qp"] = true, },
    },
  },
  [7096] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Ascendant Order Note",
    ["q"] = 6751,
    ["e"] = {
      [1] = {
        ["px"] = 0.7256208187, ["py"] = 0.3117144003, ["pm"] = 1157, ["d"] = true,
        ["zx"] = 0.7252892229, ["zy"] = 0.3110492054, ["zm"] = 1060,
      },
    },
  },
  [7097] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Ascendant Champion Orders",
    ["q"] = 6751,
    ["e"] = {
      [1] = { ["px"] = -0.1207628051, ["py"] = 0.3140947944, ["pm"] = 2141, ["d"] = true, },
    },
  },
  [7098] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Emerald Eye Mage's Journal",
    ["q"] = 6787,
    ["e"] = {
      [1] = { ["px"] = 0.1742916002, ["py"] = 0.3957151922, ["pm"] = 30, ["qp"] = true, }, --Must be read as part of quest
    },
  },
  [7099] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter from Aurelia Jourvel",
    ["q"] = 6789, -- given to you at the begining of the quest
    ["e"] = {
      [1] = { ["px"] = 0.0518443997, ["py"] = 0.5991439875, ["pm"] = 2219, ["d"] = true, ["zm"] = 2114, ["qc"] = true, }, -- can be found here AFTER completing the quest
    },
  },
  [7100] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Kiv's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.1641764007, ["py"] = 0.5435359912, ["pm"] = 530, ["zm"] = 201, },
    },
    ["c"] = true,
  },
  [7101] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Balki's Instructions",
    ["q"] = 6792,
    ["e"] = {
      [1] = { ["px"] = 0.0634508015, ["py"] = 0.6029440024, ["pm"] = 2114, },
    },
  },
  [7102] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Ferone's Instructions",
    ["q"] = 6793,
    ["e"] = {
      [1] = { ["px"] = 0.0536080019, ["py"] = 0.5904032023, ["pm"] = 2114, },
    },
  },
  [7103] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Rhadh's Instructions",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7105] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter from Julles Laurdon",
    ["e"] = {
      [1] = { ["px"] = 0.7549328263, ["py"] = 0.3674868081, ["pm"] = 1060, },
    },
    ["c"] = true,
  },
  [7107] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Kiv's Notes",
    ["e"] = {
      [1] = { ["px"] = 0.7549288248, ["py"] = 0.3674888034, ["pm"] = 1060, },
    },
    ["c"] = true,
  },
  [7108] = {
    ["cn"] = "Hearts and Flowers",
    ["n"] = "The Rose of Navire, Part the First",
    ["q"] = 6790,
    ["e"] = {
      [1] = {
        ["px"] = 0.0518555997, ["py"] = 0.5992875875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7109] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Captured by the Dreadsails",
    ["e"] = {
      [1] = { ["px"] = 0.0760352029, ["py"] = 0.5750420020, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7110] = {
    ["cn"] = "Hearts and Flowers",
    ["n"] = "The Rose of Navire, Part the Second",
    ["q"] = 6790,
    ["e"] = {
      [1] = { ["px"] = 0.0692584028, ["py"] = 0.6027004052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7111] = {
    ["cn"] = "Hearts and Flowers",
    ["n"] = "The Rose of Navire, Part the Third",
    ["q"] = 6790,
    ["e"] = {
      [1] = { ["px"] = 0.0698044028, ["py"] = 0.6041568052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7113] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Society of the Steadfast",
    ["e"] = {
      [1] = { ["px"] = 0.0619276014, ["py"] = 0.5987352035, ["pm"] = 2114, },
    },
  },
  [7114] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Green Serpent Bounty",
    ["e"] = {
      [1] = { ["px"] = 0.0815220019, ["py"] = 0.5830836017, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7115] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Aurelia's Letter",
    ["q"] = 6791,
    ["e"] = {
      [1] = { ["px"] = 0.0694004026, ["py"] = 0.6027752052, ["pm"] = 2163, ["zm"] = 2114, ["qp"] = true, },
    },
  },
  [7116] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "A History of Shipbuilding, Vol. 1 of 27",
    ["e"] = {
      [1] = {
        ["px"] = 0.0518379997, ["py"] = 0.5991531875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7117] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Dirge of the Stormy Seas",
    ["e"] = {
      [1] = {
        ["px"] = 0.0860383992, ["py"] = 0.5828747965, ["pm"] = 2199, ["d"] = true,
        ["zx"] = 0.0851008033, ["zy"] = 0.5826904014, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7118] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Mysteries of the Eltheric Ammonite",
    ["e"] = {
      [1] = {
        ["px"] = 0.0567103990, ["py"] = 0.5968303929, ["pm"] = 2156, ["d"] = true,
        ["zx"] = 0.0571856025, ["zy"] = 0.5969848026, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7119] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Wyrd and Druid",
    ["e"] = {
      [1] = {
        ["px"] = 0.0820991981, ["py"] = 0.5727091922, ["pm"] = 2153, ["d"] = true,
        ["zx"] = 0.0827916034, ["zy"] = 0.5731292019, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7120] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Sorrows of the Wind",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0691184033, ["py"] = 0.5966264029, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7121] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Noble Ranks and Titles",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2114] = 1,
    },
  },
  [7122] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Fair and Fresh Upon the Lea",
    ["q"] = 6753,
    ["e"] = {
      [1] = {
        ["px"] = 0.0513172003, ["py"] = 0.5986976046, ["pm"] = 2172, ["d"] = true,
        ["zx"] = 0.0519376017, ["zy"] = 0.5989264028, ["zm"] = 2114,
      },
      [2] = { ["px"] = 0.0517472016, ["py"] = 0.6002128014, ["pm"] = 2114, },
    },
  },
  [7123] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Green Serpent Testimonials",
    ["e"] = {
      [1] = {
        ["px"] = 0.0674408018, ["py"] = 0.5783427862, ["pm"] = 2138, ["d"] = true,
        ["zx"] = 0.0727092014, ["zy"] = 0.5804376024, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7124] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Theories: Soulrazer Knights",
    ["e"] = {
      [1] = {
        ["px"] = 0.0804511975, ["py"] = 0.5962460132, ["pm"] = 2171, ["d"] = true,
        ["zx"] = 0.0735124018, ["zy"] = 0.5961748009, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7126] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "A Hunter's Journey VI: Fauns",
    ["e"] = {
      [1] = { ["px"] = 0.0691048008, ["py"] = 0.5966884014, ["pm"] = 2114, },
    },
  },
  [7130] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "History of House Dufort",
    ["e"] = {
      [1] = { ["px"] = 0.0715032013, ["py"] = 0.5897176011, ["pm"] = 2114, },
    },
    ["r"] = true,
    ["m"] = {
      [2114] = true,
    },
  },
  [7132] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Burned Research Notes",
    ["q"] = 6765,
    ["e"] = {
      [1] = { ["px"] = 0.0560376013, ["py"] = 0.5815155940, ["pm"] = 2167, ["d"] = true, ["zx"] = 0.0593876026, ["zy"] = 0.5800732015, ["zm"] = 2114, },
    },
  },
  [7133] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Duties and Routine",
    ["e"] = {
      [1] = { ["px"] = 0.0502804017, ["py"] = 0.6004376034, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7134] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Delicacies of High Isle",
    ["e"] = {
      [1] = { ["px"] = 0.0528000009, ["py"] = 0.5920516085, ["pm"] = 2213, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7136] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Ballad of the All Flags Navy",
    ["e"] = {
      [1] = { ["px"] = 0.0614832014, ["py"] = 0.5944344016, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7137] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter from Deesh-Jee",
    ["e"] = {
      [1] = {
        ["px"] = 0.0820651981, ["py"] = 0.5728451922, ["pm"] = 2153, ["d"] = true,
        ["zx"] = 0.0827916034, ["zy"] = 0.5731292019, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7138] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Letter from Lady Arabelle",
    ["q"] = 6751,
    ["e"] = {
      [1] = { ["px"] = 0.7848220306, ["py"] = 0.3827544091, ["pm"] = 1060, },
    },
  },
  [7142] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Evergrowth Restoration Ritual",
    ["q"] = 6770,
    ["e"] = {
      [1] = { ["px"] = 0.0532444010, ["py"] = 0.5924796086, ["pm"] = 2213, ["zm"] = 2114, },
    },
  },
  [7143] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Mad Baron Densil, Part the First",
    ["q"] = 6760,
    ["e"] = {
      [1] = {
        ["px"] = 0.0518315997, ["py"] = 0.5991275875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7144] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Fera's Journal",
    ["q"] = 6780,
    ["e"] = {
      [1] = { ["px"] = 0.0821884016, ["py"] = 0.5853772025, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7145] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Finimi's Spellbook",
    ["e"] = {
      [1] = { ["px"] = 0.0777800019, ["py"] = 0.5801048019, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7146] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "History of House Mornard",
    ["e"] = {
      [1] = { ["px"] = 0.0758744031, ["py"] = 0.5863940123, ["pm"] = 2214, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7147] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "1. The Thrassian Plague",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0604220027, ["py"] = 0.5949436024, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7148] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "2. Baron-Admiral Bendu Olo",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0603652025, ["py"] = 0.5949900032, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7149] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "3. The All Flags Navy",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0603168022, ["py"] = 0.5950076018, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7150] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "4. Instrument of Vengeance",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0602188024, ["py"] = 0.5949620024, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7151] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "5. Construction of Monument Island",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0601784013, ["py"] = 0.5948972016, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7152] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Journal of a Scorned Lover",
    ["e"] = {
      [1] = {
        ["px"] = 0.0664971973, ["py"] = 0.5808847899, ["pm"] = 2131, ["d"] = true,
        ["zx"] = 0.0669036022, ["zy"] = 0.5865292019, ["zm"] = 2114,
      },
    },
  },
  [7153] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The All Flags Navy Started Here",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0613176026, ["py"] = 0.5942208033, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7154] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "In Memory of the Brave Souls",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0602744018, ["py"] = 0.5936384031, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7157] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "About Jhaka",
    ["e"] = {
      [1] = {
        ["px"] = 0.8013100067, ["py"] = 0.2972772004, ["pm"] = 1300, ["d"] = true,
        ["zx"] = 0.8020876301, ["zy"] = 0.2968624027, ["zm"] = 1060,
      },
    },
    ["c"] = true,
  },
  [7158] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Investigator Vale and the Haunted Lighthouse",
    ["e"] = {
      [1] = { ["px"] = 0.0713104028, ["py"] = 0.6032672052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7159] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Izbadd's Letter",
    ["q"] = 6787, --It is given to you during the quest.
    ["e"] = {
      [1] = { ["px"] = 0.2835007991, ["py"] = 0.3134632048, ["pm"] = 84, ["zm"] = 20, ["qc"] = true, }, -- can be found here AFTER completing the quest
    },
  },
  [7168] = {
    ["c"] = true,
    ["n"] = "Seeking Tribute Players!",
    ["cn"] = "Tomes of Tributes",
    ["e"] = {
      [1] = { ["px"] = 0.0682280026, ["py"] = 0.6043096051, ["pm"] = 2163, ["zm"] = 2114, },
      [2] = { ["px"] = 0.9388055812, ["py"] = 0.3856527953, ["pm"] = 2343, ["zm"] = 2274, },
      [3] = { ["px"] = 0.8237192089, ["py"] = 0.4120223878, ["pm"] = 2386, ["zm"] = 2274, },
    },
  },
  [7172] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Mad Baron Densil, Part the Second",
    ["q"] = 6760,
    ["e"] = {
      [1] = {
        ["px"] = 0.0518031997, ["py"] = 0.5991539875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7173] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Mad Baron Densil, Part the Third",
    ["q"] = 6760,
    ["e"] = {
      [1] = {
        ["px"] = 0.0518475997, ["py"] = 0.5991415875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7174] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Sea Lore for Arcane Crafting",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0691448011, ["py"] = 0.5965368016, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7175] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Amiviridil Arcanium",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0689028013, ["py"] = 0.5972980009, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7176] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Magister Irin's Notes",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0691424023, ["py"] = 0.5966392011, ["pm"] = 2114, ["qp"] = true, },
    },
    ["c"] = true,
  },
  [7177] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Notes on Vulk'esh",
    ["e"] = {
      [1] = {
        ["px"] = 0.0569307990, ["py"] = 0.5971303929, ["pm"] = 2156, ["d"] = true,
        ["zx"] = 0.0571856025, ["zy"] = 0.5969848026, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7178] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Coral's Revenge",
    ["e"] = {
      [1] = {
        ["px"] = 0.0817875981, ["py"] = 0.5730263922, ["pm"] = 2153, ["d"] = true,
        ["zx"] = 0.0827916034, ["zy"] = 0.5731292019, ["zm"] = 2114,
      },
    },
    ["c"] = true,
  },
  [7179] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Purities of Mania",
    ["q"] = 6771,
    ["e"] = {
      [1] = { ["px"] = 0.0692752014, ["py"] = 0.5971692036, ["pm"] = 2114, ["qp"] = true, },
    },
    ["c"] = true,
  },
  [7180] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Sea Stone",
    ["e"] = {
      [1] = { ["px"] = 0.0603748018, ["py"] = 0.5944532023, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7181] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Monument Lighthouse",
    ["e"] = {
      [1] = { ["px"] = 0.0603776013, ["py"] = 0.5947836012, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7182] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Monument Inn",
    ["e"] = {
      [1] = { ["px"] = 0.0598676018, ["py"] = 0.5940324034, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7184] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Tobin Moorcroft",
    ["q"] = 6796,
    ["e"] = {
      [1] = { ["px"] = 0.0606468018, ["py"] = 0.5936976020, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7185] = {
    ["c"] = true,
    ["n"] = "Spirits of Lost Nature",
    ["cn"] = "Library of Incunabula",
    ["e"] = {
      [1] = {
        ["px"] = 0.0834724004, ["py"] = 0.6082812037, ["pm"] = 2206, ["d"] = true,
        ["zx"] = 0.0553544017, ["zy"] = 0.6021128012, ["zm"] = 2114,
      },
    },
  },
  [7186] = {
    ["c"] = true,
    ["n"] = "Message of Welcome",
    ["cn"] = "Library of Incunabula",
    ["e"] = {
      [1] = {
        ["px"] = 0.0833120004, ["py"] = 0.6081424037, ["pm"] = 2206, ["d"] = true,
        ["zx"] = 0.0553544017, ["zy"] = 0.6021128012, ["zm"] = 2114,
      },
    },
  },
  [7187] = {
    ["c"] = true,
    ["n"] = "The Only Record of Our Plan",
    ["cn"] = "Library of Incunabula",
    ["e"] = {
      [1] = {
        ["px"] = 0.0843764011, ["py"] = 0.6077860012, ["pm"] = 2208, ["d"] = true,
        ["zx"] = 0.0553544017, ["zy"] = 0.6021128012, ["zm"] = 2114,
      },
    },
  },
  [7188] = {
    ["c"] = true,
    ["n"] = "The Meaning of the Hidden Fawn",
    ["cn"] = "Library of Incunabula",
    ["e"] = {
      [1] = {
        ["px"] = 0.0845008011, ["py"] = 0.6080680012, ["pm"] = 2208, ["d"] = true,
        ["zx"] = 0.0553544017, ["zy"] = 0.6021128012, ["zm"] = 2114,
      },
    },
  },
  [7192] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "A Warning to Those Who Follow",
    ["e"] = {
      [1] = { ["px"] = 0.0506455998, ["py"] = 0.6090427932, ["pm"] = 2240, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, },
    },
  },
  [7193] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "A Second Warning",
    ["e"] = {
      [1] = { ["px"] = 0.0519360015, ["py"] = 0.6090544034, ["pm"] = 2230, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, },
    },
  },
  [7194] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Your Final Warning",
    ["e"] = {
      [1] = { ["px"] = 0.0509284004, ["py"] = 0.6079315914, ["pm"] = 2233, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, },
    },
  },
  [7195] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Logbook of Druid Anwas",
    ["e"] = {
      [1] = { ["px"] = 0.0507428004, ["py"] = 0.6076639914, ["pm"] = 2233, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, }, --This is for the pre-dungeon completion location.
      [2] = { ["px"] = 0.0505004003, ["py"] = 0.6091539992, ["pm"] = 2229, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, }, --This is for the post-dungeon completion location. You can find this on the ground pre-completion but it must be read BEFORE fighting final boss.
    },
  },
  [7196] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Logbook of Druid Betrys",
    ["e"] = {
      [1] = { ["px"] = 0.0505128004, ["py"] = 0.6091255992, ["pm"] = 2229, ["d"] = true, ["zx"] = 0.0759564031, ["zy"] = 0.5872872124, ["zm"] = 2114, },
    },
  },
  [7199] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Visitor's Guide to High Isle",
    ["e"] = {
      [1] = { ["px"] = 0.0671516026, ["py"] = 0.6047216053, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7200] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Lighthouse Orders",
    ["q"] = 6752,
    ["e"] = {
      [1] = { ["px"] = 0.0626664018, ["py"] = 0.6069092015, ["pm"] = 2114, },
    },
  },
  [7201] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 1",
    ["e"] = {
      [1] = { ["px"] = 0.0817732017, ["py"] = 0.5830268015, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7202] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 2",
    ["e"] = {
      [1] = { ["px"] = 0.0876128014, ["py"] = 0.5784588014, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7203] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 3",
    ["e"] = {
      [1] = { ["px"] = 0.0606980016, ["py"] = 0.6060320030, ["pm"] = 2114, },
    },
  },
  [7204] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 4",
    ["e"] = {
      [1] = { ["px"] = 0.0653668025, ["py"] = 0.5916424015, ["pm"] = 2114, },
    },
  },
  [7205] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter from Vetitia Marcott",
    ["e"] = {
      [1] = { ["px"] = 0.1700347960, ["py"] = 0.2494235974, ["pm"] = 812, ["d"] = true, ["zx"] = 0.1760099976, ["zy"] = 0.2461672003, ["zm"] = 10, },
      [2] = { ["px"] = 0.1733212026, ["py"] = 0.2514208053, ["pm"] = 85, ["fp"] = true, },
    },
  },
  [7206] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Ecology of the Ornaug",
    ["e"] = {
      [1] = { ["px"] = 0.0540044017, ["py"] = 0.5872220022, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7207] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Gwenengith's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.0697956029, ["py"] = 0.6027548052, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7208] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres Knightly Orders Vol 1",
    ["e"] = {
      [1] = { ["px"] = 0.0503752020, ["py"] = 0.5986948024, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7209] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres Knightly Orders Vol 2",
    ["e"] = {
      [1] = { ["px"] = 0.0519288017, ["py"] = 0.6005180019, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7210] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Note to Nilsmon Booklover",
    ["e"] = {
      [1] = {
        ["px"] = 0.0518639997, ["py"] = 0.5992931875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7211] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Sea Elf Threat",
    ["e"] = {
      [1] = { ["px"] = 0.0578304019, ["py"] = 0.5808016025, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7212] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Glittering Sapphire Tourney",
    ["e"] = {
      [1] = { ["px"] = 0.0599324026, ["py"] = 0.5862504021, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7213] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Page from Mender's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.0587308022, ["py"] = 0.5983564029, ["pm"] = 2114, },
    },
  },
  [7214] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 5",
    ["e"] = {
      [1] = { ["px"] = 0.0533272009, ["py"] = 0.5924776086, ["pm"] = 2213, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7215] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 6",
    ["e"] = {
      [1] = { ["px"] = 0.0572524014, ["py"] = 0.6015260014, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7216] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Systres History: Volume 7",
    ["e"] = {
      [1] = { ["px"] = 0.0740604008, ["py"] = 0.5811956014, ["pm"] = 2114, },
    },
  },
  [7217] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "By Command of the Ascendant Order",
    ["e"] = {
    },
  },
  [7219] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Blackfeather Knave Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7250] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Help Wanted: Philien's Tours",
    ["e"] = {
    },
  },
  [7251] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Murder of Crows Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7252] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "House Embassy Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7253] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Hlaalu Councilor Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7254] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Summerset Raid Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7255] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Psijic Relicmaster Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7256] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Ceporah's Insight Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7257] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Blood Sacrifice Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7258] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Hagraven Matron Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7259] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Serpentguard Rider Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7260] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Knights of Saint Pelin Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7261] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Knight Commander Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7263] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Tales of Tribute: Series One",
    ["e"] = {
      [1] = { ["px"] = 0.0702816026, ["py"] = 0.6048292055, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7264] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Captain Tsuzo's Log",
    ["q"] = 6754,
    ["e"] = {
      [1] = {
        ["px"] = 0.0663555973, ["py"] = 0.5807015899, ["pm"] = 2131, ["d"] = true,
        ["zx"] = 0.0669036022, ["zy"] = 0.5865292019, ["zm"] = 2114,
      },
    },
  },
  [7266] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Captain Kaleen's Log",
    ["e"] = {
      [1] = { ["px"] = 0.0714024028, ["py"] = 0.6032328053, ["pm"] = 2163, ["zm"] = 2114, },
    },
  },
  [7267] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Captain Za'ji's Log",
    ["e"] = {
      [1] = { ["px"] = 0.0882464027, ["py"] = 0.5786228014, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7268] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "A Harrowing Sea Voyage",
    ["e"] = {
      [1] = { ["px"] = 0.0756716021, ["py"] = 0.5711016021, ["pm"] = 2114, },
    },
    ["c"] = true,
  },
  [7269] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Colossus of Gonfalon Bay",
    ["e"] = {
      [1] = { ["px"] = 0.0696612026, ["py"] = 0.6053352051, ["pm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7270] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Secrets of Amenos",
    ["e"] = {
      [1] = { ["px"] = 0.0766088033, ["py"] = 0.5855524124, ["pm"] = 2214, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7271] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Archdruid Michiel's Orders",
    ["q"] = 6843,
    ["e"] = {
      [1] = { ["px"] = 0.0670119999, ["py"] = 0.3616176081, ["pm"] = 1, ["qp"] = true, },
    },
  },
  [7274] = {
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Tribute Beginner's Guide",
    ["e"] = {
      [1] = { ["zx"] = 0.0703660026, ["zy"] = 0.6049512052, ["zm"] = 2163, ["zm"] = 2114, },
    },
    ["c"] = true,
  },
  [7280] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Hadolid Researcher's Journal",
    ["e"] = {
      [1] = {
        ["px"] = 0.0599800010, ["py"] = 0.6063484070, ["pm"] = 2130, ["d"] = true,
        ["zx"] = 0.0597760025, ["zy"] = 0.6067328012, ["zm"] = 2114,
      },
    },
  },
  [7281] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Visitor's Guide to Y'ffre's Cauldron",
    ["e"] = {
      [1] = { ["px"] = 0.0635180025, ["py"] = 0.6005328009, ["pm"] = 2114, },
    },
  },
  [7282] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "Letter from Druid Laurel",
    ["e"] = {
      [1] = { ["px"] = 0.0588544026, ["py"] = 0.3539028008, ["pm"] = 1, },
    },
  },
  [7283] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Congratulations On Another Success!",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0713852029, ["py"] = 0.6034324053, ["pm"] = 2163, ["zm"] = 2114, },
    },
  },
  [7284] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Dreadsail Orders",
    ["q"] = 6849,
    ["e"] = {
      [1] = { ["px"] = 0.0581116005, ["py"] = 0.5672824020, ["pm"] = 2212, },
    },
  },
  [7285] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Shipping Label",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0619628014, ["py"] = 0.5847404144, ["pm"] = 2236, ["d"] = true, ["zx"] = 0.0632516015, ["zy"] = 0.5845536026, ["zm"] = 2114, },
    },
  },
  [7286] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Welcome, Initiates!",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0616848013, ["py"] = 0.5849788144, ["pm"] = 2236, ["d"] = true, ["zx"] = 0.0632516015, ["zy"] = 0.5845536026, ["zm"] = 2114, },
    },
  },
  [7287] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Orders from the Lord",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0619548013, ["py"] = 0.5852788145, ["pm"] = 2236, ["d"] = true, ["zx"] = 0.0632516015, ["zy"] = 0.5845536026, ["zm"] = 2114, },
    },
  },
  [7288] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Lord Bacaro's Journal",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0619043994, ["py"] = 0.5986511935, ["pm"] = 2268, ["d"] = true, ["zx"] = 0.0621792019, ["zy"] = 0.5980144024, ["zm"] = 2114, },
    },
  },
  [7289] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Ancient Druid Bloodlines",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0619119994, ["py"] = 0.5986619935, ["pm"] = 2268, ["d"] = true, ["zx"] = 0.0621792019, ["zy"] = 0.5980144024, ["zm"] = 2114, },
    },
  },
  [7290] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Yves Grandvache Ledger",
    ["q"] = 6845,
    ["e"] = {
      [1] = { ["px"] = 0.0494999998, ["py"] = 0.5712436109, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7291] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Letter from Gad",
    ["q"] = 6845,
    ["e"] = {
      [1] = { ["px"] = 0.0494931995, ["py"] = 0.5712112111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7292] = {
    ["c"] = false,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter From Ember",
    ["q"] = 6786,
    ["e"] = {
    },
  },
  [7293] = {
    ["c"] = false,
    ["cn"] = "Hearts and Flowers",
    ["n"] = "Letter From Isobel",
    ["q"] = 6790,
    ["e"] = {
    },
  },
  [7294] = {
    ["c"] = true,
    ["cn"] = "Systres Tomes and Scrolls",
    ["n"] = "The Secret Origins of Tribute",
    ["e"] = {
      [1] = { ["px"] = 0.0728160034, ["py"] = 0.5904348013, ["pm"] = 2114, },
    },
  },
  [7295] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Grand Larceny Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7296] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Ring's Guile Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7297] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Grand Oratory Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7298] = {
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Ansei's Victory Clue",
    ["e"] = {
    },
    ["c"] = false,
  },
  [7300] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Senna's Last Account",
    ["q"] = 6858,
    ["e"] = {
      [1] = { ["px"] = 0.0490812011, ["py"] = 0.5605904008, ["pm"] = 2212, },
    },
  },
  [7301] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Note to Neri",
    ["q"] = 6857,
    ["e"] = {
      [1] = { ["px"] = 0.0597144018, ["py"] = 0.5574904010, ["pm"] = 2212, },
    },
  },
  [7302] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Ritual of Life's Commencement",
    ["q"] = 6857,
    ["e"] = {
      [1] = { ["px"] = 0.0590896012, ["py"] = 0.5565792013, ["pm"] = 2212, },
    },
  },
  [7303] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Deal with the Messenger",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0698068011, ["py"] = 0.5886680012, ["pm"] = 2114, },
    },
  },
  [7304] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Minahel's Note",
    ["q"] = 6857,
    ["e"] = {
      [1] = { ["px"] = 0.0591472007, ["py"] = 0.5570900010, ["pm"] = 2212, },
    },
  },
  [7305] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Messenger's Report",
    ["q"] = 6847,
    ["e"] = {
      [1] = { ["px"] = 0.0704956026, ["py"] = 0.5882668018, ["pm"] = 2114, },
    },
  },
  [7306] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Orders from Sealord Nalos",
    ["e"] = {
      [1] = {
        ["px"] = 0.0445988017, ["py"] = 0.5596256082, ["pm"] = 2241, ["d"] = true,
        ["zx"] = 0.0446328008, ["zy"] = 0.5601956011, ["zm"] = 2212,
      },
    },
  },
  [7308] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Kiko's Riddles",
    ["q"] = 6860,
    --Post-quest location if not read during quest
    ["e"] = {
      [1] = { ["px"] = 0.0497435996, ["py"] = 0.5706932110, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7309] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Kiko's Final Riddle",
    ["q"] = 6860,
    ["e"] = {
      [1] = { ["px"] = 0.0497411995, ["py"] = 0.5706952111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7310] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "For Your Next Celebration",
    ["q"] = 6847,
    ["e"] = {
      [1] = {
        ["px"] = 0.0519439997, ["py"] = 0.5993407875, ["pm"] = 2219, ["d"] = true,
        ["zx"] = 0.0519460016, ["zy"] = 0.5990540036, ["zm"] = 2114,
      },
    },
  },
  [7311] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Note from Umindior",
    ["q"] = 6857,
    ["e"] = {
      [1] = { ["px"] = 0.0573284011, ["py"] = 0.5553264009, ["pm"] = 2212, },
    },
  },
  [7314] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Calling All Sea Elves!",
    ["q"] = 6887,
    ["e"] = {
      [1] = { ["px"] = 0.0596308016, ["py"] = 0.5565696009, ["pm"] = 2212, },
      [2] = { ["px"] = 0.0590552015, ["py"] = 0.5566132010, ["pm"] = 2212, },
      [3] = { ["px"] = 0.0597644005, ["py"] = 0.5550648011, ["pm"] = 2212, },
      [4] = { ["px"] = 0.0585296019, ["py"] = 0.5569444012, ["pm"] = 2212, },
    },
  },
  [7315] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Fables: The Proud Faun",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7318] = {
    ["c"] = true,
    ["cn"] = "Criminal Correspondence",
    ["n"] = "Wrongly Incarcerated!",
    ["e"] = {
      [1] = { ["px"] = 0.0729452014, ["py"] = 0.5902120030, ["pm"] = 2114, },
    },
  },
  [7349] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Journal of Kovan Giryon",
    ["e"] = {
      [1] = { ["px"] = 0.7834560094, ["py"] = 0.4616164114, ["pm"] = 2255, ["d"] = true, ["zx"] = 0.7770799938, ["zy"] = 0.4578639996, ["zm"] = 7, },
    },
  },
  [7350] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Journal of Nerile Belvayn",
    ["e"] = {
      [1] = { ["px"] = 0.7829868265, ["py"] = 0.4607308128, ["pm"] = 2258, ["d"] = true, ["zx"] = 0.7770799938, ["zy"] = 0.4578639996, ["zm"] = 7, },
    },
  },
  [7351] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Journal of Adosi Fevur",
    ["e"] = {
      [1] = { ["px"] = 0.7912075943, ["py"] = 0.4628452146, ["pm"] = 2262, ["d"] = true, ["zx"] = 0.7770799938, ["zy"] = 0.4578639996, ["zm"] = 7, },
    },
  },
  [7356] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Annotated Dream of Kasorayn",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7357] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Warning! Do Not Touch Cask!",
    ["e"] = {
      [1] = { ["px"] = 0.0497471998, ["py"] = 0.5706808110, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7358] = {
    ["c"] = false,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "Mel Adrys' Journal",
    ["e"] = {
    },
  },
  [7359] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Wines of the Systres",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7360] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Flora and Fauna of Galen",
    ["e"] = {
      [1] = { ["px"] = 0.0495767994, ["py"] = 0.5722292111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7361] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Dream of Kasorayn",
    ["e"] = {
      [1] = { ["px"] = 0.0512948013, ["py"] = 0.5619304014, ["pm"] = 2212, },
    },
  },
  [7362] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Frog Stealing Plans",
    ["q"] = 6904,
    ["e"] = {
      [1] = { ["px"] = 0.0557676013, ["py"] = 0.5649572008, ["pm"] = 2212, },
      [2] = { ["px"] = 0.0476288009, ["py"] = 0.5681704006, ["pm"] = 2212, },
    },
  },
  [7363] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Druid Monoliths",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7364] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Y'ffelon, the Forbidden Island",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7365] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Final Dream of Kasorayn",
    ["q"] = 6852,
    ["e"] = {
      [1] = { ["px"] = 0.0612380001, ["py"] = 0.5623435976, ["pm"] = 2251, ["zx"] = 0.0604484007, ["zy"] = 0.5615872013, ["zm"] = 2212, ["d"] = true, },
    },
  },
  [7416] = {
    ["c"] = false,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Vastyr Fisherfolk Song",
    ["e"] = {
    }
  },
  [7417] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Larydeilmo is Sane",
    ["e"] = {
      [1] = { ["px"] = 0.2027576100, ["py"] = 0.0412456070, ["pm"] = 2275, },
    },
  },
  [7418] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Oath of the Keepers",
    ["e"] = {
      [1] = { ["px"] = 0.9393200151, ["py"] = 0.3738271957, ["pm"] = 2385, ["d"] = true, ["zx"] = 0.9393200115, ["zy"] = 0.3738272052, ["zm"] = 2274, },
      [2] = { ["px"] = 0.9393200153, ["py"] = 0.3738272057, ["pm"] = 2343, ["fp"] = true, },
    },
  },
  [7419] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Ode to Vaermina",
    ["e"] = {
      [1] = { ["px"] = 0.8661852119, ["py"] = 0.4698572014, ["pm"] = 2274, },
    },
  },
  [7420] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Deal with a Daedric Prince",
    ["e"] = {
      [1] = { ["px"] = 0.8861720097, ["py"] = 0.4305332063, ["pm"] = 2274, },
    },
  },
  [7421] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Legend of Fathoms Drift",
    ["e"] = {
      [1] = { ["px"] = 0.1293304025, ["py"] = -0.0596463938, ["pm"] = 2355, ["d"] = true, ["zx"] = 0.1296596063, ["zy"] = -0.0567127977, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1296596063, ["py"] = -0.0567127977, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7422] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Ranks and Titles of House Telvanni",
    ["e"] = {
      [1] = { ["px"] = 0.8230964090, ["py"] = 0.4199739878, ["pm"] = 2386, ["zm"] = 2274, },
    },
  },
  [7423] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Doom of the Hushed",
    ["e"] = {
      [1] = { ["px"] = 0.1608235997, ["py"] = 0.0007188021, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1608236080, ["py"] = 0.0007187995, ["pm"] = 2275, ["fp"] = true, },
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7424] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Report on the Dusksabers",
    ["e"] = {
      [1] = { ["px"] = 0.8485160087, ["py"] = 0.4127248039, ["pm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7425] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Peryite's Salvation",
    ["e"] = {
      [1] = { ["px"] = 0.9584180149, ["py"] = 0.3716560054, ["pm"] = 2343, ["zm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7426] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "On Joining the Keepers of the Dead",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7428] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Currency of Secrets",
    ["e"] = {
      [1] = { ["px"] = 0.2214655958, ["py"] = 0.0122960076, ["pm"] = 2334, ["d"] = true, ["zx"] = 0.2118800029, ["zy"] = 0.0192912033, ["zm"] = 2275, },
      [2] = { ["px"] = 0.2118800029, ["py"] = 0.0192912033, ["pm"] = 2275, ["fp"] = true, },
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7429] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Uluscant's Manifesto",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1731127947, ["py"] = 0.0358927986, ["pm"] = 2309, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.1595139937, ["py"] = 0.0336096025, ["pm"] = 2317, ["d"] = true, ["qc"] = true, },
      [4] = { ["px"] = 0.1598592070, ["py"] = 0.0303152009, ["pm"] = 2275, ["fp"] = true, ["qc"] = true, },
    },
  },
  [7430] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On Tracts Perilous",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7431] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "How Rajhin Stole the Book that Knows",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1730235960, ["py"] = 0.0352615979, ["pm"] = 2311, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  -- TODO check this
  [7432] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Herma-Mora: The Woodland Man?",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1734363973, ["py"] = 0.0354483998, ["pm"] = 2310, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.1750796052, ["py"] = 0.0347760042, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7433] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Life in the Camonna Tong",
    ["e"] = {
      [1] = { ["px"] = 0.8279483761, ["py"] = 0.4592540153, ["pm"] = 2292, ["d"] = true, ["zx"] = 0.8289800098, ["zy"] = 0.4558020008, ["zm"] = 2274, },
    },
  },
  [7434] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Kynmarcher Strix's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.1632744029, ["py"] = -0.0831064057, ["pm"] = 2354, ["d"] = true, },
    },
  },
  [7435] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "A Summoner's Guide to Nymics",
    ["e"] = {
      [1] = { ["px"] = 0.1643508029, ["py"] = -0.0810468057, ["pm"] = 2354, ["d"] = true, },
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7436] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Dangers of Truth",
    ["e"] = {
      [1] = { ["px"] = 0.1571519996, ["py"] = 0.0030268022, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1571520033, ["py"] = 0.0030268074, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7437] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On the Nature of Nymics",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7438] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Master of the Tides of Fate",
    ["e"] = {
      [1] = { ["px"] = 0.9442271803, ["py"] = 0.3885443965, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7439] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Spires of the 34th Sermon",
    ["e"] = {
      [1] = { ["px"] = 0.9407631813, ["py"] = 0.3838179950, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7440] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Our Puny Allies",
    ["e"] = {
      [1] = { ["px"] = 0.9503796151, ["py"] = 0.3700068059, ["pm"] = 2343, ["zm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7441] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "We Reject the Pact",
    ["e"] = {
      [1] = { ["px"] = 0.8355576096, ["py"] = 0.4162647883, ["pm"] = 2386, ["zm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7442] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Critter Dangers: Telvanni Peninsula",
    ["e"] = {
      [1] = { ["px"] = 0.9112944066, ["py"] = 0.4113324036, ["pm"] = 2274, },
    },
  },
  [7443] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Visitor's Guide: Telvanni Peninsula",
    ["e"] = {
      [1] = { ["px"] = 0.9407420136, ["py"] = 0.4101616015, ["pm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7444] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Feast Among the Dead, Chapter I",
    ["e"] = {
      [1] = { ["px"] = 0.9389759801, ["py"] = 0.3850419962, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7445] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Brief History of House Telvanni",
    ["e"] = {
      [1] = { ["px"] = 0.8949996049, ["py"] = 0.4542968115, ["pm"] = 2401, ["d"] = true, ["zx"] = 0.8949996052, ["zy"] = 0.4542968084, ["zm"] = 2274, },
    },
  },
  [7446] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Brave Little Scrib and the River Troll",
    ["e"] = {
      [1] = { ["px"] = 0.9328583810, ["py"] = 0.3933239959, ["pm"] = 2343, ["zm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7447] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "History of Necrom: The City of the Dead",
    ["e"] = {
      [1] = { ["px"] = 0.9228820130, ["py"] = 0.4020644052, ["pm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7448] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Denizens of Apocrypha",
    ["e"] = {
      [1] = { ["px"] = 0.1763735987, ["py"] = 0.0489875976, ["pm"] = 2346, ["d"] = true, ["zx"] = 0.1765940042, ["zy"] = 0.0481807999, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1765940042, ["py"] = 0.0481807999, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7449] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Beverages for the Bereaved",
    ["e"] = {
      [1] = { ["px"] = 0.9465512162, ["py"] = 0.3900300064, ["pm"] = 2343, ["zm"] = 2274, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7450] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Planar Exploration Vol. 14: Darkreave Curators",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2275] = 1,
    },
  },
  [7451] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Ciphers of the Eye",
    ["e"] = {
      [1] = { ["px"] = 0.1597811997, ["py"] = 0.0001896021, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1597812045, ["py"] = 0.0001896028, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7452] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Daedric Worship and the Dark Elves",
    ["e"] = {
      [1] = { ["px"] = 0.9346643811, ["py"] = 0.3887079951, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7453] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Torvesard's Journal",
    ["q"] = 6977,
    ["e"] = {
      [1] = { ["px"] = 0.1608312068, ["py"] = -0.0154607970, ["pm"] = 2275, ["qc"] = true, },
    },
  },
  [7454] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A New Cult Arises",
    ["e"] = {
      [1] = { ["px"] = 0.9347635802, ["py"] = 0.3888835951, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7455] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Littlest Tomeshell",
    ["e"] = {
      [1] = { ["px"] = 0.0887256033, ["py"] = -0.0157803961, ["pm"] = 2275, },
    },
  },
  [7456] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On Cipher's Midden",
    ["e"] = {
      [1] = { ["px"] = 0.1132124044, ["py"] = -0.0153127966, ["pm"] = 2275, },
    },
  },
  -- TODO check this
  [7457] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "What About Glyphics?",
    ["e"] = {
      [1] = { ["px"] = 0.1828492077, ["py"] = 0.0444188017, ["pm"] = 2275, },
    },
  },
  [7458] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Working in the Infinite Panopticon",
    ["e"] = {
      [1] = { ["px"] = 0.1706908094, ["py"] = -0.0131067952, ["pm"] = 2275, },
    },
  },
  [7459] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "What's an Arcanist? Part 2",
    ["e"] = {
      [1] = { ["px"] = 0.1636095995, ["py"] = 0.0024352021, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1636095995, ["py"] = 0.0024352021, ["pm"] = 2275, },
    },
    ["r"] = true,
    ["m"] = {
      [2274] = 1,
    },
  },
  [7460] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "What's an Arcanist? Part 1",
    ["e"] = {
      [1] = { ["px"] = 0.1575327995, ["py"] = 0.0036156022, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1575327995, ["py"] = 0.0036156022, ["pm"] = 2275, },
    },
  },
  [7461] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Feast Among the Dead, Chapter II",
    ["e"] = {
      [1] = { ["px"] = 0.9439375806, ["py"] = 0.3891207951, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7462] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Feast Among the Dead, Chapter III",
    ["e"] = {
      [1] = { ["px"] = 0.9401100038, ["py"] = 0.3849048077, ["pm"] = 2342, ["d"] = true, ["zm"] = 2274, },
      [2] = { ["px"] = 0.9401100148, ["py"] = 0.3849048059, ["pm"] = 2343, ["fp"] = true, },
    },
  },
  [7463] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Feast Among the Dead, Chapter IV",
    ["e"] = {
      [1] = { ["px"] = 0.9467279801, ["py"] = 0.3916679954, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7464] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Our Dunmer Heritage",
    ["e"] = {
      [1] = { ["px"] = 0.8768564109, ["py"] = 0.4327468016, ["pm"] = 2274, },
    },
  },
  [7465] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Tidefall Cantos I",
    ["e"] = {
      [1] = { ["px"] = 0.1296464024, ["py"] = -0.0595667938, ["pm"] = 2355, ["d"] = true, ["zx"] = 0.1296596063, ["zy"] = -0.0567127977, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1296596063, ["py"] = -0.0567127977, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7466] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Fanlyrion's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.1613592007, ["py"] = 0.0179840058, ["pm"] = 2275, },
    },
  },
  [7467] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Fauns' Thicket Research Notes",
    ["e"] = {
      [1] = {
        ["px"] = 0.0450864016, ["py"] = 0.5643967910, ["pm"] = 2265, ["d"] = true,
        ["zx"] = 0.0482888008, ["zy"] = 0.5642948013, ["zm"] = 2212,
      },
    },
  },
  [7470] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "A Travel Guide to Tamriel Castles",
    ["e"] = {
      [1] = { ["px"] = 0.0482436009, ["py"] = 0.5700763859, ["pm"] = 2279, ["d"] = true, },
      [2] = { ["px"] = 0.0482979994, ["py"] = 0.5701256112, ["pm"] = 2227, ["zm"] = 2212, ["fp"] = true, },
    },
  },
  [7472] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Octants of the Scrivener",
    ["e"] = {
      [1] = { ["px"] = 0.6140451918, ["py"] = 0.4043703997, ["pm"] = 2286, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7473] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Mission Report: Successful",
    ["e"] = {
      [1] = { ["px"] = 0.6161935995, ["py"] = 0.4037172003, ["pm"] = 2289, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7474] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Mazandi's Rift Tracking",
    ["e"] = {
      [1] = { ["px"] = 0.6162123843, ["py"] = 0.4054256026, ["pm"] = 2287, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7475] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Letter to the Magnastylus",
    ["e"] = {
      [1] = { ["px"] = 0.6162287995, ["py"] = 0.4037220004, ["pm"] = 2289, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7476] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Excerpts from Keshargo's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.6140556012, ["py"] = 0.4041763994, ["pm"] = 2363, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7477] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Letter of Resignation",
    ["e"] = {
      [1] = { ["px"] = 0.6143671918, ["py"] = 0.4043879997, ["pm"] = 2286, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7478] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Scribes of Mephala",
    ["e"] = {
      [1] = { ["px"] = 0.6163655843, ["py"] = 0.4053000026, ["pm"] = 2287, ["d"] = true, ["zx"] = 0.6163903933, ["zy"] = 0.3979327919, ["zm"] = 125, },
    },
  },
  [7509] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Mildanor's Ripped Note",
    ["q"] = 6967,
    ["e"] = {
      [1] = { ["px"] = 0.4734155837, ["py"] = 0.5894560061, ["pm"] = 256, ["qp"] = true, },
    },
  },
  [7511] = {
    ["c"] = false,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Legion's Arrival Clue",
    ["e"] = {
    },
  },
  [7512] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Argument Between Priest and Druid Number 12",
    ["e"] = {
      [1] = { ["px"] = 0.0479479996, ["py"] = 0.5710064111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7513] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Dreadsails: Threat to the Isles",
    ["e"] = {
      [1] = { ["px"] = 0.0503007996, ["py"] = 0.5725312113, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7514] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Note to Rilasi",
    ["q"] = 6998,
    ["e"] = {
      [1] = { ["px"] = 0.8673792091, ["py"] = 0.4288468007, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7515] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Eye of Baan Dar",
    ["q"] = 6998,
    ["e"] = {
      [1] = { ["px"] = 0.8803096135, ["py"] = 0.4342672051, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7517] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Ransom Note from Shadeya",
    ["q"] = 6998,
    ["e"] = {
      [1] = { ["px"] = 0.8790816037, ["py"] = 0.4345715978, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7519] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Glimmertarn: A Stonelore Community",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7520] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Embracing the Natural Order",
    ["e"] = {
      [1] = { ["px"] = 0.0478695996, ["py"] = 0.5700544110, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7521] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Mirah's Journal: The Salvage",
    ["e"] = {
      [1] = { ["px"] = 0.0625700007, ["py"] = 0.5601908011, ["pm"] = 2212, },
    },
  },
  [7522] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Molith the Mudcrab",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7523] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Funerals: A Piece of Y'ffre",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7524] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Investigator Vale and the Darkmasts",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7525] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Tempest and the Sunflower",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7526] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Arnoit and Lisette: The True Story",
    ["e"] = {
      [1] = { ["px"] = 0.0483504009, ["py"] = 0.5698271983, ["pm"] = 2281, ["d"] = true, },
      [2] = { ["px"] = 0.0483500008, ["py"] = 0.5698280005, ["pm"] = 2227, ["zm"] = 2212, ["fp"] = true, },
    },
  },
  [7527] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Scapegoats",
    ["e"] = {
      [1] = { ["px"] = 0.0587748009, ["py"] = 0.5676064013, ["pm"] = 2212, },
    },
  },
  [7528] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Fables: Systres Beavers",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7529] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Food of Vastyr",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7530] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Journeys In Galen: A Scholar's Travels",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7531] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Beast of Galen",
    ["e"] = {
      [1] = { ["px"] = 0.0538528006, ["py"] = 0.5666320015, ["pm"] = 2212, },
    },
  },
  [7532] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Bolga's Guide to Galen Beasts",
    ["e"] = {
      [1] = { ["px"] = 0.0498307996, ["py"] = 0.5721628110, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7533] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Systres History Addendum: The Druids of Galen",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7534] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Systres History: Vastyr",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7535] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Systres History: Addendum",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7536] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Exodus of the Druids",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7537] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Visitor's Guide to Galen",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7538] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Emeric's Judgment",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7539] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "On Nature Spirits",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7540] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Legacy of the Bretons",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = { [2212] = 1, },
  },
  [7541] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "A Helpful, Steadfast Hand",
    ["e"] = {
    },
    ["r"] = true,
    ["m"] = {
      [2212] = 1,
    },
  },
  [7543] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "First Mate Dalmir's Log",
    ["q"] = 6971,
    ["e"] = {
      [1] = { ["px"] = 0.9571595798, ["py"] = 0.3746799957, ["pm"] = 2343, ["qp"] = true, },
      [2] = { ["px"] = 0.9571064119, ["py"] = 0.3746932017, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7544] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "A Trespasser in Ivyhame",
    ["e"] = {
      [1] = { ["px"] = 0.0491040009, ["py"] = 0.5560692011, ["pm"] = 2212, },
    },
  },
  [7545] = {
    ["c"] = false,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Wispheart Totem Clue",
    ["e"] = {
    },
  },
  [7546] = {
    ["c"] = false,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Druid King Vestments Clue",
    ["e"] = {
    },
  },
  [7547] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Fearless as the Sun",
    ["e"] = {
      [1] = { ["px"] = 0.0470592007, ["py"] = 0.5582448007, ["pm"] = 2212, },
    },
  },
  [7548] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Siege of Vastyr",
    ["e"] = {
      [1] = { ["px"] = 0.0482128009, ["py"] = 0.5700812095, ["pm"] = 2280, ["d"] = true, },
      [2] = { ["px"] = 0.0482979994, ["py"] = 0.5701256112, ["pm"] = 2227, ["zm"] = 2212, ["fp"] = true, },
    },
  },
  [7549] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Curse of Blackscale Island",
    ["q"] = 6981,
    ["e"] = {
      [1] = { ["px"] = 0.1585823937, ["py"] = 0.0322472024, ["pm"] = 2317, ["d"] = true, ["zx"] = 0.1598484006, ["zy"] = 0.0302976072, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1598484006, ["py"] = 0.0302976072, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7551] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Belaigh and the Molmor",
    ["e"] = {
      [1] = { ["px"] = 0.0475171997, ["py"] = 0.5701788111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7553] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "A Lissome Sprite",
    ["e"] = {
      [1] = {
        ["px"] = 0.0480436016, ["py"] = 0.5641543908, ["pm"] = 2265, ["d"] = true,
        ["zx"] = 0.0482888008, ["zy"] = 0.5642948013, ["zm"] = 2212,
      },
    },
  },
  [7554] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Coded Missive",
    ["q"] = 6997,
    ["e"] = {
      [1] = { ["px"] = 0.1925343930, ["py"] = 0.0011100034, ["pm"] = 2356, ["d"] = true, ["zx"] = 0.1900744063, ["zy"] = -0.0005199991, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1900744063, ["py"] = -0.0005199991, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7556] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Fargrave: A City of Myth",
    ["e"] = {
      [1] = { ["px"] = 0.1591923937, ["py"] = 0.0324312025, ["pm"] = 2317, ["d"] = true, ["zx"] = 0.1598484006, ["zy"] = 0.0302976072, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1598484006, ["py"] = 0.0302976072, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7557] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Poet-Champion of Vastyr",
    ["e"] = {
      [1] = { ["px"] = 0.0493403994, ["py"] = 0.5713852111, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7558] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "White-Gold: The Ayleid Perspective",
    ["e"] = {
      [1] = { ["px"] = 0.1591595938, ["py"] = 0.0325156025, ["pm"] = 2317, ["d"] = true, ["zx"] = 0.1598484006, ["zy"] = 0.0302976072, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1598484006, ["py"] = 0.0302976072, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7559] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Tamrielic Twins of Myth",
    ["q"] = 6981,
    ["e"] = {
      [1] = { ["px"] = 0.1593063937, ["py"] = 0.0326764023, ["pm"] = 2317, ["d"] = true, ["zx"] = 0.1598484006, ["zy"] = 0.0302976072, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1598484006, ["py"] = 0.0302976072, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7560] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "List of Books",
    ["q"] = 6997,
    ["e"] = {
      [1] = { ["px"] = 0.1937031970, ["py"] = -0.0000728027, ["pm"] = 2405, ["d"] = true, ["zx"] = 0.1900744063, ["zy"] = -0.0005199991, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1900744063, ["py"] = -0.0005199991, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7561] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Song of Vastyr",
    ["e"] = {
      [1] = { ["px"] = 0.0497443997, ["py"] = 0.5706488110, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7563] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter to Mouth Vabdru",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8228776091, ["py"] = 0.4180279879, ["pm"] = 2386, ["zm"] = 2274, ["qp"] = true, },
    },
  },
  [7564] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Mouth Vabdru's Journal",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8234172089, ["py"] = 0.4182675884, ["pm"] = 2386, ["zm"] = 2274, ["qp"] = true, },
    },
  },
  [7565] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dusk Captain Zenfis's Orders",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8929896058, ["py"] = 0.3894804022, ["pm"] = 2284, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8928332146, ["py"] = 0.3890708051, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7566] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Blightcrown's Notes",
    ["q"] = 6975,
    ["e"] = {
      [1] = { ["px"] = 0.0808071968, ["py"] = -0.0304872013, ["pm"] = 2321, ["d"] = true, ["zx"] = 0.0806836031, ["zy"] = -0.0303551953, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.0806836031, ["py"] = -0.0303551953, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7567] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter to Deredrien",
    ["q"] = 7017,
    ["e"] = {
      [1] = { ["px"] = 0.9407499813, ["py"] = 0.3835687950, ["pm"] = 2343, ["qp"] = true, },
      [2] = { ["px"] = 0.9407499813, ["py"] = 0.3835687950, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7568] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "First Servant's Letter, Page 1",
    ["e"] = {
      [1] = { ["px"] = 0.2249787957, ["py"] = 0.0153956075, ["pm"] = 2334, ["d"] = true, ["zx"] = 0.2118800029, ["zy"] = 0.0192912033, ["zm"] = 2275, },
      [2] = { ["px"] = 0.2118800029, ["py"] = 0.0192912033, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7569] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Note to Nathyn",
    ["q"] = 6999,
    ["e"] = {
      [1] = { ["px"] = 0.8963116161, ["py"] = 0.4478907963, ["pm"] = 2293, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8963160162, ["py"] = 0.4478939964, ["pm"] = 2293, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.8954456049, ["py"] = 0.4538136114, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7570] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Organization Notes",
    ["q"] = 7017,
    ["e"] = {
      [1] = { ["px"] = 0.8805228089, ["py"] = 0.4039224053, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7571] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Modern Day Bretons: Man or Mer?",
    ["e"] = {
      [1] = { ["px"] = 0.0558304009, ["py"] = 0.5625072015, ["pm"] = 2212, },
    },
  },
  [7572] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Druid Fables: Butterfly and Faun Lord",
    ["e"] = {
      [1] = { ["px"] = 0.0492940008, ["py"] = 0.5573040011, ["pm"] = 2212, },
    },
  },
  [7573] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Dame Helenie's Quest",
    ["e"] = {
      [1] = { ["px"] = 0.0490615997, ["py"] = 0.5707380111, ["pm"] = 2227, ["pm"] = 2212, },
    },
  },
  [7574] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "On the Purchase of the Alavelis Mine",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.8671936081, ["py"] = 0.4788076093, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7575] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "On the Work at Alavelis",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.8664072115, ["py"] = 0.4798339984, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7576] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Who Are the Sea Elves?",
    ["e"] = {
      [1] = { ["px"] = 0.0581976008, ["py"] = 0.5666032017, ["pm"] = 2212, },
    },
  },
  [7577] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Sathile's Research Notes",
    ["q"] = 6999,
    ["e"] = {
      [1] = { ["px"] = 0.8960900162, ["py"] = 0.4476811964, ["pm"] = 2293, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8960876161, ["py"] = 0.4476511963, ["pm"] = 2293, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.8954456049, ["py"] = 0.4538136114, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7578] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Courier's Permit",
    ["q"] = 7018,
    ["e"] = {
      [1] = { ["px"] = 0.6371024269, ["py"] = 0.2604059998, ["pm"] = 160, ["qp"] = true, },
      [2] = { ["px"] = 0.6371024269, ["py"] = 0.2604059998, ["zm"] = 61, ["qp"] = true, },
    },
  },
  [7579] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Note from Gadri to Federo",
    ["q"] = 7018,
    ["e"] = {
      [1] = { ["px"] = 0.6214216265, ["py"] = 0.2787667965, ["pm"] = 61, ["qp"] = true, },
    },
  },
  [7580] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Master's Warning",
    ["e"] = {
      [1] = { ["px"] = 0.8262884091, ["py"] = 0.4134243877, ["pm"] = 2386, ["zm"] = 2274, },
    },
  },
  [7582] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Sondivel's Journal",
    ["q"] = 7018,
    ["e"] = {
      [1] = { ["px"] = 0.7010488238, ["py"] = 0.2738556066, ["pm"] = 1060, ["zm"] = 2274, },
    },
  },
  [7584] = {
    ["c"] = true,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Torn Note From Brahgas",
    ["e"] = {
      [1] = { ["px"] = 0.0496843997, ["py"] = 0.5706768111, ["pm"] = 2227, ["zm"] = 2212, },
      [2] = { ["px"] = 0.0703840026, ["py"] = 0.6049100054, ["pm"] = 2163, ["zm"] = 2114, },
      [3] = { ["px"] = 0.9385240153, ["py"] = 0.3851824057, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7585] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Hidden Kindred Instructions",
    ["q"] = 6971,
    ["e"] = {
      [1] = { ["px"] = 0.9571595798, ["py"] = 0.3746799957, ["pm"] = 2343, ["qp"] = true, },
      [2] = { ["px"] = 0.9571064119, ["py"] = 0.3746932017, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7586] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "To See My Systres",
    ["e"] = {
      [1] = { ["px"] = 0.0599904015, ["py"] = 0.5562128009, ["pm"] = 2212, },
    },
  },
  [7587] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Dame of Castle Navire",
    ["e"] = {
      [1] = { ["px"] = 0.0499716006, ["py"] = 0.5548024009, ["pm"] = 2212, },
    },
  },
  [7588] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Blightcrown's Orders",
    ["q"] = 6971,
    ["e"] = {
      [1] = { ["px"] = 0.9389263735, ["py"] = 0.3749232004, ["pm"] = 2347, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.9386639812, ["py"] = 0.3769459957, ["pm"] = 2343, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.9510455811, ["py"] = 0.3718255957, ["pm"] = 2343, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7589] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Death to All Mages",
    ["e"] = {
      [1] = { ["px"] = 0.8570451919, ["py"] = 0.4880987990, ["pm"] = 2372, ["d"] = true, },
      [2] = { ["px"] = 0.8574188105, ["py"] = 0.4831791982, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7590] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "History of the Dreamstone",
    ["e"] = {
      [1] = { ["px"] = 0.8599843738, ["py"] = 0.4877555864, ["pm"] = 2330, ["d"] = true, },
      [2] = { ["px"] = 0.8574188105, ["py"] = 0.4831791982, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7591] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Wizard Vanton's Research Proposal",
    ["e"] = {
      [1] = { ["px"] = 0.8599927738, ["py"] = 0.4872551865, ["pm"] = 2330, ["d"] = true, },
      [2] = { ["px"] = 0.8574188105, ["py"] = 0.4831791982, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7592] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Archwizard Twelvane's Decree",
    ["e"] = {
      [1] = { ["px"] = 0.8592979760, ["py"] = 0.4898191921, ["pm"] = 2373, ["d"] = true, },
      [2] = { ["px"] = 0.8574188105, ["py"] = 0.4831791982, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7596] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "First Servant's Letter, Page 2",
    ["e"] = {
      [1] = { ["px"] = 0.2231303960, ["py"] = 0.0121620075, ["pm"] = 2334, ["d"] = true, ["zx"] = 0.2118800029, ["zy"] = 0.0192912033, ["zm"] = 2275, },
      [2] = { ["px"] = 0.2118800029, ["py"] = 0.0192912033, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  -- TODO check this
  [7597] = {
    ["c"] = true,
    ["cn"] = "Cipher Sabinius's Apology",
    ["n"] = "Apocryphal Pages",
    ["e"] = {
      [1] = { ["px"] = 0.2137451964, ["py"] = 0.0126264074, ["pm"] = 2334, ["d"] = true, },
      [2] = { ["px"] = 0.2119080021, ["py"] = 0.0192984012, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7598] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "The Storm and the Sunflower",
    ["e"] = {
      [1] = { ["px"] = 0.0569228006, ["py"] = 0.5704416012, ["pm"] = 2212, },
    },
  },
  [7599] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Spirit of the Volcano",
    ["e"] = {
      [1] = { ["px"] = 0.0491772008, ["py"] = 0.5625984008, ["pm"] = 2212, },
    },
  },
  [7600] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Rescue Me",
    ["e"] = {
      [1] = { ["px"] = 0.0467448009, ["py"] = 0.5665836010, ["pm"] = 2212, },
    },
  },
  [7601] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Vastyr Fisherfolk Song",
    ["e"] = {
      [1] = { ["px"] = 0.0494599997, ["py"] = 0.5720068112, ["pm"] = 2227, ["zm"] = 2212, },
    },
  },
  [7603] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Master Shelreni's Notes: Torvesard",
    ["q"] = 6976,
    ["e"] = {
      [1] = { ["px"] = 0.8350163843, ["py"] = 0.4038655896, ["pm"] = 2406, ["d"] = true, ["zx"] = 0.8373416068, ["zy"] = 0.4169944008, ["zm"] = 2274, ["qp"] = true, },
      [2] = { ["px"] = 0.8373416068, ["py"] = 0.4169944008, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, }, -- Pin on Telvanni Peninsula Zone-Map
      [3] = { ["px"] = 0.8373416094, ["py"] = 0.4169943875, ["pm"] = 2386, ["fp"] = true, ["qp"] = true, }, -- Entrance in City to Conclave
    },
  },
  [7604] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Master Shelreni's Notes: The Restoration",
    ["q"] = 6976,
    ["e"] = {
      [1] = { ["px"] = 0.8350151843, ["py"] = 0.4038855896, ["pm"] = 2406, ["d"] = true, ["zx"] = 0.8373416068, ["zy"] = 0.4169944008, ["zm"] = 2274, ["qp"] = true, },
      [2] = { ["px"] = 0.8373416068, ["py"] = 0.4169944008, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, }, -- Pin on Telvanni Peninsula Zone-Map
      [3] = { ["px"] = 0.8373416094, ["py"] = 0.4169943875, ["pm"] = 2386, ["fp"] = true, ["qp"] = true, }, -- Entrance in City to Conclave
    },
  },
  [7605] = {
    ["c"] = true,
    ["cn"] = "Archipelago Books and Almanacs",
    ["n"] = "Archdruid's Letter",
    ["e"] = {
      [1] = { ["px"] = 0.0601052001, ["py"] = 0.5635000088, ["pm"] = 2225, ["d"] = true, ["zx"] = 0.0579724016, ["zy"] = 0.5636720016, ["zm"] = 2212, },
    },
  },
  [7606] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Correspondence from Torvesard",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8934360059, ["py"] = 0.3890268021, ["pm"] = 2284, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8928332146, ["py"] = 0.3890708051, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7607] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Naanurrel's Logbook",
    ["q"] = 6982,
    ["e"] = {
      [1] = { ["px"] = 0.1297436024, ["py"] = -0.0594995938, ["pm"] = 2389, ["d"] = true, ["zx"] = 0.1296596063, ["zy"] = -0.0567127977, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1296596063, ["py"] = -0.0567127977, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7609] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Never-Woven",
    ["q"] = 7021,
    ["e"] = {
      [1] = { ["px"] = 0.1361084055, ["py"] = 0.0260107982, ["pm"] = 2404, ["d"] = true, ["zx"] = 0.1317344040, ["zy"] = -0.0072423963, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1317344040, ["py"] = -0.0072423963, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.1634983997, ["py"] = 0.0023208022, ["pm"] = 2384, ["zm"] = 2275, ["qc"] = true, ["zx"] = 0.1635248071, ["zy"] = 0.0023292052, ["zm"] = 2275, },
      [4] = { ["px"] = 0.1635248071, ["py"] = 0.0023292052, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7610] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Pact of the Remnants",
    ["q"] = 6992,
    ["e"] = {
      [1] = { ["px"] = 0.1555771974, ["py"] = -0.0292451923, ["pm"] = 2340, ["d"] = true, ["zx"] = 0.1537979973, ["zy"] = -0.0282487988, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1537979973, ["py"] = -0.0282487988, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7611] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Master Shelreni's Orders",
    ["e"] = {
      [1] = { ["px"] = 0.8499724078, ["py"] = 0.4125300029, ["pm"] = 2274, },
    },
  },
  [7612] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dusksaber Report",
    ["e"] = {
      [1] = { ["px"] = 0.8457696086, ["py"] = 0.4164852040, ["pm"] = 2274, },
    },
  },
  [7613] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Meln's To-Do List",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8422407814, ["py"] = 0.4189944138, ["pm"] = 2285, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8422307813, ["py"] = 0.4189992140, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7615] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Notes on Doors of Oblivion",
    ["q"] = 6994,
    ["e"] = {
      [1] = { ["px"] = 0.0932772034, ["py"] = -0.0165807971, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7616] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Call to the Cloisters",
    ["q"] = 6997,
    ["e"] = {
      [1] = { ["px"] = 0.1890012066, ["py"] = -0.0066523995, ["pm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1904436077, ["py"] = 0.0041752030, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7618] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Folsi's Report",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8368548092, ["py"] = 0.4177747882, ["pm"] = 2386, ["zm"] = 2274, ["qp"] = true, },
    },
  },
  [7619] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Morian Zenas Cell Note",
    ["q"] = 6994,
    ["e"] = {
      [1] = { ["px"] = 0.0899632038, ["py"] = -0.0130367973, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7620] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Beasts of the Gallery",
    ["q"] = 6994,
    ["e"] = {
      [1] = { ["px"] = 0.0913344042, ["py"] = -0.0135887952, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7621] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Commentary on Fate Dialectal",
    ["q"] = 7020,
    ["e"] = {
      [1] = { ["px"] = 0.7884160052, ["py"] = 0.4818308158, ["pm"] = 13, ["qp"] = true, },
    },
  },
  [7622] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Mud-Covered Letter",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8380128079, ["py"] = 0.3970012019, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7623] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter Concering Tredecim",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8327316086, ["py"] = 0.4434232029, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7624] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Report on Operation Siphon",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8342712094, ["py"] = 0.4451927989, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7625] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dres Message",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8390820082, ["py"] = 0.3958232015, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7626] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Adventurers, Take Heed!",
    ["e"] = {
      [1] = { ["px"] = 0.9411615798, ["py"] = 0.3917811969, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7628] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Voidprowler Journal",
    ["q"] = 6996,
    ["e"] = {
      [1] = { ["px"] = 0.1809100098, ["py"] = 0.0417776008, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7630] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter to Magister Meln Rendys",
    ["q"] = 6973,
    ["e"] = {
      [1] = { ["px"] = 0.8460679809, ["py"] = 0.4234800137, ["pm"] = 2285, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8460679809, ["py"] = 0.4234808138, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7631] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Your New Target",
    ["q"] = 6996,
    ["e"] = {
      [1] = { ["px"] = 0.1728439986, ["py"] = 0.0502371978, ["pm"] = 2346, ["d"] = true, ["zx"] = 0.1765940042, ["zy"] = 0.0481807999, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1765940042, ["py"] = 0.0481807999, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7632] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Predestination and Paradox: A Treatise",
    ["q"] = 7021,
    ["e"] = {
      [1] = { ["px"] = 0.1591924010, ["py"] = -0.0031656008, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7633] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Memories Lost",
    ["q"] = 6975,
    ["e"] = {
      [1] = { ["px"] = 0.1574159996, ["py"] = 0.0034512024, ["pm"] = 2384, ["qp"] = true, },
      [2] = { ["px"] = 0.1574160050, ["py"] = 0.0034512053, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7635] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "From the Journal of Balver Bemis",
    ["e"] = {
      [1] = { ["px"] = 0.8346808094, ["py"] = 0.4219427879, ["pm"] = 2386, ["zx"] = 0.8346940096, ["zy"] = 0.4219480009, ["zm"] = 2274, },
    },
  },
  [7637] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dreynis's Notes, Entry 001",
    ["e"] = {
      [1] = { ["px"] = 0.9352372158, ["py"] = 0.3585232068, ["pm"] = 2302, ["d"] = true, ["zx"] = 0.9207820072, ["zy"] = 0.3840748011, ["zm"] = 2274, },
    },
  },
  [7638] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dreynis's Notes, Entry 028",
    ["e"] = {
      [1] = { ["px"] = 0.9322316156, ["py"] = 0.3589072069, ["pm"] = 2302, ["d"] = true, ["zx"] = 0.9207820072, ["zy"] = 0.3840748011, ["zm"] = 2274, },
    },
  },
  [7639] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dreynis's Notes, Entry 007",
    ["e"] = {
      [1] = { ["px"] = 0.9313068155, ["py"] = 0.3617596069, ["pm"] = 2302, ["d"] = true, ["zx"] = 0.9207820072, ["zy"] = 0.3840748011, ["zm"] = 2274, },
    },
  },
  [7640] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Compiled Research",
    ["e"] = {
      [1] = { ["px"] = 0.9336175902, ["py"] = 0.3614855963, ["pm"] = 2303, ["d"] = true, ["zx"] = 0.9207820072, ["zy"] = 0.3840748011, ["zm"] = 2274, },
    },
  },
  [7642] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Cipher Tlaxalt's Note",
    ["e"] = {
      [1] = { ["px"] = 0.1478196073, ["py"] = -0.0088747998, ["pm"] = 2391, ["d"] = true, },
      [2] = { ["px"] = 0.1602136022, ["py"] = -0.0361115973, ["pm"] = 2275, },
    },
  },
  [7643] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Cipher Dreyla's Note",
    ["q"] = 7049,
    ["e"] = {
      [1] = { ["px"] = 0.1998420020, ["py"] = 0.0309224001, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7644] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Cipher Nelfynn's Note",
    ["q"] = 7050,
    ["e"] = {
      [1] = { ["px"] = 0.0840604039, ["py"] = -0.0373239957, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7645] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Altered Naanurrel's Logbook",
    ["q"] = 6982,
    ["e"] = {
      [1] = { ["px"] = 0.1297528064, ["py"] = -0.0551955969, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7646] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Letter from Leramil the Wise",
    ["q"] = 6967,
    ["e"] = {
      [1] = { ["px"] = 0.4326671990, ["py"] = 0.7265287947, ["pm"] = 445, ["qp"] = true, },
    },
  },
  [7647] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Bringing Home the Trolls",
    ["e"] = {
      [1] = { ["px"] = 0.8266199760, ["py"] = 0.4564912151, ["pm"] = 2292, ["d"] = true, ["zx"] = 0.8289800098, ["zy"] = 0.4558020008, ["zm"] = 2274, },
      [2] = { ["px"] = 0.8289800098, ["py"] = 0.4558020008, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7649] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Communications Between Nilphas and Thoryn",
    ["e"] = {
      [1] = { ["px"] = 0.8487604151, ["py"] = 0.3794231991, ["pm"] = 2300, ["d"] = true, },
      [2] = { ["px"] = 0.8494152091, ["py"] = 0.3766884051, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7650] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Orders to Kindred Rector Nyleth",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1738472017, ["py"] = 0.0358356017, ["pm"] = 2308, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7651] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Chamber Instructions",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1719883979, ["py"] = 0.0371531987, ["pm"] = 2313, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7652] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Secret of the Tormenting Eye",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1728647998, ["py"] = 0.0359116004, ["pm"] = 2312, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7653] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Dreams of the Forgotten",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1728751999, ["py"] = 0.0359100004, ["pm"] = 2312, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7654] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On the Pact Primordial",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.1728751999, ["py"] = 0.0359100004, ["pm"] = 2312, ["d"] = true, ["zx"] = 0.1751208068, ["zy"] = 0.0348208047, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1751208068, ["py"] = 0.0348208047, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7662] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Sentient Beasts of the Gallery",
    ["q"] = 6994,
    ["e"] = {
      [1] = { ["px"] = 0.0937408030, ["py"] = -0.0172015950, ["pm"] = 2275, ["qp"] = true, ["qp"] = true, },
    },
  },
  [7668] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Uldazaan's Letter",
    ["q"] = 7051,
    ["e"] = {
      [1] = { ["px"] = 0.2119024080, ["py"] = 0.0164256081, ["pm"] = 2275, ["zx"] = 0.2118800029, ["zy"] = 0.0192912033, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.2213351964, ["py"] = 0.0123968072, ["pm"] = 2334, ["fp"] = true, ["qp"] = true, }, -- postion of Portal to Quest Area inside Delve
      [3] = { ["px"] = 0.2118800029, ["py"] = 0.0192912033, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, }, -- Zone-Map "Quires Wind" Delve entrance
    },
  },
  [7670] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Oblivion Gateway Instructions",
    ["q"] = 6974,
    ["e"] = {
      [1] = { ["px"] = 0.8719016017, ["py"] = 0.4776500030, ["pm"] = 2299, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.8724436112, ["py"] = 0.4730584011, ["pm"] = 2274, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7671] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Plague Concoctor's Instructions",
    ["e"] = {
      [1] = { ["px"] = 0.1641800029, ["py"] = -0.0801340057, ["pm"] = 2395, ["d"] = true, },
    },
  },
  [7675] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Reynila's Journal",
    ["q"] = 7019,
    ["e"] = {
      [1] = { ["px"] = 0.7769651895, ["py"] = 0.5660899920, ["pm"] = 26, ["qp"] = true, },
    },
  },
  [7677] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter to Elistrenne Starflower",
    ["q"] = 7020,
    ["e"] = {
      [1] = { ["px"] = 0.4499367830, ["py"] = 0.5668588065, ["pm"] = 256, ["qp"] = true, },
    },
  },
  [7678] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Attention All Egg-Hands",
    ["e"] = {
      [1] = { ["px"] = 0.9373284123, ["py"] = 0.4195620022, ["pm"] = 2305, ["d"] = true, },
      [2] = { ["px"] = 0.9337532095, ["py"] = 0.4190540044, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7679] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "A Plea for Aid",
    ["q"] = 6994,
    ["e"] = {
      [1] = { ["px"] = 0.0922744025, ["py"] = -0.0211143954, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7680] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On the Fulcrum Obscura",
    ["q"] = 6975,
    ["e"] = {
      [1] = { ["px"] = 0.1571643996, ["py"] = 0.0040336022, ["pm"] = 2384, ["qp"] = true, },
      [2] = { ["px"] = 0.1571644039, ["py"] = 0.0040336033, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7681] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "On the Infinite Panopticon",
    ["q"] = 6975,
    ["e"] = {
      [1] = { ["px"] = 0.1564407996, ["py"] = 0.0032504024, ["pm"] = 2384, ["qp"] = true, },
      [2] = { ["px"] = 0.1564351995, ["py"] = 0.0032520025, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7682] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Onri Murien's Hidden Wishes",
    ["e"] = {
      [1] = { ["px"] = 0.1758139986, ["py"] = 0.0512811975, ["pm"] = 2346, ["d"] = true, },
      [2] = { ["px"] = 0.1765472084, ["py"] = 0.0481807999, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7683] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Ilasaba's Excuses",
    ["e"] = {
      [1] = { ["px"] = 0.1748455987, ["py"] = 0.0520839977, ["pm"] = 2346, ["d"] = true, },
      [2] = { ["px"] = 0.1765472084, ["py"] = 0.0481807999, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7684] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Zeirinia's Silent Admission",
    ["e"] = {
      [1] = { ["px"] = 0.1773987985, ["py"] = 0.0524795978, ["pm"] = 2346, ["d"] = true, },
      [2] = { ["px"] = 0.1765472084, ["py"] = 0.0481807999, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7687] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter from the Reformer",
    ["q"] = 7017,
    ["e"] = {
      [1] = { ["px"] = 0.8749928070, ["py"] = 0.4069272037, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7688] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Mysterious Letter to Federo",
    ["q"] = 7018,
    ["e"] = {
      [1] = { ["px"] = 0.6213904223, ["py"] = 0.2788387989, ["pm"] = 61, ["qp"] = true, },
    },
  },
  [7689] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Another Letter from the Reformer",
    ["q"] = 7018,
    ["e"] = {
      [1] = { ["px"] = 0.6214168247, ["py"] = 0.2788327955, ["pm"] = 61, ["qp"] = true, },
    },
  },
  [7690] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Cipher Akacirn's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.2127940092, ["py"] = 0.0163400068, ["pm"] = 2275, },
    },
  },
  [7691] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Conversations with Sleeps-Fitfully",
    ["e"] = {
      [1] = { ["px"] = 0.1122368057, ["py"] = -0.0430367953, ["pm"] = 2275, },
    },
  },
  [7692] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Administrative Ledger, Entry 3,412",
    ["q"] = 6995,
    ["e"] = {
      [1] = { ["px"] = 0.1123588021, ["py"] = -0.0431783949, ["pm"] = 2275, ["qp"] = true, },
    },
  },
  [7693] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Pact of the Daggerfall Devil",
    ["q"] = 6995,
    ["e"] = {
      [1] = { ["px"] = 0.1177608020, ["py"] = -0.0450756023, ["pm"] = 2367, ["d"] = true, ["zx"] = 0.1159252022, ["zy"] = -0.0472775979, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1159252022, ["py"] = -0.0472775979, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7694] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Survey of the Alavelis Mine",
    ["e"] = {
      [1] = { ["px"] = 0.8724824073, ["py"] = 0.4726204014, ["pm"] = 2274, },
    },
  },
  [7695] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Prior's Fulcrum",
    ["q"] = 6971,
    ["e"] = {
      [1] = { ["px"] = 0.9389111735, ["py"] = 0.3743644004, ["pm"] = 2347, ["d"] = true, ["qp"] = true, },
      [2] = { ["px"] = 0.9386639812, ["py"] = 0.3769459957, ["pm"] = 2343, ["fp"] = true, ["qp"] = true, },
      [3] = { ["px"] = 0.9510455811, ["py"] = 0.3718255957, ["pm"] = 2343, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7696] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "House Dres Orders",
    ["e"] = {
      [1] = { ["px"] = 0.8356992110, ["py"] = 0.4427000020, ["pm"] = 2274, },
    },
  },
  [7697] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Camp Update",
    ["q"] = 6990,
    ["e"] = {
      [1] = { ["px"] = 0.8350176111, ["py"] = 0.4447179990, ["pm"] = 2274, ["qp"] = true, },
    },
  },
  [7713] = {
    ["c"] = true,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Challenge of the Paramount",
    ["e"] = {
      [1] = { ["px"] = 0.0704384028, ["py"] = 0.6051880052, ["pm"] = 2163, },
    },
  },
  -- TODO Check this
  [7714] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Chronicle of Apocrypha",
    ["q"] = 6977,
    ["e"] = {
      [1] = { ["px"] = 0.1620339997, ["py"] = 0.0009808024, ["pm"] = 2384, },
      [2] = { ["px"] = 0.1620339997, ["py"] = 0.0009808024, ["pm"] = 2275, },
      [3] = { ["px"] = 0.8289800098, ["py"] = 0.4558020008, ["pm"] = 2274, ["fp"] = true, },
    },
  },
  [7745] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Closed By Order of the Abbot",
    ["e"] = {
      [1] = { ["px"] = 0.9390364163, ["py"] = 0.3772484060, ["pm"] = 2343, },
    },
  },
  [7751] = {
    ["c"] = true,
    ["cn"] = "The Impresario's Catalogue",
    ["n"] = "The Impresario's Catalogue",
    ["e"] = {
      [1] = { ["px"] = 0.2394868022, ["py"] = 0.7341292216, ["pm"] = 243, ["zm"] = 143, }, -- TODO Check this
      [2] = { ["px"] = 0.7919784000, ["py"] = 0.4376684091, ["pm"] = 24, },
      [3] = { ["px"] = 0.0703480029, ["py"] = 0.3838416085, ["pm"] = 1, },
      [4] = { ["px"] = 0.7652772262, ["py"] = 0.3713136074, ["pm"] = 1060, },
      [5] = { ["px"] = 0.0713900014, ["py"] = 0.7482572133, ["pm"] = 1349, },
      [6] = { ["px"] = 0.5647067729, ["py"] = 0.6247211963, ["pm"] = 1576, },
      [7] = { ["px"] = 0.4233080153, ["py"] = 0.2181312034, ["pm"] = 1719, },
      [8] = { ["px"] = 0.6097244054, ["py"] = 0.6774832075, ["pm"] = 1940, },
      [9] = { ["px"] = 0.0710136029, ["py"] = 0.6023444052, ["pm"] = 2163, },
      [10] = { ["px"] = 0.9418383804, ["py"] = 0.3945583964, ["pm"] = 2343, },
    },
  },
  [7753] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Sunvys Golsathyn Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8252300085, ["py"] = 0.4290488000, ["pm"] = 2274, },
    },
  },
  [7754] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Savienie Mavlyn Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8706836109, ["py"] = 0.4561263996, ["pm"] = 2274, },
    },
  },
  [7755] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Elovul Alarndil Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8762340089, ["py"] = 0.4194548025, ["pm"] = 2274, },
    },
  },
  [7756] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Favami Seravel Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8668592121, ["py"] = 0.3882540036, ["pm"] = 2274, },
    },
  },
  [7757] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Triys Rehlo Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.9194792040, ["py"] = 0.4230828059, ["pm"] = 2274, },
    },
  },
  [7758] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Dayldela Gilrom Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8559208105, ["py"] = 0.4076184052, ["pm"] = 2274, },
    },
  },
  [7759] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Aralos Sarvrothi Gravestone",
    ["e"] = {
      [1] = { ["px"] = 0.8494224073, ["py"] = 0.4801320016, ["pm"] = 2274, },
    },
  },
  [7760] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter from Azandar",
    ["q"] = 7023,
    ["e"] = {
      [1] = { ["qc"] = true, },
    },
  },
  [7761] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Letter from Sharp",
    ["q"] = 7019,
    ["e"] = {
      [1] = { ["qc"] = true, },
    },
  },
  [7762] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Preparing Necrom Kwama, Fifth Draft",
    ["e"] = {
      [1] = { ["px"] = 0.9347500139, ["py"] = 0.4017576035, ["pm"] = 2274, },
    },
  },
  [7763] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "The Last Addition of Bikkus-Muz",
    ["e"] = {
      [1] = { ["px"] = 0.1770703948, ["py"] = -0.0311508035, ["pm"] = 2422, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7764] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Snushularg's Promise",
    ["e"] = {
      [1] = { ["px"] = 0.1758708001, ["py"] = -0.0306579957, ["pm"] = 2425, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7765] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "A Servant's Tale", --Marked as A Hireling's Tale in the overworld, but shows up as A Servant's Tale in game
    ["e"] = {
      [1] = { ["px"] = 0.8354092088, ["py"] = 0.4221563884, ["pm"] = 2386, ["zx"] = 0.8354020109, ["zy"] = 0.4221504017, ["zm"] = 2274, },
    },
  },
  [7766] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Malkhest's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.1758571953, ["py"] = -0.0311891934, ["pm"] = 2407, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7769] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Recipe for Book Soup",
    ["e"] = {
      [1] = { ["px"] = 0.1930935929, ["py"] = 0.0004176033, ["pm"] = 2356, ["d"] = true, ["zx"] = 0.1900744063, ["zy"] = -0.0005199991, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1900744063, ["py"] = -0.0005199991, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7770] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Reminders for Underweave Watchlings",
    ["e"] = {
      [1] = { ["px"] = 0.1233172020, ["py"] = 0.0145692015, ["pm"] = 2353, ["d"] = true, ["zx"] = 0.1317344040, ["zy"] = -0.0072423963, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1317344040, ["py"] = -0.0072423963, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7771] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Tainted Egg Mine Report",
    ["e"] = {
      [1] = { ["px"] = 0.9339132121, ["py"] = 0.4180644017, ["pm"] = 2305, ["d"] = true, ["zx"] = 0.9337532095, ["zy"] = 0.4190540044, ["zm"] = 2274, },
    },
  },
  [7772] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Parables of Saint Vorys",
    ["e"] = {
      [1] = { ["px"] = 0.8664948069, ["py"] = 0.4291420048, ["pm"] = 2274, },
    },
  },
  [7773] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "The Remnant Truth",
    ["e"] = {
      [1] = { ["px"] = 0.1224592002, ["py"] = -0.0386048016, ["pm"] = 2349, ["d"] = true, ["zx"] = 0.1205480055, ["zy"] = -0.0253859966, ["zm"] = 2275, },
      [2] = { ["px"] = 0.1205480055, ["py"] = -0.0253859966, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7775] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Note from Uxunath",
    ["q"] = 6992,
    ["e"] = {
      [1] = { ["px"] = 0.1575616061, ["py"] = -0.0292804010, ["pm"] = 2337, ["d"] = true, ["zx"] = 0.1537979973, ["zy"] = -0.0282487988, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1537979973, ["py"] = -0.0282487988, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7776] = {
    ["c"] = true,
    ["cn"] = "Apocryphal Pages",
    ["n"] = "Journal of the First Remnant",
    ["q"] = 6992,
    ["e"] = {
      [1] = { ["px"] = 0.1566891944, ["py"] = -0.0297452037, ["pm"] = 2339, ["d"] = true, ["zx"] = 0.1537979973, ["zy"] = -0.0282487988, ["zm"] = 2275, ["qp"] = true, },
      [2] = { ["px"] = 0.1537979973, ["py"] = -0.0282487988, ["pm"] = 2275, ["fp"] = true, ["qp"] = true, },
    },
  },
  [7786] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Obscure Killers of the North",
    ["e"] = {
      [1] = { ["px"] = 0.1767440000, ["py"] = -0.0312256023, ["pm"] = 2421, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7787] = {
    ["c"] = true,
    ["cn"] = "Library of Incunabula",
    ["n"] = "Fynboar the Resurrected", --Has a quest attached to it
    ["e"] = {
      [1] = { ["px"] = 0.1758559953, ["py"] = -0.0312191934, ["pm"] = 2407, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7788] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Archmagister Mavon's Ascension",
    ["e"] = {
      [1] = { ["px"] = 0.1758471953, ["py"] = -0.0311995934, ["pm"] = 2407, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7793] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "The Silver Rose Blooms over Borderwatch",
    ["e"] = {
      [1] = { ["px"] = 0.1761883982, ["py"] = -0.0308459952, ["pm"] = 2408, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7794] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Izzmothar's Power",
    ["e"] = {
      [1] = { ["px"] = 0.1768020013, ["py"] = -0.0308828049, ["pm"] = 2414, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7795] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Captain Burwarah's Records",
    ["e"] = {
      [1] = { ["px"] = 0.1764803982, ["py"] = -0.0302087977, ["pm"] = 2416, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7799] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "The Felling of Windweaper's Grove",
    ["e"] = {
      [1] = { ["px"] = 0.1767352013, ["py"] = -0.0307784049, ["pm"] = 2414, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7800] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Waiting Door",
    ["e"] = {
      [1] = { ["px"] = 0.9388071804, ["py"] = 0.3854871955, ["pm"] = 2343, ["zm"] = 2274, },
    },
  },
  [7804] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "House Telvanni Song",
    ["e"] = {
      [1] = { ["px"] = 0.8453284084, ["py"] = 0.4149040023, ["pm"] = 2274, },
    },
  },
  [7805] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "Song of Fate",
    ["e"] = {
      [1] = { ["px"] = 0.1308008040, ["py"] = -0.0263719960, ["pm"] = 2275, },
    },
  },
  [7806] = {
    ["c"] = true,
    ["cn"] = "Telvanni Tomes",
    ["n"] = "The Spotted Towers", -- Listed in game as TP Towers Song
    ["e"] = {
      [1] = { ["px"] = 0.8939672051, ["py"] = 0.4530512014, ["pm"] = 2274, },
    },
  },
  [7810] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Lessons of the Pit",
    ["e"] = {
      [1] = { ["px"] = 0.3570552024, ["py"] = 0.2424703996, ["pm"] = 2462, ["d"] = true, },
      [2] = { ["px"] = 0.3573404041, ["py"] = 0.2439459981, ["pm"] = 1814, ["fp"] = true, },
    },
  },
  [7811] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Initiate's Fear",
    ["e"] = {
      [1] = { ["px"] = 0.3567308023, ["py"] = 0.2423303996, ["pm"] = 2462, ["d"] = true, },
      [2] = { ["px"] = 0.3573404041, ["py"] = 0.2439459981, ["pm"] = 1814, ["fp"] = true, },
    },
  },
  [7812] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Niborwen's Journal",
    ["e"] = {
      [1] = { ["px"] = 0.3578692112, ["py"] = 0.2425596003, ["pm"] = 2464, ["d"] = true, },
      [2] = { ["px"] = 0.3573404041, ["py"] = 0.2439459981, ["pm"] = 1814, ["fp"] = true, },
    },
  },
  [7813] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Maerolor's Chronicle",
    ["e"] = {
      [1] = { ["px"] = 0.3581592112, ["py"] = 0.2424756003, ["pm"] = 2464, ["d"] = true, },
      [2] = { ["px"] = 0.3573404041, ["py"] = 0.2439459981, ["pm"] = 1814, ["fp"] = true, },
    },
  },
  [7814] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Faenalir's Letter",
    ["e"] = {
      [1] = { ["px"] = 0.3582876014, ["py"] = 0.2433660041, ["pm"] = 2466, ["d"] = true, },
      [2] = { ["px"] = 0.3573404041, ["py"] = 0.2439459981, ["pm"] = 1814, ["fp"] = true, },
    },
  },
  [7817] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "From Exile to Exodus, Pt. 1",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.8376143989, ["py"] = 0.3459719931, ["pm"] = 2448, ["d"] = true, },
      [2] = { ["px"] = 0.8367668291, ["py"] = 0.3469560064, ["pm"] = 1060, ["fp"] = true, },
    },
  },
  [7818] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "From Exile to Exodus, Pt. 2",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.8376447988, ["py"] = 0.3457715932, ["pm"] = 2448, ["d"] = true, },
      [2] = { ["px"] = 0.8367668291, ["py"] = 0.3469560064, ["pm"] = 1060, ["fp"] = true, },
    },
  },
  [7821] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Materials for Novice Necromancers",
    ["e"] = {
      [1] = { ["px"] = 0.1767475932, ["py"] = -0.0305320006, ["pm"] = 2415, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7822] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "On the Discovery of Relic Fiends",
    ["e"] = {
      [1] = { ["px"] = 0.1758739930, ["py"] = -0.0305527941, ["pm"] = 2417, ["d"] = true, },
      [2] = { ["px"] = 0.1752616046, ["py"] = -0.0298643984, ["pm"] = 2275, ["fp"] = true, },
    },
  },
  [7824] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Endegor's Orders",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.4213824062, ["py"] = 0.6882559900, ["pm"] = 2447, ["d"] = true, },
      [2] = { ["px"] = 0.4222247855, ["py"] = 0.6932991878, ["pm"] = 9, ["fp"] = true, },
    },
  },
  [7825] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "A Dance Along the Webs",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.7438352197, ["py"] = 0.4656247979, ["pm"] = 2443, ["d"] = true, },
      [2] = { ["px"] = 0.7441815913, ["py"] = 0.4652304013, ["pm"] = 7, ["fp"] = true, },
    },
  },
  [7826] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Testament of Dandera Helas",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.8377119989, ["py"] = 0.3458927932, ["pm"] = 2448, ["d"] = true, },
      [2] = { ["px"] = 0.8367668291, ["py"] = 0.3469560064, ["pm"] = 1060, ["fp"] = true, },
    },
  },
  [7845] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Tutor Riparius's List",
    ["e"] = {
      [1] = { ["px"] = 0.2117052058, ["py"] = 0.2696255955, ["pm"] = 2494, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [7846] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "A Challenger's Thoughts",
    ["e"] = {
      [1] = { ["px"] = 0.2124476061, ["py"] = 0.2696119978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [7847] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Initiate's Last Sight",
    ["e"] = {
      [1] = { ["px"] = 0.2121148033, ["py"] = 0.2705272067, ["pm"] = 2495, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [7851] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Fa-Nuit-Hen's Note",
    ["e"] = {
      [1] = { ["px"] = 0.2122284033, ["py"] = 0.2706712067, ["pm"] = 2495, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [7856] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "A Call for Recollection",
    ["e"] = {
      [1] = { ["px"] = 0.4421107823, ["py"] = 0.7517819888, ["pm"] = 9, },
    },
  },
  [7890] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Bladesongs of Boethra, Volume V",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.4232636090, ["py"] = 0.6334640087, ["pm"] = 2540, ["d"] = true, },
      [2] = { ["px"] = 0.4217207851, ["py"] = 0.6364300014, ["pm"] = 256, ["fp"] = true, },
    },
  },
  [7901] = {
    ["c"] = true,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "The Bladesongs of Boethra, Volume II",
    ["e"] = {
      [1] = { ["px"] = 0.4219643856, ["py"] = 0.6362859996, ["pm"] = 256, },
    },
  },
  [7902] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Bladesongs of Boethra, Volume III",
    ["e"] = {
      [1] = { ["px"] = 0.4945328084, ["py"] = 0.6009443933, ["pm"] = 533, },
      [2] = { ["px"] = 0.4945328084, ["py"] = 0.6009443933, ["pm"] = 256, },
    },
  },
  [7918] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "Letter from Leramil the Wise",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.7666896105, ["py"] = 0.5083392080, ["pm"] = 819, ["d"] = true, },
    },
  },
  [7938] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Nine Coruscations, Volume I",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.4218164062, ["py"] = 0.6883887900, ["pm"] = 2447, ["d"] = true, },
      [2] = { ["px"] = 0.4222247855, ["py"] = 0.6932991878, ["pm"] = 9, ["fp"] = true, },
    },
  },
  [7939] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Nine Coruscations, Volume II",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = 0.4215732062, ["py"] = 0.6883811900, ["pm"] = 2447, ["d"] = true, },
      [2] = { ["px"] = 0.4222247855, ["py"] = 0.6932991878, ["pm"] = 9, ["fp"] = true, },
    },
  },
  [7941] = {
    ["c"] = true,
    ["cn"] = "Tomes of Tributes",
    ["n"] = "Challenge of the Archivist",
    ["e"] = {
      [1] = { ["px"] = 0.0702600025, ["py"] = 0.6047920052, ["pm"] = 2163, },
    },
  },
  [7942] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Fa-Nuit-Hen's Second Note",
    ["e"] = {
      [1] = { ["px"] = 0.2120676033, ["py"] = 0.2707968067, ["pm"] = 2495, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [7943] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "Fa-Nuit-Hen's Third Note",
    ["e"] = {
      [1] = { ["px"] = 0.2119288033, ["py"] = 0.2706644067, ["pm"] = 2495, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8003] = {
    ["c"] = true,
    ["cn"] = "Scholarium Scribblings",
    ["n"] = "Ulfsild's Note",
    ["e"] = {
      [1] = { ["px"] = 0.1547416013, ["py"] = 0.7241304264, ["pm"] = 2519, ["d"] = true, },
    },
  },
  [8020] = {
    ["c"] = true,
    ["cn"] = "Scholarium Scribblings",
    ["n"] = "Fable of the Indrik",
    ["e"] = {
      [1] = { ["px"] = 0.0161347998, ["py"] = 0.1718332011, ["pm"] = 2515, },
    },
  },
  [8058] = {
    ["c"] = true,
    ["cn"] = "Daedric Cults",
    ["n"] = "The Prophecy of Anudnabia",
    ["q"] = 7079,
    ["e"] = {
      [1] = { ["px"] = -0.0393440002, ["py"] = 0.0900340000, ["pm"] = 2449, ["d"] = true, },
      [2] = { ["px"] = 0.8435692244, ["py"] = 0.3173584089, ["pm"] = 1060, ["fp"] = true, },
    },
  },
  [8091] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "In Memoriam of the Carver of Shadows",
    ["e"] = {
      [1] = { ["px"] = 0.2124720061, ["py"] = 0.2696243978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8092] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "In Memoriam of the Gentle Warrior",
    ["e"] = {
      [1] = { ["px"] = 0.2124932061, ["py"] = 0.2698507978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8093] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "In Memoriam of the Scorching Storm",
    ["e"] = {
      [1] = { ["px"] = 0.2125400061, ["py"] = 0.2698435978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8094] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "In Memoriam of the Salt Spray",
    ["e"] = {
      [1] = { ["px"] = 0.2126028061, ["py"] = 0.2697343978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8095] = {
    ["c"] = true,
    ["cn"] = "Dungeon Delver Documents",
    ["n"] = "In Memoriam of the Ashy Wind",
    ["e"] = {
      [1] = { ["px"] = 0.2125016061, ["py"] = 0.2695771978, ["pm"] = 2496, ["d"] = true, },
      [2] = { ["px"] = 0.2128399972, ["py"] = 0.2703303973, ["pm"] = 667, ["fp"] = true, },
    },
  },
  [8125] = {
    ["c"] = true,
    ["cn"] = "West Weald Writings",
    ["n"] = "Gaea's Letter",
    ["e"] = {
      [1] = { ["px"] = 0.4407163942, ["py"] = 0.5049575979, ["pm"] = 2427, },
    },
  },
  [8167] = {
    ["c"] = true,
    ["cn"] = "Scholarium Scribblings",
    ["n"] = "The Ship of Ice",
    ["e"] = {
      [1] = { ["px"] = 0.0165399997, ["py"] = 0.1767432015, ["pm"] = 2515, },
    },
  },
  [8189] = {
    ["c"] = true,
    ["cn"] = "Scholarium Scribblings",
    ["n"] = "How to Scribe",
    ["e"] = {
      [1] = { ["px"] = 0.0174615997, ["py"] = 0.1734452013, ["pm"] = 2515, },
    },
  },
  [8196] = {
    ["c"] = true,
    ["cn"] = "Scholarium Scribblings",
    ["n"] = "Ulfsild's Log: Your Discovery, My Farewell",
    ["e"] = {
      [1] = { ["px"] = 0.0168395997, ["py"] = 0.1735684013, ["pm"] = 2515, },
    },
  },
}

function LoreBooks_GetBookData()
  return bookData
end

--Global API
function LoreBooks_GetBookshelfDataFromMapId(mapId)
  if not bookshelfData[mapId] then return {} end
  return bookshelfData[mapId]
end

function LoreBooks_GetNewEideticDataFromBookId(bookId)
  if not bookData[bookId] then
    bookData[bookId] = { k = bookId }
  end
  return bookData[bookId]
end

function LoreBooks_GetNewEideticData(categoryIndex, collectionIndex, bookIndex)
  local _, _, _, bookId = GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex)
  return LoreBooks_GetNewEideticDataFromBookId(bookId)
end

function LoreBooks_GetEideticData(mapId, z_mapId)
  local _, numCollections = GetLoreCategoryInfo(internal.LORE_LIBRARY_EIDETIC) -- Only Eidetic
  local eideticInZone = {}
  for collectionIndex = 1, numCollections do
    local _, _, _, totalBooks = GetLoreCollectionInfo(internal.LORE_LIBRARY_EIDETIC, collectionIndex)
    for bookIndex = 1, totalBooks do
      local eideticBookZoneData = LoreBooks_GetNewEideticData(internal.LORE_LIBRARY_EIDETIC, collectionIndex, bookIndex)
      local _, _, _, bookId = GetLoreBookInfo(internal.LORE_LIBRARY_EIDETIC, collectionIndex, bookIndex)
      local eideticBooks
      if eideticBookZoneData and eideticBookZoneData.c and eideticBookZoneData.e then
        eideticBooks = eideticBookZoneData.c and NonContiguousCount(eideticBookZoneData.e) > 0
      end
      if eideticBooks then
        local eideticData = eideticBookZoneData.e
        for _, booksData in ipairs(eideticData) do
          local hasZoneData = booksData["pm"] == mapId or booksData["zm"] == z_mapId
          if hasZoneData then
            booksData.c = collectionIndex -- Add collectionIndex
            booksData.b = bookIndex -- Add bookIndex
            booksData.k = bookId -- Add bookId
            if eideticBookZoneData.q then booksData.q = eideticBookZoneData.q end -- Add quest info
            eideticInZone[#eideticInZone + 1] = booksData
          end
        end
      end
    end
  end

  return eideticInZone

end

local function GetNumKnownBooksInCollection(categoryIndex, collectionIndex, booksInCollection)

  local numKnownBooks = 0
  if categoryIndex and collectionIndex and booksInCollection then
    for bookIndex = 1, booksInCollection do
      local known = select(3, GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex))
      if known then
        numKnownBooks = numKnownBooks + 1
      end
    end
  end

  return numKnownBooks

end

local function GetMissingEideticBooks()

  local categoryIndex = internal.LORE_LIBRARY_EIDETIC
  local _, numCollections = GetLoreCategoryInfo(categoryIndex)

  for collectionIndex = 1, numCollections do

    local collectionName, _, _, totalBooks, hidden = GetLoreCollectionInfo(categoryIndex, collectionIndex)

    if not hidden then

      for bookIndex = 1, totalBooks do

        local _, _, _, bookId = GetLoreBookInfo(categoryIndex, collectionIndex, bookIndex)
        if not bookData[bookId].c then
          df("Book |H1:book:%s|h|h (#%d) is still Unknown. Collection %s (3/%d)", tostring(bookId), bookId, collectionName, collectionIndex)
          --elseif not bookData[bookId].q and not bookData[bookId].e or #bookData[bookId].e == 0 then
          --	df("Book |H1:book:%s|h|h (#%d) is still Wrong. Collection %s (3/%d)", tostring(bookId), bookId, collectionName, collectionIndex)
        end

      end
    end
  end

end

SLASH_COMMANDS["/lunk"] = GetMissingEideticBooks

-- copy of GetLoreCollectionInfo
-- Returns: string name, string description, number numKnownBooks, number totalBooks, boolean hidden, textureName gamepadIcon, number collectionId
function LoreBooks_GetNewLoreCollectionInfo(categoryIndex, collectionIndex)
  if libraryData[categoryIndex] and libraryData[categoryIndex][collectionIndex] then
    local collectionData = libraryData[categoryIndex][collectionIndex]
    return collectionData.n[GetCVar("Language.2")], -- name
    collectionData.d[GetCVar("Language.2")], -- description
    GetNumKnownBooksInCollection(categoryIndex, collectionIndex, collectionData.t), -- numKnownBooks
    collectionData.t, -- totalBooks
    collectionData.h, -- hidden
    collectionData.g, -- gamepadIcon
    collectionData.k  -- collectionId
  end
end
